      SUBROUTINE GETFML(AKR,AK3,AKSR,BETADF,PHIDF,THETADF,DX,X0,CALPHA,  &
                        CMDSOL,CMDFFT,CMDTRQ,CSHAPE,CXADIA,CXAOFF,       &
                        CXALPH,CXALOF,CXALOS,CXE,CXE01R,CXE02R,          &
                        CXEPS,CXF11,CXF12,CXF21,CXF22,CXRLOC,CXPOL,CXSC, &
                        CXSCR1,CXZC,CXZW,EM1R,EM2R,ETASCA,GAMMA,IBETH,   &
                        IBETH1,ICOMP,IDVOUT,INIT,IOCC,IORTH,IPBC,IPHI,   &
                        IPHI1,ITASK,IXYZ0,ITNUM,JPBC,MXITER,LACE,LAXI,   &
                        LCLM,LGI,LPI,LQI,LSC0,MXCOMP,MXCXSC,MXN3,MXNAT,  &
                        MXNX,MXNY,MXNZ,MXPBC,MXPHI,MXSCA,MYID,NAT,NAT0,  &
                        NAT3,NAVG,NCOMP,NSCAT,NX,NY,NZ,PHI,PIA2,QABS,    &
                        QBKSCA,QEXT,QPHA,QSCA,QSCAG,QSCAG2,QTRQAB,       &
                        QTRQSC,SCRRS1,SCRRS2,SHPAR,TOL,TIMERS,MXTIMERS,  &
                        NTIMERS)

!----------------------------- v2 ----------------------------------------

      USE DDPRECISION,ONLY: WP
      USE DDCOMMON_9,ONLY: ERRSCAL,IDVOUT2,ITERMX,ITERN
      IMPLICIT NONE

! Arguments:

      CHARACTER :: CALPHA*6,CMDSOL*6,CMDFFT*6,CMDTRQ*6,CSHAPE*9

      INTEGER :: IBETH,IBETH1,IDVOUT,INIT,IORTH,IPBC,IPHI,IPHI1,ITASK, &
         JPBC,LACE,LAXI,LCLM,LGI,LPI,LSC0,LQI,MXCOMP,MXCXSC,MXN3,      &
         MXNAT,MXNX,MXNY,MXNZ,MXPBC,MXPHI,MXSCA,MXTIMERS,MYID,NAT,     &
         NAT0,NAT3,NAVG,NCOMP,NSCAT,NTIMERS,NX,NY,NZ

      INTEGER :: MXITER
      INTEGER :: & 
         ITNUM(2)

      INTEGER*2 ::    &
         ICOMP(MXN3), &
         IOCC(MXNAT)

      INTEGER ::      &
         IXYZ0(NAT0,3)

      REAL(WP) :: AK3,ETASCA,GAMMA,PIA2,TOL,TOLR

      REAL(WP) ::          &
         AKR(3),           &
         AKSR(3,MXSCA),    &
         BETADF(MXNAT),    &
         DX(3),            &
         EM1R(3,MXSCA),    &
         EM2R(3,MXSCA),    &
         PHI(MXPHI),       &
         PHIDF(MXNAT),     &
         QABS(2),          &
         QBKSCA(2),        &
         QEXT(2),          &
         QPHA(2),          &
         QSCA(2),          &
         QSCAG(3,2),       &
         QSCAG2(2),        &
         QTRQAB(3,2),      &
         QTRQSC(3,2),      &
         SCRRS1(MXNAT,3),  &
         SCRRS2(MXNAT),    &
         SHPAR(12),        &
         THETADF(MXNAT),   &
         TIMERS(MXTIMERS), &
         X0(3)

      COMPLEX(WP) ::                    &
         CXADIA(MXN3),                  &
         CXALPH(MXN3),                  &
         CXALOF(MXN3),                  &
         CXAOFF(MXN3),                  &
         CXALOS(NAT,3),                 &
         CXE(MXN3),                     &
         CXE01R(3),                     &
         CXE02R(3),                     &
         CXEPS(MXCOMP),                 &
         CXF11(MXSCA),                  &
         CXF12(MXSCA),                  &
         CXF21(MXSCA),                  &
         CXF22(MXSCA),                  &
         CXRLOC(MXCOMP+1,3,3),          &
         CXPOL(MXN3),                   &
         CXSC(MXCXSC),                  &
         CXSCR1(MXN3),                  &
         CXZC(MXNX+1+MXPBC*(MXNX-1),    &
              MXNY+1+MXPBC*(MXNY-1),    &
              MXNZ+1+MXPBC*(MXNZ-1),6), &
         CXZW(MXNAT,24)

!-----------------------------------------------------------------------

! Local variables

      COMPLEX(WP) :: &
         CXE0R(3)

      INTEGER :: I,ITER,J,JO,MXITER2,NAT03
      INTEGER :: NO_CG_RESTART, NO_CG_ITER

      INTEGER :: &
         IPAR(13)

      REAL(WP) :: CABS,CBKSCA,CEXT,CPHA,CSCA,CSCAG2,COSPHI,DTIME, &
         E02,FALB,SINPHI

      REAL(WP) ::   &
         CSCAG(3),  &
         CTRQAB(3), &
         CTRQSC(3), &
         SPAR(6)

      SAVE E02

      EXTERNAL CMATVEC,DIAGL,DUMMY,MATVEC,PCSUM,PRECOND,PROGRESS,PSCNRM2

!***********************************************************************
! Function of GETFML is to 
! (1) obtain a solution to the scattering problem for given target 
!     orientation, and 
! (2) return the scattering function fml in preselected scattering 
!     directions.

! Given:
!       AKR(1-3)=(k_x,k_y,k_z)*d for incident wave [in Target Frame]
!       AK3     =(kd)**3
!       AKSR(1-3,1-NSCAT)=(k_x,k_y,k_z)*d for NSCAT scattering direction
!       GAMMA = parameter controlling summation over replica dipoles
!               (smaller alpha -> longer summation)
!       BETADF(1-NAT)=orientation angle beta (radians) describing
!                orientation of "Dielectric Frame" relative to Target Frame
!                for dipoles 1-NAT0
!       PHIDF(1-NAT)=orientation angle phi (radians) describing orientation
!                of Dielectric Frame relative to Target Frame for dipole
!                1-NAT0
!       THETADF(1-NAT)=orientation angle theta (radians) describing
!                orientation of Dielectric Frame relative to Target Frame
!                for dipoles 1-NAT0
!       DX(1-3) =(d_x/d,d_y/d,d_z/d) where d_x,d_y,d_z=x,y,z lattice spacing
!                and d=(d_x*d_y*d_z)**(1/3)=effective lattice spacing
!       CALPHA  =descriptor of method used for assigning polarizabilitie
!               =LATTDR or DRAI88 or GOBR88
!       CMDSOL  =descriptor of method used for iterative solution
!       CMDFFT  =descriptor of method used for FFTs
!       CMDTRQ  =descriptor of whether or not to compute torques
!       CSHAPE  =descriptor of target shape, needed by subroutine ALPHA
!       CXE01R(1-3)=incident polarization state 1 at origin [in TF]
!       CXE02R(1-3)=incident polarization state 2 at origin [in TF]
!       CXEPS(1-NCOMP)=dielectric constant for compositions 1-NCOMP
!       EM1R(1-3,1-NSCAT)=unit scat. polarization vectors 1 in TF
!       EM2R(1-3,1-NSCAT)=unit scat. polarization vectors 2 in TF
!       ETASCA  =parameter controlling number of scattering angles used
!                for calculation of radiation force, <cos>, <cos^2>, and
!                radiation torque
!       IBETH   =MYID+IBETH1 if first time through combined BETA/THETA
!                orientation loop
!       IBETH1  =starting value of IBETH (see above)
!       ICOMP(1-NAT3)=x,y,z "composition" for sites 1-NAT
!       IDVOUT  =device for running output
!       INIT    =0,1,2 for choice of |x0> for CCG method
!       IOCC(1-NAT)=0,1 if site in extended target is vacant,occupied
!       IORTH   =1,2 to do 1,2 orthogonal pol states
!       IPHI    =which phi value for target orientation
!       IPHI1   =starting value of IPHI (see above)
!       IPBC    = 0 if PBC not used
!               = 1 if PBC used
!       JPBC    = 0 if PBC not used
!               = 1 if PBC used in y direction only
!               = 2 if PBC used in z direction only
!               = 3 if PBC used in both y and z directions
!               **NOTE** JPBC is not used by GETFML
!                        When JPBC > 0, GETFML computes f_ml for the
!                        Target Unit Cell.
!       ITASK    not used
!       IXYZ0(1-MXNAT,1-3)=lattice coordinates for sites 1-NAT (in TF)
!                with sites 1-NAT0 in list being the occupied sites.
!       DX(1-3) = location/DX(1-3) in TF corresponding to lattice site
!                 (IX,IY,IZ)=(0,0,0)
!       LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0=integers used to assign location
!                in scratch array
!       MXCOMP  =dimensioning info: maximum number of allowed compositions
!       MXCXSC  =dimensioning info for complex scratch space
!       MXN3    =dimensioning info (3*max number of sites)
!       MXNAT   =dimensioning info (max number of sites)
!       MXNX    =dimensioning info (max x extent of target)
!       MXNY    =dimensioning info (max y extent of target)
!       MXNZ    =dimensioning info (max z extent of target)
!       MXPHI   =dimensioning info (max number of phi vals for targ. ori
!       MXSCA   =dimensioning info (max number of scat. dirs for f_ml)
!       MYID    =parallel process identifier (=0 if only 1 process)
!       NAT     =number of sites in extended target
!       NAT0    =number of sites in original target
!       NAT3    =3*NAT
!       NCOMP   =number of different dielectric tensor elements in target
!       NSCAT   =number of scat. dirs for f_ml
!       NX      =x extent of extended target
!       NY      =y extent of extended target
!       NZ      =z extent of extended target
!       PHI(1-NPHI)=phi values for target orientation
!       PIA2    =\pi*(3*NAT/4\pi)^{2/3} (NAT=number of sites in original
!       SHPAR(1-10)=target shape parameters, needed by subroutine ALPHA
!       TOL     =tolerance for terminating conjugate gradient iteration

! and scratch space:
!       CXRLOC(1-MXCOMP+1,3,3)
!       CXSC(1-MXCXSC)=scratch space
!       CXSCR1(1-MXN3)=scratch space
!       CXZC(1->MXNX+1,1->MXNY+1,1->MXNZ+1,1-6)=scratch space
!       CXZW(1-MXNAT,1-24)=scratch space
!       SCRRS1(1-MXNAT,3)=scratch space
!       SCRRS2(1-MXNAT)=scratch space

! Returns:

!       CXADIA(1-3,1-NAT)=diagonal elements of "A matrix"
!       CXAOFF(1-3,1-NAT)=off-diagonal elements of 3x3 blocks on
!                         diagonal of "A matrix"
!       CXALPH(1-3,1-NAT)=diagonal elements of 3x3 polarizability
!                         tensor for dipoles 1-NAT (in TF)
!       CXALOF(1-3,1-NAT)=off-diagonal elements of 3x3 polarizability
!                         tensor for dipoles 1-NAT
!       CXALOS(J,1-3)=(alpha_23,alpha_31,alpha_12)/d^3 for dipole J=1-NA
!                     Off-diagonal polarizability elements
!       CXE(1-NAT3)=incident x,y,z E field at dipoles 1-NAT (in TF)
!       CXF11(1-NSCAT)=scattering matrix element f_11 for NSCAT dirs
!       CXF12(1-NSCAT)=                          f_12
!       CXF21(1-NSCAT)=                          f_21
!       CXF22(1-NSCAT)=                          f_22
!       CXPOL(1-NAT3)=x,y,z polarization of dipoles 1-NAT in TF
!       QABS(1-2)=Q_abs=C_abs/(PIA2*d**2) for incident pols 1,2
!       QBKSCA(1-2)=diff.scatt.cross section/(PIA2*d^2) for backscat
!                   for inc.pols.1,2
!       QEXT(1-2)=Q_ext=C_ext/(PIA2*d**2) for incident pols 1,2
!       QPHA(1-2)=phase shift cross section for incident pols 1,2
!       QSCA(1-2)=Q_sca=C_sca/(PIA2*d**2) for incident pols 1,2
!       QSCAG(1-3,1-2)=<cos(theta)>*Q_sca for incident pols 1,2
!                      <sin(theta)*cos(phi)>*Q_sca for incident pols 1,2
!                      <sin(theta)*sin(phi)>*Q_sca for incident pols 1,2
!                      [QSCAG(1-3,1-2) is in Lab Frame]
!       QSCAG2(1-2)   =<cos^2(theta)>*Q_sca for inciden tpols 1,2
!       QTRQAB(1-3,1-2)=vector torque cross section/(PIA2*d^2) for
!                      torque due to absorption, along axes 1-3, for
!                      incident pols 1,2
!                      [QTRQAB(1-3,1-2) is in Lab Frame]
!       QTRQSC(1-3,1-2)=vector torque cross section/(PIA2*d^2) for
!                      torque due to scattering, along axes 1-3, for
!                      incident pols 1,2
!                      [QTRQSC(1-3,1-2) is in Lab Frame]
!       TIMERS(1-12)=timing information
!       ITNUM(1-2)= number of iterations taken for polarizations 1 and 2
!       MXITER    = maximum number of iterations allowed.
! if JO=1:
!       CXSCR1(1->3*NAT0)=reduced polarization vector for incident pol. 1
!       CXSC(LACE->LACE-1+3*NAT0)=reduced polarization vector for incident
!                                 pol. 2
! Requires:
!	MATVEC = external routine to compute A*x
!	CMATVEC = external routine to compute conjg(A')*x
!	where A is matrix such that A*pol=E
!	and x is arbitrary vector

! B.T.Draine, Princeton Univ. Observatory, 1990.
! History:
! 90.11.06 (BTD): modified to change argument list and pass array
!                 dimensions.
! 90.11.29 (BTD): further modifications, including arguments
!                 changed calls to EVALE
! 90.11.29 (BTD): changes to use REDUCE so that computations in
!                 EVALQ and SCAT are restricted to occupied sites.
! 90.11.30 (BTD): multiple changes to reduce storage requirements
! 90.12.03 (BTD): change ordering of XYZ0
! 90.12.10 (BTD): remove XYZ0 and use IXYZ0 instead
! 90.12.13 (BTD): add new argument to calls to EVALQ
! 91.01.03 (BTD): modified so that when IORTH=1 no attempt is made
!                 to compute f_{ml} for "standard" definition of
!                 incident pol. states defined by scattering plane.
! 91.05.09 (BTD): after call to SCAT, adjust QSCA and QSCAG to make
!                 QSCA=QEXT-QABS
! 91.05.09 (BTD): eliminate redundant write statement
! 91.08.14 (BTD): add QBKSCA to argument list for GETFML
!                 add CBKSCA to argument list for SCAT
!                 compute QBKSCA from CBKSCA
! 91.09.17 (BTD): move call to subroutine ALPHA from DDSCAT to GETFML
!                 (since polarizability from Lattice Dipersion Relation
!                 depends on direction of propagation and polarization)
!                 add CALPHA, CXEPS, ICOMP, MXCOMP to argument list for
!                 GETFML
! 93.01.14 (BTD): change method for computing QSCA to use result from
!                 SCAT when albedo << .01 , to use (QEXT-QABS) when
!                 albedo >> .01, and to smoothly join these limits.
! 93.03.11 (BTD): deleted all code associated with unused variable
!                 CMACHN (originally included to identify machine/OS)
! 93.07.09 (BTD): modify method for computing QSCA to use .03 as
!                 the dividing point rather than .01 .
! 93.11.23 (BTD): added SAVE E02 to preserve value of E02 between calls
!                 [to eliminate problem encountered on Silicon Graphics
!                 machines when IPHI>1]
! 94.06.20 (PJF): Added DTIME to argument list for TIMEIT
! 95.06.14 (BTD): Changed CSCAG from scalar to CSCAG(3) vector
!                 where CSCAG(1)=C_sca*<cos(theta)>
!                 Changed QSCAG(1-2) to QSCAG(1-3,1-2)
!                 Added CTRQSC(1-3) to argument list of SCAT
!                 Added QTRQSC(1-3,1-2) to argument list of GETFML
! 95.06.15 (BTD): Added variable CXE to argument list of SCAT
!                 Added CTRQAB(1-3) to argument list of SCAT
!                 Added QTRQAB(1-3,1-2) to argument list of GETFML
! 95.06.16 (PJF+: Modified to eliminate call to DDACCG and replace
!           BTD): with code to call PETR (a modularized implementation
!                 of the Petravic-Kuo CCG algorithm).  With this change
!                 it becomes easier to substitute other implementations
!                 of CCG (or other iterative methods, such as QMR).
! 95.06.19 (BTD): Added CMDSOL to argument list to select CCG method
!               : Added CMDTRQ to argument list to allow torque
!                 calculation to be skipped
! 95.07.10 (BTD): Changed calls to TIMEIT (was not doing timing
!                 properly)
! 95.07.17 (BTD): Relocated call to EVALQ.
!                 Call REDUCE to "reduce" CXE as well as CXP, prior
!                 to calling EVALQ and SCAT.
! 95.07.20 (BTD): Added scratch space SCRRS2 for use by SCAT
!                 Added scratch array CXZW(1-MXNAT,10-12) to SCAT
!                 argument list
! 95.07.27 (BTD): Revised way in which CXALPH is "reduced" prior to
!                 calls to EVALQ and SCAT.
!                 Revised to compute CXALPH for each incident E field
!                 [Only reason this is needed is because of slight
!                 dependence of polarizabilities on incident pol state]
!                 Added scratch space CXSCR1 to argument list, to store
!                 first polarization solution while solving for second
! 95.08.11 (BTD): Relocated CALL CINIT to precede IF statements for
!                 selection of solution method.
! 95.08.14 (BTD): Added COMMON/NORMERR/ERRSCAL to support desired
!                 normalization of error printed out by subroutine
!                 PROGRESS (part of cgcommon.f)
! 96.11.14 (PJF): ADD TIMERS, MXTIMERS, NTIMERS  to formal parameters
!                 modify code to return timer results
!                 TIMERS contains information needed to time the
!                 code (for example CPU time or number of iterations)
!                 timers(1) --- CG CPU time for all iterations
!                 timers(2) --- number of iterations needed
!                 timers(3) --- not used
!                 timers(4) --- scat CPU time
!                 ... see code for timers(5-12)
! 96.11.21 (BTD): declared MXTIMERS,NTIMERS,
! 97.02.20 (BTD): removed SNORM2 from EXTERNAL statement
! 97.11.01 (BTD): added DX(1-3) to argument list of GETFML
!                 and to argument lists for EVALE, ALPHA, and SCAT
!                 [development of DDSCAT.6.0]
! 97.12.26 (BTD): added CXALOF to argument list of GETFML
!                 and to argument list of ALPHA, EVALA
!                 [development of DDSCAT.6.0]
! 98.01.01 (BTD): added 2 calls to new routine RESTORE to expand
!                 CXADIA and CXAOFF back to 3*NAT elements after they
!                 have been "reduced" to 3*NAT0 for efficient
!                 execution of EVALQ
! 98.04.27 (BTD): added declarations for arguments CXAOFF and CXALOF
!                 [development of DDSCAT.6.0]
!                 only call CXALPH once for each orientation, since
!                 in new form of Lattice Dispersion Relation the
!                 polarizability does not depend on polarization,
!                 although it does depend on direction of propagation
! 98.11.18 (BTD): corrected misleading comments apropos EM1R,EM2R
! 98.12.04 (BTD): located error which resulted in subsequent incorrect
!                 evaluation of Mueller scattering matrix.
!                 Problem arose because at some point it was decided to
!                 convert to usual convention for incident polarization
!                 states 1 and 2 for computation of f_ml (CXF11,...)
!                 Unfortunately, this was forgotten, and subroutine
!                 GETMUELLER was written assuming that incident pol.
!                 states l=1 and 2 referred to by f_ml were the ones
!                 specified by the user in ddscat.par.  Because this in
!                 fact does seem preferable, we conform to this
!                 prescription and have disabled the portion of GETFML
!                 which converted to the "usual" convention.  Note
!                 that since f_ml is now entirely for internal use,
!                 (except when IORTH=1, but then we do not compute
!                 Muller matrix) there is no motivation to adopt usual
!                 convention.
! 98.12.07 (BTD): Experiment to verify claimed accuracy from PIM
!                 New module has been inserted into code below but
!                 commented out after verifying that reported errors
!                 appear to be close to "true" errors.
!                 However, module can be reactivated by uncommenting
!                 if such verification is desired in future.  Search
!                 below for string "98.12.07" to find the 2 modules.
! 98.12.16 (BTD): Increase upper limit on number of iterations from 300
!                 to 10000
! 03.01.29 (BTD): returned CXE0R to argument list for ALPHA
!                 reactived calls to ALPHA for different polarizations
!                 since now using LATTDR again instead of GKDLDR
! 03.04.12 (BTD): added variables ITNUM(2) and MXITER to argument list
!                 and modified code to assign values to them
!                 added veriables ITERN and ITERMX
! 03.10.23 (BTD): modified argument list for SCAT:
!                    eliminated ICTHM and IPHIM
!                    added CSCAG2 and NAVG
!                 modified argument list of GETFML
!                    eliminated ICTHM and IPHIM
! 03.10.24 (BTD): added ETASCA to argument list
!                 and to argument list of SCAT
! 04.03.31 (BTD): changed WRITE(0 to WRITE(IDVOUT
! 04.05.22 (BTD): cleanup: comment out declarations of unused variables
!                 CXVAR1,CXVAR1,CXONE,CXZERO
!                 remove IF(IPHIM.GT.1) test, and always store
!                 first polarization (even if only doing one
!                 target orientation, overhead is not significant)
! 04.05.22 (BTD): fixed bug in computation of true error
!                 was summing from 3*I+1 to 3*I+3
!                 now sum from 3*I-2 to 3*I
! 04.09.14 (BTD): added new variables BETADF(1-NAT0),PHIDF(1-NAT0),
!                 THETADF(1-NAT0) describing orientation of anisotropic
!                 target material relative to Target Frame, for each
!                 dipole location.
! 06.09.28 (BTD): version 6.2.3:
! 06.09.29 (BTD): added IPBC to argument list of ALPHA (3 places)
!                 [note that CXZC and CXSC are not used in present
!                 version of ALPHA, but we keep CXZC and CXSC in arg.
!                 list in case some future version of ALPHA might
!                 require complex scratch space
! 07.06.20 (BTD): added X0 to argument list
!                 added X0 to argument list in 3 calls to EVALE
!                 added X0 to argument list in 4 calls to SCAT
! 07.06.22 (BTD): removed THETAN and PHIN from argument list
!                 (not needed, since scattering directions are specified
!                 through vectors AKS)
!                 removed THETAN and PHIN from arg list of subroutine
!                 SCAT
! 07.08.04 (BTD): Version 7.0.3
!                 Replaced COMMON/NORMERR/ with USE DDCOMMON_9
! 07.08.10 (PJF): Added call to ZBCG2
! 07.08.15 (BTD): Use TOLR to communicate with ZBCG2
! 07.09.11 (BTD): Changed IXYZ0 from INTEGER*2 to INTEGER
! 07.10.27 (BTD): Changed SHPAR(6) -> SHPAR(10)
! 08.01.06 (BTD): Cosmetic changes
! 08.02.17 (BTD): Changed SHPAR(10) -> SHPAR(12)
! 08.03.11 (BTD): v2 / ver7.0.5
!                 added ALPHA to argument list
! 08.03.14 (BTD): corrected dimensioning of
!                 IXYZ0(MXNAT,3) -> IXYZ0(NAT0,3)
!                 BETADF(MXNAT) -> BETADF(NAT0)
!                 PHIDF(MXNAT) -> PHIDF(NAT0)
!                 THETADF(MXNAT) -> THETADF(NAT0)
! 08.04.19 (BTD): changed notation: ALPHA -> GAMMA
!                 reordered arguments
! 08.05.08 (BTD): changed SCRRS1(MXNAT3) -> SCRRS1(MXNAT,3)
! 08.05.12 (BTD): changed declaration of DUMMY from REAL to EXTERNAL
!                 as suggested by Lazanoff
! 08.07.16 (BTD): changed 
!                 ITERMX=IPAR(10) 
!                 -> 
!                 ITERMX=MXITER
!                 IPAR(10)=MXITER
! end history

! Copyright (C) 1993,1994,1995,1996,1997,1998,2003,2004,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! diagnostic
!      write(0,*)'getfml ckpt 1, mxnat=',mxnat,' myid=',myid
!***
      IDVOUT2=IDVOUT
      NAT03=3*NAT0

!*** Compute fml directly only if IPHI=1
!    Otherwise use previously computed fml values to obtain new fml

      IF(IPHI==1)THEN

         DO JO=1,IORTH
            IF(JO==1)THEN
               CXE0R(1)=CXE01R(1)
               CXE0R(2)=CXE01R(2)
               CXE0R(3)=CXE01R(3)
            ELSE
               CXE0R(1)=CXE02R(1)
               CXE0R(2)=CXE02R(2)
               CXE0R(3)=CXE02R(3)
            ENDIF
            E02=0._WP
            DO I=1,3
               E02=E02+REAL(CXE0R(I)*CONJG(CXE0R(I)))
            ENDDO

! Compute quantity used for "normalizing" error:

            ERRSCAL=SQRT(NAT0*E02)

!*** call EVALE for NAT sites
!*** diagnostic
!            write(0,*)'getfml ckpt 2, myid=',myid
!***
            CALL EVALE(CXE0R,AKR,DX,X0,IXYZ0,MXNAT,MXN3,NAT,NAT0,NX,NY,NZ,CXE)
!*** diagnostic
!            write(0,*)'getfml ckpt 3, myid=',myid
!***

!***call ALPHA to determine polarizabilities at NAT sites
!    (note: this has to be within the loop over directions and
!     polarizations because Lattice Dispersion Relation polarizabilities
!     depend on direction of propagation and on polarization state)

            CALL ALPHADIAG(AKR,BETADF,PHIDF,THETADF,CALPHA,CXALPH,    &
                           CXALOF,CXALOS,CXE0R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,  &
                           DX,IBETH,IBETH1,ICOMP,IOCC,IPBC,IPHI,IPHI1,IXYZ0, &
                           JO,MYID,MXCOMP,MXNAT,MXN3,NAT,NAT0,NAT3,NCOMP,NX, &
                           NY,NZ,CXRLOC,CSHAPE,SHPAR)

!*** diagnostic
!            write(0,*)'getfml ckpt 4, myid=',myid
!***

!*** call EVALA to prepare A matrix elements

            CALL EVALA(CXADIA,CXAOFF,CXALPH,CXALOF,MXN3,NAT)

! PIMSETPAR sets parameters used by PIM package
! ipar(1) LDA         LDA (Leading dimension of a)
! ipar(2) N           N   (Number of rows/columns of a)
! ipar(3) BLKSZ       N   (Size of block of data; used when data is
!                          partitioned using cyclic mode)
! ipar(4) LOCLEN      N   (Number of elements stored locally; for
!                          sequential=n)
! ipar(5) BASISDIM    C=basis=10 (Dimension of orthogonal basis, used in
!                                 GMRES)
! ipar(6) NPROCS      -1 (Number of processors)
! ipar(7) PROCID      -1 (Processor identification)
! ipar(8) PRECONTYPE PRET (=1 Type of preconditioning
!                     0-no preconditioning, 1-left, 2-right, 3-symmetric
! ipar(9) STOPTYPE   STOPT (Type of stopping criteria used)
! ipar(10) MAXIT     MAXIT (=int(n/2) Maximum number of iterations allowed

! on return from PIM, following are defined:
!      IPAR(11) = itno   (Number of iterations executed)
!      IPAR(12) = exit status 
!                 0: converged
!                -1: no convergence has been achieved
!                -2: soft breakdown, solution may have been found
!                -3: hard breakdown, no solution
!                -4 to -11 : other conditions
!      IPAR(13) = if IPAR(12) = -2 or -3, gives the step number in the
!                 algorithm where a breakdown has occurred.

! Set upper limit on iterations to smaller of 1e4 and NAT0

            MXITER=MIN(10000,NAT03)

! pass information on max.no. of iterations allowed to DDCOMMON_9

!BTD 080716: changed
!            ITERMX=IPAR(10)
            ITERMX=MXITER
            IPAR(10)=MXITER
!-------------------
            SPAR(1)=TOL

! Clean CXE:

            IF(NAT0<NAT)CALL NULLER(CXE,IOCC,MXNAT,MXN3,NAT)

! Iterate to improve CXPOL

!*** diagnostic
!            write(0,*)'getfml ckpt 4.1, myid=',myid
!***
            IF(CMDSOL=='PETRKP')THEN
               CALL PIMSSETPAR(IPAR,SPAR,MXN3,NAT3,NAT3,NAT3, &
                               10,-1,-1,1,5,MXITER,TOL)
               CALL CINIT(NAT3,CMPLX(0._WP,0._WP,KIND=WP),CXPOL,1)
               CALL TIMEIT('PETRKP',DTIME)
               CALL PETR(CXPOL,CXE,CXSC,MXN3,IPAR,SPAR,MATVEC,CMATVEC)
               CALL TIMEIT('PETRKP',DTIME)
               TIMERS(1)=DTIME
               TIMERS(2)=REAL(IPAR(11),KIND=WP)

            ELSEIF(CMDSOL=='PBCGS2')THEN
!*** diagnostic
!               write(0,*)'getfml ckpt 4.2, myid=',myid
!***
               CALL CINIT(NAT3,CMPLX(0._WP,0._WP,KIND=WP),CXPOL,1)
!*** diagnostic
!               write(0,*)'getfml ckpt 4.3, myid=',myid
!***
               CALL TIMEIT('PBCGS2',DTIME)
!*** diagnostic
!               write(0,*)'getfml ckpt 4.4, myid=',myid
!***

!BTD 07.08.15 Use TOLR to input TOL with ZBCG2 (ZBCG2 returns
!             actual achieved tolerance in TOLR)

               TOLR=TOL
!*** diagnostic
!               write(0,*)'getfml ckpt 4.5, myid=',myid
!***
               CALL ZBCG2(.TRUE.,2,NAT3,CXPOL,.FALSE.,CXE,MATVEC,PRECOND, &
                           TOLR,MXITER,CXSC,IPAR(12))
!*** diagnostic
!               write(0,*)'getfml ckpt 4.6, myid=',myid
!***
               CALL TIMEIT('PBCGS2',DTIME)
							   
            ELSEIF(CMDSOL=='PBCGST')THEN

! CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, 
!                 PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)
!flatau warning something is wring with timers because they also time eself - check this
!we need to write better timming routine

!flatau I am just hardwiring number of iterations (mxiter is not used anymore)
!BTD 07.08.12 minor revision

               NO_CG_RESTART=4
               IPAR(12)=-1
	       NO_CG_ITER=0

               CALL PIMSSETPAR(IPAR,SPAR,MXN3,NAT3,NAT3,NAT3, &
                               10,-1,-1,1,2,NO_CG_RESTART,TOL)

               CALL CINIT(NAT3,CMPLX(0._WP,0._WP,KIND=WP),CXPOL,1)
               CALL TIMEIT('PBCGST',DTIME)
!	       DO WHILE(IPAR(12)==-1 .AND. NO_CG_ITER < MX_CG_ITER)
               DO ITER=0,(MXITER/NO_CG_RESTART)
                  IF(IPAR(12).NE.0)THEN
                     IF(ITER.GT.0)WRITE(0,*)'restart PIMZBICGSTAG: ',ITER
                     CALL PIMCBICGSTAB(CXPOL,CXE,CXSC,IPAR,SPAR,MATVEC,DIAGL, &
                                       DUMMY,PCSUM,PSCNRM2,PROGRESS)
                  ENDIF
!                 NO_CG_ITER=NO_CG_ITER+IPAR(11)
               ENDDO
               CALL TIMEIT('PBCGST',DTIME)
               TIMERS(1)=DTIME
               TIMERS(2)=REAL(NO_CG_ITER,KIND=WP)
	    ELSE
               STOP 'Error -- invalid CMDSOL in getfml'
            ENDIF

!*** Reduce the vectors CXADIA, CXAOFF, CXPOL and CXE to retain only
!    occupied sites, to eliminate unnecessary calculations for
!    unoccupied sites when calling EVALQ and SCAT

!*** diagnostic
!            write(0,*)'getfml ckpt 4.7, myid=',myid
!***
            CALL REDUCE(CXADIA,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXAOFF,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXE,IOCC,MXN3,MXNAT,NAT,NAT0)
            CALL REDUCE(CXPOL,IOCC,MXN3,MXNAT,NAT,NAT0)
!*** diagnostic
!            write(0,*)'getfml ckpt 4.8, myid=',myid
!***

! ITERN is obtained from DDCOMMON_9

            ITNUM(JO)=ITERN

!*** Store reduced polarization vector P
!    for use in subsequent computations for other phi values
!    CXSCR1     for JO=1
!    CXSC(LACE) for JO=2 (this scratch space no longer needed by solver)

            IF(JO==1)THEN
!*** diagnostic
!            write(0,*)'getfml ckpt 4.81, myid=',myid
!***
               CALL COPYIT(CXPOL,CXSCR1,NAT03)
            ELSEIF(JO==2)THEN
!*** diagnostic
!            write(0,*)'getfml ckpt 4.82, myid=',myid,' lace=',lace
!***
               CALL COPYIT(CXPOL,CXSC(LACE),NAT03)
            ENDIF
!*** diagnostic
!            write(0,*)'getfml ckpt 4.9, myid=',myid
!***

            CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,CABS,CEXT,CPHA, &
                       MXN3,1)

            QABS(JO)=CABS/PIA2
            QEXT(JO)=CEXT/PIA2
            QPHA(JO)=CPHA/PIA2
            WRITE(IDVOUT,9010)QABS(JO),QEXT(JO)

!*** first call to timeit:

            CALL TIMEIT(' SCAT ',DTIME)

            IF(JO==1)THEN

! call SCAT to compute CXF11,CXF21

!*** diagnostic
!            write(0,*)'getfml ckpt 5, myid=',myid
!            write(0,*)'       NAT0=',nat0
!            write(0,*)'       X0=',X0
!***

               CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,CBKSCA,CSCA, &
                         CSCAG,CSCAG2,CTRQAB,CTRQSC,CXE,CXE01R,CXF11,CXF21,   &
                         CXPOL,CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),MXN3, &
                         MXNAT,MXSCA,MYID,JPBC,NAT0,NAT03,NAVG,NSCAT,SCRRS1,  &
                         SCRRS2,IXYZ0,X0)
!*** diagnostic
!            write(0,*)'getfml ckpt 6, myid=',myid
!***

            ELSEIF(JO==2)THEN

! call SCAT to compute CXF12,CXF22

!*** diagnostic
!            write(0,*)'getfml ckpt 7, myid=',myid
!***
               CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,CBKSCA,CSCA, &
                         CSCAG,CSCAG2,CTRQAB,CTRQSC,CXE,CXE01R,CXF12,CXF22,   &
                         CXPOL,CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),MXN3, &
                         MXNAT,MXSCA,MYID,JPBC,NAT0,NAT03,NAVG,NSCAT,SCRRS1,  &
                         SCRRS2,IXYZ0,X0)
!*** diagnostic
!            write(0,*)'getfml ckpt 8, myid=',myid
!***

            ENDIF

!*** second call to timeit
!*** diagnostic
!            write(0,*)'getfml ckpt 8.1, myid=',myid
!***

            CALL TIMEIT(' SCAT ',DTIME)
!*** diagnostic
!            write(0,*)'getfml ckpt 8.2, myid=',myid
!            write(0,*)'                dtime=',dtime
!            write(0,*)'                pia2=',pia2
!            write(0,*)'                jo=',jo,' qext(jo)=',qext(jo)
!            write(0,*)'                cbksca=',cbksca
!            write(0,*)'                csca=',csca
!***

            TIMERS(4)=DTIME

            IF(JPBC==0)THEN

! Note: at present, SCAT only calculates CBKSCA and CSCA when JPBC=0
!       therefore only calculate QBKSCA(JO), etc, when JPBC=0

               QBKSCA(JO)=CBKSCA/PIA2
               QSCA(JO)=CSCA/PIA2

!*** Since Q_ext and Q_abs are calculated "exactly", when particles
!    are "large" we obtain Q_sca from (Q_ext-Q_abs) rather than
!    scattering cross section computed by SCAT.  This is particularly
!    advantageous when the particles are large with complex scattering
!    patterns, so that angular integration of the differential scatterin
!    cross section would be either very time-consuming or inaccurate.
!    However, when particles are "small" the scattering cross section
!    is small compared to Q_ext and Q_abs, so that the difference
!    (Q_ext-Q_abs) may be inaccurate.  Accordingly, when particles
!    are "small" we instead accept the scattering cross section
!    computed by SCAT (probably quite accurate when albedo is small beca
!    the scattering pattern tends to be dipolar and therefore well-resol
!    by a reasonable number of scattering directions ICTHM and IPHI).
!    We use an ad-hoc procedure to smoothly make the transitions
!    between these regimes, based on the albedo.
!    The "dividing" line of albedo=.03 is chosen on basis of
!    numerical experiments.  If Q_ext and Q_abs are each calculated to
!    accuracy of 1 times 10^{-4} (say), then the
!    difference between Q_ext and Q_abs would be accurate to
!    0.0001*Q_ext*sqrt(2) .  When albedo=.03 (Q_ext-Q_abs)/Q_sca would
!    then be accurate to .0001*sqrt(2)/.03=.005

               FALB=(QSCA(JO)/(.03_WP*QEXT(JO)))**2
               QSCA(JO)=(QSCA(JO)+(QEXT(JO)-QABS(JO))*FALB)/(1._WP+FALB)

!*** diagnostic
!               write(0,*)'getfml ckpt 8.21, myid=',myid
!***
!    Compute QSCAG(1-3,JO), QTRQSC(1-3,JO), QSCAG2

               DO I=1,3
                  QSCAG(I,JO)=QSCA(JO)*CSCAG(I)/CSCA
               ENDDO
               QSCAG2(JO)=QSCA(JO)*CSCAG2/CSCA
               IF(CMDTRQ=='DOTORQ')THEN
                  DO I=1,3
                     QTRQAB(I,JO)=CTRQAB(I)/PIA2
                     QTRQSC(I,JO)=CTRQSC(I)/PIA2
                  ENDDO
               ENDIF

!*** diagnostic
!               write(0,*)'getfml ckpt 8.22, myid=',myid 
!***
            ENDIF !--- end IF(JPBC==0)
         ENDDO !--- end DO J=1,IORTH for IPHI=1

      ELSEIF(IPHI>=2)THEN

!*** Have previously computed dipole polarization vectors for
!    first phi value (and reduced them to NAT03 elements).
!    Use these two solutions to obtain Qabs,Qext, Qpha, Qsca, g*Qsca,
!    and fml for any additional values of target rotation phi.
!    CXSCR1     contains polarization vector for IPHI=1 and JO=1
!    CXSC(LACE) contains polarization vector for IPHI=1 and JO=2

! Incident polarization state 1 = CXE01R
! Call EVALE to obtain E at NAT0 occupied lattice sites
! first call to timing routine

!*** diagnostic
!         write(0,*)'getfml ckpt 8.3, myid=',myid
!***

         CALL TIMEIT(' EVALE',DTIME)

!*** Call EVALE for NAT0 occupied sites

!*** diagnostic
!            write(0,*)'getfml ckpt 9, myid=',myid
!***

         CALL EVALE(CXE01R,AKR,DX,X0,IXYZ0,MXNAT,MXN3,NAT0,NAT0,NX,NY,NZ,CXE)
!*** diagnostic
!            write(0,*)'getfml ckpt 10, myid=',myid
!***

! second call to timing routine

         CALL TIMEIT(' EVALE',DTIME)
         TIMERS(5)=DTIME

! Compute polarizabilities at NAT sites, then reduce to NAT0 occupied
! sites:

         CALL TIMEIT(' ALPHA',DTIME)

!*** diagnostic
!            write(0,*)'getfml ckpt 11, myid=',myid
!***

         CALL ALPHADIAG(AKR,BETADF,PHIDF,THETADF,CALPHA,CXALPH,CXALOF,      &
                        CXALOS,CXE01R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH, &
                        IBETH1,ICOMP,IOCC,IPBC,IPHI,IPHI1,IXYZ0,1,MYID,     &
                        MXCOMP,MXNAT,MXN3,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,     &
                        CXRLOC,CSHAPE,SHPAR)
!*** diagnostic
!            write(0,*)'getfml ckpt 12, myid=',myid
!***

         CALL REDUCE(CXALPH,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL REDUCE(CXALOF,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL TIMEIT(' ALPHA',DTIME)
         TIMERS(6)=DTIME

!*** Construct polarization for incident pol. state 1

         COSPHI=COS(PHI(IPHI)-PHI(1))
         SINPHI=SIN(PHI(IPHI)-PHI(1))
         DO I=1,NAT03
            CXPOL(I)=COSPHI*CXSCR1(I) - SINPHI*CXSC(LACE+I-1)
         ENDDO

!*** first call to timing routine

         CALL TIMEIT(' EVALQ',DTIME)

         CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,CABS,CEXT,CPHA, &
                    MXN3,1)

!*** second call to timing routine

         CALL TIMEIT(' EVALQ',DTIME)
         TIMERS(7)=DTIME
 
         QABS(1)=CABS/PIA2
         QEXT(1)=CEXT/PIA2
         QPHA(1)=CPHA/PIA2

!*** first call to timing routine

         CALL TIMEIT(' SCAT',DTIME)

!*** Now call SCAT to compute CXF11,CXF21
!    CXPOL has been reduced to NAT03 elements
!    first NAT03 elements of IXYZ0 correspond to physical sites

!*** diagnostic
!            write(0,*)'getfml ckpt 13, myid=',myid
!***

         CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,CBKSCA,CSCA,CSCAG, &
                   CSCAG2,CTRQAB,CTRQSC,CXE,CXE01R,CXF11,CXF21,CXPOL,         &
                   CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),MXN3,MXNAT,MXSCA, &
                   MYID,JPBC,NAT0,NAT03,NAVG,NSCAT,SCRRS1,SCRRS2,IXYZ0,X0)

!*** diagnostic
!            write(0,*)'getfml ckpt 14, myid=',myid
!***
!*** second call to timing routine

         CALL TIMEIT(' SCAT',DTIME)
         TIMERS(8)=DTIME

         QBKSCA(1)=CBKSCA/PIA2
         QSCA(1)=CSCA/PIA2

!*** As above, compute Q_sca from either SCAT or (Q_ext-Q_abs)
!    depending on whether albedo << .03 or albedo >> .03

         FALB=(QSCA(1)/(.03_WP*QEXT(1)))**2
         QSCA(1)=(QSCA(1)+(QEXT(1)-QABS(1))*FALB)/(1._WP+FALB)
         DO I=1,3
            QSCAG(I,1)=QSCA(1)*CSCAG(I)/CSCA
            QTRQAB(I,1)=CTRQAB(I)/PIA2
            QTRQSC(I,1)=CTRQSC(I)/PIA2
         ENDDO
         QSCAG2(1)=QSCA(1)*CSCAG2/CSCA

!*** Polarization state 2:

!*** first call to timing routine

         CALL TIMEIT(' EVALE',DTIME)

!*** Call EVALE for NAT0 occupied sites
!    to obtain appropriate E vector for pol. state 2

!*** diagnostic
!            write(0,*)'getfml ckpt 15, myid=',myid
!***

         CALL EVALE(CXE02R,AKR,DX,X0,IXYZ0,MXNAT,MXN3,NAT0,NAT0,NX,NY,NZ,CXE)

!*** diagnostic
!            write(0,*)'getfml ckpt 16, myid=',myid
!***
!*** second call to timing routine

         CALL TIMEIT(' EVALE',DTIME)
         TIMERS(9)=DTIME

! Compute polarizabilities at NAT sites, then reduce to NAT0 occupied
! sites:

         CALL TIMEIT(' ALPHA',DTIME)

!*** diagnostic
!            write(0,*)'getfml ckpt 17, myid=',myid
!***
         CALL ALPHADIAG(AKR,BETADF,PHIDF,THETADF,CALPHA,CXALPH,CXALOF, &
                        CXALOS,CXE02R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,   &
                    IBETH1,ICOMP,IOCC,IPBC,IPHI,IPHI1,IXYZ0,2,MYID,MXCOMP,    &
                    MXNAT,MXN3,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,CXRLOC,CSHAPE,    &
                    SHPAR)

!*** diagnostic
!            write(0,*)'getfml ckpt 18, myid=',myid
!***
         CALL REDUCE(CXALPH,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL REDUCE(CXALOF,IOCC,MXN3,MXNAT,NAT,NAT0)
         CALL TIMEIT(' ALPHA',DTIME)
         TIMERS(10)=DTIME

!*** Construct incident polarization vector for pol. state 2

         DO I=1,NAT03
            CXPOL(I)=COSPHI*CXSC(LACE+I-1)+SINPHI*CXSCR1(I)
         ENDDO

!*** first call to timing routine

         CALL TIMEIT(' EVALQ ',DTIME)

         CALL EVALQ(CXADIA,CXAOFF,AKR,NAT03,E02,CXE,CXPOL,CABS,CEXT,CPHA, &
                    MXN3,1)

!*** second call to timing routine

         CALL TIMEIT(' EVALQ ',DTIME)
         TIMERS(11)=DTIME

         QABS(2)=CABS/PIA2
         QEXT(2)=CEXT/PIA2
         QPHA(2)=CPHA/PIA2

!*** Call SCAT to compute CXF12,CXF22
!    CXPOL has NAT03 elements
!    IXYZ0 was initially given NAT03 elements

!*** first call to timing routine:

         CALL TIMEIT(' SCAT',DTIME)
!*** diagnostic
!            write(0,*)'getfml ckpt 19, myid=',myid
!***

         CALL SCAT(AKR,AKSR,DX,EM1R,EM2R,E02,ETASCA,CMDTRQ,CBKSCA,CSCA,CSCAG, &
                   CSCAG2,CTRQAB,CTRQSC,CXE,CXE01R,CXF12,CXF22,CXPOL,         &
                   CXZW(1,1),CXZW(1,4),CXZW(1,7),CXZW(1,10),MXN3,MXNAT,MXSCA, &
                   MYID,JPBC,NAT0,NAT03,NAVG,NSCAT,SCRRS1,SCRRS2,IXYZ0,X0)

!*** diagnostic
!            write(0,*)'getfml ckpt 20, myid=',myid
!***
!*** second call to timing routine

         CALL TIMEIT(' SCAT',DTIME)
         TIMERS(12)=DTIME

         QBKSCA(2)=CBKSCA/PIA2
         QSCA(2)=CSCA/PIA2

!*** As above, compute Q_sca from either SCAT or (Q_ext-Q_abs)
!    depending on whether albedo << .03 or albedo >> .03

         FALB=(QSCA(2)/(.03_WP*QEXT(2)))**2
         QSCA(2)=(QSCA(2)+(QEXT(2)-QABS(2))*FALB)/(1._WP+FALB)
         DO I=1,3
            QSCAG(I,2)=QSCA(2)*CSCAG(I)/CSCA
            QTRQAB(I,2)=CTRQAB(I)/PIA2
            QTRQSC(I,2)=CTRQSC(I)/PIA2
         ENDDO
         QSCAG2(2)=QSCA(2)*CSCAG2/CSCA

      ENDIF
!*** diagnostic
!      write(0,*)'getfml ckpt 21, myid=',myid,' returning from getfml'
!***
      RETURN
9010  FORMAT (1X,'Q_abs =',1P,E10.3,' Q_ext= ',E10.3)
9200  FORMAT (' final true frac.err=',F12.7)
    END SUBROUTINE GETFML

    SUBROUTINE NAMER(IWAV,IRAD,IDIR,CFLPOL1,CFLPOL2,CFLSCA,CFLAVG)
      IMPLICIT NONE
!***********************************************************************
! Purpose: to generate file names for specific (wavelength,
!                                               size,
!                                               incident direction)
! Present version allows up to 1000 wavelengths, (000-999)
!                              1000 sizes        (000-999)
!                              1000 directions   (000-999)
! Given:
!         IWAV=integer (0-999) identifying wavelength
!         IRAD=integer (0-999) identifying size
!         IDIR=integer (0-999) identifying direction
! Returns:
!         CFLSCA =name for output file containing Qext,Qabs,Qpha,Qsca,g
!                 and fml values for selected directions
!         CFLAVG =name for output file for given wavelength and size,
!                 containing scattering etc. averaged over inc.dir.
!         CFLPOL1=name for output file for given wavelength and size,
!                 containing polarization vector for input pol 1
!         CFLPOL2=name for output file for given wavelength and size,
!                 containing polarization vector for input pol 2

! B.T.Draine, Princeton Univ. Observatory, 1988
! History:
! 90.11.21 (BTD): Modified to allow 3 digits to identify direction
!                 and to change indices to begin from w00r00k000.sca
! 05.10.11 (BTD): Modified to allow 3 digits to identify wavelength
! end history
! 06.04.08 (BTD): Rewritten and extended to CFLPOL1,CFLPOL2
! 07.08.31 (BTD): Added third digit to size identifier IDIR
! Copyright (C) 1993,2005,2006,2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:

      INTEGER :: IDIR,IDIR0,IRAD,IRAD0,IWAV,IWAV0
      CHARACTER :: CFLAVG*15,CFLPOL1*17,CFLPOL2*17,CFLSCA*16

! Local variables:

      CHARACTER :: N(10)*1,V1(3)*1,V2(3)*1,V3(3)*1

! DATA statements:

      DATA N/'0','1','2','3','4','5','6','7','8','9'/
      SAVE N

!***********************************************************************
!*** Filename CFLSCA will be of the form w001r001k001
!     (for IWAV=2,IRAD=2,IDIR=2)

!*** Set IWAV0=IWAV-1 to run over range 0-999
!    Set IRAD0=IRAD-1 to run over range 0-999
!    Set IDIR0=IDIR-1 to run over range 0-999

      IWAV0=IWAV-1
      IRAD0=IRAD-1
      IDIR0=IDIR-1
      V1(1)=N(IWAV0/100+1)
      V1(2)=N((IWAV0-100*(IWAV0/100))/10+1)
      V1(3)=N(IWAV0-10*(IWAV0/10)+1)
      V2(1)=N(IRAD0/100+1)
      V2(2)=N((IRAD0-100*(IRAD0/100))/10+1)
      V2(3)=N(IRAD0-10*(IRAD0/10)+1)
      V3(1)=N(IDIR0/100+1)
      V3(2)=N((IDIR0-100*(IDIR0/100))/10+1)
      V3(3)=N(IDIR0-10*(IDIR0/10)+1)

      CFLAVG='w'//V1(1)//V1(2)//V1(3)//'r'//V2(1)//V2(2)//V2(3)//'.avg'
      CFLSCA='w'//V1(1)//V1(2)//V1(3)//'r'//V2(1)//V2(2)//V2(3)// &
        'k'//V3(1)//V3(2)//V3(3)//'.sca'
      CFLPOL1='w'//V1(1)//V1(2)//V1(3)//'r'//V2(1)//V2(2)//V2(3)// &
        'k'//V3(1)//V3(2)//V3(3)//'.pol1'
      CFLPOL2='w'//V1(1)//V1(2)//V1(3)//'r'//V2(1)//V2(2)//V2(3)// &
        'k'//V3(1)//V3(2)//V3(3)//'.pol2'

      RETURN

    END SUBROUTINE NAMER

    SUBROUTINE REASHP(CSHAPE,CFLSHP,IDVOUT,IDVSHP,A1,A2,DX,X0,BETADF,PHIDF, &
                      THETADF,CDESCR,MXNAT,NAT,IXYZ,ICOMP,MXN3,NAT3)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: IDVOUT,IDVSHP,MXNAT,NAT,MXN3,NAT3
      CHARACTER :: CDESCR*67,CFLSHP*(*),CSHAPE*9
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) ::        &
         A1(3),          &
         A2(3),          &
         BETADF(MXNAT),  &
         DX(3),          &
         PHIDF(MXNAT),   &
         THETADF(MXNAT), &
         X0(3)

! Local variables:

      INTEGER :: J,JJ

!***********************************************************************
! Given:
!    CSHAPE = 'FROM_FILE' to read list of occupied sites and compositions
!                         from file -- use this for targets composed of
!                         isotropic materials
!             'ANIFRMFIL' to read list of occupied sites, compositions,
!                         and orientations for anisotropic material from
!                         file -- use this for targets composed of general
!                         isotropic materials
!    CFLSHP = name of (unformatted) file containing target description
!    IDVSHP  = device number to use in reading this file
!    IDVOUT = device number to use for "running" output
!    MXNAT,MXN3 = dimensioning information
! Returns:
!    A1(3)  = target axis 1
!    A2(3)  = target axis 2
!    DX(3)  = dx/d , dy/d , dz/d   [where d=(dx*dy*dz)^{1/3}]
!    X0(3)  = location/d in TF of lattice site IXYZ=0 0 0
!    CDESCR = string describing target
!    NAT    = number of dipoles in target
!    NAT3   = 3*NAT
!    IXYZ(1-NAT,1-3) = lattice coordinates of dipoles
!    ICOMP(1-NAT,1-3)= composition for directions x,y,z (in Target
!                      Frame) of dipoles 1-NAT.
!    BETADF(1-NAT)=orientation angle "beta" (radians) for
!                  "Dielectric Frame" (DF) relative to Target Frame (TF)
!    PHIDF(1-NAT)=orientation angle "phi" (radians) for DF relative to T
!    THETADF(1-NAT)=orientation angle "theta" (radians) for DF relative
!                   to TF

! Note: It is expected that users may wish to modify this routine
!       to be consistent with whatever target generation software they
!       use.  However, as an example (and for test purposes) this routin
!       is supplied with code compatible with the "target.out" files whi
!       are generated by the program "calltarget"

!       Also provided below (commented out) is
!       a module of code appropriate for reading an unformatted
!       "shape.dat" file for a general target, assuming user's
!       target generation routine writes an unformatted file with
!       the same structure.


!***********************************************************************
! History:
! 91.05.02 (BTD): Added IDVOUT to argument list.
! 91.05.23 (BTD): Added A1, A2 to argument list.
! 91.11.11 (BTD): Modified for compatibility with WRITE statements in
!                 program CALLTARGET; Changed dimensioning of ICOMP from
!                 ICOMP(MXN3) to ICOMP(MXNAT,3)
! 93.09.24 (BTD): Modified to include examples of READ statements
!                 for both unformatted and formatted shape.dat files.
!                 Leave the formatted example (compatible with the
!                 "target.out" files generated by "calltarget") in effec
! 95.04.07 (BTD): Changed CDESCR*60 -> CDESCR*67 for compatibility with
!                 calling routine TARGET
! 95.05.15 (BTD): Changed  READ(DVSHP,FMT='(A60)') to ..(A67)..
!                 Added module for inhomogeneous/anisotropic targets
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 98.02.11 (BTD): Modified to read lattice spacing DX(1-3) from
!                 "shape.dat"
! 98.03.09 (BTD): Add DX(3) to argument list
! 01.04.21 (BTD): Copied over changes made to version 5a10 on 00.11.02:
!                 Modified so now will ALWAYS expect ICOMP(x,y,z) to be
!                 included in file shape.dat
! 04.02.18 (BTD): Eliminated READ(IDVSHP,*)DX as we are not using
!                 noncubic lattices.
! 04.09.14 (BTD): Added CSHAPE,BETADF,PHIDF, and THETADF to the
!                 argument list.
!                 Add support for CSHAPE='ANIFIL' to read dipole
!                 locations, composition, and orientation angles
!                 BETADF, PHIDF, THETADF for Dielectric Frame relative
!                 to Target Frame at each occupied site.
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.08.08 (BTD): Changed FRMFIL -> FROM_FILE
!                         ANIFIL -> ANIFRMFIL
! 08.08.31 (BTD): Updated for consistency with new convention for
!                 target.out files
! 08.09.12 (BTD): Removed extra read statement when called with
!                 CSHAPE=FROM_FILE
! end history

! Copyright (C) 1993,1995,1996,1998,2001,2004,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      IF(CSHAPE=='FROM_FILE'.OR.CSHAPE=='from_file') THEN

! Enable following module of code if "shape.dat" file has been written
! in formatted form consistent with the "target.out" files generated by
! e.g., tarcel.f (inhomoeneous target, with ICOMP in file)

! Note: it is assumed that arrays THETADF,PHIDF,BETADF are
!       initialized to zero prior to calling this routine.

         OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='FORMATTED')
         READ(IDVSHP,FMT='(A67)')CDESCR
         READ(IDVSHP,*)NAT
         READ(IDVSHP,*)A1
         READ(IDVSHP,*)A2
         READ(IDVSHP,*)DX
         READ(IDVSHP,*)X0
         READ(IDVSHP,*)
         DO J=1,NAT
            READ(IDVSHP,*)JJ,IXYZ(J,1),IXYZ(J,2),IXYZ(J,3),ICOMP(J,1), &
                         ICOMP(J,2),ICOMP(J,3)
         ENDDO
         CLOSE(IDVSHP)

      ELSEIF(CSHAPE=='ANIFRMFIL'.OR.CSHAPE=='anifrmfil')THEN

         OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='FORMATTED')
         READ(IDVSHP,FMT='(A67)')CDESCR
         READ(IDVSHP,*)NAT
         READ(IDVSHP,*)A1
         READ(IDVSHP,*)A2
         READ(IDVSHP,*)DX
         READ(IDVSHP,*)X0
         READ(IDVSHP,*)
         DO J=1,NAT
            READ(IDVSHP,*)JJ,IXYZ(J,1),IXYZ(J,2),IXYZ(J,3),ICOMP(J,1), &
                 ICOMP(J,2),ICOMP(J,3),THETADF(J),PHIDF(J),BETADF(J)
         ENDDO
         CLOSE(IDVSHP)
      ELSE
         WRITE(IDVOUT,*)'Fatal error in REASHP: ',              &
                        'do not understand target option ',CSHAPE
         STOP
      ENDIF

!***********************************************************************

! Enable following module of code if "shape.dat" file has been written
! in unformatted form consistent with these read statements:

!      INTEGER JX,JY,JZ
!      OPEN(UNIT=IDVSHP,FILE=CFLSHP,STATUS='OLD',FORM='UNFORMATTED')
!      READ(IDVSHP)CDESCR,NAT,A1,A2,DX,X0
!      READ(IDVSHP)((IXYZ(JX,JY),JX=1,NAT),JY=1,3),
!     &            ((ICOMP(J,JJ),J=1,NAT),JJ=1,3),
!     &            (THETADF(J),J=1,NAT),
!     &            (PHIDF(J),J=1,NAT),
!                  (BETADF(J),J=1,NAT)
!      CLOSE(IDVSHP)

!***********************************************************************

      NAT3=3*NAT
      RETURN
    END SUBROUTINE REASHP

    SUBROUTINE SCAT(AK,AKS,DX,EM1,EM2,E02,ETASCA,CMDTRQ,CBKSCA,CSCA,CSCAG,    &
                    CSCAG2,CTRQIN,CTRQSC,CXE,CXE00,CXF1L,CXF2L,CXP,CXSCR1,    &
                    CXSCR2,CXSCR3,CXSCR4,MXN3,MXNAT,MXSCA,MYID,JPBC,NAT,NAT3, &
                    NAVG,NDIR,SCRRS1,SCRRS2,IXYZ,X0)
!-------------------------------- v4 -----------------------------------------
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      CHARACTER :: CMDTRQ*6
      REAL(WP) :: CBKSCA,CSCA,CSCAG2,E02,ETASCA
      INTEGER :: JPBC,MXN3,MXNAT,MXSCA,MYID,NAT,NAT3,NAVG,NDIR
      INTEGER ::   &
         IXYZ(NAT,3)
      COMPLEX(WP) ::     &
         CXE(NAT,3),     &
         CXE00(3),       &
         CXF1L(MXSCA),   &
         CXF2L(MXSCA),   &
         CXP(NAT,3),     &
         CXSCR1(MXN3),   &
         CXSCR2(MXN3),   &
         CXSCR3(MXN3),   &
         CXSCR4(MXNAT,3)
      REAL(WP) ::        &
         AK(3),          &
         AKS(3,MXSCA),   &
         CSCAG(3),       &
         CTRQIN(3),      &
         CTRQSC(3),      &
         DX(3),          &
         EM1(3,MXSCA),   &
         EM2(3,MXSCA),   &
         SCRRS1(NAT,3),  &
         SCRRS2(MXNAT),  &
         X0(3)

! Local variables:

      CHARACTER :: CMSGNM*70
      COMPLEX(WP) :: CXI,CXSCL1,CXSCL2,CXSCL3,CXZERO
      COMPLEX(WP) :: CXSCL1_L,CXSCL2_L,CXSCL3_L,CXF1L_L,CXF2L_L,CXTRM_K  !Art for local private vars
      REAL(WP) :: AFAC,AK2,AK3,AKK,COSPHI,COSTH,DOMEGA,DPHI,EINC,ES2,PI,PHI, &
                  RRR,SI,SINPHI,SINTH,TERM,THETA,THETA0,THETAL,THETAU,W,X
      INTEGER :: ICOSTH,IPHI,J,K,ND,NPHI,NTHETA
      COMPLEX(WP) ::  &
         CXBS(3),     &
         CXES(3),     &
         CXES_L(3),   &  !Art for private use
         CXTRM(3)
      REAL(WP) ::     &
         AKS0(3),     &
         AKS1(3),     &
         AKS2(3),     &
         AKSN(3),     &
         CTRQSCTF(3), &
         TEMP(MXNAT), &   !Art for local temp
         XYZCM(3)

! Intrinsic functions:

      INTRINSIC COS,EXP,SIN,SQRT,CONJG,REAL

!***********************************************************************

! SCAT computes energy radiated by array of oscillating dipoles
! and corresponding scattering properties if oscillations are in
! response to incident E field.

! Note: *** All vectors are given in the same frame ***
!           (e.g., the Target Frame)

! Given:
!     AK(1-3) = (kx,ky,kz)*d = where (kx,ky,kz)=incident k vector in TF
!               d = (dx*dy*dz)**(1/3) = effective lattice spacing
!     AKS(3,MXSCA)=scattered k vectors in TF
!     DX(1-3) = (dx,dy,dz)/d where dx,dy,dz=x,y,z lattice spacing
!     CMDTRQ = 'DOTORQ' to calculate torques
!            = 'NOTORQ' to skip calculation of torques
!     EM1(3,MXSCA)=pol.vector 1 in TF for each scattering direction
!     EM2(3,MXSCA)=pol.vector 2 in TF for each scattering direction
!     E02 = |E_0|^2 , where E_0 = incident complex E field
!     NAT = number of dipoles
!     NAT3 = 3*NAT
!     IXYZ(NAT,1-3) = [x-X0(1)]/d, [y-X0(2)]/d, [z-X0(3)]/d (integers) 
!                     for dipoles 1-NAT
!     X0(1-3) = location/d in TF of lattice site with IXYZ=(0,0,0)
!     CXE(1-NAT,1-3) = components in TF of E field at each dipole at t=0
!     CXE00(1-3) = (complex) reference polarization vector in TF
!     CXP(1-NAT,1-3) = components in TF of polarization of each dipole at t=0
!     NDIR = number of directions at which scattering matrix elements
!            are to be computed
!     JPBC = 0 for finite target
!            1 for target periodic in y_TF direction
!            2 for target periodic in z_TF direction
!            3 for target periodic in y_TF and z_TF directions
!     MYID = id of this thread 

! Returns:

!     CBKSCA   =differential scattering cross section for theta=pi
!               (lattice units)
!     CSCA     = scattering cross section (lattice units)
!     CSCAG(1) = CSCA*<cos(theta)> , where theta=scattering angle
!     CSCAG(2) = CSCA*<sin(theta)cos(phi)>
!     CSCAG(3) = CSCA*<sin(theta)sin(phi)>
!     CSCAG2   = CSCA*<cos^2(theta)>
!     NAVG     = number of directions used for calculating CSCAG(1-3)
!                and CSCAG2
!   CTRQIN(1-3)=cross section for torque on grain due to incident
!               E and B fields,
!               for torque in directions x,y,z assuming incident
!               radiation is along x direction,
!               and "reference pol state" is in y direction.
!   CTRQSC(1-3)=cross section for torque on grain due to scattered
!               E and B fields,
!               for torque in directions x,y,z assuming incident
!               radiation is along x direction,
!               and "reference pol state" is in y direction
!               Here "torque cross section" is defined so that
!               torque(1-3)=(momentum flux)*(1/k)*C_torque(1-3)
!               Total torque cross section=CTRQIN+CTRQSC
!   CXF1L(NDIR)=f_{1L} for direction NDIR
!   CXF2L(NDIR)=f_{2L} for direction NDIR
!               where f_{1L} connects incident polarization L to
!               outgoing theta polarization (E in scattering plane)
!               f_{2L} connects incident polarization L to outgoing phi
!               polarization (E perpendicular to scattering plane)
!               This is same f_{ml} notation as used by Draine (1988;
!               Ap.J., 333, 848).

! Notes:
!     AKS0(1-3)=k_s*d=scattered k vector (lattice units)
!     AKSN(1-3)=k_s/|k_s|=unit vector in scattering direction
! Scratch vectors introduced to permit vectorization:
!     SCRRS1 = real vector of length.GE.3*NAT
!     SCRRS2 = real vector of length.GE.NAT
!     CXSCR1 = complex scratch array of length 3*MXNAT
!     CXSCR2 = complex scratch array of length 3*MXNAT
!     CXSCR3 = complex scratch array of length 3*MXNAT
!     CXSCR4 = complex scratch array of length 3*MXNAT

! B.T.Draine, Princeton Univ. Obs., 87.01.04
! History:
! 88.06.29 (BTD): modified
! 89.11.28 (BTD): modified
! 90.11.02 (BTD): modified to enable use with vacuum sites.
! 90.11.20 (BTD): corrected error in calculation of f_ml (missing
!                 factor of k).
! 90.12.03 (BTD): changed ordering of XYZ0 and CXP
!                 eliminated cxe0 from argument list
! 90.12.10 (BTD): replaced XYZ0 with IXYZ to reduce memory use
! 91.08.14 (BTD): add CBKSCA to argument list for SCAT
!                 add code to eliminate sum over phi when theta=0 or pi
!                 add code to calculate CBKSCA
! 94.04.04 (BTD): removed superfluous CMPLX( ) operation from 2 lines
!                 in DO 200 loop. Also added new variable TERM to move
!                 some computation out of last DO loop.
! 95.06.14 (BTD): modified to compute moments <sin(theta)cos(phi)>
!                 and <sin(theta)sin(phi)> of scattered radiation
!                 added code to compute torque on grain relative to
!                 grain centroid XYZCM(1-3)
!                 NOTE: handling of grain centroid is not as efficient
!                 as it should be.  Can be recoded to reduce number
!                 of computations.
! 95.06.15 (BTD): modified to compute absorption contribution to
!                 torque on grain.
!                 added CXE and CTRQIN to argument list
! 95.06.15 (BTD): corrected errors found by Joseph Weingartner
! 95.06.16 (BTD): more corrections
! 95.06.20 (BTD): added argument CMDTRQ to allow torque calculations
!                 to be skipped if not desired.
! 95.06.22 (BTD): added factor CXI in terms appearing in evaluation
!                 of scattered torque
! 95.06.29 (BTD): Added loop to compute AKS0(1-3) for special cases
!                 theta-0 and 180. Error found by J. Weingartner.
! 95.07.20 (BTD): Add scratch vector SCRRS2
!                 Add scratch array CXSCR4 to argument list
!                 Rewrite to make torque computation more efficient:
!                 move as many calculations as possible out of loops
!                 over scattering directions:
!                 SCRRS1 now used to store coords relative to centroid
!                 SCRRS2 now used to store (k_s dot r_j)
!                 CXSCR4 is needed to store (p_j cross r_j)
! 95.07.21 (BTD): Rewrite (again!) to make the correspondence
!                 to notation of Draine & Weingartner more apparent.
!                 This involved changing various definitions by
!                 factors of k, and change of sign of CXBS
! 95.07.24 (BTD): Corrected errors in evaluation of both scattering
!                 torque and incident torque
! 95.07.28 (BTD): Reenabled computation of CBKSCA
! 97.11.02 (BTD): Modified to allow use of noncubic lattice:
!                 added DX(1-3) to argument list and used DX in
!                 evaluation of phase factors
! 98.08.10 (BTD): Added DX(1-3) in calculation of scattering amplitudes
!                 FML for selected scattering directions.
! 03.10.21 (BTD): Changed selection of angles used in calculation of
!                 radiation force and torque.
! 03.10.23 (BTD): New method works well.  Number of scattering angles
!                 used in calculation of radiation force (and torque)
!                 will now be set automatically.
!                 Local variable alpha can be used to adjust resolution
!                 if required (alpha now set to 0.5).
!                 Eliminate ICTHM and IPHIM from argument list -- no longer
!                 to be used.
!                 Add CSCAG2 and NAVG to argument list.
! 07.06.20 (BTD): Add X0 to argument list
!                 Modify to use X0 in evaluating phase factors
! 07.06.22 (BTD): Removed THETAN and PHIN from argument list
!                 They are not needed, because scattering directions
!                 are specified by vector AKS
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.01.06 (BTD): Cosmetic changes
! 08.03.14 (BTD): v7.0.5
!                 changed declaration
!                 IXYZ(MXNAT,3) -> IXYZ(NAT,3)
! 08.05.12 (BTD): v7.0.6 changes introduced by Art Lazanoff, NASA Ames:
!                 introduced local variables CXSCL1_L,CXSCL2_L,CXSCL3_L,
!                 and TEMP(MXNAT) 
!                 added numerous OpenMP directives such as
!                    #ifdef scat_omp
!                    !$omp parallel
!                    #endif
!                 which will be compiled only if compiled with
!                 preprocessor flag -fpp -Dscat_omp 
! 08.07.01 (BTD): this is a copy of scat_asl2.f90 as of 08.06.20
! 08.08.06 (BTD): change #ifdef debug -> #ifdef openmp
!                 so that all omp directives are enabled by single
!                 preprocessor flag
! end history
! Copyright (C) 1993,1994,1995,1997,1998,2003,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!*** diagnostic
!      write(0,*)'scat ckpt 0: entered SCAT with JPBC=',JPBC
!***
      CXZERO=(0._WP,0._WP)
      CXI=(0._WP,1._WP)
      PI=4._WP*ATAN(1._WP)

      AK2=AK(1)*AK(1)+AK(2)*AK(2)+AK(3)*AK(3)
      AKK=SQRT(AK2)
      AK3=AKK*AK2

!=======================================================================

!         Calculate scattering and possibly torque for finite target

!    Method used to choose scattering directions for calculation
!    of radiation force and torque:

!    Define function
!                        A*(theta/theta0)
!       s(theta)=theta + ----------------
!                        1 + theta/theta0

!    We choose angles theta to be uniformly-distributed in s.
!    With A > 0 this gives increased resolution at small
!    scattering angles, particularly for theta < theta0

!    We take
!       A=1
!       theta0=2*pi/(1.+x)

!    Parameter etasca determines the numbers of angles, chosen so that
!    the largest interval is
!                                 pi/2
!    [Delta theta]_max = etasca * ----
!                                 3+x

!    A reasonable choice is etasca = 1

!    With etasca=1:
!         x=0 --> [Delta theta]_max = 30 deg
!           1                         22.5 deg
!           10                         6.92
!           15                         5 deg

!    With this requirement for [Delta theta]_max,
!    the number of theta values (including 0 and pi) becomes

!                 2*(3+x)       1 + A/(pi+theta0)
!    NTHETA = 1 + ------- * --------------------------
!                 etasca    1 + A*theta0/(pi+theta0)^2

!    Thus, with A=1 and etasca=1
!    x=0: theta0 = 2*pi   NTHETA=7.19818 -> 7
!      1            pi           9.48970 -> 9
!      2          2*pi/3         12.0646 -> 12
!     10          2*pi/11        32.6897 -> 33

! etasca = 1 appears to work well.
! Use smaller value of ETASCA for improved accuracy

! Incident k vector AK defines one axis (for spherical integration)
! Use (real part of) reference polarization vector CXE00 to define
! second coordinate axis.
! Construct third coordinate axis by taking cross product of first
! two axes.
! AKS1, AKS2 = vectors of length equal to AK lying along second and
!              third coordinate axes.

!*** diagnostic
!      write(0,*)'scat ckpt 1'
!***
      IF(JPBC==0)THEN

         AKS1(1)=REAL(CXE00(1))
         AKS1(2)=REAL(CXE00(2))
         AKS1(3)=REAL(CXE00(3))

! EINC = magnitude of (real part of) reference electric field

         EINC=SQRT(AKS1(1)**2+AKS1(2)**2+AKS1(3)**2)
         IF(EINC<=0._WP)CALL ERRMSG('FATAL','SCAT','CXE00 IS PURE IMAGINARY!')
         RRR=AKK/EINC
         AKS1(1)=RRR*AKS1(1)
         AKS1(2)=RRR*AKS1(2)
         AKS1(3)=RRR*AKS1(3)
         AKS2(1)=(AK(2)*AKS1(3)-AK(3)*AKS1(2))/AKK
         AKS2(2)=(AK(3)*AKS1(1)-AK(1)*AKS1(3))/AKK
         AKS2(3)=(AK(1)*AKS1(2)-AK(2)*AKS1(1))/AKK

!*** diagnostic
!      write(0,*)'scat ckpt 2'
!***
      
         AFAC=1._WP
         X=AKK*(3._WP*NAT/(4._WP*PI))**(1._WP/3._WP)
         THETA0=2._WP*PI/(1._WP+X)
         NTHETA=1+NINT((2._WP*(3._WP+X)/ETASCA)*(1._WP+             &
                AFAC/(PI+THETA0))/(1._WP+AFAC*THETA0/(PI+THETA0)**2))

! prepare for first interval in theta

         THETA=0._WP
         THETAU=0._WP

         CSCA=0._WP
         DO K=1,3
            CSCAG(K)=0._WP
            CTRQSCTF(K)=0._WP
         ENDDO
         CSCAG2=0._WP

         IF(CMDTRQ=='DOTORQ')THEN

!***********************************************************************

! Additional quantities required for torque computations
! XYZCM(1-3) = coordinates of grain centroid
! SCRRS1(J,K)= r_j = coordinates of dipole J relative to centroid.
! CXSCR3(J) = r_j dot p_j
! CXSCR4(J,1-3) = p_j cross r_j

#ifdef openmp
!$omp parallel 
#endif
            DO K=1,3
#ifdef openmp
!$omp single
#endif

               XYZCM(K)=0._WP
#ifdef openmp
!$omp end single
!$omp do reduction(+: XYZCM)
#endif
               DO J=1,NAT
                  XYZCM(K)=XYZCM(K)+(REAL(IXYZ(J,K),KIND=WP)+X0(K))*DX(K)
               ENDDO
#ifdef openmp
!$omp end do
#endif
               XYZCM(K)=XYZCM(K)/REAL(NAT,KIND=WP)
            ENDDO
            DO K=1,3
#ifdef openmp
!$omp do
#endif
               DO J=1,NAT
                  SCRRS1(J,K)=(REAL(IXYZ(J,K),KIND=WP)+X0(K))*DX(K)-XYZCM(K)
               ENDDO
#ifdef openmp
!$omp end do
#endif
            ENDDO
#ifdef openmp
!$omp do private(k)
#endif
            DO J=1,NAT
               CXSCR3(J)=CXZERO
               DO K=1,3
                  CXSCR3(J)=CXSCR3(J)+SCRRS1(J,K)*CXP(J,K)
               ENDDO
            ENDDO
#ifdef openmp
!$omp end do
!$omp do
#endif
            DO J=1,NAT
               CXSCR4(J,1)=CXP(J,2)*SCRRS1(J,3)-CXP(J,3)*SCRRS1(J,2)
               CXSCR4(J,2)=CXP(J,3)*SCRRS1(J,1)-CXP(J,1)*SCRRS1(J,3)
               CXSCR4(J,3)=CXP(J,1)*SCRRS1(J,2)-CXP(J,2)*SCRRS1(J,1)
            ENDDO
#ifdef openmp
!$omp end do
!$omp end parallel
#endif

!***********************************************************************

         ELSE
!*** diagnostic
!           write(0,*)'scat ckpt 3, nat, mxnat = ',nat,mxnat
!***
#ifdef openmp
!$omp parallel
#endif
            DO K=1,3
#ifdef openmp
!$omp do
#endif
               DO J=1,NAT
!*** diagnostic
!                  write(0,*)'scat ckpt 3.5 myid=',myid,' J,K=',J,K, &
!                            ' ixyz(j,k)=',ixyz(j,k)
!***
                  
                  SCRRS1(J,K)=(REAL(IXYZ(J,K),KIND=WP)+X0(K))*DX(K)
!*** diagnostic
!                  write(0,*)'scat ckpt 3.6'
!***
               ENDDO
#ifdef openmp
!$omp end do
#endif
            ENDDO
#ifdef openmp
!$omp end parallel
#endif
         ENDIF !--- end IF(CMDTRQ=='DOTORQ')

! Proceed to sum over scattering angles:
!*** diagnostic
!      write(0,*)'scat ckpt 4, NTHETA=',NTHETA
!***
         NAVG=0

           DO ICOSTH=1,NTHETA

!*** diagnostic
!      write(0,*)'scat ckpt 5, ICOSTH=',ICOSTH
!***

! set the scattering angle THETA
! and calculate THETAU = scattering angle for next value of ICOSTH

            THETAL=THETA
            THETA=THETAU
            IF(ICOSTH<NTHETA)THEN

! THETAU will be the *next* value of theta:
! SI = value of S for *next* value of ICOSTH

               SI=ICOSTH*(PI+AFAC*PI/(THETA0+PI))/(NTHETA-1)
               TERM=SI-AFAC-THETA0
               THETAU=0.5_WP*(TERM+SQRT(TERM**2+4._WP*THETA0*SI))

            ELSE
               THETAU=PI
            ENDIF

            DOMEGA=2._WP*PI*(COS(0.5_WP*(THETAL+THETA))-  &
                   COS(0.5_WP*(THETA+THETAU)))

            COSTH=COS(THETA)
            SINTH=SIN(THETA)

            IF(ICOSTH==1.OR.ICOSTH==NTHETA)THEN
               NPHI=1
            ELSE
               NPHI=NINT(4._WP*PI*SINTH/(THETAU-THETAL))
               NPHI=MAX(NPHI,3)
            ENDIF

! evaluate weight factor W

            W=DOMEGA/REAL(NPHI,KIND=WP)

            DPHI=2._WP*PI/REAL(NPHI,KIND=WP)
            NAVG=NAVG+NPHI

            DO IPHI=1,NPHI

! offset phi values by 0.5*DPHI each time

               PHI=DPHI*(REAL(IPHI,KIND=WP)-0.5_WP*MOD(ICOSTH,2))
               SINPHI=SIN(PHI)
               COSPHI=COS(PHI)

! Compute scattered k vector AKS0(1-3)
! Initialize CXES(1-3) = scattered electric field

               DO K=1,3
                  AKS0(K)=COSTH*AK(K)+SINTH*(COSPHI*AKS1(K)+SINPHI*AKS2(K))
                  CXES(K)=CXZERO
               ENDDO

! Compute normalized scattering vector = nhat

               DO K=1,3
                  AKSN(K)=AKS0(K)/AKK
               ENDDO

! Now compute CXES(1-3) = sum_j[p_j-nhat(nhat dot p_j)]exp[-ik_s dot x_j
!      =(r/k*k)*exp(-ikr+iwt)*E(k_s,r,t)
!      where E(k_s,r,t) is complex electric field vector propagating
!      with wave vector k_s, at distance r from origin
! Notation:
!    If CMDTRQ='DOTORQ', then r_j = position relative to centroid XYZCM
!    If CMDTRQ='NOTORQ', then r_j = original lattice coords, and XYZCM=0
! Note that since we are not concerned with overall phase shifts for
! evaluation of forces and torques, we do NOT need to worry about change
! in phase resulting from using two different definitions of r_j when
! computing phase factors exp[-i k_s dot r_j]

#ifdef openmp
!$omp parallel private(cxes_l,cxscl2_l)
#endif
              cxes_l = cxzero  !Art 
#ifdef openmp
!$omp do private(k)
#endif
               DO J=1,NAT

! CXSCR1(J) = nhat dot p(j)

                  CXSCR1(J)=CXZERO
                  DO K=1,3
                     CXSCR1(J)=CXSCR1(J)+AKSN(K)*CXP(J,K)
                  ENDDO

! SCRRS2(J) = nhat dot r(j)

                  SCRRS2(J)=0._WP
                  DO K=1,3
                     SCRRS2(J)=SCRRS2(J)+SCRRS1(J,K)*AKSN(K)
                  ENDDO

! CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j

                  CXSCR2(J)=EXP(-CXI*AKK*SCRRS2(J))

! CXES(1-3) = sum_j[p_j-nhat(nhat dot p_j)]exp[-ik_s dot x_j]

                  DO K=1,3
!Art                     CXES(K)=CXES(K)+(CXP(J,K)-AKSN(K)*CXSCR1(J))*CXSCR2(J)
                     CXES_l(K)=CXES_l(K)+(CXP(J,K)-AKSN(K)*CXSCR1(J))*CXSCR2(J)
                  ENDDO
               ENDDO
#ifdef openmp
!$omp end do
!$omp atomic
#endif
               cxes(1) = cxes(1) + cxes_l(1)
#ifdef openmp
!$omp atomic
#endif
               cxes(2) = cxes(2) + cxes_l(2)
#ifdef openmp
!$omp atomic
#endif
               cxes(3) = cxes(3) + cxes_l(3)

               IF(CMDTRQ=='DOTORQ')THEN

!***********************************************************************
! Additional terms required to compute torque on grain
! Have already computed
! CXES(1-3)=sum_j[p_j - k_s*(k_s dot p_j)/|k|^2]exp[-ik_s dot x_j]
!             where p_j = polarization of dipole j
!                   x_j = position of dipole j rel. to CM
!                   k_s = scattered k vector

! CXBS = -nhat cross CXES  = -(r/k*k)*exp(-ikr+iwt)*B(k_s,r,t)

                  CXBS(1)=AKSN(3)*CXES(2)-AKSN(2)*CXES(3)
                  CXBS(2)=AKSN(1)*CXES(3)-AKSN(3)*CXES(1)
                  CXBS(3)=AKSN(2)*CXES(1)-AKSN(1)*CXES(2)

! CXSCL1 = sum_j p_j dot (r_j cross nhat)*exp(-i*k_s dot r_j)
!        = nhat dot sum_j (p_j cross r_j)*exp(-i*k_s dot r_j)
! recall that have previously evaluated
! CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j
! CXSCR4(J,K)=p_j cross r_j

#ifdef openmp
!$omp single
#endif
                  CXSCL1=CXZERO
#ifdef openmp
!$omp end single
#endif

!Art                  DO K=1,3
!Art                     CXTRM(K)=CXZERO
!Art                  ENDDO
                  DO K=1,3
#ifdef openmp
!$omp single
#endif
                     CXTRM_K=CXZERO
#ifdef openmp
!$omp end single
!$omp do reduction(+: cxtrm_k)
#endif
                     DO J=1,NAT
!Art                        CXTRM(K)=CXTRM(K)+CXSCR2(J)*CXSCR4(J,K)
                        CXTRM_K=CXTRM_K+CXSCR2(J)*CXSCR4(J,K)
                     ENDDO
#ifdef openmp
!$omp end do
!$omp atomic
#endif
!Art                     CXSCL1=CXSCL1+AKSN(K)*CXTRM(K)
                     CXSCL1=CXSCL1+AKSN(K)*CXTRM_K
                  ENDDO

! CXSCL2 = sum_j[(r_j dot p_j) -
!                 (nhat dot p_j)*((nhat dot r_j) + 2i/k_s)]*
!                 exp(-i*k_s dot r_j)
! Have previously computed
! CXSCR1(J) = nhat dot p(j)
! CXSCR2(J) = exp(-i*k_s dot r_j) factor for atom j
! CXSCR3(J) = r_j dot p_j
! SCRRS2(J) = nhat dot r(j)

#ifdef openmp
!$omp single
#endif
                  CXSCL2=CXZERO
                  CXSCL3=2._WP*CXI/AKK
#ifdef openmp
!$omp end single
!$omp do reduction (+: CXSCL2)
#endif
                  DO J=1,NAT
                     CXSCL2=CXSCL2+CXSCR2(J)*                    &
                              (CXSCR3(J)-CXSCR1(J)*(SCRRS2(J)+CXSCL3))
                  ENDDO
#ifdef openmp
!$omp end do
#endif

! Note following notational correspondence:
!    present    Draine & Weingartner (1996)
!    -------    ---------------------------
!     CXES   =        V_E
!     CXBS   =        V_B
!    CXSCL1  =        S_B
!    CXSCL2  =        S_E

!***********************************************************************
               ENDIF
#ifdef openmp
!$omp end parallel
#endif

! Have completed computation of vector CXES(1-3) and terms to calculate
! angular momentum flux for scattering direction (THETA,PHI).
! CTRQSCTF(K) is "torque cross section" due to "scattered radiation"
! resulting in torque in lattice direction k (i.e., in "target
! frame".  After CTRQSCTF has been evaluated, we will compute CTRQSC in
! the "scattering frame", where radiation is incident along the x direct
! and "reference polarization state" is along the y direction.

               ES2=0.0_WP
               DO K=1,3
                  ES2=ES2+REAL(CXES(K)*CONJG(CXES(K)))
               ENDDO
               CSCA=CSCA+W*ES2
               CSCAG(1)=CSCAG(1)+W*COSTH*ES2
               CSCAG(2)=CSCAG(2)+W*SINTH*COSPHI*ES2
               CSCAG(3)=CSCAG(3)+W*SINTH*SINPHI*ES2
               CSCAG2=CSCAG2+W*COSTH**2*ES2
               IF(CMDTRQ=='DOTORQ')THEN
                  DO K=1,3
                     CTRQSCTF(K)=CTRQSCTF(K)-W*REAL(CONJG(CXBS(K))*CXSCL2+ &
                                 CONJG(CXES(K))*CXSCL1)
                  ENDDO
               ENDIF
            ENDDO !--- end DO IPHI=1,NPHI

! Save backscattering cross section:

            IF(ICOSTH==NTHETA)CBKSCA=AK2*AK2*ES2/E02

         ENDDO !--- end DO ICOSTH=1,NTHETA
!***********************************************************************

         CSCA=AK2*AK2*CSCA/E02

! Convert CSCAG,CSCAG2, and CTRQSCTF to cross sections measured in
! lattice units:

         DO K=1,3
            CSCAG(K)=AK2*AK2*CSCAG(K)/E02
         ENDDO
         CSCAG2=AK2*AK2*CSCAG2/E02
         IF(CMDTRQ=='DOTORQ')THEN

!***********************************************************************
! Compute the two contributions to the torque on the target:
! (1) torque due to E and B fields of incident radiation (CTRQIN)
! (2) torque due to E and B fields of scattered radiation (CTRQSC)
! These are first computed in the target frame, then transformed to
! the lab frame (frame where incident radiation propagates along
! the x axis, and "reference pol. state 1" is along the y axis).

            DO K=1,3
               CTRQSCTF(K)=AK2*AK2*CTRQSCTF(K)/E02
            ENDDO

! CTRQSCTF(1-3) is the vector torque cross section/|k| measured in the
! target frame.  We now compute CTRQSC(1-3)=the vector torque cross
! section in the "scattering frame", where the radiation is incident alo
! the x axis, and the "reference polarization state" (at t=0) is
! linearly polarized along the y axis.
! Note that the following computation introduces an additional factor
! of |k|.

            CTRQSC(1)=AK(1)*CTRQSCTF(1)+AK(2)*CTRQSCTF(2)+AK(3)*CTRQSCTF(3)
            CTRQSC(2)=AKS1(1)*CTRQSCTF(1)+AKS1(2)*CTRQSCTF(2) + &
                      AKS1(3)*CTRQSCTF(3)
            CTRQSC(3)=AKS2(1)*CTRQSCTF(1)+AKS2(2)*CTRQSCTF(2) + &
                      AKS2(3)*CTRQSCTF(3)

! Now compute vector torque cross section due to incident radiation:

            DO K=1,3
               CTRQIN(K)=0._WP
            ENDDO

! Redefine scratch vector CXSCR1:
! CXSCR1(J)=conjg(p_j) dot E_0j at t=0

#ifdef openmp
!$omp parallel do private(k)
#endif
            DO J=1,NAT
               CXSCR1(J)=CXZERO
               DO K=1,3
                  CXSCR1(J)=CXSCR1(J)+CONJG(CXP(J,K))*CXE(J,K)
               ENDDO
            ENDDO
#ifdef openmp
!$omp end parallel do
!$omp single
#endif
            CXSCL1=CXZERO
            CXSCL2=CXZERO
            CXSCL3=CXZERO
#ifdef openmp
!$omp end single
#endif

! Compute CXSCL1,CXSCL2,CXSCL3=components of the torque due to
! incident E and B fields in the target frame.
! 95.06.22 (BTD): added factor CXI in r cross k term appearing in
!                 evaluations of CXSCL1,CXSCL2,CXSCL2
! 95.07.21 (BTD): corrected sign mistake (+CXI -> -CXI)
! 95.07.24 (BTD): changed def. of CXSCR1 to agree with paper,
!                 changed calc. of CXSCLn to more closely mirror paper,
!                 and changed AKS0 to AK

#ifdef openmp
!$omp parallel do reduction(+: CXSCL1,CXSCL2,CXSCL3)
#endif
            DO J=1,NAT
               CXSCL1=CXSCL1+CONJG(CXP(J,2))*CXE(J,3)-                    &
                        CONJG(CXP(J,3))*CXE(J,2)-                         &
                        CXI*(AK(2)*SCRRS1(J,3)-AK(3)*SCRRS1(J,2))*CXSCR1(J)
               CXSCL2=CXSCL2+CONJG(CXP(J,3))*CXE(J,1)-                    &
                        CONJG(CXP(J,1))*CXE(J,3)-                         &
                        CXI*(AK(3)*SCRRS1(J,1)-AK(1)*SCRRS1(J,3))*CXSCR1(J)
               CXSCL3=CXSCL3+CONJG(CXP(J,1))*CXE(J,2)-                    &
                        CONJG(CXP(J,2))*CXE(J,1)-                         &
                        CXI*(AK(1)*SCRRS1(J,2)-AK(2)*SCRRS1(J,1))*CXSCR1(J)
            ENDDO
#ifdef openmp
!$omp end parallel do
#endif

! Compute CTRQIN(1-3)=2*components of torque due to incident E and B
! fields (in lab frame), expressed as a cross section:

            CTRQIN(1)=AK(1)*REAL(CXSCL1)+AK(2)*REAL(CXSCL2)+AK(3)*REAL(CXSCL3)
            CTRQIN(2)=AKS1(1)*REAL(CXSCL1)+AKS1(2)*REAL(CXSCL2)+ &
                      AKS1(3)*REAL(CXSCL3)
            CTRQIN(3)=AKS2(1)*REAL(CXSCL1)+AKS2(2)*REAL(CXSCL2)+ &
                      AKS2(3)*REAL(CXSCL3)
            DO K=1,3
               CTRQIN(K)=4._WP*PI*CTRQIN(K)/E02
            ENDDO
         ENDIF

!***********************************************************************
         WRITE(CMSGNM,FMT='(I8,A)')NAVG,                           &
               ' scattering directions used to calculate <cos>, etc.'
         CALL WRIMSG('SCAT',CMSGNM)

         IF(NDIR<=0)RETURN
      ENDIF ! end IF(JPBC==0)

!============== Following code is used to calculate ====================
!               CXF1L(J=1-NDIR) and CXF2L(J=1-NDIR)
!               for JPBC=0,1,2,3 (i.e., all cases)

!*** diagnostic
!      write(0,*)'in scat, ckpt alpha'
!***
!*** Calculate the 2 matrix elements FM1 for selected directions
! F1L(NDIR) is to the polarization state e1 (E in scattering plane)
! F2L(NDIR) is to the polarization state e2 (E perp. to scatt. plane)

! IMPORTANT NOTE: If the incident radiation is not linearly polarized,
! with zero imaginary component to the polarization vector, then the
! F1L and F2L computed here are NOT the "usual" f_ml, which
! describe scattering from linearly polarized states l to linearly
! polarized states m.
! If one wishes to reconstruct the "usual" f_ml even when computing
! with elliptically polarized light, then one must add additional
! code to subroutine SCAT to reconstruct the f_ml from the F1L and
! F2L computed here.

!*** diagnostic
!      write(0,7431)
!      do j=1,nat
!         write(0,7432)j,cxp(j,1),cxp(j,2),cxp(j,3)
!      enddo
! 7431 format(' j  ---------------- cxp(j,1-3) -------------------------')
! 7432 format(i4,2f10.5,1x,2f10.5,1x,2f10.5)
!*** end diagnostic
!*** diagnostic
!      write(0,*)'scat ckpt 6'
!***
      TERM=AK3/SQRT(E02)
      DO ND=1,NDIR
         CXF1L(ND)=CXZERO
         CXF2L(ND)=CXZERO
#ifdef openmp
!$OMP parallel 
!$omp single
#endif
         cxf1l_l = cxzero
         cxf2l_l = cxzero
#ifdef openmp
!$omp end single
!$OMP do private (k) reduction(+: cxf1l_l, cxf2l_l)
#endif
         DO J=1,NAT
            CXSCR2(J)=CXZERO
            CXSCR3(J)=CXZERO
            CXSCR1(J)=EXP(-CXI*(                                         &
                      AKS(1,ND)*(REAL(IXYZ(J,1),KIND=WP)+X0(1))*DX(1)+   &
                      AKS(2,ND)*(REAL(IXYZ(J,2),KIND=WP)+X0(2))*DX(2)+   &
                      AKS(3,ND)*(REAL(IXYZ(J,3),KIND=WP)+X0(3))*DX(3)))
            DO K=1,3
               CXSCR2(J)=CXSCR2(J)+CXP(J,K)*EM1(K,ND)
               CXSCR3(J)=CXSCR3(J)+CXP(J,K)*EM2(K,ND)
            ENDDO
            CXF1L_L=CXF1L_L+CXSCR2(J)*CXSCR1(J)
            CXF2L_L=CXF2L_L+CXSCR3(J)*CXSCR1(J)
         ENDDO
#ifdef openmp
!$omp end do
!$omp end parallel
#endif

!*** diagnostic
!         write(0,9900)nd,aks(1,nd),aks(2,nd),aks(3,nd), &
!                         em1(1,nd),em1(2,nd),em1(3,nd), &
!                         em2(1,nd),em2(2,nd),em2(3,nd)
! 9900 format('nd=',i2,' aksr=',3f10.5,/,           &
!             6x,'em1r=',3f10.5,/,6x,'em2r=',3f10.5)
!
!         do j=1,nat
!            write(0,9910)j,cxscr2(j),cxscr3(j)
! 9910       format(i2,' cxscr2=',2f8.4,' cxscr3=',2f8.4)
!         enddo
!***
!Art         DO J=1,NAT
!Art            CXSCR1(J)=EXP(-CXI*(                                         &
!Art                      AKS(1,ND)*(REAL(IXYZ(J,1),KIND=WP)+X0(1))*DX(1)+   &
!Art                      AKS(2,ND)*(REAL(IXYZ(J,2),KIND=WP)+X0(2))*DX(2)+   &
!Art                      AKS(3,ND)*(REAL(IXYZ(J,3),KIND=WP)+X0(3))*DX(3)))
!Art            CXF1L(ND)=CXF1L(ND)+CXSCR2(J)*CXSCR1(J)
!Art            CXF2L(ND)=CXF2L(ND)+CXSCR3(J)*CXSCR1(J)
!Art            CXF1L_L=CXF1L_L+CXSCR2(J)*CXSCR1(J)
!Art            CXF2L_L=CXF2L_L+CXSCR3(J)*CXSCR1(J)
!Art         ENDDO
!Art!$omp end  do
         CXF1L(ND) = CXF1L_L
         CXF2L(ND) = CXF2L_L
!Art!$omp end parallel

!   Units: Dipole polarizations are in units of [E]*d**3, where d=lattic
!          spacing, and [E]=dimensions of E field
!          Therefore, up to this point CXF1L, CXF2L are in units
!          of [E]*d**3
!          Now multiply by AK3/SQRT(E02) (units of 1/([E]d**3)) to get
!          dimensionless result.

         CXF1L(ND)=CXF1L(ND)*TERM
         CXF2L(ND)=CXF2L(ND)*TERM

! diagnostic
!        write(0,9700)nd,cxf1l(nd),cxf2l(nd)
! 9700   format('nd=',i3,' cxf1L=',1p,2e10.3,' cxf2L=',2e10.3)
! end diagnostic

      ENDDO !--- end DO ND=1,NDIR

!*** diagnostic
!      write(0,*)'returning from SCAT'
!***
      RETURN
    END SUBROUTINE SCAT

    SUBROUTINE SIZER(MXNAT,NAT,IXYZ,LXYZ)
      IMPLICIT NONE
! Arguments:
      INTEGER :: MXNAT,NAT
      INTEGER :: &
         LXYZ(3)
      INTEGER :: &
         IXYZ(MXNAT,3)
! Local variables:
      CHARACTER :: CMSGNM*70
      INTEGER :: JA,JD,JX
      INTEGER ::   &
         LXMIN(3), &
         LXMAX(3)
!***********************************************************************

! Purpose: to determine full extent of target in x,y,z directions
! in order to determine what "computational" volume will be.
! B.T.Draine, Princeton University Observatory, 96.01.26
! History:
! 96.11.21 (BTD) modified to replace WRITE(0,... with CALL WRIMSG
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER
! end history
! Copyright (C) 1996,2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DO JD=1,3
        LXMIN(JD)=IXYZ(1,JD)
        LXMAX(JD)=LXMIN(JD)
      ENDDO
      DO JD=1,3
        DO JA=2,NAT
          JX=IXYZ(JA,JD)
          IF(JX<LXMIN(JD))LXMIN(JD)=JX
          IF(JX>LXMAX(JD))LXMAX(JD)=JX
        ENDDO
      ENDDO
      DO JD=1,3
        LXYZ(JD)=LXMAX(JD)-LXMIN(JD)+1
      ENDDO
      JA=LXYZ(1)*LXYZ(2)*LXYZ(3)
      WRITE(CMSGNM,6000) LXYZ,JA
      CALL WRIMSG('SIZER ',CMSGNM)
6000  FORMAT('min. comp. vol.: L_x*L_y*L_z=',I5,' *',I5,' *',I5,' =',I8)
      RETURN
    END SUBROUTINE SIZER

    SUBROUTINE DIVIDE(CDIVID,X1,X2,NX,MXARY,ARY)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
! Arguments:
      REAL (WP) :: X1, X2
      INTEGER :: MXARY, NX
      CHARACTER :: CDIVID*3
      REAL (WP) :: ARY(MXARY)

! Local variables:
      INTEGER :: I
      REAL (WP) :: DELTA

! External Subroutines:
      EXTERNAL ERRMSG, WRIMSG

! Intrinsic Functions:
      INTRINSIC REAL
!***********************************************************************
! Given:
!       CDIVID='LIN','INV', or 'LOG'
!       X1 = lower limit to interval
!       X2 = upper limit to interval
!       NX = number of elements
!       MXARY=dimensioning information for array ARY

! Returns:
!       ARY(1-NX)=vector of points with
!                 ARY(1)=X1
!                 ARY(NX)=X2
!                 ARY(J) values spaced either
!                        linearly (if CDIVID.EQ.'LIN')
!                        linearly in 1/X (if CDIVID.EQ.'INV')
!                        logarithmically (if CDIVID.EQ.'LOG')

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      IF (NX>MXARY) THEN
        CALL ERRMSG('FATAL','DIVIDE','  NX .GT. MXARY ')
      END IF
!      IF(X1.GT.X2)THEN
!         CALL ERRMSG('FATAL','DIVIDE','  X1 .GT. X2 ')
!      ENDIF
      IF (NX<1) THEN
        CALL ERRMSG('FATAL','DIVIDE','  NX .LT. 1 ')
      END IF
      IF (NX==1) THEN
        CALL WRIMSG('DIVIDE',' Only one element initialized ')
        ARY(1) = X1
      ELSE
        IF (CDIVID=='LIN') THEN
          DELTA = (X2-X1)/REAL(NX-1,KIND=WP)
          DO I = 1, NX
            ARY(I) = X1 + DELTA*REAL(I-1,KIND=WP)
          END DO
        ELSE IF (CDIVID=='INV') THEN
          DELTA = (1._WP/X2-1._WP/X1)/REAL(NX-1,KIND=WP)
          DO I = 1, NX
            ARY(I) = 1._WP/(1._WP/X1+DELTA*REAL(I-1,KIND=WP))
          END DO
        ELSE IF (CDIVID=='LOG') THEN
          DELTA = LOG(X2/X1)/REAL(NX-1,KIND=WP)
          DO I = 1, NX
            ARY(I) = EXP(LOG(X1)+DELTA*REAL(I-1,KIND=WP))
          END DO
        END IF
      END IF
      RETURN
    END SUBROUTINE DIVIDE

    SUBROUTINE GETMUELLER(IBETA,IORTH,IPHI,ITHETA,JPBC,MXBETA,MXSCA,MXPHI,   &
        MXTHET,NSCAT,ORDERM,ORDERN,CMDTRQ,AK1,AKSR,ENSC,ENSCR,PYDDX,PZDDX,   &
        PHIN,SM,SMORI,S1111,S2121,CX1121,CXE01,CXE02,CXF11,CXF12,CXF21,      &
        CXF22,CXS1,CXS2,CXS3,CXS4,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,QEXT,     &
        QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,QSCG2SUM,QSCGSUM,QSCSUM,QTRQAB,       &
        QTRQABSUM,QTRQSC,QTRQSCSUM,WGTA,WGTB,EM1,EM2,EM1R,EM2R)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: IBETA,IORTH,IPHI,ITHETA,JPBC,MXBETA,MXSCA,MXPHI,MXTHET,NSCAT
      CHARACTER :: CMDTRQ*6
      REAL(WP) :: AK1,PYDDX,PZDDX,WG
      REAL(WP) ::            &
         AKSR(3,MXSCA),      &
         EM1(3,MXSCA),       &
         EM1R(3,MXSCA),      &
         EM2(3,MXSCA),       &
         EM2R(3,MXSCA),      &
         ENSC(3,MXSCA),      &
         ENSCR(3,MXSCA),     &
         ORDERM(MXSCA),      &
         ORDERN(MXSCA),      &
         PHIN(MXSCA),        &
         QABS(2),            &
         QABSUM(2),          &
         QBKSCA(2),          &
         QBKSUM(2),          &
         QEXSUM(2),          &
         QEXT(2),            &
         QPHA(2),            &
         QPHSUM(2),          &
         QSCAG(3,2),         &
         QSCAG2(2),          &
         QSCAT(2),           &
         QSCG2SUM(2),        &
         QSCGSUM(3,2),       &
         QSCSUM(2),          &
         QTRQAB(3,2),        &
         QTRQABSUM(3,2),     &
         QTRQSC(3,2),        &
         QTRQSCSUM(3,2),     &
         S1111(MXSCA),       &
         S2121(MXSCA),       &
         SM(4,4,MXSCA),      &
         SMORI(4,4,MXSCA),   &
         WGTA(MXTHET,MXPHI), &
         WGTB(MXBETA)
      COMPLEX(WP) ::    &
         CX1121(MXSCA), &
         CXE01(3),      &
         CXE02(3),      &
         CXF11(MXSCA),  &
         CXF12(MXSCA),  &
         CXF21(MXSCA),  &
         CXF22(MXSCA),  &
         CXS1(MXSCA),   &
         CXS2(MXSCA),   &
         CXS3(MXSCA),   &
         CXS4(MXSCA)

! Local variables:

      INTEGER :: J,K,JO,ND,ND2
      REAL(WP) :: COSPHI,FAC,FAC0,PI,SINPHI
      COMPLEX(WP) :: CXA,CXB,CXC,CXD,CXI,CXTRM1,CXTRM2

!***********************************************************************
! Given:
!   IBETA =index specifying rotation of target around axis a1
!   IORTH =number of incident polarization states being calculated for
!   IPHI  =index specifying phi value for orientation of target axis a1
!   ITHETA=index specifying theta value for orientation of target axis
!          a1
!   JPBC  = 0 if PBC not used
!           1 if PBC used in y direction only
!           2 if PBC used in z direction only
!           3 if PBC used in both y and z directions
!   MXBETA=dimensioning information
!   MXSCA =dimensioning information
!   MXPHI =dimensioning information
!   MXTHET=dimensioning information
!   NSCAT =number of scattering directions for evaluation of Mueller
!          matrix
!   CMDTRQ='DOTORQ' or 'NOTORQ' depending on whether or not torque
!          calculation is to be carried out
!   ENSC(1-3,1-NSCAT)=normalized scattering direction vector in Lab Frame
!                     for scattering directions 1-NSCAT
!   ENSCR(1-3,1-NSCAT)=normalized scattering direction vector in Target
!                      Frame for scattering directions 1-NSCA
!   EM1(1-3,1-NSCAT)=unit scattering polarization vector 1 in Lab Frame
!   EM2(1-3,1-NSCAT)=unit scattering polarization vector 2 in Lab Frame
!   EM1R(1-3,1-NSCAT)=unit scattering polarization vector 1 in Target Frame
!   EM2R(1-3,1-NSCAT)=unit scattering polarization vector 2 in Target Frame
!   PHIN(1-NSCAT)=values of PHI for scattering directions 1-NSCAT in
!                 Lab Frame
!                 [only used if JPBC=0: scattering by finite target]
!   AKSR(1-3,1-NSCAT)=(kx,ky,kz)*d for NSCAT scattering directions
!                    in Target Frame
!   ORDERM(1-NSCAT)=scattering order M for case of 1-d or 2-d target
!   ORDERN(1-NSCAT)=scattering order N for case of 2-d target
!   S1111(1-NSCAT)=weighted sum of |f_11|^2 over previous orientations
!   S2121(1-NSCAT)=weighted sum of |f_21|^2 over previous orientations
!   CXE01(1-3)    =incident pol state 1 in Lab Frame
!   CXE02(1-3)    =                   2
!   CXF11(1-NSCAT)=f_11 for current orientation
!   CXF12(1-NSCAT)=f_12 for current orientation
!   CXF21(1-NSCAT)=f_21 for current orientation
!   CXF22(1-NSCAT)=f_22 for current orientation
!   QABS(2)       =Q_abs for two incident polarizations
!   QABSUM(2)     =weighted sum of Qabs over previous orientations
!   QBKSCA(2)     =Q_bk for two incident polarizations
!   QBKSUM(2)     =weighted sum of Q_bk over previous orientations
!   QEXSUM(2)     =weighted sum of Q_ext over previous orientations
!   QEXT(2)       =Q_ext for two incident polarizations
!   QPHA(2)       =Q_pha for two incident polarizations
!   QPHSUM(2)     =weighted sum of Q_ph over previous orientations
!   QSCAG(3,2)    =Q_pr vector for two incident polarizations
!   QSCAT(2)      =Q_sca for two incident polarizations
!   QSCGSUM(3,2)  =weighted sum of Q_pr vector over prev. orients.
!   QSCSUM(2)     =weighted sum of Q_sca over previous orientations
!   QTRQAB(3,2)   =absorptive part of Q_gamma for two inc. pols.
!   QTRQABSUM(3,2)=weighted sum of Q_gamma over previous orientations
!   QTRQSC(3,2)   =scattering part of Q_gamma for two inc. pols.
!   QTRQSCSUM(3,2)=weighted sum of Q_gamma over previous orientations
!   WGTA(ITHETA,IPHI)=weight factor for theta,phi orientation
!   WGTB(IBETA)      =weight factor for beta orientation
!   SMORI(1-NSCAT,4,4)=weighted sum of Mueller matrix over previous
!                      orientations
! If IORTH=1, returns:
!   S1111(1-NSCAT)=updated weighted sum of |f_11|^2 over NSCAT
!                  scattering directions
!   S2121(1-NSCAT)=updated weighted sum of |f_21|^2
!   CX1121(1-NSCAT)=updated weighted summ of f_11*conjg(f_21)

! If IORTH=2, returns:
!   SM(1-NSCAT,4,4)=Mueller matrix for current orientation, and NSCAT
!                   scattering directions
!   CXS1(1-NSCAT)=amplitude scattering matrix element S_1 for current
!                 orientation
!   CXS2(1-NSCAT)=amplitude scattering matrix element S_2 for current
!                 orientation
!   CXS3(1-NSCAT)=amplitude scattering matrix element S_3 for current
!                 orientation
!   CXS4(1-NSCAT)=amplitude scattering matrix element S_4 for current
!                 orientations
!   QABSUM(2)     =updated weighted sum of Q_abs
!   QBKSUM(2)     =updated weighted sum of Q_bk
!   QEXSUM(2)     =updated weighted sum of Q_ext
!   QSCGSUM(3,2)  =updated weighted sum of Q_pr vector
!   QSCSUM(2)     =updated weighted sum of Q_sca
!   QTRQABSUM(3,2)=updated weighted sum of absorptive contribution to
!                  Q_gamma
!   QTRQSCSUM(3,2)=updated weighted sum of scattering contribution to
!                  Q_gamma

!   SMORI(1-NSCAT,4,4)=updated weighted sum of Mueller matrix elements

! History:
! 96.11.11 (BTD) ready for use
! 97.07.24 (BTD) corrected error in computation of amplitude scattering
!                matrix elements (CXS1,CXS2,CXS3,CXS4) and Mueller matri
!                elements SM.  Until now code mistakenly used PHI
!                defining target orientation rather than PHIN
!                defining scattering direction.  Correction of error
!                required replacing PHI by PHIN in argument list,
!                thereby requiring corresponding change in DDSCAT.
!                All calculated Mueller matrix elements until now were
!                therefore incorrect except for special cases where
!                PHI and PHIN were coincidentally the same (e.g.
!                target orientation PHI=0 and scattering plane PHIN=0).
!                This error was pointed out by Henriette Lemke (Inst.
!                for Atmospheric Physics, GKSS - Research Center,
!                Geesthacht.
! 97.07.24 (BTD) also corrected sign mistake in evaluation of S_14
!                and typo in evaluation of S_31.  Note that since S_31
!                had been evaluated incorrectly, PPOL (evaluated by
!                subroutine WRITESCA) was then numerically incorrect.
! 98.11.01 (BTD) Timo Nousiainen (tpnousia@lumi.meteo.helsinki.fi)
!                reported a problem with S_12 computed by DDSCAT for
!                a pseudosphere target when the scattering plane has
!                e.g. phi=90.  Problem is real and must be tracked down
!                and corrected.
! 98.11.16 (BTD) Modified code calculating complex amplitude scattering
!                matrix elements S1,S2,S3,S4 from f_ij.
! 00.06.13 (BTD) make data conversions explicit
! 03.10.23 (BTD) add QSCAG2 and QSCAG2SUM to argument list
!                add code to update QSCAG2SUM
! 06.10.07 (BTD) extend to handle 1-d and 2-d periodic targets
!                * add JPBC to arg list
!                * add PYDDX and PZDDX to arg list
! 06.12.24 (BTD) ver 7.0.1
!                * redefine normalization of Mueller matrix for 1d targe
! 06.12.25 (BTD) * for 2d targets, add contribution of incident wave to
!                  forward scattering if M=N=0
! 07.06.22 (BTD) ver 7.0.2
!                correct calculation of S_{ij} for targets with 1-d
!                periodicity
! 07.07.03 (BTD) introduce new treatment for evaluation of CXS1,CXS2,
!                CXS3,CXS4 when JPBC > 0 (previous treatment was not
!                correct).
!                add ENSC to argument list to support this new approach
! 07.07.08 (BTD) added EM1,EM2 to argument list
!                modified code to determine S matrix in case of
!                forward scattering (use EM1,EM2)
! 07.09.13 (BTD) Cosmetic changes
! 07.10.08 (BTD) Rewritten
! 07.10.09 (BTD) Added EM1R,EM2R to argument list
! 07.10.24 (BTD) Added ENSCR to argument list
! 07.12.29 (BTD) Experimentally determined correct phase relationship
!                between incident wave and scattered wave in case
!                of forward scattering from target that is periodic
!                in 2 dimensions.
! 08.05.29 (BTD) ver7.0.6
!                * changed declaration of arguments
!                  SM(MXSCA,4,4)    -> SM(4,4,MXSCA)
!                  SMORI(MXSCA,4,4) -> SMORI(4,4,MXSCA)
!                * made corresponding reordering of indices in lines
!                  evaluating SM and SMORI
! end history

! Copyright (C) 1996,1997,1998,2000,2003,2006,2007
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!*********  Sum scattering properties over orientations ****************

! Correspondence to notation of Bohren & Huffman (1983):
! Our f_jk correspond to notation of Draine (1988).
! For the special case where incident polarization modes 1 and 2 are
! parallel and perpendicular to the scattering plane, we have the
! relationship between the f_jk and the elements S_j of the amplitude
! scattering matrix as defined by Bohren & Huffman (1983) is as follows:
!     S_1 = -i*f_22
!     S_2 = -i*f_11
!     S_3 =  i*f_12
!     S_4 =  i*f_21
! In this case (incident pol. states parallel,perpendicular to the
! scattering plane), the elements of the 4x4 Mueller matrix (see Bohren
! Huffman 1983) are related to our f_jk as follows:
!     S_11 = [|f_11|^2 + |f_22|^2 + |f_12|^2 + |f_21|^2]/2
!     S_12 = [|f_11|^2 + |f_21|^2 - |f_22|^2 - |f_12|^2]/2
!     S_13 = -Re[f_11*conjg(f_12) + f_22*conjg(f_21)]
!     S_14 =  Im[f_22*conjg(f_21) - f_11*conjg(f_12)]
!     S_21 = [|f_11|^2 + |f_12|^2 - |f_22|^2 - |f_21|^2]/2
!     S_22 = [|f_11|^2 + |f_22|^2 - |f_21|^2 - |f_12|^2]/2
!     S_23 =  Re[f_22*conjg(f_21) - f_11*conjg(f_12)]
!     S_24 = -Im[f_11*conjg(f_12) + f_22*conjg(f_21)]
!     S_31 = -Re[f_11*conjg(f_21) + f_22*conjg(f_22)]
!     S_32 =  Re[f_22*conjg(f_12) - f_22*conjg(f_21)]
!     S_33 =  Re[f_22*conjg(f_11) + f_12*conjg(f_21)]
!     S_34 =  Im[f_11*conjg(f_22) + f_21*conjg(f_22)]
!     S_41 = -Im[f_21*conjg(f_11) + f_22*conjg(f_12)]
!     S_42 =  Im[f_22*conjg(f_12) - f_22*conjg(f_11)]
!     S_43 =  Im[f_22*conjg(f_11) - f_12*conjg(f_21)]
!     S_44 =  Re[f_22*conjg(f_11) - f_12*conjg(f_21)]

! Notation internal to this program:
! ij.ne.kl: CX_ijkl = \f_ij* \times f_kl  (summed over orientations)
!            S_ijij = \f_ij* \times f_ij  (summed over orientations)
! 4 pure real elements: S1111,S1212,S2121,S2222
! 8 complex elements:   CX1112,CX1121,CX1122,CX1221,CX1222,CX2122
! 4 redundant elts.:    CX1211 = Conjg(CX1112)
!                       CX2111 = Conjg(CX1121)
!                       CX2112 = Conjg(CX1221)
!                       CX2211 = Conjg(CX1122)

! In this routine we will carry out fully general calculation of the
! 4x4 Mueller matrix elements, valid for arbitrary incident polarization
! states j=1,2 for which we have the scattering matrix f_ij

! First, we compute the amplitude scattering matrix elements S_1,S_2,
! S_3,S_4 as defined by Bohren & Huffman:
!=======================================================================
      CXI=(0._WP,1._WP)
      PI=4._WP*ATAN(1._WP)

! WG=weighting factor for this orientation

      WG=WGTA(ITHETA,IPHI)*WGTB(IBETA)
      IF(IORTH==2)THEN

! CXE01,CXE02 are unit incident polarization vectors in Lab Frame.
! We assume CXE01 and CXE02 are normalized (REAPAR makes sure of this).
! CXA,CXB,CXC,CXD are complex coefficients corresponding to dot product
! of complex polarization vectors CXE01,CXE02 with y and z unit vectors
! in Lab Frame.

         CXA=CONJG(CXE01(2))
         CXB=CONJG(CXE01(3))
         CXC=CONJG(CXE02(2))
         CXD=CONJG(CXE02(3))

!*** diagnostic
!         write(0,*)'getmueller ckp a'
!         write(0,*)'cxa=',cxa
!         write(0,*)'cxb=',cxb
!         write(0,*)'cxc=',cxc
!         write(0,*)'cxd=',cxd
!***

! Compute complex scattering amplitudes S_1,S_2,S_3,S_4 for this
! particular target orientation and NSCAT scattering directions:

         IF(JPBC==0)THEN
            DO ND=1,NSCAT
               SINPHI=SIN(PHIN(ND))
               COSPHI=COS(PHIN(ND))
               CXS1(ND)=CXI*(CXF21(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                             CXF22(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS2(ND)=-CXI*(CXF11(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                              CXF12(ND)*(CXD*SINPHI+CXC*COSPHI))
               CXS3(ND)=-CXI*(CXF11(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                              CXF12(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS4(ND)=CXI*(CXF21(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                             CXF22(ND)*(CXD*SINPHI+CXC*COSPHI))
            ENDDO

         ELSEIF(JPBC==1.OR.JPBC==2)THEN

! JPBC = 1 or 2:
! ENSC(1-3,ND) = components of scattering unit vector in Lab Frame
! CXA,CXB = y,z components of incident polarization state 1 in Lab Frame
! CXC,CXD = y,z                                           2 in Lab Frame

            DO ND=1,NSCAT
               FAC=SQRT(ENSC(2,ND)**2+ENSC(3,ND)**2)
               IF(FAC<=1.E-3_WP)THEN

! if FAC = 0, then scattering is in either forward (theta=0) or
!                  backward (theta=pi) directions

                  FAC=SQRT(EM1(2,ND)**2+EM2(2,ND)**2)
                  FAC=FAC*SQRT(REAL(CXA)**2+REAL(CXB)**2)
                  COSPHI=REAL(CXA*EM1(2,ND)+CXB*EM1(3,ND))/FAC
                  SINPHI=-REAL(CXA*EM2(2,ND)+CXB*EM2(3,ND))/FAC

               ELSE

! if scattering angle is neither 0 nor pi:

                  COSPHI=REAL(CXA*ENSC(2,ND)+CXB*ENSC(3,ND))/FAC
                  SINPHI=REAL(CXC*ENSC(2,ND)+CXD*ENSC(3,ND))/FAC

               ENDIF
               CXS1(ND)=CXI*(CXF21(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                             CXF22(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS2(ND)=-CXI*(CXF11(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                              CXF12(ND)*(CXD*SINPHI+CXC*COSPHI))
               CXS3(ND)=-CXI*(CXF11(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                              CXF12(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS4(ND)=CXI*(CXF21(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                             CXF22(ND)*(CXD*SINPHI+CXC*COSPHI))
            ENDDO

         ELSEIF(JPBC==3)THEN

! JPBC = 3
!     Target is periodic in y and z directions in Lab Frame
!     Allowed scattering directions are identified by scattering
!     order (M,N).  
!     For each allowed (M,N) there is one forward (transmitted) 
!     direction and one backward (reflected) direction.
!     Following convention set in subroutine PBCSCAVEC for JPBC=3, 
!     it is assumed that NSCAT is even, with 
!     the first NSCAT/2 directions corresponding to transmission, and
!     the remaining NSCAT/2 directions corresponding to reflection

! CXA,CXB = y,z components of incident polarization state 1 in Lab Frame
! CXC,CXD = y,z                                           2 in Lab Frame
! ENSC(1-3,ND) = components of scattering unit vector in Lab Frame
! EM1(1-3,ND) = components of scattering polarization 1 in Lab Frame
! EM2(1-3,ND) = components of scattering polarization 2 in Lab Frame

            DO ND=1,NSCAT

               FAC=SQRT(ENSC(2,ND)**2+ENSC(3,ND)**2)

!*** diagnostic
!               write(0,7013)nd,ensc(1,nd),ensc(2,nd),ensc(3,nd),fac
! 7013 format('getmueller checkpoint baker: nd=',i2,/, &
!             'ensc(1-3,nd)=',3f8.5,' fac=',f10.7)
!*** end diagnostic

               IF(FAC<1.E-3_WP)THEN

! either zero-deg forward scattering, or 180 deg backscattering:

                  FAC=SQRT(EM1(2,ND)**2+EM2(2,ND)**2)
                  FAC=FAC*SQRT(REAL(CXA)**2+REAL(CXB)**2)
                  COSPHI=REAL(CXA*EM1(2,ND)+CXB*EM1(3,ND))/FAC
! 080111 (BTD) change
!                  SINPHI=-REAL(CXA*EM2(2,ND)+CXB*EM2(3,ND))/FAC
                  SINPHI=REAL(CXA*EM2(2,ND)+CXB*EM2(3,ND))/FAC

!*** diagnostic
!                  write(0,*)'in getmueller, ckpt ashanti, IBETA=',IBETA
!                  write(0,*)'nd=',nd,' --- zero deg forward scattering ---'
!                  write(0,7700)ensc(1,nd),ensc(2,nd),ensc(3,nd),    &
!                               em1(1,nd),em1(2,nd),em1(3,nd),       &
!                               em2(1,nd),em2(2,nd),em2(3,nd),       &
!                               enscr(1,nd),enscr(2,nd),enscr(3,nd), &
!                               em1r(1,nd),em1r(2,nd),em1r(3,nd),    &
!                               em2r(1,nd),em2r(2,nd),em2r(3,nd)
!                  write(0,7701)cxf11(nd),cxf21(nd),cxf12(nd),cxf22(nd), &
!                               cxa,cxb,cxc,cxd
!                  write(0,7702)cosphi,sinphi
! 7700 format('ensc(1-3,nd) =',3f9.5,' [Lab Frame]',/,     &
!             'em1(1-3,nd)  =',3f9.5,' [Lab Frame]',/,     &
!             'em2(1-3,nd)  =',3f9.5,' [Lab Frame]',/,     &
!             'enscr(1-3,nd)=',3f9.5,' [Target Frame]',/,  &
!             'em1r(1-3,nd) =',3f9.5,' [Target Frame]',/,  &
!             'em2r(1-3,nd) =',3f9.5,' [Target Frame]')
! 7701 format('cxf11(nd)=',2f10.6,/,'cxf21(nd)=',2f10.6,/,   &
!             'cxf12(nd)=',2f10.6,/,'cxf22(nd)=',2f10.6,/,   &
!             'cxa=',2f10.6,/,'cxb=',2f10.6,/,'cxc=',2f10.6,/,'cxd=',2f10.6)
! 7702 format('cosphi=',f10.6,' sinphi=',f10.6)
!*** end diagnostic

               ELSE

! scattering plane is well-defined:

                  COSPHI=REAL(CXA*ENSC(2,ND)+CXB*ENSC(3,ND))/FAC
                  SINPHI=REAL(CXC*ENSC(2,ND)+CXD*ENSC(3,ND))/FAC
!*** diagnostic
!                  write(0,*)'in getmueller, ckpt zulu'
!                  write(0,*)'nd=',nd,' --- not forward scattering ---'
!                  write(0,7700)ensc(1,nd),ensc(2,nd),ensc(3,nd),    &
!                               em1(1,nd),em1(2,nd),em1(3,nd),       &
!                               em2(1,nd),em2(2,nd),em2(3,nd),       &
!                               enscr(1,nd),enscr(2,nd),enscr(3,nd), &
!                               em1r(1,nd),em1r(2,nd),em1r(3,nd),    &
!                               em2r(1,nd),em2r(2,nd),em2r(3,nd)
!                  write(0,7701)cxf11(nd),cxf21(nd),cxf12(nd),cxf22(nd), &
!                               cxa,cxb,cxc,cxd
!                  write(0,7702)cosphi,sinphi
!*** end diagnostic

               ENDIF

               CXS1(ND)=CXI*(CXF21(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                             CXF22(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS2(ND)=-CXI*(CXF11(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                              CXF12(ND)*(CXD*SINPHI+CXC*COSPHI))
               CXS3(ND)=-CXI*(CXF11(ND)*(CXA*SINPHI-CXB*COSPHI)+ &
                              CXF12(ND)*(CXC*SINPHI-CXD*COSPHI))
               CXS4(ND)=CXI*(CXF21(ND)*(CXB*SINPHI+CXA*COSPHI)+ &
                             CXF22(ND)*(CXD*SINPHI+CXC*COSPHI))
            ENDDO

!*** diagnostic
!            if(nd.lt.20)then
!               write(0,*)'ensc(1-3,nd)=',ensc(1,nd),ensc(2,nd),ensc(3,nd)
!               write(0,*)'fac=',fac
!               write(0,*)'sinphi=',sinphi
!               write(0,*)'cosphi=',cosphi
!               write(0,*)'cxf11(nd)=',cxf11(nd)
!               write(0,*)'cxf21(nd)=',cxf21(nd)
!               write(0,*)'cxf12(nd)=',cxf12(nd)
!               write(0,*)'cxf22(nd)=',cxf22(nd)
!               write(0,9700)nd,cxs1(nd),cxs2(nd),cxs3(nd),cxs4(nd)
! 9700          format(i2,' s1,s2,s3,s4=',1p,  &
!                      2e11.3,1x,2e11.3,1x,2e11.3,1x,2e11.3)
!               fac=cxs1(nd)*conjg(cxs1(nd))
!               write(0,*)'|S1|^2=',fac
!               fac=cxs2(nd)*conjg(cxs2(nd))
!               write(0,*)'|S2|^2=',fac
!               fac=cxs3(nd)*conjg(cxs3(nd))
!               write(0,*)'|S3|^2=',fac
!               fac=cxs4(nd)*conjg(cxs4(nd))
!               write(0,*)'|S4|^2=',fac
!            endif
!***
         ENDIF

! if JPBC=1,2,3 (target periodic in y, z, or y and z directions):
! Check for special case: JPBC=3 (2-d target) and forward scattering wit
! ORDERM=ORDERN=0.  For this case we need to add incident wave to
! S_1 and S_2.
! Note that S_1 and S_2 are defined such that for M=N=0 we change
! iS_1 -> iS_1 +1  and iS_2 -> iS_2 +1
!  S_1 ->  S_1 -i       S_2 ->  S_2 -i
! note that CXS1 and CXS2 have yet to be multiplied by factor
! 2*pi/(ak1*aksr(1,nd)*pyddx*pzddx)

         IF(JPBC==3)THEN
!*** diagnostic
!            write(0,9089)ibeta
!            do nd=1,nscat
!               write(0,9090)nd,em1(1,nd),em1(2,nd),em1(3,nd),        &
!                            em2(1,nd),em2(2,nd),em2(3,nd),           &
!                            em1r(1,nd),em1r(2,nd),em1r(3,nd),        &
!                            em2r(1,nd),em2r(2,nd),em2r(3,nd),        &
!                            cxf11(nd),cxf21(nd),cxf12(nd),cxf22(nd), &
!                            cosphi,sinphi,cxs1(nd),cxs2(nd),         &
!                            cxs3(nd),cxs4(nd),cxa,cxb,cxc,cxd
!            enddo
! 9089 format('------------ in getmueller, ibeta=',i3,' ------------------')
! 9090 format(' nd=',i2,/,                            &
!             'em1=',3f10.6,' in lab frame',/,        &
!             'em2=',3f10.6,' in lab frame',/,        &
!             'em1r=',3f10.6,' in TF',/,              &
!             'em2r=',3f10.6,' in TF',/,              &
!             'cxf11=',2F12.8,/,'cxf21=',2F12.8,/,    &
!             'cxf12=',2F12.8,/,'cxf22=',2F12.8,/,    &
!             'cosphi=',f10.6,' sinphi=',f10.6,/,     &
!             'cxs1=',2f12.8,/,'cxs2=',2f12.8,/,      &
!             'cxs3=',2f12.8,/,'cxs4=',2f12.8,/,      &
!             'cxa=',2f13.8,/,'cxb=',2f13.8,/,        &
!             'cxc=',2f13.8,/,'cxd=',2f13.8)
!*** end diagnostic

            DO ND=1,NSCAT/2
               IF(NINT(ORDERM(ND))==0.AND.NINT(ORDERN(ND))==0)THEN
                  FAC=AK1*ABS(AKSR(1,ND))*PYDDX*PZDDX/(2._WP*PI)
                  CXTRM1= FAC*(COSPHI*(CXD*COSPHI-CXC*SINPHI)  &
                               +SINPHI*(-CXB*COSPHI+CXA*SINPHI))
                  CXTRM2= FAC*(COSPHI*(-CXA*COSPHI-CXB*SINPHI) &
                               -SINPHI*(CXC*COSPHI+CXD*SINPHI))

!*** begin diagnostic
!
!                  write(0,9050)nd,cxs1(nd),cxtrm1,(cxs1(nd)+cxtrm1)
!                  write(0,9051)cxs2(nd),cxtrm2,(cxs2(nd)+cxtrm2)
! 9050 format('nd --- radiated cxs --- ',   &
!                 '----- direct ------- ',  &
!                 '------ sum ---------',/, &
!              i2,1x,2f10.6,1x,2f10.6,1x,2f10.6)
! 9051 format(3x,2f10.6,1x,2f10.6,1x,2f10.6)
!*** end diagnostic

                  CXS1(ND)=CXS1(ND)+CXTRM1
                  CXS2(ND)=CXS2(ND)+CXTRM2
               ENDIF
!*** diagnostic
!                  write(0,9091)nd,aksr(1,nd),  &
!                  cxa,cxb,cxc,cxd,cosphi,sinphi,cxs1(nd),cxs2(nd), &
!                  cxs3(nd),cxs4(nd)
!                  nd2=nd+nscat/2
!                  write(0,9091)nd2,aksr(1,nd2),  &
!                  cxa,cxb,cxc,cxd,cosphi,sinphi,cxs1(nd2),cxs2(nd2), &
!                  cxs3(nd2),cxs4(nd2)
! 9091 format('in getmueller: nd=',i2,            &
!             ' aksr(1,nd)=',f8.5,/,                           &
!             'cxa=',2f8.5,/,                                  &
!             'cxb=',2f8.5,/,                                  &
!             'cxc=',2f8.5,/,                                  &
!             'cxd=',2f8.5,/,                                  &
!             'cosphi=',f8.5,' sinphi=',f8.5,/,                &
!             'cxs1=',2f12.8,/,'cxs2=',2f12.8,/,               &
!             'cxs3=',2f12.8,/,'cxs4=',2f12.8)
!*** end diagnostic
            ENDDO
         ENDIF

! Calculation of scattering amplitudes CXS1, CXS2, CXS3, CXS4
! is complete.
! Now compute Mueller matrix elements for this particular target
! orientation:

         DO ND=1,NSCAT
            SM(1,1,ND)=0.5_WP*REAL(CXS1(ND)*CONJG(CXS1(ND))+ &
                                   CXS2(ND)*CONJG(CXS2(ND))+ &
                                   CXS3(ND)*CONJG(CXS3(ND))+ &
                                   CXS4(ND)*CONJG(CXS4(ND)))
            SM(1,2,ND)=0.5_WP*REAL(CXS2(ND)*CONJG(CXS2(ND))- &
                                   CXS1(ND)*CONJG(CXS1(ND))+ &
                                   CXS4(ND)*CONJG(CXS4(ND))- &
                                   CXS3(ND)*CONJG(CXS3(ND)))
            SM(1,3,ND)=REAL(CXS2(ND)*CONJG(CXS3(ND))+CXS1(ND)*CONJG(CXS4(ND)))
            SM(1,4,ND)=AIMAG(CXS2(ND)*CONJG(CXS3(ND))- &
                             CXS1(ND)*CONJG(CXS4(ND)))
            SM(2,1,ND)=0.5_WP*REAL(CXS2(ND)*CONJG(CXS2(ND))- &
                                   CXS1(ND)*CONJG(CXS1(ND))- &
                                   CXS4(ND)*CONJG(CXS4(ND))+ &
                                   CXS3(ND)*CONJG(CXS3(ND)))
            SM(2,2,ND)=0.5_WP*REAL(CXS2(ND)*CONJG(CXS2(ND))+ &
                                   CXS1(ND)*CONJG(CXS1(ND))- &
                                   CXS4(ND)*CONJG(CXS4(ND))- &
                                   CXS3(ND)*CONJG(CXS3(ND)))
            SM(2,3,ND)=REAL(CXS2(ND)*CONJG(CXS3(ND))-CXS1(ND)*CONJG(CXS4(ND)))
            SM(2,4,ND)=AIMAG(CXS2(ND)*CONJG(CXS3(ND))+ &
                             CXS1(ND)*CONJG(CXS4(ND)))
            SM(3,1,ND)=REAL(CXS2(ND)*CONJG(CXS4(ND))+CXS1(ND)*CONJG(CXS3(ND)))
            SM(3,2,ND)=REAL(CXS2(ND)*CONJG(CXS4(ND))-CXS1(ND)*CONJG(CXS3(ND)))
            SM(3,3,ND)=REAL(CXS1(ND)*CONJG(CXS2(ND))+CXS3(ND)*CONJG(CXS4(ND)))
            SM(3,4,ND)=AIMAG(CXS2(ND)*CONJG(CXS1(ND))+ &
                             CXS4(ND)*CONJG(CXS3(ND)))
            SM(4,1,ND)=AIMAG(CXS4(ND)*CONJG(CXS2(ND))+ &
                             CXS1(ND)*CONJG(CXS3(ND)))
            SM(4,2,ND)=AIMAG(CXS4(ND)*CONJG(CXS2(ND))- &
                             CXS1(ND)*CONJG(CXS3(ND)))
            SM(4,3,ND)=AIMAG(CXS1(ND)*CONJG(CXS2(ND))- &
                             CXS3(ND)*CONJG(CXS4(ND)))
            SM(4,4,ND)=REAL(CXS1(ND)*CONJG(CXS2(ND))-CXS3(ND)*CONJG(CXS4(ND)))
         ENDDO

         IF(JPBC>0)THEN

            IF(JPBC==1)THEN

! prepare to calculate S^{(1d)} for target with 1-d periodicity in y

               FAC0=2._WP*PI/(AK1*PYDDX**2)

            ELSEIF(JPBC==2)THEN

! prepare to calculate S^{(1d)} for target with 1-d periodicity in z

               FAC0=2._WP*PI/(AK1*PZDDX**2)

            ELSEIF(JPBC==3)THEN

! Prepare to calculate S^{(2d)} for target with periodicity in y and z

               FAC0=(2._WP*PI/(AK1*PYDDX*PZDDX))**2
            ENDIF

! k*sin(alpha_s)=component of k_s perpendicular to target

            DO ND=1,NSCAT
               IF(JPBC==1)THEN
                  FAC=FAC0/SQRT(AKSR(1,ND)**2+AKSR(3,ND)**2)
               ELSEIF(JPBC==2)THEN
                  FAC=FAC0/SQRT(AKSR(1,ND)**2+AKSR(2,ND)**2)
               ELSEIF(JPBC==3)THEN
                  FAC=FAC0/AKSR(1,ND)**2
               ELSE
                  CALL ERRMSG('FATAL','GETMUELLER',' invalid JPBC')
               ENDIF

               DO K=1,4
                  DO J=1,4
                     SM(J,K,ND)=FAC*SM(J,K,ND)
                  ENDDO
               ENDDO
            ENDDO
         ENDIF

! Augment Mueller matrix for orientational average

         DO ND=1,NSCAT
            DO K=1,4
               DO J=1,4
                  SMORI(J,K,ND)=SMORI(J,K,ND)+WG*SM(J,K,ND)
               ENDDO
            ENDDO
         ENDDO

!***********************************************************************

      ELSE

! When IORTH=1, cannot compute full Mueller matrix.
! Compute three scattering properties:

         DO ND=1,NSCAT
            S1111(ND)=S1111(ND)+WG*REAL(CONJG(CXF11(ND))*CXF11(ND))
            S2121(ND)=S2121(ND)+WG*REAL(CONJG(CXF21(ND))*CXF21(ND))
            CX1121(ND)=CX1121(ND)+WG*REAL(CONJG(CXF11(ND))*CXF21(ND))
         ENDDO
      ENDIF

!**** Now augment sums of QABS,QBKSCA,QEXT,QSCA,G*QSCA over incident
!     directions and polarizations.

      DO JO=1,IORTH
         QEXSUM(JO)=QEXSUM(JO)+QEXT(JO)*WG
         QABSUM(JO)=QABSUM(JO)+QABS(JO)*WG
         QBKSUM(JO)=QBKSUM(JO)+QBKSCA(JO)*WG
         QPHSUM(JO)=QPHSUM(JO)+QPHA(JO)*WG
         QSCSUM(JO)=QSCSUM(JO)+QSCAT(JO)*WG
         QSCG2SUM(JO)=QSCG2SUM(JO)+QSCAG2(JO)*WG
         DO J=1,3
            QSCGSUM(J,JO)=QSCGSUM(J,JO)+QSCAG(J,JO)*WG
         ENDDO
         IF(CMDTRQ=='DOTORQ')THEN
            DO J=1,3
               QTRQABSUM(J,JO)=QTRQABSUM(J,JO)+QTRQAB(J,JO)*WG
               QTRQSCSUM(J,JO)=QTRQSCSUM(J,JO)+QTRQSC(J,JO)*WG
            ENDDO
         ENDIF
      ENDDO
!*** diagnostic
!      write(0,*)'returning from getmueller'
!***
      RETURN
    END SUBROUTINE GETMUELLER

    SUBROUTINE MPI_BCAST_CHAR(CHARVAR,ICOUNT,IROOT,IERR)
      IMPLICIT NONE
!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments
      CHARACTER :: CHARVAR*(*)
     INTEGER :: ICOUNT,IERR,IROOT
!-----------------------------------------------------------------------
! Subroutine MPI_BCAST_CHAR
! Purpose: to serve as a "jacket" for passing character variables to
!          MPI_BCAST so that MPI_BCAST will be called with only a single 
!          variable type in a given fortran routine.
! B.T. Draine, Princeton University Observatory, 2004.04.09
! history
! 04.04.09 (BTD) first written
! 08.01.17 (BTD) f90 version
! end history
! Copyright (C) 2004,2008 B.T.Draine and P.J. Flatau
! This code is covered by the GNU General Public License
!-----------------------------------------------------------------------

      CALL MPI_BCAST(CHARVAR,ICOUNT,MPI_CHARACTER,IROOT,MPI_COMM_WORLD,IERR)
      RETURN
      END

    SUBROUTINE TARCYLCAP(A1,A2,A,B,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Scalar arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: MXNAT,NAT
      REAL(WP) :: A,B

! Array arguments:

      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     & 
         IXYZ(MXNAT,3)
      REAL(WP) :: & 
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local scalars:

      INTEGER :: IOSHP,JX,JXL,JXU,JY,JZ,NB,NFAC,NLAY,NX2,NY1,NY2,NZ1,NZ2
      REAL(WP) :: ASPR,PI,R2,REFF2,X2,XCM,Y2,Y2M,YCM,Z2,ZCM
!***********************************************************************
! Purpose: to construct cylindrical target with hemispherical caps
! from "atoms", with cylinder axis along x axis.
! cylinder diameter is b,
! length of cylinder itself is a
! length of cylinder with caps is (a+b)

! Input:
!        A = cylinder length (in units of lattice spacing d)
!            *NOT* including caps
!        B = cylinder diameter (in units of lattice spacing d)
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT = dimensioning information
! Returns:
!        A1(1-3) = unit vector along cylinder axis
!        A2(1-3) = unit vector perpendicular to cylinder axis
!        CDESCR = string describing target (up to 67 chars.)
!        NAT = number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms in target
!        ICOMP(1-NAT,1-3)=1 (composition identifier)
!        X0(1-3)=location/d) in Target Frame corresponding to dipole with
!                IXYZ=(0,0,0).  This will be treated at the origin of physical
!                coordinates in the TF.
!                Here set to be centroid of capped cylinder

! B.T.Draine, Princeton Univ. Obs., 2006.09.13
! History:
! 06.09.13 (BTD): Created from tarcyl.f
! 06.12.09 (BTD): initialized NAT=0
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.01.13 (BTD): Cosmetic changes
!                 Added X0 to argument list
!                 Added code setting X0 so that centroid will be origin
! 08.06.23 (BTD): Fixed bug discovered by Prescott and Mulvaney
!                 ICOMP was not being initialized for hemispherical caps.
! 08.08.29 (BTD): Modified format 9020
! end history
! Copyright (C) 2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      PI=4._WP*ATAN(1._WP)

! Cylinder axis is along x axis in target frame.

      DO JX=1,3
        A1(JX)=0._WP
        A2(JX)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! A = cylinder length/d
! B = cylinder diameter/d

! Determine centroid XCM,YCM,ZCM

! If A/d_x is near an odd integer, XCM=0
! If A/d_x is near an even integer, XCM=0.5

! If B/d_y is near an odd or even integer, YCM=0 or 0.5
! If B/d_z is near an odd or even integer, ZCM=0 or 0.5

! Determine limits for testing x,y,z values
! In case of disk axis, run from I=1 to I=INT(A+0.5)
! In radial directions, place atoms as follows:
!     If B is close to even number
!          y = j + 0.5
!          with j running from -int((b+.5)/2) to int((b+.5)/2)-1
!     If B is close to odd number
!          x = j
!          with j running from -int((b+.5)/2) to int((b+.5)/2)

      NX2=INT(A/DX(1)+0.5_WP)

      XCM=0.5_WP*REAL(NX2+1,KIND=WP)

      NB=INT(B/DX(2)+0.5_WP)
      IF(2*(NB/2)<NB)THEN
         YCM=0._WP
         NY1=-NB/2
         NY2=NB/2
      ELSE
         YCM=0.5_WP
         NY1=-NB/2+1
         NY2=NB/2
      ENDIF
      NB=INT(B/DX(3)+0.5_WP)
      IF(2*(NB/2)<NB)THEN
         ZCM=0._WP
         NZ1=-NB/2
         NZ2=NB/2
      ELSE
         ZCM=0.5_WP
         NZ1=-NB/2 + 1
         NZ2=NB/2
      ENDIF

      NAT=0
      DO JZ=NZ1,NZ2
         Z2=((JZ-ZCM)*DX(3))**2
         Y2M=((0.5_WP*B)**2-Z2)/DX(2)**2
         DO JY=NY1,NY2
            IF((JY-YCM)**2<Y2M)THEN
               DO JX=1,NX2
                  NAT=NAT + 1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','CYLCAP',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDDO
            ENDIF
         ENDDO
      ENDDO

! NLAY = number of layers in cylinder
! NFAC = number of atoms in slice

      NLAY=NX2
      NFAC=NAT/NLAY

! Now add hemispherical caps
! XCM = 0.5*REAL(NX2+1)
! XU  = XCM+0.5*(A+B)
! JXU = INT(XU)
! JXL = NX2+1-JXU

      R2=(0.5_WP*B)**2
      JXU=INT(0.5_WP*(NX2+1+A+B))
      JXL=NX2 + 1 - JXU
      DO JZ=NZ1,NZ2
         Z2=((JZ-ZCM)*DX(3))**2
         DO JY=NY1,NY2
            Y2=((JY-YCM)*DX(2))**2
            DO JX=JXL,0
               X2=((JX-XCM+0.5_WP*A)*DX(1))**2
               IF(X2+Y2+Z2<R2) THEN
                  NAT=NAT + 1
                  IF(NAT>MXNAT) THEN
                     CALL ERRMSG('FATAL','CYLCAP',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
            DO JX=NX2+1,JXU
               X2=((JX-XCM-0.5_WP*A)*DX(1))**2
               IF(X2+Y2+Z2<R2)THEN
                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','CYLCAP',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
         ENDDO
      ENDDO

! Set composition

      DO JZ=1,3
         DO JX=1,NAT
            ICOMP(JX,JZ)=1
         ENDDO
      ENDDO

! Set X0 so that origin is at centroid

      DO JY=1,3
         X0(JY)=0.
         DO JX=1,NAT
            X0(JY)=X0(JY)+IXYZ(JX,JY)
         ENDDO
         X0(JY)=-X0(JY)/REAL(NAT)
      ENDDO

! REFF2=effective radius**2 of disk

      REFF2=REAL(NFAC,KIND=WP)/PI

! ASPR=aspect ratio (length/diameter)

      ASPR=0.5_WP*REAL(NLAY,KIND=WP)/SQRT(REFF2)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')' Cyl.prism, NAT=',NAT, &
            ' NFAC=',NFAC,' NLAY=',NLAY,' asp.ratio=',ASPR

      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A,B,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARCYLCAP  cylinder with end-caps: Length=',       &
             F8.4,' Diameter=',F8.4,/,                             &
         I10,' = NAT',/,                                           &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARCYLCAP

! ----------------------------------------------------------------------
! Numerical diagonalization of 3x3 matrcies
! Copyright (C) 2006  Joachim Kopp
! ----------------------------------------------------------------------
! This library is free software; you can redistribute it and/or
! modify it under the terms of the GNU Lesser General Public
! License as published by the Free Software Foundation; either
! version 2.1 of the License, or (at your option) any later version.

! This library is distributed in the hope that it will be useful,
! but WITHOUT ANY WARRANTY; without even the implied warranty of
! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
! Lesser General Public License for more details.

! You should have received a copy of the GNU Lesser General Public
! License along with this library; if not, write to the Free Software
! Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-13
! ----------------------------------------------------------------------


! ----------------------------------------------------------------------
    SUBROUTINE DSYEVJ3(A,Q,W)
      USE DDPRECISION, ONLY : WP
! ----------------------------------------------------------------------
! Calculates the eigenvalues and normalized eigenvectors of a symmetric
! matrix A using the Jacobi algorithm.
! The upper triangular part of A is destroyed during the calculation,
! the diagonal elements are read but not destroyed, and the lower
! triangular elements are not referenced at all.
! ----------------------------------------------------------------------
! Parameters:
!   A: The symmetric input matrix
!   Q: Storage buffer for eigenvectors
!   W: Storage buffer for eigenvalues
! ----------------------------------------------------------------------
!     .. Arguments ..
      REAL(WP) :: a(3,3)
      REAL(WP) :: q(3,3)
      REAL(WP) :: w(3)

!     .. Parameters ..
      INTEGER :: n
      PARAMETER (n=3)

!     .. Local Variables ..
      REAL(WP) :: sd, so
      REAL(WP) :: s, c, t
      REAL(WP) :: g, h, z, theta
      REAL(WP) :: thresh
      INTEGER :: i, x, y, r

!     Initialize Q to the identitity matrix
!     --- This loop can be omitted if only the eigenvalues are desired -
      DO 10 x = 1, n
        q(x,x) = 1.0E0_wp
        DO 11 y = 1, x - 1
          q(x,y) = 0.0E0_wp
          q(y,x) = 0.0E0_wp
11      CONTINUE
10    CONTINUE

!     Initialize W to diag(A)
      DO 20 x = 1, n
        w(x) = a(x,x)
20    CONTINUE

!     Calculate SQR(tr(A))
      sd = 0.0E0_wp
      DO 30 x = 1, n
        sd = sd + abs(w(x))
30    CONTINUE
      sd = sd**2

!     Main iteration loop
      DO 40 i = 1, 50
!       Test for convergence
        so = 0.0E0_wp
        DO 50 x = 1, n
          DO 51 y = x + 1, n
            so = so + abs(a(x,y))
51        CONTINUE
50      CONTINUE
        IF (so==0.0E0_wp) THEN
!*** diagnostic
           write(0,*)'>DSYEVJ3: converged.'
!***
          RETURN
        END IF

        IF (i<4) THEN
          thresh = 0.2E0_wp*so/n**2
        ELSE
          thresh = 0.0E0_wp
        END IF

!       Do sweep
        DO 60 x = 1, n
          DO 61 y = x + 1, n
            g = 100.0E0_wp*(abs(a(x,y)))
            IF (i>4 .AND. abs(w(x))+g==abs(w(x)) .AND. abs(w(y))+g==abs(w(y))) &
                THEN
              a(x,y) = 0.0E0_wp
            ELSE IF (abs(a(x,y))>thresh) THEN
!             Calculate Jacobi transformation
              h = w(y) - w(x)
              IF (abs(h)+g==abs(h)) THEN
                t = a(x,y)/h
              ELSE
                theta = 0.5E0_wp*h/a(x,y)
                IF (theta<0.0E0_wp) THEN
                  t = -1.0E0_wp/(sqrt(1.0E0_wp+theta**2)-theta)
                ELSE
                  t = 1.0E0_wp/(sqrt(1.0E0_wp+theta**2)+theta)
                END IF
              END IF

              c = 1.0E0_wp/sqrt(1.0E0_wp+t**2)
              s = t*c
              z = t*a(x,y)

!             Apply Jacobi transformation
              a(x,y) = 0.0E0_wp
              w(x) = w(x) - z
              w(y) = w(y) + z
              DO 70 r = 1, x - 1
                t = a(r,x)
                a(r,x) = c*t - s*a(r,y)
                a(r,y) = s*t + c*a(r,y)
70            CONTINUE
              DO 80 r = x + 1, y - 1
                t = a(x,r)
                a(x,r) = c*t - s*a(r,y)
                a(r,y) = s*t + c*a(r,y)
80            CONTINUE
              DO 90 r = y + 1, n
                t = a(x,r)
                a(x,r) = c*t - s*a(y,r)
                a(y,r) = s*t + c*a(y,r)
90            CONTINUE

!             Update eigenvectors
!             --- This loop can be omitted if only the eigenvalues are desired
              DO 100 r = 1, n
                t = q(r,x)
                q(r,x) = c*t - s*q(r,y)
                q(r,y) = s*t + c*q(r,y)
100           CONTINUE
            END IF
61        CONTINUE
60      CONTINUE
40    CONTINUE

      WRITE(0,*)'>DSYEVJ3: No convergence.'
      RETURN

    END SUBROUTINE dsyevj3

!=======================================================================
! Module mpi_subs.f
! This module contains three main subroutines 
!    SUBROUTINE COLSUM
!    SUBROUTINE SHARE0
!    SUBROUTINE SHARE1
!    SUBROUTINE SHARE2
! and auxiliary routines
!    SUBROUTINE MPI_BCAST_CHAR
!    SUBROUTINE MPI_BCAST_INT
!    SUBROUTINE MPI_BCAST_INT2
!    SUBROUTINE MPI_BCAST_REAL
!    SUBROUTINE MPI_BCAST_CPLX

! COLSUM, SHARE1, and SHARE2 are used by DDSCAT to manage information 
! in all the various processes when MPI is being used. 

! MPI_BCAST_CHAR, MPI_BCAST_INT, MPI_BCAST_INT2, MPI_BCAST_REAL, and
! MPI_BCAST_CPLX are used here to provide "jackets" for MPI_BCAST for
! different variable types, to eliminate warning messages from fortran
! compilers.
!
! COLSUM, SHARE1, and SHARE2
! were originally written by Matthew Collinge,
! Princeton University Observatory, 2002.11.15

! Code has been modified to provide "jackets" for MPI_BCAST for
! different variable types, to eliminate warning messages from fortran
! compilers.

! history: 
! 02.11.15 (BTD) Working version developed by Matthew Collinge
! 03.07.13 (BTD) cosmetic changes during preparation of official
!                release of version 6.0
! 04.04.09 (BTD) modifications to introduce jacket routines
!                MPI_BCAST_CHAR 
!                MPI_BCAST_INT
!                MPI_BCAST_INT2
!                MPI_BCAST_REAL
!                MPI_BCAST_CPLX
! 08.05.01 (BTD) added MYID to arg list of SHARE0
! 08.05.09 (BTD) added LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0 to arg list of SHARE0
! end history
!
! Copyright (C) 2002,2003,2004,2007,2008 B.T. Draine and M. Collinge
!
! This code is covered by the GNU General Public License
!=======================================================================

    SUBROUTINE COLSUM(IORTH,MYID,MXSCA,NSCAT,QSCSUM,QSCSUM_1,QABSUM,     &
                      QABSUM_1,QEXSUM,QEXSUM_1,QBKSUM,QBKSUM_1,QPHSUM,   &
                      QPHSUM_1,QSCG2SUM,QSCG2SUM_1,QSCGSUM,QSCGSUM_1,    &
                      QTRQABSUM,QTRQABSUM_1,QTRQSCSUM,QTRQSCSUM_1,S1111, &
                      S1111_1,S2121,S2121_1,CX1121,CX1121_1,SMORI,SMORI_1)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------

! arguments:

      INTEGER :: IORTH,MXSCA,NSCAT,MYID
      REAL(WP) ::              &
         QABSUM(IORTH),        &
         QABSUM_1(IORTH),      &
         QBKSUM(IORTH),        &
         QBKSUM_1(IORTH),      &
         QEXSUM(IORTH),        &
         QEXSUM_1(IORTH),      &
         QPHSUM(IORTH),        &
         QPHSUM_1(IORTH),      &
         QSCG2SUM(IORTH),      &
         QSCG2SUM_1(IORTH),    &
         QSCGSUM(3,IORTH),     &
         QSCGSUM_1(3,IORTH),   &
         QSCSUM(IORTH),        &
         QSCSUM_1(IORTH),      &
         QTRQABSUM(3,IORTH),   &
         QTRQABSUM_1(3,IORTH), &
         QTRQSCSUM(3,IORTH),   &
         QTRQSCSUM_1(3,IORTH), &
         S1111(MXSCA),         &
         S1111_1(MXSCA),       &
         S2121(MXSCA),         &
         S2121_1(MXSCA),       &
         SMORI(4,4,MXSCA),     &
         SMORI_1(4,4,MXSCA)
      COMPLEX(WP) ::    &
         CX1121(MXSCA), &
         CX1121_1(MXSCA)

! local variables:

      LOGICAL :: SINGLE
      INTEGER :: IERR,NDAT

!=======================================================================
! Subroutine COLSUM
! Given:
!    IORTH                   = 1 for single incident polarization
!                              2 for both incident polarizations
!    MYID                    = process rank
!    MXSCA                   = max number of scattering directions
!    NSCAT                   = actual number of scattering directions
!    QSCSUM_1(1-IORTH)       = sum of Q_sca for orientations done by MYID
!    QABSUM_1(1-IORTH)       = sum of Q_abs "
!    QEXSUM_1(1-IORTH)       = sum of Q_ext "
!    QBKSUM_1(1-IORTH)       = sum of Q_bk  "
!    QPHSUM_1(1-IORTH)       = sum of Q_ph  "
!    QSCGSUM_1(1-3,1-IORTH)  = sum of Q_sca*<cos> for orientation done by MYID
!    QSCG2SUM_1(1-IORTH)     = sum of Q_sca*<cos^2> "
!    QTRQABSUM_1(1-3,1-IORTH)= sum of Q_trq,abs for orientations done by MYID
!    QTRQSCSUM_1(1-3,1-IORTH)= sum of Q_trq,sca "
!    S1111_1(1-NSCAT)        = sum of S1111 for orientations done by MYID
!    S2121_1(1-NSCAT)        = sum of S2121 for orientations done by MYID
!    SMORI_1(1-NSCAT,1-4,1-4)= sum of Mueller matrix for orientations done
!                              by MYID 
!    QSCSUM(1-IORTH)         = running sum of Q_sca
!    QABSUM(1-IORTH)         = running sum of Q_abs
!    QEXSUM(1-IORTH)         = running sum of Q_ext
!    QBKSUM(1-IORTH)         = running sum of Q_bk
!    QPHSUM(1-IORTH)         = running sum of Q_ph
!    QSCGSUM(1-3,1-IORTH)    = running sum of Q_sca*<cos>
!    QSCG2SUM(1-IORTH)       = running sum of Q_sca*<cos^2>
!    QTRQABSUM(1-3,1-IORTH)  = running sum of Q_trq,abs
!    QTRQSCSUM(1-3,1-IORTH)  = running sum of Q_trq,sca
!    S1111(1-NSCAT)          = running sum of S1111
!    S2121(1-NSCAT)          = running sum of S2121
!    SMORI(1-NSCAT,1-4,1-4)  = running sum of Mueller matrix for orientations
!                              done by MYID

! Returns
!    QSCSUM(1-IORTH)         = updated Q_sca sum over orientations
!    QABSUM(1-IORTH)         = updated Q_abs sum over orientations
!    QEXSUM(1-IORTH)         = updated Q_ext sum over orientations
!    QBKSUM(1-IORTH)         = updated Q_bk sum over orientations
!    QPHSUM(1-IORTH)         = updated Q_pha sum over orientations
!    QSCGSUM(1-3,1-IORTH)    = updated Q_sca*<cos> sum over orientations
!    QSCG2SUM(1-IORTH)       = updated Q_sca*<cos^2> sum over orientations
!    QTRQABSUM(1-3,1-IORTH)  = updated Q_trq,abs sum over orientations
!    QTRQSCSUM(1-3,1-IORTH)  = updated Q_trq,sca sum over orientations
!    S1111(1-NSCAT)          = updated S1111 sum over orientations
!    S2121(1-NSCAT)          = updated S2121 sum over orientations
!    SMORI(1-NSCAT,1-4,1-4)  = updated Mueller matrix sum over orientations
!
! Originally written by Matthew Collinge
! history
! 03.10.23 (BTD) Added variable QSCG2SUM(1-IORTH)
! 08.05.10 (BTD) ver7.0.5
!                * major revision: add to argument list
!                   CX1121_1
!                   QABSUM_1
!                   QBKSUM_1
!                   QEXTSUM_1
!                   QPHSUM_1
!                   QSCAGSUM_1
!                   QSCG2SUM_1
!                   QSCASUM_1
!                   QTRQABSUM_1
!                   QTRQSCSUM_1
!                   S1111_1
!                   S2121_1
!                   SMORI_1
! 08.05.11 (BTD) rewrite to transfer NDAT values per call to MPI_REDUCE
!                where NDAT=IORTH or IORTH*3 or NSCAT or 4*4*NSCAT
! 08.05.29 (BTD) v7.0.6
!                * change declarations
!                  SMORI(MXSCA,4,4) -> SMORI(4,4,MXSCA)
!                  in order to accomplish update of SMORI using SMORI_1
!                  with a single call to MPI_REDUCE
! end history
!=======================================================================
!*** diagnostic
!      write(0,*)'COLSUM ckpt 1, myid=',myid
!***
      IF(WP==KIND(0.E0))THEN
         SINGLE=.TRUE.
      ELSEIF(WP==KIND(0.D0))THEN
         SINGLE=.FALSE.
      ELSE
         WRITE(0,*)'fatal error in mpi_subs: unable to determine precision'
         STOP
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 2, myid=',myid
!***
!*** diagnostic
!      write(0,*)'COLSUM ckpt 3, myid=',myid
      IF(SINGLE)THEN
!*** diagnostic
!         write(0,*)'COLSUM ckpt 4, myid=',myid
!***
         CALL MPI_REDUCE(QSCSUM_1(1),QSCSUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
!*** diagnostic
!         write(0,*)'COLSUM ckpt 5, myid=',myid
!***
         CALL MPI_REDUCE(QSCSUM_1(1),QSCSUM(1),IORTH,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
!*** diagnostic
!         write(0,*)'COLSUM ckpt 5.1, myid=',myid
!***
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 6, myid=',myid
!***
      IF(SINGLE)THEN
!*** diagnostic
!      write(0,*)'COLSUM ckpt 7, myid=',myid
!***
         CALL MPI_REDUCE(QABSUM_1(1),QABSUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
!*** diagnostic
!      write(0,*)'COLSUM ckpt 8, myid=',myid
!***
         CALL MPI_REDUCE(QABSUM_1(1),QABSUM(1),IORTH,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 9, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QEXSUM_1(1),QEXSUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QEXSUM_1(1),QEXSUM(1),IORTH,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 10, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QBKSUM_1(1),QBKSUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QBKSUM_1(1),QBKSUM(1),IORTH,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 11, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QPHSUM_1(1),QPHSUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QPHSUM_1(1),QPHSUM(1),IORTH,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 12, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QSCG2SUM_1(1),QSCG2SUM(1),IORTH, &
                         MPI_REAL,MPI_SUM,0,              &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QSCG2SUM_1(1),QSCG2SUM(1),IORTH, &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0,  &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 13, myid=',myid
!***
      NDAT=3*IORTH
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QSCGSUM_1(1,1),QSCGSUM(1,1),NDAT, &
                         MPI_REAL,MPI_SUM,0,               &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QSCGSUM_1(1,1),QSCGSUM(1,1),NDAT, &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0,   &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!         write(0,*)'COLSUM ckpt 15, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QTRQABSUM_1(1,1),QTRQABSUM(1,1),NDAT, &
                         MPI_REAL,MPI_SUM,0,                   &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QTRQABSUM_1(1,1),QTRQABSUM(1,1),NDAT, &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0,       &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 16, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(QTRQSCSUM_1(1,1),QTRQSCSUM(1,1),NDAT, &
                         MPI_REAL,MPI_SUM,0,                   &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(QTRQSCSUM_1(1,1),QTRQSCSUM(1,1),NDAT, &
                        MPI_DOUBLE_PRECISION,MPI_SUM,0,       &
                        MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 17, myid=',myid
!***
      IF(SINGLE)THEN
         CALL MPI_REDUCE(S1111_1(1),S1111(1),NSCAT, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(S1111_1(1),S1111(1),NSCAT,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
      IF(SINGLE)THEN
         CALL MPI_REDUCE(S2121_1(1),S2121(1),NSCAT, &
                         MPI_REAL,MPI_SUM,0,          &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(S2121_1(1),S2121(1),NSCAT,    &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0, &
                         MPI_COMM_WORLD,IERR)
      ENDIF
      IF(SINGLE)THEN
         CALL MPI_REDUCE(CX1121_1(1),CX1121(1),NSCAT, &
                         MPI_COMPLEX,MPI_SUM,0,         &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(CX1121_1(1),CX1121(1),NSCAT, &
                         MPI_DOUBLE_COMPLEX,MPI_SUM,0,  &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!   write(0,*)'COLSUM ckpt 19, myid=',myid
!***
      NDAT=4*4*NSCAT

      IF(SINGLE)THEN
         CALL MPI_REDUCE(SMORI_1(1,1,1),SMORI(1,1,1),NDAT, &
                         MPI_REAL,MPI_SUM,0,               &
                         MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_REDUCE(SMORI_1(1,1,1),SMORI(1,1,1),NDAT, &
                         MPI_DOUBLE_PRECISION,MPI_SUM,0,   &
                         MPI_COMM_WORLD,IERR)
      ENDIF
!*** diagnostic
!      write(0,*)'COLSUM ckpt 99, myid=',myid
!***
      RETURN
    END SUBROUTINE COLSUM

!=============================================================================

    SUBROUTINE SHARE0(LACE,LAXI,LCLM,LGI,LPI,LQI,                     &
                      MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,MXCXSC,MYID,NAT0)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments

      INTEGER :: LACE,LAXI,LCLM,LGI,LPI,LQI,                    &
                 MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,MXCXSC,MYID,NAT0

! local variables:

      INTEGER :: IERR

! History:
! 08.05.01 (BTD) v7.0.5 
!                * added MYID to argument list of SHARE0
! end history

      CALL MPI_BCAST_INT(LACE,1,0,IERR)
      CALL MPI_BCAST_INT(LAXI,1,0,IERR)
      CALL MPI_BCAST_INT(LCLM,1,0,IERR)
      CALL MPI_BCAST_INT(LGI,1,0,IERR)
      CALL MPI_BCAST_INT(LPI,1,0,IERR)
      CALL MPI_BCAST_INT(LQI,1,0,IERR)

!*** diagnostic
!      write(0,*)'share0 ckpt 1, myid=',myid,' mxn3=',mxn3
!***
      CALL MPI_BCAST_INT(MXN3,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 2, myid=',myid,' mxn3=',mxn3,' mxnat=',mxnat
!***
      CALL MPI_BCAST_INT(MXNAT,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 3, myid=',myid,' mxnat=',mxnat,' mxnx=',mxnx
!***
      CALL MPI_BCAST_INT(MXNX,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 4, myid=',myid,' mxnx=',mxnx,' mxny=',mxny
!***
      CALL MPI_BCAST_INT(MXNY,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 5, myid=',myid,' mxny=',mxny,' mxnz=',mxnz
!***
      CALL MPI_BCAST_INT(MXNZ,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 6, myid=',myid,' mxnz=',mxnz,' mxpbc=',mxpbc
!***
      CALL MPI_BCAST_INT(MXPBC,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 7, myid=',myid,' mxpbc=',mxpbc,' mxcxsc=',mxcxsc
!***
      CALL MPI_BCAST_INT(MXCXSC,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 8, myid=',myid,' mxcxsc=',mxcxsc,' nat0=',nat0
!***
      CALL MPI_BCAST_INT(NAT0,1,0,IERR)
!*** diagnostic
!      write(0,*)'share0 ckpt 9, myid=',myid,' nat0=',nat0,' return...'
!***
      RETURN

    END SUBROUTINE SHARE0

!=============================================================================

    SUBROUTINE SHARE1(A1,A2,A3,AEFFA,BETA,BETADF,BETMID,BETMXD,CALPHA,       &
                      CBINFLAG,CDESCR,CFLEPS,CMDFFT,CMDFRM,CMDSOL,CMDTRQ,    &
                      CSHAPE,CXE01,CXE02,DAEFF,DX,ENSC,EM1,EM2,ETASCA,GAMMA, &
                      IANISO,ICOMP,IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,   &
                      IOCC,IORI0,IORTH,IPBC,IRAD0,IWAV0,IWRKSC,IWRPOL,IXYZ0, &
                      JPBC,MXBETA,MXCOMP,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,    &
                      MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,MYID,NAT,NAT0,NAT3,     &
                      NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA, &
                      NWAV,NX,NY,NZ,ORDERM,ORDERN,PHI,PHIDF,PHIMID,PHIMXD,   &
                      PHIN,PYD,PYDDX,PZD,PZDDX,SHPAR,SMIND1,SMIND2,THETA,    &
                      THETADF,THETAN,THTMID,THTMXD,TOL,WAVEA,WGTA,WGTB,X0,   &
                      XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments
! dimensioning information:

      INTEGER :: MXNAT,MXN3,MXBETA,MXCOMP,MXNX,MXNY,MXNZ,MXPBC, &
                 MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,MYID

      CHARACTER :: CBINFLAG*(*),CALPHA*6,CDESCR*67,CMDFFT*6, &
                   CMDFRM*6,CMDSOL*6,CSHAPE*9,CMDTRQ*6

      CHARACTER*60 :: CFLEPS(MXCOMP)

      INTEGER :: IANISO,IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,        &
                 IORTH,IORI0,IPBC,IRAD0,IWAV0,IWRKSC,IWRPOL,JPBC,      &
                 NAT,NAT0,NAT3,NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT, &
                 NSMELTS,NTHETA,NWAV,NX,NY,NZ

      INTEGER*2 ::    &
         ICOMP(MXN3), &
         IOCC(MXNAT)

      INTEGER ::        &
         IXYZ0(NAT0,3), &
         SMIND1(9),     &
         SMIND2(9)

      REAL(WP) :: BETMID,BETMXD,DAEFF,ETASCA,GAMMA,PHIMID,PHIMXD,PYD,PYDDX, &
                  PZD,PZDDX,THTMID,THTMXD,TOL,XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN

      REAL(WP) ::            &
         A1(3),              &
         A2(3),              &
         A3(3),              &
         AEFFA(MXRAD),       &
         BETA(MXBETA),       &
         BETADF(NAT0),       &
         DX(3),              &
         EM1(3,MXSCA),       &
         EM2(3,MXSCA),       &
         ENSC(3,MXSCA),      &
         ORDERM(MXSCA),      &
         ORDERN(MXSCA),      &
         PHI(MXPHI),         &
         PHIDF(NAT0),        &
         PHIN(MXSCA),        &
         SHPAR(12),          &
         THETA(MXTHET),      &
         THETADF(NAT0),      &
         THETAN(MXSCA),      &
         WAVEA(MXWAV),       &
         WGTA(MXTHET,MXPHI), &
         WGTB(MXBETA),       &
         X0(3)

      COMPLEX(WP) :: &
         CXE01(3),   &
         CXE02(3)

! local variables:
      LOGICAL :: SINGLE
      INTEGER :: IERR
!=======================================================================
! Subroutine SHARE1
! Given:

! Returns:


! This routine uses the MPI data type MPI_INTEGER2, which may 
! not be supported in all implementations of MPI.

! The format of the call to MPI_BCAST is as follows:
!
!     CALL MPI_BCAST(SENDPAR,NUMPAR,MPI_TYPEPAR,SOURCE_PROCESS,
!    &     MPI_COMM_WORLD,IERR)
!
! SENDPAR        = information to communicate with other processes
! NUMPAR         = number of units of information in SENDPAR
! MPI_TYPEPAR    = MPI data type of SENDPAR
! SOURCE_PROCESS = identifier of the process sending the broadcast.
!                  Always 0 (master) in this code.
! MPI_COMM_WORLD = name of MPI communicator
! IERR           = Error code. Not used by this code.
!
! collinge:
! what are the sizes of cbinflag and cnetflag?
! apparently 6, or maaaaybe 7 in fortran convention?
! I am not sure if this means of sending characters actually 
! works or not. Needs to be tested.
!
! Originally written by Matthew Collinge,
! Princeton University Observatory, 2002.11.15

! history: 
! 02.11.15 (BTD) Working version developed by Matthew Collinge
! 03.07.13 (BTD) cosmetic changes during preparation of official
!                release of version 6.0
! 03.10.23 (BTD) removed ICTHM and IPHIM from argument list: no longer
!                used.
!                removed ICTHM and IPHIM from calls to SHARE1
!                removed MPI_BCAST calls for ICTHM and IPHIM
! 03.10.24 (BTD) added ETASCA to argument list
!                added MPI_BCAST call for ETASCA
! 04.09.14 (BTD) added BETADF,PHIDF,THETADF to argument list
!                add MPI_BCAST calls for BETADF,PHIDF,THETADF
! 05.08.04 (BTD) added CMDFRM to argument list
!                added MPI_BCAST_CHAR call for CMDFRM
! 07.01.18 (BTD) added A3(3),IWRPOL,IPBC,JPBC,MXNX,MXNY,MXNZ,MXPBC,
!                ORDERM(MXSCA),ORDERN(MXSCA),
!                PYD,PYDDX,PZD,PZDDX 
!                to argument list of SHARE1, with appropriate
!                MPI_BCAST... calls below
! 07.06.21 (BTD) add X0 to argument list of SHARE1
!                add call to MPI_BCAST_REAL
! 08.01.21 (BTD) add IANISO to argument list of SHARE1
!                add call to MPI_BCAST_INT
!                changed MPI_BCAST_REAL call to share SHPAR(12)
! 08.02.04 (BTD) corrected typos found by Y.Shen
!                add declaration of IXYZ0
! 08.02.10 (BTD) corrected declaration of SHPAR(6)->SHPAR(12) 
! 08.02.12 (BTD) changed CSHAPE*6 to CSHAPE*9, and changed
!                   CALL MPI_BCAST_CHAR(CSHAPE,6,0,IERR)
!                to CALL MPI_BCAST_CHAR(CSHAPE,9,0,IERR)
!                removed CDIEL from argument list
!                removed CALL MPI_BCAST_CHAR(CDIEL,6,0,IERR)
! 08.02.13 (BTD) added MXNAT0 to argument list
!                added CALL_MPI_BCAST_INT calls for
!                * MXBETA
!                * MXNAT
!                * MXNAT0
!                * MXPHI
!                * MXSCA
!                * MXTHET
!                * MXWAV
!                changed dimensioning of IOCC,IXYZ0,BETADF,THETADF,PHIDF from
!                MXNAT to MXNAT0
! 08.02.14 (BTD) * corrected error in dimension of IOCC:
!                  was MXN3, changed to MXNAT
!                also corrected call to MPI_BCAST_INT2
! 08.02.14 (BTD) * changed allocation of IOCC to IOCC(MXNAT) [not MXNAT0]
!                * changed allocation from IXYZ0(MXNAT,3) to IXYZ0(NAT0,3)
!                * changed allocation from BETADF(MXNAT) to BETADF(NAT0)
!                * changed allocation from PHIDF(MXNAT) to PHIDF(NAT0)
!                * changed allocation from THETADF(MXNAT) to THETADF(NAT0)
! 08.02.15 (BTD) * deleted CALL MPI_BCAST_INT(MXNAT0,1,0,IERR)
!                * changed CALL MPI_BCAST_INT(IXYZ0,3*MXNAT0,0,IERR)
!                  to CALL MPI_BCAST_INT(IXYZ0,3*NAT0,0,IERR)
! 08.02.17 (BTD) * add DAEFF to argument list
!                * add CALL_MPI_BCAST_REAL(DAEFF)
! 08.03.11 (BTD) ver7.0.5
!                * add ALPHA to argument list
!                * add CALL_MPI_BCAST_REAL(ALPHA)
! 08.04.19 (BTD) * changed notation: ALPHA -> GAMMA
!                  reordered argument list
! 08.05.01 (BTD) * added MYID to argument list
! 08.07.22 (BTD) * added XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN to argument list
! end history
! Copyright (C) 2002,2003,2004,2005,2007,2008 
!               B.T. Draine, M. Collinge, and P.J. Flatau
!
! This code is covered by the GNU General Public License
!=======================================================================

! character variables:
!*** diagnostic
!      write(0,*)'share1 ckpt 1, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CALPHA,6,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 2, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CBINFLAG,6,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 3, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CDESCR,67,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 4, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CFLEPS,60*MXCOMP,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 5, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CMDFFT,6,0,IERR)
      CALL MPI_BCAST_CHAR(CMDFRM,6,0,IERR)
      CALL MPI_BCAST_CHAR(CMDSOL,6,0,IERR)
      CALL MPI_BCAST_CHAR(CMDTRQ,6,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 10, myid=',myid
!***
      CALL MPI_BCAST_CHAR(CSHAPE,9,0,IERR)


! integer scalars:

      CALL MPI_BCAST_INT(IANISO,1,0,IERR)
      CALL MPI_BCAST_INT(IDVERR,1,0,IERR)
      CALL MPI_BCAST_INT(IDVOUT,1,0,IERR)
      CALL MPI_BCAST_INT(ILIN10,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 15, myid=',myid
!***
      CALL MPI_BCAST_INT(ILIN12,1,0,IERR)
      CALL MPI_BCAST_INT(INIT,1,0,IERR)
      CALL MPI_BCAST_INT(IOBIN,1,0,IERR)
      CALL MPI_BCAST_INT(IORTH,1,0,IERR)
      CALL MPI_BCAST_INT(IORI0,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 20, myid=',myid
!***
      CALL MPI_BCAST_INT(IPBC,1,0,IERR)
      CALL MPI_BCAST_INT(IRAD0,1,0,IERR)
      CALL MPI_BCAST_INT(IWAV0,1,0,IERR)
      CALL MPI_BCAST_INT(IWRKSC,1,0,IERR)
      CALL MPI_BCAST_INT(IWRPOL,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 25, myid=',myid
!***
      CALL MPI_BCAST_INT(JPBC,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 26, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXBETA,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 27, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXNAT,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 28, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXNX,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 29, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXNY,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 30, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXNZ,1,0,IERR)
      CALL MPI_BCAST_INT(MXPBC,1,0,IERR)
      CALL MPI_BCAST_INT(MXPHI,1,0,IERR)
      CALL MPI_BCAST_INT(MXSCA,1,0,IERR)
      CALL MPI_BCAST_INT(MXTHET,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 35, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(MXWAV,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 36, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NAT,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 37, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NAT0,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 38, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NAT3,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 39, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NBETA,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 40, myid=',myid
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NBETH,1,0,IERR)
      CALL MPI_BCAST_INT(NCOMP,1,0,IERR)
      CALL MPI_BCAST_INT(NORI,1,0,IERR)
      CALL MPI_BCAST_INT(NPHI,1,0,IERR)
      CALL MPI_BCAST_INT(NRAD,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 45, myid=',myid
!***
      CALL MPI_BCAST_INT(NSCAT,1,0,IERR)
      CALL MPI_BCAST_INT(NSMELTS,1,0,IERR)
      CALL MPI_BCAST_INT(NTHETA,1,0,IERR)
      CALL MPI_BCAST_INT(NWAV,1,0,IERR)
      CALL MPI_BCAST_INT(NX,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 50, myid=',myid
!***
      CALL MPI_BCAST_INT(NY,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 51, myid=',myid,' nz=',nz
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT(NZ,1,0,IERR)

! integer*2 arrays:
!*** diagnostic
!      write(0,*)'share1 ckpt 52, myid=',myid
!      write(0,*)'%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%'
!      write(0,*)'about to call mpi_bcast_int2(icomp,...) with mxn3=',mxn3
      call mpi_barrier(mpi_comm_world,ierr)
!***
      CALL MPI_BCAST_INT2(ICOMP,MXN3,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 53, myid=',myid
!      write(0,*)'about to call mpi_bcast_int2(iocc,...) with mxnat=',mxnat
!***
      CALL MPI_BCAST_INT2(IOCC,MXNAT,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 54, myid=',myid
!      write(0,*)'returned from mpi_bcast_int2'
!***
! integer arrays:

      CALL MPI_BCAST_INT(IXYZ0,3*NAT0,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 55, myid=',myid
!***
      CALL MPI_BCAST_INT(SMIND1,NSMELTS,0,IERR)
      CALL MPI_BCAST_INT(SMIND2,NSMELTS,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 57, myid=',myid
!***

! determine precision

      IF(WP==KIND(0.E0))THEN
         SINGLE=.TRUE.
      ELSEIF(WP==KIND(0.D0))THEN
         SINGLE=.FALSE.
      ELSE
         WRITE(0,*)'fatal error in mpi_subs: unable to determine precision'
         STOP
      ENDIF

! Real scalars:

!*** diagnostic
!      write(0,*)'share1 ckpt 58, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,BETMID,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,BETMXD,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 60, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,DAEFF,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ETASCA,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,GAMMA,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PHIMID,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PHIMXD,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 65, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,PYD,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PYDDX,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PZD,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PZDDX,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,THTMID,1,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 70, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,THTMXD,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,TOL,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,XMAX,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,XMIN,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,YMAX,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,YMIN,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ZMAX,1,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ZMIN,1,0,IERR)

! Real arrays:

      CALL MPI_BCAST_REAL(SINGLE,A1,3,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,A2,3,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,A3,3,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 75, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,AEFFA,MXRAD,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,BETA,MXBETA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,BETADF,NAT0,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,DX,3,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,EM1,3*MXSCA,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 80, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,EM2,3*MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ENSC,3*MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ORDERM,MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,ORDERN,MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PHI,MXPHI,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 85, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,PHIDF,NAT0,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,PHIN,MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,SHPAR,12,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,THETA,MXTHET,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,THETADF,NAT0,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 90, myid=',myid
!***
      CALL MPI_BCAST_REAL(SINGLE,THETAN,MXSCA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,WAVEA,MXWAV,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,WGTA,MXTHET*MXPHI,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,WGTB,MXBETA,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,X0,3,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 95, myid=',myid
!***

! Complex arrays:

      CALL MPI_BCAST_CPLX(SINGLE,CXE01,3,0,IERR)
      CALL MPI_BCAST_CPLX(SINGLE,CXE02,3,0,IERR)
!*** diagnostic
!      write(0,*)'share1 ckpt 97, myid=',myid,' returning from share1'
!***

      RETURN

    END SUBROUTINE SHARE1

!=======================================================================

    SUBROUTINE SHARE2(MXCOMP,MXWAVT,CXEPS,E1A,E2A,WVA)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments:

      INTEGER :: MXCOMP,MXWAVT,IERR

      REAL(WP) ::     &
         E1A(MXWAVT), &
         E2A(MXWAVT), &
         WVA(MXWAVT)
      COMPLEX(WP) ::  &
         CXEPS(MXCOMP)

! local variable:

      LOGICAL SINGLE

!=======================================================================
! Subroutine SHARE2
! Given:
!    MXCOMP
!    MXWAVT
!    CXEPS
!    E1A
!    E2A
!    WVA

! history:
! Originally written by Matthew Collinge,
! Princeton University Observatory, 2002.11.15

! history: 
! 02.11.15 (BTD) Working version developed by Matthew Collinge
! 03.07.13 (BTD) cosmetic changes during preparation of official
!                release of version 6.0
! end history
!
! Copyright (C) 2002,2003 B.T. Draine and M. Collinge

!=======================================================================

      IF(WP==KIND(0.E0))THEN
         SINGLE=.TRUE.
      ELSEIF(WP==KIND(0.D0))THEN
         SINGLE=.FALSE.
      ELSE
         WRITE(0,*)'fatal error in SHARE2: unable to determine precision'
         STOP
      ENDIF

      CALL MPI_BCAST_REAL(SINGLE,E1A,MXWAVT,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,E2A,MXWAVT,0,IERR)
      CALL MPI_BCAST_REAL(SINGLE,WVA,MXWAVT,0,IERR)
      CALL MPI_BCAST_CPLX(SINGLE,CXEPS,MXCOMP,0,IERR)

      RETURN
    END SUBROUTINE SHARE2

    SUBROUTINE TARNAS(A1,A2,DIAMX,PRINAX,DX,X0,BETADF,PHIDF,THETADF,CFLSHP, &
                      CDESCR,IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
!-------------------------------- tarnas v2 --------------------------------
!** Arguments:

      CHARACTER :: CDESCR*67,CFLSHP*80
      INTEGER :: IDVSHP,IOSHP,MXNAT,NAT
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: DIAMX,PRINAX
      REAL(WP) ::        &
         A1(3),          &
         A2(3),          &
         DX(3),          &
         BETADF(MXNAT),  &
         PHIDF(MXNAT),   &
         THETADF(MXNAT), &
         X0(3)

!** Local variables:

      INTEGER :: NSPHMX
      PARAMETER(NSPHMX=4096)
      CHARACTER :: CMSGNM*70
      LOGICAL :: OCC
      INTEGER :: JA,JS,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NSPH
      INTEGER ::      &
         IC1(NSPHMX), &
         IC2(NSPHMX), &
         IC3(NSPHMX)
      REAL(WP) :: R2,SCALE,X,XMAX,XMIN,Y,YMAX,YMIN,Z,ZMAX,ZMIN
      REAL(WP) ::     &
         ALPHA(3),    &
         AS(NSPHMX),  &
         AS2(NSPHMX), &
         BE(NSPHMX),  &
         PH(NSPHMX),  &
         TH(NSPHMX),  &
         XS(NSPHMX),  &
         YS(NSPHMX),  &
         ZS(NSPHMX)

!***********************************************************************
! Routine to construct multisphere target of general anisotropic
! materials (target option 'NANSPH')

! Input:
!        DIAMX =max extent in X direction/d
!        PRINAX=0 to set A1=(1,0,0), A2=(0,1,0)
!              =1 to use principal axes for vectors A1 and A2
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        CFLSHP= name of file containing locations and radii of spheres
!        IOSHP =device number for "target.out" file
!              =-1 to suppress printing of "target.out"
!        MXNAT =dimensioning information (max number of atoms)

! and, from input file CFLSHP:

!        N              = number of spheres
!        one descriptive line which will be ignored (may be blank)
!        XS(1) YS(1) ZS(1) AS(1) IC1(1) IC2(1) IC3(1) TH(1) PH(1) BE(1)
!        XS(2) YS(2) ZS(2) AS(2) IC1(2) IC2(2) IC3(2) TH(2) PH(2) BE(2)
!        ...
!        XS(N) YS(N) ZS(N) AS(N) IC1(N) IC2(N) IC3(N) TH(N) PH(N) BE(N)

! where XS(J),YS(J),ZS(J) = x,y,z coordinates in target frame, in
!                                 arbitrary units, of center of sphere J
!        AS(J)            = radius of sphere J (same arbitrary units)
!        IC1(J),IC2(J),IC3(J) = dielectric function identifier
!                               for directions 1,2,3 in DF
!        TH(J),PH(J),BE(J) = angles theta_epsilon,phi_epsilon,beta_epsil
!                            specifying orientation of DF in TF

! units used for XS,YS,ZS, and AS are really arbitrary: actual size of
! overall target, in units of lattice spacing d, is controlled by
! parameter SHPAR(1) in ddscat.par

! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
!        X0(1-3)=location/d in TF of lattice site IXYZ=0 0 0
!                TF origin is taken to be located at centroid of N spheres.
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=composition identifier
!        BETADF(1-NAT)=angle beta_epsilon (radians) specifying orientation
!                      of Dielectric Frame (DF) rel to Target Frame (TF)
!                      See UserGuide for definition of angles theta_epsilon
!                      phi_epsilon, beta_epsilon and discussion.
!        PHIDF(1-NAT)=angle phi_epsilon (radians) specifying orientation
!                     DF relative to TF
!        THETADF(1-NAT)=angle theta_epsilon (radians) specifying
!                       orientation of DF relative to TF
!        CDESCR=description of target (up to 67 characters)

! B.T.Draine, Princeton Univ. Obs., 2004.09.15

! History: 
! 04.09.15 (BTD) adapted from subroutine TARNSP 
! 04.09.16 (BTD) further work 
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER 
! 08.08.08 (BTD) added X0 to argument list 
!                added code to set X0 so that TF origin is located at 
!                volume-weighted centroid of the N spheres.  
! 08.08.30 (BTD) modified format 9020 
! 08.09.17 (BTD) v2: fixed bugs 
!                target centroid and therefore X0 was not being 
!                computed correctly in v1: now corrected 
! end history

! Copyright (C) 2004,2007,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Read parameters of spheres:

      OPEN(UNIT=IDVSHP,FILE=CFLSHP)
! diagnostic
      write(0,*)'tarnas ckpt 0.1'
      write(0,*)'read sphere data from file= ',CFLSHP
!
      READ(IDVSHP,*)NSPH
      IF(NSPH>NSPHMX)THEN
         CALL ERRMSG('FATAL','TARNAS',' NSPH > NSPHMX')
         STOP
      ENDIF
      READ(IDVSHP,*)
      DO JA=1,NSPH
         READ(IDVSHP,*)XS(JA),YS(JA),ZS(JA),AS(JA),IC1(JA),IC2(JA), &
                       IC3(JA),TH(JA),PH(JA),BE(JA)
      ENDDO
      CLOSE(IDVSHP)

! Check for overlap and, if so, possible conflict in composition
! or (if anisotropic) orientation

      IF(NSPH>=2)THEN
         DO JA=2,NSPH
            DO JY=1,JA-1
               R2=(XS(JY)-XS(JA))**2+(YS(JY)-YS(JA))**2 + &
                  (ZS(JY)-ZS(JA))**2-(AS(JY)+AS(JA))**2

! exact R2 should be nonnegative, but allow for roundoff error

               IF(R2<-0.0001_WP*(AS(JY)+AS(JA)))THEN
                  IF(IC1(JY)/=IC1(JA).OR.IC2(JY)/=IC2(JA).OR. &
                     IC3(JY)/=IC3(JA))THEN
!*** diagnostic
!      write(0,*)'in tarnas, apparent overlap of spheres JY,JA=',jy,ja
!      write(0,*)'jy: x,y,z=',xs(jy),ys(jy),zs(jy)
!      write(0,*)'ja: x,y,z=',xs(ja),ys(ja),zs(ja)
!      write(0,*)'a(jy),a(ja)=',as(jy),as(ja)
!***
                     CALL ERRMSG('FATAL','TARNAS',                          &
                                 ' Sphere overlap but differing composition')
                  ENDIF
                  IF(IC1(JY)/=IC2(JY).OR.IC1(JY)/=IC3(JY))THEN
                     IF(BE(JY)/=BE(JA).OR.PH(JY)/=PH(JA).OR.TH(JY)/=TH(JA)) &
                        THEN
                        CALL ERRMSG('FATAL','TARNAS',                      &
                                ' Sphere overlap but differing orientation')
                     ENDIF
                  ENDIF
               ENDIF
            ENDDO
         ENDDO
      ENDIF

! Dipoles are located at sites
! (x,y,z)=(I,J,K), I,J,K=integers

! Determine max extent in X direction:

      XMIN=XS(1)-AS(1)
      XMAX=XS(1)+AS(1)
      YMIN=YS(1)-AS(1)
      YMAX=YS(1)+AS(1)
      ZMIN=ZS(1)-AS(1)
      ZMAX=ZS(1)+AS(1)
      IF(NSPH>1)THEN
         DO JA=2,NSPH
            IF(XS(JA)-AS(JA)<XMIN)XMIN=XS(JA)-AS(JA)
            IF(XS(JA)+AS(JA)>XMAX)XMAX=XS(JA)+AS(JA)
            IF(YS(JA)-AS(JA)<YMIN)YMIN=YS(JA)-AS(JA)
            IF(YS(JA)+AS(JA)>YMAX)YMAX=YS(JA)+AS(JA)
            IF(ZS(JA)-AS(JA)<ZMIN)ZMIN=ZS(JA)-AS(JA)
            IF(ZS(JA)+AS(JA)>ZMAX)ZMAX=ZS(JA)+AS(JA)
         ENDDO
      ENDIF
      SCALE=DIAMX/(XMAX-XMIN)

! Now determine min,max values of I,J,K:

      LMX1=NINT(SCALE*XMIN/DX(1)-0.01_WP)
      LMX2=NINT(SCALE*XMAX/DX(1)+0.01_WP)
      LMY1=NINT(SCALE*YMIN/DX(2)-0.01_WP)
      LMY2=NINT(SCALE*YMAX/DX(2)+0.01_WP)
      LMZ1=NINT(SCALE*ZMIN/DX(3)-0.01_WP)
      LMZ2=NINT(SCALE*ZMAX/DX(3)+0.01_WP)


      DO JA=1,NSPH
         AS2(JA)=(SCALE*AS(JA))**2
         XS(JA)=SCALE*XS(JA)
         YS(JA)=SCALE*YS(JA)
         ZS(JA)=SCALE*ZS(JA)
      ENDDO

! Determine list of occupied sites

      NAT=0
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ,KIND=WP)*DX(3)
         DO JY=LMY1,LMY2
            Y=REAL(JY,KIND=WP)*DX(2)
            DO JX=LMX1,LMX2
               X=REAL(JX,KIND=WP)*DX(1)
               OCC=.FALSE.
               DO JA=1,NSPH
                  R2=(X-XS(JA))**2+(Y-YS(JA))**2+(Z-ZS(JA))**2
                  IF(R2<AS2(JA))THEN
                     OCC=.TRUE.
                     JS=JA
                  ENDIF
               ENDDO
               IF(OCC)THEN

! Site is occupied: assign location IXYZ, composition ICOMP, and
! material orientation BETADF,PHIDF,THETADF:

                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  ICOMP(NAT,1)=IC1(JS)
                  ICOMP(NAT,2)=IC2(JS)
                  ICOMP(NAT,3)=IC3(JS)
                  BETADF(NAT)=BE(JS)
                  PHIDF(NAT)=PH(JS)
                  THETADF(NAT)=TH(JS)
               ENDIF
            ENDDO
         ENDDO
      ENDDO

      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARNSP',' NAT.GT.MXNAT ')
      ENDIF

! Specify target axes A1 and A2
! If PRINAX=0, then
!     A1=(1,0,0) in target frame
!     A2=(0,1,0) in target frame
! If PRINAX=1., then
!     A1,A2 are principal axes of largest, second largest moment of
!     inertia

      IF(PRINAX<=0._WP)THEN
         DO JX=1,3
            A1(JX)=0._WP
            A2(JX)=0._WP
         ENDDO
         A1(1)=1._WP
         A2(2)=1._WP
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,ALPHA)
      ENDIF

! Find volume-weighted centroid of the N spheres in IJK space
! Take this to be TF origin.
! Set X0 = -(IJK centroid)

      DO JX=1,3
         X0(JX)=0._WP
      ENDDO
      Z=0._WP

      DO JA=1,NSPH
         Z=Z+AS(JA)**3
      ENDDO

      DO JA=1,NSPH
         Y=AS(JA)**3/Z
         X0(1)=X0(1)-XS(JA)*Y
         X0(2)=X0(2)-YS(JA)*Y
         X0(3)=X0(3)-ZS(JA)*Y
      ENDDO
! diagnostic
      write(0,*)'tarnas ckpt 2, x0=',x0
!
!***********************************************************************
! Write target description into string CDESCR

      WRITE(CDESCR,FMT='(A,I7,A)')' Multisphere cluster containing',NAT, &
                                  ' dipoles'

!***********************************************************************

      CMSGNM=CDESCR
      CALL WRIMSG('TARNSP',CMSGNM)
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NSPH,DIAMX,NAT,ALPHA,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
9020  FORMAT(' >TARNSP multisphere target composed of ',I3,        &
             ' spheres, DIAMX=',F8.4,/,                            &
         I10,3F8.4,' = NAT, alpha_1-3',/,                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARNAS

! These routines were created by Art Lazanoff in order to
! satisfy dependencies when passing dummy routines as argument
! to various subroutines.
! Added to DDSCAT 2008.05.12
      SUBROUTINE DUMMY(D1,D2,I1)
      USE DDPRECISION,ONLY : WP
      REAL(WP)::D1,D2
      INTEGER I1
      END SUBROUTINE DUMMY
      SUBROUTINE CDUMMY(D1,D2,I1)
      USE DDPRECISION,ONLY : WP
      REAL(WP)::D1,D2
      INTEGER I1
      END SUBROUTINE CDUMMY
      SUBROUTINE CDUMMY_1(D1,D2,I1)
      USE DDPRECISION,ONLY : WP
      REAL(WP)::D1,D2
      INTEGER I1
      END SUBROUTINE CDUMMY_1

    PROGRAM DDPOL
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! arguments of READPOL
      INTEGER :: IANISO,MODE,MXNAT,NAT0
      INTEGER*2,ALLOCATABLE :: ICOMP(:,:)
      INTEGER,ALLOCATABLE :: IXYZ0(:,:)
      INTEGER :: NX,NY,NZ
      REAL(WP) :: PYD,PZD,WAVE
      REAL(WP) :: &
         AKD(3),  &
         DX(3),   &
         X0(3)
      REAL(WP),ALLOCATABLE :: &
         BETADF(:),           &
         PHIDF(:),            &
         THETADF(:)
      COMPLEX(WP) :: &
         CXE0(3)
      COMPLEX(WP),ALLOCATABLE :: &
         CXADIA(:,:),            &
         CXAOFF(:,:),            &
         CXPOL(:,:)
      CHARACTER :: CFLPOL*80

! local variables

      INTEGER ::                       &
         IAT,JA,JD,JX,JXMAX,JXMIN,     &
         JY,JYMAX,JYMIN,JZ,JZMAX,JZMIN
      REAL(WP) ::                          &
         CWORD,DSTORAGE,EX0,EY0,EZ0,KD,MB, &
         PI,PSIX,PSIY,PSIZ,                &
         RWORD,STORAGE,STORAGE0,X,Y,Z

      COMPLEX(WP) :: &
         CXB0(3)

!=======================================================================
!                          DDpol
!
! Program DDpol takes the target polarization array output by DDSCAT,
! and reports polarization at selected points in the target.
!
! Input: file DDpol.in with list of coordinates, given as
!        x/dx(1), y/dx(2), z/dx(3)
!
!        where dx(j)=lattice spacing in direction j
!        with dx(1)*dx(2)*dx(3)=d**3
!
! history:
! 06.09.22 (BTD) created from DDfield as template
!                write PYD,PZD to output files
! 08.01.17 (BTD) modified to use new version of READPOL, with additional
!                arguments MODE,IANISO,ICOMP,BETADF,THETADF,PHIDF
!                modified to write out information concerning target
!                geometry
! 08.10.30 (BTD) corrected 
!                * typos in memory allocation
!                  (errors pointed out by Michel Devel)
!                * must allocate BETADF,THETADF,PHIDF even when
!                  IANISO=1, since readpol writes zeros.
! 09.08.12 (BTD) bug reported by Rodrigo Alcazar de la Osa (Univ. of
!                Cantabria, Spain)
!                corrected declaration of CFLPOL*16 -> CFLPOL*80
!                as required by READPOL
! 09.08.13 (BTD) several declaration statements 
!                arrays were inconsistent with READPOL:
!                changes:
!                INTEGER -> INTEGER*2 for ICOMP
!                REAL -> REAL(WP) for real variables
!                COMPLEX -> COMPLEX(WP) for complex variables
! end history

! Copyright (C) 2006,2007,2008,2009
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!=======================================================================

      PI=4.*ATAN(1.)

! for storage computations:

      MB=REAL(1024**2)
      IF(WP==KIND(0.E0))THEN
         RWORD=4._WP
         CWORD=2._WP*RWORD
         STORAGE0=6.79
      ELSEIF(WP==KIND(0.D0))THEN
         RWORD=8._WP
         CWORD=2._WP*RWORD
         STORAGE0=6.794
      ELSE
         WRITE(0,*)'Fatal error in DDfield: unable to determine word length'
         STOP
      ENDIF
      STORAGE=STORAGE0

! Input control file:

      OPEN(UNIT=3,FILE='DDpol.in')

! Output files:

      OPEN(UNIT=7,FILE='DDpol.out')

! Read name of file containing stored polarization information:

! temporary allocation

      MXNAT=1
      ALLOCATE(ICOMP(MXNAT,3))
      ALLOCATE(IXYZ0(MXNAT,3))
      ALLOCATE(BETADF(MXNAT))
      ALLOCATE(THETADF(MXNAT))
      ALLOCATE(PHIDF(MXNAT))
      ALLOCATE(CXADIA(MXNAT,3))
      ALLOCATE(CXAOFF(MXNAT,3))
      ALLOCATE(CXPOL(MXNAT,3))

      READ(3,*)CFLPOL

! skip one line so that one can use the same file structure as DDfield.in
      READ(3,*)

! Use routine READPOL to read in the polarization array from file CFLPOL.
! call first with MODE=0 to obtain size information

      MODE=0
      CALL READPOL(MODE,MXNAT,NX,NY,NZ,NAT0,IANISO,ICOMP,IXYZ0,PYD,PZD,AKD,  &
                   DX,X0,WAVE,BETADF,THETADF,PHIDF,CXE0,CXADIA,CXAOFF,CXPOL, &
                   CFLPOL)

! Now allocate necessary storage:

      DEALLOCATE(ICOMP)
      DEALLOCATE(IXYZ0)
      DEALLOCATE(CXADIA)
      DEALLOCATE(CXAOFF)
      DEALLOCATE(CXPOL)

      MXNAT=NAT0
      STORAGE=STORAGE0

      DSTORAGE=REAL(2*3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6605)DSTORAGE,STORAGE
      ALLOCATE(ICOMP(MXNAT,3))

      DSTORAGE=REAL(4*3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6610)DSTORAGE,STORAGE
      ALLOCATE(IXYZ0(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6620)DSTORAGE,STORAGE
      ALLOCATE(CXADIA(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6630)DSTORAGE,STORAGE
      ALLOCATE(CXAOFF(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6640)DSTORAGE,STORAGE
      ALLOCATE(CXPOL(MXNAT,3))

      DEALLOCATE(BETADF)
      DEALLOCATE(THETADF)
      DEALLOCATE(PHIDF)

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6660)DSTORAGE,STORAGE
      ALLOCATE(BETADF(MXNAT))

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6670)DSTORAGE,STORAGE
      ALLOCATE(THETADF(MXNAT))

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6680)DSTORAGE,STORAGE
      ALLOCATE(PHIDF(MXNAT))

      MODE=1
      CALL READPOL(MODE,MXNAT,NX,NY,NZ,NAT0,IANISO,ICOMP,IXYZ0,PYD,PZD,AKD,  &
                   DX,X0,WAVE,BETADF,THETADF,PHIDF,CXE0,CXADIA,CXAOFF,CXPOL, &
                   CFLPOL)

! Check target dimensions

      JXMIN=IXYZ0(1,1)
      JYMIN=IXYZ0(1,2)
      JZMIN=IXYZ0(1,3)
      JXMAX=JXMIN
      JYMAX=JYMIN
      JZMAX=JZMIN
      DO JA=2,NAT0
         JX=IXYZ0(JA,1)
         JY=IXYZ0(JA,2)
         JZ=IXYZ0(JA,3)
         IF(JX.LT.JXMIN)JXMIN=JX
         IF(JX.GT.JXMAX)JXMAX=JX
         IF(JY.LT.JYMIN)JYMIN=JY
         IF(JY.GT.JYMAX)JYMAX=JY
         IF(JZ.LT.JZMIN)JZMIN=JZ
         IF(JZ.GT.JZMAX)JZMAX=JZ
      ENDDO

      KD=0.
      DO JD=1,3
         KD=KD+AKD(JD)**2
      ENDDO
      KD=SQRT(KD)

! KD = k*d

! Calculate incident B field:

      CXB0(1)=(AKD(2)*CXE0(3)-AKD(3)*CXE0(2))/KD
      CXB0(2)=(AKD(3)*CXE0(1)-AKD(1)*CXE0(3))/KD
      CXB0(3)=(AKD(1)*CXE0(2)-AKD(2)*CXE0(1))/KD

      WRITE(7,7001)NAT0,JXMIN,JXMAX,JYMIN,JYMAX,JZMIN,JZMAX,PYD,PZD,AKD,CXE0

 1000 READ(3,*,END=9000,ERR=9000)X,Y,Z
      WRITE(0,6100)X,Y,Z

      DO JA=1,NAT0
         IF(IXYZ0(JA,1).EQ.INT(X))THEN
            IF(IXYZ0(JA,2).EQ.NINT(Y))THEN
               IF(IXYZ0(JA,3).EQ.NINT(Z))THEN
                  IAT=JA
               ENDIF
            ENDIF
         ENDIF
      ENDDO
            
      EX0=ABS(CXPOL(IAT,1))
      PSIX=0.
      IF(EX0.GT.0.)THEN
         PSIX=ACOS(REAL(CXPOL(IAT,1))/EX0)
         IF(AIMAG(CXPOL(IAT,1)).LT.0.)PSIX=2.*PI-PSIX
      ENDIF
      EX0=4.*PI*EX0

      EY0=ABS(CXPOL(IAT,2))
      PSIY=0.
      IF(EY0.GT.0.)THEN
         PSIY=ACOS(REAL(CXPOL(IAT,2))/EY0)
         IF(AIMAG(CXPOL(IAT,2)).LT.0.)PSIY=2*PI-PSIY
      ENDIF
      EY0=4.*PI*EY0

      EZ0=ABS(CXPOL(IAT,3))
      PSIZ=0.
      IF(EZ0.GT.0.)THEN
         PSIZ=ACOS(REAL(CXPOL(IAT,3))/EZ0)
         IF(AIMAG(CXPOL(IAT,3)).LT.0.)PSIZ=2*PI-PSIZ
      ENDIF
      EZ0=4.*PI*EZ0

      PSIX=180.*PSIX/PI
      PSIY=180.*PSIY/PI
      PSIZ=180.*PSIZ/PI

      WRITE(7,7100)X,Y,Z,EX0,PSIX,EY0,PSIY,EZ0,PSIZ

      GOTO 1000
!-----------------------------------------------------------------------
 9000 CLOSE(7)
      STOP
 6100 FORMAT('calc E and B at (x/dx,y/dy,z/dz)=',3F10.3)
 6605 FORMAT('allocating',F8.3,' MB for ICOMP ; total=',F10.3,' MB')
 6610 FORMAT('allocating',F8.3,' MB for IXYZ0 ; total=',F10.3,' MB')
 6620 FORMAT('allocating',F8.3,' MB for CXADIA; total=',F10.3,' MB')
 6630 FORMAT('allocating',F8.3,' MB for CXAOFF; total=',F10.3,' MB')
 6640 FORMAT('allocating',F8.3,' MB for CXPOL ; total=',F10.3,' MB')
 6650 FORMAT('allocating',F8.3,' MB for DCXE  ; total=',F10.3,' MB')
 6660 FORMAT('allocating',F8.3,' MB for BETADF; total=',F10.3,' MB')
 6670 FORMAT('allocating',F8.3,' MB for THETADF;total=',F10.3,' MB')
 6680 FORMAT('allocating',F8.3,' MB for PHIDF;  total=',F10.3,' MB')
 7001 FORMAT(I10,' = number of dipoles in Target',/,              &
             'Target dipole positions in Target Frame:',/,        &
             2I6,' = min,max values of x/d',/,                    &
             2I6,' = min,max values of y/d',/,                    &
             2I6,' = min,max values of z/d',/,/,                  &
             2F10.4,' = PYD, PZD = period_y/dy, period_z/dz',/,/, &
             1PE12.5,' = k_x*d for incident wave',/,              &
             1PE12.5,' = k_y*d for incident wave',/,              &
             1PE12.5,' = k_z*d for incident wave',/,              &
             '(',0PF10.6,' , ',0PF10.6,' ) = E_inc,x(0,0,0)',/,   &
             '(',0PF10.6,' , ',0PF10.6,' ) = E_inc,y(0,0,0)',/,   &
             '(',0PF10.6,' , ',0PF10.6,' ) = E_inc,z(0,0,0)',/,   &
             4X,'x/d',6X,'y/d',6X,'z/d',2X,'4pi|P_x| psi_x',1X,   &
             '4pi|P_y| psi_y',1X,'4pi|P_z| psi_z')
 7100 FORMAT(3F9.4,F9.5,F6.1,F8.5,F6.1,F8.5,F6.1)
      END

      SUBROUTINE MPI_BCAST_REAL(SINGLE,REALVAR,ICOUNT,IROOT,IERR)
      IMPLICIT NONE
!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments
      LOGICAL SINGLE
      INTEGER ICOUNT,IERR,IROOT
      REAL REALVAR(*)
!-----------------------------------------------------------------------
! Subroutine MPI_BCAST_REAL
! Purpose: to serve as a "jacket" for passing real variables to
!          MPI_BCAST so that MPI_BCAST will be called with only a single 
!          variable type in a given fortran routine.

! if SINGLE = .TRUE. : real variables are single precision
!             .FALSE. : real variables are double precision

! B.T. Draine, Princeton University Observatory, 2004.04.09
! history
! 04.04.09 (BTD) first written
! 08.01.17 (BTD) f90 version
! end history
! Copyright (C) 2004,2008 B.T.Draine and P.J. Flatau
! This code is covered by the GNU General Public License
!-----------------------------------------------------------------------
      IF(SINGLE)THEN
         CALL MPI_BCAST(REALVAR,ICOUNT,MPI_REAL, &
                        IROOT,MPI_COMM_WORLD,IERR)
      ELSE
         CALL MPI_BCAST(REALVAR,ICOUNT,MPI_DOUBLE_PRECISION, &
                        IROOT,MPI_COMM_WORLD,IERR)
      ENDIF
      RETURN
    END SUBROUTINE MPI_BCAST_REAL

    SUBROUTINE EXTEND(CMETHD,ICOMP,ICOMP2,IDVERR,IDVOUT,IOCC,IX,IY,IZ,BETADF, &
                      PHIDF,THETADF,SCRRS2,X0,MXNX,MXNY,MXNZ,MXNAT,MXN3,NAT,  &
                      NAT0,NAT3,NX,NY,NZ)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      CHARACTER(6) :: CMETHD
      INTEGER :: IDVERR,IDVOUT,MXNAT,MXN3,MXNX,MXNY,MXNZ,NAT,NAT0, &
         NAT3,NX,NY,NZ
      INTEGER*2 ::     &
         ICOMP(MXN3),  &
         ICOMP2(MXN3), &
         IOCC(MXNAT)
      INTEGER ::    &
         IX(MXNAT), &
         IY(MXNAT), &
         IZ(MXNAT)
      REAL(WP) ::        &
         BETADF(MXNAT),  &
         PHIDF(MXNAT),   &
         SCRRS2(MXNAT),  &
         THETADF(MXNAT), &
         X0(3)

! Local parameters:

      INTEGER :: MX235
      PARAMETER(MX235=137)

! Local variables:

      INTEGER :: IXA,IXMAX,IXMIN,IYA,IYMAX,IYMIN,IZA,IZMAX,IZMIN,JA,JA2,NXY
      INTEGER ::    &
         NF235(MX235)
      SAVE NF235

!***********************************************************************
! Given:
!    NAT0 = number of dipoles in real target
!    IX(1-NAT0) = x-index of dipoles in desired target
!    IY(1-NAT0) = y-index of dipoles in desired target
!    IZ(1-NAT0) = z-index of dipoles in desired target
!    X0(1-3)    = x,y,z offset/d from target origin for dipole with IX=0
!                 IY=0, IZ=0
!    ICOMP(1-NAT0,1-3) = composition info. for dipoles in desired target
!                       [with storage locations according to
!                        dimensioning ICOMP(MXNAT,3) ]
!    BETADF(1-NAT0) = constituent material orientation angle BETA
!                     (radians) for Dielectric Frame (DF) relative to
!                     Target Frame (TF)
!    PHIDF(1-NAT0)  = constituent material orientation angle PHI (radian
!                     for DF relative to TF
!    THETADF(1-NAT0)= constituent material orientation angle THETA
!                     (radians) for DF relative to TF
!    SCRRS2         = scratch array
!    MXNX,MXNY,MXNZ = maximum allowed target size in x,y,z directions
!    MXNAT,MXN3 = dimensioning information

! Returns:
!    NAT = number of dipoles in extended target = NX*NY*NZ
!    NAT3 = 3*NAT
!    IX(1-NAT0) = x-index of dipoles in reordered physical target
!    IY(1-NAT0) = y-index of dipoles in reordered physical target
!    IZ(1-NAT0) = z-index of dipoles in reordered physical target
!    ICOMP(1-NAT,1-3) = composition inf. for dipoles (ICOMP=0 if vacant)
!                       [with storage locations according to
!                        dimensioning ICOMP(NAT,3) ]
!    IOCC(J=1-NAT3) = 0 or 1 depending on whether site (JX,JY,JZ) is
!                            unoccupied or occupied
!                     J=NX*NY(JZ-1)+NX*(JY-1)+JX
!    BETADF(1-NAT0)= material orientation angle BETA (radians) for
!                    reordered physical target
!    PHIDF(1-NAT0)=material orientation angle PHI (radians) for
!                  reordered physical target
!    THETADF(1-NAT)=material orientation angle THETA (radians) for
!                    reordered target
!             NB: BETADF(JA)=PHIDF(JA)=THETADF(JA)=0 at unoccupied sites
!    NX = range of IX values (1 to NX)
!    NY = range of IY values (1 to NY)
!    NZ = range of IZ values (1 to NZ)

! Note: it is necessary to reorder IX,IY,IZ because DDSCAT calls routine
!    REDUCE to take list of polarizations for "extended" target and
!    collapse it to list of polarizations for "physical" target.
!    Similarly, REDUCE is also used to collapse vector of incident E
!    and vector of polarizabilities.

! B.T.Draine, Princeton Univ. Obs., 90.10.30
! History:
! 90.11. 8 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
! 90.11.30 (BTD): Cosmetic changes.
! 90.11.30 (BTD): Modify to choose NX,NY,NZ from NF235.
! 90.12.05 (BTD): Change argument list; correct bug.
! 90.12.07 (BTD): Previous version was stupidly written. Rewritten.
! 90.12.13 (BTD): Corrected data list for NF235. Modified to allow
!                 CMETHD='CONVEX' option.
! 92.06.01 (BTD+PJF): Corrected major flaw in EXTEND: previous version
!                 neglected to reorder elements of IX,IY,IZ to
!                 correspond to possible reordering of occupied sites
!                 when extended target is constructed.  This error was
!                 previously overlooked because ordering was fortuitousl
!                 unchanged by extend for targets generated by TARREC,
!                 TARELL, TARCYL, TARHEX.  Note that differential
!                 scattering cross sections computed previously using
!                 DDSCAT ver4a and using TARTET are not correct.
! 92.09.09 (BTD): extended values of NF235 up to 1024, and added
!                 warning if calling with IXMAX,IYMAX,or IZMAX > 1024
! 93.01.20 (BTD): added MXNX,MXNY,MXNZ to argument list and
!                 added tests to ensure that target is consistent with
!                 limits MXNX,MXNY,MXNZ
! 93.03.12 (BTD): extended NF235 up to 4096
! 94.06.20 (PJF): added code for NEWTMP 3D FFT
! 96.10.18 (BTD): changed NEWTMP to GPFAFT (Generalized Prime Factor
!                 Algorithm for Fourier Transform).
! 98.08.09 (BTD): Modified to permit execution to continue with warning
!                 if one or more of NX,NY,NZ exceeds MXNX,MXNY,MXNZ
!                 but NX*NY*NZ < MXNX*MXNY*MXNZ
!                 since we believe that memory management should still
!                 be ok in this case
!                 Also eliminate superfluous warning/error message
!                 about NX,NY,NZ
! 00.06.23 (BTD): Modified to support option FFTWFJ
! 04.09.15 (BTD): Modified to treat material orientation angles
!                 BETADF,PHIDF,THETADF
!                 Add scratch array SCRRS1 to use in doing this.
! 06.12.24 (BTD): Increased size of array NF235 to MX235=137
!                 Added 1 to array NF235
! 07.06.19 (BTD): Added dipole offset X0(3) to argument list
!                 Modified to shift X0 when changing IX,IY,IZ
!                 [Question: do we really need to shift IX,IY,IZ?]
! 07.09.11 (BTD): Corrected shift of X0(3)
!                 Changed IX,IY,IZ from INTEGER*2 to INTEGER
! end history
! Copyright (C) 1993,1996,1998,2000,2004,2006,2007
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Elements of NF235 are numbers.le.4096  which can be factored by 2,3,5:

      DATA NF235/1,2,3,4,5,6,8,9,10,12,15,16,18,20,24,25,27,      &
         30,32,36,40,45,48,50,54,60,64,72,75,80,81,90,96,100,     &
         108,120,125,128,135,144,150,160,162,180,192,200,216,225, &
         240,243,250,256,270,288,300,320,324,360,375,384,400,405, &
         432,450,480,486,500,512,540,576,600,625,640,648,675,720, &
         729,750,768,800,810,864,900,960,972,1000,1024,1080,1125, &
         1152,1200,1215,1250,1280,1296,1350,1440,1458,1500,1536,  &
         1600,1620,1728,1800,1875,1920,1944,2000,2025,2048,2160,  &
         2187,2250,2304,2400,2430,2500,2560,2592,2700,2880,2916,  &
         3000,3072,3125,3200,3240,3375,3456,3600,3645,3750,3840,  &
         3888,4000,4050,4096/

!*** First determine max., min values of input IX,IY,IZ for occupied sites:

      IXMIN=IX(1)
      IXMAX=IX(1)
      IYMIN=IY(1)
      IYMAX=IY(1)
      IZMIN=IZ(1)
      IZMAX=IZ(1)
      DO JA=2,NAT0
         IF(IX(JA)<IXMIN)IXMIN=IX(JA)
         IF(IX(JA)>IXMAX)IXMAX=IX(JA)
         IF(IY(JA)<IYMIN)IYMIN=IY(JA)
         IF(IY(JA)>IYMAX)IYMAX=IY(JA)
         IF(IZ(JA)<IZMIN)IZMIN=IZ(JA)
         IF(IZ(JA)>IZMAX)IZMAX=IZ(JA)
      ENDDO

!*** Now shift so that IX runs from 1 to IXMAX-IXMIN+1, etc.

      DO JA=1,NAT0
         IX(JA)=IX(JA)+1-IXMIN
         IY(JA)=IY(JA)+1-IYMIN
         IZ(JA)=IZ(JA)+1-IZMIN
      ENDDO
      IXMAX=IXMAX-IXMIN+1
      IYMAX=IYMAX-IYMIN+1
      IZMAX=IZMAX-IZMIN+1

! we have shifted IX,IY,IZ
! therefore need to change X0(1-3)
! where X0(1-3)*d = physical location in TF of dipole with IX=IY=IZ=0

      X0(1)=X0(1)+REAL(IXMIN-1,KIND=WP)
      X0(2)=X0(2)+REAL(IYMIN-1,KIND=WP)
      X0(3)=X0(3)+REAL(IZMIN-1,KIND=WP)

      WRITE(IDVOUT,6100)IXMAX,IYMAX,IZMAX

!*** Now determine NX,NY,NZ

      IF(CMETHD=='GPFAFT')THEN

! Using GPFAFT : Temperton's new GPFA routine
! which requireS that NX,NY,NZ be factorable by 2,3,5
! We require that NX,NY,NZ be selected from list NF235
! Check that list is long enough:

         IF(IXMAX>NF235(MX235))THEN
            WRITE(IDVERR,*)'EXTEND> Error: IXMAX=',IXMAX, &
                           '.gt.NF235(MX235)=',NF235(MX235)
            CALL ERRMSG('FATAL','EXTEND',' need to add to NF235 in EXTEND')
         ELSEIF(IYMAX>NF235(MX235))THEN
            WRITE(IDVERR,*)'EXTEND> Error: IYMAX=',IYMAX, &
                           '.gt.NF235(MX235)=',NF235(MX235)
            CALL ERRMSG('FATAL','EXTEND',' need to add to NF235 in EXTEND')
         ELSEIF(IZMAX>NF235(MX235))THEN
           WRITE(IDVERR,*)'EXTEND> Error: IZMAX=',IZMAX, &
                          '.gt.NF235(MX235)=',NF235(MX235)
           CALL ERRMSG('FATAL','EXTEND',' need to add to NF235 in EXTEND')
         ENDIF
         NX=0
         NY=0
         NZ=0
         DO JA=1,MX235
            IF(IXMAX<=NF235(JA).AND.NX==0)NX=NF235(JA)
            IF(IYMAX<=NF235(JA).AND.NY==0)NY=NF235(JA)
            IF(IZMAX<=NF235(JA).AND.NZ==0)NZ=NF235(JA)
         ENDDO
      ELSE

! Using a routine with no restriction on NX,NY,NZ:
! e.g.,
! -- FFTWFJ : FFTW routine from Frigo and Johnson

         NX=IXMAX
         NY=IYMAX
         NZ=IZMAX
      ENDIF
      IF(NX>MXNX .OR. NY>MXNY .OR. NZ>MXNZ)THEN
         IF(NX*NY*NZ>MXNX*MXNY*MXNZ)THEN
            WRITE(IDVOUT,6300)NX,NY,NZ,MXNX,MXNY,MXNZ
            CALL ERRMSG('FATAL','EXTEND', &
                 ' need to change MXNX,MXNY,MXNZ in DDSCAT and recompile')
         ELSE
            WRITE(IDVOUT,6301)NX,NY,NZ,MXNX,MXNY,MXNZ
         ENDIF
      ENDIF
      NAT=NX*NY*NZ
      NAT3=3*NAT

!*** Now extend target: generate vectors of dipole properties
!        ICOMP(jx,jy,jz,1-3)=ICOMP(ja,1-3)=ICOMP(ja3)
!        IOCC(jx,jy,jz)=IOCC(ja)
!    with indices jx,jy,jz running from 1-NX,1-NY,1-NZ
!              or ja          "     "   1-(NX*NY*NZ)
!              or ja3         "     "   1-(3*NX*NY*NZ)


! First initialize ICOMP, IOCC, and SCRRS1 to zero:

      DO JA2=1,NAT
         IOCC(JA2)=0
         ICOMP2(JA2)=0
         ICOMP2(JA2+NAT)=0
         ICOMP2(JA2+2*NAT)=0
         SCRRS2(JA2)=0._WP
      ENDDO

! Now reset values at occupied sites

      NXY=NX*NY
      DO JA=1,NAT0
         JA2=IX(JA)+NX*(IY(JA)-1)+NXY*(IZ(JA)-1)
         IOCC(JA2)=1
         ICOMP2(JA2)=ICOMP(JA)
         ICOMP2(JA2+NAT)=ICOMP(JA+MXNAT)
         ICOMP2(JA2+2*NAT)=ICOMP(JA+2*MXNAT)
         SCRRS2(JA2)=BETADF(JA)
      ENDDO

! Now overwrite original ICOMP

      DO JA=1,NAT3
         ICOMP(JA)=ICOMP2(JA)
      ENDDO
      DO JA=1,NAT
         BETADF(JA)=SCRRS2(JA)
      ENDDO

! SCRRS2 should still be zero at unoccupied sites, so no need
! to rezero this array.

      DO JA=1,NAT0
         JA2=IX(JA)+NX*(IY(JA)-1)+NXY*(IZ(JA)-1)
         SCRRS2(JA2)=PHIDF(JA)
      ENDDO
      DO JA=1,NAT
         PHIDF(JA)=SCRRS2(JA)
      ENDDO
      DO JA=1,NAT0
         JA2=IX(JA)+NX*(IY(JA)-1)+NXY*(IZ(JA)-1)
         SCRRS2(JA2)=THETADF(JA)
      ENDDO
      DO JA=1,NAT
         THETADF(JA)=SCRRS2(JA)
      ENDDO

! Now reorder IX,IY,IZ to correspond to new ordering of occupied sites

      JA=0
      DO JA2=1,NAT
         IF(IOCC(JA2)>=1)THEN
            JA=JA+1
            IXA=1+MOD(JA2-1,NX)
            IYA=1+MOD(JA2-IXA,NXY)/NX
            IZA=1+(JA2-IXA-NX*(IYA-1))/NXY
            IX(JA)=IXA
            IY(JA)=IYA
            IZ(JA)=IZA
         ENDIF
      ENDDO
      RETURN
6100  FORMAT(' >EXTEND: target extent in x,y,z directions =',I5,',',I5,',', &
        I5,' (in Target Frame)')
6300  FORMAT(' >EXTEND: Fatal error after extending target!:',/,            &
        '          Extended target extent in x,y,z directions =',I5,',',I5, &
        ',',I5,/,'          exceeds dimension limits MXNX,MXNY,MXNZ=',I5,   &
        ',',I5,',',I5)
6301  FORMAT(' >EXTEND: Warning after extending target!:',/,                &
        '          Extended target extent in x,y,z directions =',I5,',',I5, &
        ',',I5,/,'          exceeds dimension limits MXNX,MXNY,MXNZ=',I5,   &
        ',',I5,',',I5,/,'          execution allowed to continue since ',   &
        'MXNX*MXNY*MXNZ > NX*NY*NZ')
    END SUBROUTINE EXTEND

    SUBROUTINE ROTATE(A1,A2,AK1,CXE01,CXE02,BETA,THETA,PHI,EN0R,CXE01R,CXE02R, &
        MXSCA,NSCAT,ENSC,EM1,EM2,AKSR,EM1R,EM2R)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: MXSCA, NSCAT
      REAL (WP) :: AK1, BETA, THETA, PHI
      REAL (WP) :: A1(3), A2(3), AKSR(3,MXSCA), EM1(3,MXSCA), EM1R(3,MXSCA), &
        EM2(3,MXSCA), EM2R(3,MXSCA), EN0R(3), ENSC(3,MXSCA)
      COMPLEX (WP) :: CXE01(3), CXE02(3), CXE01R(3), CXE02R(3)

! Local variables

      INTEGER :: I
      REAL (WP) :: BETA0, PHI0, PI, SINTHE, TERM, THETA0
      REAL (WP) :: RM1(3,3), RM2(3,3), RM3(3,3), VEC(3)
!***********************************************************************
! Given:
!       A1(1-3)=axis 1 of (original, unrotated) target
!       A2(1-3)=axis 2 of (original, unrotated) target
!       AK1=magnitude of k vector
!       CXE01(1-3)=original incident polarization vector 1
!       CXE02(1-3)=original incident polarization vector 2
!       BETA=angle (radians) through which target is to be rotated
!            around target axis A1
!       THETA=angle (radians)which target axis A1 is to make with
!            Lab x-axis
!       PHI=angle (radians) between Lab x,A1 plane and Lab x,y plane
!       ENSC(1-3,1-NSCAT)=scattering directions in Lab Frame
!       EM1(1-3,1-NSCAT)=scattering polarization vector 1 in Lab Frame
!       EM2(1-3,1-NSCAT)=scattering polarization vector 2 in Lab Frame

! Returns:
!       EN0R(1-3)=incident propagation vector in Target Frame
!       CXE01R(1-3)=incident polariz. vector 1 in Target Frame
!       CXE02R(1-3)=incident polariz. vector 2 in Target Frame
!       AKSR(1-3,1-NSCAT)=scattering k vectors in Target Frame
!       EM1R(1-3,1-NSCAT)=scattering pol. vector 1 in Target Frame
!       EM2R(1-3,1-NSCAT)=scattering pol. vector 2 in Target Frame

! Purpose:
!       In the Lab Frame, we hold the propagation direction (x-axis)
!       and incident polarization vectors (CXE01 and CXE02) fixed,
!       and rotate target to an orientation specified by the three
!       angles BETA,THETA,PHI.
!       However, computations in the main program DDSCAT are carried out
!       in the Target Frame, in which the target is held fixed and the
!       propagation vectors and polarization vectors are rotated.
!       Hence, this routine computes the incident propagation vector,
!       scattering propagation vectors, and associated polarization
!       vectors in the Target Frame.

! B. T. Draine, Princeton Univ. Obs., 89.11.20
! History:
! 91.04.22 (BTD) Eliminated vector A1R and removed superfluous line
!                computing A1R
! 96.11.03 (BTD) Corrected comments
! 03.06.06 (BTD) Corrected calculation of BETA0,PHI0 -- it appears that
!                these were not correct when a_1z < 0
!                                     and/or a_3x < 0
! 05.03.29 (BTD) Add a few lines of code to guard against possibility
!                that numerical roundoff will cause argument of
!                ACOS to have absolute value > 1.
!                Declare new veriable TERM
! end history

! Copyright (C) 1996,2003,2005 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      PI = 4._WP*ATAN(1._WP)

! Determine initial orientation THETA0,PHI0,BETA0 of target:
! theory:

!     theta = arccos(a_1x)

! if sin(theta) .ne. 0 , then

!     cos(phi)=a_1y/sin(theta)      sin(phi)=a_1z/sin(theta)
!     if(a_1z/sin(theta) > 0) then phi = arccos(a_1y/sin(theta))
!     if(a_1z/sin(theta) < 0) then phi = 2*pi-arccos(a_1y/sin(theta))

!     cos(beta)=-a_2x/sin(theta)    sin(beta)=a_3x/sin(theta)
!     if(a_3x/sin(theta) > 0) then beta = arccos(-a_2x/sin(theta))
!     if(a_3x/sin(theta) < 0) then beta = 2*pi-arccos(-a_2x/sin(theta))

! note: a_3x = a_1y*a_2z - a_1z*a_2y

! if sin(theta) = 0 , then

!     phi = 0

!     cos(beta)=a_2y                sin(beta)=a_2z
!     if(a_2z) > 0)      then      beta = arccos(a_2y)
!     if(a_2z) < 0)      then      beta = 2*pi-arccos(a_2y)

      THETA0 = ACOS(A1(1))
      SINTHE = SIN(THETA0)
      IF (SINTHE/=0._WP) THEN

!-------------------------------
! guard against roundoff errors:
        TERM = A1(2)/SINTHE
        IF (TERM>1._WP) TERM = 1._WP
        IF (TERM<-1._WP) TERM = -1._WP
!-------------------------------

        IF (A1(3)>=0._WP) THEN
          PHI0 = ACOS(TERM)
        ELSE
          PHI0 = 2._WP*PI - ACOS(TERM)
        END IF

!------------------------------
! guard against roundoff errors:
        TERM = -A2(1)/SINTHE
        IF (TERM>1._WP) TERM = 1._WP
        IF (TERM<-1._WP) TERM = -1
!-------------------------------

        IF (A1(2)*A2(3)-A1(3)*A2(2)>=0._WP) THEN
          BETA0 = ACOS(TERM)
        ELSE
          BETA0 = 2._WP*PI - ACOS(TERM)
        END IF
      ELSE
        PHI0 = 0._WP
        IF (A2(3)>=0._WP) THEN
          BETA0 = ACOS(A2(2))
        ELSE
          BETA0 = 2._WP*PI - ACOS(A2(2))
        END IF
      END IF

!**** First rotate the target through angle PHI-PHI0 around x axis
!    (i.e., rotate the lab through angle PHI0-PHI around x axis)
!** obtain rotation matrix:

      VEC(1) = 1._WP
      VEC(2) = 0._WP
      VEC(3) = 0._WP

      CALL ROT2(VEC,PHI0-PHI,RM1)

!**** Now rotate the target through angle THETA-THETA0 around axis
!     VEC = xaxis cross a1
!     (i.e., rotate the lab through angle THETA0-THETA around
!     xaxis cross a1 )
!** first compute rotation axis

      VEC(1) = 0._WP
      VEC(2) = -A1(3)
      VEC(3) = A1(2)

!*** For special case where a1=xaxis, we want rotation axis=a1 cross a2

      IF ((VEC(2)**2+VEC(3)**2)<1.E-10_WP) THEN
        VEC(2) = A1(3)*A2(1) - A1(1)*A2(3)
        VEC(3) = A1(1)*A2(2) - A1(2)*A2(1)
      END IF

      CALL ROT2(VEC,THETA0-THETA,RM2)
      CALL MULT3(RM2,RM1,RM3)

!**** Now rotate the target through angle BETA-BETA0 around a1
!     (i.e., rotate the lab through angle BETA0-BETA around a1)

      CALL ROT2(A1,BETA0-BETA,RM1)
      CALL MULT3(RM1,RM3,RM2)

!**** RM2 is now the full rotation matrix

!**** Now rotate all required vectors:
! Incident propagation vector:

      VEC(1) = 1._WP
      VEC(2) = 0._WP
      VEC(3) = 0._WP

      CALL PROD3(RM2,VEC,EN0R)

! Incident polarization vectors:

      CALL PROD3C(RM2,CXE01,CXE01R)
      CALL PROD3C(RM2,CXE02,CXE02R)

! Scattering vectors:

      CALL PROD3V(RM2,ENSC,AKSR,NSCAT,MXSCA)

      DO I = 1, NSCAT
        AKSR(1,I) = AK1*AKSR(1,I)
        AKSR(2,I) = AK1*AKSR(2,I)
        AKSR(3,I) = AK1*AKSR(3,I)
      END DO

! Scattering polarization vectors:

      CALL PROD3V(RM2,EM1,EM1R,NSCAT,MXSCA)
      CALL PROD3V(RM2,EM2,EM2R,NSCAT,MXSCA)

      RETURN
    END SUBROUTINE ROTATE

      SUBROUTINE TIMEIT(CMSGTM,DTIME)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE
!***********************************************************************
! Subroutine TIMEIT
!
! Given:
!       CMSGTM = string
!
! Returns:
!       If odd-numbered call (first, third, etc.): no input/output:
!       
!       If even-numbered call:
!         * Call WRIMSG to print out CMSGTM and elapsed cpu time since
!           previous call
!         * Return
!           DTIME = elapsed cputime (sec) on
!   
! This version of timeit uses the system call "etime" available under
! Linux, Solaris, and some other bsd-like Unix systems (e.g., Convex unix).
!
!***********************************************************************
! history
! 94.06.20 (PJF) add dtime to the formal parameters
! 95.06.19 (PJF) modified to suppress printing in CMSGTM='noprint'
! 04.04.05 (BTD) changed IF(CMSGTM(1:7).NE.. to IF(CMSGTM.NE..
! 07.07.31 (BTD) rewritten to use f95 intrinsic routine CPU_TIME
! 08.03.14 (BTD) add USE DDPRECISION,ONLY: WP
!                REAL(WP) DTIME
! end history
! Copyright (C) 1993,1994,1995,2004,2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!=======================================================================
      CHARACTER :: CMSGTM*(*)
      REAL(WP) :: DTIME

! External system calls:

!     EXTERNAL CPU_TIME

! Local variables:

      CHARACTER :: CSTA*3,CMSGNM*70
      REAL :: T1,T2

! External subroutines:

      EXTERNAL WRIMSG

! Local variables to be saved:

      SAVE CSTA,T1

! Data statements:

      DATA CSTA/'ONE'/

      IF(CSTA.EQ.'ONE')THEN
         CSTA='TWO'
         CALL CPU_TIME(T1)
      ELSEIF(CSTA.EQ.'TWO')THEN
         CSTA='ONE'
         CALL CPU_TIME(T2)
         DTIME=T2-T1
         IF(CMSGTM.NE.'NOPRINT'.AND.CMSGTM.NE.'noprint')THEN
            WRITE(CMSGNM,FMT='(A,A)')' Timing results for: ',CMSGTM
            CALL WRIMSG('TIMEIT',CMSGNM)
            IF(DTIME.GT.1.E4)THEN
               WRITE(CMSGNM,FMT='(F9.0, A)')DTIME,' = CPU time (sec)'
            ELSE
               WRITE(CMSGNM,FMT='(F9.3, A)')DTIME,' = CPU time (sec)'
            ENDIF
            CALL WRIMSG('TIMEIT',CMSGNM)
         ENDIF
      ENDIF
      RETURN
      END

    SUBROUTINE TARPBXN(A1,A2,XD,YD,XS2,XS3,YS,ZS,DX,X0,CDESCR,IOSHP, &
                       MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL(WP) :: XD,XS2,XS3,YD,YS,ZS
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 :: &
         ICOMP(MXNAT,3)
      INTEGER :: &
         IXYZ(MXNAT,3)
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local variables:

      INTEGER :: JA,JX,JXMAX,JXMAX1,JXMAX2,JXMIN,JXMIN1,JXMIN2,        &
                 JY,JYMAX,JYMIN,JZ,JZMAX,JZMIN,NATD,NATS1,NATS2,NX,NY,NZ
      REAL(WP) :: R2,Y,Y2,Z,Z2
      CHARACTER :: CMSGNM*70

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:

!***********************************************************************
! subroutine TARPBXN
! Purpose: to construct "pillbox" target: disk on top of a bilayer slab
!          disk has composition 1
!          slab has compositions 2 and 3: 2 above, 3 below
!          disk-slab interface is in the y-z plane (x=0) (in TF)
!          disk symmetry axis is in x-direction (in TF)
! Input:
!        XD=(disk thickness)/d
!        YD=(disk diameter)/d
!        XS2=(x thickness of composition 2 of slab)/d   (d=lattice spacing)
!        XS3=(x thickness of composition 3 of slab)/d   
!        YS=(y length of slab)/d
!        ZS=(z length of slab)/d
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Frame
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Frame
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        X0(1-3)=offset vector, such that
!                x/d=IXYZ(J,1)+X0(1)
!                y/d=IXYZ(J,2)+X0(2)
!                z/d=IXYZ(J,3)+X0(3)
!                where (x,y,z)=location of dipole in Target Frame
!                with (0,0,0)=point where axis of disk
!                             intersects upper surface of slab
!                             upper surface of slab is assumed to
!                             located 0.5*d above dipoles defining slab

! Target consists of a rectangular slab of composition 1
!        extent XS x YS x ZS
!        center of upper surface of slab is at (0,0,0)
!        upper surface of slab is in the x=0 plane
!        lower surface of slab is in the x=-XS plane
!        slab runs from -XS   to 0
!                       -YS/2 to +YS/2
!                       -ZS/2 to +ZS/2
!        plus a disk of composition 2, diameter YD, thickness XD
!        with symmetry axis in x direction
!        centroid of disk located at (XD/2,0,0)

!        XS2,XS3,YS,ZS should ideally be integers
!        if YS is even, lattice will be located at y = +/-0.5, +/-1.5, .
!                 odd                              y = 0, +/-1, +/-2, ..
!        if ZS is even, lattice will be located at z = +/-0.5, +/-1.5, .
!                 odd                              z = 0, +/-1, +/-2, ..

! B.T.Draine, Princeton Univ. Obs.
! History:
! 06.12.08 (BTD) first written for collaboration with Ward Johnson and
!                Zhandos Utegulov (NIST, Boulder Colorado).
! 07.01.17 (BTD) modified to center pillbox on slab
! 07.01.18 (BTD) dimensions not quite right: fix
! 07.06.19 (BTD) major modification
!                * add X0(1-3) to argument list
!                * different lattice offset for YS even or odd
!                * different lattice offset for ZS even or odd
!                * revamp procedure for choosing dipoles
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER
! 07.10.26 (BTD) major modification
!                * now allow one or two layers in slab
!                * changed argument list
! 07.10.30 (BTD) renamed XS2->XS3,XS1->XS2
!                reordered argument list
! 08.01.13 (BTD) cosmetic changes
! end history

! Copyright (C) 2006,2007,2008
!               B.T. Draine and P.J. Flatau

! This code is covered by the GNU General Public License.
!***********************************************************************
!***********************************************************************
      IF(XS2.GT.0._WP.AND.XS3.GT.0._WP)THEN
         WRITE(CMSGNM,FMT='(A)')' Two-layer slab+disk'
         WRITE(CDESCR,FMT='(A)')' Two-layer slab+disk'
      ELSE
         WRITE(CMSGNM,FMT='(A)')' Slab+disk'
         WRITE(CDESCR,FMT='(A)')' Slab+disk'
      ENDIF

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in Target Frame
!             A2 will be (0,1,0) in Target Frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! Target reference point =intersection of disk axis with upper surface
! of slab: (x,y,z)=(0,0,0) in Target Frame

! Set lattice offset in x direction:
! Dipole with IX=0 is located at x/d=0.5

      X0(1)=0.5_WP

! Determine lattice offset in y and z directions
!   if NY is even, dipole with IY=0 is located at y/d=0.5
!            odd                                      0
!   if NZ is even, dipole with IZ=0 is located at z/d=0.5
!            odd                                      0

      NY=NINT(YS)
      IF(MOD(NY,2)==0)THEN
         X0(2)=0.5_WP
      ELSE
         X0(2)=0._WP
      ENDIF

      NZ=NINT(ZS)
      IF(MOD(NZ,2)==0)THEN
         X0(3)=0.5_WP
      ELSE
         X0(3)=0._WP
      ENDIF

! Now populate lattice:

      NAT=0

! First do the pillbox (material 1)
! disk axis is in x direction
! XD=thickness
! YD=diameter

      NX=NINT(XD)

      JXMIN=0
      JXMAX=NX-1

      JYMIN=NINT(-0.5_WP*YD-X0(2))
      JYMAX=NINT(0.5_WP*YD-X0(2))
      JZMIN=NINT(-0.5_WP*YD-X0(3))
      JZMAX=NINT(0.5_WP*YD-X0(3))

      R2=(0.5_WP*YD)**2

!*** diagnostic
!      write(0,*)'disk: jx runs from ',jxmin,' to ',jxmax
!      write(0,*)'     diameter yd=',yd
!      write(0,*)'jymin,jymax=',jymin,jymax
!      write(0,*)'jzmin,jzmax=',jzmin,jzmax
!***
      DO JY=JYMIN,JYMAX
         Y=JY+X0(2)
         Y2=Y**2
         DO JZ=JZMIN,JZMAX
            Z=JZ+X0(3)
            Z2=Z**2
            IF(Y2+Z2<R2)THEN
!*** diagnostic
!               write(0,*)'disk: jy,jz=',jy,jz
!***
               DO JX=JXMIN,JXMAX
                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','TARPBX',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDDO
            ENDIF
         ENDDO
      ENDDO
      NATD=NAT
      DO JX=1,3
         DO JA=1,NATD
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

! completed definition of disk
! begin definition of slab
! layer 1: extends from     -xs1   to  0         [composition 2]
!          dipoles from    JXMIN1  to -1
! layer 2: extends from -(xs1+xs2) to -xs1       [composition 3]
!          dipoles from   JXMIN2   to (JXMIN1-1)

      JYMIN=NINT(-0.5_WP*YS-X0(2))
      JYMAX=NINT(0.5_WP*YS-X0(2))
      JZMIN=NINT(-0.5_WP*ZS-X0(3))
      JZMAX=NINT(0.5_WP*ZS-X0(3))

      JXMIN2=-NINT(XS2+XS3)
      JXMAX2=-NINT(XS2)-1
      JXMIN1=-NINT(XS2)
      JXMAX1=-1

! layer 1 = composition 2:
!*** diagnostic
!      write(0,*)'slab layer 1 runs from ',jxmin1,' to ',jxmax1
!***
      IF(JXMIN1.LE.JXMAX1)THEN
         DO JX=JXMIN1,JXMAX1
            DO JY=JYMIN,JYMAX
               IF(ABS(REAL(JY)+X0(2))<0.5_WP*YS)THEN
                  DO JZ=JZMIN,JZMAX
                     IF(ABS(REAL(JZ)+X0(3))<0.5_WP*ZS)THEN
                        NAT=NAT+1
                        IF(NAT>MXNAT)THEN
                           CALL ERRMSG('FATAL','TARPBX',' NAT.GT.MXNAT ')
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
         DO JX=1,3
            DO JA=NATD+1,NAT
               ICOMP(JA,JX)=2
            ENDDO
         ENDDO
      ENDIF
      NATS1=NAT-NATD

      IF(JXMIN2.LE.JXMAX2)THEN
!*** diagnnostic
!         write(0,*)'slab lower layer runs from ',jxmin2,' to ',jxmax2
!***
         DO JX=JXMIN2,JXMAX2
            DO JY=JYMIN,JYMAX
               IF(ABS(REAL(JY)+X0(2))<0.5_WP*YS)THEN
                  DO JZ=JZMIN,JZMAX
                     IF(ABS(REAL(JZ)+X0(3))<0.5_WP*ZS)THEN
                        NAT=NAT+1
                        IF(NAT>MXNAT)THEN
                           CALL ERRMSG('FATAL','TARPBX',' NAT.GT.MXNAT ')
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
         DO JX=1,3
            DO JA=NATD+NATS1+1,NAT
               ICOMP(JA,JX)=3
            ENDDO
         ENDDO
      ENDIF
      NATS2=NAT-NATS1

      IF(NATS1*NATS2>0)THEN
         WRITE(CMSGNM,FMT='(A,I7,A)')                              &
                       ' Bilayer slab+disk with NAT=',NAT,' dipoles'
      ELSE
         WRITE(CMSGNM,FMT='(A,I7,A)')' Slab+disk with NAT=',NAT,' dipoles'
      ENDIF
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XS2,XS3,YS,ZS,NAT,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
!*** diagnostic/sanity check
!      jxmin=ixyz(1,1)
!      jxmax=ixyz(1,1)
!      do ja=2,nat
!         if(ixyz(ja,1)<jxmin)jxmin=ixyz(ja,1)
!         if(ixyz(ja,1)>jxmax)jxmax=ixyz(ja,1)
!      enddo
!      write(0,*)'ckpt 1 in tarpbxn: jxmin= ',jxmin,' jxmax= ',jxmax
!***
      RETURN
9020  FORMAT(' >TARPBXN : slab+disk; XS2,XS3,YS,ZS=',4F8.4,/,      &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARPBXN

    FUNCTION P_LM(L,M,X)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! arguments

      INTEGER :: L,M
      REAL(WP) :: P_LM,X

! local variables

      CHARACTER :: CMSGNM*70
      INTEGER :: I,LL
      REAL(WP) :: FACT,ONE,PLL,PMM,PMMP1,SINTH,TWO

!-----------------------------------------------------------------------
! FUNCTION P_LM  = Associated Legendre polynomial P_{lm}(x=cos(theta))
! given:
!    L,M
!    X
! returns:
!    P_LM = P_lm(x)
!             associated Legendre polynomial
! this routine follows closely the structure of function PLGNDR 
! described in section 6.6 of "Numerical Recipes", by Press, W.H.,
! Flannery, B.P., Teukolsky, S.A., and Vetterling, W.T. (1986, Cambridge
! Univ. Press).
!
! Modifications by B.T. Draine, Princeton Univ. Observatory
! history
! 02.11.12 (BTD) first written
! 04.03.31 (BTD) changed WRITE(0 to CALL WRIMSG(
! 07.08.06 (BTD) converted to f90
! end history
!-----------------------------------------------------------------------
      ONE=1._WP
      TWO=2._WP
      PMM=ONE
      IF(M>0)THEN
         SINTH=SQRT(ONE-X*X)
         FACT=ONE
         DO I=1,M
            PMM=PMM*FACT*SINTH
            FACT=FACT+TWO
         ENDDO
      ELSEIF(M<0.OR.M>=L)THEN
         WRITE(CMSGNM,'(A)')' Fatal error in P_LM: M=',M,' < 0'
         CALL WRIMSG(' P_LM ',CMSGNM)
         STOP
      ENDIF

      IF(L==M)THEN
         P_LM=PMM
      ELSE
         PMMP1=X*REAL(2*M+1)*PMM
         IF(L==M+1)THEN
            P_LM=PMMP1
         ELSE
            DO LL=M+2,L
               PLL=(X*REAL(2*LL-1)*PMMP1-REAL(LL+M-1)*PMM)/REAL(LL-M)
               PMM=PMMP1
               PMMP1=PLL
            ENDDO
            P_LM=PLL
         ENDIF
      ENDIF
      RETURN
      END

    SUBROUTINE TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,X0,IPRINAX,IOSHP, &
        CDESCR,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: BLKSIZ,IPRINAX,NBLOCKS,IOSHP,MXNAT,NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      INTEGER :: XYZB(3,100)
      REAL(WP) :: & 
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)
      CHARACTER :: CDESCR*67

! Local variables:

      INTEGER :: J,JB,JD,JJX,JJY,JJZ,JOFF,JOFFX,JOFFY,JOFFZ,JX,JY,JZ
      REAL(WP) :: EIGVAL(3)

!***********************************************************************

! Subroutine to construct a target out of "cubic" blocks.
! Blocks are only cubic for case of a cubic lattice DX=(1.,1.,1.)
! In case of a noncubic lattice, "blocks" are rectangular, with an equal
! number (=BLKSIZ) of dipole spacings in each direction.

! Given:
! DX(1-3)     =(dx/d,dy/d,dz/d) where dx,dy,dz = x,y,z lattice spacing,
!              and d = (dx*dy*dz)**(1/3) = effective lattice spacing
! NBLOCKS     =number of cubic blocks in target
! BLKSIZ      =(integer) ratio of block width/dipole spacing
!              (there will be BLKSIZ**3 dipoles per block)
! XYZB(1-3,J) =x,y,z coordinates of block J, in units of block width
! IPRINAX     =0. to return A1=(1,0,0), A2=(0,1,0)
!             =1. to return A1,A2=principal axes with largest, 2nd large
!              moment of inertia
! IOSHP       =device number for output file "target.out"
!             =-1 to suppress generation of file "target.out"
! MXNAT       =limit on largest allowed value of NAT=number of dipoles

! Returns:
! NAT         =number of dipoles in target
! IXYZ(J,1-3) =x,y,z location of dipole J on lattice
! ICOMP(J,1-3)=composition for dipole J; x,y,z directions
! A1(1-3)     =principal axis A1 in target frame (normalized)
! A2(1-3)     =principal axis A2 in target frame (normalized)
! X0(1-3)     =location in TF of dipole with IXYZ=0 0 0
!              TF origin is taken to be at centroid of target
! CDESCR      =string describing target

! where A1 = principal axis with largest moment of inertia
!       A2 = principal axis with second-largest moment of inertia

! B.T. Draine, Princeton Univ. Observatory, 95.12.11
! History:
! 96.01.02 (BTD) modified to compute eigenvalues and eigenvectors of
!                moment of inertia tensor, and to define vectors A1 and
!                A2 to be along eigenvectors with largest and second
!                largest eigenvalues, respectively.
! 96.01.26 (BTD) Replaced IX,IY,IZ by IXYZ
!                Removed principal axis calculation to separate
!                subroutine PRINAXIS
! 96.01.29 (BTD) Added variable IPRINAX to allow control over definition
!                of axes A1,A2
! 96.02.23 (BTD) Remove computation of principal axes and eigenvalues
!                as this is now carried out by routine PRINAXIS.
! 97.12.26 (BTD) Add DX(3) to argument list to support nonuniform
!                lattice spacing.
!                Add DX to argument list of PRINAXIS.
! 98.03.07 (BTD) Add DX to file target.out for compatibility with
!                new version of REASHP
! 03.11.06 (BTD) Modified to use new version of PRINAXIS with eigenvalue
!                in argument list
! 04.03.19 (BTD) Revert to previous version of PRINAXIS
! 04.05.23 (BTD) Added EIGVAL to argument list of PRINAXIS to conform
!                to change in PRINAXIS
! 07.09.11 (BTD) Changed IXYZ from INTEGER*2 to INTEGER
! 08.08.08 (BTD) Add X0(3) to argument list
!                Add code to define X0
! 08.08.29 (BTD) Modified format 9020
! End history.
! Copyright (C) 1996,1997,1998,2003,2004,2007,2008 
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! For the moment, let us assume that blocks do not overlap.

      JOFF=1-((BLKSIZ+1)/2)
      JD=0
      DO JB=1,NBLOCKS
         JOFFX=JOFF+BLKSIZ*XYZB(1,JB)
         JOFFY=JOFF+BLKSIZ*XYZB(2,JB)
         JOFFZ=JOFF+BLKSIZ*XYZB(3,JB)
         DO JX=1,BLKSIZ
            JJX=JX+JOFFX
            DO JY=1,BLKSIZ
               JJY=JY+JOFFY
               DO JZ=1,BLKSIZ
                  JJZ=JZ+JOFFZ
                  JD=JD+1
                  IXYZ(JD,1)=JJX
                  IXYZ(JD,2)=JJY
                  IXYZ(JD,3)=JJZ

! Homogeneous target:

                  ICOMP(JD,1)=1
                  ICOMP(JD,2)=1
                  ICOMP(JD,3)=1
               ENDDO
            ENDDO
         ENDDO
      ENDDO
      NAT=JD

      DO J=1,3
         X0(J)=0._WP
         DO JD=1,NAT
            X0(J)=X0(J)+REAL(IXYZ(JD,J),KIND=WP)
         ENDDO
! Set value of X0:
         X0(J)=-X0(J)/REAL(NAT,KIND=WP)
      ENDDO

      IF(IPRINAX/=0)THEN

! Call PRINAXIS to compute principal axes

         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      ELSE

! Do not compute principal axes: simply set
! a1=(1,0,0) and a2=(0,1,0) in target frame.

         A1(1)=1._WP
         A1(2)=0._WP
         A1(3)=0._WP
         A2(1)=0._WP
         A2(2)=1._WP
         A2(3)=0._WP
      ENDIF

!***********************************************************************
! Write target description into string CDESCR
! Note: this will replace whatever CDESCR was read in from the
! 'blocks.par' file. If you want to retain that description,
! then comment out the following statement:
!      WRITE(CDESCR,FMT='(A,I7,A,I3,A)')'Target containing',
!     &      NAT,' dipoles arranged in ',NBLOCKS,' cubic blocks'
!***********************************************************************

      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARBLOCKS: cubic building blocks',/,              &
         I9,' = NAT',/,                                           &
         3F9.4,' = A_1 vector',/,                                 &
         3F9.4,' = A_2 vector',/,                                 &
         3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F9.6,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                              &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARBLOCKS

    SUBROUTINE CXFFTW(CX,MX,MY,MZ,ISIGN)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: ISIGN, MX, MY, MZ
      COMPLEX (WP) :: CX(MX,MY,MZ)

! Local variables:

      CHARACTER :: CMSGNM*70

!***********************************************************************

! Purpose: This is a dummy routine to substitute for CXFFTW to allow
!          DDSCAT to be used on systems where the FFTW package has not
!          been installed.  If called, it will generate a fatal error
!          with an error message reporting DDSCAT has been compiled
!          with this dummy routine and option FFTW is unavailable.

! History:
! 00.07.05 (BTD): created
! 03.07.13 (BTD): changed option FFTWFJ to option FFTW21
! 04.03.31 (BTD): replaced WRITE(0,  with CALL WRIMSG(...
! end history
! Copyright (C) 2000, 2003
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.

!***********************************************************************

      WRITE (CMSGNM,FMT='(A,A)') &
        'FATAL ERROR: DDSCAT has been compiled with dummy version of', &
        ' CXFFTW'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A)') &
        ' *** option FFTW21 cannot be used with dummy routine'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A)') &
        ' *** to enable option FFTW21 it is necessary to:'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A)') &
        ' --- have fftw 2.1.x library installed on system'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A,A)') &
        ' --- in Makefile, variable LIBFFTW should include ', &
        'correct path to libsfftw.a'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A,A)') ' --- in Makefile, define cxfftw = cxfftw', &
        ' (rather than dummycxfftw.f)'
      CALL WRIMSG('CXFFTW',CMSGNM)
      WRITE (CMSGNM,FMT='(A)') ' --- then make ddscat'
      CALL WRIMSG('CXFFTW',CMSGNM)
      STOP
    END SUBROUTINE CXFFTW

    SUBROUTINE PBCSCAVEC(MXSCA,JPBC,NSCAT,PYDDX,PZDDX,A1,A2,THETA,BETA,    &
                         XLR,YLR,ZLR,AK1,EN0R,CXE01R,ORDERM,ORDERN,THETAN, &
                         PHIN,AKSR,EM1R,EM2R,ENSC,EM1,EM2)
! --------------------------------- v4 ------------------------------------
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
      INTEGER :: JPBC,MXSCA,NSCAT
      REAL(WP) :: AK1,BETA,THETA,PYDDX,PZDDX
      REAL(WP) ::      &
        A1(3),         &
        A2(3),         &
        AKSR(3,MXSCA), &
        EM1(3,MXSCA),  &
        EM2(3,MXSCA),  &
        EM1R(3,MXSCA), &
        EM2R(3,MXSCA), &
        EN0R(3),       &
        ENSC(3,MXSCA), &
        ORDERM(MXSCA), &
        ORDERN(MXSCA), &
        PHIN(MXSCA),   &
        THETAN(MXSCA), &
        XLR(3),        &
        YLR(3),        &
        ZLR(3)
      COMPLEX(WP) :: &
        CXE01R(3)

! local variables:

      INTEGER :: J,JR,JT,K
      REAL(WP) :: AK2,AKPERP,AKPERP0,AKPERP2,                &
                  COSALPHAI,COSPHI,COSTHETA,DENOM,PI,SINALPHAI,SINPHI,SUM
      REAL(WP) :: &
        EM01R(3)

!-----------------------------------------------------------------------
! subroutine PBCSCAVEC
! given:

!     JPBC = 1 for target periodic in y_TF only (PZD=0)
!            2                        z_TF only (PYD=0)
!            3                        both y_TF and z_TF

!     MXSCA = dimensioning information
!     PYDDX = periodicity in y direction/d
!     PZDDX = periodicity in z direction/d
!     A1(3) = target axis a1 in TF (TF = Target Frame)    [**NOT USED**]
!     A2(3) = target axis a2 in TF                        [**NOT USED**]
!     THETA = rotation angle (rad) of a1 relative to x_LF
!     BETA  = rotation angle (rad) of target around axis a1
!     XLR(3)= unit vector xlab in TF = direction of incident radiation
!     YLR(3)= unit vector ylab in TF
!     ZLR(3)= unit vector zlab in TF

!     AK1   = k*d in vacuo
!     NSCAT = number of scattering directions
!     EN0R(1-3) = unit vector in incident wave direction in TF
!     CXE01R(1-3) = (complex) incident pol.vector 1 in TF
!     ORDERM(1-NSCAT)=diffraction order in y_TF direction if JPBC=1 or 3
!                                       in z_TF direction if JPBC=2
!     ORDERN(1-NSCAT)=rotation angle (rad) around scattering cone if
!                     JPBC=1 or 2
!                    =diffraction order in z_TF direction if JPBC=3

! returns:

!     AKSR(3,1-NSCAT) = scattering vectors in TF
!     EM1R(3,1-NSCAT) = scattered polarization vector parallel to
!                       scattering plane in TF
!     EM2R(3,1-NSCAT) = scattered polarization vector perpendicular to
!                       scattering plane in TF
!     ENSC(3,1-NSCAT) = scattering unit vectors in Lab Frame
!     EM1(3,1-NSCAT)  = scattered polarization vector parallel to
!                       scattering plane in LF
!     EM2(3,1-NSCAT)  = scattered polarization vector perpendicular to
!                       scattering plane in LF
! if JPBC=1 or 2:
!     THETAN(1-NSCAT) = alpha_s (rad) in TF
!     PHIN(1-NSCAT)   = zeta_s (rad) in TF

! where the scattering directions are determined as follows:

! if JPBC=1:
!    input ORDERM(J) = scattering order for y (integer)
!          ORDERN(J) = azimuthal angle zeta (radians) around y_TF 
!                      where ORDERM=0 and zeta=0 for forward scattering
!    computes THETAN(J) = angle between k_s and y_TF
!             PHIN(J)   = azimuthal angle zeta (radians)

! if JPBC=2:
!    input ORDERM(J) = scattering order for z (integer)
!          ORDERN(J) = azimuthal angle zeta (radians) around z_TF 
!                      where ORDERM=0 and zeta=0 for forward scattering
!    computes THETAN(J) = angle between k_s and z_TF
!             PHIN(J)   = azimuthal angle zeta (radians)

! if JPBC=3:
!    input ORDERM(J) = scattering order for y (integer)
!          ORDERN(J) = scattering order for z (integer)
!                      where ORDERM=0 and ORDERM=0 for forward scattering
!
!     NSCAT is even: each scattering order (M,N) appears twice:
!                    first for transmission, later for reflection
!                    (this is established in REAPAR)
!       J = 1         -> NSCAT/2 correspond to transmission
!       J = NSCAT/2+1 -> NSCAT   correspond to reflection

!     computes THETAN(J) = angle (rad) between k_s and x_TF
!              PHIN(J)   = azimuthal angle (around x_TF)
!                          k_sx=k_s*cos(thetan)
!                          k_sy=k_s*sin(thetan)*cos(phin)
!                          k_sz=k_s*sin(thetan)*sin(phin)
!
!     in special case of zeroth-order transmission, the angle
!     THETAN(J)=0, and the angle PHIN(J) is taken to be the
!     same as for (0,0) reflection.
!     In the special case of (0,0) normal incidence, where k_sy=k_sz=0,
!     we set PHIN=0 

! B.T. Draine, Princeton University Observatory, 2006.10.08
! history
! 06.10.08 (BTD) First written
! 06.10.13 (BTD) fixed bug when JPBC=2
!                added fatal error warning
! 06.10.13 (BTD) added new arguments ORDERM,ORDERN
!                to preserve scattering order information
!                as orientation is changed
! 06.10.14 (BTD) added code to guard against numerical problem
!                evaluating angle PHIN when incident radiation is
!                normal (or near-normal) to target axis (for JPBC=1 or
!                2) or target plane (for JPBC=3)
!                Now treat near-normal as exactly normal when
!                calculating angle PHIN
! 06.12.28 (BTD) corrected error in computation of unit scattered pol.
!                vector in special cases
!                added arrays XLR,YLR,ZLR to argument list
!                use XLR,YLR,ZLR in defining unit pol vectors in special
!                case of scattering angle theta = 0 or pi (in which
!                case scattering plane is not uniquely defined).
! 07.01.20 (BTD) corrected bug in assignment of transmitted/reflected
!                unit vectors when JPBC=3 (2-d periodic target)
! 07.06.22 (BTD) modified so that azimuthal angle = 0 for forward
!                scattering when JPBC=1 or 2
!                introduce new variable AKP1(1-3) and AKP2(1-3)
!                revise calculation of THETAN(J) and PHIN(J) for the
!                JPBC=1, 2, and 3
! 07.06.28 (BTD) corrected error in computation of AKSR when JPBC=1 or 2
!                and incident radiation is not perpendicular to
!                periodicity direction.
! 07.07.01 (BTD) corrected error in computation of EM1R
! 07.07.08 (BTD) added EM1,EM2 to argument list
!                added code to compute EM1,EM2
! 07.10.03 (BTD) corrected error in computation of angle PHIN(J) when 
!                JPBC=3
! 07.10.04 (BTD) corrected error in evalation of AKPERP when JPBC=3
! 07.10.06 (BTD) modified handling of JPBC=3:
!                * use (0,0) reflection to establish PHIN(J) for (0,0)
!                  transmission
!                * in case of (0,0) and normal incidence,
!                  set PHIN(J)=0
! 07.10.07 (BTD) * added THETA,BETA to argument list
!                * rewrote treatment of JPBC=1 and 2
! 08.01.02 (BTD) v2 Revised code to calculate scattered pol vectors
!                   when JPBC=3:
! 08.01.03 (BTD) v2 Another major revision for JPBC=3 case
! 08.01.10 (BTD) v3 Revised treatment for JPBC=3 to conform to
!                   Bohren & Huffman convention for ehat_{spar}
!                   and ehat_{sperp}
! 08.04.09 (BTD) v4 Revised creation of scattering vectors for JPBC=1 or 2
! 08.06.30 (BTD) v4 Fixed bug in determining PHIN for special case
!                   THETA=0.
! end history
!-----------------------------------------------------------------------
!      write(0,*)'pbcscavec ckpt 0, en0r(1-3)=',en0r

      PI=4._WP*ATAN(1._WP)

! for use in this module, define
! EM01R = unit polarization vector for incident polarization state 1 in TF
! AK2 = |kd|^2

      DO K=1,3
         EM01R(K)=REAL(CXE01R(K))
      ENDDO
      SUM=SQRT(EM01R(1)**2+EM01R(2)**2+EM01R(3)**2)
      DO K=1,3
         EM01R(K)=EM01R(K)/SUM
      ENDDO
      AK2=AK1*AK1

      IF(JPBC==1)THEN

! JPBC=1 : target periodic in y_TF direction
!       -> input ORDERM = diffraction order in y_TF direction
!                ORDERN = azimuthal angle around y_TF axis
!                         with ORDERN=0 for forward scattering

!         write(0,*)'pbcscavec ckpt 1'

         AKPERP0=AK1*SQRT(EN0R(1)**2+EN0R(3)**2)
         DO J=1,NSCAT
            AKSR(2,J)=AK1*EN0R(2)+ORDERM(J)*2._WP*PI/PYDDX
            IF(ABS(AKSR(2,J))<=AK1)THEN
               PHIN(J)=ORDERN(J)
               THETAN(J)=ACOS(AKSR(2,J)/AK1)
               AKPERP=SQRT(AK2-AKSR(2,J)**2)
               AKSR(3,J)=(AKPERP/AKPERP0)*AK1*                     &
                         (EN0R(3)*COS(PHIN(J))-EN0R(1)*SIN(PHIN(J)))
               AKSR(1,J)=(AKPERP/AKPERP0)*AK1*                     &
                         (EN0R(1)*COS(PHIN(J))+EN0R(3)*SIN(PHIN(J)))
            ELSE
               CALL ERRMSG('FATAL','PBCSCAVEC','invalid diffraction order')
            ENDIF
         ENDDO

      ELSEIF(JPBC==2)THEN

! JPBC=2 : target periodic in z direction
!       -> input ORDERM = diffraction order in z_TF direction
!                ORDERN = azimuthal angle around z_TF axis
!                         with ORDERN=0 for forward scattering

!         write(0,*)'pbcscavec ckpt 2'

         AKPERP0=AK1*SQRT(EN0R(1)**2+EN0R(2)**2)
         DO J=1,NSCAT
            AKSR(3,J)=AK1*EN0R(3)+ORDERM(J)*2._WP*PI/PZDDX
            IF(ABS(AKSR(3,J))<=AK1)THEN
               PHIN(J)=ORDERN(J)
               THETAN(J)=ACOS(AKSR(3,J)/AK1)
               AKPERP=SQRT(AK2-AKSR(3,J)**2)
               AKSR(1,J)=(AKPERP/AKPERP0)*AK1*                     &
                         (EN0R(1)*COS(PHIN(J))-EN0R(2)*SIN(PHIN(J)))
               AKSR(2,J)=(AKPERP/AKPERP0)*AK1*                     &
                         (EN0R(2)*COS(PHIN(J))+EN0R(1)*SIN(PHIN(J)))
            ELSE
               CALL ERRMSG('FATAL','PBCSCAVEC','invalid diffraction order')
            ENDIF
         ENDDO

!         write(0,*)'pbcscavec ckpt 2.5'

      ELSEIF(JPBC==3)THEN

! JPBC=3 : infinite and periodic in y and z directions
!       -> input ORDERM = diffraction order in y_TF direction
!                ORDERN = diffraction order in z_TF direction
!          NSCAT is assumed to be an even number (this is set by
!                subroutine REAPAR)
!          every (M,N) case appears twice: 
!             first for transmission (directions J = 1 -> NSCAT/2)
!             then for reflection (directions J = NSCAT/2+1 -> NSCAT)
!          EN0R(1-3) = components of unit vector for incident direction
!                      in TF
!          calculate
!             AKSR(1-3,J) = scattered vector in TF for J=1,NSCAT
!             THETAN(J)   = angle between k_s and x_TF
!             PHIN(J)     = azimuthal angle in TF
!             where  k_sx = k_s*cos(thetan)
!                    k_sy = k_s*sin(thetan)*cos(phin)
!                    k_sz = k_s*sin(thetan)*sin(phin)
!             Note: for special case k_sy=k_sz=0, we set phin=0

!         write(0,*)'pbcscavec ckpt 3'

         DO JT=1,NSCAT/2
            JR=NSCAT/2+JT
            AKSR(2,JT)=AK1*EN0R(2)+ORDERM(JT)*2._WP*PI/PYDDX
            AKSR(3,JT)=AK1*EN0R(3)+ORDERN(JT)*2._WP*PI/PZDDX
            AKSR(2,JR)=AKSR(2,JT)
            AKSR(3,JR)=AKSR(3,JT)
            AKPERP2=AKSR(2,JR)**2+AKSR(3,JR)**2
!*** diagnostic
!            write(0,*)'pbcscavec ckpt 3.1, jt=',jt
!            write(0,*)'                    aksr(2,jt)=',aksr(2,jt)
!            write(0,*)'                    aksr(3,jt)=',aksr(3,jt)
!***
            IF(AKPERP2<=AK2)THEN
               AKSR(1,JT)=SIGN(SQRT(AK2-AKPERP2),EN0R(1))
               AKSR(1,JR)=-AKSR(1,JT)
!*** diagnostic
!               write(0,*)'pbcscavec ckpt 3.2'
!
               THETAN(JT)=ACOS(AKSR(1,JT)/AK1)
!*** diagnostic
!               write(0,*)'pbcscavec ckpt 3.3'
!               write(0,*)'          aksr(1,jr)=',aksr(1,jr)
!               write(0,*)'                 ak1=',ak1
!
               THETAN(JR)=ACOS(AKSR(1,JR)/AK1)
!*** diagnostic
!               write(0,*)'pbcscavec ckpt 3.31, thetan(jr)=',thetan(jr)
!
               AKPERP=SQRT(AKPERP2)
               IF(AKPERP.GT.0._WP)THEN
                  COSPHI=AKSR(2,JT)/AKPERP
                  SINPHI=AKSR(3,JT)/AKPERP
                  IF(SINPHI<0._WP)THEN
                     PHIN(JT)=2._WP*PI-ACOS(COSPHI)
                  ELSE
                     PHIN(JT)=ACOS(COSPHI)
                  ENDIF
               ELSE
                  PHIN(JT)=0._WP
               ENDIF
!*** diagnostic
!               write(0,*)'pbcscavec ckpt 3.34'
!
               PHIN(JR)=PHIN(JT)
            ELSE
               CALL ERRMSG('FATAL','PBCSCAVEC','invalid diffraction order')
            ENDIF
!*** diagnostic
!            write(0,*)'pbcscavec ckpt 3.4'
!
         ENDDO ! end loop over JT

!*** diagnostic
!         write(0,*)'pbcscavec ckpt 3.5'
!
      ELSE
         CALL ERRMSG('FATAL','PBCSCAVEC',' invalid value of JPBC')
      ENDIF

!=======================================================================

! scattering directions AKSR are now defined.
! For each transmission direction that is not either parallel or 
! antiparallel to the incident beam there is a scattering plane defined
! by vectors k_0 and k_s.
! Construct unit vector for scattered polarization
! parallel to plane (EM1R) and perpendicular to plane (EM2R)
! We adopt convention of Bohren & Huffman 1984 sec 3.2 for
! unit vectors parallel and perpendicular to the scattering plane:
!   em1 = ehat_{para,s} is in direction of increasing scattering angle theta
!   em2 = ehat_{perp,s} = ehat_{para,s} cross khat_s

! For special case of |k_s cross k_0| = 0  
!   (i.e., k_s dot k_0 = +/- |k_0|^2 , or k_s = +/- k_0: 
!   forward scattering or 180deg backscattering):
!   Let k_sperp = component of k_s perpendicular to target normal
!   If |k_sperp| = 0, then incident and scattered rays are normal
!                     to target.  For this special case, let
!                     
!                     ehat_spar =  ehat_01
!                     ehat_sperp = ehat_spar cross khat_s
!                               
!   If |k_s cross k_0} > 0, then
!                                k_s cross k_0 
!                     e_sperp = ---------------
!                               |k_s cross k_0|
!
! For all cases, we take:
!                     e_iperp = e_sperp
!                     e_iparr = (k_0 cross e_iperp) / |k_0|
!                     e_sparr = (k_s cross e_sperp) / |k_s|

! Here we evaluate em1r(1-3,J) = (x,y,z) components of e_sparr in TF
!                  em2r(1-3,J) = (x,y,z) components of e_sperp in TF

!*** diagnostic
!      write(0,*)'pbcscavec ckpt 4'
!
      DO J=1,NSCAT

! determine which case we have

         COSTHETA=0._WP
         DO K=1,3
            COSTHETA=COSTHETA+AKSR(K,J)*EN0R(K)
         ENDDO
         COSTHETA=COSTHETA/AK1

         IF(ABS(COSTHETA).LE.0.9999_WP)THEN

! scattering angle is neither zero nor pi
! scattering plane is therefore defined by k_0 and k_s
! obtain EM2R(1-3,J) = components of em2 = (ks cross k0)/|ks cross k0|= in TF

!*** diagnostic
!            write(0,*)'pbcscavec ckpt 5'
!

            EM2R(1,J)=(AKSR(2,J)*EN0R(3)-AKSR(3,J)*EN0R(2))
            EM2R(2,J)=(AKSR(3,J)*EN0R(1)-AKSR(1,J)*EN0R(3))
            EM2R(3,J)=(AKSR(1,J)*EN0R(2)-AKSR(2,J)*EN0R(1))
            DENOM=SQRT(EM2R(1,J)**2+EM2R(2,J)**2+EM2R(3,J)**2)
            DO K=1,3
               EM2R(K,J)=EM2R(K,J)/DENOM
            ENDDO

!*** diagnostic
!            if(j<=20)then
!            write(0,9970)j,sum,aksr(1,j),aksr(2,j),aksr(3,j),en0r,     &
!                         ak1,em1r(1,j),em1r(2,j),em1r(3,j),            &
!                         sqrt(em1r(1,j)**2+em1r(2,j)**2+em1r(3,j)**2), &
!                         em2r(1,j),em2r(2,j),em2r(3,j),                &
!                         sqrt(em2r(1,j)**2+em2r(2,j)**2+em2r(3,j)**2)
!            endif
! 9970 format('in pbcscavec ckpt alpha: J=',I2,'  sum=',F10.6,/, &
!             '   aksr=',3F10.6,/,       &
!             '   en0r=',3F10.6,/,       &
!             '    ak1=',f10.6,/,        &
!             '   em1r=',3f10.6,/,       &
!             ' |em1r|=',f10.6,/,        &
!             '   em2r=',3f10.6,/,       &
!             ' |em2r|=',f10.6)
!***

         ELSE

! Scattering angle is either zero or pi

!*** diagnostic
!            write(0,*)'pbcscavec ckpt 6'
!

            IF(JPBC==1.OR.JPBC==2)THEN

! JPBC=1 or 2 scattering angle = 0  -> ORDERM=0 and PHIN=0
!             scattering angle = pi -> ORDERM=0 and PHIN=pi and alpha=pi/2
! Check to see whether scattering angle theta = 0 or pi

!*** diagnostic
!               write(0,*)'pbcscavec ckpt 7'
!

               IF(COSTHETA>0)THEN

! forward scattering: em2 = [chat - nhat (nhat dot chat)]/sin(alpha)

!*** diagnostic
!                  write(0,*)'pbcscavec ckpt 8'
!
                  IF(JPBC==1)THEN
                     SINALPHAI=SQRT(1._WP-EN0R(2)**2)
                     COSALPHAI=EN0R(2)
                     EM2R(1,J)=EN0R(1)*COSALPHAI/SINALPHAI
                     EM2R(2,J)=(EN0R(2)*COSALPHAI-1._WP)/SINALPHAI
                     EM2R(3,J)=EN0R(3)*COSALPHAI/SINALPHAI
!*** diagnostic
!                     if(j<=20)then
!                        write(0,*)'pbcscavec ckpt 2, j=',j
!                        write(0,*)'sinalphai=',SINALPHAI
!                        write(0,*)'em2r(1-3,j)=',em2r(1,j),em2r(2,j),em2r(3,j)
!                     endif
!*** end diagnostic
                  ELSE
                     SINALPHAI=SQRT(1._WP-EN0R(3)**2)
                     COSALPHAI=EN0R(3)
                     EM2R(1,J)=EN0R(1)*COSALPHAI/SINALPHAI
                     EM2R(2,J)=EN0R(2)*COSALPHAI/SINALPHAI
                     EM2R(3,J)=(EN0R(3)-1._WP)/SINALPHAI
                  ENDIF

               ELSE

! backscattering: em2 = chat

!*** diagnostic
!                  write(0,*)'pbcscavec ckpt 9'
!
                  IF(JPBC==1)THEN
                     EM2R(1,J)=0._WP
                     EM2R(2,J)=-1._WP
                     EM2R(3,J)=0._WP
                  ELSE
                     EM2R(1,J)=0._WP
                     EM2R(2,J)=0._WP
                     EM2R(3,J)=-1._WP
                  ENDIF

               ENDIF

            ELSEIF(JPBC==3)THEN

!*** diagnostic
!               write(0,*)'pbcscavec ckpt 10'
!
! Check to see if k_0 is normal to target plane.

               IF((EN0R(2)**2+EN0R(3)**2)<0.0001_WP)THEN

! incident and scattered ray are both normal to the target plane:

                  DO K=1,3
                     EM1R(K,J)=REAL(CXE01R(K))
                  ENDDO
                  DENOM=SQRT(EM1R(1,J)**2+EM1R(2,J)**2+EM1R(3,J)**2)
                  DO K=1,3
                     EM1R(K,J)=EM1R(K,J)/DENOM
                  ENDDO
                  EM2R(1,J)=(EM1R(2,J)*AKSR(3,J)-EM1R(3,J)*AKSR(2,J))/AK1
                  EM2R(2,J)=(EM1R(3,J)*AKSR(1,J)-EM1R(1,J)*AKSR(3,J))/AK1
                  EM2R(3,J)=(EM1R(1,J)*AKSR(2,J)-EM1R(2,J)*AKSR(1,J))/AK1

               ELSE

! incident ray is not normal to the target plane.  Therefore we can
! use the reflected ray to construct a scattering plane, and use this
! to define the perp polarization direction.
! Note that AKSR for the reflected ray differs from AKSR for the
! transmitted ray only by change in sign of AKSR(1,J)

                  EM2R(1,J)=AKSR(2,J)*EN0R(3)-AKSR(3,J)*EN0R(2)
                  EM2R(2,J)=AKSR(3,J)*EN0R(1)+AKSR(1,J)*EN0R(3)
                  EM2R(3,J)=-AKSR(1,J)*EN0R(2)-AKSR(2,J)*EN0R(1)
                  DENOM=SQRT(EM2R(1,J)**2+EM2R(2,J)**2+EM2R(3,J)**2)
                  DO K=1,3
                     EM2R(K,J)=EM2R(K,J)/DENOM
                  ENDDO
               ENDIF

            ENDIF


         ENDIF ! end IF(ABS(SUM).LE.0.9999_WP) ...
      
! Now use EM2R to obtain EM1R from e_par = khat cross e_perp

         EM1R(1,J)=(AKSR(2,J)*EM2R(3,J)-AKSR(3,J)*EM2R(2,J))/AK1
         EM1R(2,J)=(AKSR(3,J)*EM2R(1,J)-AKSR(1,J)*EM2R(3,J))/AK1

!*** diagnostic
!         write(0,9811)j,aksr(3,j),em2r(1,j),aksr(1,j),em2r(3,j), &
!                         ak1,em1r(2,j)
! 9811 format('in pbcscavec ckpt 11: j=',i2,/,                          &
!             'aksr(3,j)=',f10.6,' em2r(1,j)=',f10.6,' aksr(1,j)=',f10.6, &
!             ' em2r(3,j)=',f10.6,/,'ak1=',f10.6,' em1r(2,j)=',f10.6)
!*** end diagnostic

         EM1R(3,J)=(AKSR(1,J)*EM2R(2,J)-AKSR(2,J)*EM2R(1,J))/AK1

!*** diagnostic
!         write(0,9980)j,sum,aksr(1,j),aksr(2,j),aksr(3,j),en0r,     &
!                         ak1,em1r(1,j),em1r(2,j),em1r(3,j),            &
!                         sqrt(em1r(1,j)**2+em1r(2,j)**2+em1r(3,j)**2), &
!                         em2r(1,j),em2r(2,j),em2r(3,j),                &
!                         sqrt(em2r(1,j)**2+em2r(2,j)**2+em2r(3,j)**2)
! 9980 format('in pbcscavec ckpt 12: J=',I2,'  sum=',F10.6,/, &
!             '   aksr=',3F10.6,/,       &
!             '   en0r=',3F10.6,/,       &
!             '    ak1=',f10.6,/,        &
!             '   em1r=',3f10.6,/,       &
!             ' |em1r|=',f10.6,/,        &
!             '   em2r=',3f10.6,/,       &
!             ' |em2r|=',f10.6)
!***

! now evaluate scattering unit vector in Lab Frame

         ENSC(1,J)=AKSR(1,J)*XLR(1)+AKSR(2,J)*XLR(2)+AKSR(3,J)*XLR(3)
         ENSC(2,J)=AKSR(1,J)*YLR(1)+AKSR(2,J)*YLR(2)+AKSR(3,J)*YLR(3)
         ENSC(3,J)=AKSR(1,J)*ZLR(1)+AKSR(2,J)*ZLR(2)+AKSR(3,J)*ZLR(3)
         DO K=1,3
            ENSC(K,J)=ENSC(K,J)/AK1
         ENDDO

! evaluate scattering polarization vectors in Lab Frame

         EM1(1,J)=EM1R(1,J)*XLR(1)+EM1R(2,J)*XLR(2)+EM1R(3,J)*XLR(3)
         EM1(2,J)=EM1R(1,J)*YLR(1)+EM1R(2,J)*YLR(2)+EM1R(3,J)*YLR(3)
         EM1(3,J)=EM1R(1,J)*ZLR(1)+EM1R(2,J)*ZLR(2)+EM1R(3,J)*ZLR(3)

         EM2(1,J)=EM2R(1,J)*XLR(1)+EM2R(2,J)*XLR(2)+EM2R(3,J)*XLR(3)
         EM2(2,J)=EM2R(1,J)*YLR(1)+EM2R(2,J)*YLR(2)+EM2R(3,J)*YLR(3)
         EM2(3,J)=EM2R(1,J)*ZLR(1)+EM2R(2,J)*ZLR(2)+EM2R(3,J)*ZLR(3)

      ENDDO

!*** diagnostic
!         write(0,*)'pbcscavec ckpt 99'
!         write(0,*)'aksr(1-3,1)=',aksr(1,1),aksr(2,1),aksr(3,1)
!         write(0,*)'aksr(1-3,2)=',aksr(1,2),aksr(2,2),aksr(3,2)
!         write(0,*)'aksr(1-3,3)=',aksr(1,3),aksr(2,3),aksr(3,3)
!         write(0,*)'aksr(1-3,4)=',aksr(1,4),aksr(2,4),aksr(3,4)
!         write(0,*)'aksr(1-3,9)=',aksr(1,9),aksr(2,9),aksr(3,9)
!         write(0,*)'aksr(1-3,10)=',aksr(1,10),aksr(2,10),aksr(3,10)
!         write(0,*)'aksr(1-3,11)=',aksr(1,11),aksr(2,11),aksr(3,11)
!
!         write(0,*)'em1r(1-3,1)=',em1r(1,1),em1r(2,1),em1r(3,1)
!         write(0,*)'em1r(1-3,2)=',em1r(1,2),em1r(2,2),em1r(3,2)
!         write(0,*)'em1r(1-3,3)=',em1r(1,3),em1r(2,3),em1r(3,3)
!         write(0,*)'em1r(1-3,4)=',em1r(1,4),em1r(2,4),em1r(3,4)
!         write(0,*)'em1r(1-3,9)=',em1r(1,9),em1r(2,9),em1r(3,9)
!         write(0,*)'em1r(1-3,10)=',em1r(1,10),em1r(2,10),em1r(3,11)
!         write(0,*)'em1r(1-3,11)=',em1r(1,11),em1r(2,10),em1r(3,11)
!
!         write(0,*)'em2r(1-3,1)=',em2r(1,1),em2r(2,1),em2r(3,1)
!         write(0,*)'em2r(1-3,2)=',em2r(1,2),em2r(2,2),em2r(3,2)
!         write(0,*)'em2r(1-3,3)=',em2r(1,3),em2r(2,3),em2r(3,3)
!         write(0,*)'em2r(1-3,4)=',em2r(1,4),em2r(2,4),em2r(3,4)
!         write(0,*)'em2r(1-3,9)=',em2r(1,9),em2r(2,9),em2r(3,9)
!         write(0,*)'em2r(1-3,10)=',em2r(1,10),em2r(2,10),em2r(3,10)
!         write(0,*)'em2r(1-3,11)=',em2r(1,11),em2r(2,11),em2r(3,11)
!
!         write(0,*)'ensc(1-3,1)=',ensc(1,1),ensc(2,1),ensc(3,1)
!         write(0,*)'ensc(1-3,2)=',ensc(1,2),ensc(2,2),ensc(3,2)
!         write(0,*)'ensc(1-3,3)=',ensc(1,3),ensc(2,3),ensc(3,3)
!         write(0,*)'ensc(1-3,4)=',ensc(1,4),ensc(2,4),ensc(3,4)
!         write(0,*)'ensc(1-3,9)=',ensc(1,9),ensc(2,9),ensc(3,9)
!         write(0,*)'ensc(1-3,10)=',ensc(1,10),ensc(2,10),ensc(3,10)
!         write(0,*)'ensc(1-3,11)=',ensc(1,11),ensc(2,11),ensc(3,11)
!
!         write(0,*)'em1(1-3,1)=',em1(1,1),em1(2,1),em1(3,1)
!         write(0,*)'em1(1-3,2)=',em1(1,2),em1(2,2),em1(3,2)
!         write(0,*)'em1(1-3,3)=',em1(1,3),em1(2,3),em1(3,3)
!         write(0,*)'em1(1-3,4)=',em1(1,4),em1(2,4),em1(3,4)
!         write(0,*)'em1(1-3,9)=',em1(1,9),em1(2,9),em1(3,9)
!         write(0,*)'em1(1-3,10)=',em1(1,10),em1(2,10),em1(3,10)
!         write(0,*)'em1(1-3,11)=',em1(1,11),em1(2,11),em1(3,11)
!
!         write(0,*)'em2(1-3,1)=',em2(1,1),em2(2,1),em2(3,1)
!         write(0,*)'em2(1-3,2)=',em2(1,2),em2(2,2),em2(3,2)
!         write(0,*)'em2(1-3,3)=',em2(1,3),em2(2,3),em2(3,3)
!         write(0,*)'em2(1-3,4)=',em2(1,4),em2(2,4),em2(3,4)
!         write(0,*)'em2(1-3,9)=',em2(1,9),em2(2,9),em2(3,9)
!         write(0,*)'em2(1-3,10)=',em2(1,10),em2(2,10),em2(3,10)
!         write(0,*)'em2(1-3,11)=',em2(1,11),em2(2,11),em2(3,11)
!*** end diagnostic

      RETURN
    END SUBROUTINE PBCSCAVEC

    SUBROUTINE PIMCBICG(X,B,WRK,IPAR,SPAR,MATVEC,TMATVEC,PRECONL,PRECONR, &
        PCSUM,PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS, TMATVEC
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, DELTA, RHO, RHO0, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IPTILDE, IR, IRTILDE, IS, ITNO, &
        IW, IXOLD, IZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, &
        STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, PIMSGETPAR, STOPCRIT
!     ..
      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IRTILDE = IR + LOCLEN
      IPTILDE = IRTILDE + LOCLEN
      IP = IPTILDE + LOCLEN
      IW = IP + LOCLEN
      IZ = IW + LOCLEN
      IS = IZ + LOCLEN
      IXOLD = IS + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to ssetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. rtilde=ptilde=p=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IRTILDE),1)
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IPTILDE),1)
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)

!  3. rho=dot(rtilde,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RHO = DOTS(1)

!  4. w=Q1AQ2p
      IF (PRECONTYPE==0) THEN
        CALL MATVEC(WRK(IP),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==1) THEN
        CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
        CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==3) THEN
        CALL PRECONR(WRK(IP),WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
      END IF

!  5. xi=dot(ptilde,w)
      DOTS(1) = CDOTC(LOCLEN,WRK(IPTILDE),1,WRK(IW),1)
      CALL PCSUM(1,DOTS)
      XI = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  6. alpha=rho/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        ALPHA = RHO/XI

!  7. x=x+alpha*p
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)

!  8. r=r-alpha*w
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IR),1)

!  9. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IW),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,TMATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF
! 10. rtilde=rtilde-alpha*Q1A^{T}Q2ptilde
        IF (PRECONTYPE==0) THEN
          CALL TMATVEC(WRK(IPTILDE),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL TMATVEC(WRK(IPTILDE),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IPTILDE),WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IPTILDE),WRK(IW),IPAR)
          CALL TMATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
        END IF

        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IRTILDE),1)

! 11. s=Q1AQ2r
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IR),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IR),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IR),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IR),WRK(IS),IPAR)
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)
        END IF

! 12. rho=dot(rtilde,r)
        RHO0 = RHO
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)

! 13. delta=dot(rtilde,s)
        DOTS(2) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IS),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)
        RHO = DOTS(1)
        DELTA = DOTS(2)

! 14. beta=rho/rho0
        IF (RHO0==CZERO) THEN
          STATUS = -3
          STEPERR = 14
          GO TO 9999

        END IF

        BETA = RHO/RHO0

! 15. p=r+beta*p
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IP),1)

! 16. ptilde=rtilde+beta*ptilde
        CALL CCOPY(LOCLEN,WRK(IPTILDE),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IRTILDE),1,WRK(IPTILDE),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IPTILDE),1)

! 17. w=s+beta*w
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IW),1)

! 18. xi=delta-beta^2*xi
        XI = DELTA - BETA**2*XI

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCBICG

    SUBROUTINE PIMCBICGSTAB(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM, &
        PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, KAPPA, OMEGA, RHO, RHO0, XI
      REAL (WP) :: EPSILON, EXITNORM, MACHEPS, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IQ, IR, IRTILDE, IS, IT, ITNO, &
        IV, IW, IXOLD, IZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, &
        STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CINIT, PIMSGETPAR, SMACHCONS, STOPCRIT
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS
!     ..
!*** diagnostic
!      write(0,*)'entered pibcbigcstab'
!      write(0,*)'about to call smachcons'
!****

      CALL SMACHCONS('M',MACHEPS)

!*** diagnostic
!      write(0,*)'returned from smachcons with MACHEPS=',macheps
!      write(0,*)'about to call pimsgetpar with'
!      write(0,*)'ipar=',ipar
!      write(0,*)'spar=',spar
!      write(0,*)'N=',n
!***

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!*** diagnostic
!      write(0,*)'returned from pisgetpar'
!      write(0,*)'ipar=',ipar
!      write(0,*)'spar=',spar
!      write(0,*)'precontype=',precontype
!      write(0,*)'stoptype=',stoptype
!***

!Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IRTILDE = IR + LOCLEN
      IP = IRTILDE + LOCLEN
      IQ = IP + LOCLEN
      IS = IQ + LOCLEN
      IT = IS + LOCLEN
      IV = IT + LOCLEN
      IW = IV + LOCLEN
      IZ = IW + LOCLEN
      IXOLD = IZ + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)
!*** diagnostic
!      write(0,*)'pimcbigstab ckpt delta, rhsstop=',rhsstop
!***

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
!*** diagnostic
!             write(0,*)'pimcbigstab ckpt delta.2, about to call ccopy'
!             write(0,*)'loclen=',loclen,' IZ=',IZ
!             write(0,*)'b(1)=',b(1)
!             write(0,*)'b(17000)=',b(17000)
!***
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
!*** diagnostic
!              write(0,*)'about to call matvec with x(17000)=',x(17000)
!***
          CALL MATVEC(X,WRK(IW),IPAR)
!*** diagnostic
!              write(0,*)'ckpt delta.3, returned from matvec with'
!              write(0,*)'iw=',iw
!              write(0,*)'wrk(iw+1000)=',wrk(iw+1000)
!              write(0,*)'wrk(iw+2000)=',wrk(iw+2000)
!              write(0,*)'wrk(iw+3000)=',wrk(iw+3000)
!              write(0,*)'wrk(iw+4000)=',wrk(iw+4000)
!              write(0,*)'wrk(iw+5000)=',wrk(iw+5000)
!              write(0,*)'wrk(iw+6000)=',wrk(iw+6000)
!              write(0,*)'wrk(iw+7000)=',wrk(iw+7000)
!              write(0,*)'wrk(iw+8000)=',wrk(iw+8000)
!              write(0,*)'wrk(iw+9000)=',wrk(iw+9000)
!              write(0,*)'wrk(iw+10000)=',wrk(iw+10000)
!              write(0,*)'wrk(iw+17000)=',wrk(iw+17000)
!              write(0,*)'x(1000)=',x(1000)
!              write(0,*)'x(2000)=',x(2000)
!              write(0,*)'x(3000)=',x(3000)
!              write(0,*)'x(4000)=',x(4000)
!              write(0,*)'x(5000)=',x(5000)
!              write(0,*)'x(6000)=',x(6000)
!              write(0,*)'x(7000)=',x(7000)
!              write(0,*)'x(8000)=',x(8000)
!              write(0,*)'x(9000)=',x(9000)
!***
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
!*** diagnostic
!          write(0,*)'ckpt n1: about to call PRECONL with IZ=',IZ,' IR=',IR
!          write(0,*)'wrk(iw+1)=',wrk(iw+1)
!          write(0,*)'wrk(iz+1)=',wrk(iz+1)
!***
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)
!***
!          write(0,*)'returned from PRECONL'
!***

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. rtilde=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IRTILDE),1)

!  3. p=v=0
      CALL CINIT(LOCLEN,CZERO,WRK(IP),1)
      CALL CINIT(LOCLEN,CZERO,WRK(IV),1)

!  4. rho=alpha=omega=1
      RHO = CONE
      ALPHA = CONE
      OMEGA = CONE

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  5. rho=dot(rtilde,r)
        RHO0 = RHO
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)
!*** diagnostic
!          write(0,*)'itno=',itno,' dots(1)=',dots(1)
!***
        CALL PCSUM(1,DOTS)
        RHO = DOTS(1)

!  6. beta=rho*alpha/(rho0*omega)
        KAPPA = RHO0*OMEGA
!*** diagnostic
!          write(0,*)'rho0=',rho0
!          write(0,*)'omega=',omega
!          write(0,*)'kappa=',kappa
!***
        IF (KAPPA==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        BETA = RHO*ALPHA/KAPPA

!*** diagnostic
!          write(0,*)'ckpt m100, alpha=',alpha,' beta=',beta
!***
!  7. p=r+beta*(p-omega*v)
        CALL CAXPY(LOCLEN,-OMEGA,WRK(IV),1,WRK(IP),1)
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IW),1)
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IW),1,WRK(IP),1)
!*** diagnostic
!          write(0,*)'ckpt m101, precontype=',precontype
!***
!  8. v=Q1AQ2p
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IP),WRK(IV),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
!*** diagnostic
!             write(0,*)'ckpt m201, about to call matvec'
!             write(0,*)'with ipar=',ipar
!             write(0,*)'ip=',ip
!             write(0,*)'wrk(ip+1)=',wrk(ip+1)
!             write(0,*)'iz=',iz
!             write(0,*)'wrk(iz+1)=',wrk(iz+1)
! ************ wrk(iz+1) is ok at this point
!              problem must be in next call to matvec:
!***
          CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
!*** diagnostic
!              write(0,*)'returned from matvec with'
!              write(0,*)'ipar=',ipar
!              write(0,*)'ip=',ip,' iz=',iz
!              write(0,*)'wrk(iw+1000)=',wrk(iw+1000)
!              write(0,*)'wrk(iw+2000)=',wrk(iw+2000)
!              write(0,*)'wrk(iw+3000)=',wrk(iw+3000)
!              write(0,*)'wrk(iw+4000)=',wrk(iw+4000)
!              write(0,*)'wrk(iw+5000)=',wrk(iw+5000)
!              write(0,*)'wrk(iw+6000)=',wrk(iw+6000)
!              write(0,*)'wrk(iw+7000)=',wrk(iw+7000)
!              write(0,*)'wrk(iw+8000)=',wrk(iw+8000)
!              write(0,*)'wrk(iw+9000)=',wrk(iw+9000)
!              write(0,*)'wrk(iw+10000)=',wrk(iw+10000)
!              write(0,*)'wrk(iw+17000)=',wrk(iw+17000)
!              write(0,*)'wrk(589825)=',wrk(589825)
!              write(0,*)'wkr(iz+1)=',wrk(iz+1)
!***
!*** diagnostic
!              write(0,*)'ckpt n2: about to call PRECONL with iz=',iz,' iv=',iv
! ************** problem occurs before this point: wrk(iz+1) is NaN
!                where iz=786433
!              write(0,*)'wrk(iz+1)=',wrk(iz+1)
!              write(0,*)'wkr(iv+1)=',wrk(iv+1)
!              write(0,*)'call PRECONL'
!***
          CALL PRECONL(WRK(IZ),WRK(IV),IPAR)

! PRECONL has messed with wrk(589825)...
!*** diagnostic
!              write(0,*)'ckpt m210'
!              write(0,*)'wrk(589825)=',wrk(589825)
!***
        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IV),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IP),WRK(IV),IPAR)
          CALL MATVEC(WRK(IV),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IV),IPAR)
        END IF

!  9. xi=dot(rtilde,v)
!*** diagnostic
!          write(0,*)'ckpt m230, loclen=',loclen
!          write(0,*)'irtilde=',irtilde
!          write(0,*)'wrk(irtilde)=',wrk(irtilde)
!          write(0,*)'iv=',iv
!          write(0,*)'wrk(iv)=',wrk(iv)
!***
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IV),1)
!*** diagnostic
!          write(0,*)'ckpt m250, dots(1)=',dots(1)
!***
        CALL PCSUM(1,DOTS)
        XI = DOTS(1)
!*** diagnostic
!          write(0,*)'ckpt m270, xi=',xi
!***
! 10. alpha=rho/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 10
          GO TO 9999

        END IF

        ALPHA = RHO/XI

! 11. s=r-alpha*v
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IS),1)
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IV),1,WRK(IS),1)

! 12. if ||s||<breaktol then soft-breakdown has occurred
        KAPPA = PSCNRM(LOCLEN,WRK(IS))
        IF (ABS(KAPPA)<MACHEPS) THEN
          STATUS = -2
          STEPERR = 12
          CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)
          GO TO 9999

        END IF

! 13. t=Q1AQ2s
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IS),WRK(IT),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IT),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IS),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IT),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IS),WRK(IT),IPAR)
          CALL MATVEC(WRK(IT),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IT),IPAR)
        END IF

! 14. omega=dot(t,s)/dot(t,t)
        DOTS(1) = CDOTC(LOCLEN,WRK(IT),1,WRK(IT),1)
        DOTS(2) = CDOTC(LOCLEN,WRK(IT),1,WRK(IS),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)

        IF (DOTS(1)==CZERO) THEN
          STATUS = -3
          STEPERR = 14
          GO TO 9999

        END IF

        OMEGA = DOTS(2)/DOTS(1)

! 15. x=x+alpha*p+omega*s
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)
        CALL CAXPY(LOCLEN,OMEGA,WRK(IS),1,X,1)

! 16. r=s-omega*t
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IR),1)
        CALL CAXPY(LOCLEN,-OMEGA,WRK(IT),1,WRK(IR),1)

! 17. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IW),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF
      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCBICGSTAB

    SUBROUTINE PIMCCG(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM,PSCNRM, &
        PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, DELTA, RDOTR, RDOTR0, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IR, IS, ITNO, IW, IXOLD, IZ, &
        LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, STATUS, STEPERR, &
        STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, PIMSGETPAR, STOPCRIT
!     ..

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IP = IR + LOCLEN
      IW = IP + LOCLEN
      IZ = IW + LOCLEN
      IS = IZ + LOCLEN
      IXOLD = IS + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. p=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)

!  3. rdotr=dot(r,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RDOTR = DOTS(1)

!  4. w=Q1AQ2p
      IF (PRECONTYPE==0) THEN
        CALL MATVEC(WRK(IP),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==1) THEN
        CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
        CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==3) THEN
        CALL PRECONR(WRK(IP),WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
      END IF

!  5. xi=dot(p,w)
      DOTS(1) = CDOTC(LOCLEN,WRK(IP),1,WRK(IW),1)
      CALL PCSUM(1,DOTS)
      XI = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  6. alpha=rdotr/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        ALPHA = RDOTR/XI

!  7. x=x+alpha*p
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)

!  8. r=r-alpha*w
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IR),1)

!  9. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IS),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

! 10. s=Q1AQ2r
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IR),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IR),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IR),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IR),WRK(IS),IPAR)
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)
        END IF

! 11. rdotr=dot(r,r)
        RDOTR0 = RDOTR
        DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)

! 12. delta=dot(r,s)
        DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IS),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)
        RDOTR = DOTS(1)
        DELTA = DOTS(2)

! 13. beta=rdotr/rdotr0
        IF (RDOTR0==CZERO) THEN
          STATUS = -3
          STEPERR = 13
          GO TO 9999

        END IF

        BETA = RDOTR/RDOTR0

! 14. p=r+beta*p
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IP),1)

! 15. w=s+beta*w
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IW),1)

! 16. xi=delta-beta^2*xi
        XI = DELTA - BETA**2*XI

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCCG
    SUBROUTINE PIMCCGNE(X,B,WRK,IPAR,SPAR,MATVEC,TMATVEC,PRECONL,PRECONR, &
        PCSUM,PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS, TMATVEC
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, DELTA, RDOTR, RDOTR0, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IR, IS, ITNO, IW, IXOLD, IZ, &
        LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, STATUS, STEPERR, &
        STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, PIMSGETPAR, STOPCRIT
!     ..

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Needs conversion Y=Q2X for residual
      CNVRTX = 1

!  Set indices for mapping local vectors into wrk
      IR = 1
      IP = IR + LOCLEN
      IW = IP + LOCLEN
      IZ = IW + LOCLEN
      IS = IZ + LOCLEN
      IXOLD = IS + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AA^{T}Q2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL TMATVEC(X,WRK(IP),IPAR)
          CALL MATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-AA^{T})
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL TMATVEC(X,WRK(IP),IPAR)
          CALL MATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AA^{T}Q2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AA^{T}Q2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL TMATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-AA^{T}x)
          CALL TMATVEC(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IP),IPAR)
          CALL PRECONL(WRK(IP),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AA^{T}Q2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)
        END IF

      END IF

!  2. p=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)

!  3. rdotr=dot(r,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RDOTR = DOTS(1)

!  4. w=Q1AA^{T}Q2p
      IF (PRECONTYPE==0) THEN
        CALL TMATVEC(WRK(IP),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==1) THEN
        CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
        CALL PRECONR(WRK(IP),WRK(IW),IPAR)
        CALL TMATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==3) THEN
        CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
        CALL TMATVEC(WRK(IZ),WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
      END IF

!  5. xi=dot(p,w)
      DOTS(1) = CDOTC(LOCLEN,WRK(IP),1,WRK(IW),1)
      CALL PCSUM(1,DOTS)
      XI = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  6. alpha=rdotr/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        ALPHA = RDOTR/XI

!  7. x=x+alpha*p
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)

!  8. r=r-alpha*w
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IR),1)

!  9. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IS),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,TMATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

! 10. s=Q1AA^{T}Q2r
        IF (PRECONTYPE==0) THEN
          CALL TMATVEC(WRK(IR),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL TMATVEC(WRK(IR),WRK(IS),IPAR)
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IR),WRK(IS),IPAR)
          CALL TMATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IR),WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IS),IPAR)
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)
        END IF

! 11. rdotr=dot(r,r)
        RDOTR0 = RDOTR
        DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)

! 12. delta=dot(r,s)
        DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IS),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)
        RDOTR = DOTS(1)
        DELTA = DOTS(2)

! 13. beta=rdotr/rdotr0
        IF (RDOTR0==CZERO) THEN
          STATUS = -3
          STEPERR = 10
          GO TO 9999

        END IF

        BETA = RDOTR/RDOTR0

! 14. p=r+beta*p
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IP),1)

! 15. w=s+beta*w
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IW),1)

! 16. xi=delta-beta^2*xi
        XI = DELTA - BETA**2*XI

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),WRK(IXOLD),IPAR)
        CALL TMATVEC(WRK(IXOLD),X,IPAR)
      ELSE
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL TMATVEC(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCCGNE
    SUBROUTINE PIMCCGNR(X,B,WRK,IPAR,SPAR,MATVEC,TMATVEC,PRECONL,PRECONR, &
        PCSUM,PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS, TMATVEC
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, DELTA, RDOTR, RDOTR0, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IR, IS, ITNO, IW, IXOLD, IZ, &
        LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, STATUS, STEPERR, &
        STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, PIMSGETPAR, STOPCRIT
!     ..

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IP = IR + LOCLEN
      IW = IP + LOCLEN
      IZ = IW + LOCLEN
      IS = IZ + LOCLEN
      IXOLD = IS + LOCLEN

!  Set rhs of stopping criteria
!  On (P)CGNR, the rhs vector is actually A^{T}b
      CALL TMATVEC(B,WRK(IZ),IPAR)
      RHSSTOP = SCSETRHSSTOP(WRK(IZ),WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(A^{T}b-A^{T}AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL MATVEC(X,WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL CCOPY(LOCLEN,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(A^{T}b-A^{T}Ax)
          CALL MATVEC(X,WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=A^{T}b-A^{T}AQ2x
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL CCOPY(LOCLEN,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(A^{T}b-A^{T}AQ2x)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Q(A^{T}b) in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(A^{T}b-A^{T}Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL TMATVEC(WRK(IW),WRK(IP),IPAR)
          CALL PRECONL(WRK(IP),WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(A^{T}b-A^{T}AQ2x)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IP),IPAR)
          CALL TMATVEC(WRK(IP),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IP),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IP),1,WRK(IR),1)
        END IF

      END IF

!  2. p=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)

!  3. rdotr=dot(r,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RDOTR = DOTS(1)

!  4. w=Q1A^{T}AQ2p
      IF (PRECONTYPE==0) THEN
        CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
        CALL TMATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==1) THEN
        CALL MATVEC(WRK(IP),WRK(IW),IPAR)
        CALL TMATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
        CALL PRECONR(WRK(IP),WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL TMATVEC(WRK(IZ),WRK(IW),IPAR)

      ELSE IF (PRECONTYPE==3) THEN
        CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
        CALL TMATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
      END IF

!  5. xi=dot(p,w)
      DOTS(1) = CDOTC(LOCLEN,WRK(IP),1,WRK(IW),1)
      CALL PCSUM(1,DOTS)
      XI = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  6. alpha=rdotr/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        ALPHA = RDOTR/XI

!  7. x=x+alpha*p
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IP),1,X,1)

!  8. r=r-alpha*w
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IR),1)

!  9. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IS),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,TMATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

! 10. s=Q1A^{T}AQ2r
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IR),WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IR),WRK(IS),IPAR)
          CALL TMATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IR),WRK(IS),IPAR)
          CALL MATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IS),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IR),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IS),IPAR)
          CALL TMATVEC(WRK(IS),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IS),IPAR)
        END IF

! 11. rdotr=dot(r,r)
        RDOTR0 = RDOTR
        DOTS(1) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR),1)

! 12. delta=dot(r,s)
        DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IS),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)
        RDOTR = DOTS(1)
        DELTA = DOTS(2)

! 13. beta=rdotr/rdotr0
        IF (RDOTR0==CZERO) THEN
          STATUS = -3
          STEPERR = 13
          GO TO 9999

        END IF

        BETA = RDOTR/RDOTR0

! 14. p=r+beta*p
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IP),1)

! 15. w=s+beta*w
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IZ),1,WRK(IW),1)

! 16. xi=delta-beta^2*xi
        XI = DELTA - BETA**2*XI

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCCGNR
    SUBROUTINE PIMCCGS(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM,PSCNRM, &
        PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, RHO, RHO0, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IP, IQ, IR, IRTILDE, IS, IT, ITNO, &
        IU, IW, IXOLD, IZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, &
        STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(1)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, PIMSGETPAR, STOPCRIT
!     ..
      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IRTILDE = IR + LOCLEN
      IP = IRTILDE + LOCLEN
      IQ = IP + LOCLEN
      IS = IQ + LOCLEN
      IT = IS + LOCLEN
      IU = IT + LOCLEN
      IW = IU + LOCLEN
      IZ = IW + LOCLEN
      IXOLD = IZ + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to ssetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. p=s=rtilde=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IRTILDE),1)
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IS),1)

!  3. rho=dot(rtilde,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RHO = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  4. w=Q1AQ2p
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IP),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IP),WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IW),IPAR)
        END IF

!  5. xi=dot(rtilde,w)
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IW),1)
        CALL PCSUM(1,DOTS)
        XI = DOTS(1)

!  6. alpha=rho/xi
        IF (XI==CZERO) THEN
          STATUS = -3
          STEPERR = 6
          GO TO 9999

        END IF

        ALPHA = RHO/XI

!  7. t=s-alpha*w
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IT),1)
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IW),1,WRK(IT),1)

!  8. w=s+t
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,CONE,WRK(IT),1,WRK(IW),1)

!  9. x=x+alpha*w
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,ALPHA,WRK(IW),1,X,1)

! 10. r=r-alpha*Q1AQ2w
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IW),WRK(IU),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IU),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IW),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IU),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IW),WRK(IU),IPAR)
          CALL MATVEC(WRK(IU),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IU),IPAR)
        END IF

        CALL CAXPY(LOCLEN,-ALPHA,WRK(IU),1,WRK(IR),1)

! 11. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IU),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF
! 12. rho=dot(rtilde0,r)
        RHO0 = RHO
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)
        CALL PCSUM(1,DOTS)
        RHO = DOTS(1)

! 13. beta=rho/rho0
        IF (RHO0==CZERO) THEN
          STATUS = -3
          STEPERR = 13
          GO TO 9999

        END IF

        BETA = RHO/RHO0

! 14. s=r+beta*t
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IS),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IT),1,WRK(IS),1)

! 15. w=t+beta*p
        CALL CCOPY(LOCLEN,WRK(IT),1,WRK(IW),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IP),1,WRK(IW),1)

! 16. p=s+beta*w
        CALL CCOPY(LOCLEN,WRK(IS),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IW),1,WRK(IP),1)

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCCGS
    SUBROUTINE PIMCCHEBYSHEV(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM, &
        PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ZERO
      PARAMETER (ZERO=0.0E0_WP)
      COMPLEX (WP) :: ZONE
      PARAMETER (ZONE=(1.0E0_WP,0.0E0_WP))
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      REAL (WP) :: TWO
      PARAMETER (TWO=2.0_WP)
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      REAL (WP) :: AXISISQ, AXISRSQ, D, DELTA, EPSILON, EXITNORM, GAMMA, &
        LENGTHI, LENGTHR, RHO, RHSSTOP, SIGMA, SIGMASQ
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, IK, IR, ITNO, IW, IXOLD, IZ, LDA, &
        LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, PROCID, STATUS, STEPERR, &
        STOPTYPE
!     ..
!     .. External Functions ..
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CSCAL, CSWAP, PIMSGETPAR, STOPCRIT
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC CMPLX, MAX
!     ..
      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of stop types
      IF ((STOPTYPE/=1) .AND. (STOPTYPE/=2) .AND. (STOPTYPE/=7)) THEN
        ITNO = 0
        STATUS = -6
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IW = 1
      IK = IW + LOCLEN
      IZ = IK + LOCLEN
      IR = IZ + LOCLEN
      IXOLD = IR + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. Set parameters for iteration
      IF ((SPAR(3)==ZERO) .AND. (SPAR(4)==ZERO) .AND. (SPAR( &
          5)==ZERO) .AND. (SPAR(6)==ZERO)) THEN
        STATUS = -7
        STEPERR = 1
        GO TO 9999

      ELSE IF (SPAR(5)==SPAR(6)) THEN
!     Eigenvalues are contained in the interval [SPAR(3),SPAR(4)] on
!     the real axis:
!         sigma=(dpar(4)-dpar(3))/(2-dpar(4)-dpar(3))
!         gamma=2/(2-dpar(4)-dpar(3))
        SIGMA = (SPAR(4)-SPAR(3))/(TWO-SPAR(4)-SPAR(3))
        SIGMASQ = SIGMA*SIGMA
        GAMMA = TWO/(TWO-SPAR(4)-SPAR(3))

      ELSE IF (SPAR(3)==SPAR(4)) THEN
!     Eigenvalues are contained in the interval [SPAR(5),SPAR(6)] on
!     the imaginary axis:
!         sigma^2=-max(dpar(5),dpar(6))
!         gamma=1
        SIGMASQ = -MAX(SPAR(5),SPAR(6))
        GAMMA = ONE

      ELSE
!     Eigenvalues are complex and contained in the box
!     SPAR(3)<= Real(e) <= SPAR(4) and SPAR(5)<= Imag(e) <= SPAR(6).
!     Compute the minimum bounding ellipse that circumscribes the box;
!     this is defined by its axes a=sqrt(2)*(dpar(4)-dpar(3))/2 (along
!     the real axis) and b=sqrt(2)*(dpar(6)-dpar(5))/2 (along the
!     imaginary axis). The center of the ellipse is d.
!         sigma^2=(a^2+b^2)/(1-d)^2
!         gamma=1/(1-d)
        LENGTHR = (SPAR(4)-SPAR(3))/TWO
        LENGTHI = (SPAR(6)-SPAR(5))/TWO
        AXISRSQ = LENGTHR*LENGTHR*TWO
        AXISISQ = LENGTHI*LENGTHI*TWO
        D = (SPAR(6)+SPAR(5))/TWO
        SIGMASQ = (AXISRSQ-AXISISQ)/(ONE-D)**2
        GAMMA = ONE/(ONE-D)

      END IF

!  2. k=gamma*Q1b
      IF (PRECONTYPE==0) THEN
        CALL CCOPY(LOCLEN,B,1,WRK(IK),1)
        CALL CSCAL(LOCLEN,CMPLX(GAMMA,KIND=WP),WRK(IK),1)

      ELSE IF ((PRECONTYPE==1) .OR. (PRECONTYPE==3)) THEN
        CALL PRECONL(B,WRK(IK),IPAR)
        CALL CSCAL(LOCLEN,CMPLX(GAMMA,KIND=WP),WRK(IK),1)
      END IF

!    xold=x
      CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  3. rho
        IF (ITNO==1) THEN
          RHO = ONE

        ELSE IF (ITNO==2) THEN
          RHO = ONE/(ONE-SIGMASQ/TWO)

        ELSE
          RHO = ONE/(ONE-RHO*SIGMASQ/4.0_WP)
        END IF

!  4. w=(I-Q1AQ2)x
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(X,WRK(IZ),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
        END IF

        CALL CCOPY(LOCLEN,X,1,WRK(IW),1)
        CALL CAXPY(LOCLEN,-ZONE,WRK(IZ),1,WRK(IW),1)

!  5. x=rho*(gamma*((I-Q1A)x+Q1b)+(1-gamma)*x)+(1-rho)*xold
        DELTA = RHO*GAMMA
        CALL CSCAL(LOCLEN,CMPLX(ONE-RHO,KIND=WP),WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,CMPLX(RHO,KIND=WP),WRK(IK),1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,CMPLX(RHO-DELTA,KIND=WP),X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,CMPLX(DELTA,KIND=WP),WRK(IW),1,WRK(IXOLD),1)
        CALL CSWAP(LOCLEN,WRK(IXOLD),1,X,1)

!  6. check stopping criterion
        CALL STOPCRIT(B,WRK(IZ),WRK(IR),X,WRK(IXOLD),WRK(IW),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IR))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCCHEBYSHEV
    SUBROUTINE PIMCQMR(X,B,WRK,IPAR,SPAR,MATVEC,TMATVEC,PRECONL,PRECONR,PCSUM, &
        PSCNRM,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS, TMATVEC
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: BETA, C, C0, DE, DELTA, DI, EPS, ETA, KSI, OMEGA, RHO, &
        RHO0, THETA, THETA0
      REAL (WP) :: EPSILON, EXITNORM, OVERFLOW, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, ID, IP, IQ, IR, ITNO, IV, IVTILDE, &
        IW, IWTILDE, IXOLD, IY, IZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, &
        PROCID, STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CINIT, CSCAL, PIMSGETPAR, SMACHCONS, STOPCRIT
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
!     ..
      CALL SMACHCONS('O',OVERFLOW)

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 1

!  Set indices for mapping local vectors into wrk
      IR = 1
      IV = IR + LOCLEN
      IW = IV + LOCLEN
      IP = IW + LOCLEN
      IQ = IP + LOCLEN
      ID = IQ + LOCLEN
      IVTILDE = ID + LOCLEN
      IWTILDE = IVTILDE + LOCLEN
      IXOLD = IWTILDE + LOCLEN
      IZ = IXOLD + LOCLEN
      IY = IZ + LOCLEN

!  Set RHS of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Q1b in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. rho=||r||_{2}
      RHO = PSCNRM(LOCLEN,WRK(IR))

!  3. v=r/rho
      IF (RHO==CZERO) THEN
        STATUS = -3
        STEPERR = 3
        GO TO 9999

      END IF

      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IV),1)
      CALL CSCAL(LOCLEN,CONE/RHO,WRK(IV),1)

!  4. w=-r/rho
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IW),1)
      CALL CSCAL(LOCLEN,-CONE/RHO,WRK(IW),1)

!  5. p=q=d=0
      CALL CINIT(LOCLEN,CZERO,WRK(IP),1)
      CALL CINIT(LOCLEN,CZERO,WRK(IQ),1)
      CALL CINIT(LOCLEN,CZERO,WRK(ID),1)

!  6. c0=1, eps=1, ksi=1, theta0=0, eta=-1, omega=1
      C0 = CONE
      EPS = CONE
      KSI = CONE
      THETA0 = CZERO
      ETA = -CONE
      OMEGA = CONE

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  7. delta=w^{T}v
        DOTS(1) = CDOTC(LOCLEN,WRK(IW),1,WRK(IV),1)
        CALL PCSUM(1,DOTS)
        DELTA = DOTS(1)

!  8. if eps=0 then breakdown
        IF (EPS==CZERO) THEN
          STATUS = -3
          STEPERR = 8
          GO TO 9999

        END IF

!  9. if delta=0 then breakdown
        IF (DELTA==CZERO) THEN
          STATUS = -3
          STEPERR = 9
          GO TO 9999

        END IF

! 10. p=v-(ksi*delta/eps)*p
        DE = DELTA/EPS
        CALL CCOPY(LOCLEN,WRK(IP),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IV),1,WRK(IP),1)
        CALL CAXPY(LOCLEN,-KSI*DE,WRK(IZ),1,WRK(IP),1)

! 11. q=w-(rho*delta/eps)*q
        CALL CCOPY(LOCLEN,WRK(IQ),1,WRK(IZ),1)
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IQ),1)
        CALL CAXPY(LOCLEN,-RHO*DE,WRK(IZ),1,WRK(IQ),1)

! 12. vtilde=Q1AQ2p
        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IP),WRK(IVTILDE),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IVTILDE),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IP),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IVTILDE),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IP),WRK(IVTILDE),IPAR)
          CALL MATVEC(WRK(IVTILDE),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IVTILDE),IPAR)
        END IF

! 13. eps=q^{T}(Q1AQ2p)=q^{T}vtilde
        DOTS(1) = CDOTC(LOCLEN,WRK(IQ),1,WRK(IVTILDE),1)
        CALL PCSUM(1,DOTS)
        EPS = DOTS(1)

! 14. beta=eps/delta
        BETA = EPS/DELTA

! 15. vtilde=vtilde-beta*v
        CALL CAXPY(LOCLEN,-BETA,WRK(IV),1,WRK(IVTILDE),1)

! 16. wtilde=Q1A^{T}Q2q-beta*w
        IF (PRECONTYPE==0) THEN
          CALL TMATVEC(WRK(IQ),WRK(IWTILDE),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL TMATVEC(WRK(IQ),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IWTILDE),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IQ),WRK(IZ),IPAR)
          CALL TMATVEC(WRK(IZ),WRK(IWTILDE),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IQ),WRK(IWTILDE),IPAR)
          CALL TMATVEC(WRK(IWTILDE),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IWTILDE),IPAR)
        END IF

        CALL CAXPY(LOCLEN,-BETA,WRK(IW),1,WRK(IWTILDE),1)

! 17. rho=norm(vtilde)
        RHO0 = RHO
        DOTS(1) = CDOTC(LOCLEN,WRK(IVTILDE),1,WRK(IVTILDE),1)

! 18. ksi=norm(wtilde)
        DOTS(2) = CDOTC(LOCLEN,WRK(IWTILDE),1,WRK(IWTILDE),1)

!  Accumulate simultaneously partial values
        CALL PCSUM(2,DOTS)
        IF (ABS(DOTS(1))>=OVERFLOW) THEN
          STATUS = -3
          STEPERR = 17
          GO TO 9999

        END IF
        RHO = SQRT(DOTS(1))

        IF (ABS(DOTS(2))>=OVERFLOW) THEN
          STATUS = -3
          STEPERR = 18
          GO TO 9999

        END IF
        KSI = SQRT(DOTS(2))

! 19. theta=(omega*rho)/(omega*c0*abs(beta))
        DI = OMEGA*C0*ABS(BETA)
        IF (DI==CZERO) THEN
          STATUS = -3
          STEPERR = 19
          GO TO 9999

        END IF
        THETA = (OMEGA*RHO)/DI

! 20. c=1/sqrt(1+theta^2)
        C = CONE/SQRT(CONE+THETA**2)

! 21. eta=-eta*rho0*c^2/(beta*c0^2)
        DI = BETA*C0**2
        IF (DI==CZERO) THEN
          STATUS = -3
          STEPERR = 21
          GO TO 9999

        END IF
        ETA = -ETA*RHO0*C**2/DI

! 22. d=p*eta+(theta0*c)^2*d
        CALL CSCAL(LOCLEN,(THETA0*C)**2,WRK(ID),1)
        CALL CAXPY(LOCLEN,ETA,WRK(IP),1,WRK(ID),1)

! 23. x=x+d
        CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
        CALL CAXPY(LOCLEN,CONE,WRK(ID),1,X,1)

! 24. r=b-Ax
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IY),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IY),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IY),IPAR)
          CALL MATVEC(WRK(IY),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IY),1)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IR),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IR),1,WRK(IY),1)
          CALL PRECONL(WRK(IY),WRK(IR),IPAR)
        END IF

! 25. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IW),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,TMATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

! 26. if rho=0 then breakdown
        IF (RHO==CZERO) THEN
          STATUS = -3
          STEPERR = 26
          GO TO 9999

        END IF

! 27. if ksi=0 then breakdown
        IF (KSI==CZERO) THEN
          STATUS = -3
          STEPERR = 27
          GO TO 9999

        END IF

! 28. v=vtilde/rho
        CALL CCOPY(LOCLEN,WRK(IVTILDE),1,WRK(IV),1)
        CALL CSCAL(LOCLEN,CONE/RHO,WRK(IV),1)

! 29. w=wtilde/rho
        CALL CCOPY(LOCLEN,WRK(IWTILDE),1,WRK(IW),1)
        CALL CSCAL(LOCLEN,CONE/RHO,WRK(IW),1)

! c0=c,theta0=theta
        C0 = C
        THETA0 = THETA

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCQMR

    SUBROUTINE PIMCRBICGSTAB(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM, &
        PSCNRM2,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ZERO
      PARAMETER (ZERO=0.0E0_WP)
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)

! 04.05.21 (BTD) corrected REAL CZERO,CONE to COMPLEX CZERO,CONE

      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
      INTEGER :: IBDIM
      PARAMETER (IBDIM=10)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM2
      EXTERNAL PSCNRM2
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      REAL (WP) :: ALPHA, BETA, EPSILON, EXITNORM, KSI, OMEGA, RHO0, RHO1, &
        RHSSTOP, S
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, I, I0, I1, I2, I3, I4, IR, IRTILDE, &
        ITNO, IU, IW, IXOLD, IZ, J, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, &
        PROCID, STATUS, STEPERR, STOPTYPE

!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(IBDIM)
      REAL (WP) :: GAMMA(IBDIM), GAMMA1(IBDIM), GAMMA2(IBDIM), SIGMA(IBDIM), &
        TAU(IBDIM,IBDIM)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CINIT, PIMSGETPAR, STOPCRIT
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC CMPLX
!     ..
      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IRTILDE = 1
      IW = IRTILDE + LOCLEN
      IZ = IW + LOCLEN
      IXOLD = IZ + LOCLEN
      IR = IXOLD + LOCLEN
      IU = IR + (BASISDIM+1)*LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM2)

!  1. r=Q1(b-AQ2x)
      IF (PRECONTYPE==0) THEN
!     r=b-Ax
        CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
        CALL MATVEC(X,WRK(IW),IPAR)
        CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

      ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
        CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
        CALL MATVEC(X,WRK(IW),IPAR)
        CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
        CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
        CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
        CALL PRECONR(X,WRK(IW),IPAR)
        CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
        CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

      ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
        CALL CCOPY(LOCLEN,B,1,WRK(IW),1)
        CALL PRECONR(X,WRK(IR),IPAR)
        CALL MATVEC(WRK(IR),WRK(IZ),IPAR)
        CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IW),1)
        CALL PRECONL(WRK(IW),WRK(IR),IPAR)
      END IF

!  2. rtilde=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IRTILDE),1)

!  3. u0=0
      CALL CINIT(LOCLEN,CZERO,WRK(IU),1)

!  4. rho0=1, alpha=0, omega=1
      RHO0 = ONE
      ALPHA = ZERO
      OMEGA = ONE

!  Loop
      STATUS = 0
      STEPERR = -1
      EXITNORM = -ONE
      DO ITNO = 1, MAXIT

!  5. rho0=-omega*rho0
        RHO0 = -OMEGA*RHO0

!  BiCG loop
        I1 = 0
        I2 = LOCLEN
        DO J = 0, BASISDIM - 1

!  6. rho1=r(j)^{T}rtilde
          DOTS(1) = CDOTC(LOCLEN,WRK(IR+I1),1,WRK(IRTILDE),1)
          CALL PCSUM(1,DOTS)
          RHO1 = DOTS(1)

!  7. beta=alpha*rho1/rho0
          IF (RHO0==ZERO) THEN
            STATUS = -3
            STEPERR = 7
            GO TO 9999

          END IF

          BETA = ALPHA*RHO1/RHO0

!  8. rho0=rho1
          RHO0 = RHO1

!  9. u(i)=r(i)-beta*u(i), i=0:j
          I3 = 0
          DO I = 0, J
            CALL CCOPY(LOCLEN,WRK(IU+I3),1,WRK(IZ),1)
            CALL CCOPY(LOCLEN,WRK(IR+I3),1,WRK(IU+I3),1)
            CALL CAXPY(LOCLEN,CMPLX(-BETA,KIND=WP),WRK(IZ),1,WRK(IU+I3),1)
            I3 = I3 + LOCLEN
          END DO

! 10. u(j+1)=Q1AQ2u(j)
          IF (PRECONTYPE==0) THEN
            CALL MATVEC(WRK(IU+I1),WRK(IU+I2),IPAR)

          ELSE IF (PRECONTYPE==1) THEN
            CALL MATVEC(WRK(IU+I1),WRK(IW),IPAR)
            CALL PRECONL(WRK(IW),WRK(IU+I2),IPAR)

          ELSE IF (PRECONTYPE==2) THEN
            CALL PRECONR(WRK(IU+I1),WRK(IW),IPAR)
            CALL MATVEC(WRK(IW),WRK(IU+I2),IPAR)

          ELSE IF (PRECONTYPE==3) THEN
            CALL PRECONR(WRK(IU+I1),WRK(IZ),IPAR)
            CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
            CALL PRECONL(WRK(IW),WRK(IU+I2),IPAR)
          END IF

! 11. ksi=u(j+1)^{T}rtilde
          DOTS(1) = CDOTC(LOCLEN,WRK(IU+I2),1,WRK(IRTILDE),1)
          CALL PCSUM(1,DOTS)
          KSI = DOTS(1)

! 12. alpha=rho0/ksi
          IF (KSI==ZERO) THEN
            STATUS = -3
            STEPERR = 12
            GO TO 9999

          END IF

          ALPHA = RHO0/KSI

! 13. r(i)=r(i)-alpha*u(i+1), i=0:j
          I3 = 0
          I4 = LOCLEN
          DO I = 0, J
            CALL CAXPY(LOCLEN,CMPLX(-ALPHA,KIND=WP),WRK(IU+I4),1,WRK(IR+I3),1)
            I3 = I3 + LOCLEN
            I4 = I4 + LOCLEN
          END DO

! 14. r(j+1)=Q1AQ2r(j)
          IF (PRECONTYPE==0) THEN
            CALL MATVEC(WRK(IR+I1),WRK(IR+I2),IPAR)

          ELSE IF (PRECONTYPE==1) THEN
            CALL MATVEC(WRK(IR+I1),WRK(IW),IPAR)
            CALL PRECONL(WRK(IW),WRK(IR+I2),IPAR)

          ELSE IF (PRECONTYPE==2) THEN
            CALL PRECONR(WRK(IR+I1),WRK(IW),IPAR)
            CALL MATVEC(WRK(IW),WRK(IR+I2),IPAR)

          ELSE IF (PRECONTYPE==3) THEN
            CALL PRECONR(WRK(IR+I1),WRK(IZ),IPAR)
            CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
            CALL PRECONL(WRK(IW),WRK(IR+I2),IPAR)
          END IF

! 15. x0=x0+alpha*u0
          CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
          CALL CAXPY(LOCLEN,CMPLX(ALPHA,KIND=WP),WRK(IU),1,X,1)
          I1 = I1 + LOCLEN
          I2 = I2 + LOCLEN
        END DO

! 16. check stopping criterion
        CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IW),RHSSTOP,CNVRTX, &
          EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM2)

!  Call monitoring routine
        CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

        IF (STATUS==0) THEN
          GO TO 9999
        END IF

!  MR loop

! 17. sigma(1)=r(1)^{T}r(1), gamma'(1)=r(0)^{T}r(1)/sigma(1)
        DOTS(1) = CDOTC(LOCLEN,WRK(IR+LOCLEN),1,WRK(IR+LOCLEN),1)
        DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR+LOCLEN),1)
        CALL PCSUM(2,DOTS)
        SIGMA(1) = DOTS(1)

        IF (SIGMA(1)==ZERO) THEN
          STATUS = -3
          STEPERR = 17
          GO TO 9999

        END IF

        GAMMA1(1) = DOTS(2)/SIGMA(1)

        I0 = LOCLEN + LOCLEN
        DO J = 2, BASISDIM

! 18. tau(i,j)=r(j)^{T}r(i)/sigma(i), r(j)=r(j)-tau(i,j)r(i)
          I1 = LOCLEN
          DO I = 1, J - 1
            DOTS(I) = CDOTC(LOCLEN,WRK(IR+I0),1,WRK(IR+I1),1)
            I1 = I1 + LOCLEN
          END DO
          CALL PCSUM(J-1,DOTS)
          I1 = LOCLEN
          DO I = 1, J - 1
            TAU(I,J) = DOTS(I)/SIGMA(I)
            CALL CAXPY(LOCLEN,CMPLX(-TAU(I,J),KIND=WP),WRK(IR+I1),1,WRK(IR+I0) &
              ,1)
          END DO

! 19. sigma(j)=r(j)^{T}r(j), gamma'(j)=r(0)^{T}r(j)/sigma(j)
          DOTS(1) = CDOTC(LOCLEN,WRK(IR+I0),1,WRK(IR+I0),1)
          DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IR+I0),1)
          CALL PCSUM(2,DOTS)
          SIGMA(J) = DOTS(1)

          IF (SIGMA(J)==ZERO) THEN
            STATUS = -3
            STEPERR = 19
            GO TO 9999

          END IF

          GAMMA1(J) = DOTS(2)/SIGMA(J)
          I0 = I0 + LOCLEN
        END DO

! 20. gamma_{l}=omega=gamma'_{l}
!     gamma_{j}=gamma'_{j}-\sum_{i=j+1}^{l}{tau_{j,i}gamma_{i}}
        GAMMA(BASISDIM) = GAMMA1(BASISDIM)
        OMEGA = GAMMA(BASISDIM)
        DO J = BASISDIM - 1, 1, -1
          S = ZERO
          DO I = J + 1, BASISDIM
            S = S + TAU(J,I)*GAMMA(I)
          END DO
          GAMMA(J) = GAMMA1(J) - S
        END DO

! 21. gamma''=gamma_{j+1}+\sum_{i=j+1}^{l-1}{tau_{j,i}gamma_{i+1}}
        DO J = 1, BASISDIM - 1
          S = ZERO
          DO I = J + 1, BASISDIM - 1
            S = S + TAU(J,I)*GAMMA(I+1)
          END DO
          GAMMA2(J) = GAMMA(J+1) + S
        END DO

!  Update

! 22. x(0)=x(0)+gamma(1)r(0)
        CALL CAXPY(LOCLEN,CMPLX(GAMMA(1),KIND=WP),WRK(IR),1,X,1)

! 23. r(0)=r(0)-gamma'(l)r(l)
        CALL CAXPY(LOCLEN,CMPLX(-GAMMA1(BASISDIM),KIND=WP), &
          WRK(IR+BASISDIM*LOCLEN),1,WRK(IR),1)

! 24. u(0)=u(0)-gamma(l)u(l)
        CALL CAXPY(LOCLEN,CMPLX(-GAMMA(BASISDIM),KIND=WP), &
          WRK(IU+BASISDIM*LOCLEN),1,WRK(IU),1)

        I0 = LOCLEN
        DO J = 1, BASISDIM - 1

! 25. u(0)=u(0)-gamma(j)u(j), j=1:l-1
          CALL CAXPY(LOCLEN,CMPLX(-GAMMA(J),KIND=WP),WRK(IU+I0),1,WRK(IU),1)

! 26. x(0)=x(0)+gamma''(j)r(j), j=1:l-1
          CALL CAXPY(LOCLEN,CMPLX(GAMMA2(J),KIND=WP),WRK(IR+I0),1,X,1)

! 27. r(0)=r(0)-gamma'(j)r(j), j=1:l-1
          CALL CAXPY(LOCLEN,CMPLX(-GAMMA1(J),KIND=WP),WRK(IR+I0),1,WRK(IR),1)
          I0 = I0 + LOCLEN
        END DO

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCRBICGSTAB
    SUBROUTINE PIMCRGCR(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM,PSCNRM, &
        PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, XI
      REAL (WP) :: EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, I, IDOTS, IP, IQ, IR, ITNO, IW, &
        IXOLD, IZ, IZETA, J, J0, K, K1, LDA, LOCLEN, MAXIT, N, NPROCS, &
        PRECONTYPE, PROCID, STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(2)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CINIT, PIMSGETPAR, STOPCRIT
!     ..

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Does not need conversion Y=Q2X for residual
      CNVRTX = 0

!  Set indices for mapping local vectors into wrk
      IR = 1
      IP = IR + LOCLEN
      IW = IP + BASISDIM*LOCLEN
      IZETA = IW + BASISDIM*LOCLEN
      IZ = IZETA + BASISDIM
      IQ = IZ + LOCLEN
      IXOLD = IQ + LOCLEN
      IDOTS = IXOLD + BASISDIM

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      DO ITNO = 1, MAXIT

!  2. p(1)=r
        CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP),1)

        K = 0
        DO J = 1, BASISDIM
          J0 = J - 1

!  3. w(j)=Q1AQ2p(j)
          IF (PRECONTYPE==0) THEN
            CALL MATVEC(WRK(IP+K),WRK(IW+K),IPAR)

          ELSE IF (PRECONTYPE==1) THEN
            CALL MATVEC(WRK(IP+K),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IW+K),IPAR)

          ELSE IF (PRECONTYPE==2) THEN
            CALL PRECONR(WRK(IP+K),WRK(IZ),IPAR)
            CALL MATVEC(WRK(IZ),WRK(IW+K),IPAR)

          ELSE IF (PRECONTYPE==3) THEN
            CALL PRECONR(WRK(IP+K),WRK(IW+K),IPAR)
            CALL MATVEC(WRK(IW+K),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IW+K),IPAR)
          END IF

!  4. zeta(j)=dot(w(j),w(j))
          DOTS(1) = CDOTC(LOCLEN,WRK(IW+K),1,WRK(IW+K),1)

!  5. xi=dot(r,w(j))
          DOTS(2) = CDOTC(LOCLEN,WRK(IR),1,WRK(IW+K),1)

!  Accumulate simultaneously partial values
          CALL PCSUM(2,DOTS)
          WRK(IZETA+J0) = DOTS(1)
          XI = DOTS(2)

!  5. alpha=xi/zeta(j)
          IF (WRK(IZETA+J0)==CZERO) THEN
            STATUS = -3
            STEPERR = 5
            GO TO 9999

          END IF

          ALPHA = XI/WRK(IZETA+J0)

!  6. x=x+alpha*p(j)
          CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
          CALL CAXPY(LOCLEN,ALPHA,WRK(IP+K),1,X,1)

!  7. r=r-alpha*w(j)
          CALL CAXPY(LOCLEN,-ALPHA,WRK(IW+K),1,WRK(IR),1)

!  8. check stopping criterion
          CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IQ),RHSSTOP,CNVRTX, &
            EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM)

!  Call monitoring routine
          CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

          IF (STATUS==0) THEN
            GO TO 9999
          END IF

!  9. q=Q1AQ2r
          IF (PRECONTYPE==0) THEN
            CALL MATVEC(WRK(IR),WRK(IQ),IPAR)

          ELSE IF (PRECONTYPE==1) THEN
            CALL MATVEC(WRK(IR),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IQ),IPAR)

          ELSE IF (PRECONTYPE==2) THEN
            CALL PRECONR(WRK(IR),WRK(IZ),IPAR)
            CALL MATVEC(WRK(IZ),WRK(IQ),IPAR)

          ELSE IF (PRECONTYPE==3) THEN
            CALL PRECONR(WRK(IR),WRK(IQ),IPAR)
            CALL MATVEC(WRK(IQ),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IQ),IPAR)
          END IF

! 10. p(j+1)=r-sum_{i=1}^{j}{dot(q,w(i))/zeta(i)*p(i)}
          IF (J<BASISDIM) THEN

!  Compute partial inner-products
            K1 = 0
            DO I = 0, J - 1
              WRK(IDOTS+I) = CDOTC(LOCLEN,WRK(IQ),1,WRK(IW+K1),1)
              K1 = K1 + LOCLEN
            END DO

!  Accumulate simultaneously partial values
            CALL PCSUM(J,WRK(IDOTS))

!  Compute summation
            CALL CINIT(LOCLEN,CZERO,WRK(IZ),1)
            K1 = 0
            DO I = 0, J - 1
              BETA = WRK(IDOTS+I)/WRK(IZETA+I)
              CALL CAXPY(LOCLEN,BETA,WRK(IP+K1),1,WRK(IZ),1)
              K1 = K1 + LOCLEN
            END DO

!  Compute p(j+1)
            K = K + LOCLEN
            CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IP+K),1)
            CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP+K),1)
          END IF

        END DO

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCRGCR
    SUBROUTINE PIMCTFQMR(X,B,WRK,IPAR,SPAR,MATVEC,PRECONL,PRECONR,PCSUM, &
        PSCNRM2,PROGRESS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!     National Supercomputing Centre and Mathematics Institute
!         Universidade Federal do Rio Grande do Sul, Brasil

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0E0_WP,0.0E0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
!Art      PARAMETER (SPARSIZ=2)
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*), X(*)
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM2
      EXTERNAL PSCNRM2
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONL, PRECONR, PROGRESS
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: ALPHA, BETA, C, ETA, ETA0, KAPPA, RHO, RHO0, SIGMA, TAU, &
        TAU0, THETA, THETA0
      REAL (WP) :: CHANGETEST, EPSILON, EXITNORM, RHSSTOP
      INTEGER :: BASISDIM, BLKSZ, CNVRTX, ID, IM, IM0, IP, IR, IRTILDE, ITNO, &
        IV, IW, IXOLD, IY, IY0, IZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, &
        PROCID, STATUS, STEPERR, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(1)
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CDOTC
      REAL (WP) :: SCSETRHSSTOP
      EXTERNAL CDOTC, SCSETRHSSTOP
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY, CINIT, PIMSGETPAR, STOPCRIT
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS, REAL, SQRT
!     ..

      CALL PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)

!  Check consistency of preconditioning and stop types
      IF (((PRECONTYPE==0) .OR. (PRECONTYPE==2)) .AND. (STOPTYPE==6)) THEN
        ITNO = 0
        STATUS = -4
        STEPERR = 0
        GO TO 9999

      END IF

!  Needs conversion Y=Q2X for residual
      CNVRTX = 1

!  Set indices for mapping local vectors into wrk
      IR = 1
      IRTILDE = IR + LOCLEN
      IY = IRTILDE + LOCLEN
      IY0 = IY + LOCLEN
      IW = IY0 + LOCLEN
      IV = IW + LOCLEN
      ID = IV + LOCLEN
      IZ = ID + LOCLEN
      IP = IZ + LOCLEN
      IXOLD = IP + LOCLEN

!  Set rhs of stopping criteria
      RHSSTOP = SCSETRHSSTOP(B,WRK(IR),EPSILON,IPAR,PRECONL,PSCNRM2)

!  1. r=Q1(b-AQ2x)
      IF (STOPTYPE/=6) THEN
        IF (PRECONTYPE==0) THEN
!     r=b-Ax
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IW),1,WRK(IZ),1)
          CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
          CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL CCOPY(LOCLEN,B,1,WRK(IP),1)
          CALL PRECONR(X,WRK(IW),IPAR)
          CALL MATVEC(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IP),1)
          CALL PRECONL(WRK(IP),WRK(IR),IPAR)
        END IF

      ELSE
!     r has been set to Qb in the call to dsetrhsstop
        IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
          CALL MATVEC(X,WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

        ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
          CALL PRECONR(X,WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IW),IPAR)
          CALL PRECONL(WRK(IW),WRK(IZ),IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)
        END IF

      END IF

!  2. w=y=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IW),1)
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IY),1)

!  3. v=Q1AQ2y
      IF (PRECONTYPE==0) THEN
        CALL MATVEC(WRK(IY),WRK(IV),IPAR)

      ELSE IF (PRECONTYPE==1) THEN
        CALL MATVEC(WRK(IY),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IV),IPAR)

      ELSE IF (PRECONTYPE==2) THEN
        CALL PRECONR(WRK(IY),WRK(IZ),IPAR)
        CALL MATVEC(WRK(IZ),WRK(IV),IPAR)

      ELSE IF (PRECONTYPE==3) THEN
        CALL PRECONR(WRK(IY),WRK(IV),IPAR)
        CALL MATVEC(WRK(IV),WRK(IZ),IPAR)
        CALL PRECONL(WRK(IZ),WRK(IV),IPAR)
      END IF

!  4. d=0
      CALL CINIT(LOCLEN,CZERO,WRK(ID),1)

!  5. tau=||r||2
      TAU = PSCNRM2(LOCLEN,WRK(IR))

!  6. theta=eta=0
      THETA = CZERO
      ETA = CZERO

!  7. rtilde=r
      CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IRTILDE),1)

!  8. rho=dot(rtilde,r)
      DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IR),1)
      CALL PCSUM(1,DOTS)
      RHO = DOTS(1)

!  Loop
      STATUS = 0
      EXITNORM = -ONE
      STEPERR = -1
      CHANGETEST = -1
      IM0 = 1
      DO ITNO = 1, MAXIT
!  9. sigma=dot(rtilde,v)
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IV),1)
        CALL PCSUM(1,DOTS)
        SIGMA = DOTS(1)

! 10. alpha=rho/sigma
        IF (SIGMA==CZERO) THEN
          STATUS = -3
          STEPERR = 10
          GO TO 9999

        END IF

        ALPHA = RHO/SIGMA

! 11. y=y0-alpha*v
        CALL CCOPY(LOCLEN,WRK(IY),1,WRK(IY0),1)
        CALL CAXPY(LOCLEN,-ALPHA,WRK(IV),1,WRK(IY),1)

        DO IM = IM0, IM0 + 1

! 12. w=w-alpha*Q1AQ2y0
          IF (PRECONTYPE==0) THEN
            CALL MATVEC(WRK(IY0),WRK(IP),IPAR)

          ELSE IF (PRECONTYPE==1) THEN
            CALL MATVEC(WRK(IY0),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IP),IPAR)

          ELSE IF (PRECONTYPE==2) THEN
            CALL PRECONR(WRK(IY0),WRK(IZ),IPAR)
            CALL MATVEC(WRK(IZ),WRK(IP),IPAR)

          ELSE IF (PRECONTYPE==3) THEN
            CALL PRECONR(WRK(IY0),WRK(IP),IPAR)
            CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
            CALL PRECONL(WRK(IZ),WRK(IP),IPAR)
          END IF

          CALL CAXPY(LOCLEN,-ALPHA,WRK(IP),1,WRK(IW),1)

! 13. theta=||w||_2/tau0
          THETA0 = THETA
          TAU0 = TAU
          IF (TAU0==CZERO) THEN
            STATUS = -3
            STEPERR = 13
            GO TO 9999

          END IF

          THETA = PSCNRM2(LOCLEN,WRK(IW))/TAU0

! 14. c=1/sqrt(1+theta^2)
          C = CONE/SQRT(CONE+THETA*THETA)

! 15. tau=tau0*theta*c
          TAU = TAU0*THETA*C

! 16. eta=(c^2)*alpha
          ETA0 = ETA
          ETA = C*C*ALPHA

! 17. d=y0+((theta0^2)*eta0/alpha)*d
          IF (ALPHA==CZERO) THEN
            STATUS = -3
            STEPERR = 17
            GO TO 9999

          END IF

          CALL CCOPY(LOCLEN,WRK(ID),1,WRK(IP),1)
          CALL CCOPY(LOCLEN,WRK(IY0),1,WRK(ID),1)
          CALL CAXPY(LOCLEN,THETA0*THETA0*ETA0/ALPHA,WRK(IP),1,WRK(ID),1)

! 18. x=x+eta*d
          CALL CCOPY(LOCLEN,X,1,WRK(IXOLD),1)
          CALL CAXPY(LOCLEN,ETA,WRK(ID),1,X,1)

! 19. kappa=tau*sqrt(m+1)
          KAPPA = SQRT(REAL(IM+1,KIND=WP))*TAU

! 20. check stopping criterion
          IF (ABS(KAPPA)<EPSILON) THEN

!     r=Q1(b-AQ2x)
            IF (PRECONTYPE==0) THEN
!     r=b-Ax
              CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
              CALL MATVEC(X,WRK(IP),IPAR)
              CALL CAXPY(LOCLEN,-CONE,WRK(IP),1,WRK(IR),1)
              CALL CCOPY(LOCLEN,WRK(IR),1,WRK(IZ),1)

            ELSE IF (PRECONTYPE==1) THEN
!     r=Q1(b-Ax)
              CALL CCOPY(LOCLEN,B,1,WRK(IZ),1)
              CALL MATVEC(X,WRK(IP),IPAR)
              CALL CAXPY(LOCLEN,-CONE,WRK(IP),1,WRK(IZ),1)
              CALL PRECONL(WRK(IZ),WRK(IR),IPAR)

            ELSE IF (PRECONTYPE==2) THEN
!     r=b-AQ2x
              CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
              CALL PRECONR(X,WRK(IP),IPAR)
              CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
              CALL CAXPY(LOCLEN,-CONE,WRK(IZ),1,WRK(IR),1)

            ELSE IF (PRECONTYPE==3) THEN
!     r=Q1(b-AQ2x)
              CALL CCOPY(LOCLEN,B,1,WRK(IR),1)
              CALL PRECONR(X,WRK(IZ),IPAR)
              CALL MATVEC(WRK(IZ),WRK(IP),IPAR)
              CALL CAXPY(LOCLEN,-CONE,WRK(IP),1,WRK(IR),1)
              CALL PRECONL(WRK(IR),WRK(IZ),IPAR)
              CALL CCOPY(LOCLEN,WRK(IZ),1,WRK(IR),1)
            END IF

            CALL STOPCRIT(B,WRK(IR),WRK(IZ),X,WRK(IXOLD),WRK(IP),RHSSTOP, &
              CNVRTX,EXITNORM,STATUS,IPAR,MATVEC,MATVEC,PRECONR,PCSUM,PSCNRM2)

!  Call monitoring routine
            CALL PROGRESS(LOCLEN,ITNO,EXITNORM,X,WRK(IR),WRK(IZ))

            IF (STATUS==0) THEN
              GO TO 9999
            END IF

          ELSE
!  Call monitoring routine
! 04.05.21 (BTD) correction: replace KAPPA by ABS(KAPPA)

            CALL PROGRESS(LOCLEN,ITNO,ABS(KAPPA),X,WRK(IR),WRK(IZ))

          END IF

!  y0=y
          CALL CCOPY(LOCLEN,WRK(IY),1,WRK(IY0),1)

        END DO

! 21. rho=dot(rtilde,w)
        RHO0 = RHO
        DOTS(1) = CDOTC(LOCLEN,WRK(IRTILDE),1,WRK(IW),1)
        CALL PCSUM(1,DOTS)
        RHO = DOTS(1)

! 22. beta=rho/rho0
        IF (RHO0==CZERO) THEN
          STATUS = -3
          STEPERR = 22
          GO TO 9999

        END IF

        BETA = RHO/RHO0

! 23. y=w+beta*y0
        CALL CCOPY(LOCLEN,WRK(IW),1,WRK(IY),1)
        CALL CAXPY(LOCLEN,BETA,WRK(IY0),1,WRK(IY),1)

! 24. v=Q1AQ2y+beta*(Q1AQ2y0+beta*v)

        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IY0),WRK(IP),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IY0),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IP),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IY0),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IP),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IY0),WRK(IP),IPAR)
          CALL MATVEC(WRK(IP),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IP),IPAR)
        END IF

        CALL CAXPY(LOCLEN,BETA,WRK(IV),1,WRK(IP),1)

        IF (PRECONTYPE==0) THEN
          CALL MATVEC(WRK(IY),WRK(IV),IPAR)

        ELSE IF (PRECONTYPE==1) THEN
          CALL MATVEC(WRK(IY),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IV),IPAR)

        ELSE IF (PRECONTYPE==2) THEN
          CALL PRECONR(WRK(IY),WRK(IZ),IPAR)
          CALL MATVEC(WRK(IZ),WRK(IV),IPAR)

        ELSE IF (PRECONTYPE==3) THEN
          CALL PRECONR(WRK(IY),WRK(IV),IPAR)
          CALL MATVEC(WRK(IV),WRK(IZ),IPAR)
          CALL PRECONL(WRK(IZ),WRK(IV),IPAR)
        END IF

        CALL CAXPY(LOCLEN,BETA,WRK(IP),1,WRK(IV),1)

        IM0 = IM0 + 2

      END DO

      IF (ITNO>MAXIT) THEN
        STATUS = -1
        ITNO = MAXIT
        IF (EXITNORM==(-ONE)) THEN
          EXITNORM = KAPPA
        END IF

      END IF

9999  CONTINUE

      IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
        CALL CCOPY(LOCLEN,X,1,WRK(IZ),1)
        CALL PRECONR(WRK(IZ),X,IPAR)
      END IF

!  Set output parameters
      IPAR(11) = ITNO
      IPAR(12) = STATUS
      IPAR(13) = STEPERR
      SPAR(2) = EXITNORM

      RETURN

    END SUBROUTINE PIMCTFQMR

    SUBROUTINE DIELEC(WAVE,IDVOUT,CFLEPS,CXEPS,MXCOMP,MXWAVT,NCOMP,E1A,E2A,WVA)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: MXCOMP,MXWAVT
      CHARACTER(60) :: &
         CFLEPS(MXCOMP)
      COMPLEX(WP) :: &
         CXEPS(MXCOMP)
      INTEGER :: IDVOUT,NCOMP
      REAL(WP) :: WAVE
      REAL(WP) ::     &
         E1A(MXWAVT), &
         E2A(MXWAVT), &
         WVA(MXWAVT)

! Local Variables:

      LOGICAL :: INIT
      CHARACTER(70) :: CMSGNM
      CHARACTER(80) :: CDESCR
      COMPLEX(WP) :: CXI
      INTEGER :: I,J,JJ,NWAVT,IWV,IREN,IIMN,IEPS1,IEPS2,ICOL
      REAL(WP) :: DUM1,DUM2,E1,E2,TEMP
      REAL(WP) :: & 
         XIN(10)
      EXTERNAL ERRMSG
      SAVE CXI,IEPS1,INIT,NWAVT
!**********************************************************************
! Given:
!       WAVE = wavelength (micron)
!       IDVOUT=output unit number
!       CFLEPS(1-NCOMP) = names of files containing dielectric data
!       MXCOMP,MXWAVT = dimensioning information
!       NCOMP = number of components
!       NWAV = number of wavelengths
!       E1A, E2A, WVA = scratch arrays
! Returns:
!       CXEPS(1-NCOMP) = dielectric constant for materials
!                        1-NCOMP
! NOTE:
!       It is assumed that file(s) containing
!       the table(s) will have following format:
! line1 = description (CHARACTER*80)
! line2 = IWV, IREN, IIMN, IEPS1, IEPS2
!         where IWV = column in which wavelengths are tabulated
!               IREN = col. in which Re(N) is tabulated (0 if not)
!               IIMN = col. in which Im(N) is tabulated (0 if not)
!               IEPS1= col. in which Re(EPS) is tabulated (0 if not)
!               IEPS2= col. in which Im(EPS) is tabulated (0 if not)
! line3 = header line (will not be read)
! line4... = data, according to columns specified on line2
! wavelengths must be monotonic, either increasing or decreasing

! B.T.Draine, Princeton Univ. Obs.
! History:
! 90.12.04 (BTD): Rewritten to allow H2OICE and H2OLIQ options.
! 90.12.21 (BTD): Correct handling of 'TABLES' option when more than
!                 one wavelength is considered.
! 91.05.02 (BTD): Added IDVOUT to argument list for subr. INTERP
! 91.09.12 (BTD): Moved declaration of MXCOMP and MWAVT ahead of
!                 declaration of CFLEPS and CXEPS
! 93.12.06 (BTD): Added IEPS1,INIT, and NWAVT to SAVE statement
!                 (without this did not run properly on SGI Indigo)
! 96.12.16 (BTD): Corrected temperature to T=250K in output statement
!                 for H2OICE option
! 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
!                 CHARACTER*60 to allow longer file names
!                 (also changed in reapar.f and DDSCAT.f)
! 04.10.14 (BTD): added check to ensure that user does not specify
!                 refractive index = 1 (this would cause division
!                 by zero elsewhere in code)
! 07.07.30 (PJF): Converted to f90
! 07.07.31 (BTD): Removed calls to REFWAT and REFICE
! 07.10.28 (BTD): Eliminated CDIEL -- reading from tables is standard
!                 Added output line just before table read as clue in
!                 case of failure during table read.
! 09.10.19 (BTD): Added some more output to report begin/end reading file
! Copyright (C) 1993,1996,1998,2004,2007,2009 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DATA CXI/(0._WP,1._WP)/,INIT/.TRUE./

      IF(INIT.OR.NCOMP>1)THEN
         DO J=1,NCOMP
            WRITE(CMSGNM,FMT='(A)')'about to read file ='
            CALL WRIMSG('DIELEC',CMSGNM)
            CALL WRIMSG('DIELEC',CFLEPS(J))
            OPEN(UNIT=3,FILE=CFLEPS(J),STATUS='OLD')

! Read header line:

            READ(3,9000)CDESCR
            CALL WRIMSG('DIELEC',CDESCR)
!            WRITE(IDVOUT,9000)CDESCR

! Read line specifying columns for wavelength,Re(n),Im(n),Re(eps),Im(eps
!            write(0,*)'dielec ckpt 1, j=',j
            READ(3,*)IWV,IREN,IIMN,IEPS1,IEPS2
!            write(0,*)'dielec ckpt 1.1, iwv,iren,iimn,ieps1,ieps2=', &
!                      iwv,iren,iimn,ieps1,ieps2
            ICOL=IWV
            IF(IREN>ICOL)ICOL=IREN
            IF(IIMN>ICOL)ICOL=IIMN
            IF(IEPS1>ICOL)ICOL=IEPS1
            IF(IEPS2>ICOL)ICOL=IEPS2

! Skip header line:

            READ(3,*)
            DO I=1,MXWAVT
               READ(3,*,END=600)(XIN(JJ),JJ=1,ICOL)
               WVA(I)=XIN(IWV)
               IF(IEPS1>0)THEN
                  E1A(I)=XIN(IEPS1)
                  E2A(I)=XIN(IEPS2)
               ELSE
                  E1A(I)=XIN(IREN)
                  E2A(I)=XIN(IIMN)
               ENDIF
               NWAVT=I
            ENDDO

! Check whether there is unread data remaining in file

            READ(3,*,END=600)(XIN(JJ),JJ=1,ICOL)

! If this point is reached, apparently unread data remains, so
! issue warning:

            CALL ERRMSG('WARNING','DIELEC', &
                        'parameter MXWAVT not large enough to read full dielec file')
600         CLOSE(3)

! 091019 BTD added
!            write(0,*)' dielec ckpt 2, j=',j,' cfleps(j)=',cfleps(j)
! ------
            WRITE(CMSGNM,FMT='(A,A)')' completed reading file ='
            CALL WRIMSG('DIELEC',CMSGNM)
            CALL WRIMSG('DIELEC',CFLEPS(J))

!*** Have completed reading in table for this composition.
!    Now interpolate

            CALL INTERP(WAVE,E1,E2,WVA,E1A,E2A,IDVOUT,MXWAVT,NWAVT)
            IF(IEPS1>0)THEN
               CXEPS(J)=E1+CXI*E2
            ELSE
               CXEPS(J)=(E1**2-E2**2)+2._WP*CXI*E1*E2
            ENDIF

! check that user has not specified refractive index = 1
! issue fatal warning if this occurs

            IF(CXEPS(J)==1._WP)CALL ERRMSG('FATAL','DIELEC', &
               'Refractive index = 1 is not allowed: should leave unoccupied')

         ENDDO
         INIT=.FALSE.
      ELSE

!*** Perform this only if NCOMP=1 and previously initialized:

         CALL INTERP(WAVE,E1,E2,WVA,E1A,E2A,IDVOUT,MXWAVT,NWAVT)
         IF(IEPS1>0)THEN
            CXEPS(1)=E1+CXI*E2
         ELSE
            CXEPS(1)=(E1**2-E2**2)+2._WP*CXI*E1*E2
         ENDIF
      ENDIF
      RETURN
9000  FORMAT (A80)
    END SUBROUTINE DIELEC

    SUBROUTINE RESTORE(CXV,CXUNOC,IOCC,MXN3,MXNAT,NAT,NAT0)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!***********************************************************************
! Given:
!      CXV(1-3*NAT0) defined for NAT0 occupied lattice sites
!      IOCC(1-NAT) = 0 or 1 depending on whether lattice site
!                      is vacant or occupied
!      CXUNOC      = value to use for unoccupied sites
!      MXN3,MXNAT  = dimensioning information
!      NAT         = number of lattice sites
!      NAT0        = number of occupied lattice sites
! Returns
!      CXV(1-3*NAT) defined for NAT lattice sites, occupied and
!                   unoccupied, with CXV(J)=CXUNOC for unoccupied sites
! Arguments:
      INTEGER :: MXN3, MXNAT, NAT, NAT0
      INTEGER*2 :: IOCC(MXNAT)
      COMPLEX (WP) :: CXUNOC
      COMPLEX (WP) :: CXV(MXN3)
! Local variables:
      INTEGER :: J, JUN, M

! B.T.Draine, Princeton Univ. Observatory
! History:
! 98.01.01 (BTD): Created for use in DDSCAT.6
! 06.07.07 (BTD): corrected typo in comments
! end history

! Copyright (C) 1998,2006 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DO M = 2, 0, -1
        JUN = NAT - NAT0
        DO J = NAT, 1, -1
          IF (IOCC(J)==0) THEN
            JUN = JUN - 1
            CXV(J+M*NAT) = CXUNOC
          ELSE
            CXV(J+M*NAT) = CXV(M*NAT0+J-JUN)
          END IF
        END DO
      END DO
      RETURN
    END SUBROUTINE RESTORE

    PROGRAM DDSCAT
!-------------------------------- v7.0.7 -------------------------------
      USE DDPRECISION,ONLY: WP
      USE DDCOMMON_1,ONLY: AKR,DX
      USE DDCOMMON_2,ONLY: CXADIA
      USE DDCOMMON_3,ONLY: CXZC
      USE DDCOMMON_4,ONLY: CXZW
      USE DDCOMMON_5,ONLY: IOCC
      USE DDCOMMON_6,ONLY: GAMMA,PYD,PZD,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, &
                           NAT0,NX,NY,NZ,MXN3F,IDVOUT,IPBC
      USE DDCOMMON_7,ONLY: CXAOFF
      USE DDCOMMON_8,ONLY: CMDFFT
      USE DDCOMMON_10,ONLY: MYID
      IMPLICIT NONE

!-----------------------------------------------------------------------

!           Instructions for Enabling or Disabling MPI
!           ==========================================

! To enable MPI use (this requires that you have installed the "full"
! version of DDSCAT):
!                      uncomment INCLUDE 'mpif.h' statement
!                      comment out INTEGER MPI_COMM_WORLD statement
!                      compile mpi_subs.f

! For non-MPI version (either the "plain" version of DDSCAT, or the
! "full" version with MPI support disabled:

!                      comment out INCLUDE 'mpif.h' statement
!                      uncomment INTEGER MPI_COMM_WORLD statement
!                      compile mpi_fake.f

#ifdef mpi
      INCLUDE 'mpif.h'
#endif
#ifndef mpi
      INTEGER :: MPI_COMM_WORLD
#endif

!-----------------------------------------------------------------------

!**********************************************************************

!    DDSCAT is a program to use the Discrete Dipole Approximation (DDA)
!    to calculate the absorption and scattering properties of targets
!    of arbitrary geometry and dielectric properties.  The only
!    approximation is that the target may be approximated by an array
!    of point dipoles on a cubic lattice.
!    DDA theory and validity criteria are discussed in
!    Draine, B.T. 1988,
!       "The Discrete-Dipole Approximation and its Application to
!       Interstellar Graphite Grains",
!       Astrophys. J., 333, pp. 848-872
!    Draine, B.T., & Flatau, P.J. 1994,
!       "Discrete dipole approximation for scattering calculations",
!       J. Opt. Soc. Am. A, 11, 1491-1499

!    The original version of DDSCAT was developed by B. T. Draine,
!    Princeton University Observatory.

!    Subsequent versions  of DDSCAT were jointly developed by
!    B. T. Draine (Princeton University Observatory) and
!    P. J. Flatau (University of California, San Diego, Scripps Inst.
!                  of Oceanography, La Jolla)

!    DDSCAT.7.0.4 includes the following features:
!    1. Optional generation of target arrays for to approximate several
!       standard target shapes, including
!       a. ellipsoid (sphere is special case) ("ELLIPSOID")
!       b. cylindrical prism ("CYLINDER1")
!       c. rectangular prism ("RCTGLPRSM")
!       d. hexagonal prism ("HEX_PRISM")
!       e. regular tetrahedron ("TETRAHDRN")
!       f. cylindrical prism with anisotropic diel. tensor ("UNIAXICYL")
!          (uniaxial material with crystal axis = cylinder axis)
!       g. ellipsoid with anisotropic diel. tensor ("ANIELLIPS")
!       h. two touching ellipsoids with either isotropic or aniostropic
!          dielectric tensors ("ELLIPSO_2" or "ANI_ELL_2")
!       i. three thouching ellipsoids with either isotropic or aniostrop
!          dielectric constants ("ELLIPSO_3" or "ANI_ELL_3")
!       j. two concentric ellipsoids ("CONELLIPS")
!       k. target consisting of cubic blocks ("MULTBLOKS")
!       l. target consisting of union of N spheres ("SPHERES_N")
!       m. triangular prism ("TRNGLPRSM")
!       n. layered slab ("LAYRDSLAB")
!       ... and additional target options (see UserGuide)
!    2. Alternatively, program may read in target array properties from
!       ascii file ("FROM_FILE")
!    3. User may easily specify target orientation with respect to
!       incident plane wave.
!    4. Solution is found iteratively using Complex Conjugate Gradient
!       methods.
!    5. User may select FFT implementation:
!       a. GPFA code of Temperton (recommended for general use).
!       b. FFTW code of Frigo and Johnson
!       c. Convex vector library implementation (if on Convex);
!    6. User may select prescription for determining dipole
!       polarizabilities:
!       a. 'LATTDR' = Lattice Dispersion Relation of 
!                     Draine & Goodman 1993
!       b. 'GKDLDR' = Lattice Dispersion Relation of
!                     Gutkowicz-Krusin & Draine 2004
!    7. Automatic computation of cross sections for:
!       a. absorption;
!       b. extinction;
!       c. scattering;
!       d. vector radiation pressure;
!       e. vector torque.
!    8. User may easily specify scattering directions for which
!       scattering matrixs is to be computed.
!    9. Automatic computation of orientational averages, with
!       orientation weights provided by simple subroutine.
!   10. Multicomponent targets are allowed.
!   11. Anisotropic dielectric tensors are allowed, although with
!       the restriction that the principal axes must be aligned with
!       the xyz directions in the "target frame".
!   12. Wavelength-dependent dielectric functions are read from user-
!       provided files, with automatic interpolation if necessary.
!   13. Automatic looping over radii and wavelengths if desired.
!   14. User may select up to nine Mueller matrix elements for
!       computation.
!   15. DDSCAT.6.0 introduces support for MPI (Message Passing Interface
!       for parallel computations of different scattering orientations.
!   16. New with DDSCAT.6.1:
!       Automatic selection of scattering directions for computation
!       of angular averages: radiation pressure force, <cos>, <cos^2>,
!       and radiation torque.  User sets a single parameter ETASCA
!       which controls angular resolution.  Reducing ETASCA will lead
!       to greater accuracy in calculation of angular averages.
!       ETASCA=1 should provide accuracy of better than 1% for angular
!       averages.
!   17. New with DDSCAT 6.2:
!       gaussian sphere targets
!       arbitrary orientation of anisotropic constituent material
!   18. New with DDSCAT 7.0:
!       support for infinite periodic targets
! History:
! Note: Overall history of significant changes to the DDSCAT package may
!       be found in the comments in subroutine version.f .
! Here we limit comments to changes to this program module, DDSCAT.f:
! 90.11.30 (BTD): Removed LSC3 portion of CXSC complex scratch space.
! 90.12.03 (BTD): Reordered vectors.
!                 Removed LSC2 and LSC1 portions of CXSC scratch space.
! 90.12.21 (BTD): Added code to create output files
!                 'qtable' (summary of Q values)
!                 'mtable' (summary of diel. func. for material 1)
! 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list for REAPAR
! 91.01.05 (BTD): Changed I4 -> I7 in format statements 9010,9011.
!                 Set IOSHP=-1 to suppress printing of target.out file.
! 91.05.08 (BTD): Added CALPHA to argument lists for REAPAR and ALPHA
!                 and added CALPHA to various WRITE statements.
! 91.05.23 (BTD): Added IWRKSC to arg. list for REAPAR and use it to
!                 control creation of wAArBBkCCC.sca files
!                 Move lines calculating G.
!                 Move code writing to qtable and mtable.
!                 Added IDVOUT to argument list for TARGET
! 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
!                 Modify code to print out Q_bk
! 91.08.15 (BTD): Provide different headings for qtable depending on
!                 whether IORTH=1 or 2 (add statement 9043).
! 91.09.17 (BTD): Remove calls to ALPHA and EVALA (needed to move these
!                 to subroutine GETFML since alpha from Lattice
!                 Dispersion Relation depends on propagation direction
!                 and polarization state)
!                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
!                 GETFML (information required by ALPHA)
! 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
!                 (device number for REASHP to use in reading shape file
! 93.01.15 (BTD): Divided output file qtable into 2 files:
!                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
!                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
! 93.01.16 (BTD): Modify so that qtable, qtable2, and mtable are closed
!                 after writing, and reopened for each new write
! 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
!                 EXTEND to permit checking of target size against
!                 maximum allowed dimensions
! 93.03.11 (BTD): Deleted all code associated with unused variable
!                 CMACHN (originally included to identify machine/OS)
! 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
!                 Moved WRITE(IDVOUT,9010) to subr. TARGET
! 93.06.02 (BTD): Corrected error in FORMAT statement 9045
! 93.06.03 (BTD): Corrected error in computation of angle-averaged
!                 backscattering cross section QBKSUM(JO) (had neglected
!                 to reset sum to zero for each new target).
! 93.09.28 (BTD): Add "fix" to work around Sun compiler/OS bug (see
!                 description below.
! 93.12.15 (BTD): Corrected calculation of PPOL.  Added comments on
!                 correspondence between our notation and elements
!                 of 2x2 amplitude scattering matrix and 4x4 Mueller
!                 scattering matrix.
! 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
!                 allow up to 6 shape parameters
! 94.06.20 (PJF): Comment about NEWTMP FFT and corresponding changes
!                 in reapar, eself, extend.  Add FFT timing code
!                 TSTFFT to distribution and changes to cxfft3 and
!                 timeit routines.
! 94.12.20 (BTD): Introduce subroutine VERSION to set value of
!                 variable CSTAMP.  version.f will now serve as
!                 location to maintain log of significant code
!                 changes.
! 95.06.15 (BTD): Changed CSTAMP from character*11 to character*22
!                 to include a date.
! 95.06.14 (BTD): Create version 5x.1 for internal use.
!                 Version 5x.1 computes vector force and torque
!                 on grain due to incident radiation.
!                 Changed QSCATG(2) to QSCAG(3,2) to allow for
!                 asymmetric scattering by target.
!                 Added variable QTRQSC(1-3,1-2) and added to
!                 argument list of GETFML
!                 Replaced variable GSUM(1-2) to QSCGSUM(1-3,1-2)
!                 Added variables QTRQAB(1-3,1-2) and
!                 QTRQABSUM(1-3,1-2)
! 95.06.20 (PJF+: Introduce changes into DDSCAT in order to support
!           BTD): use of modular iterative solvers (e.g., CCG).
!               : add CMDSOL to argument list to specify method
!                 of solution
!               : add CMDTRQ to argument list of REAPAR and GETFML
! 95.07.10 (BTD): deleted redundant declarations of NAT,NAT0,NAT3,
!                 NX,NY,NZ (already declared in COMMON/M6/
! 95.07.20 (BTD): added new scratch array SCRRS2(MXNAT) for use in
!                 torque calculations in SCAT
! 95.07.27 (BTD): Added new scratch variable CXSCR1 for GETFML to
!                 use for storing first polarization solution while
!                 solving for second.
! 96.01.26 (BTD): Replaced IX0,IY0,IZ0 by IXYZ0
!                 (with simultaneous change in TARGET)
! 96.02.23 (BTD): Modified format statements to get additional digits
!                 for a_1, a_2, k vector, and pol. vectors.
! 96.11.05 (BTD): Modified to remove various computations to
!                 subroutines GETMUELLER and WRITESCA
! 96.11.14 (PJF): Add TIMERS, MXTIMERS, NTIMERS
!                 Add cbinflag, cbinfile, IOBIN (binary file)
!                 Add cbinflag to formal parameters of REAPAR routine
!                 Remove GETSET routine calls
! 96.11.15 (PJF): Add cnetflag, cnetfile to reapar call. Add netCDF clos
! 96.11.21 (BTD): Declared IDNC,NTIMERS,etc.
!                 Removed call to NCCLOS
!                 Added call to WRITESCA in order to call WRITENET in
!                 order to call NCCLOS in order to close netCDF file
! 96.12.02 (BTD): initialized smori to zero before looping over
!                 orientations
!                 eliminated variables S1212,S222,CX1112,CX1122,
!                 CX1221,CX1222,CX2122
! 97.07.24 (BTD): Changed argument list for GETMUELLER, replacing
!                 PHI by PHIN, in order to correct error in computation
!                 of Mueller matrix elements and amplitude scattering
!                 matrix elements (see GETMUELLER).
! 97.11.01 (BTD): Modified to allow noncubic rectangular lattice.
!                 Information on lattice anisotropy is contained
!                 in variable DX(1-3)=(dx/d,dy/d,dz/d) where
!                 dx,dy,dz=lattice spacings in x,y,z directions
!                 d=(dx*dy*dz)**(1/3)
!                 Note that by definition, DX(1)*DX(2)*DX(3)=1
!                 Pass DX through COMMON/M1/ for use by subroutines
!                 MATVEC and CMATVEC
! 97.12.25 (BTD): Added CXAOFF to COMMON/M7/
! 98.01.13 (BTD): Added DX to argument list in last 2 calls to WRITESCA
! 98.05.01 (BTD): Removed DATA/IDVOUT/0 since IDVOUT is in COMMON
!                 Reduced number of continuation lines in CALL WRITESCA
!                 statements
! 98.08.09 (BTD): Slight change to FORMAT statement 9020
! 98.12.12 (BTD): Add NSMELTS,SMIND1,SMIND2 to argument lists of REAPAR
!                 and WRITESCA, to allow selection of Muller matrix
!                 elements
! 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
!                 CHARACTER*60 to allow longer file names
!                 (also changed in reapar.f and dielec.f)
! 99.01.26 (BTD): modify so we can restart calculation for specified
!                 IWAV0,IRAD0,IORI0
!                 now need to input IWAV0,IRAD0,IORI0 through ddscat.par
! 00.06.12 (BTD): added CFLSHP to argument list of REAPAR to support
!                 option SPHERES_N (need to pass CFLSPH from REAPAR to
!                 TARGET)
! 03.02.13 (BTD): added 1 more digit of precision to qtable and qtable2
!                 outputs; modified header line in stmnts 9044,9046
! 03.04.13 (BTD): added character variable CFLLOG to contain name of
!                 running output file
!                 added call to NAMID to generate a unique name for outp
!                 file, to support MPI use.
!                 Unfortunately, when this is done, output to device 0
!                 is no longer unbuffered.
!                 If it is necessary to reenable unbuffered output for
!                 debugging purposes,
!                 OPEN(UNIT=IDVOUT,FILE=CFLLOG)
!                 should be commented out
!                 Added variables ITNUM(2) and MXITER to argument lists
!                 for GETFML and WRITESCA
! 03.07.13 (BTD): Added new variable ITNUMMX(2) to store maximum number
!                 of iterations taken for any of the orientations for
!                 each size and wavelength, for output in orientational
!                 average files waarbbkccc.sca
! Develop version 6.1
! 03.10.23 (BTD): Removed ICTHM and IPHIM from argument lists of
!                 REAPAR, GETFML, SHARE1, and WRITESCA -- these
!                 variables are no longer used, since SCAT now
!                 determines scattering directions automatically
!                 Add ETASCA to argument list of REAPAR, SHARE1,
!                    GETFML, WRITESCA
!                 Added NAVG to argument list of GETFML and WRITESCA
!                 Add IWRKSC to argument list of SHARE1
! 04.02.22 (BTD): Add IWRKSC to argument list of WRITESCA and SHARE1
! 04.02.25 (BTD): Added final call to WRIMSG reporting normal
!                 termination
! 04.04.01 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
!                 boundary condition option
! 04.04.04 (BTD): Added NPY,NPZ to argument list of TARGET to be
!                 compatible with new version of TARGET
! 04.05.21 (BTD): One of the calls to WRITESCA had QSCGSUM and
!                 QSCG2SUM in incorrect order. Fixed.
! 04.05.22 (BTD): Added IF(CBINFLAG.NE.'NOTBIN') conditional
!                 before closing dd.bin (file never opened otherwise)
! 04.09.14 (BTD): Add new variables THETADF,PHIDF,BETADF to specify
!                 orientation of "Dielectric Frame" for each dipole.
! 05.06.16 (BTD): Replaced integer variables NPY,NPZ by
!                 real variables PYD,PZD in
!                 COMMON/M6/
!                 argument list of TARGET
! 05.08.04 (BTD): Added new character variable CMDFRM to be read by
!                 subroutine REAPAR from input file ddscat.par.
!                 CMDFRM=LFRAME : angles THETAN,PHIN are relative to
!                                 Lab Frame (xlab,ylab,zlab)
!                 CMDFRM=TFRAME : angles THETAN,PHIN are relative to
!                                 Target Frame (a1,a2,a3)
!                 Modified DDSCAT.f to define ENSC,EM1,EM2 accordingly
! 05.09.26 (BTD): Corrected bug in calculation of scattering for
!                 option CMDFRM = TFRAME
! 05.10.11 (BTD): Modified to support up to 1000 wavelengths:
!                 changed MXWAV from 100 to 1000
!                 changed CFLAVG*13 to CFLAVG*14
!                 changed CFLSCA*14 to CFLSCA*15
!                 (also changes in NAMER and WRITESCA)
! 05.10.11 (BTD): Added CMDFRM to argument list of WRITESCA
! 05.10.18 (BTD): Modified to allow use of more than 1000 orientations
!                 if IWRKSC=0 (previously would exceed array limits
!                 in subroutine NAMER with IORI>1000).
! 06.04.14 (BTD): Modified to call routine WRITEPOL to write files
!                 wxxxryykzzz.pol1 and wxxxryykzzz.pol2 with
!                 polarization array and other information
! 06.09.21 (BTD): Modified to add PYD,PZD, and DX to argument list of
!                 WRITEPOL
! 06.09.28 (BTD): *** Version 7.0.0 ***
! 06.10.05 (BTD): Added call to PBCSCAVEC to prepare scattering
!                 vectors for PBC targets
! 06.12.24 (BTD): Added ORDERM,ORDERN to argument list of subroutine
!                 GETMUELLER
! 06.12.28 (BTD): Added arrays XLR(3),YLR(3),ZLR(3),A3(3)
!                 Added XLR,YLR,ZLR to argument list of PBCSCAVEC
! 07.01.18 (BTD): Added A3(3),IWRPOL,IPBC,JPBC,MXNX,MXNY,MXNZ,MXPBC,
!                 ORDERM(MXSCA),ORDERN(MXSCA),
!                 PYD,PYDDX,PZD,PZDDX to argument list of SHARE1
! 07.06.20 (BTD): v7.0.2:
!                 * define X0(3)
!                 * add X0 to argument list of TARGET
!                 * add X0 to argument list of EXTEND
!                 * add X0 to argument list of GETFML
!                 * add X0 to argument list of WRITEPOL
!                 * add X0 to argument list of SHARE1
! 07.06.22 (BTD): removed THETAN and PHIN from argument list of GETFML
!                 (not needed, because scattering directions are
!                  specified through vector AKSR)
! 07.06.30 (BTD): moved CMDFFT from COMMON/M6/... CMDFFT
!                 to COMMON/M8/CMDFFT
!                 moved PYD,PZD to beginning of COMMON/M6/
! 07.07.03 (BTD): add ENSC to argument list of GETMUELLER
!                 add ENSC to argument list of PBCSCAVEC
! 07.07.08 (BTD): add EM1,EM2 to argument list of PBCSCAVEC
!                 add EM1,EM2 to argument list of GETMUELLER
! 07.08.04 (BTD): Version 7.0.3
!                 * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                 * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                   add dynamic allocation of CXADIA
!                 * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                   add dynamic allocation of CXZC
!                 * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                   add dynamic allocation of CXZW
!                 * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                   add dynamic allocation of IOCC
!                 * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                 * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                   add dynamic allocation of CXAOFF
!                 * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
! 07.08.05 (BTD): * Modified to do dynamic memory allocation based
!                   on actual target size
!                 * Read size upper bounds MXNX,MXNY,MXNZ from
!                   ddscat.par
!                 * Add MXNX,MXNY,MXNZ to argument list of REAPAR
!                 * Add output line reporting whether single- or
!                   double-precision version used
!                 * Add output to report memory allocation, so that
!                   if system memory limits prevent execution, there
!                   will be an indication of this in log file
! 07.08.31 (BTD): * Added call to new routines NAMER2 and WRITEFML
!                   to write out scattering amplitudes f_ml
! 07.10.07 (BTD): * Added THETA, BETA to argument list of PBCSCAVEC
! 07.10.09 (BTD): * Added EM1R,EM2R to argument list of GETMUELLER
! 07.10.24 (BTD)  * Defined new array ENSCR
!                   Added ENSCR to argument list of GETMUELLER
! 07.10.27 (BTD)  v7.0.4
!                 * changed CSHAPE*6 to CSHAPE*9
!                 * changed shape names to 9 character strings
!                 * changed SHPAR(6) -> SHPAR(10)
! 07.10.28 (BTD)  * eliminated CDIEL -- reading from tables is now standard
! 08.01.06 (BTD)  * added comments
!                 * minor streamlining since CONVEX and TMPRTN are no
!                   longer options
!                 * cosmetic changes
! 08.01.12 (BTD)  * add PYDDX,PZDDX to argument list of WRITESCA
! 08.01.13 (BTD)  * introduce variable NRWORD = length (bytes) of real word
!                 * add to argument list of WRITEPOL, so that this can
!                   be stored in file written by WRITEPOL for sanity check
! 08.01.17 (BTD)  * add new variable IANISO to indicate whether target
!                   is isotropic (IANISO=0), anisotropic with optical
!                   axes || (x,y,z)_TF (IANISO=1), or generally anisotropic
!                   (IANISO=2)
!                 * add IANISO to argument list of TARGET
!                 * modify TARGET to set value of IANISO
!                 * modifications to support changes to WRITEPOL
! 08.01.21 (BTD)  * add IANISO to argument list of SHARE1
! 08.02.01 (BTD)  * changed SHPAR(10) -> SHPAR(12) to allow up to 12 
!                   shape parameters to be passed to TARGET
! 08.02.17 (BTD)  * add call to routine SHARE0 to share dimensioning
!                   information to all processes
!                 * change so ALLOCATION is done by all processes
!                 * add DAEFF to argument list of SHARE1
!                 * add CLOSE(11) to close mtable at end
! 08.03.11 (BTD)  ver7.0.5
!                 * added ALPHA to argument list of REAPAR
!                 * added ALPHA to argument list of SHARE1
!                 * added ALPHA to DDCOMMON_6 (to communicate with CPROD)
! 08.03.15 (BTD)  * added DDCOMMON_10 to transfer MYID to DIRECT_CALC
! 08.04.17 (BTD)  * changed MXRAD from 100 to 1000
! 08.04.19 (BTD)  * changed notation: ALPHA -> GAMMA
!                 * changed order of arguments in argument list of
!                   * REAPAR
!                   * SHARE1 (in mpi_subs.f90)
!                   * GETFML
! 08.05.01 (BTD)  * added MYID to argument list of SHARE0
!                 * added MYID to argument list of SHARE1
! 08.05.09 (BTD)  * added LACE,LAXI,LCLM,LGI,LPI,LQI,LSC0 to argument list
!                   of SHARE0
!                 * added MYID to argument list of WRITESCA
!                 * moved block of code calculating scratch array positions
!                   LACE, etc. so that it is executed for all MYID values
! 08.05.10 (BTD)  * Introduce new arrays
!                   CX1121_1
!                   QABSUM_1
!                   QBKSUM_1
!                   QEXTSUM_1
!                   QPHSUM_1
!                   QSCAGSUM_1
!                   QSCG2SUM_1
!                   QSCASUM_1
!                   QTRQABSUM_1
!                   QTRQSCSUM_1
!                   S1111_1
!                   S2121_1
!                   SMORI_1
! 08.05.12 (BTD) ver7.0.6
!                 * changes introduced by Art Lazanoff, NASA Ames:
!                   added loops initializing IXYZ0,CXZC,CXZW,CXSCR1,SCRRS1
!                   to zero, but BTD does not see why this is helpful...
! 08.05.29 (BTD)  * changed declarations to allow single call to MPI_REDUCE
!                   in routine COLSUM:
!                   SM(MXSCA,4,4)      -> SM(4,4,MXSCA)
!                   SMORI(MXSCA,4,4)   -> SMORI(4,4,MXSCA)
!                   SMORI_1(MXSCA,4,4) -> SMORI_1(4,4,MXSCA)
! 08.07.22 (BTD)  * added XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN to argument list
!                   of SHARE1
! 08.07.23 (BTD)  * removed some MPI_BARRIER calls, added others just
!                   before SHARE1 and SHARE2
! 08.07.27 (BTD)  * changed final allocation of BETADF,PHIDF,THETADF
!                   from NAT0 -> MXNAT
! 08.08.29 (BTD) v7.0.7
!                 * removed variable CNETFLAG and CNETFILE
!                 * removed CNETFLAG from argument list of REAPAR
!                 * removed CNETFLAG from argument list of SHARE1
!                 * removed CNETFLAG and CNETFILE from argument list of
!                   WRITESCA
! 10.01.28 (BTD)  * when IWRKSC=0, change IORI from 0 to 1 in call to
!                   NAMER
! end history
! Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2003,2004,2005,
!               2006,2007,2008,2010 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

!    Adjustable Parameters:

!    MXNX   = max. extent of target in x direction
!    MXNY   =                          y
!    MXNZ   =                          z
!    MXPBC  = 0 if not planning to use PBC option
!           = 1 for best memory use with PBC option
!    MXCOMP = max. number of different dielectric functions
!    MXTHET = max. number of target  rotation angles THETA
!    MXBETA = max. number of target rotation angles BETA
!    MXPHI  = max. number of target rotation angles PHI
!    MXSCA  = max. number of scattered directions
!    MXRAD  = max. number of radii
!    MXWAV  = max. number of wavelengths
!    MXWAVT = max. number of wavelengths in dielectric tables

!*** Set parameter MXPBC
      INTEGER :: MXPBC,MXPBC_SH
      PARAMETER(MXPBC=1)

      INTEGER :: MXNX,MXNY,MXNZ

! experiment with temporary storage for ixyz0 to support first call to target

      INTEGER :: MXNAT0,MXN03
      
!*** Set parameters MXCOMP,MXTHET,MXBETA,MXPHI,MXRAD,MXWAV,MXWAVT,MXSCA

      INTEGER :: MXCOMP,MXCOMP_SH
      PARAMETER(MXCOMP=9)
      INTEGER :: MXTHET,MXTHET_SH,MXBETA,MXBETA_SH,MXPHI,MXPHI_SH
      PARAMETER(MXTHET=100,MXBETA=100,MXPHI=100)
      INTEGER :: MXRAD,MXRAD_SH,MXWAV,MXWAV_SH,MXWAVT
      PARAMETER(MXRAD=1000,MXWAV=1000,MXWAVT=1500)
      INTEGER :: MXSCA,MXSCA_SH
      PARAMETER(MXSCA=10000)
      INTEGER :: MXTIMERS,NTIMERS
      PARAMETER(MXTIMERS=20,NTIMERS=12)

!*** Derived Parameters: **********************************************

      INTEGER :: MXNAT,MXN3
      INTEGER :: MXCXSC

! Local variables:

      CHARACTER :: CMDFRM*6,CMDSOL*6,CMDTRQ*6,CMSGNM*70

      COMPLEX(WP) :: CXEN

      INTEGER :: IANISO,JX,JXMAX,JXMIN,JY,JYMAX,JYMIN,JZ,JZMAX,JZMIN, &
                 NAVG,NRWORD

      REAL(WP) :: AEFF,AK1,AK3,BETAD,BETAMI,BETAMX,BETMID,BETMXD,COSBET,      &
                  COSPHI,COSTHE,CWORD,DAEFF,DEGRAD,DSTORAGE,ETASCA,FREQ,MB,   &
                  PHID,PHIMAX,PHIMID,PHIMIN,PHIMXD,PI,PIA2,PYDDX,PZDDX,RWORD, &
                  SINBET,SINPHI,SINTHE,STORAGE,STORAGE0,THETAD,THETMI,THETMX, &
                  THTMID,THTMXD,TOL,WAVE,XMAX,XMIN,XX,YMAX,YMIN,ZMAX,ZMIN

! Target Properties:
! AEFF=aeff=effective radius of target (physical units)
! PIA2=pi*(aeff/d)**2=pi*(3*NAT/4*pi)**(2/3)

! Incident Wave Properties:
! AK1=(k*d), where k=2*pi/wave=propagation vector and d=dipole spacing
! AK3=(k*d)**3
! AKE2=(k*d \dot E0), where E0 is incident polarization vector
! WAVE=wavelength (in vacuo) in physical units
! XX=k*aeff=2*pi*aeff/wave

! Scattering Properties:
! G=<cos(theta)> for scattered radiation
! QSCGSUM(1-3,1-2)=running (weighted) sum of g(1-3)*Q_sca
!           over target orientations, for incident polarizations 1-2,
!           where
!           g(1)=<cos(theta)> for scattered radiation
!           g(2)=<sin(theta)cos(phi)> for scattered radiation
!           g(3)=<sin(theta)sin(phi)> for scattered radiation
!           theta is measured relative to incident direction
!           phi is measured relative to x,y plane (Lab Frame)
! QPHA(1-2)=(phaseshift cross section)/(pi*aeff**2)
! QEXSUM(1-2)=running sum of QEXT over target orientations
! QABSUM(1-2)=running sum of QABS over target orientations
! QBKSUM(1-2)=running sum of QBKSCA over target orientations
! QSCSUM(1-2)=running sum of QSCA over target orientations
! QSCG2SUM(1-2)=running sum of cos^2*Q_sca
! QTRQSCSUM(1-3,1-2)=running sum of QTRQSC(1-3,1-2) over target orientat
! THETND=scattering angle theta in degrees
! PHIND=scattering angle phi in degrees
! SINPHI=sin(phi)
! DEPOLR=depolarization ratio for scattered of initially polarized
!        light into direction theta,phi
! PPOL=percentage polarization for scattering of initially unpolarized
!      light into direction theta,phi

      INTEGER :: IBETA,IBETA1,IBETH,IBETH1,IDIR,IDNC,IDVERR,IDVSHP,IERR,INIT, &
                 ILIN10,ILIN12,IOBIN,IOPAR,IORI,IORI0,IORI1,IORTH,IOSHP,IPHI, &
                 IPHI1,IRAD,IRAD0,IRAD1,ITASK,ITHETA,ITHETA1,IWAV,IWAV0,      &
                 IWAV1,IWRKSC,IWRPOL,J,JJ,JO,JPBC,LACE,LAXI,LCLM,LGI,LPI,LQI, &
                 LSC0,NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA,  &
                 NUMPROCS,NWAV

      INTEGER :: MXITER
      INTEGER ::     &
         ITNUM(2),   &
         ITNUMMX(2), &
         SMIND1(9),  &
         SMIND2(9)

! MYID     = MPI process identifier that runs from 0-(NUMPROCS-1). 0 is
!            master process.
! NUMPROCS = number of MPI parallel processes (including the master)
! IERR     = MPI error code, which we ignore
! NAT=number of dipoles in target
! NAT3=3*NAT
! NBETA=number of different beta values for target orientation
! NBETH=NBETA*NTHETA=number of target orientations for outer orientation
! NTHETA=number of different theta values for target orientation
! NPHI=number of different phi values for target orientation
! NORI=NBETA*NTHETA*NPHI=total number of target orientations
! NSCAT=number of different scattering directions for each orientation
! NWAV=number of different wavelengths
! NRAD=number of different target radii
! NSMELTS=number of scattering matrix elements to print out
! INIT=0,1,2 for choice of initial vector |x0> in complex conjugate grad
!      method
! IORTH=1 or 2 to do 1 or 2 incident polarizations
! IWRKSC=0 or 1 to suppress or generate "wAArBBkCCC.sca" files for each
!        target orientation
! NX=x-length of extended target
! NY=y-length of extended target
! NZ=z-length of extended target

! SMIND1(1-NSMELTS) = index 1 of scattering matrix elements to
!                     be printed out (e.g., 1 for element S_{13})
! SMIND2(1-NSMELTS) = index 2 of scattering matrix elements to
!                     be printed out (e.g., 3 for element S_{13})

      CHARACTER :: CALPHA*6,CSHAPE*9,CSTAMP*26,CFLAVG*15,CFLFML*16, &
        CFLPAR*13,CFLPOL1*17,CFLPOL2*17,CFLSCA*16,CFLSHP*80,CDESCR*67,      &
        CBINFLAG*6,CBINFILE*14
      CHARACTER :: CFLLOG*14
      CHARACTER(60) :: &
        CFLEPS(MXCOMP)
!     ..
!     .. Local Arrays ..

      COMPLEX(WP),ALLOCATABLE :: &
        CXALOF(:),               &
        CXALOS(:),               &
        CXALPH(:),               &
        CXE(:),                  &
        CXSC(:),                 &
        CXSCR1(:),               &
        CXXI(:)

      COMPLEX(WP) ::          &
        CX1121(MXSCA),        &
        CX1121_1(MXSCA),      &
        CXE01(3),             &
        CXE02(3),             &
        CXE01R(3),            &
        CXE02R(3),            &
        CXEPS(MXCOMP),        &
        CXF11(MXSCA),         &
        CXF12(MXSCA),         &
        CXF21(MXSCA),         &
        CXF22(MXSCA),         &
        CXRLOC(MXCOMP+1,3,3), &
        CXRFR(MXCOMP),        &
        CXS1(MXSCA),          &
        CXS2(MXSCA),          &
        CXS3(MXSCA),          &
        CXS4(MXSCA)

! Arrays describing target properties:
! CXADIA(1-3*NAT)=diagonal elements of A matrix
! CXEPS(1-MXCOMP)=dielectric const. for each of MXCOMP materials
! CXREFR(1-3)=complex refractive index at current wavelength
! CXALPH(1-3*NAT)=diagonal elements of dipole polarizability tensor alpha
! CXALOF(1-3*NAT)=off-diagonal elements of dipole polarizability tensor
! CXALOS(1-3*NAT)=off-diagonal elements of dipole polarizability tensor

! Arrays describing incident radiation:
! CXE01(1-3)=incident polarization vector e01 prior to target rotation
! CXE02(1-3)=incident polarization vector e02 prior to target rotation
! CXE01R(1-3)=rotated incident polarization vector e01 in Target Frame
! CXE02R(1-3)=rotated incident polarization vector e02 in Target Frame
! CXE0R(1-3)=incident polarization vector (=CXE01R or CXE02R) being used
! CXE(1-3*NAT)=incident electric field vector in Target Frame

! Array describing polarization of target for one incident wave:
! CXXI(1-3*NAT)=polarization vector at each dipole

! Arrays describing scattering properties of target:
! CXFF11(1-NSCAT)=scattering matrix element f11 for each of NSCAT directions
! CXFF12(1-NSCAT)=                          f12
! CXFF21(1-NSCAT)=                          f21
! CXFF22(1-NSCAT)=                          f22
! CX1121(1-NSCAT)=sum of f11* \times f21 over orientations

! Scratch arrays:
! CXSC(1-MXCXSC)=scratch array used by DDACCG

      INTEGER*2,ALLOCATABLE :: &
        ICOMP(:),              &
        ISCR1(:)

      INTEGER,ALLOCATABLE :: &
        IXYZ0(:,:)

! IXYZ0(1-NAT0,1-3)=[x-X0(1)]/d,
!                   [y-X0(2)]/d,
!                   [z-X0(3)]/d for dipoles 1-NAT0 in real target
!                   where offset vector X0(1-3) is set by routine TARGET
!                   X0(1-3)*DX(1-3) = location of lattice site (0,0,0)

! Scratch arrays:
! ISCR1,ISCR2,ISCR3,ISCR4 (used by EXTEND)


      REAL(WP) ::           &
        A1(3),              &
        A2(3),              &
        A3(3),              &
        AEFFA(MXRAD),       &
        AKSR(3,MXSCA),      &
        BETA(MXBETA),       &
        E1A(MXWAVT),        &
        E2A(MXWAVT),        &
        EM1(3,MXSCA),       &
        EM1R(3,MXSCA),      &
        EM2(3,MXSCA),       &
        EM2R(3,MXSCA),      &
        EN0R(3),            &
        ENSC(3,MXSCA),      &
        ENSCR(3,MXSCA),     &
        ORDERM(MXSCA),      &
        ORDERN(MXSCA),      &
        PHI(MXPHI),         &
        PHIN(MXSCA)
      REAL(WP) ::           &
        QABS(2),            &
        QABSUM(2),          &
        QABSUM_1(2),        &
        QBKSCA(2),          &
        QBKSUM(2),          &
        QBKSUM_1(2),        &
        QEXT(2),            &
        QEXSUM(2),          &
        QEXSUM_1(2),        &
        QPHA(2),            &
        QPHSUM(2),          &
        QPHSUM_1(2),        &
        QSCAT(2),           &
        QSCAG(3,2),         &
        QSCAG2(2),          &
        QSCG2SUM(2),        &
        QSCG2SUM_1(2),      &
        QSCGSUM(3,2),       &
        QSCGSUM_1(3,2),     &
        QSCSUM(2),          &
        QSCSUM_1(2),        &
        QTRQAB(3,2),        &
        QTRQSC(3,2),        &
        QTRQABSUM(3,2),     &
        QTRQABSUM_1(3,2),   &
        QTRQSCSUM(3,2),     &
        QTRQSCSUM_1(3,2)
      REAL(WP) ::           &
        S1111(MXSCA),       &
        S1111_1(MXSCA),     &
        S2121(MXSCA),       &
        S2121_1(MXSCA),     &
        SHPAR(12),          &
        SM(4,4,MXSCA),      &
        SMORI(4,4,MXSCA),   &
        SMORI_1(4,4,MXSCA), &
        THETA(MXTHET),      &
        THETAN(MXSCA),      &
        TIMERS(MXTIMERS),   &
        WAVEA(MXWAV),       &
        WGTA(MXTHET,MXPHI), &
        WGTB(MXBETA),       &
        WVA(MXWAVT),        &
        X0(3),              &
        XLR(3),             &
        YLR(3),             &
        ZLR(3)

      REAL(WP),ALLOCATABLE :: &
        BETADF(:),            &
        PHIDF(:),             &
        SCRRS1(:,:),          &
        SCRRS2(:),            &
        THETADF(:)

! IANISO=0 for isotropic target
!        1 for anisotropic target, but with principal axes of
!              dielectric tensor || x_TF,y_TF,z_TF
!              (i.e., for every dipole, Dielectric Frame = Target Frame)
!        2 for general anisotropic target, where orientation of
!              Dielectric Frame is specified for every dipole
!                                  
! Arrays describing target properties:
! A1(1-3)=direction of target axis a1 in Target Frame
!        =initial direction of target axis a1 in Lab Frame
! A2(1-3)=direction of target axis a2 in Target Frame
!        =initial direction of target axis a2 in Lab Frame
! A3(1-3)=direction of target axis a3=a1xa2 in Target Frame
!        =initial direction of target axis a3 in Lab Frame
! AEFFA(1-NRAD)=values of effective radius of target (physical units)
! SHPAR(1-10)=up to 10 parameters for defining target geometry
! X0(1-3)=offset for IXYZ array, such that
!         x/d = IXYZ(J,1) - X0(1)
!         y/d = IXYZ(J,2) - X0(2)
!         z/d = IXYZ(J,3) - X0(3)
! Arrays describing orientation of "Dielectric Frame" for anisotropic
! material relative to Target Frame, for each dipole location:
! BETADF(1-NAT) = angle BETADF (radians)
! PHIDF(1-NAT) = angle PHIDF (radians)
! THETADF(1-NAT) = angle THETADF (radians)

! Arrays describing target rotation:
! THETA(1-NTHETA)=desired values of target rotation angle theta
! BETA(1-NBETA)=desired values of target rotation angle beta
! PHI(1-NPHI)=desired values of target rotation angle phi
! WGTA(1-NTHETA,1-NPHI)=weight factor for each orientation of target
!                       axis a1 in Lab Frame
! WGTB(1-NBETA)=weight factor for rotation of target around a1
! Arrays describing incident wave:
! WAVEA(1-NWAV)=values of wavelength (physical units)
! EN0R(3)=unit vector in direction of incidence in (rotated) Target
!         Frame
! AKR(3)=k*d vector in (rotated) Target Frame
! XLR(3)=unit vector xlab in target frame
! YLR(3)=unit vector ylab in target frame
! ZLR(3)=unit vector zlab in target frame
! Arrays describing scattering properties:
! ENSC(1-3,1-NSCAT)=unit scattering vectors in Lab Frame
! ENSCR(1-3,1-NSCAT)=unit scattering vectors in Target Frame
! AKSR(1-3,1-NSCAT)=scattering k-vectors in Target Frame
! EM1(1-3,1-NSCAT)=scattering polarization state 1 in Lab Frame
! EM2(1-3,1-NSCAT)=scattering polarization state 2 in Lab Frame
! EM1R(1-3,1-NSCAT)=scattering polarization state 1 in Target Frame
! EM1R(1-3,1-NSCAT)=scattering polarization state 2 in Target Frame
! THETAN(1-NSCAT)=values of theta for NSCAT scattering directions nhat
!                 at which scattering matrix fml is to be calculated
!                 For finite target (JPBC=0), THETAN is specified
!                 in the Lab Frame
! PHIN(1-NSCAT)=values of phi for scattering NSCAT directions nhat at
!               which scattering matrix fml is to be calculated
!               For finite target (JPBC=0), PHIN is specified
!               in the Lab Frame.
! S1111(1-NSCAT)=sum of |f11|**2 over target orientations
! S2121(1-NSCAT)=       |f21|**2
! QABS(1-2)=(absorption cross section)/(pi*aeff**2) for 2 polarizations
! QBKSCA(1-2)=4*pi*(diff.scatt.cross section for theta=pi)/(pi*aeff**2)
!             for 2 polarizations
! QEXT(1-2)=(extinction cross section)/(pi*aeff**2)
! QSCA(1-2)=(scattering cross section)/(pi*aeff**2)=QEXT-QABS
! QSCAT(1-2)=(scattering cross section)/(pi*aeff**2) estimated by SCAT

! Scratch array:
! SCRRS1(1-NAT,3)=scratch array used by DDACCG and SCAT
! SCRRS2(1-NAT)=scratch array used by SCAT

! External subroutines:

      EXTERNAL DIELEC,NAMER,REAPAR

! Intrinsic functions:

      INTRINSIC ATAN,SQRT,REAL

      DATA CFLPAR/'ddscat.par'/
      DATA CFLSHP/'shape.dat'/

! Set device numbers:
! IDVERR = device number for error messages
! IOPAR = device number for reading ddscat.par file
! IOSHP = device number for writing target.out (IOSHP<0 to suppress)
! IDVSHP = device number for reading shape file

      DATA IDVERR/0/
      DATA IDVSHP/10/
      DATA IOPAR/1/
      DATA IOSHP/ -1/

! IDVOUT = device number for running I/O
!          on Solaris IDVOUT=0 produces unbuffered output to standard
!                              output
!                     IDVOUT=6 produces buffered output to standard
!                              output
! Initialize IDVOUT (cannot be done in DATA statement because IDVOUT
! is in COMMON/M6/

      IDVOUT=0
!*** diagnostic
!      write(0,*)'ddscat ckpt 0.9'
!***
!***********************************************************************
! MPI environment setup:

      CALL MPI_INIT(IERR)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,NUMPROCS,IERR)

      IF(MYID==0)THEN
         WRITE(CMSGNM,FMT='(A,I4)')'NUMPROC=',NUMPROCS
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF

! MPI_INIT is called by each process to initialize the MPI environment
! MPI_COMM_RANK is called by each process to determine its identifier
!                which is stored in MYID
! MPI_COMM_SIZE is called by each process to determine the number of
!                parallel processes, stored in NUMPROCS
! If not using MPI, these calls can be turned into dummies by including
! subroutines in mpi_fake.f (also need to comment out INCLUDE 'mpif.h'
! and uncomment declaration of integer variable MPI_COMM_WORLD as noted
! above)

! Initialize variables to pass to SHARE1:

      MXBETA_SH=MXBETA
      MXCOMP_SH=MXCOMP
      MXPBC_SH=MXPBC
      MXPHI_SH=MXPHI
      MXRAD_SH=MXRAD
      MXSCA_SH=MXSCA
      MXTHET_SH=MXTHET
      MXWAV_SH=MXWAV

! Call subroutine NAMID to obtain unique filename for output file
! written by this process.

!*** diagnostic
!      write(0,*)'ddscat ckpt 1.1, myid=',myid
!      call mpi_barrier(mpi_comm_world,ierr)
!***      

      CALL NAMID(MYID,CFLLOG)
!*** diagnostic
!      write(0,*)'ddscat ckpt 1.2, myid=',myid
!***
!=======================================================================

! When following statement is enabled, output is buffered.
! If using MPI, each MPI process will write to a unique file named
! ddscat.log_xxx , where xxx=000,001,002, etc.
! If it is necessary to have unbuffered output for debugging purposes,
! comment out the following OPEN statement, in which case running
! diagnostic information will be written to standard output.
! Note that in this case, if using MPI, all MPI processes will write
! to a single output stream.

!      OPEN(UNIT=IDVOUT,FILE=CFLLOG)

!=======================================================================
      CALL VERSION(CSTAMP)

      IF(MYID==0)THEN   ! begin if(myid==0)... #1
         WRITE(IDVOUT,FMT=9000)CSTAMP

#ifdef openmp
         WRITE(IDVOUT,FMT=9000)'compiled with OpenMP enabled'
#endif

         IF(WP==KIND(0.E0))THEN
            WRITE(CMSGNM,FMT='(A)')'    Single-precision version'

! for storage computations:
! NRWORD,RWORD = length (bytes) of REAL word
! CWORD = length (bytes) of COMPLEX word

            NRWORD=4
            RWORD=4._WP
            CWORD=2._WP*RWORD
         ELSEIF(WP==KIND(0.D0))THEN
            WRITE(CMSGNM,FMT='(A)')'    Double-precision version'
            NRWORD=8.
            RWORD=8._WP
            CWORD=2._WP*RWORD
         ELSE
            CALL ERRMSG('FATAL','DDSCAT', &
                         'Fatal error determining word length in DDSCAT')
         ENDIF
         CALL WRIMSG('DDSCAT',CMSGNM)
!*** diagnostic
!         write(0,*)'ddscat ckpt 1.3, myid=',myid
!***
      ENDIF   !--- endif(myid==0)... #1

!*** diagnostic
!      write(0,*)'ddscat ckpt 1.4, myid=',myid
!***
      PI=4._WP*ATAN(1._WP)
      DEGRAD=180._WP/PI

!**** Read program control parameters
! CMDFFT=choice of solution methods
! CMDFRM=specify scattering directions in either Lab Frame ('LFRAME')
!        or target frame ('TFRAME')
! CSHAPE=description of shape
! SHPAR(1-10)= up to 10 parameters for defining target geometry
! INIT=selection of |x0> in CCG method
! TOL=error tolerance in CCG method
! MXWAV=dimensioning information for array WAVEA
! NWAV=number of wavelengths to be used
! WAVEA(1-NWAV)=wavelengths (physical units)
! MXRAD=dimensioning information for array AEFFA
! NRAD=number of radii to be used
! AEFFA(1-NRAD)=effective radii (physical units)
! IORTH=1 or 2 for 1 or 2 incident polarization states to be used
! NBETA=number of beta values to be used for target orientation
! BETAMI=minimum value of beta (radians)
! BETAMX=maximum value of beta (radians)
! NTHETA=number of theta values to be used for target orientation
! THETMI=minimum value of theta (radians)
! THETMX=maximum value of theta (radians)
! NPHI=number of phi values to be used for target orientation
! PHIMIN=minimum value of phi (radians)
! PHIMAX=maximum value of phi (radians)
! DEGRAD=degrees/radian (conversion factor)
! MXSCA=dimensioning information for arrays PHIN, THETAN
! NSCAT=number of scattered directions for computation of fml
! THETAN(1-NSCAT)=theta values (radians) for scattered directions
!                 for finite targets (JPBC=0), THETAN is in Lab Frame
! PHIN(1-NSCAT)=phi values (radians) for scattered directions
!                 for finite targets (JPBC=0), PHIN is in Lab Frame
! for JPBC=1 or 2 (infinite target with periodicity in 1-d):
!                 PHIN(1-NSCAT) specifies scattering order
!                 THETAN(1-NSCAT) specifies azimuthal angle of scatterin
!                 direction around periodicity axis
! for JPBC=3 (infinite target with periodicity in y_TF and z_TF)
!                 PHIN(1-NSCAT) specifies scattering order M
!                 THETAN(1-NSCAT) specifies scattering order N

      IF(MYID==0)THEN   ! begin if(myid==0)... #2

!*** diagnostic
!         write(0,*)'ddscat ckpt 1.5, myid=',myid
!***
         CALL REAPAR(CBINFLAG,AEFFA,BETAMI,BETAMX,CALPHA,CFLEPS,CFLPAR,     &
                     CFLSHP,CMDSOL,CMDFFT,CMDFRM,CSHAPE,CMDTRQ,CXE01,CXE02, &
                     DEGRAD,ETASCA,GAMMA,IDVERR,IDVOUT,INIT,IOPAR,IORTH,    &
                     JPBC,IWRKSC,IWRPOL,MXNX,MXNY,MXNZ,MXBETA,MXCOMP,MXPHI, &
                     MXRAD,MXSCA,MXTHET,MXWAV,NBETA,NCOMP,NPHI,NRAD,NSCAT,  &
                     NTHETA,NWAV,IWAV0,IRAD0,IORI0,NSMELTS,PHIMIN,PHIMAX,   &
                     PHIN,THETAN,THETMI,THETMX,TOL,WAVEA,SHPAR,SMIND1,      &
                     SMIND2,DX)
!*** diagnostic
!         write(0,*)'ddscat ckpt 1.6, myid=',myid
!***

!***********************************************************************
! Allocate memory required by TARGET and EXTEND

         MXNAT0=MXNX*MXNY*MXNZ
         MXN03=3*MXNAT0
         MB=REAL(1024**2)

! STORAGE0 = estimate of storage (bytes) that is independent of target size
        
         IF(KIND(STORAGE)==KIND(0.E0))THEN
!***diagnostic
!            write(0,*)'ddscat ckpt 1.61: single-precision'
!***
            STORAGE0=37.6E6/MB     !35.0E6 MB 
         ELSE
!***diagnostic
!            write(0,*)'ddscat ckpt 1.62: double-precision'
!***
            STORAGE0=41.9E6/MB    !40.0D6 MB
         ENDIF

!*** diagnostic
!         write(0,*)'ddscat ckpt 1.7'
!***
         STORAGE=STORAGE0
         WRITE(CMSGNM,FMT='(A)')'Allocate memory for first call to TARGET...'
         CALL WRIMSG('DDSCAT',CMSGNM)

! allocate IXYZ0

         DSTORAGE=REAL(2*MXNAT0*3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for IXYZ0;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(IXYZ0(MXNAT0,3))
!-----------------------------------------------------------------------
! following introduced by Art Lazanoff to touch the array CXZW
! which supposedly helps with allocation and distribution of this memory
! to the different processors...
! BTD: I can't really see why the following is beneficial...

!$omp parallel do
         DO J=1,MXNAT0
            IXYZ0(J,1)=0
            IXYZ0(J,2)=0
            IXYZ0(J,3)=0
         ENDDO
!$omp end parallel do
!-----------------------------------------------------------------------


! allocate ICOMP

         DSTORAGE=REAL(2*MXN03)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for ICOMP;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(ICOMP(MXN03))

! allocate IOCC

         DSTORAGE=REAL(2*MXNAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for IOCC;   total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(IOCC(MXNAT0))

! allocate ISCR1

         DSTORAGE=REAL(2*MXN03)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for ISCR1;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(ISCR1(MXN03))

! allocate BETADF

         DSTORAGE=RWORD*REAL(MXNAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for BETADF; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(BETADF(MXNAT0))

! allocate PHIDF

         DSTORAGE=RWORD*REAL(MXNAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for PHIDF;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(PHIDF(MXNAT0))

! allocate THETADF

         DSTORAGE=RWORD*REAL(MXNAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for THETADF;total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(THETADF(MXNAT0))

! allocate SCRRS2

         DSTORAGE=RWORD*REAL(MXNAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for SCRRS2; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         ALLOCATE(SCRRS2(MXNAT0))

!*** diagnostic
!        write(0,*)'completed preliminary allocation of storage'
!        write(0,*)'about to call target...'
!***
!-----------------------------------------------------------------------------
! Specify target properties

! A1(1-3)=target axis 1 in Target Frame
! A2(1-3)=target axis 2 in Target Frame

         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT0,SHPAR,DX, &
                     NAT0,IXYZ0,ICOMP,IDVOUT,MXN03,NAT3,PYD,PZD,BETADF,PHIDF, &
                     THETADF,X0,IANISO)

! write out some information on target geometry

         JXMIN=IXYZ0(1,1)
         JYMIN=IXYZ0(1,2)
         JZMIN=IXYZ0(1,3)
         JXMAX=JXMIN
         JYMAX=JYMIN
         JZMAX=JZMIN
         DO J=2,NAT0
            JX=IXYZ0(J,1)
            JY=IXYZ0(J,2)
            JZ=IXYZ0(J,3)
            IF(JX<JXMIN)JXMIN=JX
            IF(JX>JXMAX)JXMAX=JX
            IF(JY<JYMIN)JYMIN=JY
            IF(JY>JYMAX)JYMAX=JY
            IF(JZ<JZMIN)JZMIN=JZ
            IF(JZ>JZMAX)JZMAX=JZ
         ENDDO
         XMIN=REAL(JXMIN)-0.5_WP+X0(1)
         XMAX=REAL(JXMAX)+0.5_WP+X0(1)
         YMIN=REAL(JYMIN)-0.5_WP+X0(2)
         YMAX=REAL(JYMAX)+0.5_WP+X0(2)
         ZMIN=REAL(JZMIN)-0.5_WP+X0(3)
         ZMAX=REAL(JZMAX)+0.5_WP+X0(3)
         WRITE(CMSGNM,FMT='(A)')'returned from TARGET:'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JXMIN,JXMAX,' = min, max values of JX'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JYMIN,JYMAX,' = min, max values of JY'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JZMIN,JZMAX,' = min, max values of JZ'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(3F10.5,A)')X0,' = X0(1-3)'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(A)')                                 &
               ' --- physical extent of target volume (occupied sites) ---'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')XMIN,XMAX,' = min, max values of x/d'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')YMIN,YMAX,' = min, max values of y/d'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')ZMIN,ZMAX,' = min, max values of z/d'
         CALL WRIMSG('DDSCAT',CMSGNM)

! Return from TARGET with following arrays defined:
!      NAT0   = number of occupied lattice sites
! IXYZ0(J,1-3)= (IX,IY,IZ) for occupied sites J=1-NAT0
!     X0(1-3) = specifies location in TF of lattice site (IX,IY,IZ)=(0,0,0) :
!       x_TF  = (IX+X0(1))*d*DX(1)
!       y_TF  = (IY+X0(2))*d*DX(2)
!       z_TF  = (IZ+X0(3))*d*DX(3)
!     A1(1-3) = target axis A1 in TF
!     A2(1-3) = target axis A2 in TF
!       PYD   = periodicity/[d*DX(2)] in y_TF direction (for JPBC=1 or 3)
!       PZD   = periodicity/[d*DX(3)] in z_TF direction (for JPBC=2 or 3)
! ICOMP(J,1-3)= composition at lattice site J, for directions 1-3
!               in local "Dielectric Frame" where dielectric tensor is
!               diagonalized
!
! for targets composed of general anisotropic materials (IANISO=2), also define:
!   BETADF(J) = rotation angle beta defining orientation in TF of
!               "dielectric frame" (DF) for site J
!    PHIDF(J) = rot. angle phi defining orientation in TF of DF for site J
!  THETADF(J) = rot. angle theta defining orientation in TF of DF for site J

! Calculate target axis A3 in Target Frame

         A3(1)=A1(2)*A2(3)-A1(3)*A2(2)
         A3(2)=A1(3)*A2(1)-A1(1)*A2(3)
         A3(3)=A1(1)*A2(2)-A1(2)*A2(1)

         PYDDX=PYD*DX(2)
         PZDDX=PZD*DX(3)

! Calculate DAEFF = d/aeff for this target (d=lattice spacing)

         DAEFF=(4._WP*PI/(3._WP*REAL(NAT0,KIND=WP)))**(1._WP/3._WP)

! NAT0=number of dipoles in "real" target
! Extend target to rectangular volume suitable for FFT

         CALL EXTEND(CMDFFT,ICOMP,ISCR1,IDVERR,IDVOUT,IOCC,IXYZ0(1,1),     &
                     IXYZ0(1,2),IXYZ0(1,3),BETADF,PHIDF,THETADF,SCRRS2,X0, &
                     MXNX,MXNY,MXNZ,MXNAT0,MXN03,NAT,NAT0,NAT3,NX,NY,NZ)

! write out some information on target geometry
! following call to EXTEND, as a check

!*** diagnostic
!         write(0,*)'ddscat ckpt 1.8, myid=',myid
!***
         JXMIN=IXYZ0(1,1)
         JYMIN=IXYZ0(1,2)
         JZMIN=IXYZ0(1,3)
         JXMAX=JXMIN
         JYMAX=JYMIN
         JZMAX=JZMIN
         DO J=2,NAT0
            JX=IXYZ0(J,1)
            JY=IXYZ0(J,2)
            JZ=IXYZ0(J,3)
            IF(JX<JXMIN)JXMIN=JX
            IF(JX>JXMAX)JXMAX=JX
            IF(JY<JYMIN)JYMIN=JY
            IF(JY>JYMAX)JYMAX=JY
            IF(JZ<JZMIN)JZMIN=JZ
            IF(JZ>JZMAX)JZMAX=JZ
         ENDDO
         XMIN=REAL(JXMIN)-0.5_WP+X0(1)
         XMAX=REAL(JXMAX)+0.5_WP+X0(1)
         YMIN=REAL(JYMIN)-0.5_WP+X0(2)
         YMAX=REAL(JYMAX)+0.5_WP+X0(2)
         ZMIN=REAL(JZMIN)-0.5_WP+X0(3)
         ZMAX=REAL(JZMAX)+0.5_WP+X0(3)
         WRITE(CMSGNM,FMT='(A)')'returned from EXTEND:'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JXMIN,JXMAX,' = min, max values of JX'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JYMIN,JYMAX,' = min, max values of JY'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2I6,A)')JZMIN,JZMAX,' = min, max values of JZ'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(A)')                               &
               ' ------- physical extent of target volume -------'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')XMIN,XMAX,' = min, max values of x/d'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')YMIN,YMAX,' = min, max values of y/d'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(2F12.5,A)')ZMIN,ZMAX,' = min, max values of z/d'
         CALL WRIMSG('DDSCAT',CMSGNM)
!***

! EXTEND reorders the occupied lattice sites,
!    returns the extents NX,NY,NZ for the extended target.

!    if necessary, shifts JX,JY,JZ for each site to that JX,JY,JZ
!    run from 1-NX,1-NY,1-NZ

!    IXYZ0(JA,1-3) = coordinates JX,JY,JZ of occupied lattice sites JA=1-NAT0

! location JX,JY,JZ in extended target corresponds to 
! JE=NX*NY*(JZ-1)+NX*(JY-1)+JX, where JE runs from 1 to NX*NY*NZ

!    ICOMP(JE,1-3)  = composition for each site in extended target
!                   = 0 if site is unoccupied
!       IOCC(JE)    = 1 if occupied, 0 if not
! BETADF(JA=1-NAT0) = rotation angle beta for DF in reordered physical target
!                    for JA=1-NAT0
!  PHIDF(JA=1-NAT0) = rotation angle phi for DF in reordered physical target
! THETADF(JA=1-NAT0)= rotation angle theta for DF in reordered physical target
!    X0(1-3)        = location in TF of lattice site JX,JY,JZ=0,0,0

! With actual size of extended target determined, 
! now set required values of MXNX,MXNY,MXNZ,MXNAT,MXN3 and reallocate arrays
! IXYZ0,ICOMP,IOCC,ISCR1,BETADF,PHIDF,THETADF,SCRRS2

         MXNX=NX
         MXNY=NY
         MXNZ=NZ
         MXNAT=NX*NY*NZ
         MXN3=3*MXNAT

!*** diagnostic
!         write(0,*)'ddscat ckpt 1.85, myid=',myid,' mxn3=',mxn3
!***


! MXCXSC specifies required complex scratch array CXSC
! increase from 7*MXN3 required by PETR
!           to 10*MXN3 required by PIMCBICGSTAB method
!                 (PIM Complex BiConjugate Gradient with Stabilization)

         MXCXSC=10*MXN3

! Initialize various variables in common blocks which are derived
! from parameters:

         MXNATF=MXNAT
         MXNXF=MXNX
         MXNYF=MXNY
         MXNZF=MXNZ
         MXN3F=MXN3

! Pseudo names of scratch array  positions:

         LACE=1
         LAXI=1*MXN3+1
         LCLM=2*MXN3+1
         LGI=3*MXN3+1
         LPI=4*MXN3+1
         LQI=5*MXN3+1
         LSC0=6*MXN3+1

!*** diagnostic
!         write(0,*)'ddscat ckpt 1.9, myid=',myid
!***
! Reallocate ISCR1:

         WRITE(CMSGNM,FMT='(A)')'Allocate memory required for this problem...'
         CALL WRIMSG('DDSCAT',CMSGNM)

         STORAGE=STORAGE0

         DSTORAGE=REAL(2*MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for ISCR1;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DEALLOCATE(ISCR1)
         ALLOCATE(ISCR1(MXN3))

      ENDIF   !--- endif(myid==)... #2

! need to share dimensioning parameters:
!    MXNAT
!    NAT0
!    MXN3
!    MXNX,MXNY,MXNZ
!    MXCXSC
!    MXPBC

!*** diagnostic
!      write(0,*)'ddscat ckpt 1.94, myid=',myid,' mxn3=',mxn3
!***

! this mpi_barrier is required to ensure that LACE, etc have been
! evaluated by MYID=0 before being SHAREd by other threads

      CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)

!*** diagnostic
!      write(0,*)'ddscat ckpt 1.95, myid=',myid
!***      

      CALL SHARE0(LACE,LAXI,LCLM,LGI,LPI,LQI,                        &
                  MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC_SH,MXCXSC,MYID,NAT0)

!*** diagnostic
!      write(0,*)'ddscat ckpt 1.96, myid=',myid,' mxn3=',mxn3
!      call mpi_barrier(mpi_comm_world,ierr)
!***      

! Reallocate SCRRS2:

      IF(MYID==0)THEN   !--- begin if(myid==0)... #3
         DSTORAGE=RWORD*REAL(MXNAT)/MB
         STORAGE=STORAGE+DSTORAGE
            WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
               ' MB for SCRRS2; total=',STORAGE,' MB'
            CALL WRIMSG('DDSCAT',CMSGNM)
!*** diagnostic
!      write(0,*)'ddscat ckpt 2, myid=',myid
!***
         DEALLOCATE(SCRRS2)
!*** diagnostic
!      write(0,*)'ddscat ckpt 3, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #3

!*** diagnostic
!      call mpi_barrier(mpi_comm_world,ierr)
!      write(0,*)'ddscat ckpt 4, myid=',myid
!***
      ALLOCATE(SCRRS2(MXNAT))
!*** diagnostic
!      write(0,*)'ddscat ckpt 5, myid=',myid
!      call mpi_barrier(mpi_comm_world,ierr)
!***

! Reallocate IXYZ0:

      IF(MYID==0)THEN   !--- begin if(myid==0)... #4
         DSTORAGE=REAL(2*NAT0*3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for IXYZ0;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT0
            ISCR1(J)=IXYZ0(J,1)
            ISCR1(J+NAT0)=IXYZ0(J,2)
            ISCR1(J+2*NAT0)=IXYZ0(J,3)
         ENDDO
!*** diagnostic
!      write(0,*)'ddscat ckpt 6, myid=',myid
!***
         DEALLOCATE(IXYZ0)
!*** diagnostic
!      write(0,*)'ddscat ckpt 7, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #4
!*** diagnostic
!      call mpi_barrier(mpi_comm_world,ierr)
!      write(0,*)'ddscat ckpt 8, myid=',myid
!***
      ALLOCATE(IXYZ0(NAT0,3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 9, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #5
!$omp parallel do
         DO J=1,NAT0
            DO JJ=1,3
               IXYZ0(J,JJ)=ISCR1((JJ-1)*NAT0+J)
            ENDDO
         ENDDO
!$omp end parallel do

! Note: IXYZ0(1-NAT0,1-3) contain coordinates of occupied lattice sites
!       [reordered to standard order used for arrays produced by REDUCE]
!       BETADF(1-NAT0),PHIDF(1-NAT0),THETADF(1-NAT0) contain orientation
!                         angles for anisotropic material at occupied
!                         lattice sites (not used for isotropic material

! Reallocate ICOMP:
!*** diagnostic
!         write(0,*)'ddscat ckpt 9.5, myid=',myid
!***
         DSTORAGE=REAL(2*MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for ICOMP;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT3
            ISCR1(J)=ICOMP(J)
         ENDDO
!*** diagnostic
!      write(0,*)'ddscat ckpt 10, myid=',myid
!***
         DEALLOCATE(ICOMP)
!*** diagnostic
!      write(0,*)'ddscat ckpt 11, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #5
!*** diagnostic
!      write(0,*)'ddscat ckpt 12, myid=',myid
!      call mpi_barrier(mpi_comm_world,ierr)
!***
      ALLOCATE(ICOMP(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 13, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #6
         DO J=1,NAT3
            ICOMP(J)=ISCR1(J)
         ENDDO

! Reallocate IOCC:

         DSTORAGE=REAL(2*MXNAT)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for IOCC;   total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT
            ISCR1(J)=IOCC(J)
         ENDDO 
!*** diagnostic
!      write(0,*)'ddscat ckpt 14, myid=',myid
!***
         DEALLOCATE(IOCC)
!*** diagnostic
!      write(0,*)'ddscat ckpt 15, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #6
!*** diagnostic
!      write(0,*)'ddscat ckpt 16, myid=',myid
!***
      ALLOCATE(IOCC(MXNAT))
!*** diagnostic
!      write(0,*)'ddscat ckpt 17, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #7
         DO J=1,NAT
            IOCC(J)=ISCR1(J)
         ENDDO

! Reallocate BETADF:

         DSTORAGE=RWORD*REAL(NAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for BETADF; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT0
            SCRRS2(J)=BETADF(J)
         ENDDO
!*** diagnostic
!      write(0,*)'ddscat ckpt 18, myid=',myid
!***
         DEALLOCATE(BETADF)
!*** diagnostic
!      write(0,*)'ddscat ckpt 19, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #7
!*** diagnostic
!      write(0,*)'ddscat ckpt 20, myid=',myid
!***
      ALLOCATE(BETADF(MXNAT))
!*** diagnostic
!      write(0,*)'ddscat ckpt 21, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #8
         DO J=1,NAT0
            BETADF(J)=SCRRS2(J)
         ENDDO

! Reallocate PHIDF:

         DSTORAGE=RWORD*REAL(NAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for PHIDF;  total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT0
            SCRRS2(J)=PHIDF(J)
         ENDDO
!*** diagnostic
!      write(0,*)'ddscat ckpt 22, myid=',myid
!***
         DEALLOCATE(PHIDF)
!*** diagnostic
!      write(0,*)'ddscat ckpt 23, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #8
!*** diagnostic
!      write(0,*)'ddscat ckpt 24, myid=',myid
!***
      ALLOCATE(PHIDF(MXNAT))
!*** diagnostic
!      write(0,*)'ddscat ckpt 25, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #9
         DO J=1,NAT0
            PHIDF(J)=SCRRS2(J)
         ENDDO

! Reallocate THETADF:

         DSTORAGE=RWORD*REAL(NAT0)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for THETADF;total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         DO J=1,NAT0
            SCRRS2(J)=THETADF(J)
         ENDDO
!*** diagnostic
!      write(0,*)'ddscat ckpt 26, myid=',myid
!***
         DEALLOCATE(THETADF)
!*** diagnostic
!      write(0,*)'ddscat ckpt 27, myid=',myid
!***
      ENDIF   !--- end if(myid==0)... #9
!*** diagnostic
!      write(0,*)'ddscat ckpt 28, myid=',myid
!***
      ALLOCATE(THETADF(MXNAT))
!*** diagnostic
!      write(0,*)'ddscat ckpt 29, myid=',myid
!***
      IF(MYID==0)THEN   !--- begin if(myid==0)... #10
         DO J=1,NAT0
            THETADF(J)=SCRRS2(J)
         ENDDO

!------------------------------------------------------------------------------

! allocate CXADIA

         DSTORAGE=CWORD*REAL(MXNAT*3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for CXADIA; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #10
!*** diagnostic
!      write(0,*)'ddscat ckpt 30, myid=',myid
!***
      ALLOCATE(CXADIA(MXNAT,3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 31, myid=',myid
!***
!---------------------------------------------------------

! allocate CXZC
      IF(MYID==0)THEN   !--- begin if(myid==0)... #11
         DSTORAGE=CWORD*REAL((MXNX+1+MXPBC*(MXNX-1))*   &
                             (MXNY+1+MXPBC*(MXNY-1))*   &
                             (MXNZ+1+MXPBC*(MXNZ-1))*6)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
            ' MB for CXZC;   total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #11
!*** diagnostic
!      write(0,*)'ddscat ckpt 32, myid=',myid
!***
      ALLOCATE(CXZC(MXNX+1+MXPBC*(MXNX-1), &
                    MXNY+1+MXPBC*(MXNY-1), &
                    MXNZ+1+MXPBC*(MXNZ-1),6))

!-----------------------------------------------------------------------
! following introduced by Art Lazanoff to touch the array CXZW
! which supposedly helps with allocation and distribution of this memory
! to the different processors...
! BTD: I can't really see why the following is beneficial...

      DO JJ=1,6
!$omp parallel do
         DO JZ=1,MXNZ+1+MXPBC*(MXNZ-1)
            DO JY=1,MXNY+1+MXPBC*(MXNY-1)
               DO JX=1,MXNX+1+MXPBC*(MXNX-1)
                  CXZC(JX,JY,JZ,JJ)=(0._WP,0._WP)
               ENDDO
            ENDDO
         ENDDO
!$omp end parallel do
      ENDDO
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'ddscat ckpt 33, myid=',myid
!***
! allocate CXZW

      IF(MYID==0)THEN   !--- begin if(myid==0)... #12
         DSTORAGE=CWORD*REAL((2*MXNX)*(2*MXNY)*(2*MXNZ)*3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXZW;   total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #12
!*** diagnostic
!      write(0,*)'ddscat ckpt 34, myid=',myid
!***
      ALLOCATE(CXZW(2*MXNX,2*MXNY,2*MXNZ,3))

!-----------------------------------------------------------------------
! following introduced by Art Lazanoff to touch the array CXZW
! which supposedly helps with allocation and distribution of this memory
! to the different processors...
! BTD: I can't really see why the following is beneficial...

      DO JJ=1,3
!$omp parallel do
         DO JZ=1,2*MXNZ
            DO JY=1,2*MXNY
               DO JX=1,2*MXNX 
                  CXZW(JX,JY,JZ,JJ)=(0._WP,0._WP)
               ENDDO
            ENDDO
         ENDDO
!$omp end parallel do
      ENDDO
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'ddscat ckpt 35, myid=',myid
!***

! allocate CXAOFF

      IF(MYID==0)THEN   !--- begin if(myid==0)... #13
         DSTORAGE=CWORD*REAL(3*MXNAT)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXAOFF; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #13
!*** diagnostic
!      write(0,*)'ddscat ckpt 36, myid=',myid
!***
      ALLOCATE(CXAOFF(MXNAT,3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 37, myid=',myid
!***

! allocate CXALOF

      IF(MYID==0)THEN   !--- begin if(myid==0)... #14
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXALOF; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #14
!*** diagnostic
!      write(0,*)'ddscat ckpt 38, myid=',myid
!***
      ALLOCATE(CXALOF(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 39, myid=',myid
!***

! allocate CXALOS

      IF(MYID==0)THEN   !--- begin if(myid==0)... #15
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXALOS; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #15
!*** diagnostic
!      write(0,*)'ddscat ckpt 40, myid=',myid
!***
      ALLOCATE(CXALOS(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 41, myid=',myid
!***

! allocate CXALPH

      IF(MYID==0)THEN   !--- begin if(myid==0)... #16
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXALPH; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #16
!*** diagnostic
!      write(0,*)'ddscat ckpt 42, myid=',myid
!***
      ALLOCATE(CXALPH(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 44, myid=',myid
!***

! allocate CXE

      IF(MYID==0)THEN   !--- begin if(myid==0)... #18
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXE   ; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #18
!*** diagnostic
!      write(0,*)'ddscat ckpt 46, myid=',myid
!***
      ALLOCATE(CXE(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 47, myid=',myid
!***

! allocate CXSC

      IF(MYID==0)THEN   !--- begin if(myid==0)... #19
         DSTORAGE=CWORD*REAL(MXCXSC)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXSC  ; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #19
!*** diagnostic
!      write(0,*)'ddscat ckpt 48, myid=',myid
!***
      ALLOCATE(CXSC(MXCXSC))
!*** diagnostic
!      write(0,*)'ddscat ckpt 49, myid=',myid
!***

! allocate CXSCR1

      IF(MYID==0)THEN   !--- begin if(myid==0)... #20
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXSCR1; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #20
!*** diagnostic
!      write(0,*)'ddscat ckpt 50, myid=',myid
!***
      ALLOCATE(CXSCR1(MXN3))

!-----------------------------------------------------------------------
! following introduced by Art Lazanoff to touch the array CXZW
! which supposedly helps with allocation and distribution of this memory
! to the different processors...
! BTD: I can't really see why the following is beneficial...

!$omp parallel do
      DO J=1,MXN3
         CXSCR1(J)=(0._WP,0._WP)
      ENDDO
!$omp end parallel do
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'ddscat ckpt 51, myid=',myid
!***

! allocate CXXI

      IF(MYID==0)THEN   !--- begin if(myid==0)... #21
         DSTORAGE=CWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for CXXI;   total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #21
!*** diagnostic
!      write(0,*)'ddscat ckpt 52, myid=',myid
!***
      ALLOCATE(CXXI(MXN3))
!*** diagnostic
!      write(0,*)'ddscat ckpt 53, myid=',myid
!***

! allocate SCRRS1

      IF(MYID==0)THEN   !--- begin if(myid==0)... #22
         DSTORAGE=RWORD*REAL(MXN3)/MB
         STORAGE=STORAGE+DSTORAGE
         WRITE(CMSGNM,FMT='(A,F9.2,A,F9.2,A)')'allocating',DSTORAGE, &
                          ' MB for SCRRS1; total=',STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
         WRITE(CMSGNM,FMT='(16X,A,F9.2,A)')'Total memory allocation =', &
                          STORAGE,' MB'
         CALL WRIMSG('DDSCAT',CMSGNM)
      ENDIF   !--- end if(myid==0)... #22
!*** diagnostic
!      write(0,*)'ddscat ckpt 54, myid=',myid
!***
!***
!btd 08.05.08
!      ALLOCATE(SCRRS1(MXN3))
      ALLOCATE(SCRRS1(MXNAT,3))
!-----------------------------------------------------------------------
! following introduced by Art Lazanoff to touch the array CXZW
! which supposedly helps with allocation and distribution of this memory
! to the different processors...
! BTD: I can't really see why the following is beneficial...

      DO JJ=1,3
!$omp parallel do
         DO J=1,MXNAT
            SCRRS1(J,JJ)=0._WP
         ENDDO
!$omp end parallel do
      ENDDO
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'ddscat ckpt 55, myid=',myid
!      call mpi_barrier(mpi_comm_world,ierr)
!***

!---------------- memory allocation is complete -----------------------

!080217 BTD change
      IF(MYID==0)THEN   !--- begin if(myid==0)... #23

         IF(JPBC>0)THEN
            DO J=1,NSCAT
               ORDERM(J)=PHIN(J)
               ORDERN(J)=THETAN(J)
            ENDDO
         ENDIF

!-----------------------------------------------------------------------
! JPBC = 0 if PBC not used
!      = 1 for PBC in y direction only
!      = 2 for PBC in z direction only
!      = 3 for PBC in y and z directions

! IPBC controls memory use.
! At this time use same approach for JPBC=1 and 2 as for JPBC=3
! May change this in future.

         IF(JPBC==0)THEN
            IF(CMDFRM=='TFRAME')CALL ERRMSG('FATAL','DDSCAT',      &
               ' TFRAME = invalid option for finite targets (JPBC=0)')
            IPBC=0
         ELSEIF(JPBC==1.OR.JPBC==2)THEN
            IF(CMDFRM=='LFRAME')CALL ERRMSG('FATAL','DDSCAT',        &
               ' LFRAME = invalid option for periodic target (JPBC>0)')
            IPBC=1
         ELSEIF(JPBC==3)THEN
            IF(CMDFRM=='LFRAME')CALL ERRMSG('FATAL','DDSCAT',        &
               ' LFRAME = invalid option for periodic target (JPBC>0)')
            IPBC=1
         ENDIF

! Check that sufficient memory has been allocated:

         IF(IPBC==1.AND.MXPBC==0)THEN
            IF(8*NX*NY*NZ>(MXNX+1)*(MXNY+1)*(MXNZ+1))THEN
               CALL ERRMSG('FATAL','DDSCAT',                      &
                 ' CXSC too small for PBC: recompile with MXPBC=1')
            ENDIF
         ENDIF

         NORI=NTHETA*NBETA*NPHI
         NBETH=NTHETA*NBETA

! Compute angles in degrees for printout

         BETMID=DEGRAD*BETAMI
         BETMXD=DEGRAD*BETAMX
         THTMID=DEGRAD*THETMI
         THTMXD=DEGRAD*THETMX
         PHIMID=DEGRAD*PHIMIN
         PHIMXD=DEGRAD*PHIMAX

! If JPBC=0, obtain scattering vectors and scattering pol. vectors in 
! Lab Frame
!*** diagnostic
!         write(0,*)'ddscat ckpt 56, myid=',myid
!***

         IF(JPBC==0)THEN

!*** diagnostic
!            write(0,*)'in ddscat with jpbc=',jpbc,' about to call SCAVEC'
!***
            CALL SCAVEC(MXSCA,NSCAT,THETAN,PHIN,CXE01,ENSC,EM1,EM2)
!*** diagnostic
!            write(0,*)'returned to ddscat from scavec'
!***

! if JPBC = 0:
! ENSC(1-3,1-NSCAT) = scattering vectors in Lab Frame
! EM1(1-3,1-NSCAT)  = scattering polarization state 1 in Lab Frame
! EM2(1-3,1-NSCAT)  = scattering polarization state 2 in Lab Frame

         ELSE

! if JPBC > 0:
! initialize ENSC,EM1,EM2 to ensure that there are no divisions by zero
! in ROTATE.  Note that for JPBC > 0 these vectors are not actually used
! AKSR,EM1R,EM2R will be calculated later by subroutine PBCSCAVEC

            DO J=1,NSCAT
               DO JJ=1,3
                  ENSC(JJ,J)=0._WP
                  EM1(JJ,J)=0._WP
                  EM2(JJ,J)=0._WP
               ENDDO
               ENSC(1,J)=1._WP
               EM1(2,J)=1._WP
               EM2(3,J)=1._WP
            ENDDO
         ENDIF

! Note: IXYZ0(1-NAT0,1-3) contain coordinates of occupied lattice sites
!       [reordered to standard order used for arrays produced by REDUCE]
!       BETADF(1-NAT0),PHIDF(1-NAT0),THETADF(1-NAT0) contain orientation
!                         angles for anisotropic material at occupied
!                         lattice sites (not used for isotropic material

         WRITE(IDVOUT,FMT=9011)NAT,NX,NY,NZ

! Specify target orientations

! MXBETA=dimensioning information for array BETA of beta values
! MXTHET=dimensioning information for array THETA of theta values
! MXPHI=dimensioning information for array PHI of phi values
! BETAMI,BETAMX=minimum,maximum beta values (radians)
! THETMI,THETMX=minimum,maximum theta values (radians)
! PHIMIN,PHIMAX=minimum,maximum phi values (radians)
! BETA(1-NBETA)=beta values for target orientations (radians)
! THETA(1-NTHETA)=theta values for target orientations (radians)
! PHI(1-NPHI)=phi values for target orientations (radians)
! WGTA(1-NTHETA,1-NPHI)=weight for each orientation of axis a1 in LF
! WGTB(1-NBETA)=weight for each rotation of target around a1

!*** diagnostic
!         write(0,*)'in DDSCAT, about to call ORIENT'
!***
         CALL ORIENT(BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX,MXBETA,MXTHET, &
                    MXPHI,NBETA,NTHETA,NPHI,BETA,THETA,PHI,WGTA,WGTB)

!*** diagnostic
!         write(0,*)'returned to DDSCAT from ORIENT'
!***

! Open file 'qtable' for summary of Q values and
!           'mtable' for summary of refractive indices

         OPEN(UNIT=10,FILE='qtable',STATUS='UNKNOWN')
         OPEN(UNIT=11,FILE='mtable',STATUS='UNKNOWN')
         OPEN(UNIT=12,FILE='qtable2',STATUS='UNKNOWN')
!*** diagnostic
!         write(0,*)'in DDSCAT, after opening qtable,mtable,qtable2'
!***

! why not use cbinfile ? and open it in writesca ?

         IF(CBINFLAG=='ALLBIN'.OR.CBINFLAG=='ORIBIN')THEN
            IOBIN=51
            OPEN(UNIT=IOBIN,FILE='dd.bin',FORM='unformatted')
         ENDIF

! Write out header for 'qtable', 'qtable2', and 'mtable' files

         WRITE(10,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0
         ILIN10=6
         WRITE(10,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         ILIN10=ILIN10+NCOMP
         WRITE(12,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0
         ILIN12=6
         WRITE(12,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         ILIN12=ILIN12+NCOMP
         IF(IORTH==1)THEN
            WRITE(10,FMT=9043)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA, &
                              PHIMID,PHIMXD,NPHI,ETASCA,NORI,IORTH
            ILIN10=ILIN10+7
            WRITE(12,FMT=9045)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA, &
                              PHIMID,PHIMXD,NPHI,NORI,IORTH
            ILIN12=ILIN12+6
         ELSE
            WRITE(10,FMT=9043)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA, &
                              PHIMID,PHIMXD,NPHI,ETASCA,NORI,IORTH
            ILIN10=ILIN10+7
            WRITE(12,FMT=9046)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA, &
                              PHIMID,PHIMXD,NPHI,NORI,IORTH
            ILIN12=ILIN12+6
         ENDIF
         CLOSE(10)
         CLOSE(12)
         WRITE(11,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0
         WRITE(11,FMT=9021)(CFLEPS(J),J=1,NCOMP)
         WRITE(11,FMT=9048)
      ENDIF             !--- end if(myid==0)... #23

!*** The master process needs to share information from the above section
!    with the slave processes. All processes call this subroutine, which
!    does nothing if MPI is not being used.

!*** diagnostic
!      write(0,*)'DDSCAT ckpt 56.1, myid=',myid,' ICOMP(1)  =',ICOMP(1)
!      write(0,*)'DDSCAT ckpt 56.2, myid=',myid,' ICOMP(MXN3)=', &
!                ICOMP(MXN3),' MXN3=',MXN3
!      write(0,*)'DDSCAT ckpt 56.3, myid=',myid,' about to call SHARE1...'
!      write(0,*)'                  nz=',nz
!***
! this mpi_barrier is required to ensure that NX, etc computed by MYID=0
! will be evaluated before being SHAREd to the other threads

      CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)

      CALL SHARE1(A1,A2,A3,AEFFA,BETA,BETADF,BETMID,BETMXD,CALPHA,CBINFLAG,   &
                  CDESCR,CFLEPS,CMDFFT,CMDFRM,CMDSOL,CMDTRQ,CSHAPE,           &
                  CXE01,CXE02,DAEFF,DX,ENSC,EM1,EM2,ETASCA,GAMMA,IANISO,      &
                  ICOMP,IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,IOCC,IORI0,    &
                  IORTH,IPBC,IRAD0,IWAV0,IWRKSC,IWRPOL,IXYZ0,JPBC,MXBETA_SH,  &
                  MXCOMP_SH,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC_SH,MXPHI_SH,      &
                  MXRAD_SH,MXSCA_SH,MXTHET_SH,MXWAV_SH,MYID,NAT,NAT0,NAT3,    &
                  NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA,NWAV, &
                  NX,NY,NZ,ORDERM,ORDERN,PHI,PHIDF,PHIMID,PHIMXD,PHIN,PYD,    &
                  PYDDX,PZD,PZDDX,SHPAR,SMIND1,SMIND2,THETA,THETADF,THETAN,   &
                  THTMID,THTMXD,TOL,WAVEA,WGTA,WGTB,X0,XMAX,XMIN,YMAX,YMIN,   &
                  ZMAX,ZMIN)

!*** diagnostic
!      write(0,*)'ddscat ckpt 57, myid=',myid
!***
! IWAV0,IRAD0,IORI0 were obtained from REAPAR

!*** diagnostic
!      write(0,*)'returned to DDSCAT from SHARE1'
!***
      IWAV1=IWAV0+1
      IRAD1=IRAD0+1
      IORI1=IORI0+1
      ITHETA1=1+IORI0/(NBETA*NPHI)
      IBETA1=1+IORI0/NPHI-(ITHETA1-1)*NBETA
      IBETH1=1+IORI0/NPHI
      IPHI1=IORI1-(ITHETA1-1)*NBETA*NPHI-(IBETA1-1)*NPHI

!*** Loop over wavelengths:

      DO IWAV=IWAV1,NWAV                         !----- loop over IWAV -------
         WAVE=WAVEA(IWAV)

!*** Determine dielectric properties of target

         IF(MYID==0)THEN

!*** diagnostic
!            write(0,*)'DDSCAT ckpt 57.1, about to call DIELEC'
!***
            CALL DIELEC(WAVE,IDVOUT,CFLEPS,CXEPS,MXCOMP,MXWAVT,NCOMP, &
                        E1A,E2A,WVA)
!*** diagnostic
!            write(0,*)'DDSCAT ckpt 57.2 returned to DDDSCAT from DIELEC'
!***
         ENDIF

!*** Again the master process needs to share information with the slaves

!*** diagnostic
!         write(0,*)'DDSCAT ckpt 57.3, about to call SHARE2'
!***
! 080723 BTD add mpi_barrier to ensure that E1A,E2A have been read by MYID=0
!            before being SHAREd by other threads.

         CALL MPI_BARRIER(MPI_COMM_WORLD,IERR)

         CALL SHARE2(MXCOMP,MXWAVT,CXEPS,E1A,E2A,WVA)

!*** diagnostic
!         write(0,*)'DDSCAT ckpt 57.4, returned to DDSCAT from SHARE2'
!***

!*** Obtain complex polarizabilities

         DO J=1,NCOMP
            CXRFR(J)=SQRT(CXEPS(J))
            IF(MYID==0)THEN
               WRITE(IDVOUT,FMT=9031)CXRFR(J),CXEPS(J),J
            ENDIF
         ENDDO

         DO IRAD=IRAD1,NRAD                     !**** Loop over IRAD ----------

!*** diagnostic
!            write(0,*)'in DDSCAT, IRAD=',IRAD
!***

            AEFF=AEFFA(IRAD)
            XX=2._WP*PI*AEFF/WAVE

! Compute AK1=length of k vector in "natural" units=k*d
! (natural unit of length = d = lattice spacing)
! Remember that NAT = number of dipoles including "vacuum" sites in
!                     extended target
!               NAT0= number of dipoles in "real" target

            AK1=XX*DAEFF

            IF(MYID==0)THEN
               WRITE(IDVOUT,FMT=9032)AEFF,DAEFF,WAVE,XX,AK1
            ENDIF

            AK3=AK1**3

! PIA2=pi*(aeff/d)**2

            PIA2=PI*(.75_WP*NAT0/PI)**(2._WP/3._WP)

! Initialize various sums over target orientation.

            DO JO=1,IORTH
               QSCSUM(JO)=0._WP
               QABSUM(JO)=0._WP
               QEXSUM(JO)=0._WP
               QBKSUM(JO)=0._WP
               QPHSUM(JO)=0._WP
               QSCSUM_1(JO)=0._WP
               QABSUM_1(JO)=0._WP
               QEXSUM_1(JO)=0._WP
               QBKSUM_1(JO)=0._WP
               QPHSUM_1(JO)=0._WP
               QSCG2SUM(JO)=0._WP
               QSCG2SUM_1(JO)=0._WP
               DO J=1,3
                  QSCGSUM(J,JO)=0._WP
                  QTRQABSUM(J,JO)=0._WP
                  QTRQSCSUM(J,JO)=0._WP
                  QSCGSUM_1(J,JO)=0._WP
                  QTRQABSUM_1(J,JO)=0._WP
                  QTRQSCSUM_1(J,JO)=0._WP
               ENDDO
            ENDDO
            DO IDIR=1,NSCAT
               S1111(IDIR)=0._WP
               S2121(IDIR)=0._WP
               S1111_1(IDIR)=0._WP
               S2121_1(IDIR)=0._WP
               CX1121(IDIR)=(0._WP,0._WP)
               CX1121_1(IDIR)=(0._WP,0._WP)
            ENDDO
            DO IDIR=1,NSCAT
               DO J=1,4
                  DO JO=1,4
                     SMORI(JO,J,IDIR)=0._WP
                     SMORI_1(JO,J,IDIR)=0._WP
                  ENDDO
               ENDDO
            ENDDO

! Loop over target orientations (target rotations in Lab Frame)
! (actually, loop over lab rotations in Target Frame)

!**** The outer orientation loop over IBETH=1,NBETH is divided up among
!     the parallel processes.

            IORI=IORI0

! ITNUMMX will store the maximum number of iterations used for any of
! the orientations for current size and wavelength, so that this can
! be written to the waarbbkccc.sca output file

            DO J=1,2
               ITNUMMX(J)=0
            ENDDO

            DO IBETH=MYID+IBETH1,NBETH,NUMPROCS  !---- loop over IBETH -------
!*** diagnostic
!               write(0,*)'DDSCAT ckpt 57.5, IBETH=',IBETH
!***
               ITHETA=INT((IBETH-1)/NBETA)+1
               THETAD=THETA(ITHETA)*DEGRAD
               IBETA=MOD(IBETH-1,NBETA)+1
               BETAD=BETA(IBETA)*DEGRAD

               DO IPHI=IPHI1,NPHI                 !---- loop over PHI --------

!*** diagnostic
!                  write(0,*)'DDSCAT ckpt 57.6, IPHI=',IPHI
!***
                  PHID=PHI(IPHI)*DEGRAD
                  IORI=(ITHETA-1)*NBETA*NPHI+(IBETA-1)*NPHI+IPHI

!-----------------------------------------------------------------------
!**** For specified target rotations BETA,THETA,PHI in the Lab Frame,
!     and predefined 

!     ENSC(1-3,1-NSCAT) scattering directions in the Lab Frame 
!     EM1(1-3,1-NSCAT) scattered pol. vectors 1 in the Lab Frame
!     EM2(1-3,1-NSCAT) scattered pol. vectors 2 in the Lab Frame

!     subroutine ROTATE computes

!     AKSR(1-3,1-NSCAT) propagation vectors in the Target Frame
!     EM1R(1-3,1-NSCAT) scattered pol vectors 1 in Target Frame
!     EM2R(1-3,1-NSCAT) scattered pol vectors 2 in Target Frame

!     Note: subroutine ROTATE assumes that the angles THETAN,PHIN define
!     scattering directions in the Lab Frame -- if these values are
!     actually for the Target Frame, values of AKSR,EM1R,EM2R returned
!     by ROTATE will later be replaced by correct values.

!*** diagnostic
!                  write(0,*)'DDSCAT ckpt 57.65, about to call ROTATE'
!***
                  CALL ROTATE(A1,A2,AK1,CXE01,CXE02,BETA(IBETA),          &
                              THETA(ITHETA),PHI(IPHI),EN0R,CXE01R,CXE02R, &
                              MXSCA,NSCAT,ENSC,EM1,EM2,AKSR,EM1R,EM2R)
!*** diagnostic
!                  write(0,*)'DDSCAT ckpt 57.66, myid=',myid,              &
!                            ' BETA,THETA,PHI=',BETA(IBETA),THETA(ITHETA), &
!                            PHI(IPHI)
!                  write(0,*)'myid=',myid,' en0r(1-3)=',en0r
!*** end diagnostic
!                  write(0,*)' returned from ROTATE'
!                  write(0,9113)cxe01,cxe02,cxe01r,cxe02r
! 9113 format('cxe01 =',2f8.5,2x,2f8.5,2x,2f8.5,/, &
!             'cxe02 =',2f8.5,2x,2f8.5,2x,2f8.5,/, &
!             'cxe01r=',2f8.5,2x,2f8.5,2x,2f8.5,/, &
!             'cxe02r=',2f8.5,2x,2f8.5,2x,2f8.5)
!*** end diagnostic

! calculate ENSCR = unit scattering vector in Target Frame

                  DO IDIR=1,NSCAT
                     DO J=1,3
                        ENSCR(J,IDIR)=AKSR(J,IDIR)/AK1
                     ENDDO
                  ENDDO

! calculate XLR,YLR,ZLR = lab unit vectors XL,YL,ZL in Target Frame

                  DO J=1,3
                     SINTHE=SIN(THETA(ITHETA))
                     COSTHE=COS(THETA(ITHETA))
                     SINPHI=SIN(PHI(IPHI))
                     COSPHI=COS(PHI(IPHI))
                     SINBET=SIN(BETA(IBETA))
                     COSBET=COS(BETA(IBETA))
                     XLR(J)=A1(J)*COSTHE-A2(J)*SINTHE*COSBET+                &
                            A3(J)*SINTHE*SINBET
                     YLR(J)=A1(J)*SINTHE*COSPHI+A2(J)*(COSTHE*COSBET*COSPHI- &
                            SINBET*SINPHI)-A3(J)*(COSTHE*SINBET*COSPHI+      &
                            COSBET*SINPHI)
                     ZLR(J)=A1(J)*SINTHE*SINPHI+A2(J)*(COSTHE*COSBET*SINPHI+ &
                            SINBET*COSPHI)-A3(J)*(COSTHE*SINBET*SINPHI-      &
                            COSBET*COSPHI)
                  ENDDO

! If CMDFRM = 'TFRAME' then angles THETAN,PHIN define scattering
!                      directions in the Target Frame, so ignore
!                      vectors AKSR,EM1R,EM2R calculated by ROTATE,
!                      and instead simply use ENSC,EM1,EM2

                  IF(CMDFRM=='TFRAME')THEN
                     IF(JPBC==0)THEN
                        DO IDIR=1,NSCAT
                           DO J=1,3
                              AKSR(J,IDIR)=AK1*ENSC(J,IDIR)
                              EM1R(J,IDIR)=EM1(J,IDIR)
                              EM2R(J,IDIR)=EM2(J,IDIR)
                           ENDDO
                        ENDDO
                     ELSE

! JPBC= 1, 2, or 3: call PBCSCAVEC to calculate scattering vectors 
!                        AKSR,EM1R,EM2R in TF,
!                        ENSC,EM1,EM2 in LF

!*** diagnostic
!                        write(0,*)'DDSCAT ckpt 57.67, ',        & 
!                                  'about to call pbcscavec with'
!                        write(0,*)'          phin(1)=',phin(1)
!                        write(0,*)'          phin(2)=',phin(2)
!                        write(0,9393)xlr,ylr,zlr
!  9393 format('xlr(1-3)=',3f8.5,/,'ylr(1-3)=',3f8.5,/,'zlr(1-3)=',3f8.5)
!***
                        CALL PBCSCAVEC(MXSCA,JPBC,NSCAT,PYDDX,PZDDX,A1,A2, &
                                       THETA(ITHETA),BETA(IBETA),          &
                                       XLR,YLR,ZLR,AK1,EN0R,CXE01R,ORDERM, &
                                       ORDERN,THETAN,PHIN,AKSR,EM1R,EM2R,  &
                                       ENSC,EM1,EM2)
!*** diagnostic
!                        write(0,*)'DDSCAT ckpt 57.68: returned from pbcscavec'
!                        write(0,*)'                   phin(1)=',phin(1)
!                        write(0,*)'                   phin(2)=',phin(2)
!                        do idir=1,2
!                           write(0,9411)idir,                         &
!                              ensc(1,idir),ensc(2,idir),ensc(3,idir), &
!                              aksr(1,idir),aksr(2,idir),aksr(3,idir), &
!                              em1(1,idir),em1(2,idir),em1(3,idir),    &
!                              em1r(1,idir),em1r(2,idir),em1r(3,idir), &
!                              em2(1,idir),em2(2,idir),em2(3,idir),    &
!                              em2r(1,idir),em2r(2,idir),em2r(3,idir)
!                        enddo
! 9411 format('nd=',i2,'ensc=',3f9.5,' aksr=',3f9.5,/, &
!                   5x,' em1=',3f9.5,' em1r=',3f9.5,/, &
!                   5x,' em2=',3f9.5,' em2r=',3f9.5)
!*** end diagnostic
                     ENDIF
                  ENDIF

!-----------------------------------------------------------------------

                  DO J=1,3
                     AKR(J)=AK1*EN0R(J)
                  ENDDO

!*** diagnostic
!                  write(0,*)'ddscat ckpt 58, myid=',myid, &
!                            ' ak1=',ak1,' en0r(1-3)=',en0r
!***
! note: if called with IORI > 999, NAMER will have trouble when
!       generating CFLSCA.  If IWRKSC=0, this is immaterial, because
!       CFLSCA will not be used.
!       We will check in REAPAR to halt if user requests IWRKSC=1 and
!       more than 1000 orientations.

!*** diagnostic
!                  write(0,*)'in DDSCAT, about to call NAMER'
!***
                  IF(IWRKSC==1)THEN
                     CALL NAMER(IWAV,IRAD,IORI,CFLPOL1,CFLPOL2,CFLSCA,CFLAVG)
                  ELSE

! 100128 BTD change IORI from 0 to 1 when calling NAMER with IWRKSC=0

                     CALL NAMER(IWAV,IRAD,1,CFLPOL1,CFLPOL2,CFLSCA,CFLAVG)
                  ENDIF
!*** diagnostic
!                  write(0,*)'returned to DDSCAT from NAMER'
!***
!*** diagnostic
!                  write(0,*)'about to call getfml at ckpt alpha'
!                  write(0,9220)(theta(itheta)*180./pi), &
!                        (beta(ibeta)*180./pi),          &
!                        (phi(iphi)*180./pi),            &
!                        akr,cxe01r,cxe02r,              &
!                        aksr(1,1),aksr(2,1),aksr(3,1),  &
!                        em1r(1,1),em1r(2,1),em1r(3,1),  &
!                        em2r(1,1),em2r(2,1),em2r(3,1)
! 9220 format('=========================================',/, &
!             'theta=',f10.5,' beta=',f10.5,' phi=',f10.5,/, &
!             '  akr =',3f10.6,/,                            &
!             'cxe01r=',2f9.5,' ,',2f9.5,' ,',2f9.5,/,       &
!             'cxe01r=',2f9.5,' ,',2f9.5,' ,',2f9.5,/,       &
!             'aksr(j,1)=',3f10.6,/,                         &
!             'em1r(j,1)=',3f10.6,/,                         &
!             'em2r(j,1)=',3f10.6)
!***
!*** diagnostic
!                  write(0,FMT='(A,I3,A,F10.6,A,3F10.6)')                     &
!                     'ddscat ckpt 59, myid=',myid,' ak1=',ak1,' akr(1-3)=',akr
!                  write(0,*)'mxnat=',mxnat
!                  write(0,*)'about to call GETFML...'
!***
                  CALL GETFML(AKR,AK3,AKSR,BETADF,PHIDF,THETADF,DX,X0,CALPHA, &
                              CMDSOL,CMDFFT,CMDTRQ,CSHAPE,CXADIA,CXAOFF,      &
                              CXALPH,CXALOF,CXALOS,CXE,CXE01R,CXE02R,CXEPS,   &
                              CXF11,CXF12,CXF21,CXF22,CXRLOC,CXXI,CXSC,       &
                              CXSCR1,CXZC,CXZW,EM1R,EM2R,ETASCA,GAMMA,IBETH,  &
                              IBETH1,ICOMP,IDVOUT,INIT,IOCC,IORTH,IPBC,IPHI,  &
                              IPHI1,ITASK,IXYZ0,ITNUM,JPBC,MXITER,LACE,LAXI,  &
                              LCLM,LGI,LPI,LQI,LSC0,MXCOMP,MXCXSC,MXN3,MXNAT, &
                              MXNX,MXNY,MXNZ,MXPBC,MXPHI,MXSCA,MYID,NAT,NAT0, &
                              NAT3,NAVG,NCOMP,NSCAT,NX,NY,NZ,PHI,PIA2,QABS,   &
                              QBKSCA,QEXT,QPHA,QSCAT,QSCAG,QSCAG2,QTRQAB,     &
                              QTRQSC,SCRRS1,SCRRS2,SHPAR,TOL,TIMERS,MXTIMERS, &
                              NTIMERS)

!*** diagnostic
!                  write(0,*)'DDSCAT ckpt 60, myid=',myid
!***
!                  write(0,9221)cxf11(1),cxf12(1),cxf21(1),cxf22(1)
! 9221 format('cxf11(1)=',2f10.6,' cxf21(1)=',2f10.6,/, &
!             'cxf12(1)=',2f10.6,' cxf22(1)=',2f10.6)
!***
! if IORTH=1, GETFML returns reduced polarization array for orientation
!             IPHI=IPHI1 and JO=1 (incident wave CXE01R) in CXSCR1,
!             and scattering amplitude factors CXF11,CXF21 for NSCAT
!             directions
! if IORTH=2, GETFML also returns reduced polarization array for
!             JO=2 (incident wave CXE02R) in CXSC(LACE)
!             and scattering amplitude factors CXF12,CXF22

                  IF(IWRKSC==1)THEN
!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 61, myid=',myid
!***
                     CALL NAMER2(IWAV,IRAD,IORI,CFLFML)
!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 62, myid=',myid
!***
                     CALL WRITEFML(JPBC,IORI,IORTH,IRAD,IWAV,MXCOMP,MXSCA,   &
                                   NAT0,NAVG,NCOMP,NSCAT,CALPHA,CDESCR,      &
                                   CMDFFT,CMDFRM,CSHAPE,CSTAMP,AEFF,AK1,AKR, &
                                   BETAD,PHID,THETAD,TOL,WAVE,XX,A1,A2,PHIN, &
                                   THETAN,CXE01,CXE01R,CXE02,CXE02R,CXEPS,   &
                                   CXRFR,CXF11,CXF21,CXF12,CXF22,PYD,PZD)
!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 63, myid=',myid
!***
                  ENDIF

                  DO J=1,2
                     IF(ITNUM(J)>ITNUMMX(J))ITNUMMX(J)=ITNUM(J)
                  ENDDO

! Compute Mueller scattering matrix

!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 64, myid=',myid
!***
                  CALL GETMUELLER(IBETA,IORTH,IPHI,ITHETA,JPBC,MXBETA,MXSCA,  &
                                  MXPHI,MXTHET,NSCAT,ORDERM,ORDERN,CMDTRQ,    &
                                  AK1,AKSR,ENSC,ENSCR,PYDDX,PZDDX,PHIN,SM,    &
                                  SMORI_1,S1111_1,S2121_1,CX1121_1,CXE01,     &
                                  CXE02,CXF11,CXF12,CXF21,CXF22,CXS1,CXS2,    &
                                  CXS3,CXS4,QABS,QABSUM_1,QBKSCA,QBKSUM_1,    &
                                  QEXSUM_1,QEXT,QPHA,QPHSUM_1,QSCAG,QSCAG2,   &
                                  QSCAT,QSCG2SUM_1,QSCGSUM_1,QSCSUM_1,QTRQAB, &
                                  QTRQABSUM_1,QTRQSC,QTRQSCSUM_1,WGTA,WGTB,   &
                                  EM1,EM2,EM1R,EM2R)
!*** diagnostic
!                  write(0,*)'DDSCAT ckpt 65, myid=',myid, &
!                            'IORTH=',IORTH,' QSCSUM_1(1-2)=',QSCSUM_1
!***
!----------------------------------------------------------------------
!**** Choose whether or not to write out scattering properties for
!     current orientation; conditional may be replaced if desired.

!**** If IWRKSC=1, write scattering properties of current orientation:

                  IF(IWRKSC==1)THEN

!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 66, myid=',myid
!***
                       CALL WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,IXYZ0,  &
                          JPBC,MXNAT,MXN3,MYID,NAT,NAT3,WAVEA,MXWAV,NWAV,     &
                          AEFFA,MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,MXTHET,    &
                          NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,NPHI,NSMELTS,    &
                          TIMERS,MXTIMERS,NTIMERS,CBINFILE,IOBIN,CBINFLAG,    &
                          IDNC,ILIN10,ILIN12,IORI,IWRKSC,   &
                          IORTH,IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,ITNUM,       &
                          MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,CFLAVG,       &
                          CFLSCA,CMDFFT,CMDFRM,CMDTRQ,CSHAPE,CSTAMP,AEFF,AK1, &
                          AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,PHIMXD,  &
                          THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,A2,PHIN,QABS,   &
                          QABSUM_1,QBKSCA,QBKSUM_1,QEXSUM_1,QEXT,QPHA,        &
                          QPHSUM_1,QSCAG,QSCAG2,QSCAT,QSCGSUM_1,QSCG2SUM_1,   &
                          QSCSUM_1,QTRQAB,QTRQABSUM_1,QTRQSC,QTRQSCSUM_1,     &
                          S1111_1,S2121_1,SM,SMIND1,SMIND2,SMORI_1,THETAN,    &
                          CX1121,CXE01,CXE01R,CXE02,CXE02R,CXEPS,CXRFR,CXF11, &
                          CXF21,CXF12,CXF22,PYDDX,PZDDX,XMIN,XMAX,YMIN,YMAX,  &
                          ZMIN,ZMAX)
!*** diagnostic
!                       write(0,*)'DDSCAT ckpt 67, myid=',myid
!***
                  ENDIF

! only write out polarization array if IPHI=1 (for IPHI>1, can
! reconstruct polarization array by linear combination of CFPOL1 and
! CFPOL2)

                  IF(IWRPOL==1.AND.IPHI==1)THEN
!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 68, myid=',myid
!***
                     CALL WRITEPOL(NRWORD,MXNAT,NX,NY,NZ,NAT0,IANISO,  &
                                   ICOMP,IXYZ0,PYD,PZD,AKR,DX,X0,WAVE, &
                                   BETADF,THETADF,PHIDF,CXE01R,CXADIA, &
                                   CXAOFF,CXSCR1,CFLPOL1)
!*** diagnostic
!                     write(0,*)'DDSCAT ckpt 69, myid=',myid
!***
                     IF(IORTH==2)THEN
                        CALL WRITEPOL(NRWORD,MXNAT,NX,NY,NZ,NAT0,IANISO,  &
                                      ICOMP,IXYZ0,PYD,PZD,AKR,DX,X0,WAVE, &
                                      BETADF,THETADF,PHIDF,CXE02R,CXADIA, &
                                      CXAOFF,CXSC(LACE),CFLPOL2)
                     ENDIF
                  ENDIF
               ENDDO ! end loop over IPHI

               IPHI1=1

            ENDDO ! end loop over IBETH

            IBETH1=1

!*** Collect the partial sums over target orientation
!     from the parallel processes. This routine is a dummy
!     if MPI is not being used.

!*** diagnostic
!            write(0,*)'DDSCAT ckpt 70, myid=',myid
!***
            CALL COLSUM(IORTH,MYID,MXSCA,NSCAT,QSCSUM,QSCSUM_1,QABSUM,     &
                        QABSUM_1,QEXSUM,QEXSUM_1,QBKSUM,QBKSUM_1,QPHSUM,   &
                        QPHSUM_1,QSCG2SUM,QSCG2SUM_1,QSCGSUM,QSCGSUM_1,    &
                        QTRQABSUM,QTRQABSUM_1,QTRQSCSUM,QTRQSCSUM_1,S1111, &
                        S1111_1,S2121,S2121_1,CX1121,CX1121_1,SMORI,SMORI_1)
!*** diagnostic
!            write(0,*)'DDSCAT ckpt 71, myid=',myid
!***
!*** Write dielectric information to 'mtable'

            FREQ=1.E4_WP/WAVE
            CXEN=SQRT(CXEPS(1))
            IF(MYID==0)THEN
                WRITE(11,FMT=9058)WAVE,FREQ,CXEN,CXEPS(1)
            ENDIF

! Set IORI=0 prior to calling WRITESCA in order to print orientational
! averages

            IORI=0

!******** Now print out orientational averages **********

            IF(MYID==0)THEN

               CALL WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,IXYZ0,JPBC,     &
                             MXNAT,MXN3,MYID,NAT,NAT3,WAVEA,MXWAV,NWAV,AEFFA, &
                             MXRAD,NRAD,ITHETA,IBETA,IPHI,THETA,MXTHET,       &
                             NTHETA,BETA,MXBETA,NBETA,PHI,MXPHI,NPHI,NSMELTS, &
                             TIMERS,MXTIMERS,NTIMERS,CBINFILE,IOBIN,CBINFLAG, &
                             IDNC,ILIN10,ILIN12,IORI,       &
                             IWRKSC,IORTH,IRAD,IWAV,MXCOMP,MXSCA,NAT0,NAVG,   &
                             ITNUMMX,MXITER,NCOMP,NORI,NSCAT,CALPHA,CDESCR,   &
                             CFLAVG,CFLSCA,CMDFFT,CMDFRM,CMDTRQ,CSHAPE,       &
                             CSTAMP,AEFF,AK1,AKR,BETAD,BETMID,BETMXD,ETASCA,  &
                             PHID,PHIMID,PHIMXD,THETAD,THTMID,THTMXD,TOL,     &
                             WAVE,XX,A1,A2,PHIN,QABS,QABSUM,QBKSCA,QBKSUM,    &
                             QEXSUM,QEXT,QPHA,QPHSUM,QSCAG,QSCAG2,QSCAT,      &
                             QSCGSUM,QSCG2SUM,QSCSUM,QTRQAB,QTRQABSUM,QTRQSC, &
                             QTRQSCSUM,S1111,S2121,SM,SMIND1,SMIND2,SMORI,    &
                             THETAN,CX1121,CXE01,CXE01R,CXE02,CXE02R,CXEPS,   &
                             CXRFR,CXF11,CXF21,CXF12,CXF22,PYDDX,PZDDX,XMIN,  &
                             XMAX,YMIN,YMAX,ZMIN,ZMAX)

            ENDIF

        ENDDO ! end loop over IRAD
        IRAD1=1

      ENDDO ! end loop over IWAV

! close binary file (this perhaps should be moved to writesca)

      IF(MYID==0)THEN
         IF(CBINFLAG/='NOTBIN')THEN
            CALL WRIMSG('DDSCAT',' close dd.bin')
            CLOSE(IOBIN)
         ENDIF
         CLOSE(11) ! close mtable
      ENDIF

      CALL WRIMSG('DDSCAT',' terminates normally')

! MPI environment shutdown:

      CALL MPI_FINALIZE(IERR)

      STOP

9000  FORMAT(' >DDSCAT --- ',A)
9011  FORMAT(7X,I7,' = NAT  = number of dipoles in extended target'/7X,3I4, &
        ' = x,y,z length of extended target (Targ. Frame)')
9020  FORMAT(' DDSCAT --- ',A/' TARGET ---',A/' ',A,                      &
        ' --- method of solution '/' ',A,                                 &
        ' --- prescription for polarizabilities'/' ',A,' --- shape '/I7,  &
        ' = NAT0 = number of dipoles')
9021  FORMAT(' ',A)
9031  FORMAT(' m= (',F7.4,' ,',F7.4,'),  epsilon= (',F8.4,' , ',F7.4,     &
         ')  for material',I2)
9032  FORMAT(F12.6,' = AEFF = effective radius (physical units)',/, &
         F12.6,' = d/aeff for this target',/,                       &
         F12.6,' = WAVE = wavelength (physical units)',/,           &
         F12.6,' = k*aeff = 2*pi*aeff/lambda',/,                    &
         F12.6,' = k*d')
9043  FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2/2F8.3,               &
        ' = theta_min, theta_max; NTHETA=',I2/2F8.3,                          &
        ' = phi_min, phi_max   ;   NPHI =',I2/F7.4,                           &
        ' = ETASCA (param. controlling # of ',                                &
        'scatt. dirs used to calculate <cos> etc.'/' Results averaged over ', &
        I4,' target orientations'/'                   and ',I2,               &
        ' incident polarizations'/3X,'aeff',7X,'wave',7X,'Q_ext',5X,'Q_abs',  &
        6X,'Q_sca',5X,'g(1)=<cos>',2X,'<cos^2>',4X,'Q_bk',7X,'Nsca')
9045  FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2/2F8.3,             &
        ' = theta_min, theta_max; NTHETA=',I2/2F8.3,                        &
        ' = phi_min, phi_max   ;   NPHI =',I2/' Results averaged over ',I4, &
        ' target orientations'/'                   and ',I2,                &
        ' incident polarizations'/'   aeff       wave      Q_pha')
9046  FORMAT(2F8.3,' = beta_min, beta_max ;  NBETA =',I2/2F8.3,              &
        ' = theta_min, theta_max; NTHETA=',I2/2F8.3,                         &
        ' = phi_min, phi_max   ;   NPHI =',I2/' Results averaged over ',I4,  &
        ' target orientations'/'                   and ',I2,                 &
        ' incident polarizations'/'   aeff',7X,'wave',7X,'Q_pha',7X,'Q_pol', &
        7X,'Q_cpol')
9048  FORMAT(' wave(um)   f(cm-1)     Re(m)     Im(m)    Re(eps)   ', &
        'Im(eps)')
9058  FORMAT(1P,E10.4,E11.4,4E10.3)

    END PROGRAM DDSCAT

! mpi_fake.f contains dummy subroutines that take the place
! of
!    SUBROUTINE COLSUM
!    SUBROUTINE SHARE0
!    SUBROUTINE SHARE1
!    SUBROUTINE SHARE2
!    SUBROUTINE MPI_INIT
!    SUBROUTINE MPI_COMM_RANK
!    SUBROUTINE MPI_COMM_SIZE
!    SUBROUTINE MPI_FINALIZE
!    SUBROUTINE MPI_BARRIER
! which are called when MPI is being used.
! These dummy routines do nothing when MPI is not being used.

    SUBROUTINE COLSUM(IORTH,MYID,MXSCA,NSCAT,QSCSUM,QSCSUM_1,QABSUM,     &
                      QABSUM_1,QEXSUM,QEXSUM_1,QBKSUM,QBKSUM_1,QPHSUM,   &
                      QPHSUM_1,QSCG2SUM,QSCG2SUM_1,QSCGSUM,QSCGSUM_1,    &
                      QTRQABSUM,QTRQABSUM_1,QTRQSCSUM,QTRQSCSUM_1,S1111, &
                      S1111_1,S2121,S2121_1,CX1121,CX1121_1,SMORI,SMORI_1)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
! arguments:
      INTEGER :: IORTH,MXSCA,NSCAT,MYID
      REAL(WP) ::              &
         QABSUM(IORTH),        &
         QABSUM_1(IORTH),      &
         QBKSUM(IORTH),        &
         QBKSUM_1(IORTH),      &
         QEXSUM(IORTH),        &
         QEXSUM_1(IORTH),      &
         QPHSUM(IORTH),        &
         QPHSUM_1(IORTH),      &
         QSCG2SUM(IORTH),      &
         QSCG2SUM_1(IORTH),    &
         QSCGSUM(3,IORTH),     &
         QSCGSUM_1(3,IORTH),   &
         QSCSUM(IORTH),        &
         QSCSUM_1(IORTH),      &
         QTRQABSUM(3,IORTH),   &
         QTRQABSUM_1(3,IORTH), &
         QTRQSCSUM(3,IORTH),   &
         QTRQSCSUM_1(3,IORTH), &
         S1111(MXSCA),         &
         S1111_1(MXSCA),       &
         S2121(MXSCA),         &
         S2121_1(MXSCA),       &
         SMORI(4,4,MXSCA),     &
         SMORI_1(4,4,MXSCA)
      COMPLEX(WP) ::    &
         CX1121(MXSCA), &
         CX1121_1(MXSCA)
! local variables
      INTEGER J,K,ND

      DO ND=1,IORTH
         QSCSUM(ND)=QSCSUM(ND)+QSCSUM_1(ND)
         QABSUM(ND)=QABSUM(ND)+QABSUM_1(ND)
         QEXSUM(ND)=QEXSUM(ND)+QEXSUM_1(ND)
         QBKSUM(ND)=QBKSUM(ND)+QBKSUM_1(ND)
         QPHSUM(ND)=QPHSUM(ND)+QPHSUM_1(ND)
         QSCG2SUM(ND)=QSCG2SUM(ND)+QSCG2SUM_1(ND)
      ENDDO
      DO J=1,IORTH
         DO ND=1,3
            QSCGSUM(ND,J)=QSCGSUM(ND,J)+QSCGSUM_1(ND,J)
            QTRQABSUM(ND,J)=QTRQABSUM(ND,J)+QTRQABSUM_1(ND,J)
            QTRQSCSUM(ND,J)=QTRQSCSUM(ND,J)+QTRQSCSUM_1(ND,J)
         ENDDO
      ENDDO
      DO ND=1,NSCAT
         CX1121(ND)=CX1121(ND)+CX1121_1(ND)
         S1111(ND)=S1111(ND)+S1111_1(ND)
         S2121(ND)=S2121(ND)+S2121_1(ND)
      ENDDO
      DO ND=1,NSCAT
         DO K=1,4
            DO J=1,4
               SMORI(J,K,ND)=SMORI(J,K,ND)+SMORI_1(J,K,ND)
            ENDDO
         ENDDO
      ENDDO
         
      RETURN
    END SUBROUTINE COLSUM

    SUBROUTINE SHARE0(LACE,LAXI,LCLM,LGI,LPI,LQI,                     &
                      MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,MXCXSC,MYID,NAT0)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
! arguments
      INTEGER :: LACE,LAXI,LCLM,LGI,LPI,LQI,                    &
                 MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,MXCXSC,MYID,NAT0
      RETURN
    END SUBROUTINE SHARE0
    
    SUBROUTINE SHARE1(A1,A2,A3,AEFFA,BETA,BETADF,BETMID,BETMXD,CALPHA,       &
                      CBINFLAG,CDESCR,CFLEPS,CMDFFT,CMDFRM,CMDSOL,CMDTRQ,    &
                      CSHAPE,CXE01,CXE02,DAEFF,DX,ENSC,EM1,EM2,ETASCA,GAMMA, &
                      IANISO,ICOMP,IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,   &
                      IOCC,IORI0,IORTH,IPBC,IRAD0,IWAV0,IWRKSC,IWRPOL,IXYZ0, &
                      JPBC,MXBETA,MXCOMP,MXN3,MXNAT,MXNX,MXNY,MXNZ,MXPBC,    &
                      MXPHI,MXRAD,MXSCA,MXTHET,MXWAV,MYID,NAT,NAT0,NAT3,     &
                      NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA, &
                      NWAV,NX,NY,NZ,ORDERM,ORDERN,PHI,PHIDF,PHIMID,PHIMXD,   &
                      PHIN,PYD,PYDDX,PZD,PZDDX,SHPAR,SMIND1,SMIND2,THETA,    &
                      THETADF,THETAN,THTMID,THTMXD,TOL,WAVEA,WGTA,WGTB,X0,   &
                      XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN)

      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! arguments

      INTEGER :: MXNAT,MXN3,MXBETA,MXCOMP,MXNX,MXNY,MXNZ,MXPBC, &
                 MXPHI,MXRAD,MXSCA,MXTHET,MXWAV
      CHARACTER :: CALPHA*6,CBINFLAG*(*),CDESCR*67,CMDFFT*6, &
                   CMDFRM*6,CSHAPE*9,CMDSOL*6,CMDTRQ*6
      CHARACTER(60) :: &
         CFLEPS(MXCOMP)
      INTEGER :: IANISO,IDVERR,IDVOUT,ILIN10,ILIN12,INIT,IOBIN,IORTH,IORI0,  &
                 IPBC,IRAD0,IWAV0,IWRKSC,IWRPOL,JPBC,MYID,NAT,NAT0,NAT3,     &
                 NBETA,NBETH,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA,NWAV, &
                 NX,NY,NZ
      INTEGER*2 ::    &
         ICOMP(MXN3), &
         IOCC(MXNAT)
      INTEGER ::        &
         IXYZ0(NAT0,3), &
         SMIND1(9),     &
         SMIND2(9)
      REAL(WP) :: BETMID,BETMXD,DAEFF,ETASCA,GAMMA,PHIMID,PHIMXD,PYD,PYDDX, &
                  PZD,PZDDX,THTMID,THTMXD,TOL,XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN
      REAL(WP) ::            &
         A1(3),              &
         A2(3),              &
         A3(3),              &
         AEFFA(MXRAD),       &
         BETA(MXBETA),       &
         BETADF(NAT0),       &
         DX(3),              &
         EM1(3,MXSCA),       &
         EM2(3,MXSCA),       &
         ENSC(3,MXSCA),      &
         ORDERM(MXSCA),      &
         ORDERN(MXSCA),      &
         PHI(MXPHI),         &
         PHIDF(NAT0),        &
         PHIN(MXSCA),        &
         SHPAR(10),          &
         THETA(MXTHET),      &
         THETADF(NAT0),      &
         THETAN(MXSCA),      &
         WAVEA(MXWAV),       &
         WGTA(MXTHET,MXPHI), &
         WGTB(MXBETA),       &
         X0(3)
      COMPLEX(WP) :: &
         CXE01(3),   &
         CXE02(3)
!-----------------------------------------------------------------------
      RETURN
    END SUBROUTINE SHARE1

!=======================================================================

    SUBROUTINE SHARE2(MXCOMP,MXWAVT,CXEPS,E1A,E2A,WVA)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
! arguments:
      INTEGER :: MXCOMP,MXWAVT,IERR
      REAL(WP) ::     &
         E1A(MXWAVT), &
         E2A(MXWAVT), &
         WVA(MXWAVT)
      COMPLEX(WP) :: CXEPS(MXCOMP)
!-----------------------------------------------------------------------
      RETURN
    END SUBROUTINE SHARE2

!=======================================================================

    SUBROUTINE MPI_INIT(IERR)
      IMPLICIT NONE
! arguments:
      INTEGER :: IERR
!-----------------------------------------------------------------------
      IERR=0
      RETURN
    END SUBROUTINE MPI_INIT

!=======================================================================

    SUBROUTINE MPI_COMM_RANK(MPI_COMM_WORLD,MYID,IERR)
      IMPLICIT NONE
! arguments:
      INTEGER :: IERR,MPI_COMM_WORLD,MYID
!-----------------------------------------------------------------------
      MYID=0
      RETURN
    END SUBROUTINE MPI_COMM_RANK

!=======================================================================

    SUBROUTINE MPI_COMM_SIZE(MPI_COMM_WORLD,NUMPROCS,IERR)
      IMPLICIT NONE
! arguments:
      INTEGER :: IERR,MPI_COMM_WORLD,NUMPROCS
!-----------------------------------------------------------------------
      NUMPROCS=1
      RETURN
    END SUBROUTINE MPI_COMM_SIZE

!=======================================================================

    SUBROUTINE MPI_FINALIZE(IERR)
      IMPLICIT NONE
! arguments:
      INTEGER :: IERR
!-----------------------------------------------------------------------
      IERR=0
      RETURN
    END SUBROUTINE MPI_FINALIZE

!=======================================================================

    SUBROUTINE MPI_BARRIER(MPI_COMM_WORLD,IERR)
      IMPLICIT NONE
! arguments:
      INTEGER :: IERR,MPI_COMM_WORLD
!-----------------------------------------------------------------------
      IERR=0
      RETURN
    END SUBROUTINE MPI_BARRIER

    SUBROUTINE NAMER2(IWAV,IRAD,IDIR,CFLFML)
      IMPLICIT NONE
!***********************************************************************
! Purpose: to generate file names for specific (wavelength,
!                                               size,
!                                               incident direction)
! Present version allows up to 1000 wavelengths, (000-999)
!                              1000 sizes        (000-999)
!                              1000 directions   (000-999)
! Given:
!         IWAV=integer (0-999) identifying wavelength
!         IRAD=integer (0-999) identifying size
!         IDIR=integer (0-999) identifying direction
! Returns:
!         CFLFML =name for output file containing complex scattering
!                 amplitudes f_ml for selected directions
!
! B.T.Draine, Princeton Univ. Observatory, 2007
! History:
! 07.08.31 (BTD): Adapted from NAMER
! Copyright (C) 2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:

      INTEGER :: IDIR, IDIR0, IRAD, IRAD0, IWAV, IWAV0
      CHARACTER :: CFLFML*16

! Local variables:

      CHARACTER :: N(10)*1, V1(3)*1, V2(3)*1, V3(3)*1

! DATA statements:

      DATA N/'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'/
      SAVE N

!***********************************************************************
!*** Filename CFLSCA will be of the form w001r01k001
!     (for IWAV=2,IRAD=2,IDIR=2)

!*** Set IWAV0=IWAV-1 to run over range 0-999
!    Set IRAD0=IRAD-1 to run over range 0-99
!    Set IDIR0=IDIR-1 to run over range 0-999

      IWAV0=IWAV - 1
      IRAD0=IRAD - 1
      IDIR0=IDIR - 1
      V1(1)=N(IWAV0/100+1)
      V1(2)=N((IWAV0-100*(IWAV0/100))/10+1)
      V1(3)=N(IWAV0-10*(IWAV0/10)+1)
      V2(1)=N(IRAD0/100+1)
      V2(2)=N((IRAD0-100*(IRAD0/100))/10+1)
      V2(3)=N(IRAD0-10*(IRAD0/10)+1)
      V3(1)=N(IDIR0/100+1)
      V3(2)=N((IDIR0-100*(IDIR0/100))/10+1)
      V3(3)=N(IDIR0-10*(IDIR0/10)+1)

      CFLFML='w'//V1(1)//V1(2)//V1(3)//'r'//V2(1)//V2(2)//V2(3)//&
        'k'//V3(1)//V3(2)//V3(3)//'.fml'

      RETURN

    END SUBROUTINE NAMER2

    SUBROUTINE CXFFT3N(C,MX,MY,MZ,ISIGN)
      USE DDPRECISION,ONLY : WP

! Parameters:

      INTEGER :: MXTRIG
!      PARAMETER(MXTRIG=1000)
      PARAMETER(MXTRIG=16384)

! Arguments:

      INTEGER :: ISIGN,MX,MY,MZ
      REAL(WP) :: C(*)

! Local scalars:

      INTEGER :: INC,IND,JUMP,K,LOT,MXOLD,MYOLD,MZOLD

! Local arrays:

      REAL(WP) ::       &
         TRIG1(MXTRIG), &
         TRIG2(MXTRIG), &
         TRIG3(MXTRIG)
      SAVE TRIG1,TRIG2,TRIG3,MXOLD,MYOLD,MZOLD
!***********************************************************************
! Subroutine CXFFT3N

! Interface routine for "Generalized Prime Factor Algorithm" FFT code
! of Temperton for computation of 3 dimensional FFTs

! Calling program should have call of form

!    CALL CXFFT3N(CX,MX,MY,MZ,ISIGN)

! where
!    CX(I,J,K)= complex array of 3-vectors at locations (I,J,K), with
!               I = 1,...,MX
!               J = 1,...,MY
!               K = 1,...,MZ

! Upon return,
!
!            Mx-1 My-1 Mz-1
! CX(I,J,K)= sum  sum  sum CXin(u,v,w)*exp[ISIGN*2*pi*i*(u*I/Mx+v*J/My+w*K/Mz)
!            u=0  v=0  w=0

! Note that here C is defined as a real array C(*)
! C(1) = Re[CX(1,1,1)]
! C(2) = Im[CX(1,1,1)]
! C(3) = Re[CX(2,1,1)]
! C(4) = Im[CX(2,1,1)]
! ...

! or, in general:

! C(1+2*((I-1)+(J-1)*MY+(K-1)*MY*MZ) = Re[CX(I,J,K)]
! C(2+2*((I-1)+(J-1)*MY+(K-1)*MY*MZ) = Im[CX(I,J,K)]


! Interface written by P.J.Flatau

! History:
! 07.06.30 (BTD) Increased MXTRIG from 1000 to 16384=4*4096
!                (since current version of EXTEND has NF235 up to 4096).
! 08.06.05 (BTD) corrected comments
! end history
!***********************************************************************
      DATA MXOLD,MYOLD,MZOLD/0,0,0/

!*** diagnostic
!      write(0,*)'cxfft3n ckpt 1'
!***
      IF(MX/=MXOLD.OR.MY/=MYOLD.OR.MZ/=MZOLD)THEN
         MXOLD=MX
         MYOLD=MY
         MZOLD=MZ
!*** diagnostic
!        write(0,*)'cxfft3n ckpt 2'
!***
         CALL SETGPFA(TRIG1,MX)
         CALL SETGPFA(TRIG2,MY)
         CALL SETGPFA(TRIG3,MZ)
!*** diagnostic
!        write(0,*)'cxfft3n ckpt 3'
!***
      ENDIF
! --- first dimension
      INC=2
      JUMP=2*MX
      LOT=MY*MZ

!*** diagnostic
!      write(0,*)'cxfft3n ckpt 4'
!***
      CALL GPFA(C(1),C(2),TRIG1,INC,JUMP,MX,LOT,ISIGN)
!*** diagnostic
!      write(0,*)'cxfft3n ckpt 5'
!***
      INC=MX*2
      JUMP=2
      LOT=MX
! --- one plane at a time
      DO K=1,MZ
         IND=1+2*MX*MY*(K-1)
!*** diagnostic
!        write(0,*)'cxfft3n ckpt 250, about to call GPFA for k=',k
!***
        CALL GPFA(C(IND),C(IND+1),TRIG2,INC,JUMP,MY,LOT,ISIGN)
!*** diagnostic
!        write(0,*)'returned to cxfft3n from gpfa'
!***
      ENDDO

! --- third dimension
      INC=MX*MY*2
      JUMP=2
      LOT=MX*MY
!*** diagnostic
!        write(0,*)'cxfft3n ckpt 300, about to call GPFA for k=',k
!***
      CALL GPFA(C(1),C(2),TRIG3,INC,JUMP,MZ,LOT,ISIGN)
!*** diagnostic
!      write(0,*)'returned to cxfft3n from GPFA'
!***
      RETURN
    END SUBROUTINE CXFFT3N

    SUBROUTINE ROT2(A,THETA,RM)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!***********************************************************************
! This subroutine finds the (3 by 3) rotation matrix for the
! given axis (vector) --- a and the rotation angle --- theta.
! On input:
! a(3)    --- axis of rotation  (vector, any length)
! theta   --- angle of rotation (in radians) around vector a
! On output:
! rm(3,3) --- rotation matrix such that new vector v2 is obtained
!             from the old vector v1 by the transformation:
!             v2 = rm \dot v1
! (If more rotations are needed: generate matrices rm with the
! help of this subroutine and (matrix) multiply them before
! performing v2 = rm \dot v1.)

! Reference:
! Leubner, C., 1977,  Coordinate-free  rotation operator,
! Am. J. Phys. 47, 727---729.

! History:
! Written by PJF, May 1989, for use in the rotation-averaged
! DDA calculations.

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! pre-calculate some stuff:
!     .. Scalar Arguments ..
      REAL (WP) :: THETA
!     ..
!     .. Array Arguments ..
      REAL (WP) :: A(3), RM(3,3)
!     ..
!     .. Local Scalars ..
      REAL (WP) :: ANORM, CT, ST
      INTEGER :: I, J
!     ..
!     .. Local Arrays ..
      REAL (WP) :: AHAT(3)
!     ..
!     .. External Subroutines ..
      EXTERNAL XNORM3
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC COS, SIN
!     ..
      CT = COS(THETA)
      ST = SIN(THETA)
      CALL XNORM3(A,ANORM)
      AHAT(1) = A(1)/ANORM
      AHAT(2) = A(2)/ANORM
      AHAT(3) = A(3)/ANORM
!  cos(\theta) {\bf 1}  term:
      RM(1,1) = CT
      RM(2,2) = CT
      RM(3,3) = CT
! Skew-term  a \times {\bf 1}:
      RM(1,2) = -ST*AHAT(3)
      RM(1,3) = ST*AHAT(2)
      RM(2,1) = ST*AHAT(3)
      RM(2,3) = -ST*AHAT(1)
      RM(3,1) = -ST*AHAT(2)
      RM(3,2) = ST*AHAT(1)
! aa-dyadic (outer-product):
      DO I = 1, 3
        DO J = 1, 3
          RM(I,J) = RM(I,J) + (1.E0_WP-CT)*AHAT(J)*AHAT(I)
        END DO
      END DO
      RETURN
    END SUBROUTINE ROT2

    SUBROUTINE XNORM3(A,XN)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments

      REAL (WP) :: XN
      REAL (WP) :: A(3)

! Intrinsic Functions ..

      INTRINSIC SQRT

! auxilary for "rotation" routines

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      XN = SQRT(A(1)**2+A(2)**2+A(3)**2)
      RETURN
    END SUBROUTINE XNORM3

    SUBROUTINE MULT3(A,B,C)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL (WP) :: A(3,3), B(3,3), C(3,3)

! Local variables:

      REAL (WP) :: S
      INTEGER :: I, J, K
!***********************************************************************
! Purpose:
! Given:  A(I,J)= 3x3 matrix
!         B(J,K)= 3x3 matrix
! Returns:C(I,K)= matrix product of A and B
! This is auxilary for "rotation" routines

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!**********************************************************************

      DO J = 1, 3
        DO I = 1, 3
          S = 0.E0_WP
          DO K = 1, 3
            S = S + A(I,K)*B(K,J)
          END DO
          C(I,J) = S
        END DO
      END DO
      RETURN
    END SUBROUTINE MULT3

    SUBROUTINE PROD3(RM,VIN,VOUT)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments;

      REAL (WP) :: RM(3,3), VIN(3), VOUT(3)

! Local variables:

      INTEGER :: I, J

! Given:  RM(I,J)=3x3 matrix
!         VIN(J)=3-vector
! Returns:VOUT(I)=RM*VIN

! Auxilary for "rotation" routines

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      DO I = 1, 3
        VOUT(I) = 0.E0_WP
        DO J = 1, 3
          VOUT(I) = VOUT(I) + RM(I,J)*VIN(J)
        END DO
      END DO
      RETURN
    END SUBROUTINE PROD3

    SUBROUTINE PROD3C(RM,CVIN,CVOUT)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL (WP) :: RM(3,3)
      COMPLEX (WP) :: CVIN(3), CVOUT(3)

! Local variables:

      INTEGER :: I, J

! Given:
!       RM=3x3 rotation matrix
!       CVIN=complex 3-vector
! Computes:
!       CVOUT=RM \dot CVIN

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DO I = 1, 3
        CVOUT(I) = (0.E0_WP,0.E0_WP)
        DO J = 1, 3
          CVOUT(I) = CVOUT(I) + RM(I,J)*CVIN(J)
        END DO
      END DO
      RETURN
    END SUBROUTINE PROD3C

    SUBROUTINE PROD3V(RM,VIN,VOUT,NV,NVMAX)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: NV, NVMAX
      REAL (WP) :: RM(3,3), VIN(3,NVMAX), VOUT(3,NVMAX)

! Local variables:
      INTEGER :: I, J, N
! Given:
!       RM = 3x3 rotation matrix
!       VIN = NV 3-vectors
! Computes:
!       VOUT=RM \dot VIN for each of the NV 3-vectors

! Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
! History
! 96.08.09 (BTD) trivial modification to remove obsolescent construct.
! end history
! This code is covered by the GNU General Public License.
!***********************************************************************

      DO N = 1, NV
        DO I = 1, 3
          VOUT(I,N) = 0.E0_WP
        END DO
      END DO

      DO N = 1, NV
        DO J = 1, 3
          DO I = 1, 3
            VOUT(I,N) = VOUT(I,N) + RM(I,J)*VIN(J,N)
          END DO
        END DO
      END DO

      RETURN
    END SUBROUTINE PROD3V

    SUBROUTINE COPYIT(CXA,CXB,NPTS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!*** Arguments:
      INTEGER :: NPTS
      COMPLEX (WP) :: CXA(*), CXB(*)

!*** Local variables:
      INTEGER :: IPTS
!***********************************************************************
! Purpose: To copy a complex vector from one memory location to another.
!***********************************************************************
      DO IPTS = 1, NPTS
        CXB(IPTS) = CXA(IPTS)
      END DO
      RETURN
    END SUBROUTINE COPYIT

    SUBROUTINE EVALQ(CXADIA,CXAOFF,AK,NAT3,E02,CXE,CXP,CABS,CEXT,CPHA,MXN3, &
                     IMETHD)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

!*** Arguments:

      REAL(WP) :: CABS,CEXT,CPHA,E02
      INTEGER :: IMETHD,MXN3,NAT3
      COMPLEX(WP) ::   &
         CXADIA(MXN3), &
         CXAOFF(MXN3), &
         CXE(MXN3),    &
         CXP(MXN3)
      REAL(WP) :: &
         AK(3)

!*** Local variables:

      COMPLEX(WP) :: CXA,CXI,DCXA,RABS
      REAL(WP) :: AK1,AK2,AK3,PI
      INTEGER :: J1,J2,J3,NAT

!*** Intrinsic functions:

      INTRINSIC AIMAG,CONJG,REAL,SQRT

!*** SAVE statements:

      SAVE CXI

!*** Data statements:

      DATA CXI/(0._WP,1._WP)/

!***********************************************************************

! Given: CXADIA(J,1-3)=(a_11,a_22,a_33) for dipoles J=1-NAT,
!                  where symmetric 3x3 matrix a_ij is inverse of complex
!                  polarizability tensor alpha_ij for dipole J
!        CXAOFF(J,1-3)=(a_23,a_31,a_12) for dipoles J=1-NAT
!        AK(1-3) = (k_x,k_y,k_z)*d
!                  d = (d_x*d_y*d_z)**(1/3) = effective lattice spacing
!        NAT3 = 3*number of dipoles
!        E02 = |E_0|^2 , where E_0 = incident complex E field.
!        CXE(1-NAT3) = components of E field at each dipole, in order
!                      E_1x,E_2x,...,E_NATx,E_1y,E_2y,...,E_NATy,
!                      E_1z,E_2z,...,E_NATz
!        CXP(1-NAT3) = components of polarization vector at each dipole,
!                      in order
!                      P_1x,P_2x,...,P_NATx,P_1y,P_2y,...,P_NATy,
!                      P_1z,P_2z,...,P_NATz
!        IMETHD = 0 or 1
! Finds:
!        CEXT = extinction cross section /d**2
!  and, if IMETHD=1, also computes
!        CPHA = phase-lag cross section /d**2
!        CABS = absorption cross section /d**2

! Note: present definition of CPHA is 1/2 of Martin's definition

! B.T.Draine, Princeton Univ. Obs., 87/1/4

! History:
! 88.04.28 (BTD): modifications
! 90.11.02 (BTD): modified to allow use of vacuum sites (now pass E02
!                 from calling routine instead of evaluating it here)
! 90.12.13 (BTD): modified to use IMETHD flag, to allow "fast" calls
!                 in which only CEXT is computed.
! 97.12.26 (BTD): removed CXALPH from argument list; replaced with
!                 CXADIA and CXAOFF.
!                 CXADIA and CXAOFF are diagonal and off-diagonal
!                 elements of alpha^{-1} for each dipole.
!                 Modified to properly evaluate CABS
! 98.01.01 (BTD): Correct inconsistencies in assumed data ordering.
! 98.01.13 (BTD): Examine for possible error in evaluation of Qabs
! 98.04.27 (BTD): Minor polishing.
! 08.01.13 (BTD): cosmetic changes to f90 version
! End history

! Copyright (C) 1993,1997,1998,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Initialization:
! Compute magnitude of kd

      CEXT=0._WP
      CABS=0._WP
      CPHA=0._WP
      PI=4._WP*ATAN(1._WP)
      AK2=0._WP
      DO J1=1,3
         AK2=AK2+AK(J1)*AK(J1)
      ENDDO
      AK1=SQRT(AK2)
      AK3=AK1*AK2

! Initialization complete.

      IF(IMETHD==0)THEN

!*** Compute CEXT:

         DO J1=1,NAT3
            CEXT=CEXT+AIMAG(CXP(J1))*REAL(CXE(J1))-REAL(CXP(J1))*AIMAG(CXE(J1))
         ENDDO
         CEXT=4._WP*PI*AK1*CEXT/E02
      ELSEIF(IMETHD==1)THEN

! Compute
! C_abs=(4*pi*k/|E_0|^2)*
!       sum_J { Im[P_J*conjg(a_J*P_J)] - (2/3)*k^3*|P_J|^2 }
!      =(4*pi*k/|E_0|^2)*
!       sum_J {-Im[conjg(P_J)*a_J*P_J] - Im[i*(2/3)*k^3*P_J*conjg(P_J)]}
!      =-(4*pi*k/|E_0|^2)*
!       Im{ sum_J [ conjg(P_J)*(a_J*P_J + i*(2/3)*k^3*P_J) ] }

         NAT=NAT3/3
         CXA=(0._WP,0._WP)
         RABS=CXI*AK3/1.5_WP
         DO J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            DCXA=CONJG(CXP(J1))*((CXADIA(J1)+RABS)*CXP(J1)+              &
                                 CXAOFF(J2)*CXP(J3)+CXAOFF(J3)*CXP(J2))+ &
                 CONJG(CXP(J2))*((CXADIA(J2)+RABS)*CXP(J2)+              &
                                 CXAOFF(J3)*CXP(J1)+CXAOFF(J1)*CXP(J3))+ &
                 CONJG(CXP(J3))*((CXADIA(J3)+RABS)*CXP(J3)+              &
                                 CXAOFF(J1)*CXP(J2)+CXAOFF(J2)*CXP(J1))
            CXA=CXA+DCXA
         ENDDO
         CABS=-4._WP*PI*AK1*AIMAG(CXA)/E02
! Compute CEXT and CPHA
         CXA=(0._WP,0._WP)
         DO J1=1,NAT3
            CXA=CXA+CXP(J1)*CONJG(CXE(J1))
         ENDDO
         CEXT=4._WP*PI*AK1*AIMAG(CXA)/E02
         CPHA=2._WP*PI*AK1*REAL(CXA)/E02
      ENDIF
      RETURN

    END SUBROUTINE EVALQ

    SUBROUTINE TARCYL(A1,A2,A,B,ORI,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Scalar arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: MXNAT,NAT
      REAL(WP) :: A,B,ORI

! Array arguments:

      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local scalars:

      INTEGER :: IORI,IOSHP,JA,JLO,JHI,JX,JY,JZ,NB,NFAC,NLAY,NX1, &
        NX2,NY1,NY2,NZ1,NZ2
      REAL(WP) :: ASPR,PI,R2,REFF2,RX2,RY2,RZ2,XCM,Y2M,YCM,Z2,ZCM

!***********************************************************************
! Subroutine TARCYL
! Purpose: to construct cylindrical target by populating sites on a
! rectangular lattice.

! Input:
!        A = cylinder length (in units of lattice spacing d)
!        B = cylinder diameter (in units of lattice spacing d)
!        ORI = 1. for cylinder axis in x_TF direction
!                 a1=(1,0,0),a2=(0,1,0)
!              2. for cylinder axis in y_TF direction
!                 a1=(0,1,0),a1=(0,0,1)
!              3. for cylinder axis in z_TF direction
!                 a1=(0,0,1),a2=(1,0,0)
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT = dimensioning information
! Returns:
!        A1(1-3) = unit vector along cylinder axis
!        A2(1-3) = unit vector perpendicular to cylinder axis
!        CDESCR = string describing target (up to 67 chars.)
!        NAT = number of atoms in target
!        IXYZ(1-NAT,1-3)=[x-X0(1)]/d,[y-X0(2)]/d,[z-X0(3)]/d for 
!                        dipoles in target
!                        where x=y=z=0 at target centroid
!        X0(1-3) = offset vector defined by above condition
!        ICOMP(1-NAT,1-3)=1 (composition identifier)

! B.T.Draine, Princeton Univ. Obs., 87.04.03
! History:
! 89.12.21 (BTD): Modified for use by ddscat 89.12.21
! 90.12.03 (BTD): Modified for conformity with other target routines
! 91.01.05 (BTD): Changed I4 -> I7 when printing NAT
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
! 95.04.07 (BTD): Corrected error in code which affected target
!                 construction for 4.5<B<5.5, 6.5<B<7.5, ...
!                 In these cases code was construction target with
!                 diameter 4, 6, ... dipoles
!                 This error was discovered by Tao Du
! 96.01.25 (BTD): Modified for conformity with DDSCAT.5a
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(1-3) to argument list to support noncubic
!                 lattice.
! 98.02.11 (BTD): Make changes to generate target for noncubic lattice.
!                 Take opportunity to simplify and streamline.
! 98.04.27 (BTD): Delete unused variables IN,Y2,ROFF,X,Z,IAXIS
!                 Declare variabels Y2M
!                 Delete IAXIS from WRITE(IOSHP,FMT=9020) statement
! 00.11.02 (BTD): Add ICOMP to argument list, return with ICOMP=1
!                 for occupied sites.
!                 write ICOMP to target.out
! 06.09.15 (BTD): Revised to allow selection of cylinder orientation
!                 in TF via argument ORI
! 06.12.09 (BTD): Initialized NAT=0
! 07.06.21 (BTD): Major rewrite
!                 * added X0 to argument list
!                 * revised to work properly for noncubic lattice
! 07.06.26 (BTD): corrected calculation of NLAY and NFAC for all IORI
! 07.09.10 (BTD): changed definition of X0(1-3) to ensure that target
!                 centroid is at x=y=z=0
!                 where dipole J is at (x,y,z)=[IXYZ(J,1-3)+X0(1-3)]*d
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.08.30 (BTD): Modified format 9020
! 08.08.31 (BTD): added code to set A1,A2
! end history
! Copyright (C) 1993,1995,1996,1997,1998,2000,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      PI=4._WP*ATAN(1._WP)
      IORI=NINT(ORI)

      DO JX=1,3
         A1(JX)=0._WP
         A2(JX)=0._WP
      ENDDO

! A=cylinder length/d
! B=cylinder diameter/d

      R2=(B/2._WP)**2

      IF(ORI==1)THEN

         A1(1)=1._WP
         A2(2)=1._WP

! cylinder axis in x direction
! determine centroid XCM,YCM,ZCM

! If A/d_x is near an odd integer, XCM=0
!                    even             0.5

! If B/d_y is near an odd integer, YCM=0
!                    even             0.5

! If B/d_z is near an odd integer, ZCM=0
!                    even             0.5

         JX=NINT(A/DX(1))
         IF(MOD(JX,2)==0)THEN
            XCM=0.5_WP
         ELSE
            XCM=0._WP
         ENDIF
         JY=NINT(B/DX(2))
         IF(MOD(JY,2)==0)THEN
            YCM=0.5_WP
         ELSE
            YCM=0._WP
         ENDIF
         JZ=NINT(B/DX(3))
         IF(MOD(JZ,2)==0)THEN
            ZCM=0.5_WP
         ELSE
            ZCM=0._WP
         ENDIF
         NX1=-JX
         NX2=JX+1
         NY1=-JY
         NY2=JY+1
         NZ1=-JZ
         NZ2=JZ+1

         JLO=NX2
         JHI=NX1
         DO JZ=NZ1,NZ2
            RZ2=(REAL(JZ,KIND=WP)*DX(3)-ZCM)**2
            DO JY=NY1,NY2
               RY2=(REAL(JY,KIND=WP)*DX(2)-YCM)**2
               IF(RZ2+RY2<=R2)THEN
                  DO JX=NX1,NX2
                     RX2=2._WP*ABS(REAL(JX,KIND=WP)*DX(1)-XCM)
                     IF(RX2<=A)THEN
                        NAT=NAT+1
                        IF(NAT>MXNAT)THEN
                           CALL ERRMSG('FATAL','TARCYL',' NAT.GT.MXNAT')
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                        IF(JX<JLO)JLO=JX
                        IF(JX>JHI)JHI=JX
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
         NLAY=JHI-JLO+1

      ELSEIF(ORI==2)THEN

         A1(2)=1._WP
         A2(3)=1._WP

! cylinder axis in y direction

         JY=NINT(A/DX(2))
         IF(MOD(JY,2)==0)THEN
            YCM=0.5_WP
         ELSE
            YCM=0._WP
         ENDIF
         JX=NINT(B/DX(1))
         IF(MOD(JX,2)==0)THEN
            XCM=0.5_WP
         ELSE
            XCM=0._WP
         ENDIF
         JZ=NINT(B/DX(3))
         IF(MOD(JZ,2)==0)THEN
            ZCM=0.5_WP
         ELSE
            ZCM=0._WP
         ENDIF
         NX1=-JX
         NX2=JX+1
         NY1=-JY
         NY2=JY+1
         NZ1=-JZ
         NZ2=JZ

         JLO=NY2
         JHI=NY1
         DO JZ=NZ1,NZ2
            RZ2=(REAL(JZ,KIND=WP)*DX(3)-ZCM)**2
            DO JX=NX1,NX2
               RX2=(REAL(JX,KIND=WP)*DX(1)-XCM)**2
               IF(RZ2+RX2<=R2)THEN
                  DO JY=NY1,NY2
                     RY2=2*ABS(REAL(JY,KIND=WP)*DX(2)-YCM)
                     IF(RY2<=A)THEN
                        NAT=NAT+1
                        IF(NAT>MXNAT)THEN
                           CALL ERRMSG('FATAL','TARCYL',' NAT.GT.MXNAT')
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                        IF(JY<JLO)JLO=JY
                        IF(JY>JHI)JHI=JY
                     ENDIF
                  ENDDO
              ENDIF
            ENDDO
         ENDDO
         NLAY=JHI-JLO+1

      ELSEIF(ORI==3)THEN

         A1(3)=1._WP
         A2(1)=1._WP

! cylinder axis in z direction
! determine centroid XCM,YCM,ZCM

! If A/d_z is near an odd integer, ZCM=0
!                    even             0.5

! If B/d_x is near an odd integer, XCM=0
!                    even             0.5

! If B/d_y is near an odd integer, YCM=0
!                    even             0.5

         JZ=NINT(A/DX(3))
          IF(MOD(JZ,2)==0)THEN
            ZCM=0.5_WP
         ELSE
            ZCM=0._WP
         ENDIF
         JX=NINT(B/DX(1))
         IF(MOD(JX,2)==0)THEN
            XCM=0.5_WP
         ELSE
            XCM=0._WP
         ENDIF
         JY=NINT(B/DX(2))
         IF(MOD(JY,2)==0)THEN
            YCM=0.5_WP
         ELSE
            YCM=0._WP
         ENDIF
         NX1=-JX
         NX2=JX+1
         NY1=-JY
         NY2=JY+1
         NZ1=-JZ
         NZ2=JZ+1

         JLO=NZ2
         JHI=NZ1
         DO JX=NX1,NX2
            RX2=(REAL(JX,KIND=WP)*DX(1)-XCM)**2
            DO JY=NY1,NY2
               RY2=(REAL(JY,KIND=WP)*DX(2)-YCM)**2
               IF(RX2+RY2<=R2)THEN
                  DO JZ=NZ1,NZ2
                     RZ2=2*ABS(REAL(JZ,KIND=WP)*DX(3)-ZCM)
                     IF(RZ2<=A)THEN
                        NAT=NAT+1
                        IF(NAT>MXNAT)THEN
                           CALL ERRMSG('FATAL','TARCYL',' NAT.GT.MXNAT')
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                        IF(JZ<JLO)JLO=JZ
                        IF(JZ>JHI)JHI=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
         NLAY=JHI-JLO+1
      ELSE
         CALL ERRMSG('FATAL','TARCYL',' INVALID ORI')
      ENDIF

! now redetermine location of centroid

      XCM=0._WP
      YCM=0._WP
      ZCM=0._WP
      DO JA=1,NAT
         XCM=XCM+REAL(IXYZ(JA,1),KIND=WP)
         YCM=YCM+REAL(IXYZ(JA,2),KIND=WP)
         ZCM=ZCM+REAL(IXYZ(JA,3),KIND=WP)
      ENDDO
      X0(1)=-XCM/REAL(NAT,KIND=WP)
      X0(2)=-YCM/REAL(NAT,KIND=WP)
      X0(3)=-ZCM/REAL(NAT,KIND=WP)
! diagnostic
!      write(0,*)'diagnostic: in tarcyl, calculated x0=',x0
! end diagnostic

! Set composition

      DO JZ=1,3
         DO JX=1,NAT
            ICOMP(JX,JZ)=1
         ENDDO
      ENDDO

! NLAY = number of layers in cylinder
! NFAC = number of atoms in slice

      NFAC=NAT/NLAY

! REFF2=effective radius**2 of disk

      REFF2=REAL(NFAC,KIND=WP)/PI

! ASPR=aspect ratio (length/diameter)

      ASPR=0.5_WP*REAL(NLAY,KIND=WP)/SQRT(REFF2)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')' Cyl.prism, NAT=',NAT, &
            ' NFAC=',NFAC,' NLAY=',NLAY,' asp.ratio=',ASPR

      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A,B,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARCYL  cylindrical target: Length=',F8.4,         &
             ' Diameter=',F8.4,/,                                  &
         I10,' = NAT',/,                                           &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARCYL

      Subroutine CXFFT3_MKL(CX,MX,MY,MZ,ISIGN)
      USE DDPRECISION,ONLY : WP 
! Library:

      use mkl_dfti

      IMPLICIT NONE

! Arguments:

      INTEGER :: ISIGN,MX,MY,MZ
      COMPLEX(WP) :: CX(*)


! Local Variables

      type(DFTI_DESCRIPTOR), POINTER :: Desc_Handle
      save Desc_Handle
      integer   status
!BTD 080605 start
      real(WP):: Scale
!BTD 080605 end
      integer   lengths(3)
      integer   strides_in(4)

        
      integer i,j,k

!BTD 080605 start
      INTEGER MXOLD,MYOLD,MZOLD
      SAVE MXOLD,MYOLD,MZOLD
      DATA MXOLD,MYOLD,MZOLD/0,0,0/
!BTD 080605 end

!=======================================================================
! Subroutine CXFFT3_MKL
! Purpose: to use Intel Math Kernel Library to calculate 3d FFTs
! input:
!    MX,MY,MZ = dimensioning information
!    ISIGN = +1 for forward FFT
!            -1 for backward FFT
!    CX(I,J,K)=complex arry of complex scalars at locations (I,J,K) with
!                I=1,...,MX
!                J=1,...,MY
!                K=1,...,MZ
! returns:
!
!             Mx-1 My-1 Mz-1
! CX(I,J,K) = sum  sum  sum  CXin(u,v,w)*exp(ISIGN*2*pi*i*(u*I/Mx+v*J/My+w*K/Mz)
!             u=0  v=0  w=0

! MKL routines used:
!    DftiCreateDescriptor
!    DftiErrorClass
!    DftiSetValue
!    DftiCommitDescriptor
!    DftiComputeBackward
!    DftiComputeForward
! Written by Art S. Lazanoff, NASA Ames Research Center, June 2008
! Modified by B.T. Draine, Princeton University
! History
! 080601 (ASL) first written
! 080605 (BTD) modified
!              * IMPLICIT NONE 
!              * initialize trig tables only when called for
!                new values of MX or MY or MZ
! end history
!========================================================================
!Art debug       write(61,'(a,3(1x,i5),z16)')'mx, my, mz = ',mx,my,mz,loc(cx)
!Art debug       write(61,*)cx
        lengths(1) = mx
        lengths(2) = my
        lengths(3) = mz
        strides_in(1) = 0
        strides_in(2) = 1
        strides_in(3) = mx
        strides_in(4) = mx*my


!BTD 080605 start
!       if( isign .eq. 0) then

      IF(MX/=MXOLD.OR.MY/=MYOLD.OR.MZ/=MZOLD)THEN
!BTD 080605 end

!.......Compute trig table

!Art      write(0,*)'MKL DFT initialization'

         if(WP == 8) then
         Status = DftiCreateDescriptor( Desc_Handle, DFTI_DOUBLE, DFTI_COMPLEX, 3, lengths)
         else
         Status = DftiCreateDescriptor( Desc_Handle, DFTI_SINGLE, DFTI_COMPLEX, 3, lengths)
         endif

         if(.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'DftiCreateDescriptor, status = ',status
            stop'cannot create DftiDescriptor'
         endif

         Status = DftiSetValue(Desc_Handle, DFTI_INPUT_STRIDES, strides_in)
         if (.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'Dfti_input_strides, status = ',status
            stop'cannot create Dfti_input_strides'
         endif

         Status = DftiSetValue(Desc_Handle, DFTI_OUTPUT_STRIDES, strides_in)
         if (.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'Dfti_output_strides, status = ',status
            stop'cannot create Dfti_output_strides'
         endif

         Scale = 1._WP
!Art         scale = 1./real((mx*my*mz),WP)
         Status = DftiSetValue(Desc_Handle, DFTI_FORWARD_SCALE, Scale)
         if (.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'DFTI_FORWARD_SCALE status = ',Status
            stop'DFTI_FORWARD_SCALE'
         endif

!Art         scale = 1./real((mx*my*mz),WP)
         Scale = 1._WP
         Status = DftiSetValue(Desc_Handle, DFTI_BACKWARD_SCALE, Scale)
         if (.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'DFTI_BACKWARD_SCALE status = ',Status
            stop'DFTI_BACKWARD_SCALE'
         endif


         Status = DftiCommitDescriptor( Desc_Handle )
         if(.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then
            write(0,*)'DftiCommitDescriptor, status = ',status
            stop'cannot DftiCommitDescriptor'
         endif

         MXOLD = MX; MYOLD = MY; MZOLD = MZ

!Art      write(0,*)'Dfti initialization done'
      endif

!.......Compute 3d FFT 

      if (isign .eq. -1 ) then
!Art     write(0,*)'DFTI_Backward_SCALE'

         Status = DftiComputeBackward( Desc_Handle, cx)
         if (.not. DftiErrorClass(Status, DFTI_NO_ERROR) ) then
            write(0,*)'DftiComputeBackward = ',Status
            stop'DftiComputeBackward'
         endif
!Art debug        write(62,*)'mx, my, mz = ',mx,my,mz
!Art debug        write(62,*)cx
!Art debug        stop'scsl debug'

      else
        
!Art        write(0,*)'DftiComputeForward'

         Status = DftiComputeForward( Desc_Handle, cx)
         if(.not. DftiErrorClass(Status, DFTI_NO_ERROR)) then 
            write(0,*)'DftiComputeForward, status = ',status
            stop'cannot DftiComputeForward'
         endif
      endif   !isign test

       
    end subroutine cxfft3_mkl

    FUNCTION GASDEV(IDUM)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! arguments:

      INTEGER :: IDUM
      REAL(WP) :: GASDEV

! local variables:

      INTEGER :: ISET
      REAL(WP) :: FAC,GSET,ONE,RSQ,TWO,V1,V2,ZERO

! external functions

      REAL(WP) :: RAN3

      SAVE ISET,GSET
      DATA ISET/0/

!=======================================================================
! function GASDEV
!
! given:

!    IDUM = seed for random number generator
!            if IDUM < 0, reinitialize RAN1 with seed IDUM
!            if IDUM .ge. 0, continue sequence from RAN1
! returns:

!    GASDEV(IDUM) = gaussian random deviate
!                   with mean <gasdev>= 0 
!                   and variance <gasdev**2>=1

! This subroutine follows closely the structure of the routine gasdev
! described in Numerical Recipes by Press, W.H., Flannery, B.P.,
! Teukolsky, S.A., and Vetterling, W.T. (Cambridge Univ. Press).

! NR version uses RAN1, but it was found that under RH7.1/pgf77 
! gasdev does not have <gasdev> = 0 when we use RAN1.
! Therefore have changed to use RAN3

! Modifications by B.T. Draine, Princeton University Observatory,
! 2003.09.10
! 2007.08.06 (BTD) converted to f90

!=======================================================================

      ZERO=0._WP
      ONE=1._WP
      TWO=2._WP

      IF(ISET==0)THEN

! when ISET = 0, we do not have an extra deviate on hand
!                so generate two new deviates

 0100   CONTINUE

! generate random variates V1 and V2 on interval -1,1

        V1=TWO*RAN3(IDUM)-ONE
        V2=TWO*RAN3(IDUM)-ONE
        RSQ=V1**2+V2**2
        IF(RSQ>=ONE.OR.RSQ==ZERO)GOTO 0100
        FAC=SQRT(-TWO*LOG(RSQ)/RSQ)
        GSET=V1*FAC
        GASDEV=V2*FAC
        ISET=1

      ELSE

! when ISET = 1, we have an extra deviate on hand
!                so use it, and change ISET back to 0

         GASDEV=GSET
         ISET=0
      ENDIF
      RETURN
      END

      SUBROUTINE CAXPY(N,CA,CX,INCX,CY,INCY)
      USE DDPRECISION,ONLY : WP

!     constant times a vector plus a vector:
! given:
!       vectors CX,CY
!       scalar CA
! computes
!     CY = CY + CA*CX
!
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      COMPLEX (WP) :: CX(*),CY(*),CA
      INTEGER :: I,INCX,INCY,IX,IY,N

      IF (N<=0) RETURN
      IF (ABS(REAL(CA))+ABS(AIMAG(CA))==0.0_WP) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        CY(IY) = CY(IY)+CA*CX(IX)
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!        code for both increments equal to 1

20    DO I = 1,N
        CY(I) = CY(I)+CA*CX(I)
      END DO
      RETURN
    END SUBROUTINE CAXPY
    SUBROUTINE CSCAL(N,CA,CX,INCX)
      USE DDPRECISION,ONLY : WP

!     scales a vector by a constant.
!     jack dongarra, 3/11/78.
!     modified to correct problem with negative increment, 8/21/90.

      COMPLEX (WP) :: CA,CX(1)
      INTEGER :: I,INCX,IX,N

      IF (N<=0) RETURN
      IF (INCX==1) GO TO 20

!        code for increment not equal to 1

      IX = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      DO I = 1,N
        CX(IX) = CA*CX(IX)
        IX = IX+INCX
      END DO
      RETURN

!        code for increment equal to 1

20    DO I = 1,N
        CX(I) = CA*CX(I)
      END DO
      RETURN
    END SUBROUTINE CSCAL
    SUBROUTINE CSWAP(N,CX,INCX,CY,INCY)
      USE DDPRECISION,ONLY : WP

!     interchanges two vectors.
!     jack dongarra, 3/11/78.

      COMPLEX (WP) :: CX(1),CY(1),CTEMP
      INTEGER :: I,IX,IY,N,INCX,INCY

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!       code for unequal increments or equal increments not equal
!         to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        CTEMP = CX(IX)
        CX(IX) = CY(IY)
        CY(IY) = CTEMP
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!       code for both increments equal to 1
20    DO I = 1,N
        CTEMP = CX(I)
        CX(I) = CY(I)
        CY(I) = CTEMP
      END DO
      RETURN
      END SUBROUTINE CSWAP

      INTEGER FUNCTION ICAMAX(N,CX,INCX)
      USE DDPRECISION,ONLY : WP

!     finds the index of element having max. absolute value.
!     jack dongarra, linpack, 3/11/78.
!     modified 3/93 to return if incx .le. 0.
!     modified 12/3/93, array(1) declarations changed to array(*)

      COMPLEX (WP) :: CX(*)
      REAL (WP) :: SMAX
      INTEGER :: I,INCX,IX,N
      COMPLEX (WP) :: ZDUM
      REAL (WP) :: CABS1

      CABS1(ZDUM) = ABS(REAL(ZDUM))+ABS(AIMAG(ZDUM))

      ICAMAX = 0
      IF (N<1 .OR. INCX<=0) RETURN
      ICAMAX = 1
      IF (N==1) RETURN
      IF (INCX==1) GO TO 20

!        code for increment not equal to 1

      IX = 1
      SMAX = CABS1(CX(1))
      IX = IX+INCX
      DO I = 2,N
        IF (CABS1(CX(IX))<=SMAX) GO TO 5
        ICAMAX = I
        SMAX = CABS1(CX(IX))
5       IX = IX+INCX
      END DO
      RETURN

!        code for increment equal to 1

20    SMAX = CABS1(CX(1))
      DO I = 2,N
        IF (CABS1(CX(I))<=SMAX) GO TO 30
        ICAMAX = I
        SMAX = CABS1(CX(I))
30    END DO
      RETURN
      END FUNCTION ICAMAX

!---------------------------------------------------------------------------

      INTEGER FUNCTION ISAMAX(N,SX,INCX)
      USE DDPRECISION,ONLY : WP

!     finds the index of element having max. absolute value.
!     jack dongarra, linpack, 3/11/78.
!     modified 3/93 to return if incx .le. 0.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SMAX
      INTEGER :: I,INCX,IX,N

      ISAMAX = 0
      IF (N<1 .OR. INCX<=0) RETURN
      ISAMAX = 1
      IF (N==1) RETURN
      IF (INCX==1) GO TO 20

!        code for increment not equal to 1

      IX = 1
      SMAX = ABS(SX(1))
      IX = IX+INCX
      DO I = 2,N
        IF (ABS(SX(IX))<=SMAX) GO TO 5
        ISAMAX = I
        SMAX = ABS(SX(IX))
5       IX = IX+INCX
      END DO
      RETURN

!        code for increment equal to 1

20    SMAX = ABS(SX(1))
      DO I = 2,N
        IF (ABS(SX(I))<=SMAX) GO TO 30
        ISAMAX = I
        SMAX = ABS(SX(I))
30    END DO
      RETURN
    END FUNCTION ISAMAX
    LOGICAL FUNCTION LSAME(CA,CB)

!  -- LAPACK auxiliary routine (version 3.0) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     September 30, 1994

!     .. Scalar Arguments ..
      CHARACTER :: CA,CB
!     ..

!  Purpose
!  =======

!  LSAME returns .TRUE. if CA is the same letter as CB regardless of
!  case.

!  Arguments
!  =========

!  CA      (input) CHARACTER*1
!  CB      (input) CHARACTER*1
!          CA and CB specify the single characters to be compared.

! =====================================================================

!     .. Intrinsic Functions ..
      INTRINSIC ICHAR
!     ..
!     .. Local Scalars ..
      INTEGER :: INTA,INTB,ZCODE
!     ..
!     .. Executable Statements ..

!     Test if the characters are equal

      LSAME = CA == CB
      IF (LSAME) RETURN

!     Now test for equivalence if both characters are alphabetic.

      ZCODE = ICHAR('Z')

!     Use 'Z' rather than 'A' so that ASCII can be detected on Prime
!     machines, on which ICHAR returns a value with bit 8 set.
!     ICHAR('A') on Prime machines returns 193 which is the same as
!     ICHAR('A') on an EBCDIC machine.

      INTA = ICHAR(CA)
      INTB = ICHAR(CB)

      IF (ZCODE==90 .OR. ZCODE==122) THEN

!        ASCII is assumed - ZCODE is the ASCII code of either lower or
!        upper case 'Z'.

        IF (INTA>=97 .AND. INTA<=122) INTA = INTA - 32
        IF (INTB>=97 .AND. INTB<=122) INTB = INTB - 32

      ELSE IF (ZCODE==233 .OR. ZCODE==169) THEN

!        EBCDIC is assumed - ZCODE is the EBCDIC code of either lower or
!        upper case 'Z'.

        IF (INTA>=129 .AND. INTA<=137 .OR. INTA>=145 .AND. INTA<=153 .OR. &
          INTA>=162 .AND. INTA<=169) INTA = INTA+64
        IF (INTB>=129 .AND. INTB<=137 .OR. INTB>=145 .AND. INTB<=153 .OR. &
          INTB>=162 .AND. INTB<=169) INTB = INTB+64

      ELSE IF (ZCODE==218 .OR. ZCODE==250) THEN

!        ASCII is assumed, on Prime machines - ZCODE is the ASCII code
!        plus 128 of either lower or upper case 'Z'.

        IF (INTA>=225 .AND. INTA<=250) INTA = INTA - 32
        IF (INTB>=225 .AND. INTB<=250) INTB = INTB - 32
      END IF
      LSAME = INTA == INTB

!     RETURN

!     End of LSAME

    END FUNCTION LSAME
    SUBROUTINE SAXPY(N,SA,SX,INCX,SY,INCY)
      USE DDPRECISION,ONLY : WP

!     constant times a vector plus a vector.
!     uses unrolled loop for increments equal to one.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SY(*),SA
      INTEGER :: I,INCX,INCY,IX,IY,M,MP1,N

      IF (N<=0) RETURN
      IF (SA==0.0_WP) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        SY(IY) = SY(IY)+SA*SX(IX)
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!        code for both increments equal to 1


!        clean-up loop

20    M = MOD(N,4)
      IF (M==0) GO TO 40
      DO I = 1,M
        SY(I) = SY(I)+SA*SX(I)
      END DO
      IF (N<4) RETURN
40    MP1 = M+1
      DO I = MP1,N,4
        SY(I) = SY(I)+SA*SX(I)
        SY(I+1) = SY(I+1)+SA*SX(I+1)
        SY(I+2) = SY(I+2)+SA*SX(I+2)
        SY(I+3) = SY(I+3)+SA*SX(I+3)
      END DO
      RETURN
    END SUBROUTINE SAXPY
    SUBROUTINE SCOPY(N,SX,INCX,SY,INCY)
      USE DDPRECISION,ONLY : WP

!     copies a vector, x, to a vector, y.
!     uses unrolled loops for increments equal to 1.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SY(*)
      INTEGER :: I,INCX,INCY,IX,IY,M,MP1,N

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        SY(IY) = SX(IX)
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!        code for both increments equal to 1


!        clean-up loop

20    M = MOD(N,7)
      IF (M==0) GO TO 40
      DO I = 1,M
        SY(I) = SX(I)
      END DO
      IF (N<7) RETURN
40    MP1 = M+1
      DO I = MP1,N,7
        SY(I) = SX(I)
        SY(I+1) = SX(I+1)
        SY(I+2) = SX(I+2)
        SY(I+3) = SX(I+3)
        SY(I+4) = SX(I+4)
        SY(I+5) = SX(I+5)
        SY(I+6) = SX(I+6)
      END DO
      RETURN
    END SUBROUTINE SCOPY
    FUNCTION SDOT(N,SX,INCX,SY,INCY)
      USE DDPRECISION,ONLY : WP
      REAL (WP) :: SDOT

!     forms the dot product of two vectors.
!     uses unrolled loops for increments equal to one.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SY(*),STEMP
      INTEGER :: I,INCX,INCY,IX,IY,M,MP1,N

      STEMP = 0.0E0_WP
      SDOT = 0.0E0_WP
      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        STEMP = STEMP+SX(IX)*SY(IY)
        IX = IX+INCX
        IY = IY+INCY
      END DO
      SDOT = STEMP
      RETURN

!        code for both increments equal to 1


!        clean-up loop

20    M = MOD(N,5)
      IF (M==0) GO TO 40
      DO I = 1,M
        STEMP = STEMP+SX(I)*SY(I)
      END DO
      IF (N<5) GO TO 60
40    MP1 = M+1
      DO I = MP1,N,5
        STEMP = STEMP+SX(I)*SY(I)+SX(I+1)*SY(I+1)+SX(I+2)*SY(I+2)+ &
          SX(I+3)*SY(I+3)+SX(I+4)*SY(I+4)
      END DO
60    SDOT = STEMP
      RETURN
    END FUNCTION SDOT
    SUBROUTINE SGEMM(TRANSA,TRANSB,M,N,K,ALPHA,A,LDA,B,LDB,BETA,C,LDC)
      USE DDPRECISION,ONLY : WP
!     .. Scalar Arguments ..
      CHARACTER (1) :: TRANSA,TRANSB
      INTEGER :: M,N,K,LDA,LDB,LDC
      REAL (WP) :: ALPHA,BETA
!     .. Array Arguments ..
      REAL (WP) :: A(LDA,*),B(LDB,*),C(LDC,*)
!     ..

!  Purpose
!  =======

!  SGEMM  performs one of the matrix-matrix operations

!     C := alpha*op( A )*op( B ) + beta*C,

!  where  op( X ) is one of

!     op( X ) = X   or   op( X ) = X',

!  alpha and beta are scalars, and A, B and C are matrices, with op( A )
!  an m by k matrix,  op( B )  a  k by n matrix and  C an m by n matrix.

!  Parameters
!  ==========

!  TRANSA - CHARACTER*1.
!           On entry, TRANSA specifies the form of op( A ) to be used in
!           the matrix multiplication as follows:

!              TRANSA = 'N' or 'n',  op( A ) = A.

!              TRANSA = 'T' or 't',  op( A ) = A'.

!              TRANSA = 'C' or 'c',  op( A ) = A'.

!           Unchanged on exit.

!  TRANSB - CHARACTER*1.
!           On entry, TRANSB specifies the form of op( B ) to be used in
!           the matrix multiplication as follows:

!              TRANSB = 'N' or 'n',  op( B ) = B.

!              TRANSB = 'T' or 't',  op( B ) = B'.

!              TRANSB = 'C' or 'c',  op( B ) = B'.

!           Unchanged on exit.

!  M      - INTEGER.
!           On entry,  M  specifies  the number  of rows  of the  matrix
!           op( A )  and of the  matrix  C.  M  must  be at least  zero.
!           Unchanged on exit.

!  N      - INTEGER.
!           On entry,  N  specifies the number  of columns of the matrix
!           op( B ) and the number of columns of the matrix C. N must be
!           at least zero.
!           Unchanged on exit.

!  K      - INTEGER.
!           On entry,  K  specifies  the number of columns of the matrix
!           op( A ) and the number of rows of the matrix op( B ). K must
!           be at least  zero.
!           Unchanged on exit.

!  ALPHA  - REAL            .
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.

!  A      - REAL             array of DIMENSION ( LDA, ka ), where ka is
!           k  when  TRANSA = 'N' or 'n',  and is  m  otherwise.
!           Before entry with  TRANSA = 'N' or 'n',  the leading  m by k
!           part of the array  A  must contain the matrix  A,  otherwise
!           the leading  k by m  part of the array  A  must contain  the
!           matrix A.
!           Unchanged on exit.

!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. When  TRANSA = 'N' or 'n' then
!           LDA must be at least  max( 1, m ), otherwise  LDA must be at
!           least  max( 1, k ).
!           Unchanged on exit.

!  B      - REAL             array of DIMENSION ( LDB, kb ), where kb is
!           n  when  TRANSB = 'N' or 'n',  and is  k  otherwise.
!           Before entry with  TRANSB = 'N' or 'n',  the leading  k by n
!           part of the array  B  must contain the matrix  B,  otherwise
!           the leading  n by k  part of the array  B  must contain  the
!           matrix B.
!           Unchanged on exit.

!  LDB    - INTEGER.
!           On entry, LDB specifies the first dimension of B as declared
!           in the calling (sub) program. When  TRANSB = 'N' or 'n' then
!           LDB must be at least  max( 1, k ), otherwise  LDB must be at
!           least  max( 1, n ).
!           Unchanged on exit.

!  BETA   - REAL            .
!           On entry,  BETA  specifies the scalar  beta.  When  BETA  is
!           supplied as zero then C need not be set on input.
!           Unchanged on exit.

!  C      - REAL             array of DIMENSION ( LDC, n ).
!           Before entry, the leading  m by n  part of the array  C must
!           contain the matrix  C,  except when  beta  is zero, in which
!           case C need not be set on entry.
!           On exit, the array  C  is overwritten by the  m by n  matrix
!           ( alpha*op( A )*op( B ) + beta*C ).

!  LDC    - INTEGER.
!           On entry, LDC specifies the first dimension of C as declared
!           in  the  calling  (sub)  program.   LDC  must  be  at  least
!           max( 1, m ).
!           Unchanged on exit.


!  Level 3 Blas routine.

!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.


!     .. External Functions ..
      LOGICAL :: LSAME
      EXTERNAL LSAME
!     .. External Subroutines ..
      EXTERNAL XERBLA
!     .. Intrinsic Functions ..
      INTRINSIC MAX
!     .. Local Scalars ..
      LOGICAL :: NOTA,NOTB
      INTEGER :: I,INFO,J,L,NCOLA,NROWA,NROWB
      REAL (WP) :: TEMP
!     .. Parameters ..
      REAL (WP) :: ONE,ZERO
      PARAMETER (ONE=1.0E+0_WP,ZERO=0.0E+0_WP)
!     ..
!     .. Executable Statements ..

!     Set  NOTA  and  NOTB  as  true if  A  and  B  respectively are not
!     transposed and set  NROWA, NCOLA and  NROWB  as the number of rows
!     and  columns of  A  and the  number of  rows  of  B  respectively.

      NOTA = LSAME(TRANSA,'N')
      NOTB = LSAME(TRANSB,'N')
      IF (NOTA) THEN
        NROWA = M
        NCOLA = K
      ELSE
        NROWA = K
        NCOLA = M
      END IF
      IF (NOTB) THEN
        NROWB = K
      ELSE
        NROWB = N
      END IF

!     Test the input parameters.

      INFO = 0
      IF (( .NOT. NOTA) .AND. ( .NOT. LSAME(TRANSA,'C')) .AND. ( .NOT. LSAME( &
          TRANSA,'T'))) THEN
        INFO = 1
      ELSE IF (( .NOT. NOTB) .AND. ( .NOT. LSAME(TRANSB, &
          'C')) .AND. ( .NOT. LSAME(TRANSB,'T'))) THEN
        INFO = 2
      ELSE IF (M<0) THEN
        INFO = 3
      ELSE IF (N<0) THEN
        INFO = 4
      ELSE IF (K<0) THEN
        INFO = 5
      ELSE IF (LDA<MAX(1,NROWA)) THEN
        INFO = 8
      ELSE IF (LDB<MAX(1,NROWB)) THEN
        INFO = 10
      ELSE IF (LDC<MAX(1,M)) THEN
        INFO = 13
      END IF
      IF (INFO/=0) THEN
        CALL XERBLA('SGEMM ',INFO)
        RETURN
      END IF

!     Quick return if possible.

      IF ((M==0) .OR. (N==0) .OR. (((ALPHA==ZERO) .OR. (K==0)) .AND. (BETA== &
        ONE))) RETURN

!     And if  alpha.eq.zero.

      IF (ALPHA==ZERO) THEN
        IF (BETA==ZERO) THEN
          DO J = 1,N
            DO I = 1,M
              C(I,J) = ZERO
            END DO
          END DO
        ELSE
          DO J = 1,N
            DO I = 1,M
              C(I,J) = BETA*C(I,J)
            END DO
          END DO
        END IF
        RETURN
      END IF

!     Start the operations.

      IF (NOTB) THEN
        IF (NOTA) THEN

!           Form  C := alpha*A*B + beta*C.

          DO J = 1,N
            IF (BETA==ZERO) THEN
              DO I = 1,M
                C(I,J) = ZERO
              END DO
            ELSE IF (BETA/=ONE) THEN
              DO I = 1,M
                C(I,J) = BETA*C(I,J)
              END DO
            END IF
            DO L = 1,K
              IF (B(L,J)/=ZERO) THEN
                TEMP = ALPHA*B(L,J)
                DO I = 1,M
                  C(I,J) = C(I,J)+TEMP*A(I,L)
                END DO
              END IF
            END DO
          END DO
        ELSE

!           Form  C := alpha*A'*B + beta*C

          DO J = 1,N
            DO I = 1,M
              TEMP = ZERO
              DO L = 1,K
                TEMP = TEMP+A(L,I)*B(L,J)
              END DO
              IF (BETA==ZERO) THEN
                C(I,J) = ALPHA*TEMP
              ELSE
                C(I,J) = ALPHA*TEMP+BETA*C(I,J)
              END IF
            END DO
          END DO
        END IF
      ELSE
        IF (NOTA) THEN

!           Form  C := alpha*A*B' + beta*C

          DO J = 1,N
            IF (BETA==ZERO) THEN
              DO I = 1,M
                C(I,J) = ZERO
              END DO
            ELSE IF (BETA/=ONE) THEN
              DO I = 1,M
                C(I,J) = BETA*C(I,J)
              END DO
            END IF
            DO L = 1,K
              IF (B(J,L)/=ZERO) THEN
                TEMP = ALPHA*B(J,L)
                DO I = 1,M
                  C(I,J) = C(I,J)+TEMP*A(I,L)
                END DO
              END IF
            END DO
          END DO
        ELSE

!           Form  C := alpha*A'*B' + beta*C

          DO J = 1,N
            DO I = 1,M
              TEMP = ZERO
              DO L = 1,K
                TEMP = TEMP+A(L,I)*B(J,L)
              END DO
              IF (BETA==ZERO) THEN
                C(I,J) = ALPHA*TEMP
              ELSE
                C(I,J) = ALPHA*TEMP+BETA*C(I,J)
              END IF
            END DO
          END DO
        END IF
      END IF

      RETURN

!     End of SGEMM .

    END SUBROUTINE SGEMM
    SUBROUTINE SGEMV(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)
      USE DDPRECISION,ONLY : WP
!     .. Scalar Arguments ..
      REAL (WP) :: ALPHA,BETA
      INTEGER :: INCX,INCY,LDA,M,N
      CHARACTER (1) :: TRANS
!     .. Array Arguments ..
      REAL (WP) :: A(LDA,*),X(*),Y(*)
!     ..

!  Purpose
!  =======

!  SGEMV  performs one of the matrix-vector operations

!     y := alpha*A*x + beta*y,   or   y := alpha*A'*x + beta*y,

!  where alpha and beta are scalars, x and y are vectors and A is an
!  m by n matrix.

!  Parameters
!  ==========

!  TRANS  - CHARACTER*1.
!           On entry, TRANS specifies the operation to be performed as
!           follows:

!              TRANS = 'N' or 'n'   y := alpha*A*x + beta*y.

!              TRANS = 'T' or 't'   y := alpha*A'*x + beta*y.

!              TRANS = 'C' or 'c'   y := alpha*A'*x + beta*y.

!           Unchanged on exit.

!  M      - INTEGER.
!           On entry, M specifies the number of rows of the matrix A.
!           M must be at least zero.
!           Unchanged on exit.

!  N      - INTEGER.
!           On entry, N specifies the number of columns of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.

!  ALPHA  - REAL            .
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.

!  A      - REAL             array of DIMENSION ( LDA, n ).
!           Before entry, the leading m by n part of the array A must
!           contain the matrix of coefficients.
!           Unchanged on exit.

!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, m ).
!           Unchanged on exit.

!  X      - REAL             array of DIMENSION at least
!           ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = 'N' or 'n'
!           and at least
!           ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.
!           Before entry, the incremented array X must contain the
!           vector x.
!           Unchanged on exit.

!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.

!  BETA   - REAL            .
!           On entry, BETA specifies the scalar beta. When BETA is
!           supplied as zero then Y need not be set on input.
!           Unchanged on exit.

!  Y      - REAL             array of DIMENSION at least
!           ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = 'N' or 'n'
!           and at least
!           ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.
!           Before entry with BETA non-zero, the incremented array Y
!           must contain the vector y. On exit, Y is overwritten by the
!           updated vector y.

!  INCY   - INTEGER.
!           On entry, INCY specifies the increment for the elements of
!           Y. INCY must not be zero.
!           Unchanged on exit.


!  Level 2 Blas routine.

!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.


!     .. Parameters ..
      REAL (WP) :: ONE,ZERO
      PARAMETER (ONE=1.0E+0_WP,ZERO=0.0E+0_WP)
!     .. Local Scalars ..
      REAL (WP) :: TEMP
      INTEGER :: I,INFO,IX,IY,J,JX,JY,KX,KY,LENX,LENY
!     .. External Functions ..
      LOGICAL :: LSAME
      EXTERNAL LSAME
!     .. External Subroutines ..
      EXTERNAL XERBLA
!     .. Intrinsic Functions ..
      INTRINSIC MAX
!     ..
!     .. Executable Statements ..

!     Test the input parameters.

      INFO = 0
      IF ( .NOT. LSAME(TRANS,'N') .AND. .NOT. LSAME(TRANS,'T') .AND. &
          .NOT. LSAME(TRANS,'C')) THEN
        INFO = 1
      ELSE IF (M<0) THEN
        INFO = 2
      ELSE IF (N<0) THEN
        INFO = 3
      ELSE IF (LDA<MAX(1,M)) THEN
        INFO = 6
      ELSE IF (INCX==0) THEN
        INFO = 8
      ELSE IF (INCY==0) THEN
        INFO = 11
      END IF
      IF (INFO/=0) THEN
        CALL XERBLA('SGEMV ',INFO)
        RETURN
      END IF

!     Quick return if possible.

      IF ((M==0) .OR. (N==0) .OR. ((ALPHA==ZERO) .AND. (BETA==ONE))) RETURN

!     Set  LENX  and  LENY, the lengths of the vectors x and y, and set
!     up the start points in  X  and  Y.

      IF (LSAME(TRANS,'N')) THEN
        LENX = N
        LENY = M
      ELSE
        LENX = M
        LENY = N
      END IF
      IF (INCX>0) THEN
        KX = 1
      ELSE
        KX = 1 - (LENX-1)*INCX
      END IF
      IF (INCY>0) THEN
        KY = 1
      ELSE
        KY = 1 - (LENY-1)*INCY
      END IF

!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.

!     First form  y := beta*y.

      IF (BETA/=ONE) THEN
        IF (INCY==1) THEN
          IF (BETA==ZERO) THEN
            DO I = 1,LENY
              Y(I) = ZERO
            END DO
          ELSE
            DO I = 1,LENY
              Y(I) = BETA*Y(I)
            END DO
          END IF
        ELSE
          IY = KY
          IF (BETA==ZERO) THEN
            DO I = 1,LENY
              Y(IY) = ZERO
              IY = IY+INCY
            END DO
          ELSE
            DO I = 1,LENY
              Y(IY) = BETA*Y(IY)
              IY = IY+INCY
            END DO
          END IF
        END IF
      END IF
      IF (ALPHA==ZERO) RETURN
      IF (LSAME(TRANS,'N')) THEN

!        Form  y := alpha*A*x + y.

        JX = KX
        IF (INCY==1) THEN
          DO J = 1,N
            IF (X(JX)/=ZERO) THEN
              TEMP = ALPHA*X(JX)
              DO I = 1,M
                Y(I) = Y(I)+TEMP*A(I,J)
              END DO
            END IF
            JX = JX+INCX
          END DO
        ELSE
          DO J = 1,N
            IF (X(JX)/=ZERO) THEN
              TEMP = ALPHA*X(JX)
              IY = KY
              DO I = 1,M
                Y(IY) = Y(IY)+TEMP*A(I,J)
                IY = IY+INCY
              END DO
            END IF
            JX = JX+INCX
          END DO
        END IF
      ELSE

!        Form  y := alpha*A'*x + y.

        JY = KY
        IF (INCX==1) THEN
          DO J = 1,N
            TEMP = ZERO
            DO I = 1,M
              TEMP = TEMP+A(I,J)*X(I)
            END DO
            Y(JY) = Y(JY)+ALPHA*TEMP
            JY = JY+INCY
          END DO
        ELSE
          DO J = 1,N
            TEMP = ZERO
            IX = KX
            DO I = 1,M
              TEMP = TEMP+A(I,J)*X(IX)
              IX = IX+INCX
            END DO
            Y(JY) = Y(JY)+ALPHA*TEMP
            JY = JY+INCY
          END DO
        END IF
      END IF

      RETURN

!     End of SGEMV .

    END SUBROUTINE SGEMV
    SUBROUTINE SGER(M,N,ALPHA,X,INCX,Y,INCY,A,LDA)
      USE DDPRECISION,ONLY : WP
!     .. Scalar Arguments ..
      REAL (WP) :: ALPHA
      INTEGER :: INCX,INCY,LDA,M,N
!     .. Array Arguments ..
      REAL (WP) :: A(LDA,*),X(*),Y(*)
!     ..

!  Purpose
!  =======

!  SGER   performs the rank 1 operation

!     A := alpha*x*y' + A,

!  where alpha is a scalar, x is an m element vector, y is an n element
!  vector and A is an m by n matrix.

!  Parameters
!  ==========

!  M      - INTEGER.
!           On entry, M specifies the number of rows of the matrix A.
!           M must be at least zero.
!           Unchanged on exit.

!  N      - INTEGER.
!           On entry, N specifies the number of columns of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.

!  ALPHA  - REAL            .
!           On entry, ALPHA specifies the scalar alpha.
!           Unchanged on exit.

!  X      - REAL             array of dimension at least
!           ( 1 + ( m - 1 )*abs( INCX ) ).
!           Before entry, the incremented array X must contain the m
!           element vector x.
!           Unchanged on exit.

!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.

!  Y      - REAL             array of dimension at least
!           ( 1 + ( n - 1 )*abs( INCY ) ).
!           Before entry, the incremented array Y must contain the n
!           element vector y.
!           Unchanged on exit.

!  INCY   - INTEGER.
!           On entry, INCY specifies the increment for the elements of
!           Y. INCY must not be zero.
!           Unchanged on exit.

!  A      - REAL             array of DIMENSION ( LDA, n ).
!           Before entry, the leading m by n part of the array A must
!           contain the matrix of coefficients. On exit, A is
!           overwritten by the updated matrix.

!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, m ).
!           Unchanged on exit.


!  Level 2 Blas routine.

!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.


!     .. Parameters ..
      REAL (WP) :: ZERO
      PARAMETER (ZERO=0.0E+0_WP)
!     .. Local Scalars ..
      REAL (WP) :: TEMP
      INTEGER :: I,INFO,IX,J,JY,KX
!     .. External Subroutines ..
      EXTERNAL XERBLA
!     .. Intrinsic Functions ..
      INTRINSIC MAX
!     ..
!     .. Executable Statements ..

!     Test the input parameters.

      INFO = 0
      IF (M<0) THEN
        INFO = 1
      ELSE IF (N<0) THEN
        INFO = 2
      ELSE IF (INCX==0) THEN
        INFO = 5
      ELSE IF (INCY==0) THEN
        INFO = 7
      ELSE IF (LDA<MAX(1,M)) THEN
        INFO = 9
      END IF
      IF (INFO/=0) THEN
        CALL XERBLA('SGER  ',INFO)
        RETURN
      END IF

!     Quick return if possible.

      IF ((M==0) .OR. (N==0) .OR. (ALPHA==ZERO)) RETURN

!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.

      IF (INCY>0) THEN
        JY = 1
      ELSE
        JY = 1 - (N-1)*INCY
      END IF
      IF (INCX==1) THEN
        DO J = 1,N
          IF (Y(JY)/=ZERO) THEN
            TEMP = ALPHA*Y(JY)
            DO I = 1,M
              A(I,J) = A(I,J)+X(I)*TEMP
            END DO
          END IF
          JY = JY+INCY
        END DO
      ELSE
        IF (INCX>0) THEN
          KX = 1
        ELSE
          KX = 1 - (M-1)*INCX
        END IF
        DO J = 1,N
          IF (Y(JY)/=ZERO) THEN
            TEMP = ALPHA*Y(JY)
            IX = KX
            DO I = 1,M
              A(I,J) = A(I,J)+X(IX)*TEMP
              IX = IX+INCX
            END DO
          END IF
          JY = JY+INCY
        END DO
      END IF

      RETURN

!     End of SGER  .

    END SUBROUTINE SGER
    FUNCTION SNRM2(N,X,INCX)
      USE DDPRECISION,ONLY : WP
      REAL (WP) :: SNRM2
!     .. Scalar Arguments ..
      INTEGER :: INCX,N
!     .. Array Arguments ..
      REAL (WP) :: X(*)
!     ..

!  SNRM2 returns the euclidean norm of a vector via the function
!  name, so that

!     SNRM2 := sqrt( x'*x )



!  -- This version written on 25-October-1982.
!     Modified on 14-October-1993 to inline the call to SLASSQ.
!     Sven Hammarling, Nag Ltd.


!     .. Parameters ..
      REAL (WP) :: ONE,ZERO
      PARAMETER (ONE=1.0E+0_WP,ZERO=0.0E+0_WP)
!     .. Local Scalars ..
      INTEGER :: IX
      REAL (WP) :: ABSXI,NORM,SCALE,SSQ
!     .. Intrinsic Functions ..
      INTRINSIC ABS,SQRT
!     ..
!     .. Executable Statements ..
      IF (N<1 .OR. INCX<1) THEN
        NORM = ZERO
      ELSE IF (N==1) THEN
        NORM = ABS(X(1))
      ELSE
        SCALE = ZERO
        SSQ = ONE
!        The following loop is equivalent to this call to the LAPACK
!        auxiliary routine:
!        CALL SLASSQ( N,X,INCX,SCALE,SSQ )

        DO IX = 1,1+(N-1)*INCX,INCX
          IF (X(IX)/=ZERO) THEN
            ABSXI = ABS(X(IX))
            IF (SCALE<ABSXI) THEN
              SSQ = ONE+SSQ*(SCALE/ABSXI)**2
              SCALE = ABSXI
            ELSE
              SSQ = SSQ+(ABSXI/SCALE)**2
            END IF
          END IF
        END DO
        NORM = SCALE*SQRT(SSQ)
      END IF

      SNRM2 = NORM
      RETURN

!     End of SNRM2.

    END FUNCTION SNRM2
    SUBROUTINE SROT(N,SX,INCX,SY,INCY,C,S)
      USE DDPRECISION,ONLY : WP

!     applies a plane rotation.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SY(*),STEMP,C,S
      INTEGER :: I,INCX,INCY,IX,IY,N

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!       code for unequal increments or equal increments not equal
!         to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        STEMP = C*SX(IX)+S*SY(IY)
        SY(IY) = C*SY(IY) - S*SX(IX)
        SX(IX) = STEMP
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!       code for both increments equal to 1

20    DO I = 1,N
        STEMP = C*SX(I)+S*SY(I)
        SY(I) = C*SY(I) - S*SX(I)
        SX(I) = STEMP
      END DO
      RETURN
    END SUBROUTINE SROT
    SUBROUTINE SSCAL(N,SA,SX,INCX)
      USE DDPRECISION,ONLY : WP

!     scales a vector by a constant.
!     uses unrolled loops for increment equal to 1.
!     jack dongarra, linpack, 3/11/78.
!     modified 3/93 to return if incx .le. 0.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SA,SX(*)
      INTEGER :: I,INCX,M,MP1,N,NINCX

      IF (N<=0 .OR. INCX<=0) RETURN
      IF (INCX==1) GO TO 20

!        code for increment not equal to 1

      NINCX = N*INCX
      DO I = 1,NINCX,INCX
        SX(I) = SA*SX(I)
      END DO
      RETURN

!        code for increment equal to 1


!        clean-up loop

20    M = MOD(N,5)
      IF (M==0) GO TO 40
      DO I = 1,M
        SX(I) = SA*SX(I)
      END DO
      IF (N<5) RETURN
40    MP1 = M+1
      DO I = MP1,N,5
        SX(I) = SA*SX(I)
        SX(I+1) = SA*SX(I+1)
        SX(I+2) = SA*SX(I+2)
        SX(I+3) = SA*SX(I+3)
        SX(I+4) = SA*SX(I+4)
      END DO
      RETURN
    END SUBROUTINE SSCAL
    SUBROUTINE SSWAP(N,SX,INCX,SY,INCY)
      USE DDPRECISION,ONLY : WP

!     interchanges two vectors.
!     uses unrolled loops for increments equal to 1.
!     jack dongarra, linpack, 3/11/78.
!     modified 12/3/93, array(1) declarations changed to array(*)

      REAL (WP) :: SX(*),SY(*),STEMP
      INTEGER :: I,INCX,INCY,IX,IY,M,MP1,N

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!       code for unequal increments or equal increments not equal
!         to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX+1
      IF (INCY<0) IY = (-N+1)*INCY+1
      DO I = 1,N
        STEMP = SX(IX)
        SX(IX) = SY(IY)
        SY(IY) = STEMP
        IX = IX+INCX
        IY = IY+INCY
      END DO
      RETURN

!       code for both increments equal to 1


!       clean-up loop

20    M = MOD(N,3)
      IF (M==0) GO TO 40
      DO I = 1,M
        STEMP = SX(I)
        SX(I) = SY(I)
        SY(I) = STEMP
      END DO
      IF (N<3) RETURN
40    MP1 = M+1
      DO I = MP1,N,3
        STEMP = SX(I)
        SX(I) = SY(I)
        SY(I) = STEMP
        STEMP = SX(I+1)
        SX(I+1) = SY(I+1)
        SY(I+1) = STEMP
        STEMP = SX(I+2)
        SX(I+2) = SY(I+2)
        SY(I+2) = STEMP
      END DO
      RETURN
    END SUBROUTINE SSWAP
    SUBROUTINE STRMM(SIDE,UPLO,TRANSA,DIAG,M,N,ALPHA,A,LDA,B,LDB)
      USE DDPRECISION,ONLY : WP
!     .. Scalar Arguments ..
      CHARACTER (1) :: SIDE,UPLO,TRANSA,DIAG
      INTEGER :: M,N,LDA,LDB
      REAL (WP) :: ALPHA
!     .. Array Arguments ..
      REAL (WP) :: A(LDA,*),B(LDB,*)
!     ..

!  Purpose
!  =======

!  STRMM  performs one of the matrix-matrix operations

!     B := alpha*op( A )*B,   or   B := alpha*B*op( A ),

!  where  alpha  is a scalar,  B  is an m by n matrix,  A  is a unit, or
!  non-unit,  upper or lower triangular matrix  and  op( A )  is one  of

!     op( A ) = A   or   op( A ) = A'.

!  Parameters
!  ==========

!  SIDE   - CHARACTER*1.
!           On entry,  SIDE specifies whether  op( A ) multiplies B from
!           the left or right as follows:

!              SIDE = 'L' or 'l'   B := alpha*op( A )*B.

!              SIDE = 'R' or 'r'   B := alpha*B*op( A ).

!           Unchanged on exit.

!  UPLO   - CHARACTER*1.
!           On entry, UPLO specifies whether the matrix A is an upper or
!           lower triangular matrix as follows:

!              UPLO = 'U' or 'u'   A is an upper triangular matrix.

!              UPLO = 'L' or 'l'   A is a lower triangular matrix.

!           Unchanged on exit.

!  TRANSA - CHARACTER*1.
!           On entry, TRANSA specifies the form of op( A ) to be used in
!           the matrix multiplication as follows:

!              TRANSA = 'N' or 'n'   op( A ) = A.

!              TRANSA = 'T' or 't'   op( A ) = A'.

!              TRANSA = 'C' or 'c'   op( A ) = A'.

!           Unchanged on exit.

!  DIAG   - CHARACTER*1.
!           On entry, DIAG specifies whether or not A is unit triangular
!           as follows:

!              DIAG = 'U' or 'u'   A is assumed to be unit triangular.

!              DIAG = 'N' or 'n'   A is not assumed to be unit
!                                  triangular.

!           Unchanged on exit.

!  M      - INTEGER.
!           On entry, M specifies the number of rows of B. M must be at
!           least zero.
!           Unchanged on exit.

!  N      - INTEGER.
!           On entry, N specifies the number of columns of B.  N must be
!           at least zero.
!           Unchanged on exit.

!  ALPHA  - REAL            .
!           On entry,  ALPHA specifies the scalar  alpha. When  alpha is
!           zero then  A is not referenced and  B need not be set before
!           entry.
!           Unchanged on exit.

!  A      - REAL             array of DIMENSION ( LDA, k ), where k is m
!           when  SIDE = 'L' or 'l'  and is  n  when  SIDE = 'R' or 'r'.
!           Before entry  with  UPLO = 'U' or 'u',  the  leading  k by k
!           upper triangular part of the array  A must contain the upper
!           triangular matrix  and the strictly lower triangular part of
!           A is not referenced.
!           Before entry  with  UPLO = 'L' or 'l',  the  leading  k by k
!           lower triangular part of the array  A must contain the lower
!           triangular matrix  and the strictly upper triangular part of
!           A is not referenced.
!           Note that when  DIAG = 'U' or 'u',  the diagonal elements of
!           A  are not referenced either,  but are assumed to be  unity.
!           Unchanged on exit.

!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program.  When  SIDE = 'L' or 'l'  then
!           LDA  must be at least  max( 1, m ),  when  SIDE = 'R' or 'r'
!           then LDA must be at least max( 1, n ).
!           Unchanged on exit.

!  B      - REAL             array of DIMENSION ( LDB, n ).
!           Before entry,  the leading  m by n part of the array  B must
!           contain the matrix  B,  and  on exit  is overwritten  by the
!           transformed matrix.

!  LDB    - INTEGER.
!           On entry, LDB specifies the first dimension of B as declared
!           in  the  calling  (sub)  program.   LDB  must  be  at  least
!           max( 1, m ).
!           Unchanged on exit.


!  Level 3 Blas routine.

!  -- Written on 8-February-1989.
!     Jack Dongarra, Argonne National Laboratory.
!     Iain Duff, AERE Harwell.
!     Jeremy Du Croz, Numerical Algorithms Group Ltd.
!     Sven Hammarling, Numerical Algorithms Group Ltd.


!     .. External Functions ..
      LOGICAL :: LSAME
      EXTERNAL LSAME
!     .. External Subroutines ..
      EXTERNAL XERBLA
!     .. Intrinsic Functions ..
      INTRINSIC MAX
!     .. Local Scalars ..
      LOGICAL :: LSIDE,NOUNIT,UPPER
      INTEGER :: I,INFO,J,K,NROWA
      REAL (WP) :: TEMP
!     .. Parameters ..
      REAL (WP) :: ONE,ZERO
      PARAMETER (ONE=1.0E+0_WP,ZERO=0.0E+0_WP)
!     ..
!     .. Executable Statements ..

!     Test the input parameters.

      LSIDE = LSAME(SIDE,'L')
      IF (LSIDE) THEN
        NROWA = M
      ELSE
        NROWA = N
      END IF
      NOUNIT = LSAME(DIAG,'N')
      UPPER = LSAME(UPLO,'U')

      INFO = 0
      IF (( .NOT. LSIDE) .AND. ( .NOT. LSAME(SIDE,'R'))) THEN
        INFO = 1
      ELSE IF (( .NOT. UPPER) .AND. ( .NOT. LSAME(UPLO,'L'))) THEN
        INFO = 2
      ELSE IF (( .NOT. LSAME(TRANSA,'N')) .AND. ( .NOT. LSAME(TRANSA, &
          'T')) .AND. ( .NOT. LSAME(TRANSA,'C'))) THEN
        INFO = 3
      ELSE IF (( .NOT. LSAME(DIAG,'U')) .AND. ( .NOT. LSAME(DIAG,'N'))) THEN
        INFO = 4
      ELSE IF (M<0) THEN
        INFO = 5
      ELSE IF (N<0) THEN
        INFO = 6
      ELSE IF (LDA<MAX(1,NROWA)) THEN
        INFO = 9
      ELSE IF (LDB<MAX(1,M)) THEN
        INFO = 11
      END IF
      IF (INFO/=0) THEN
        CALL XERBLA('STRMM ',INFO)
        RETURN
      END IF

!     Quick return if possible.

      IF (N==0) RETURN

!     And when  alpha.eq.zero.

      IF (ALPHA==ZERO) THEN
        DO J = 1,N
          DO I = 1,M
            B(I,J) = ZERO
          END DO
        END DO
        RETURN
      END IF

!     Start the operations.

      IF (LSIDE) THEN
        IF (LSAME(TRANSA,'N')) THEN

!           Form  B := alpha*A*B.

          IF (UPPER) THEN
            DO J = 1,N
              DO K = 1,M
                IF (B(K,J)/=ZERO) THEN
                  TEMP = ALPHA*B(K,J)
                  DO I = 1,K - 1
                    B(I,J) = B(I,J)+TEMP*A(I,K)
                  END DO
                  IF (NOUNIT) TEMP = TEMP*A(K,K)
                  B(K,J) = TEMP
                END IF
              END DO
            END DO
          ELSE
            DO J = 1,N
              DO K = M,1,-1
                IF (B(K,J)/=ZERO) THEN
                  TEMP = ALPHA*B(K,J)
                  B(K,J) = TEMP
                  IF (NOUNIT) B(K,J) = B(K,J)*A(K,K)
                  DO I = K+1,M
                    B(I,J) = B(I,J)+TEMP*A(I,K)
                  END DO
                END IF
              END DO
            END DO
          END IF
        ELSE

!           Form  B := alpha*A'*B.

          IF (UPPER) THEN
            DO J = 1,N
              DO I = M,1,-1
                TEMP = B(I,J)
                IF (NOUNIT) TEMP = TEMP*A(I,I)
                DO K = 1,I - 1
                  TEMP = TEMP+A(K,I)*B(K,J)
                END DO
                B(I,J) = ALPHA*TEMP
              END DO
            END DO
          ELSE
            DO J = 1,N
              DO I = 1,M
                TEMP = B(I,J)
                IF (NOUNIT) TEMP = TEMP*A(I,I)
                DO K = I+1,M
                  TEMP = TEMP+A(K,I)*B(K,J)
                END DO
                B(I,J) = ALPHA*TEMP
              END DO
            END DO
          END IF
        END IF
      ELSE
        IF (LSAME(TRANSA,'N')) THEN

!           Form  B := alpha*B*A.

          IF (UPPER) THEN
            DO J = N,1,-1
              TEMP = ALPHA
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = 1,M
                B(I,J) = TEMP*B(I,J)
              END DO
              DO K = 1,J - 1
                IF (A(K,J)/=ZERO) THEN
                  TEMP = ALPHA*A(K,J)
                  DO I = 1,M
                    B(I,J) = B(I,J)+TEMP*B(I,K)
                  END DO
                END IF
              END DO
            END DO
          ELSE
            DO J = 1,N
              TEMP = ALPHA
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = 1,M
                B(I,J) = TEMP*B(I,J)
              END DO
              DO K = J+1,N
                IF (A(K,J)/=ZERO) THEN
                  TEMP = ALPHA*A(K,J)
                  DO I = 1,M
                    B(I,J) = B(I,J)+TEMP*B(I,K)
                  END DO
                END IF
              END DO
            END DO
          END IF
        ELSE

!           Form  B := alpha*B*A'.

          IF (UPPER) THEN
            DO K = 1,N
              DO J = 1,K - 1
                IF (A(J,K)/=ZERO) THEN
                  TEMP = ALPHA*A(J,K)
                  DO I = 1,M
                    B(I,J) = B(I,J)+TEMP*B(I,K)
                  END DO
                END IF
              END DO
              TEMP = ALPHA
              IF (NOUNIT) TEMP = TEMP*A(K,K)
              IF (TEMP/=ONE) THEN
                DO I = 1,M
                  B(I,K) = TEMP*B(I,K)
                END DO
              END IF
            END DO
          ELSE
            DO K = N,1,-1
              DO J = K+1,N
                IF (A(J,K)/=ZERO) THEN
                  TEMP = ALPHA*A(J,K)
                  DO I = 1,M
                    B(I,J) = B(I,J)+TEMP*B(I,K)
                  END DO
                END IF
              END DO
              TEMP = ALPHA
              IF (NOUNIT) TEMP = TEMP*A(K,K)
              IF (TEMP/=ONE) THEN
                DO I = 1,M
                  B(I,K) = TEMP*B(I,K)
                END DO
              END IF
            END DO
          END IF
        END IF
      END IF

      RETURN

!     End of STRMM .

    END SUBROUTINE STRMM
    SUBROUTINE STRMV(UPLO,TRANS,DIAG,N,A,LDA,X,INCX)
      USE DDPRECISION,ONLY : WP
!     .. Scalar Arguments ..
      INTEGER :: INCX,LDA,N
      CHARACTER (1) :: DIAG,TRANS,UPLO
!     .. Array Arguments ..
      REAL (WP) :: A(LDA,*),X(*)
!     ..

!  Purpose
!  =======

!  STRMV  performs one of the matrix-vector operations

!     x := A*x,   or   x := A'*x,

!  where x is an n element vector and  A is an n by n unit, or non-unit,
!  upper or lower triangular matrix.

!  Parameters
!  ==========

!  UPLO   - CHARACTER*1.
!           On entry, UPLO specifies whether the matrix is an upper or
!           lower triangular matrix as follows:

!              UPLO = 'U' or 'u'   A is an upper triangular matrix.

!              UPLO = 'L' or 'l'   A is a lower triangular matrix.

!           Unchanged on exit.

!  TRANS  - CHARACTER*1.
!           On entry, TRANS specifies the operation to be performed as
!           follows:

!              TRANS = 'N' or 'n'   x := A*x.

!              TRANS = 'T' or 't'   x := A'*x.

!              TRANS = 'C' or 'c'   x := A'*x.

!           Unchanged on exit.

!  DIAG   - CHARACTER*1.
!           On entry, DIAG specifies whether or not A is unit
!           triangular as follows:

!              DIAG = 'U' or 'u'   A is assumed to be unit triangular.

!              DIAG = 'N' or 'n'   A is not assumed to be unit
!                                  triangular.

!           Unchanged on exit.

!  N      - INTEGER.
!           On entry, N specifies the order of the matrix A.
!           N must be at least zero.
!           Unchanged on exit.

!  A      - REAL             array of DIMENSION ( LDA, n ).
!           Before entry with  UPLO = 'U' or 'u', the leading n by n
!           upper triangular part of the array A must contain the upper
!           triangular matrix and the strictly lower triangular part of
!           A is not referenced.
!           Before entry with UPLO = 'L' or 'l', the leading n by n
!           lower triangular part of the array A must contain the lower
!           triangular matrix and the strictly upper triangular part of
!           A is not referenced.
!           Note that when  DIAG = 'U' or 'u', the diagonal elements of
!           A are not referenced either, but are assumed to be unity.
!           Unchanged on exit.

!  LDA    - INTEGER.
!           On entry, LDA specifies the first dimension of A as declared
!           in the calling (sub) program. LDA must be at least
!           max( 1, n ).
!           Unchanged on exit.

!  X      - REAL             array of dimension at least
!           ( 1 + ( n - 1 )*abs( INCX ) ).
!           Before entry, the incremented array X must contain the n
!           element vector x. On exit, X is overwritten with the
!           tranformed vector x.

!  INCX   - INTEGER.
!           On entry, INCX specifies the increment for the elements of
!           X. INCX must not be zero.
!           Unchanged on exit.


!  Level 2 Blas routine.

!  -- Written on 22-October-1986.
!     Jack Dongarra, Argonne National Lab.
!     Jeremy Du Croz, Nag Central Office.
!     Sven Hammarling, Nag Central Office.
!     Richard Hanson, Sandia National Labs.


!     .. Parameters ..
      REAL (WP) :: ZERO
      PARAMETER (ZERO=0.0E+0_WP)
!     .. Local Scalars ..
      REAL (WP) :: TEMP
      INTEGER :: I,INFO,IX,J,JX,KX
      LOGICAL :: NOUNIT
!     .. External Functions ..
      LOGICAL :: LSAME
      EXTERNAL LSAME
!     .. External Subroutines ..
      EXTERNAL XERBLA
!     .. Intrinsic Functions ..
      INTRINSIC MAX
!     ..
!     .. Executable Statements ..

!     Test the input parameters.

      INFO = 0
      IF ( .NOT. LSAME(UPLO,'U') .AND. .NOT. LSAME(UPLO,'L')) THEN
        INFO = 1
      ELSE IF ( .NOT. LSAME(TRANS,'N') .AND. .NOT. LSAME(TRANS,'T') .AND. &
          .NOT. LSAME(TRANS,'C')) THEN
        INFO = 2
      ELSE IF ( .NOT. LSAME(DIAG,'U') .AND. .NOT. LSAME(DIAG,'N')) THEN
        INFO = 3
      ELSE IF (N<0) THEN
        INFO = 4
      ELSE IF (LDA<MAX(1,N)) THEN
        INFO = 6
      ELSE IF (INCX==0) THEN
        INFO = 8
      END IF
      IF (INFO/=0) THEN
        CALL XERBLA('STRMV ',INFO)
        RETURN
      END IF

!     Quick return if possible.

      IF (N==0) RETURN

      NOUNIT = LSAME(DIAG,'N')

!     Set up the start point in X if the increment is not unity. This
!     will be  ( N - 1 )*INCX  too small for descending loops.

      IF (INCX<=0) THEN
        KX = 1 - (N-1)*INCX
      ELSE IF (INCX/=1) THEN
        KX = 1
      END IF

!     Start the operations. In this version the elements of A are
!     accessed sequentially with one pass through A.

      IF (LSAME(TRANS,'N')) THEN

!        Form  x := A*x.

        IF (LSAME(UPLO,'U')) THEN
          IF (INCX==1) THEN
            DO J = 1,N
              IF (X(J)/=ZERO) THEN
                TEMP = X(J)
                DO I = 1,J - 1
                  X(I) = X(I)+TEMP*A(I,J)
                END DO
                IF (NOUNIT) X(J) = X(J)*A(J,J)
              END IF
            END DO
          ELSE
            JX = KX
            DO J = 1,N
              IF (X(JX)/=ZERO) THEN
                TEMP = X(JX)
                IX = KX
                DO I = 1,J - 1
                  X(IX) = X(IX)+TEMP*A(I,J)
                  IX = IX+INCX
                END DO
                IF (NOUNIT) X(JX) = X(JX)*A(J,J)
              END IF
              JX = JX+INCX
            END DO
          END IF
        ELSE
          IF (INCX==1) THEN
            DO J = N,1,-1
              IF (X(J)/=ZERO) THEN
                TEMP = X(J)
                DO I = N,J+1,-1
                  X(I) = X(I)+TEMP*A(I,J)
                END DO
                IF (NOUNIT) X(J) = X(J)*A(J,J)
              END IF
            END DO
          ELSE
            KX = KX+(N-1)*INCX
            JX = KX
            DO J = N,1,-1
              IF (X(JX)/=ZERO) THEN
                TEMP = X(JX)
                IX = KX
                DO I = N,J+1,-1
                  X(IX) = X(IX)+TEMP*A(I,J)
                  IX = IX - INCX
                END DO
                IF (NOUNIT) X(JX) = X(JX)*A(J,J)
              END IF
              JX = JX - INCX
            END DO
          END IF
        END IF
      ELSE

!        Form  x := A'*x.

        IF (LSAME(UPLO,'U')) THEN
          IF (INCX==1) THEN
            DO J = N,1,-1
              TEMP = X(J)
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = J - 1,1,-1
                TEMP = TEMP+A(I,J)*X(I)
              END DO
              X(J) = TEMP
            END DO
          ELSE
            JX = KX+(N-1)*INCX
            DO J = N,1,-1
              TEMP = X(JX)
              IX = JX
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = J - 1,1,-1
                IX = IX - INCX
                TEMP = TEMP+A(I,J)*X(IX)
              END DO
              X(JX) = TEMP
              JX = JX - INCX
            END DO
          END IF
        ELSE
          IF (INCX==1) THEN
            DO J = 1,N
              TEMP = X(J)
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = J+1,N
                TEMP = TEMP+A(I,J)*X(I)
              END DO
              X(J) = TEMP
            END DO
          ELSE
            JX = KX
            DO J = 1,N
              TEMP = X(JX)
              IX = JX
              IF (NOUNIT) TEMP = TEMP*A(J,J)
              DO I = J+1,N
                IX = IX+INCX
                TEMP = TEMP+A(I,J)*X(IX)
              END DO
              X(JX) = TEMP
              JX = JX+INCX
            END DO
          END IF
        END IF
      END IF

      RETURN

!     End of STRMV .

    END SUBROUTINE STRMV
    SUBROUTINE XERBLA(SRNAME,INFO)

!  -- LAPACK auxiliary routine (preliminary version) --
!     Univ. of Tennessee, Univ. of California Berkeley, NAG Ltd.,
!     Courant Institute, Argonne National Lab, and Rice University
!     February 29, 1992

!     .. Scalar Arguments ..
      CHARACTER (6) :: SRNAME
      INTEGER :: INFO
!     ..

!  Purpose
!  =======

!  XERBLA  is an error handler for the LAPACK routines.
!  It is called by an LAPACK routine if an input parameter has an
!  invalid value.  A message is printed and execution stops.

!  Installers may consider modifying the STOP statement in order to
!  call system-specific exception-handling facilities.

!  Arguments
!  =========

!  SRNAME  (input) CHARACTER*6
!          The name of the routine which called XERBLA.

!  INFO    (input) INTEGER
!          The position of the invalid parameter in the parameter list
!          of the calling routine.


      WRITE (*,FMT=9999) SRNAME,INFO

      STOP

9999  FORMAT (' ** On entry to ',A6,' parameter number ',I2,' had ', &
        'an illegal value')

!     End of XERBLA

    END SUBROUTINE XERBLA

    SUBROUTINE TARANIREC(A1,A2,XV,YV,ZV,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL(WP) :: XV,YV,ZV
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local variables:

      INTEGER :: JA,JX,JY,JZ,NX,NY,NZ
      CHARACTER :: CMSGNM*70

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:
! intrinsic function: do not need to explicitly type:      INTEGER IFIX
!***********************************************************************
! Subroutine TARANIREC
! Purpose: to construct rectangular target with anisotropic dielectric
!          tensor.
!          Dielectric tensor is assumed to be diagonalized in target
!          frame, with
!          material 1 for x-direction
!          material 2 for y-direction
!          material 3 for z-direction
!          Note: Must specify NCOMP=3 in ddscat.par, and provide
!                file names for three materials
! Input:
!        XV=(x-length)/d    (d=lattice spacing)
!        YV=(y-length)/d
!        ZV=(z-length)/d
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Frame
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Frame
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        X0(1-3)=(location/d) in TF of dipole with IXYZ=(0,0,0).  This
!                will henceforth be treated as the origin of physical
!                coordinates in the TF.
!                origin is assumed to be located at midpoint of upper surface
!                normal to the A1 vector.
!                Upper surface is presumed to be 0.5*d above uppermost
!                layer of dipoles.

! B.T.Draine, Princeton Univ. Obs.
! History:
! 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 93.03.12 (BTD): Specified CDESCR*67, and now use it.
! 95.07.12 (BTD): Changed definition of axes A1,A2.  They used to be
!                 longest,next longest dimention.  They are now
!                 fixed to always be (1,0,0) and (0,1,0).
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(1-3) to argument list to support nonuniform
!                 lattice spacing.
! 98.02.11 (BTD): Modify to generate target on noncubic lattice.
! 00.11.02 (BTD): Add ICOMP to argument list, set ICOMP=1,
!                 write ICOMP to target.out
! 04.04.29 (BTD): Created from TARREC with only minor modifications
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.01.13 (BTD): Cosmetic changes
!                 Added X0 to argument list
!                 Added code to define X0
! 08.08.29 (BTD): Modified format 9020
! end history

! Copyright (C) 1993,1995,1996,1997,1998,2000,2004,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!***********************************************************************
      NX=INT(XV/DX(1)+0.5_WP)
      NY=INT(YV/DX(2)+0.5_WP)
      NZ=INT(ZV/DX(3)+0.5_WP)
      WRITE(CMSGNM,FMT='(A,3I4)')' Anisotropic rectangular prism; NX,NY,NZ=', &
                                 NX,NY,NZ
      WRITE(CDESCR,FMT='(A,3I4)')' Anisotropic rectangular prism; NX,NY,NZ=', &
                                 NX,NY,NZ

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in target frame
!             A2 will be (0,1,0) in target frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! Now populate lattice:
      NAT=0
      DO JZ=1,NZ
         DO JY=1,NY
            DO JX=1,NX
               NAT=NAT+1
               IF(NAT>MXNAT) THEN
                  CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ
            ENDDO
         ENDDO
      ENDDO
      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT ')
      ENDIF

! set TF origin of coordinates to be located at midpoint of
! upper surface normal to A1.  Upper surface is presumed to be located
! 0.5*d above uppermost dipole layer

      X0(1)=-REAL(NX)-0.5
      X0(2)=-REAL(1+NY)/2._WP
      X0(3)=-REAL(1+NZ)/2._WP

! homogeneous, anisotropic composition:

      DO JX=1,3
         DO JA=1,NAT
            ICOMP(JA,JX)=JX
         ENDDO
      ENDDO

      WRITE(CMSGNM,FMT='(A, I7,A)') &
            '  Anisotropic rectangular prism of NAT=',NAT,' dipoles'
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XV,YV,ZV,NAT,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT (' >TARREC anisotropic rectangular prism; AX,AY,AZ=',3F8.4,/, &
         I9,' = NAT',/,                                                    &
         3F9.4,' = A_1 vector',/,                                          &
         3F9.4,' = A_2 vector',/,                                          &
         3F9.6,' = lattice spacings (d_x,d_y,d_z)/d',/,                    &
         3F9.6,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ',          &
               'for dipole 0 0 0',/,                                       &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT (I7,3I4,3I2)
    END SUBROUTINE TARANIREC

    SUBROUTINE TARTET(A1,A2,AX,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!** Arguments:
      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP,MXNAT,NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: AX
      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)
!** Local variables:
      INTEGER :: I,IMAX,IMIN,J,JMAX,JMIN,JX,K,KMAX,KMIN
      REAL(WP) :: FY,S,X,XOFF,Y,YMAX,YMIN,YOFF,Z,ZMAX,ZMAX0,ZOFF
!***********************************************************************

! Routine to construct regular tetrahedral target array
! one of the faces is parallel to the y-z plane
! one of the edges of this face is parallel to x-y plane

! Input:
!        AX = length of one edge of tetrahedron
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT = dimensioning information
! Returns:
!        A1(1-3) = unit vector (1,0,0) (along one axis of tetrahedron)
!        A2(1-3) = unit vector (0,1,0)
!        CDESCR = string describing target (up to 67 chars.)
!        NAT = number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms in target
!        ICOMP(1-NAT,1-3)=1 (composition identifier)
!        X0(1-3) = location/d in TF of site with IXYZ=0 0 0
! Occupied array sites are those within tetrahedral surface
! Size:
!    S=length of each side of tetrahedron
!    Volume = S**3/(6*sqrt(2))
! Orientation:
!    Center of mass is at origin.
!    One face is parallel to yz plane.
!    Projection onto yz plane has vertex on y axis.
!    S=length of one side (in lattice units)
!    Vertices are at
!    A=( sqrt(3/8),         0,    0)*S
!    B=(-sqrt(1/24), sqrt(1/3),    0)*S
!    C=(-sqrt(1/24),-sqrt(1/12),-1/2)*S
!    D=(-sqrt(1/24),-sqrt(1/12), 1/2)*S
! Length in x direction = S*sqrt(2/3)
!           y           = S*sqrt(3)/2
!           z           = S
! Angle(AOB)=arccos(-1/3)=109.4712 deg.
! OA=OB=OC=OD=sqrt(3/8)*S
! Occupied sites are assumed to be located at
! (X,Y,Z)=(I+XOFF,J+YOFF,K+ZOFF)
! where I,J,K are integers, and XOFF,YOFF,ZOFF are constants.
! Program sets XOFF,YOFF,ZOFF depending on choice of parameter S.

! Criterion for choosing XOFF:
!    Base of tetrahedron is located at x = -sqrt(1/24)*S
!    Let IMIN be value of I for this plane
!    Choose XOFF so that IMIN+XOFF = -sqrt(1/24)*S + 0.5
!    with -0.5 < XOFF < 0.5
! Criterion for choosing YOFF:
!    One edge of tetrahedron is located at y= -S/(2*sqrt(3))
!    Let JMIN be value of J for this line
!    Choose YOFF so that JMIN+YOFF = -S/sqrt(12) + 0.5
! Criterion for choosing ZOFF:
!    One edge of tetrahedron is parallel to z axis
!    Choose ZOFF in order to have number of dipoles along
!    this edge as close as possible to S
!    e.g., if S=odd integer, then take ZOFF=0 to place dipoles
!          at integral locations
!          if S=even integer, then take ZOFF=1/2 to place dipoles
!          at half-integral locations

! B.T.Draine, Princeton Univ. Obs., 90.10.30
! History:
! 90.11.08 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
! 90.11.09 (BTD): Corrected error in location of center of mass.
! 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 95.07.13 (BTD): Eliminated unused arguments AY,AZ
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(3) to argument list to support noncubic
!                 lattice.
!                 *** Note: additional code modifications required
!                     to support noncubic lattice!
! 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
!                 call ERRMSG and halt with fatal error.
! 98.03.07 (BTD): Modify to write DX to file "target.out" for
!                 compatibility with REASHP
! 00.11.02 (BTD): Add ICOMP to argument list
!                 set ICOMP=1 at occupied sites
!                 write ICOMP to target.out
! 07.09.11 (BTD): changed IXYZ from INTEGER*2 to INTEGER
! 08.08.30 (BTD): added X0 to argument list
!                 added code to evaluate X0 for origin of TF at centroid
!                 modified format 9020
! end history

! Copyright (C) 1993,1995,1996,1997,1998,2000,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Current version of TARTET is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TARTET',' tartet does not support noncubic lattice')
      ENDIF
      S=AX

! Set XOFF (and IMIN,IMAX):

      IMIN=-INT(S*SQRT(1._WP/24._WP))
      XOFF=0.5_WP-S*SQRT(1._WP/24._WP)-IMIN
      IMAX=IMIN+INT(S*SQRT(2._WP/3._WP)+0.5_WP)-1

! Set YOFF (and JMIN,JMAX):

      JMIN=-INT(S/SQRT(12._WP))
      YOFF=0.5_WP-S/SQRT(12._WP)-JMIN
      JMAX=JMIN+INT(S*SQRT(.75_WP)+0.5_WP)-1

! Set ZOFF (and KMIN,KMAX):
! Determine whether S is closest to even or odd integer.
!  (Temporarily let KMIN be integer which S is closest to)

      KMIN=INT(S+0.5_WP)

! If KMIN is even, then ZOFF=0.5
! If KMIN is odd, then ZOFF=0.

      ZOFF=0._WP
      IF(KMIN-2*(KMIN/2)==0)ZOFF=0.5_WP
      KMIN=-INT(0.5_WP*S+ZOFF)
      KMAX=KMIN+INT(S+0.5_WP)-1

! Determine list of occupied sites.

      NAT=0
      DO I=IMIN,IMAX
         X=REAL(I,KIND=WP)+XOFF

! YMAX=largest value of Y which can occur for this X value
! YMIN=smallest value of Y which can occur for this X value
! ZMAX0=largest value of Z which can occur for this X value

         YMAX=S*SQRT(3._WP/16._WP)-X/SQRT(2._WP)
         YMIN=-S*SQRT(3._WP/64._WP)+X/SQRT(8._WP)
         ZMAX0=3._WP*S/8._WP-X*SQRT(3._WP/8._WP)
         DO J=JMIN,JMAX
            Y=REAL(J,KIND=WP)+YOFF
            IF(Y>=YMIN.AND.Y<=YMAX)THEN

! ZMAX=largest value of Z which can occur for this (X,Y)

               FY=(Y-YMIN)/(YMAX-YMIN)
               ZMAX=(1._WP-FY)*ZMAX0
               DO K=KMIN,KMAX
                  Z=REAL(K,KIND=WP)+ZOFF
                  IF(ABS(Z)<=ZMAX)THEN

! Site is occupied:

                     NAT=NAT+1
                     IF(NAT>MXNAT)THEN
                        CALL ERRMSG('FATAL','TARTET',' NAT.GT.MXNAT ')
                     ENDIF
                     IXYZ(NAT,1)=I
                     IXYZ(NAT,2)=J
                     IXYZ(NAT,3)=K
                  ENDIF
               ENDDO
            ENDIF
         ENDDO
      ENDDO

! Initialize composition:
! Set X0 so that origin of TF is at centroid

      DO K=1,3
         X0(K)=0._WP
         DO I=1,NAT
            X0(K)=X0(K)+REAL(IXYZ(I,K))
            ICOMP(I,K)=1
         ENDDO
         X0(K)=-X0(K)/REAL(NAT)
      ENDDO

!*** Specify vectors A1 and A2 which will define target orientation
!    A1 is initially along x-axis
!    A2 is initially along y-axis

      A1(1)=1._WP
      A1(2)=0._WP
      A1(3)=0._WP
      A2(1)=0._WP
      A2(2)=1._WP
      A2(3)=0._WP

      WRITE(CDESCR,FMT='(A,I7,A)')' Tetrahedron of NAT=',NAT,' dipoles'
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)S,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARTET  tetrahedral grain: S=',F9.4,/,             &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT (I7,3I4,3I2)
    END SUBROUTINE TARTET

    SUBROUTINE REDUCE(CXV,IOCC,MXN3,MXNAT,NAT,NAT0)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: MXN3, MXNAT, NAT, NAT0
      INTEGER*2 :: IOCC(MXNAT)
      COMPLEX (WP) :: CXV(MXN3)

! Local variables:

      INTEGER :: J, JOC, M

!***********************************************************************
! Given:
!      CXV(1-3*NAT) defined for NAT lattice sites with ordering
!          (v_x1,...,v_xj,...,v_xNAT,v_y1,...,v_yj,...,v_yNAT,
!           v_z1,...,v_zj,...,v_zNAT)
!          where index j runs over occupied and unoccupied lattice sites
!      IOCC(1-NAT) = 0 or 1 depending on whether lattice site
!                    is vacant or occupied
!      MXN3,MXNAT = dimensioning information
!      NAT = number of lattice sites
!      NAT0 = number of occupied lattice sites

! Returns
!      CXV(1-3*NAT0) defined for NAT0 occupied lattice sites
!         with ordering
!         (v_x1,...,v_xj,...,v_xNAT0,v_y1,...,v_yj,...,v_yNAT0,
!          v_z1,...,v_zj,...,v_zNAT0)
!         where index j now runs over only occupied lattice sites

! B.T.Draine, Princeton Univ. Observatory, 90.11.29
! History:
! 90.12.03 (BTD): Modified for new ordering of vectors.
! 90.12.05 (BTD): Corrected errors
! 06.04.11 (BTD): Cosmetic changes
! end history

! Copyright (C) 1993, 2006 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DO M=0,2
         JOC=0
         DO J=1,NAT
            IF(IOCC(J)>=1)THEN
               JOC=JOC+1
               CXV(JOC+M*NAT0)=CXV(J+M*NAT)
            ENDIF
         ENDDO
      ENDDO
      RETURN
    END SUBROUTINE REDUCE

    SUBROUTINE TAR2SP(A1,A2,A_1,B_1,A_2,B_2,PHI,PRINAX,DX,X0,CDESCR,IOSHP, &
                      MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP, MXNAT, NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: A_1,A_2,B_1,B_2,PHI,PRINAX
      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local variables:

      CHARACTER :: CMSGNM*70
      INTEGER :: JA,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NAT1,NAT2
      REAL(WP) :: AX2,AY2,AZ2,COSPHI,SINPHI,U,V,R,RX2,RYZ2,RZ2, &
                  X,XC1,XC2,Y,YC1,YC2,Z,ZC1,ZC2
      REAL(WP) :: EIGVAL(3)

!***********************************************************************
! Routine to construct two touching spheroids from "atoms"
!    First spheroid has symmetry axis in y direction.
!    Second spheroid is displaced in x direction, with symmetry
!    axis in yz plane, in direction ey*cos(phi)+ez*sin(phi).
!    Separation between centroids=(B_1+B_2)/2

! Input:
!        A_1=length/d of 1st spheroid along symm.axis  (d=lattice spacing)
!        A_2=length/d of 2nd spheroid along symm.axis
!        B_1=diameter/d of 1st spheroid
!        B_2=diameter/d of 2nd spheroid
!        PHI=angle (deg) specifying relative orientation of spheroids
!        PRINAX=0. to set A1=(1,0,0),A2=(0,1,0) in Target Framee
!              =1. to set A1,A2=principal axes of largest and second
!                               largest moment of inertia
!        DX(1-3)=(dx/d,dy/d,dz/d) where dx,dy,dz=lattice spacing in x,y,z
!            directions, and d=(dx*dy*dz)**(1/3)=effective lattice spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
!        X0(1-3)=location in TF of dipole with IXYZ=0 0 0
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=1 for sites within first spheroid
!                        =2 for sites within second spheroid
!        CDESCR=description of target (up to 67 characters)

! B.T.Draine, Princeton Univ. Obs.
! History:
! 96.01.25 (BTD): First written.
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 96.01.29 (BTD): Modified to add PRINAX to argument list, and
!                 call to PRINAXIS to determine principal axes if
!                 PRINAX=1.
! 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
!                 lattice spacing.
!                 *** Note: additional code modifications required
!                     to support noncubic lattice!
! 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
!                 call ERRMSG and halt with fatal error.
! 98.03.07 (BTD): Modified to write DX to file "target.out" for
!                 compatibility with REASHP.
! 99.06.30 (BTD): Revised procedure for constructing target.
!                 With new prescription,
!                 should obtain a symmetric structure when called
!                 with A_1,B_1 = A_2,B_2 and PHI=0 or 90
!                 Note that we have not yet made modifications
!                 necessary to support noncubic lattice.
! 00.11.02 (BTD): Modified to write ICOMP to target.out
! 03.11.06 (BTD): Modified to use new PRINAXIS with eigenvalues in
!                 argument list.
! 04.03.19 (BTD): Revert to previous version of PRINAXIS
! 04.05.23 (BTD): Modify argument list of PRINAXIS to conform to
!                 change in PRINAXIS (eigenvalues added to arg list)
! 07.09.11 (BTD): Change IXYZ from INTEGER*2 to INTEGER
! 08.08.08 (BTD): Add X0(3) to argument list
!                 Add code to determine X0
! 08.08.29 (BTD): modified format 9020
! end history

! Copyright (C) 1996,1997,1998,1999,2000,2003,2004,2007,2008
!                B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Current version of TAR2SP is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TAR2SP',                              &
                     ' tar2sp does not yet support noncubic lattice')
      ENDIF

! Routine to construct target array representing two spheroids in
! contact.
! line connecting spheroid centers is parallel to x
! symmetry axis of first spheroid is parallel to y
! symmetry axis of second spheroid is in y-z plane, at angle PHI to y

! First spheroid:
! Array sites contained within spheroidal surface defined by
!    ((X-XC1)/B_1)**2+((Y-YC1)/A_1)**2+((Z-ZC1)/B_1)**2=0.25
! Ideal volume V=(pi/6)*A_1*B_1*B_1

! Second spheroid:
!    ((X-XC2)/B_2)**2+((U-UC1)/A_1)**2+((V-VC1)/B_1)**2=0.25
! where
!    U  =  Y*cos(PHI)  +  Z*sin(PHI)
!    V  = -Y*sin(PHI)  +  Z*cos(PHI)
!   UC1 = YC1*cos(PHI) + ZC1*sin(PHI)
!   VC1 =-YC1*sin(PHI) + ZC1*cos(PHI)

! Dipoles are located at sites
! (x,y,z)=(I,J,K)*d, I,J,K=integers

! Criterion for choosing XC1:
! Point where spheroids contact each other should be midway between
! lattice points.  Thus take XC1+0.5*B_1 = 0.5
! or XC1 = 0.5(1.-B_1)

! Criterion for choosing YC1 and ZC1:
! If XC1 is close to an integer, take YC1=ZC1=0
! If XC1 is close to a half-integer, take YC1=ZC1=0.5

! Note that other criteria are obviously possible.  For example,
! could have chosen YC1 and ZC1 to maximize number of lattice
! sites falling within spheroidal surfaces.

      XC1=0.5_WP*(1._WP-B_1)
      IF(XC1-INT(XC1)<0.25_WP.OR.XC1-INT(XC1)>0.75_WP)THEN
         YC1=0._WP
         ZC1=0._WP
      ELSE
         YC1=0.5_WP
         ZC1=0.5_WP
      ENDIF

      NAT=0

! Determine list of occupied sites in first spheroid

      LMX1=INT(XC1-.5_WP*B_1)
      LMX2=INT(XC1+.5_WP*B_1)
      LMY1=INT(YC1-.5_WP*A_1)
      LMY2=INT(YC1+.5_WP*A_1)
      LMZ1=INT(ZC1-.5_WP*B_1)
      LMZ2=INT(ZC1+.5_WP*B_1)
      AX2=B_1*B_1
      AY2=A_1*A_1
      AZ2=B_1*B_1
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ,KIND=WP)-ZC1
         RZ2=Z*Z/AZ2
         IF(RZ2<0.25_WP)THEN
            DO JY=LMY1,LMY2
               Y=REAL(JY,KIND=WP)-YC1
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2<0.25_WP)THEN
                  DO JX=LMX1,LMX2
                     X=REAL(JX,KIND=WP)-XC1
                     R=RYZ2+X*X/AX2
                     IF(R<0.25_WP)THEN
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO
      NAT1=NAT

! Determine occupied sites in second spheroid

      XC2=XC1+.5_WP*(B_1+B_2)
      YC2=YC1
      ZC2=ZC1
      LMX1=INT(XC2-.5_WP*B_2)
      LMX2=INT(XC2+.5_WP*B_2)

! This is not time-consuming, so no need to optimize choices of
! LMY1,LMY2,LMZ1,LMZ2

      LMY1=INT(YC1-.5_WP*MAX(A_2,B_2))
      LMY2=INT(YC1+.5_WP*MAX(A_2,B_2))
      LMZ1=INT(ZC1-.5_WP*MAX(A_2,B_2))
      LMZ2=INT(ZC1+.5_WP*MAX(A_2,B_2))
      SINPHI=SIN(3.1415927_WP*PHI/180._WP)
      COSPHI=COS(3.1415927_WP*PHI/180._WP)

! transform (y,z) -> (u,v) with u=y*cos(phi)-z*sin(phi)
!                               v=y*sin(phi)+z*cos(phi)

      DO JX=LMX1,LMX2
         X=REAL(JX,KIND=WP)-XC2
         RX2=(X/B_2)**2
         IF(RX2<0.25_WP)THEN
            DO JY=LMY1,LMY2
               Y=REAL(JY,KIND=WP)-YC2
               DO JZ=LMZ1,LMZ2
                  Z=REAL(JZ,KIND=WP)-ZC2
                  U=(COSPHI*Y-SINPHI*Z)/A_2
                  V=(SINPHI*Y+COSPHI*Z)/B_2
                  R=RX2+U**2+V**2
                  IF(R<0.25_WP)THEN
! Site is occupied:
                     NAT=NAT+1
                     IXYZ(NAT,1)=JX
                     IXYZ(NAT,2)=JY
                     IXYZ(NAT,3)=JZ
                  ENDIF
               ENDDO
            ENDDO
         ENDIF
      ENDDO
      NAT2=NAT-NAT1
      IF(NAT>MXNAT)THEN
        CALL ERRMSG('FATAL','TAR2SP',' NAT.GT.MXNAT ')
      ENDIF

      DO JX=1,3
         DO JA=1,NAT1
            ICOMP(JA,JX)=1
         ENDDO
         DO JA=NAT1+1,NAT
            ICOMP(JA,JX)=2
         ENDDO
      ENDDO

! Determine X0(1-3)=TF coordinates/d of dipole with IXYZ=0 0 0

      X0(1)=-0.5_WP
      X0(2)=-YC1
      X0(3)=-ZC1

! Specify target axes A1 and A2
! If PRINAX=0. then
!    A1=(1,0,0) in target frame
!    A2=(0,1,0) in target frame
! If PRINAX=1. then
!    A1,A2 are principal axes of largest,second largest moment of
!    inertia

      IF(PRINAX<=0._WP)THEN
         DO JX=1,3
            A1(JX)=0._WP
            A2(JX)=0._WP
         ENDDO
         A1(1)=1._WP
         A2(2)=1._WP
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      ENDIF

!***********************************************************************
! Write target description into string CDESCR

      WRITE(CDESCR,FMT='(A,I7,A,I7,A,I7,A)')' Spheroids with',NAT1,' +', &
                                            NAT2,'=',NAT,' dipoles'

!***********************************************************************

      CMSGNM=CDESCR
      CALL WRIMSG('TAR2SP',CMSGNM)
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)A_1,B_1,A_2,B_2,PHI,NAT,NAT1,NAT2,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
9020  FORMAT(' >TAR2SP: touching spheroids, A_1,B_2,A_2,B_2,PHI=',5F8.4,/, &
         3I10,' = NAT, NAT1, NAT2',/,                                       &
         3F10.6,' = A_1 vector',/,                                          &
         3F10.6,' = A_2 vector',/,                                          &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,                    &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ',          &
               'for dipole 0 0 0',/,                                       &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TAR2SP

    PROGRAM DDFIELD
! --------------------------------- v5 ----------------------------
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

      CHARACTER :: CFLPOL*80

      INTEGER*2,ALLOCATABLE :: ICOMP(:,:)

      INTEGER ::                                       &
         IANISO,JA,JAT,JD,JPY,JPYM,JPZ,JPZM,           &
         JX,JXMAX,JXMIN,JY,JYMAX,JYMIN,JZ,JZMAX,JZMIN, &
         MXNAT,MODE,NAT0,NPT,NTHREADS,NX,NY,NZ

      INTEGER,ALLOCATABLE :: IXYZ0(:,:)

      REAL(WP) ::                                           &
         AKD2,GAMMA,GAMMAKD4,CWORD,DSTORAGE,DXPHYS,         &
         FAC,KD,KDR,MB,                                     &
         PHASYZ,PHASY,PHASY1,PHASZ1,PI,PYD,PYDDX,PZD,PZDDX, &
         R,R2,R4,RANGE,RANGE2,RJPY,RWORD,STORAGE,STORAGE0,  &
         WAVE,X0,X2,X2Y2,XMAX,XMAXPHYS,XMIN,XMINPHYS,       &
         Y0,YMAX,YMAXPHYS,YMIN,YMINPHYS,                    &
         Z0,ZMAX,ZMAXPHYS,ZMIN,ZMINPHYS

      REAL(WP) :: &
         AKD(3),  &
         DR(3),   &
         DX(3),   &
         RHAT(3), &
         X(3),    &
         XX0(3)
 
      REAL(WP),ALLOCATABLE :: &
         BETADF(:),           &
         PHIDF(:),            &
         THETADF(:)

      COMPLEX(WP) :: CXFAC,CXFACB,CXFACR,CXI,CXPDOT,CXTRM

      COMPLEX(WP) :: &
         CXB(3),     &
         CXB0(3),    &
         CXE(3),     &
         CXE0(3),    &
         CXP(3)

      COMPLEX(WP),ALLOCATABLE :: &
         CXADIA(:,:),            &
         CXAOFF(:,:),            &
         CXPOL(:,:),             &
         DCXB(:,:),              &
         DCXE(:,:)

      INTEGER OMP_GET_NUM_THREADS

      DATA CXI/(0._WP,1._WP)/

!=======================================================================
!                          DDField
!
! Program DDfield takes the target polarization array output by DDSCAT,
! and calculates the electric field at arbitrary locations inside or
! outside the target.
!
! Input: file DDfield.in with list of coordinates, given as
!        x/dx(1), y/dx(2), z/dx(3)
!
!        where dx(j)=lattice spacing in direction j
!        with dx(1)*dx(2)*dx(3)=d**3
!
! Method: the electromagnetic field is calculated to be the sum of
!         the incident EM field plus the EM field generated by each 
!         dipole, and each replica dipole, with inclusion of all
!         retardation effects.
!         The EM field produced by each dipole is calculated exactly 
!         EXCEPT for the contribution of any dipole less than 1 
!         lattice spacing d away [there can be as many as 8 such
!         dipoles].
!         In case of dipoles at distance < d, the electric and
!         magnetic field contributions are suppressed by a factor
!         (r/d)^4
!         With this factor, it is found that E field remains quite
!         uniform within a uniformly polarized target, and the
!         field as one approaches each dipole site is then calculated 
!         correctly as the field due to all other dipoles.
!
!         Note: present method is adapted to compute the EM field
!         within and just outside the target.  If at large distances
!         from the target, exp(-(gamma*k*r)^4) suppression factor
!         for replica dipole contribution needs to be modified so as
!         to be small over the Fresnel zone.  This can be done by
!         suitable reduction in gamma.
! history:
! 06.09.14 (BTD) first written
! 06.09.21 (BTD) generalized to treat periodic targets
! 06.09.22 (BTD) now write out PYD,PZD to output files
! 06.10.25 (BTD) modified DDfield to use same cutoff factor
!                exp(-beta*(k*r)^4) as used by ESELF
! 07.01.21 (BTD) added output to screen giving JXMIN,JXMAX,JYMIN,JYMAX,
!                JZMIN,JZMAX
! 07.01.26 (BTD) cosmetic changes to output
!                added comments
! 07.06.21 (BTD) modify to use pol output from DDSCAT v7.0.2
!                with XX0(1-3)=location in TF of lattice site (0,0,0)
! 08.01.17 (BTD) * added IANISO to argument list of READPOL
!                * added ICOMP,BETADF,THETADF,PHIDF to READPOL argument list
!                * add MODE to argument list of READPOL
!                * modified to first call READPOL with MODE=0 to determine
!                  size of stored file; then allocate necessary memory;
!                  then call READPOL with MODE=1 to read stored
!                  polarization data.
!                * modified to write out useful information concerning
!                  target geometry
! 08.03.23 (BTD) * changed from exp(-beta*(kr)^4) to
!                  exp(-(alpha*kr)^4)
!                  read alpha from ddfield.in
! 08.04.20 (BTD) * changed notation: ALPHA -> GAMMA
!                * correction: had been mistakenly calculating suppression 
!                  factor as exp[-(gamma^2*(kr)^4)]
!                  correct this to exp[-(gamma*kr)^4]
! 08.05.21 (BTD) v7.0.6
!                * corrected typo:
!                  PHASZ1=AKD(3)*PYDDX -> PHASZ1=AKD(3)*PZDDX
! 08.08.24 (BTD) v7.0.7 release
!                v3
!                * added openmp directives for parallelization
!                * to support openmp, changed DCXB(JD) -> DCXB(JD,JA)
!                * to optimize memory access, changed 
!                  DCXE(JA,JD) -> DCXE(JD,JA)
!                * added xmin,xmax,ymin,ymax,zmin,zmax to output field 
!                  ddfield.E and ddfield.B
! 08.08.26 (BTD) * moved DX(1) into parallel region so that each thread
!                  will know DX(1)
! 08.08.27 (BTD) * changed power-law from (r/d)^{4.5} to (r/d)^4
!                  in factor suppressing contribution of dipoles within
!                  distance d.  This choice was based on comparison of
!                  field along track1 and track2 for an infinite slab
!                  with m=1.5+0.02i, h/lambda=0.2, illuminated by light
!                  with incidence angle theta_i=40deg (this is the case
!                  used as illustration in Draine & Flatau 2008)
! 08.08.29 (BTD) * added xmin/d, ... zmax/d and dphys to output
! 08.11.05 (BTD) * added missing "THEN" to statement
!                  IF(NPT.EQ.1)THEN
!                  error reported by Gouraya Gourmi-Said 
!                  (Laboratorie de Physique du Solide,
!                   Facultés Universitaires Notre-Dame de la Paix,
!                   Namur, Belgium)
! 09.04.10 (BTD) v5 
!                * modified to keep spaces between output columns of 
!                  ddfield.E and ddfield.B even when one of the dipole 
!                  locations/d is smaller than -100, or one of the 
!                  E or B components is smaller than -10.
! 09.07.08 (BTD) v5 
!                * corrected typo reported by Shuzhou Li in evaluation 
!                  of XMIN and XMINPHYS (output describing spatial 
!                  extent of target)
! end history

! Copyright (C) 2006,2007,2008,2009
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!=======================================================================

      PI=4._WP*ATAN(1._WP)

! for storage computations:

      MB=REAL(1024**2)
      IF(WP==KIND(0.E0))THEN
         RWORD=4._WP
         CWORD=2._WP*RWORD
         STORAGE0=6.79
      ELSEIF(WP==KIND(0.D0))THEN
         RWORD=8._WP
         CWORD=2._WP*RWORD
         STORAGE0=6.794
      ELSE
         WRITE(0,*)'Fatal error in DDfield: unable to determine word length'
         STOP
      ENDIF
      STORAGE=STORAGE0

! Input control file:

      OPEN(UNIT=3,FILE='ddfield.in')

! Output files:

      OPEN(UNIT=7,FILE='ddfield.E')
      OPEN(UNIT=8,FILE='ddfield.B')

! Read name of file containing stored polarization information:

! Preliminary allocation

      MXNAT=1
      ALLOCATE(ICOMP(MXNAT,3))
      ALLOCATE(IXYZ0(MXNAT,3))
      ALLOCATE(BETADF(MXNAT))
      ALLOCATE(THETADF(MXNAT))
      ALLOCATE(PHIDF(MXNAT))
      ALLOCATE(CXADIA(MXNAT,3))
      ALLOCATE(CXAOFF(MXNAT,3))
      ALLOCATE(CXPOL(MXNAT,3))

      READ(3,*)CFLPOL
      READ(3,*)GAMMA
      IF(GAMMA>0.1_WP.OR.GAMMA<1.E-4_WP)THEN
         WRITE(0,FMT='(A,1PE10.3,A)')'GAMMA=',GAMMA,                &
                                     ' is unusual: is this intended?'
      ENDIF
!*** diagnostic
!      write(0,*)'ddfield ckpt 1: cflpol=',cflpol
!***
      MODE=0
      CALL READPOL(MODE,MXNAT,NX,NY,NZ,NAT0,IANISO,ICOMP,IXYZ0,PYD,PZD,AKD,   &
                   DX,XX0,WAVE,BETADF,THETADF,PHIDF,CXE0,CXADIA,CXAOFF,CXPOL, &
                   CFLPOL)

!*** diagnostic
      write(0,*)'ddfield ckpt 2: returned from readpol with nat0=',nat0
!***
! Now allocate necessary storage:

      DEALLOCATE(ICOMP)
      DEALLOCATE(IXYZ0)
      DEALLOCATE(CXADIA)
      DEALLOCATE(CXAOFF)
      DEALLOCATE(CXPOL)

      MXNAT=NAT0
      STORAGE=STORAGE0

      DSTORAGE=REAL(2*3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6605)DSTORAGE,STORAGE
      ALLOCATE(ICOMP(MXNAT,3))

      DSTORAGE=REAL(4*3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6610)DSTORAGE,STORAGE
      ALLOCATE(IXYZ0(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6620)DSTORAGE,STORAGE
      ALLOCATE(CXADIA(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6630)DSTORAGE,STORAGE
      ALLOCATE(CXAOFF(MXNAT,3))

      DSTORAGE=CWORD*REAL(3*MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6640)DSTORAGE,STORAGE
      ALLOCATE(CXPOL(MXNAT,3))

      DEALLOCATE(BETADF)
      DEALLOCATE(THETADF)
      DEALLOCATE(PHIDF)

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6660)DSTORAGE,STORAGE
      ALLOCATE(BETADF(MXNAT))

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6660)DSTORAGE,STORAGE
      ALLOCATE(THETADF(MXNAT))

      DSTORAGE=RWORD*REAL(MXNAT)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6660)DSTORAGE,STORAGE
      ALLOCATE(PHIDF(MXNAT))

      MODE=1
      CALL READPOL(MODE,MXNAT,NX,NY,NZ,NAT0,IANISO,ICOMP,IXYZ0,PYD,PZD,AKD,   &
                   DX,XX0,WAVE,BETADF,THETADF,PHIDF,CXE0,CXADIA,CXAOFF,CXPOL, &
                   CFLPOL)

!*** diagnostic
!      write(0,*)'ddfield ckpt 3'
!      write(0,*)' ja  jx  jy  jz'
!      do j=1,nat0
!         write(0,9711)j,ixyz0(j,1),ixyz0(j,2),ixyz0(j,3)
!      enddo
! 9711 format(i3,3i4)
!      write(0,9712)xx0
! 9712 format('x0=',3f14.6)
!****

      DSTORAGE=CWORD*REAL(3*NAT0)/MB
      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6650)DSTORAGE,STORAGE
      ALLOCATE(DCXB(3,NAT0))

      STORAGE=STORAGE+DSTORAGE
      WRITE(0,6655)DSTORAGE,STORAGE
      ALLOCATE(DCXE(3,NAT0))

! Check target dimensions

!*** diagnostic
!      write(0,*)'ddfield ckpt 4, nat0=',nat0
!      write(0,*)' ja  jx  jy  jz'
!      do ja=1,nat0
!         write(0,9711)ja,ixyz0(ja,1),ixyz0(ja,2),ixyz0(ja,3)
!      enddo
! 9711 format(i6,3i4)
!*** end diagnostic

      JXMIN=IXYZ0(1,1)
      JYMIN=IXYZ0(1,2)
      JZMIN=IXYZ0(1,3)
      JXMAX=JXMIN
      JYMAX=JYMIN
      JZMAX=JZMIN
      DO JA=2,NAT0
         JX=IXYZ0(JA,1)
         JY=IXYZ0(JA,2)
         JZ=IXYZ0(JA,3)
         IF(JX.LT.JXMIN)JXMIN=JX
         IF(JX.GT.JXMAX)JXMAX=JX
         IF(JY.LT.JYMIN)JYMIN=JY
         IF(JY.GT.JYMAX)JYMAX=JY
         IF(JZ.LT.JZMIN)JZMIN=JZ
         IF(JZ.GT.JZMAX)JZMAX=JZ
      ENDDO

      AKD2=0.
      DO JD=1,3
         AKD2=AKD2+AKD(JD)**2
      ENDDO
      KD=SQRT(AKD2)

! KD = k*d

      DXPHYS=KD*WAVE/(2._WP*PI)

! Evaluate extreme dipole locations in physical units
! 2009.07.08 (BTD) corrected typo (reported by Shuzhou Li) in following line:
!      XMIN=(REAL(JXMIN)*XX0(1)-0.5_WP)
      XMIN=(REAL(JXMIN)+XX0(1)-0.5_WP)
!-------------------------------------
      XMAX=(REAL(JXMAX)+XX0(1)+0.5_WP)
      YMIN=(REAL(JYMIN)+XX0(2)-0.5_WP)
      YMAX=(REAL(JYMAX)+XX0(2)+0.5_WP)
      ZMIN=(REAL(JZMIN)+XX0(3)-0.5_WP)
      ZMAX=(REAL(JZMAX)+XX0(3)+0.5_WP)

      XMINPHYS=XMIN*DXPHYS*DX(1)
      XMAXPHYS=XMAX*DXPHYS*DX(1)
      YMINPHYS=YMIN*DXPHYS*DX(2)
      YMAXPHYS=YMAX*DXPHYS*DX(2)
      ZMINPHYS=ZMIN*DXPHYS*DX(3)
      ZMAXPHYS=ZMAX*DXPHYS*DX(3)

      WRITE(0,9030)XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,                      &
                   XMINPHYS,XMAXPHYS,YMINPHYS,YMAXPHYS,ZMINPHYS,ZMAXPHYS

! Calculate incident B field at origin in TF:

      CXB0(1)=(AKD(2)*CXE0(3)-AKD(3)*CXE0(2))/KD
      CXB0(2)=(AKD(3)*CXE0(1)-AKD(1)*CXE0(3))/KD
      CXB0(3)=(AKD(1)*CXE0(2)-AKD(2)*CXE0(1))/KD

      WRITE(0,7001)NAT0,JXMIN,JXMAX,JYMIN,JYMAX,JZMIN,JZMAX, &
                   XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,            &
                   XMINPHYS,XMAXPHYS,YMINPHYS,YMAXPHYS,      &
                   ZMINPHYS,ZMAXPHYS,DXPHYS,PYD,PZD,         &
                   (PYD*DXPHYS*DX(2)),(PZD*DXPHYS*DX(3)),    &
                   WAVE,AKD,GAMMA
      WRITE(0,7002)CXE0
      WRITE(7,7001)NAT0,JXMIN,JXMAX,JYMIN,JYMAX,JZMIN,JZMAX, &
                   XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,            &
                   XMINPHYS,XMAXPHYS,YMINPHYS,YMAXPHYS,      &
                   ZMINPHYS,ZMAXPHYS,DXPHYS,PYD,PZD,         &
                   (PYD*DXPHYS*DX(2)),(PZD*DXPHYS*DX(3)),    &
                   WAVE,AKD,GAMMA
      WRITE(7,7002)CXE0
      WRITE(8,7001)NAT0,JXMIN,JXMAX,JYMIN,JYMAX,JZMIN,JZMAX, &
                   XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX,            &
                   XMINPHYS,XMAXPHYS,YMINPHYS,YMAXPHYS,      &
                   ZMINPHYS,ZMAXPHYS,DXPHYS,PYD,PZD,         &
                   (PYD*DXPHYS*DX(2)),(PZD*DXPHYS*DX(3)),    &
                   WAVE,AKD,GAMMA
      WRITE(8,8002)CXB0

! Calculate range in JY and JZ required for convergence if PBC is used.

      PYDDX=PYD*DX(2)
      PZDDX=PZD*DX(3)
      GAMMAKD4=(GAMMA*GAMMA*AKD2)**2
      RANGE=2./(GAMMAKD4**0.25_WP)
      RANGE2=RANGE*RANGE
      IF(PYDDX.LE.0._WP)THEN
         JPYM=0
      ELSE
         JPYM=1+NINT(RANGE/PYDDX)
      ENDIF
      NPT=0
 1000 READ(3,*,END=9000,ERR=9000)X(1),X(2),X(3)
      NPT=NPT+1
      WRITE(0,6100)X

! Compute E and B fields at X
! DCXB(JD,JA) = component JD of B field at X 
!               contributed by dipole JA (and replicas).
! DCXE(JD,JA) = component JD of E field at X 
!               contributed by dipole JA (and replicas).

!*** diagnostic
!      write(0,*)'ddfield ckpt 5'
!***
      DO JA=1,NAT0
         DO JD=1,3
            DCXB(JD,JA)=0._WP
            DCXE(JD,JA)=0._WP
         ENDDO
      ENDDO

!*** diagnostic
!      write(0,*)'ddfield ckpt 6'
!***

      PHASY1=AKD(2)*PYDDX
      PHASZ1=AKD(3)*PZDDX

      JAT=0

! parallelize summation over replicas

#ifdef openmp

      IF(NPT.EQ.1)THEN
         NTHREADS=4
         WRITE(0,*)'ddfield ckpt 4, call OMP_SET_NUM_THREADS with NTHREADS=', &
                    NTHREADS 
         CALL OMP_SET_NUM_THREADS(NTHREADS)
      ENDIF

!$omp parallel do                                              &
!$omp&   private(jd,jpy,jpz,jpzm)                              &
!$omp&   private(dr,fac,kdr,phasy,phasyz,r,r2,rhat,rjpy,x0,x2,x2y2,y0,z0)  &
!$omp&   private(cxfac,cxfacb,cxfacr,cxp,cxpdot,cxtrm)
         
#endif

      DO JA=1,NAT0

#ifdef openmp
         IF(JA.EQ.1.AND.NPT.EQ.1)THEN
            NTHREADS=OMP_GET_NUM_THREADS()
            WRITE(0,*)'number of openmp threads=',NTHREADS
         ENDIF
#endif

         X0=X(1)-(REAL(IXYZ0(JA,1))+XX0(1))*DX(1)
         Y0=X(2)-(REAL(IXYZ0(JA,2))+XX0(2))*DX(2)
         Z0=X(3)-(REAL(IXYZ0(JA,3))+XX0(3))*DX(3)

! (X0,Y0,Z0)*d = r - r_j00

         DR(1)=X0
         X2=X0**2

! calculate E and B at location r

         DO JD=1,3
            CXP(JD)=CXPOL(JA,JD)
         ENDDO

!*** diagnostic
!      write(0,*)'ddfield ckpt 7'
!***

         DO JPY=-JPYM,JPYM

            PHASY=PHASY1*REAL(JPY)
            RJPY=REAL(JPY)*PYDDX
            IF(PZD.LE.0._WP)THEN
               JPZM=0
            ELSE
               JPZM=1+NINT(SQRT(MAX(RANGE2-RJPY**2,0._WP))/PZDDX)
            ENDIF
            DR(2)=Y0-REAL(JPY)*PYDDX
            X2Y2=X2+DR(2)**2
            DO JPZ=-JPZM,JPZM
               PHASYZ=PHASY+PHASZ1*REAL(JPZ)
               DR(3)=Z0-REAL(JPZ)*PZDDX
               R2=X2Y2+DR(3)**2
               IF(R2.LT.1.E-10_WP)THEN
                  JAT=JA
               ELSE
                  R=SQRT(R2)
                  R4=R2*R2
                  FAC=EXP(-GAMMAKD4*R4)
                  IF(R.LT.1._WP)FAC=FAC*R4
                  KDR=KD*R

! compute RHAT = (r - r_ja)/|r-r_ja|
! compute CXPDOT = P_ja dot rhat

                  CXPDOT=0.
                  DO JD=1,3
                     RHAT(JD)=DR(JD)/R
                     CXPDOT=CXPDOT+CXP(JD)*RHAT(JD)
                  ENDDO
                  CXFAC=FAC*EXP(CXI*(KDR+PHASYZ))
                  CXFACR=CXFAC/R
                  CXTRM=(CXI*KDR-1._WP)/KDR**2
                  CXFACB=CXFAC*CXTRM

! compute DCXE(JD,JA) = component JD of E field contributed by dipole JA

                  DO JD=1,3
                     DCXE(JD,JA)=DCXE(JD,JA)+                         &
                                 CXFACR*(CXP(JD)-RHAT(JD)*CXPDOT+     &
                                 CXTRM*(CXP(JD)-3._WP*RHAT(JD)*CXPDOT))
                  ENDDO
                  DCXB(1,JA)=DCXB(1,JA)+CXFACB*(CXP(2)*RHAT(3)-CXP(3)*RHAT(2))
                  DCXB(2,JA)=DCXB(2,JA)+CXFACB*(CXP(3)*RHAT(1)-CXP(1)*RHAT(3))
                  DCXB(3,JA)=DCXB(3,JA)+CXFACB*(CXP(1)*RHAT(2)-CXP(2)*RHAT(1))

               ENDIF   ! endif(r2.lt.1e-10)
            ENDDO   ! enddo jpz=-jpzm,jpzm
         ENDDO   ! enddo jpy=-jpym,jpzm
      ENDDO   ! enddo ja=1,nat0

#ifdef openmp
!$omp end parallel do
#endif

!*** diagnostic
!      write(0,*)'ddfield ckpt 8'
!***

      DO JD=1,3
         CXB(JD)=0._WP
         CXE(JD)=0._WP
      ENDDO

      DO JA=1,NAT0
         DO JD=1,3
            CXB(JD)=CXB(JD)+DCXB(JD,JA)
            CXE(JD)=CXE(JD)+DCXE(JD,JA)
         ENDDO
      ENDDO
      DO JD=1,3
         CXE(JD)=CXE(JD)*KD**2
         CXB(JD)=CXB(JD)*CXI*KD**3
      ENDDO

! add incident E and B fields

      KDR=AKD(1)*X(1)+AKD(2)*X(2)+AKD(3)*X(3)

      CXFAC=EXP(CXI*KDR)
      DO JD=1,3
         CXE(JD)=CXE(JD)+CXE0(JD)*CXFAC
         CXB(JD)=CXB(JD)+CXB0(JD)*CXFAC
      ENDDO

! under most conditions, the components of E will have magnitudes
! < 10, and the formatting provided by statement 7100 will assure that
! the numbers in the output will be separated by whitespace
! In the unusual event that the components of E become large enough
! (and negative) that whitespace is will be missing between one or more
! of the output columns, instead use statement 7110

! determine formatting requirements for X
! IXDGT = number of spaces to left of decimal point
!      IXDGT=3
!      IF(X(1)<0._WP
! changes yet to be made

      IF(X(1)>-100._WP.AND.X(2)>-100._WP.AND.X(3)>-100._WP)THEN
         IF(REAL(CXE(1))>-10._WP.AND.IMAG(CXE(1))>-10._WP.AND. &
            REAL(CXE(2))>-10._WP.AND.IMAG(CXE(2))>-10._WP.AND. &
            REAL(CXE(3))>-10._WP.AND.IMAG(CXE(3))>-10._WP)THEN
            WRITE(0,7100)X,CXE
            WRITE(7,7100)X,CXE
         ELSE
            WRITE(0,7110)X,CXE
            WRITE(7,7110)X,CXE
         ENDIF
         IF(REAL(CXB(1))>-10._WP.AND.IMAG(CXB(1))>-10._WP.AND. &
            REAL(CXB(2))>-10._WP.AND.IMAG(CXB(2))>-10._WP.AND. &
            REAL(CXB(3))>-10._WP.AND.IMAG(CXB(3))>-10._WP)THEN
            WRITE(8,7100)X,CXB
         ELSE
            WRITE(8,7110)X,CXB
         ENDIF
      ELSE
         IF(REAL(CXE(1))>-10._WP.AND.IMAG(CXE(1))>-10._WP.AND. &
            REAL(CXE(2))>-10._WP.AND.IMAG(CXE(2))>-10._WP.AND. &
            REAL(CXE(3))>-10._WP.AND.IMAG(CXE(3))>-10._WP)THEN
            WRITE(0,7102)X,CXE
            WRITE(7,7102)X,CXE
         ELSE
            WRITE(0,7112)X,CXE
            WRITE(7,7112)X,CXE
         ENDIF
         IF(REAL(CXB(1))>-10._WP.AND.IMAG(CXB(1))>-10._WP.AND. &
            REAL(CXB(2))>-10._WP.AND.IMAG(CXB(2))>-10._WP.AND. &
            REAL(CXB(3))>-10._WP.AND.IMAG(CXB(3))>-10._WP)THEN
            WRITE(8,7102)X,CXB
         ELSE
            WRITE(8,7112)X,CXB
         ENDIF
      ENDIF

!-----------------------------------------------------------------------

      IF(JAT.GT.0)THEN
         DO JD=1,3
            DCXE(JD,JAT)=CXPOL(JAT,JD)*CXADIA(JAT,JD)-CXE(JD)
         ENDDO
         WRITE(0,7900)DCXE(1,1),DCXE(2,1),DCXE(3,1)
      ENDIF
      GOTO 1000
!-----------------------------------------------------------------------
 9000 CLOSE(7)
      STOP
 6100 FORMAT(3F9.4)
 6605 FORMAT('allocating',F8.3,' MB for ICOMP ; total=',F10.3,' MB')
 6610 FORMAT('allocating',F8.3,' MB for IXYZ0 ; total=',F10.3,' MB')
 6620 FORMAT('allocating',F8.3,' MB for CXADIA; total=',F10.3,' MB')
 6630 FORMAT('allocating',F8.3,' MB for CXAOFF; total=',F10.3,' MB')
 6640 FORMAT('allocating',F8.3,' MB for CXPOL ; total=',F10.3,' MB')
 6650 FORMAT('allocating',F8.3,' MB for DCXB  ; total=',F10.3,' MB')
 6655 FORMAT('allocating',F8.3,' MB for DCXE  ; total=',F10.3,' MB')
 6660 FORMAT('allocating',F8.3,' MB for BETADF; total=',F10.3,' MB')
 6670 FORMAT('allocating',F8.3,' MB for THETADF;total=',F10.3,' MB')
 6680 FORMAT('allocating',F8.3,' MB for PHIDF;  total=',F10.3,' MB')
 7001 FORMAT(I10,' = number of dipoles in Target',/,                 &
             'Extent of occupied lattice sites',/,                   &
             2I8,' = JXMIN,JXMAX',/,                                 &
             2I8,' = JYMIN,JYMAX',/,                                 &
             2I8,' = JZMIN,JZMAX',/,                                 &
             2F12.6,' = (x_TF/d)min,(x_TF/d)max',/,                  &
             2F12.6,' = (y_TF/d)min,(y_TF/d)max',/,                  &
             2F12.6,' = (z_TF/d)min,(z_TF/d)max',/,                  &
             2F12.6,' = xmin(TF),xmax(TF) (phys. units)',/,          &
             2F12.6,' = ymin(TF),ymax(TF) (phys. units)',/,          &
             2F12.6,' = zmin(TF),zmax(TF) (phys. units)',/,          &
             F12.6,' = d (phys units)',/,                            &
             2F12.6,' = PYD,PZD = period_y/dy, period_z/dz',/,       &
             2F12.6,' = period_y, period_z (phys. units)',/,         &  
             F12.6,' = wavelength in ambient medium (phys units)',/, &
             F12.6,' = k_x*d for incident wave',/,                   &
             F12.6,' = k_y*d for incident wave',/,                   &
             F12.6,' = k_z*d for incident wave',/,                   &
             1PE10.3,' = gamma (parameter for summation cutoff)')
 7002 FORMAT(0PF10.6,0PF10.6,' = (Re,Im)E_inc,x(0,0,0)',/,             &
             0PF10.6,0PF10.6,' = (Re,Im)E_inc,y(0,0,0)',/,             &
             0PF10.6,0PF10.6,' = (Re,Im)E_inc,z(0,0,0)',/,             &
             4X,'x/d',6X,'y/d',6X,'z/d',5X,'----- E_x -----',          &
             3X,'----- E_y ------',3X,'----- E_z -----')
 7100 FORMAT(3F9.4,      &
             F9.5,F9.5,  &
             F10.5,F9.5, &
             F10.5,F9.5)
 7102 FORMAT(3F9.3,      &
             F9.5,F9.5,  &
             F10.5,F9.5, &
             F10.5,F9.5)
 7110 FORMAT(3F9.4,      &
             F9.4,F9.4,  &
             F10.4,F9.4, &
             F10.4,F9.4)
 7112 FORMAT(3F9.3,      &
             F9.4,F9.4,  &
             F10.4,F9.4, &
             F10.4,F9.4)
 7900 FORMAT('  err(E_x)=(',F10.5,',',F10.5,') ', &
               'err(E_y)=(',F10.5,',',F10.5,') ', &
               'err(E_z)=(',F10.5,',',F10.5,')')
 8002 FORMAT(0PF10.6,0PF10.6,' = (Re,Im)B_inc,x(0,0,0)',/,                 &
             0PF10.6,0PF10.6,' = (Re,Im)B_inc,y(0,0,0)',/,                 &
             0PF10.6,0PF10.6,' = (Re,Im)B_inc,z(0,0,0)',/,                 &
             4X,'x/d',6X,'y/d',6X,'z/d',5X,'----- B_x -----',              &
             3X,'----- B_y ------',3X,'----- B_z -----')
 9030 FORMAT('---------- physical extent in TF of target volume ---------',/, &
             2F14.6,' = (x_TF/d)min, (x_TF/d)max',/,                          &
             2F14.6,' = (y_TF/d)min, (y_TF/d)max',/,                          &
             2F14.6,' = (z_TF/d)min, (z_TF/d)max',/,                          &
             2F14.6,' = (x_TF)min,(x_TF)max (physical units)',/,              &
             2F14.6,' = (y_TF)min,(y_TF)max (physical units)',/,              &
             2F14.6,' = (z_TF)min,(z_TF)max (physical units)')
      END PROGRAM DDFIELD

    SUBROUTINE ALPHADIAG(AKR,BETADF,PHIDF,THETADF,CALPHA,CXALPH,CXALOF,      &
                         CXALOS,CXE0R,CXEPS,CXSC,CXSCR1,CXZC,CXZW,DX,IBETH,  &
                         IBETH1,ICOMP,IOCC,IPBC,IPHI,IPHI1,IXYZ0,JORTH,MYID, &
                         MXCOMP,MXNAT,MXN3,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ,     &
                         CXRLOC,CSHAPE,SHPAR)
      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_8,ONLY : CMDFFT
      IMPLICIT NONE

!*** Arguments:

      CHARACTER(6) :: CALPHA
      CHARACTER(9) :: CSHAPE
      INTEGER :: IBETH,IBETH1,IPBC,IPHI,IPHI1,JORTH,MXCOMP,MXNAT,MXN3, &
         MYID,NAT,NAT0,NAT3,NCOMP,NX,NY,NZ
      COMPLEX(WP) ::                                                 &
         CXALOF(NAT,3),                                              &
         CXALPH(NAT,3),                                              &
         CXE0R(3),                                                   &
         CXEPS(MXCOMP),                                              &
         CXALOS(NAT,3),                                              &
         CXSC(NAT,3,3),                                              &
         CXSCR1(NAT,3),                                              &
         CXZC(NX+1+IPBC*(NX-1),NY+1+IPBC*(NY-1),NZ+1+IPBC*(NZ-1),6), &
         CXZW(2*NX,2*NY,2*NZ,3),                                     &
         CXRLOC(MXCOMP+1,3,3)
      INTEGER*2 ::     & 
         ICOMP(NAT,3), &
         IOCC(NAT)
      INTEGER :: &
         IXYZ0(NAT0,3)
      REAL(WP) ::       &
         AKR(3),        &
         BETADF(MXNAT), &
         DX(3),         &
         PHIDF(MXNAT),  &
         SHPAR(12),     &
         THETADF(MXNAT)

!*** Local Variables:

      LOGICAL :: INIT
      CHARACTER :: CMSGNM*70
      INTEGER :: IA,IC,IC2,IC3,L
      REAL(WP) :: AK1,AK2,B1,B2,B3,B3L,COSBE,COSPH,COSTH,EMKD,PI, &
                  SINBE,SINPH,SINTH,SUM
      REAL(WP) :: &
         R(3,3),  &
         RI(3,3)
      COMPLEX(WP) :: CXI,CXRR,CXSUM1,CXSUM2,CXSUM3,CXSUM4,CXSUM5, &
         CXSUM6,CXTERM

!*** Common:

!      CHARACTER(6) :: CMETHD
!-----------------------------------------------------------------------
!      COMMON /M8/CMETHD
!-----------------------------------------------------------------------

      SAVE INIT,CXI,PI
      DATA CXI/(0._WP,1._WP)/
      DATA INIT/.TRUE./

!***********************************************************************
! Given:
!       AKR(1-3)=(kx,ky,kz)*d, where d=effective lattice spacing
!       BETADF(1-NAT)
!       PHIDF(1-NAT)
!       THETADF(1-NAT): orientation angles beta,phi,theta (radians)
!                       specifying orientation of "Dielectric Frame" (DF
!                       relative to the "Target Frame" (TF)

!       CALPHA = 'LATTDR' or 'SCLDR' = polarizability prescription
!       CMETHD = determines 3-d FFT routine used by ESELF
!       CSHAPE = descriptor of target shape
!       CXE0R(1-3) = polarization vector in lattice coordinates
!                    (assumed to be normalized)
!       CXEPS(1-NCOMP)=distinct values of dielectric constant
!       CXSC(1-NAT,1-3,1-3) = complex scratch space for SCLDR calculatio
!       CXSCR1(1-NAT,1-3)   = complex scratch space for SCLDR calculatio
!       CXZC = complex scratch space needed by ESELF
!       CXZW = complex scratch space needed by ESELF
!       DX(1-3)=(dx/d,dy/d,dz/d), where dx,dy,dz=lattice spacings in
!               x,y,z directions, and d=(dx*dy*dz)**(1/3)
!       IBETH= MYID+IBETH1 if first time through combined BETA/THETA
!              orientation loop
!       IBETH1=starting value of IBETH (see above)
!       ICOMP(1-NAT3)=composition identifier for each lattice site and
!                     direction (ICOMP=0 if lattice site is unoccupied)
!                storage scheme:
!                1x,2x,...,NATx,1y,2y,...,NATy,1z,2z,...,NATz
!       IOCC(1-NAT) == 0 if site unoccupied
!                   == 1 if site occupied
!       IPHI = IPHI1 if first time through PHI orientation loop
!       IPHI1= starting value of IPHI (see above)
!       JORTH= 1 if first incident polarization state
!       MXCOMP = dimensioning information
!       MXN3 = dimensioning information
!       MYID = parallel process identifier (=0 if only 1 process)
!       NAT  = number of sites in extended target (incl. vacuum sites)
!       NAT3 = 3*number of sites in extended target (incl. vacuum sites)
!       NCOMP= number of different dielectric tensor elements in target
!       NX   = x-dimension of extended target
!       NY   = y-dimension of extended target
!       NZ   = z-dimension of extended target
!       SHPAR(1-10)=target shape parameters

! Returns:
!       CXALPH(J,1-3)=(alpha_11,alpha_22,alpha_33)/d^3 for dipole J=1-NA
!                     where alpha_ij=complex polarizability tensor.
!       CXALOF(J,1-3)=(alpha_23,alpha_31,alpha_12)/d^3 for dipole J=1-NA

!***
! If CALPHA = LATTDR:
!    Compute dipole polarizability using "Lattice Dispersion Relation"
!    of Draine & Goodman (1993,ApJ,March 10).  It is required that
!    polarizability be such that an infinite lattice of such dipoles
!    reproduce the continuum dispersion relation for radiation
!    propagating with direction and polarization of radiation incident
!    on the DDA target.

! If CALPHA = GKDLDR:
!    Compute dipole polarizability using "Lattice Dispersion Relation"
!    of Gutkowicz-Krusin and Draine (2004)..  It is required that
!    polarizability be such that an infinite lattice of such dipoles
!    reproduce the continuum dispersion relation for radiation
!    propagating with direction and polarization of radiation incident
!    on the DDA target.  This is the recommended option.  It is nearly
!    but not exactly identical to LATTDR.

!***
!    Note: CXALPH = polarizability/d^3
!    In the event that ICOMP=0, then we set CXALPH=1.
!***********************************************************************
! B.T.Draine, Princeton Univ. Obs.
! History:
! 90.09.13 (BTD): Corrected error in DO loop limit.
! 90.11.01 (BTD): Special treatment for "vacuum" sites in order
!                 to allow FFT treatment.
! 90.11.02 (BTD): Set CXALPH=(1.,0.) at vacuum sites.
! 91.04.30 (BTD): Modified to include both O[(kd)^2] correction term
!                 from Goedecke & Obrien (1988) in addition to
!                 radiative reaction correction.
! 91.05.07 (BTD): Modified to allow easy choice among three methods
!                 for computing polarizability.
! 91.05.07 (BTD): Added call to WRIMSG to record which method in use
! 91.05.08 (BTD): Added CALPHA to argument list.
! 91.05.09 (BTD): Added printing of kd and magnitude of correction
!                 terms.
! 91.05.13 (BTD): Experiment with use of approximate directional
!                 average for coefficient of CXEPS in Lattice
!                 Disperision Relation theory
! 91.05.13 (BTD): Corrected error in radiative reaction correction
!                 (error presumably introduced during last week)
! 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
! 91.05.15 (BTD): Added option LDR000 to omit CXEPS-dependent
!                 correction term
! 91.05.30 (BTD): Changed LDRXYZ -> LDR100
!                 Added option LDR111
! 91.09.12 (BTD): Corrected error in numerical coefficient for
!                 LDRAVG case
! 91.09.17 (BTD): Eliminate options LDR000,LDRXYZ,LDRAVG
!                 Introduce option LATTDR (LATTice Dispersion Relation)
!                 which includes explicit dependence
!                 on direction and polarization state
!                 remove AK1 from argument list
!                 add AKR, CXE0R to argument list
! 92.05.14 (BTD): Introduce option LDRISO to experiment with
!                 using average directional correction term
!                 rather than using correction for incident direction
!                 and polarization
! 92.05.16 (BTD): Correct error in LDRISO option: average SUM should be
!                 3/15 rather than 4/15
! 97.11.02 (BTD): Add DX to argument list to allow use with noncubic
!                 lattices (additional modifications still required!!)
! 97.12.26 (BTD): Add CXALOF to argument list to allow use with noncubic
!                 lattices (additional modifications still required).
! 97.12.30 (BTD): Add code to evaluate alpha for noncubic case,
!                 using subroutine NONCUBIC to evaluate the lattice
!                 sums R0,R1,R2,R3
! 98.01.14 (BTD): Change sign of radiative reaction correction term.
! 98.01.19 (BTD): Change treatment of R_1,C3, and C4
!                 and output value of C4
!                 temporary modification to allow value of C4 to be
!                 read in from file 'alpha.par'
! 98.01.22 (BTD): Minor change in computation of radiative reaction
!                 correction.
! 98.03.10 (BTD): set C4=-C3, disable reading C4 from 'alpha.par'
! 98.04.27 (BTD): declared IC1,IC2,IC3 as integers.
! 99.02.09 (BTD): experiment with change in expression used to calculate
!                 off-diagonal elements of polarizability tensor
!                 experiment with C4=-C3-R1 to "cancel" the contribution
!                 of R1 to the off-diagonal terms
! 03.01.29 (BTD): remove code to calculate alpha for noncubic lattice
!                 (hold for release in future version)
! 04.02.26 (BTD): add new option 'GKDLDR' to use Gutkowicz-Krusin
!                 and Draine (2004) lattice dispersion relation
! 04.03.31 (BTD): replace WRITE(0,... with CALL WRIMSG(...
! 04.04.01 (BTD): added DUM13,DUM14 to COMMON/M6/ to accomodate use of
!                 COMMON/M6/ in communicating NPY,NPZ to subroutineS
!                 MATVEC and CMATVEC
! 04.05.21 (BTD): cleanup -- eliminated a number of unused local
!                 variables
! 04.09.14 (BTD): modify to allow target to be made of anisotropic
!                 material with arbitrary orientation, with microcrystal
!                 orientation at each lattice site specified by angles
!                 BETADF,PHIDF,THETADF giving orientation of Dielectric
!                 Frame relative to Target Frame
! 05.06.16 (BTD): Changed DUM13,DUM14 in COMMON/M6/ from integer to real
! 06.09.28 (BTD): *** Version 6.2.3 ***
!                 Note: CXZC is not used at all by alpha and could be
!                 deleted from the argument list!
! 06.09.29 (BTD): Added IPBC to argument list
!                 Modified dimensioning of CXZC when IPBC=1
!                 Note: CXZC and CXSC do not appear to be used at
!                 present. Nevertheless, keep CXZC and CXSC in argument
!                 list in case complex scratch space is needed in some
!                 future version of ALPHA
! 07.06.30 (BTD): moved CMDFFT from COMMON/M6/... CMDFFT
!                 to COMMON/M8/CMDFFT
!                 COMMON/M6/ deleted -- no longer needed by alpha
! 07.08.04 (BTD): Version 7.0.3
!                 * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
! 07.09.11 (BTD): Changed IXYZ0 from INTEGER*2 to INTEGER
! 07.10.27 (BTD): Changed SHPAR(6) -> SHPAR(10)
! 08.02.17 (BTD): Changed SHPAR(10) -> SHPAR(12)
! 08.03.11 (BTD): v7.0.5
!                 renamed SUBROUTINE ALPHA -> SUBROUTINE ALPHADIAG
! 08.03.14 (BTD): corrected dimensioning
!                 IXYZ0(MXNAT,3) -> IXYZ0(NAT0,3)
!                 BETADF(MXNAT)  -> BETADF(NAT0)
!                 PHIDF(MXNAT)   -> PHIDF(NAT0)
!                 THETADF(MXNAT) -> THETADF(NAT0)
! 08.07.27 (BTD): corrected dimensioning
!                 BETADF(NAT0)  -> BETADF(MXNAT)
!                 PHIDF(NAT0)   -> PHIDF(MXNAT)
!                 THETADF(NAT0) -> THETADF(MXNAT)
!                 eliminated variable CXALDS from argument list
! end history
! Copyright (C) 1993,1996,1997,1998,1999,2003,2004,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

!*** diagnostic
!      write(0,*)'alphadiag ckpt 1'
!***

      PI=4._WP*ATAN(1._WP)
      AK2=AKR(1)*AKR(1)+AKR(2)*AKR(2)+AKR(3)*AKR(3)
      AK1=SQRT(AK2)
      CXRR=-(AK1*AK2/1.5_WP)*CXI

!*** EMKD = |m|*k_0*d , where |m|=refractive index
!                             k_0 = wave vector in vacuo
!                             d = lattice spacing

      EMKD=SQRT(ABS(CXEPS(1)))*AK1

!***********************************************************************

!*** Lattice dispersion relation (Draine & Goodman 1993)

      IF(CALPHA=='LATTDR')THEN
         WRITE(CMSGNM,FMT='(A,F6.4)')                     &
            'Lattice dispersion relation for |m|k_0d=',EMKD
         CALL WRIMSG('ALPHA ',CMSGNM)

!*** Compute sum (a_j*e_j)^2 , where a_j=unit propagation vector
!                                    e_j=unit polarization vector

         SUM=0.0_WP
         DO L=1,3
            SUM=SUM+(AKR(L)*ABS(CXE0R(L)))**2
         ENDDO
         SUM=SUM/AK2
         B1=-1.8915316_WP*AK2
         B2=(0.1648469_WP-1.7700004_WP*SUM)*AK2
         DO L=1,3
            DO IA=1,NAT
               IC=ICOMP(IA,L)
               IF(IC>0)THEN

!*** First compute Clausius-Mossotti polarizability:

                  CXTERM=(.75_WP/PI)*(CXEPS(IC)-1._WP)/(CXEPS(IC)+2._WP)

!*** Determine polarizability by requiring that infinite lattice of
!    dipoles have dipersion relation of continuum.

                  CXTERM=CXTERM/(1._WP+CXTERM*(B1+CXEPS(IC)*B2))

!*** Radiative-reaction correction:

                  CXALPH(IA,L)=CXTERM/(1._WP+CXTERM*CXRR)

! set off-diagonal terms to zero

                  CXALOF(IA,L)=0._WP

               ELSEIF(IC==0)THEN

! To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.

                  CXALPH(IA,L)=1._WP
                  CXALOF(IA,L)=0._WP
               ENDIF
            ENDDO
         ENDDO
         RETURN

!*** Lattice dispersion relation: modified
!    (Gutkowicz-Krusin & Draine 2004)

      ELSEIF(CALPHA=='GKDLDR')THEN

         IF(MYID==0)THEN
            WRITE(CMSGNM,FMT='(A,F6.4)')                               &
                  'GKDLDR Lattice dispersion relation for |m|k_0d=',EMKD
            CALL WRIMSG('ALPHA ',CMSGNM)
         ENDIF

! B1 = (c_1/pi)*ak2 = (-5.9424219/pi)*ak2 = -1.8915316*ak2
! B2 = (c_2/pi)*ak2 = (0.5178819/pi)*ak2 = 0.1648469*ak2
! B3 = -[(3c_2+c_3)/pi]*ak2 = -[(3*0.5178819+4.0069747)/pi]*ak2
!                           = -1.7700004*ak2
! B3L = B3*A(I)**2 where a_i = unit vector in direction of propagation

!*** diagnostic
!         write(0,*)'alphadiag ckpt 2'
!***
         B1=-1.8915316_WP*AK2
         B2=0.1648469_WP*AK2
         B3=-1.7700004_WP*AK2
         DO L=1,3
            B3L=B3*AKR(L)*AKR(L)/AK2
            DO IA=1,NAT
               IC=ICOMP(IA,L)
               IF(IC>0)THEN

!*** First compute Clausius-Mossotti polarizability:

                  CXTERM=(.75_WP/PI)*(CXEPS(IC)-1._WP)/(CXEPS(IC)+2._WP)

!*** Determine polarizability by requiring that infinite lattice of
!    dipoles have dipersion relation of continuum.


                  CXTERM=CXTERM/(1._WP+CXTERM*(B1+CXEPS(IC)*(B2+B3L)))

!*** Radiative-reaction correction:

                  CXALPH(IA,L)=CXTERM/(1._WP+CXTERM*CXRR)

! set off-diagonal terms to zero

                  CXALOF(IA,L)=0._WP

               ELSEIF(IC==0)THEN

! To avoid divisions by zero, etc., set CXALPH=1 for vacuum sites.

                  CXALPH(IA,L)=1._WP
                  CXALOF(IA,L)=0._WP
               ENDIF
            ENDDO
         ENDDO

!*** diagnostic
!         write(0,*)'alphadiag ckpt 3'
!***

! Now enter module to handle possible microcrystal rotation at each
! lattice site.  BETADF,PHIDF,THETADF = 3 rotation angles specifying
! orientation of "Dielectric Frame" (in which dielectric tensor is
! diagonal) relative to Target Frame.

         DO IA=1,NAT
            IC=ICOMP(IA,1)
!*** diagnostic
!            write(0,*)'alphadiag ckpt 3.1, ia=',ia,' ic=',ic
!***
            IF(IC>0)THEN
               IC2=ICOMP(IA,2)
               IC3=ICOMP(IA,3)
               IF(IC/=IC2.OR.IC/=IC3)THEN
!*** diagnostic
!                  write(0,*)'alphadiag ckpt 3.2, ic,ic2,ic3=',ic,ic2,ic3
!***
                  COSTH=COS(THETADF(IA))
                  COSPH=COS(PHIDF(IA))
                  COSBE=COS(BETADF(IA))
                  IF(COSTH*COSBE*COSPH<1._WP)THEN

! if nonzero rotation, recalculate CXALPH and CXALOF

                     SINTH=SIN(THETADF(IA))
                     SINPH=SIN(PHIDF(IA))
                     SINBE=SIN(BETADF(IA))

! Define R = rotation matrix

                     R(1,1)=COSTH
                     R(1,2)=SINTH*COSPH
                     R(1,3)=SINTH*SINPH
                     R(2,1)=-SINTH*COSBE
                     R(2,2)=COSTH*COSBE*COSPH-SINBE*SINPH
                     R(2,3)=COSTH*COSBE*SINPH+SINBE*COSPH
                     R(3,1)=SINTH*SINBE
                     R(3,2)=-COSTH*SINBE*COSPH-COSBE*SINPH
                     R(3,3)=-COSTH*SINBE*SINPH+COSBE*COSPH

! Define RI = inverse of R

                     RI(1,1)=COSTH
                     RI(1,2)=-SINTH*COSBE
                     RI(1,3)=SINTH*SINBE
                     RI(2,1)=SINTH*COSPH
                     RI(2,2)=COSTH*COSBE*COSPH-SINBE*SINPH
                     RI(2,3)=-COSTH*SINBE*COSPH-COSBE*SINPH
                     RI(3,1)=SINTH*SINPH
                     RI(3,2)=COSTH*COSBE*SINPH+SINBE*COSPH
                     RI(3,3)=-COSTH*SINBE*SINPH+COSBE*COSPH

! calculate diagonal elements:

                     CXSUM1=0._WP
                     CXSUM2=0._WP
                     CXSUM3=0._WP
                     CXSUM4=0._WP
                     CXSUM5=0._WP
                     CXSUM6=0._WP
                     DO L=1,3
                        CXSUM1=CXSUM1+R(1,L)*CXALPH(IA,L)*RI(L,1)
                        CXSUM2=CXSUM2+R(2,L)*CXALPH(IA,L)*RI(L,2)
                        CXSUM3=CXSUM3+R(3,L)*CXALPH(IA,L)*RI(L,3)
                        CXSUM4=CXSUM4+R(2,L)*CXALPH(IA,L)*RI(L,3)
                        CXSUM5=CXSUM5+R(3,L)*CXALPH(IA,L)*RI(L,1)
                        CXSUM6=CXSUM6+R(1,L)*CXALPH(IA,L)*RI(L,2)
                     ENDDO
                     CXALPH(IA,1)=CXSUM1
                     CXALPH(IA,2)=CXSUM2
                     CXALPH(IA,3)=CXSUM3
                     CXALOF(IA,1)=CXSUM4
                     CXALOF(IA,2)=CXSUM5
                     CXALOF(IA,3)=CXSUM6
                  ENDIF
               ENDIF
            ENDIF
         ENDDO
!*** diagnostic
!         write(0,*)'alphadiag ckpt 4'
!***
         RETURN
      ELSE
         WRITE(CMSGNM,FMT='(A)') 'Error: invalid option for subroutine ALPHA'
         CALL WRIMSG('ALPHA ',CMSGNM)
         STOP
      ENDIF
    END SUBROUTINE ALPHADIAG

    SUBROUTINE SCAVEC(MXSCA,NSCAT,THETAN,PHIN,CXE01,ENSC,EM1,EM2)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!***********************************************************************
! Given:
!      MXSCA=dimension information for ENSC,PHIN,THETAN
!      NSCAT=number of scattering directions
!      THETAN(1-NSCAT)=scattering angles theta
!      PHIN(1-NSCAT)=scattering angles phi
!      CXE01(1-3)=complex polarization vector 1 (phi=0 direction
!                 is defined by x,y plane (Lab Frame), where incident
!                 radiation propagates along the x axis.
! Returns:
!      ENSC(1-3,1-NSCAT)=scattering vectors in Lab Frame
!      EM1(1-3,1-NSCAT)=scattered pol vectors parallel to scat. plane
!                       in Lab Frame
!      EM2(1-3,1-NSCAT)=scattered pol vectors perp. to scat. plane
!                       in Lab Frame
! It is assumed that incident propagation vector is in x-direction
! in Lab Frame

! History:
! 96.11.06 (BTD): Changed definition of scattering angle phi
!                 Previously, phi was measured from plane containing
!                 incident k vector (i.e., Lab x-axis) and Re(CXE01)
!                 Henceforth, phi is measured from Lab x,y plane.

! Copyright (C) 1993,1996, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Arguments:
      INTEGER :: MXSCA, NSCAT
      COMPLEX (WP) :: CXE01(3)
      REAL (WP) :: EM1(3,MXSCA), EM2(3,MXSCA), ENSC(3,MXSCA), PHIN(MXSCA), &
        THETAN(MXSCA)

! Local variables:
      INTEGER :: I
      REAL (WP) :: COSPHI, COSTHE, SINPHI, SINTHE

!***********************************************************************
      DO I = 1, NSCAT
        COSPHI = COS(PHIN(I))
        SINPHI = SIN(PHIN(I))
        COSTHE = COS(THETAN(I))
        SINTHE = SIN(THETAN(I))
        ENSC(1,I) = COSTHE
        ENSC(2,I) = SINTHE*COSPHI
        ENSC(3,I) = SINTHE*SINPHI
        EM1(1,I) = -SINTHE
        EM1(2,I) = COSTHE*COSPHI
        EM1(3,I) = COSTHE*SINPHI
        EM2(1,I) = 0._WP
        EM2(2,I) = -SINPHI
        EM2(3,I) = COSPHI
      END DO
      RETURN
    END SUBROUTINE SCAVEC

    SUBROUTINE MPI_BCAST_INT(INTVAR,ICOUNT,IROOT,IERR)
      IMPLICIT NONE
!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments
      INTEGER :: ICOUNT,IERR,IROOT
      INTEGER :: INTVAR(*)
!-----------------------------------------------------------------------
! Subroutine MPI_BCAST_INT
! Purpose: to serve as a "jacket" for passing integer variables to
!          MPI_BCAST so that MPI_BCAST will be called with only a single 
!          variable type in a given fortran routine.
! B.T. Draine, Princeton University Observatory, 2004.04.09
! history
! 04.04.09 (BTD) first written
! 08.01.17 (BTD) f90 version
! end history
! Copyright (C) 2004,2008 B.T.Draine and P.J. Flatau
! This code is covered by the GNU General Public License
!-----------------------------------------------------------------------

      CALL MPI_BCAST(INTVAR,ICOUNT,MPI_INTEGER, &
                     IROOT,MPI_COMM_WORLD,IERR)
      RETURN
    END SUBROUTINE MPI_BCAST_INT

    SUBROUTINE TARCEL(A1,A2,AX,AY,AZ,BX,BY,BZ,DX,X0,CDESCR,IOSHP,MXNAT,NAT, &
                      IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!** Arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP,MXNAT,NAT
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: AX,AY,AZ,BX,BY,BZ
      REAL(WP) :: & 
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

!** Local variables:

      INTEGER :: JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NIN
      REAL(WP) :: AX2,AY2,AZ2,BX2,BY2,BZ2,R,RR,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
!***********************************************************************

! Routine to construct target consisting of two materials, with outer
! surface an allipsoid of dimensions AX,AY,AZ,
! and core/mantle interface a concentric ellipsoid of dimensions BX,BY,B
! Input:
!        AX=(x-length)/d of outer ellipsoid  (d=lattice spacing)
!        AY=(y-length)/d "   "     "
!        AZ=(z-length)/d "   "     "
!        BX=(x-length)/d of inner ellipsoid
!        BY=(y-length)/d "   "     "
!        BZ=(z-length)/d "   "     "
!        DX(1-3)=lattice spacing (dx/d,dy/d,dz/d), d=(dx*dy*dz)**(1/3)
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Fr
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Fr
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=1 for sites within inner ellipsoid,
!                        =2 for sites between inner and outer ellipsoids
!        CDESCR=description of target (up to 67 characters)
!        X0(1-3)=(location/d) in Target Frame corresponding to dipole with
!                IXYZ=(0,0,0).  This will be treated at the origin of physical
!                coordinates in the TF.
!                Here set to be centroid of the ellipsoids.

! B.T.Draine, Princeton Univ. Obs.
! History:
! 94.01.26 (AP) : Adapted from TARELL by Antonio Peimbert, Princeton U.
! 94.01.27 (BTD): Modified for compatibility with TARGET, using
!                 AX,AY,AZ,BX,BY,BZ to transfer shape parameters read by
!                 subroutine REAPAR
! 94.03.21 (BTD): Corrected format statement
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
!                 lattice spacing.
!                 *** Note: additional code modifications required
!                     to support noncubic lattice!
! 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
!                 call ERRMSG and halt with fatal error.
! 98.03.07 (BTD): Modify to write DX to file "target.out" for
!                 compatibility with REASHP
! 00.11.02 (BTD): Remove XOFF,YOFF,ZOFF from target.out
!                 cosmetic changes
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.01.13 (BTD): Cosmetic changes
!                 Added X0 to argument list
!                 Added code setting X0 to be centroid of ellipsoid
! 08.08.29 (BTD): Modified format 9020
! end history

! Copyright (C) 1994,1996,1997,1998,2007,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Current version of TARCEL is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TARCEL',                          &
                     ' tarcel does not support noncubic lattice')
      ENDIF

! Inner ellipsoid is defined by
!      (X/AX)**2+(Y/AY)**2+(Z/AZ)**2 = 0.25
! Outer ellipsoid is defined by
!      (X/BX)**2+(Y/BY)**2+(Z/BZ)**2 = 0.25
! Material within inner ellipsoid is of composition 1
! Material between inner and outer ellipsoids is of composition 2

! Ideal volume V=(pi/6)*BX*BY*BZ

! Dipoles are located at sites
! (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
!                                 XOFF,YOFF,ZOFF=constants

! For concentric spheres: call with AX=AY=AZ, BX=BY=BZ
! For spheroids: call with AX=AY (or AY=AZ or AX=AZ) and BX=BY (or BY=BZ
!   or BX=BZ)

!***********************************************************************

! Check that input parameters have "inner" ellipsoid smaller than
! "outer" ellipsoid:
      IF(AX<BX)CALL ERRMSG('FATAL','TARCEL',' AX < BX ')
      IF(AY<BY)CALL ERRMSG('FATAL','TARCEL',' AY < BY ')
      IF(AZ<BZ)CALL ERRMSG('FATAL','TARCEL',' AZ < BZ ')
! Criterion for choosing XOFF: try to optimize outer ellipsoid surface
! If AX is close to an even integer, take XOFF=1/2
! If AX is close to an odd integer, take XOFF=0
      JX=INT(AX+.5_WP)
      IF(2*(JX/2)==JX)THEN
         XOFF=0.5_WP
      ELSE
         XOFF=0._WP
      ENDIF
! Similar criterion for YOFF:
      JY=INT(AY+.5_WP)
      IF(2*(JY/2)==JY)THEN
         YOFF=0.5_WP
      ELSE
         YOFF=0._WP
      ENDIF
! Similar criterion for ZOFF:
      JZ=INT(AZ+.5_WP)
      IF(2*(JZ/2)==JZ)THEN
         ZOFF=0.5_WP
      ELSE
         ZOFF=0._WP
      ENDIF

      LMX1=-INT(.5_WP*AX+.5_WP)
      LMX2=INT(.5_WP*AX-.25_WP)
      LMY1=-INT(.5_WP*AY+.5_WP)
      LMY2=INT(.5_WP*AY-.25_WP)
      LMZ1=-INT(.5_WP*AZ+.5_WP)
      LMZ2=INT(.5_WP*AZ-.25_WP)

      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      BX2=BX*BX
      BY2=BY*BY
      BZ2=BZ*BZ

      NAT=0
      NIN=0

! Specify target axes A1 and A2
!   A1=(1,0,0) in target frame
!   A2=(0,1,0) in target frame

      DO JX=1, 3
         A1(JX)=0._WP
         A2(JX)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! Determine list of occupied sites.

      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ,KIND=WP)+ZOFF
         RZ2=Z*Z/AZ2
         IF(RZ2<0.25_WP)THEN
            DO JY=LMY1, LMY2
               Y=REAL(JY,KIND=WP)+YOFF
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2<0.25_WP)THEN
                  DO JX=LMX1,LMX2
                     X=REAL(JX,KIND=WP)+XOFF
                     R=RYZ2+X*X/AX2
                     IF(R<0.25_WP)THEN
! Site is occupied:
                        NAT=NAT+1
                        RR=Z*Z/BZ2+Y*Y/BY2+X*X/BX2
                        IF(RR<0.25_WP)THEN
! within inner ellipsoid:
                           ICOMP(NAT,1)=1
                           ICOMP(NAT,2)=1
                           ICOMP(NAT,3)=1
                           NIN=NIN+1
                        ELSE
! between inner and outer ellipsoids:
                           ICOMP(NAT,1)=2
                           ICOMP(NAT,2)=2
                           ICOMP(NAT,3)=2
                        ENDIF
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO

! locate centroid = origin of coordinates in TF

      DO JX=1,3
         X0(JX)=0._WP
      ENDDO
      DO JX=1,3
         DO JY=1,NAT
            X0(JX)=X0(JX)+REAL(IXYZ(JY,JX))
         ENDDO
         X0(JX)=X0(JX)/REAL(NAT)
      ENDDO
      
      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF

!***********************************************************************
! Write target description into string CDESCR

      IF(AX==AY .AND. AX==AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A)')' Spherical target containing',NAT, &
                                     ' dipoles'
      ELSE
         WRITE(CDESCR,FMT='(A,I6,A,I7,A)')' Concentric ellipsoids with',NIN, &
                                          ' inner ', NAT, ' total dipoles'
      ENDIF

!***********************************************************************

      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)AX,AY,AZ,BX,BY,BZ,NAT,NIN,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARCEL: concentric ellipsoids; AX,AY,AZ=',3F8.4,   &
             ' BX,BY,BZ=',3F8.4,/,                                 &
         2I10,' = NAT, NIN,',/,                                    &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARCEL

    SUBROUTINE TARREC(A1,A2,XV,YV,ZV,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL(WP) :: XV,YV,ZV
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local variables:

      INTEGER :: JA,JX,JY,JZ,NX,NY,NZ
      CHARACTER :: CMSGNM*70

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:

!***********************************************************************
! Routine to construct rectangular prism from "atoms"
! Input:
!        XV=(x-length)/d    (d=lattice spacing)
!        YV=(y-length)/d
!        ZV=(z-length)/d
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Fr
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Fr
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        X0(1-3)=location/d in TF of dipole with IXYZ=0,0,0
!                "upper" surface of the rectangular block is in x_TF=0 plane
!                origin of the TF is set to be at the
!                midpoint of the upper surface
!
! B.T.Draine, Princeton Univ. Obs.
! History:
! 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 93.03.12 (BTD): Specified CDESCR*67, and now use it.
! 95.07.12 (BTD): Changed definition of axes A1,A2.  They used to be
!                 longest,next longest dimention.  They are now
!                 fixed to always be (1,0,0) and (0,1,0).
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(1-3) to argument list to support nonuniform
!                 lattice spacing.
! 98.02.11 (BTD): Modify to generate target on noncubic lattice.
! 00.11.02 (BTD): Add ICOMP to argument list, set ICOMP=1,
!                 write ICOMP to target.out
! 07.09.11 (BTD): changed IXYZ from INTEGER*2 to INTEGER
! 08.08.29 (BTD) v7.0.7
!                * add X0(3) to argument list
!                * add code to calculate X0
! 08.08.30 (BTD) modify format 9020
! end history

! Copyright (C) 1993,1995,1996,1997,1998,2000,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!***********************************************************************
      NX=INT(XV/DX(1)+0.5_WP)
      NY=INT(YV/DX(2)+0.5_WP)
      NZ=INT(ZV/DX(3)+0.5_WP)
      WRITE(CMSGNM,FMT='(A,3I4)')' Rectangular prism; NX,NY,NZ=',NX,NY,NZ
      WRITE(CDESCR,FMT='(A,3I4)')' Rectangular prism; NX,NY,NZ=',NX,NY,NZ

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in target frame
!             A2 will be (0,1,0) in target frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      END DO
      A1(1)=1._WP
      A2(2)=1._WP

! top dipole layer will be at x_TF=-d/2, and will have JX=NX
! therefore set X0(1)=-NX-0.5
! we want x_TF axis (i.e., y_TF=z_TF=0) to run through middle of target
! JY runs from 1 to NY : middle is at 0.5*(1+NY)
!                        X0(2)=-0.5*(1+NY)
!                        X0(3)=-0.5*(1+NZ)
      X0(1)=-REAL(NX)-0.5_WP
      X0(2)=-0.5_WP*REAL(NY+1)
      X0(3)=-0.5_WP*REAL(NZ+1)

! Now populate lattice:
      NAT=0
      DO JZ=1,NZ
         DO JY=1,NY
            DO JX=1,NX
               NAT=NAT+1
               IF(NAT>MXNAT)THEN
                  CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ
            ENDDO
         ENDDO
      ENDDO
      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT ')
      ENDIF

! homogeneous, isotropic composition:

      DO JX=1,3
         DO JA=1,NAT
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

      WRITE(CMSGNM,FMT='(A,I7,A)')'  Rectangular prism of NAT=',NAT, &
                                  ' dipoles'
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XV,YV,ZV,NAT,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARREC   rectangular prism; AX,AY,AZ=',3F8.4,/,    &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARREC

    SUBROUTINE ESELF(CMETHD,CXZP,NX,NY,NZ,IPBC,GAMMA,PYD,PZD,AK,AKD,DX, &
                     CXZC,CXZW,CXZE)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

!----------------------- eself v4.0 --------------------------------
! Arguments:

      CHARACTER(6) :: CMETHD
      INTEGER :: IPBC,NX,NY,NZ
      REAL(WP) :: AKD,GAMMA,PYD,PZD
      REAL(WP) :: AK(3),DX(3)
      COMPLEX(WP) :: &
         CXZC(NX+1+IPBC*(NX-1),NY+1+IPBC*(NY-1),NZ+1+IPBC*(NZ-1),6), &
         CXZE(NX,NY,NZ,3),    &
         CXZP(NX,NY,NZ,3),    &
         CXZW(2*NX,2*NY,2*NZ,*)

! Local scalars:

      CHARACTER :: CMSGNM*70
      INTEGER :: I,IR,ISGN,J,JR,JSGN,K,KR,KSGN,M,NGRID
      REAL(WP) :: AK2OLD,AK3OLD,AKD2,DTIME,FAC,PYDDX,PZDDX,WOLD
      COMPLEX(WP) :: CXEX,CXEY,CXEZ,CXXX,CXXY,CXXZ,CXYY,CXYZ,CXZZ

! Local arrays:

      INTEGER :: ISYM(3)

      EXTERNAL CXFFTW,DIRECT_CALC,EXTND,PAD,TIMEIT,TRIM
      INTRINSIC MIN,NINT,SIGN
      SAVE AK2OLD,AK3OLD,NGRID,WOLD
      DATA AK2OLD/-999._WP/
      DATA AK3OLD/-999._WP/
      DATA WOLD/-999._WP/

!-----------------------------------------------------------------------
! Parameter GAMMA determines the range of the sums when periodic
! boundary conditions are employed.  Dipole-dipole interactions
! are screened by a factor exp[-(gamma*kr)^4]
! The effective
! range/d = 1/(gamma*k*d) = 2000 if gamma=1e-3 and kd=0.5
!
! The sums are actually continued out to
! r/d = 2*/(gamma*kd) = 4000 if gamma=1e-3 , kd=0.5
! [screening factor = exp(-16)=1.1e-7]

!-----------------------------------------------------------------------
! subroutine ESELF

!       Given the dipole moments, CXZP, at all points on
!       a rectangular grid, oscillating at frequency AKD,
!       compute the electric field amplitude, CXZE,
!       at each point produced by all the other dipoles except the one
!       at that point.
!       The relationship between the dipoles and the field
!       values at the grid points can be expressed as a convolution,
!       and the convolution is efficiently evaluated using 3D FFTs.

!       options for computation of 3-dimensional FFT:

!    if CMETHD='GPFAFT':
!          Use CXFFT3N interface to GPFA code of Temperton.
!          Good points:
!             -On CRAY the code is on average 30-40% faster in comparison
!              to TMPRTN (and 10-15 faster in comparison to BRENNR)
!             -On scalar machines the code is 2-8 faster in comparison
!              to BRENNR or TMPRTN
!             -Doesn't require additional storage
!          Limitations:
!              -Requires that NX,NY,NZ be of form (2**I)*(3**J)*(5**K);
!               subroutine EXTEND takes care of choosing suitable NX,NY,
!              -The choice of "lvr" variable in gpfa2f, gpfa3f, gpfa5f
!               depends on machine. WARNING: on C90 use lvr=128, on
!               all other CRAY's use lvr=64; wrong lvr will produce WRONG
!               RESULTS. On scalar machines optimal lvr depends on cache
!               length; sub-optimal choice degrades performance but still
!               produces correct results.
!   if CMETHD='FFTW21'
!      Use CXFFTW interface to FFTW (Fastest Fourier Transform in the
!               West) version 2.1.x from Frigo and Johnson.
!
!   if CMETHD='FFTMKL':
!      Use CXFFT3_MKL interface to Intel Math Kernel Library (MKL) FFT
!
! INPUT:

!       CXZP(I,J,K,L)   Lth cartesian component of the dipole
!                       moment at the grid point (I,J,K);
!                       the DIMENSIONed length of CXZP in
!                       the calling routine is CXZP(NX,NY,NZ,3)
!                       [or CXZP(NX*NY*NZ,3) or CXZP(3*NX*NY*NZ)]

!       NX,NY,NZ        Size of grid in x,y,z directions (INTEGER).

!       PYD             (Period of lattice in y direction)/D(2)
!       PZD             (Period of lattice in z direction)/D(3)

!       DX(1-3)         Lattice spacing in x,y,z directions, in units of
!                       n**(-1./3.) .  Note that with this normalization
!                       we have DX(1)*DX(2)*DX(3)=1.

!       AK(1-3)         k(1-3)*d, where k = k vector in vacuo, and
!                       d = effective lattice spacing = (dx*dy*dz)**(1/3

!       AKD             Frequency of oscillation of dipoles and electric
!                       field; also absolute value of wave vector of
!                       incident wave [c=1]  (REAL*4).

!       CXZC            (NX+1)*(NY+1)*(NZ+1)*6 array of Green
!                       function coefficients used
!                       internally by ESELF and
!                       *************NOT TO BE OVERWRITTEN***********
!                       between calls, because these coefficients are
!                       recomputed only if W has changed since the last
!                       call to ESELF.

!       CXZW            Complex, scratch-space vector of length:
!                       2*NX*2*NY*2*NY*3
!                       See comment about FFT usage and CMETHD
!                       flag.
!                       Can be overwritten between calls to ESELF

! OUTPUT:

!       CXZE(I,J,K,L)   Lth component of dipole-generated electric field
!                       at grid point (I,J,K);
!                       the DECLARED length of ZE in the calling
!                       program is CXZE(NX,NY,NZ,3)
!                       [or CXZE(NX*NY*NZ,3) or CXZE(3*NX*NY*NZ)]

! Originally written by Jeremy Goodman, Princeton Univ. Observatory, 90.
! History:
! 90.11.29 (BTD): Modified to set untransformed ZC(1,1,1,1-6)=0.
! 90.11.29 (PJF): Modified to use FOURX and CXFFT99
! 90.12.05 (BTD): Modified for new ordering of elements of polarization
!                 and electric field vectors in calling program.  Modifi
!                 ESELF and PAD to remove distinction between NX,NY,NZ
!                 and dimensions CXZE and CXZP, since our new ordering
!                 always assumes this.
! 90.12.13 (BTD): Modified to include CONVEX option.
! 92.04.20 (BTD): removed ISYM from argument list of TRIM (was not used)
! 94.06.20 (PJF): modified to call CXFFT3N when CMETHD='NEWTMP'
! 96.10.18 (BTD): changed NEWTMP to GPFAFT
! 97.10.16 (BTD): added DX(1-3) to argument list to support use for
!                 noncubic rectangular lattices.
!                 Added DX to 3 lines computing X(1-3)
! 99.04.26 (BTD): changed notation: CXY -> CXZE
! 00.06.22 (BTD): modified to support option FFTWFJ, with calls to CXFFT
! 00.06.25 (BTD): modified to eliminate calls to FOURX (CMETHD=BRENNR)
!                 and CXFFT3 (CMETHD=TMPRTN), as these options are no
!                 longer supported
! 00.07.05 (BTD): further cleanup
! 03.07.13 (BTD): changed FFTWFJ to FFTW21 to allow future distinction
!                 between FFTW 2.1.x and FFTW 3.0.x
! 04.03.05 (BTD): modified to handle a periodic lattice of scatterers
!                 with periodicity NPY*D(2) in y direction and
!                 NPZ*D(3) in z direction
!                 Add parameter BETA to assist convergence
! 05.06.16 (BTD): Replaced integer NPY,NPZ by real PYD,PZD in
!                 argument list and in calculation
!                 corrected error in calculation of JPZM
! 05.07.08 (BTD): corrected error in calculation of JPZM
! 05.08.01 (BTD): changes to increase efficiency of summations
!                 required for PBC option (new variables AKD2,
!                 PYDDX,PZDDX,X0,Y0,Z0,X2,Y2,X2Y2,CXTERM)
! 05.08.03 (BTD): corrected typo.
! 05.08.04 (BTD): added AK(1-3) to argument list,
!                 added local variables PHASY and PHASYZ
!                 added phase shift exp(i*PHASYZ) for replica dipole
! 06.09.15 (BTD): added comments, reduced BETA to 1e-12 for improved
!                 accuracy (at expense of speed).
! 06.09.23 (BTD): corrected error: sign error in calculation of
!                 diplacements X(2) and X(3) for replica dipoles
! 06.09.23 (BTD): corrected error in computation of factor CXFAC
!                 appearing in summation for CXSUM
! 06.09.28 (BTD): eself v2.0 and DDSCAT 6.2.3:
!                 * put part of calculation of A matrix into subroutine
!                   DIRECT_CALC
!                 * modified to support PBC option
!                 * added IPBC to argument list to support PBC option
!                 * changed dimensioning of CXZC when IPBC=1
!                 * when IPBC=1, store full CXZC rather than only first
!                   octant
! 07.08.06 (BTD): Version 7.0.3
!                 eliminate option CONVEX -> CXC3DFFT
!                 No longer appear to be any sites where this would be
!                 useful.
! 07.10.04 (BTD): Recompute Green function coefficients only if
!                 frequency changes by more than 1 part in 1e6
!                 (previous condition of requiring frequency to be
!                 unchanged was evidently being confused by roundoff
!                 error, leading to unnecessary recalculation).
! 07.10.25 (BTD): Modified so that for IPBC>0, Green functions are
!                 recalculated when direction of incidence is
!                 changed.
! 08.03.11 (BTD): v7.0.5
!                 * added ALPHA to argument list
!                 * eliminated variable BETA
!                 * replaced exp(-beta*(k*r)^4) with exp(-(alpha*k*r)^4)
! 08.04.20 (BTD): * change notation: ALPHA -> GAMMA
! 08.05.12 (BTD): v7.0.6
!                 * added OpenMP directives as suggested by Art Lazanoff, eg.
!                      #ifdef eself_omp
!                      !$omp parallel do
!                      #endif
!                   which will be compiled when the preprocessor flag
!                      -fpp -Deself_omp
!                   is used.
! 08.06.05 (ASL,BTD): eself_v3
!                 * added call to new routine CXFFT3_MKL to use Intel MKL
!                   library for FFT.
!                   This will now be invoked with CMETHD='FFTMKL'
! 08.06.27 (BTD) : eself_v4
!                 * BTD learning the ropes...
! 08.08.07 (BTD): removed #ifdef debug / #endif statements inserted
!                 around !omp directives by Art Lazanoff for testing.
!                 omp directives appear to work properly, they can
!                 continued to be tested as a whole by compiling with or 
!                 without the -openmp flag, and it is desirable for
!                 export code to be able to compile without cpp insofar
!                 as possible
! end history
! Copyright (C) 1993,1994,1996,1997,1999,2000,2003,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

!*** diagnostic
!      write(0,*)'eself ckpt 1 with nx,ny,nz=',nx,ny,nz
!      write(0,*)'                 pyd,pzd=',pyd,pzd
!      write(0,*)'                    ipbc=',ipbc
!      write(0,*)'                     akd=',akd
!      write(0,*)'                 dx(1-3)=',dx
!***

!*** diagnostic
!      write(0,*)'entered eself with akd=',akd
!      write(0,*)'                  wold=',wold
!      write(0,*)'entered eself with ak(2)=',ak(2)
!      write(0,*)'                  ak2old=',ak2old
!      write(0,*)'entered eself with ak(3)=',ak(3)
!      write(0,*)'                  ak3old=',ak3old
!      write(0,*)'                  pyd=',pyd
!      write(0,*)'                  pzd=',pzd
!***

! check if we can skip recomputation of Green-function coefficients

      IF(PYD.EQ.0._WP.AND.PZD.EQ.0._WP)THEN
         IF(ABS(WOLD-AKD)<1.E-6_WP*AKD)GOTO 70
      ELSEIF(PYD.NE.0._WP.AND.PZD.EQ.0._WP)THEN
         IF(ABS(WOLD-AKD)<1.E-6_WP*AKD.AND.   &
            ABS(AK(2)-AK2OLD)<1.E-6_WP*AKD)GOTO 70
      ELSEIF(PYD.EQ.0._WP.AND.PZD.NE.0._WP)THEN
         IF(ABS(WOLD-AKD)<1.E-6_WP*AKD.AND.   &
            ABS(AK(3)-AK3OLD)<1.E-6_WP*AKD)GOTO 70
      ELSEIF(PYD.NE.0._WP.AND.PZD.NE.0._WP)THEN
         IF(ABS(WOLD-AKD)<1.E-6_WP*AKD.AND.   &
            ABS(AK(2)-AK2OLD)<1.E-6_WP*AKD.AND. &
            ABS(AK(3)-AK3OLD)<1.E-6_WP*AKD)GOTO 70
      ENDIF

!*** diagnostic
!      write(0,*)'recompute Green-function coefficients'
!***
! AKD.NE.WOLD :

! We have to recompute the Green-function coefficients giving
! components of field strength at a each grid point R
! produced by unit-valued component of dipole moment at
! point R', and then Fourier transform these components.

      WOLD=AKD
      AK2OLD=AK(2)
      AK3OLD=AK(3)
      NGRID=8*NX*NY*NZ
      AKD2=AKD*AKD

! We assume screening function exp(-(gamma*kr)^4) so
! range/d = 1/(gamma*kd) = 2000 if gamma=1e-3 and kd=0.5
! although the sums are actually continued out to
! r/d = 2/(gamma*kd) = 4000 if gamma=1e-3, kd=0.5
! [screening factor = exp(-16)=1.1e-7]

! PYD*d(2) = periodicity in Y direction
! PZD*d(3) = periodicity in Z direction

      IF(PYD>0._WP.OR.PZD>0._WP)THEN
         WRITE(CMSGNM,FMT='(A,2F8.2,A,1PE9.2)')'PBC with PYD, PZD=',PYD, &
                                               PZD,', GAMMA=',GAMMA
         CALL WRIMSG('ESELF ',CMSGNM)
      ENDIF

      PYDDX=PYD*DX(2)
      PZDDX=PZD*DX(3)

!               Compute the actual coefficients:

! Compute 6 independent elements of 3x3 symmetric matrix A_jk,where
! A_jk*P_k = -electric field at location j due to dipole P_k at location

! A_jk = (a_1  a_2  a_3)
!        (a_2  a_4  a_5)
!        (a_3  a_5  a_6)_jk

      IF(IPBC==0)THEN

! initialize CXZC(I,J,K,M) = a_M for electric field at (I,J,K)
!                            produced by a dipole at (1,1,1)
!                            and replica dipoles (if PYD or PYZ are
!                            nonzero).

! need to calculate this for all (I,J,K) for one octant:
! I running from 1 to NX, J from 1 to NY, K from 1 to NZ

! Later obtain A_jk values for other octants by using symmetry

!*** diagnostic
!         write(0,*)'eself ckpt 2'
!***
        CALL DIRECT_CALC(1,1,1,NX,NY,NZ,IPBC,DX,AK,AKD,AKD2,GAMMA, &
                         PYDDX,PZDDX,CXZC(1,1,1,1))
!*** diagnostic
!         write(0,*)'eself ckpt 3'
!***

!*** diagnostic
!        write(0,*)'returned from direct_calc'
!        write(0,*)'check for NaN...'
!        jr=0
!        do i=1,nx
!           do j=1,ny
!              do k=1,nz
!                 do m=1,6
!                    if(.not.(abs(cxzc(i,j,k,m))>=0.d0).or. &
!                        abs(cxzc(i,j,k,m))>=1.d100)then
!                       write(0,*)'i,j,k,m=',i,j,k,m,'cxzc=',cxzc(i,j,k,m)
!                       jr=jr+1
!                    endif
!                 enddo
!              enddo
!           enddo
!        enddo
!        write(0,*)'cxy checked for NaN or overflow',jr,' instances found'
!***

! At this point, CXZC(I,J,K,1-6) contains the upper triangular part of t
! symmetric 3 x 3 matrix giving the electric field at grid point (i,j,k)
! produced by a dipole at (1,1,1)

! Fill out CXZC to twice the size in each grid dimension to accomodate
! negative lags [periodicity in each dimension is assumed, so (e.g.)
! nx < i <= 2*nx is equivalent to -nx < i <= 0], exploiting symmetries,
! and then Fourier transform.

! If PYDDX=0 and PZDDX=0 , need only do direct calculation of A matrix
! for first octant, since remaining octants can be obtained by symmetry.
! After calculating A matrix, store only the first octant of the
! transform, since the others can be obtained by symmetry.

!-----------------------------------------------------------------------
! extend a_1 = a_xx(x,y,z) : a -> +a for x -> -x
!                                 +a     y -> -y
!                                 +a     z -> -z
        ISYM(1)=1
        ISYM(2)=1
        ISYM(3)=1
!*** diagnostic
!        write(0,*)'eself ckpt 4, about to call EXTEND'
!***
        CALL EXTND(CXZC(1,1,1,1),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
!*** diagnostic
!        write(0,*)'eself ckpt 5, returned from EXTEND'
!***
        IF(CMETHD=='GPFAFT')THEN
!*** diagnostic
!           write(0,*)'eself ckpt 6'
!***
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
!*** diagnostic
!           write(0,*)'eself ckpt 7'
!**
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF
!*** diagnostic
!        write(0,*)'eself ckpt 7.1, about to call TRIM'
!***
        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,1))
!*** diagnostic
!        write(0,*)'returned from TRIM'
!***
!-----------------------------------------------------------------------
! extend a_2 = a_xy(x,y,z) : a -> -a for x -> -x
!                                 -a     y -> -y
!                                 +a     z -> -z

        ISYM(1)=-1
        ISYM(2)=-1
        ISYM(3)=1
!*** diagnostic
!        write(0,*)'eself ckpt 7.2, about to call EXTND'
!***
        CALL EXTND(CXZC(1,1,1,2),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
        IF(CMETHD=='GPFAFT')THEN
!*** diagnostic
!           write(0,*)'eself ckpt 7.3, about to call cxfft3n'
!***
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
!*** diagnostic
!          write(0,*)'eself ckpt 7.4, returned from cxfft3n'
!***
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF
!*** diagnostic
!        write(0,*)'eself ckpt 7.5, about to call TRIM'
!***
        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,2))
!*** diagnostic
!        write(0,*)'returned from TRIM'
!***
!-----------------------------------------------------------------------
! extend a_3 = a_xz(x,y,z) : a -> -a for x -> -x
!                                 +a     y -> -y
!                                 -a     z -> -z

        ISYM(1)=-1
        ISYM(2)=1
        ISYM(3)=-1
        CALL EXTND(CXZC(1,1,1,3),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
        IF(CMETHD=='GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF

        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,3))

!-----------------------------------------------------------------------
! extend a_4 = a_yy(x,y,z) : a -> +a for x -> -x
!                                 +a     y -> -y
!                                 +a     z -> -z

        ISYM(1)=1
        ISYM(2)=1
        ISYM(3)=1
        CALL EXTND(CXZC(1,1,1,4),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
        IF(CMETHD=='GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF

        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,4))

!-----------------------------------------------------------------------
! extend a_5 = a_yz(x,y,z) : a -> +a for x -> -x
!                                 -a     y -> -y
!                                 -a     z -> -z
        ISYM(1)=1
        ISYM(2)=-1
        ISYM(3)=-1
        CALL EXTND(CXZC(1,1,1,5),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
        IF(CMETHD=='GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF

        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,5))

!-----------------------------------------------------------------------
! extend a_6 = a_zz(x,y,z) : a -> +a for x -> -x
!                                 +a     y -> -y
!                                 +a     z -> -z
        ISYM(1)=1
        ISYM(2)=1
        ISYM(3)=1
        CALL EXTND(CXZC(1,1,1,6),NX,NY,NZ,ISYM,CXZW(1,1,1,1))
        IF(CMETHD=='GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD=='FFTW21')THEN
           CALL CXFFTW(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ELSEIF(CMETHD.EQ.'FFTMKL')THEN
           CALL CXFFT3_MKL(CXZW(1,1,1,1),2*NX,2*NY,2*NZ,+1)
        ENDIF

        CALL TRIM(CXZW(1,1,1,1),NX,NY,NZ,CXZC(1,1,1,6))

      ELSEIF(IPBC==1)THEN

! This point is reached when PYDDX or PZDDX are nonzero.
! When PBC are used for general direction of incident wave,
! all octants of A matrix require direct calculation: symmetries valid
! for single target no longer apply because of position-dependent phases
! of replica dipoles.

        CALL DIRECT_CALC(-1,-1,-1,NX,NY,NZ,IPBC,DX,AK,AKD,AKD2,GAMMA, &
                         PYDDX,PZDDX,CXZC(1,1,1,1))

!*** diagnostic
!        write(0,*)'eself ckpt 8'
!***
! The array CXZC(1-2*NX,1-2*NY,1-2*NZ,1-6) of A matrix coefficients
! now covers all octants.

! Fourier transform the A matrix CXZC:

        DO M=1,6
           IF(CMETHD=='GPFAFT')THEN
              CALL CXFFT3N(CXZC(1,1,1,M),2*NX,2*NY,2*NZ,+1)
           ELSEIF(CMETHD=='FFTW21')THEN
              CALL CXFFTW(CXZC(1,1,1,M),2*NX,2*NY,2*NZ,+1)
           ELSEIF(CMETHD.EQ.'FFTMKL')THEN
              CALL CXFFT3_MKL(CXZC(1,1,1,M),2*NX,2*NY,2*NZ,+1)
           ENDIF
        ENDDO

!*** diagnostic
!        write(0,*)'eself ckpt 9'
!***

! CXZC now contains the full Fourier transform of the A convolution
! and should not be overwritten between calls to ESELF

      ENDIF
      CALL TIMEIT('ESELF (first call)',DTIME)
      CALL TIMEIT('ESELF',DTIME)
!-----------------------------------------------------------------------

! End of recomputation of Green-function coefficients

70    CONTINUE
!*** diagnostic
!      write(0,*)'eself ckpt 10'
!****
! Fourier transform the polarizations:

      DO M=1,3
         CALL PAD(CXZP(1,1,1,M),NX,NY,NZ,CXZW(1,1,1,M))

!*** diagnostic
!        write(0,*)'eself ckpt 11: returned from PAD: ', &
!                  'check cxzw for NaN or overflow...'
!        jr=0
!        do i=1,2*nx
!           do j=1,2*ny
!              do k=1,2*nz
!                 if(.not.(abs(cxzw(i,j,k,m))>=0.d0).or. &
!                     abs(cxzw(i,j,k,m))>=1.d100)then
!                    write(0,*)'i,j,k,m=',i,j,k,m,'cxzw=',cxzw(i,j,k,m)
!                    jr=jr+1
!                 endif
!              enddo
!           enddo
!        enddo
!        write(0,*)'eself ckpt 12: cxzw checked for NaN or overflow: ', &
!                  jr,' instances found'
!        if(jr>0)stop
!***

        IF(CMETHD=='GPFAFT')THEN
           CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
!*** diagnostic
!        write(0,*)'eself ckpt 13: returned from CXFFT3N: ', &
!                  'check cxzw for NaN or overflow...'
!        jr=0
!        do i=1,2*nx
!           do j=1,2*ny
!              do k=1,2*nz
!                 if(.not.(abs(cxzw(i,j,k,m))>=0.d0).or. &
!                     abs(cxzw(i,j,k,m))>=1.d100)then
!                    write(0,*)'i,j,k,m=',i,j,k,m,'cxzw=',cxzw(i,j,k,m)
!                    jr=jr+1
!                 endif
!              enddo
!           enddo
!        enddo
!        write(0,*)'eself ckpt 14: cxzw checked for NaN or overflow',jr, &
!                  ' instances found'
!        if(jr>0)stop
!***
         ELSEIF(CMETHD=='FFTW21')THEN
            CALL CXFFTW(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
         ELSEIF(CMETHD.EQ.'FFTMKL')THEN
            CALL CXFFT3_MKL(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,+1)
         ENDIF
      ENDDO

!***********************************************************************

! Multiply by F.t. of Green function.

      IF(IPBC==0)THEN

!*** diagnostic
!         write(0,*)'eself ckpt 15, check cxzc(i,j,k,m=1,6)'
!        jr=0
!        do i=1,2*nx
!           do j=1,2*ny
!              do k=1,2*nz
!                 do m=1,6
!                    if(.not.(abs(cxzc(i,j,k,m))>=0.d0).or. &
!                        abs(cxzc(i,j,k,m))>=1.d100)then
!                       write(0,*)'i,j,k,m=',i,j,k,m,'cxzc=',cxzc(i,j,k,m)
!                       jr=jr+1
!                    endif
!                 enddo
!              enddo
!           enddo
!        enddo
!        write(0,*)'eself ckpt 16: cxzc(i,j,k,m=1-6) checked for NaN ', &
!                  'or overflow: ',jr,' instances found'
!        if(jr>0)stop
!        write(0,*)'eself ckpt 17: check cxzw(i,j,k,m=1-3)'
!        jr=0
!        do i=1,2*nx
!           do j=1,2*ny
!              do k=1,2*nz
!                 do m=1,3
!                    if(.not.(abs(cxzw(i,j,k,m))>=0.d0).or. &
!                        abs(cxzw(i,j,k,m))>=1.d100)then
!                       write(0,*)'i,j,k,m=',i,j,k,m,'cxzw=',cxzw(i,j,k,m)
!                       jr=jr+1
!                    endif
!                 enddo
!              enddo
!           enddo
!        enddo
!        write(0,*)'eself ckpt 18: cxzw(i,j,k,m=1-3) checked for NaN or ', &
!                  'overflow: ',jr,' instances found'
!        if(jr>0)stop
!***
!***

! If IPBC=0, then only one octant of F.t. of Green function has been
!            stored, but can recover others using symmetry.

#ifdef openmp
!$omp parallel do                                          &
!$omp& private(K,J,I,KSGN,KR,JSGN,JR,ISGN,IR)              &
!$omp& private(CXXX,CXXY,CXXZ,CXYY,CXYZ,CXZZ,CXEX,CXEY,CXEZ)
#endif

        DO K=1,2*NZ
           KSGN=NINT(SIGN(1._WP,NZ+1.5_WP-K))
           KR=MIN(K,2*NZ+2-K)
!*** diagnostic
!          write(0,*)'K,KSGN,KR=',K,KSGN,KR
!***
           DO J=1,2*NY
              JSGN=NINT(SIGN(1._WP,NY+1.5_WP-J))
              JR=MIN(J,2*NY+2-J)
!*** diagnostic
!            write(0,*)'   J,JSGN,JR=',J,JSGN,JR
!***
              DO I=1,2*NX
                 ISGN=NINT(SIGN(1._WP,NX+1.5_WP-I))
                 IR=MIN(I,2*NX+2-I)
!*** diagnostic
!              write(0,*)'       I,ISGN,IR=',I,ISGN,IR
!***
                 CXXX=CXZC(IR,JR,KR,1)
                 CXXY=CXZC(IR,JR,KR,2)*(ISGN*JSGN)
                 CXXZ=CXZC(IR,JR,KR,3)*(ISGN*KSGN)
                 CXYY=CXZC(IR,JR,KR,4)
                 CXYZ=CXZC(IR,JR,KR,5)*(JSGN*KSGN)
                 CXZZ=CXZC(IR,JR,KR,6)
!*** diagnostic
!              if(.not.(abs(cxxx)>=0.d0))write(0,*) &
!                'ir,jr,kr,cxzc(ir,jr,kr,1)=',ir,jr,kr,cxzc(ir,jr,kr,1)
!              if(.not.(abs(cxxy)>=0.d0))write(0,*) &
!                'ir,jr,kr,cxzc(ir,jr,kr,2)=',ir,jr,kr,cxzc(ir,jr,kr,2)
!              if(.not.(abs(cxxz)>=0.d0))write(0,*) &
!                 'ir,jr,kr,cxzc(ir,jr,kr,3)=',ir,jr,kr,cxzc(ir,jr,kr,3)
!              if(.not.(abs(cxyy)>=0.d0))write(0,*) &
!                  'ir,jr,kr,cxzc(ir,jr,kr,4)=',ir,jr,kr,cxzc(ir,jr,kr,4)
!              if(.not.(abs(cxyz)>=0.d0))write(0,*) &
!                  'ir,jr,kr,cxzc(ir,jr,kr,5)=',ir,jr,kr,cxzc(ir,jr,kr,5)
!              if(.not.(abs(cxzz)>=0.d0))write(0,*) &
!                  'ir,jr,kr,cxzc(ir,jr,kr,6)=',ir,jr,kr,cxzc(ir,jr,kr,6)
!***
                 CXEX=CXXX*CXZW(I,J,K,1)+CXXY*CXZW(I,J,K,2)+CXXZ*CXZW(I,J,K,3)
                 CXEY=CXXY*CXZW(I,J,K,1)+CXYY*CXZW(I,J,K,2)+CXYZ*CXZW(I,J,K,3)
                 CXEZ=CXXZ*CXZW(I,J,K,1)+CXYZ*CXZW(I,J,K,2)+CXZZ*CXZW(I,J,K,3)
                      
!*** diagnostic
!              if(.not.(abs(cxex+cxey+cxez)>=0.d0))then
!                 write(0,*)'i,j,j,ir,jr,kr=',i,j,k,ir,jr,kr
!                 write(0,*)'cxzc(ir,jr,kr,1)=',cxzc(ir,jr,kr,1)
!                 write(0,*)'cxzc(ir,jr,kr,2)=',cxzc(ir,jr,kr,2)
!                 write(0,*)'cxzc(ir,jr,kr,3)=',cxzc(ir,jr,kr,3)
!                 write(0,*)'cxzc(ir,jr,kr,4)=',cxzc(ir,jr,kr,4)
!                 write(0,*)'cxzc(ir,jr,kr,5)=',cxzc(ir,jr,kr,5)
!                 write(0,*)'cxzc(ir,jr,kr,6)=',cxzc(ir,jr,kr,6)
!                 write(0,*)'      cxex=',cxex
!                 write(0,*)'      cxey=',cxey
!                 write(0,*)'      cxez=',cxez
!                 write(0,*)'      cxxx=',cxxx
!                 write(0,*)'      cxxy=',cxxy
!                 write(0,*)'      cxxz=',cxxz
!                 write(0,*)'      cxyy=',cxyy
!                 write(0,*)'      cxyz=',cxyz
!                 write(0,*)'      cxzz=',cxzz
!                 write(0,*)'      cxzw(i,j,k,1)=',cxzw(i,j,k,1)
!                 write(0,*)'      cxzw(i,j,k,2)=',cxzw(i,j,k,2)
!                 write(0,*)'      cxzw(i,j,k,3)=',cxzw(i,j,k,3)
!                 stop
!              endif
!***
                 CXZW(I,J,K,1)=CXEX
                 CXZW(I,J,K,2)=CXEY
                 CXZW(I,J,K,3)=CXEZ
!*** diagnostic
!              if(.not.(abs(cxzw(i,j,k,1))>=0.d0))write(0,*) &
!                 'i,j,k,cxzw(i,j,k,1)=',i,j,k,cxzw(i,j,k,1)
!              if(.not.(abs(cxzw(i,j,k,2))>=0.d0))write(0,*) &
!                 'i,j,k,cxzw(i,j,k,2)=',i,j,k,cxzw(i,j,k,2)
!              if(.not.(abs(cxzw(i,j,k,3))>=0.d0))write(0,*) &
!                 'i,j,k,cxzw(i,j,k,3)=',i,j,k,cxzw(i,j,k,3)
!***
               ENDDO
            ENDDO
         ENDDO

#ifdef openmp
!$omp end parallel do
#endif

      ELSEIF(IPBC==1)THEN

! If IPBC=1, then the full F.t. of the Green function has been stored.

#ifdef openmp
!$omp parallel do                                                &
!$omp& private(K,J,I,CXXX,CXXY,CXXZ,CXYY,CXYZ,CXZZ,CXEX,CXEY,CXEZ)
#endif

         DO K=1,2*NZ
            DO J=1,2*NY
               DO I=1,2*NX
                  CXXX=CXZC(I,J,K,1)
                  CXXY=CXZC(I,J,K,2)
                  CXXZ=CXZC(I,J,K,3)
                  CXYY=CXZC(I,J,K,4)
                  CXYZ=CXZC(I,J,K,5)
                  CXZZ=CXZC(I,J,K,6)
                  CXEX=CXXX*CXZW(I,J,K,1)+CXXY*CXZW(I,J,K,2)+CXXZ*CXZW(I,J,K,3)
                  CXEY=CXXY*CXZW(I,J,K,1)+CXYY*CXZW(I,J,K,2)+CXYZ*CXZW(I,J,K,3)
                  CXEZ=CXXZ*CXZW(I,J,K,1)+CXYZ*CXZW(I,J,K,2)+CXZZ*CXZW(I,J,K,3)
                  CXZW(I,J,K,1)=CXEX
                  CXZW(I,J,K,2)=CXEY
                  CXZW(I,J,K,3)=CXEZ
               ENDDO
            ENDDO
         ENDDO

#ifdef openmp
!$omp end parallel do
#endif

      ENDIF

! Inverse Fourier transform to obtain electric field:

      DO M=1,3
         IF(CMETHD=='GPFAFT')THEN
            CALL CXFFT3N(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ELSEIF(CMETHD=='FFTW21')THEN
            CALL CXFFTW(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ELSEIF(CMETHD.EQ.'FFTMKL')THEN
            CALL CXFFT3_MKL(CXZW(1,1,1,M),2*NX,2*NY,2*NZ,-1)
         ENDIF

!***********************************************************************

! Note: the Convex FFT routine already normalizes result.
!       For other FFT routines need to divide result by NGRID

         IF(CMETHD=='CONVEX')THEN
            DO K=1,NZ
               DO J=1,NY
                  DO I=1,NX
                     CXZE(I,J,K,M)=CXZW(I,J,K,M)
                  ENDDO
               ENDDO
            ENDDO
         ELSE
            FAC=1._WP/REAL(NGRID,KIND=WP)

#ifdef openmp
!$omp parallel do private(k,j,i)
#endif

            DO K=1,NZ
               DO J=1,NY
                  DO I=1,NX
                     CXZE(I,J,K,M)=FAC*CXZW(I,J,K,M)
                  ENDDO
               ENDDO
            ENDDO

#ifdef openmp
!$omp end parallel do
#endif

         ENDIF
      ENDDO
      RETURN
    END SUBROUTINE ESELF

!***********************************************************************

    SUBROUTINE EXTND(CXA,NX,NY,NZ,ISYM,CXB)
      USE DDPRECISION,ONLY: WP

#ifdef openmp
      USE OMP_LIB   !Art for OpenMP function declarations
#endif

      IMPLICIT NONE

!       Using symmetries, extend first octant of coefficient matrix to
!       other octants.

! Originally written by Jeremy Goodman
! 080620 (ASL) modified to use OpenMP
! 080627 (BTD) eself_v4: further mods related to OpenMP
!              reordered several nested do loops
!              introduced variables J2 and K2 to speed computations
! end history
! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:

      INTEGER :: NX,NY,NZ
      COMPLEX(WP) :: CXA(NX+1,NY+1,NZ+1),CXB(2*NX,2*NY,2*NZ)
      INTEGER :: ISYM(3)

! Local variables:

      INTEGER :: I,J,J2,K,K2
      COMPLEX(WP) :: CXZERO

! SAVE statement:

      SAVE CXZERO

! DATA statement:

      DATA CXZERO/(0._WP,0._WP)/
!***********************************************************************
#ifdef openmp
!$omp parallel
!$omp do private(k,j,i)
#endif
      DO K=1,NZ
         DO J=1,NY
            DO I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp enddo
#endif

!-----------------------------------------------------------------------
! x -> -x

#ifdef openmp
!btd 080627 moved I=NX+1 out of loop
!$omp single
#endif
      CXB(NX+1,1:NY,1:NZ)=CXZERO
#ifdef openmp
!$omp end single
!$omp do private(k,j,i)
#endif
      DO K=1,NZ
         DO J=1,NY
            DO I=NX+2,2*NX
               CXB(I,J,K)=CXA(2*NX+2-I,J,K)*ISYM(1)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end do
#endif

!-----------------------------------------------------------------------
! y -> -y

!btd 080627 moved J=NY+1 out of loop, switched order of loops I and J
#ifdef openmp
!$omp single
#endif
      CXB(1:2*NX,NY+1,1:NZ)=CXZERO
#ifdef openmp
!$omp end single
!$omp do private(k,j,i) private(j2)
#endif
      DO K=1,NZ
         DO J=NY+2,2*NY
            J2=2*NY+2-J
            DO I=1,2*NX
               CXB(I,J,K)=CXB(I,J2,K)*ISYM(2)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end do
#endif

!-----------------------------------------------------------------------
! z -> -z

#ifdef openmp
!Art pulling the 3rd dimension to the outer most loop.
!Art we'll do this expression in only the thread that has NZ+1
!btd 080627 reorder loops: J,I,K -> K,J,I
!
!$omp single
#endif
      CXB(1:2*NX,1:2*NY,NZ+1)=CXZERO
#ifdef openmp
!$omp end single
!$omp do private(k,j,i) private(k2)
#endif
      DO K=NZ+2,2*NZ
         K2=2*NZ+2-K
         DO J=1,2*NY
            DO I=1,2*NX
               CXB(I,J,K)=CXB(I,J,K2)*ISYM(3)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end do
!$omp end parallel
#endif

      RETURN
    END SUBROUTINE EXTND
!***********************************************************************

    SUBROUTINE TRIM(CXB,NX,NY,NZ,CXA)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Copy the first octant of CXB into CXA

! Originally written by Jeremy Goodman
! History:
! 92.04.20 (BTD) removed ISYM from argument list of TRIM:
! 06.09.28 (BTD) eself v2.0
! 08.06.27 (BTD) eself_v4
!                
! Copyright (C) 1993,2006 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:

      INTEGER :: NX,NY,NZ
      COMPLEX(WP) ::          &
         CXA(NX+1,NY+1,NZ+1), &
         CXB(2*NX,2*NY,2*NZ)

! Local variables:

      INTEGER :: I,J,K

!***********************************************************************

#ifdef openmp
!$omp parallel do          &
!$omp&    private(k,j,i)   &
!$omp&    shared(NX,NY,NZ) &
!$omp&    shared(CXA,CXB)
#endif
      DO K=1,NZ+1
         DO J=1,NY+1
            DO I=1,NX+1
               CXA(I,J,K)=CXB(I,J,K)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end parallel do
#endif
      RETURN
    END SUBROUTINE TRIM

!***********************************************************************

    SUBROUTINE PAD(CXA,NX,NY,NZ,CXB)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Pad the array CXA with zeros out to twice its length in each
! dimension, and put the result in CXB.

! Originally written by Jeremy Goodman

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:
      INTEGER :: NX,NY,NZ
      COMPLEX(WP) ::       &
         CXA(NX,NY,NZ),    &
         CXB(2*NX,2*NY,2*NZ)
! Local variables:
      COMPLEX(WP) :: CXZERO
      INTEGER :: I,J,K
      SAVE CXZERO
      DATA CXZERO/(0._WP,0._WP)/
!***********************************************************************
#ifdef openmp
!$omp parallel
!$omp do private(k,j,i)
#endif
      DO K=1,2*NZ
         DO J=1,2*NY
            DO I=1,2*NX
               CXB(I,J,K)=CXZERO
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end do
!$omp do private(k,j,i)
#endif
      DO K=1,NZ
         DO J=1,NY
            DO I=1,NX
               CXB(I,J,K)=CXA(I,J,K)
            ENDDO
         ENDDO
      ENDDO
#ifdef openmp
!$omp end do
!$omp end parallel
#endif

      RETURN
    END SUBROUTINE PAD

!-----------------------------------------------------------------------

    SUBROUTINE DIRECT_CALC(IX,IY,IZ,NX,NY,NZ,IPBC,DX,AK,AKD,AKD2,GAMMA, &
                           PYDDX,PZDDX,CXZC)
      USE DDPRECISION,ONLY: WP
      USE DDCOMMON_10,ONLY: MYID
#ifdef openmp
      USE OMP_LIB   !! Art omp v2.0 supplies variable and function definitions
#endif
      IMPLICIT NONE

! arguments:

      INTEGER :: IPBC,IX,IY,IZ,NX,NY,NZ
      REAL(WP) :: AKD,AKD2,GAMMA,PYDDX,PZDDX
      REAL(WP) :: &
         AK(3),   &
         DX(3)
      COMPLEX (WP) ::                                             &
         CXZC(NX+1+IPBC*(NX-1),NY+1+IPBC*(NY-1),NZ+1+IPBC*(NZ-1),6)

! local variables

      CHARACTER :: CMSGNM*70
      INTEGER :: I,ICXZC,II,IMIN,J,JCXZC,JJ,JMIN,JPY,JPYM,JPZ,JPZM, &
                 K,KCXZC,KMIN,M
      REAL(WP) :: GAMMAKD4,PHASY,PHASYZ,R,R2,R3,RANGE,RANGE2,RJPY, &
                  RJPZ,T0,T1,T2,X0,X2,X2Y2,XX,Y0,Y2,Z0
      REAL(WP) :: X(3)
      COMPLEX(WP) :: CXFAC,CXI,CXPHAS,CXTERM,CXZERO
      COMPLEX(WP) :: DCXSUM(6)
      SAVE CXZERO,CXI
      DATA CXI/(0._WP,1._WP)/,CXZERO/(0._WP,0._WP)/

!-----------------------------------------------------------------------
! subroutine DIRECT_CALC

! calculates electric field at (I,J,K) due to dipole at (1,1,1)
!                                      plus its replicas
! given:
!        IX,IY,IZ = 1, 1, 1 to do octant I>0, J>0, K>0 only
!                   1, 1,-1              I>0, J>0, all K
!                   1,-1, 1              I>0, K>0, all J
!                   1,-1,-1              I>0, all J, all K
!                  -1, 1, 1              all I, J>0, K>0
!                  -1, 1,-1              all I, J>0, all K
!                  -1,-1, 1              all I, all J, K>0
!                  -1,-1,-1              all I, all J, all K

!        IPBC     = 0 if only doing first octant (IX=IY=IZ=1)
!                 = 1 otherwise
!                   N.B.: IPBC affects dimensioning of CXZC

!        NX,NY,NZ = size of first octant (I = 1 -> NX,
!                                         J = 1 -> NY,
!                                         K = 1 -> NZ)
!        PYDDX     = period of lattice in y direction/d
!        PZDDX     = period of lattice in z direction/d
!        DX(1-3)   = lattice spacing in x,y,z direction, in units of
!                    d = n**(-1/3).
!        AK(1-3)   = k(1-3)*d, where k = k vector in vacuo
!        AKD       = |k|d
!        CXZC      = array with dimensions
!                    (NX+1)*(NY+1)*(NZ+1)*6 if IPBC=0
!                    (2*NX)*(2*NY)*(2*NZ)*6 if IPBC=1

! JPYM = maximum number of periods in Y direction
!        rmax = JPYM*PYDDX
! note that even for short-range interaction, need to extend sums
! from JPY=-1 to JPY=+1 to include "edge" interactions with next TUC

! PYD=0. for nonperiodic case
!    >0. for periodic boundary conditions in y direction

! Adapted from original subroutine ESELF written by Jeremy Goodman
! history:
! 06.09.28 (BTD) DIRECT_CALC works for isolated target
! 06.09.30 (BTD) further modifications to DIRECT_CALC
!                change definition of BETA, so that given BETA 
!                determines range/wavelength
! 08.03.11 (BTD) v7.0.5
!                * eliminate BETA, introduce ALPHA=BETA**(0.25)
! 08.03.15 (BTD) * added code to estimate time to completion
!                  may need to change way this is done before running under MPI
! 08.03.15 (BTD) * added DDCOMMON_10 to communicate value of MYID.
! 08.04.20 (BTD) * changed notation: ALPHA -> GAMMA
! 08.06.05 (ASL) v7.0.6: 
!                * Arthur S. Lazanoff added OpenMP directives
! 08.07.02 (BTD) * Added call to CPU_TIME(T0) outside of PARALLEL region
!                
! end history
!-----------------------------------------------------------------------
!*** diagnostic
!      write(0,*)'direct_calc ckpt 1'
!***
      GAMMAKD4=(GAMMA*AKD)**4
      RANGE=2._WP/(GAMMA*AKD)
      RANGE2=RANGE*RANGE
      IF(PYDDX<=0._WP)THEN
         JPYM=0
      ELSE
         JPYM=1+NINT(RANGE/PYDDX)
      ENDIF

!*** diagnostic
!      write(0,*)'jpym=',jpym
!***
! Compute 6 independent elements of 3x3 symmetric matrix A_jk, where
! A_jk*P_k = -electric field at location j due to dipole P_k at location

! A_jk = (a_1  a_2  a_3)
!        (a_2  a_4  a_5)
!        (a_3  a_5  a_6)_jk

! initialize CX(I,J,K,M) = a_M for electric field at (I,J,K)
!                          produced by a dipole at (1,1,1)
!                          and replica dipoles (if PYD or PYZ are
!                          nonzero).

! need to calculate this for all (I,J,K) for one octant:
! I running from 1 to NX, J from 1 to NY, K from 1 to NZ

! X0,Y0,Z0 = X(I,J,K) - X(1,1,1) = vector from dipole location (1,1,1)
!                                  to point where E is to be calculated
! IX = +1 -> IMIN = 1
! IX = -1 -> IMIN = 2-NX   (1-IMIN = NX-1)

      IMIN=1+(1-NX)*(1-IX)/2
      JMIN=1+(1-NY)*(1-IY)/2
      KMIN=1+(1-NZ)*(1-IZ)/2
#ifdef openmp
      if(myid==0.and.omp_get_thread_num()==0)then
!Art omp_get_num_threads is an integer function defined in omp_lib
         write(0,*)'direct_calc ckpt 1: omp_get_num_threads = ', &
                   omp_get_num_threads()
!         write(0,*)'DIRECT_CALC: kmin, nz = ',kmin,nz,nz-kmin+1
!         write(0,*)'DIRECT_CALC: jmin, ny = ',jmin,ny,ny-jmin+1
!         write(0,*)'DIRECT_CALC: imin, nx = ',imin,nx,nx-imin+1
      endif
#endif

! Determine elapsed cpu time for these sums

      CALL CPU_TIME(T0)

#ifdef openmp
!$omp parallel
!$omp do                                                 &
!$omp&   private(K,J,I,M,JPY,JPZ,II)                     &
!$omp&   private(JCXZC,JPZM,KCXZC)                       &
!$omp&   private(PHASY,PHASYZ,R2,R3,RJPY,RJPZ)           &
!$omp&   private(X,X0,X2,X2Y2,XX,Y0,Y2,Z0)               &
!$omp&   private(CXFAC,CXTERM,CXPHAS,DCXSUM)
#endif
      DO K=KMIN,NZ              !- loop over K
         Z0=REAL(K-1,KIND=WP)*DX(3)
         IF(K>0)THEN
            KCXZC=K
         ELSE
            KCXZC=2*NZ+K
         ENDIF
         DO J=JMIN,NY              !-- loop over J
            Y0=REAL(J-1,KIND=WP)*DX(2)
            IF(J>0)THEN
               JCXZC=J
            ELSE
               JCXZC=2*NY+J
            ENDIF
            DO I=IMIN,NX              !--- loop over I

! for first dipole, determine time to sum over replicas

               IF(I.EQ.IMIN.AND.J.EQ.JMIN.AND.          &
                  K.EQ.KMIN.AND.MYID==0)CALL CPU_TIME(T1)

               X0=REAL(I-1,KIND=WP)*DX(1)
               IF(I>0)THEN
                  ICXZC=I
               ELSE
                  ICXZC=2*NX+I
               ENDIF
               X(1)=X0
               X2=X0**2
               DO M=1,6
                  DCXSUM(M)=CXZERO
               ENDDO

! JPY=0, JPZ=0 gives E field from dipole at (1,1,1)
! general JPY,JPZ gives E field from dipole at
! (1,JPY*NPY+1,JPZ*NPZ+1)
! replica dipoles have same magnitude of polarization as dipole (1,1,1),
! but different phase.
! PHASYZ = phase of replica dipole - phase of dipole (1,1,1)

               DO JPY=-JPYM,JPYM         !---- loop over JPY
                  RJPY=REAL(JPY,KIND=WP)*PYDDX
                  X(2)=Y0-RJPY
                  Y2=X(2)*X(2)
                  X2Y2=X2+Y2
                  PHASY=AK(2)*RJPY

! PZDDX=0. for nonperiodic case
!      >0. for periodic boundary conditions in z direction

                  IF(PZDDX<=0._WP)THEN
                     JPZM=0
                  ELSE
                     JPZM=1+NINT(SQRT(MAX(RANGE2-RJPY**2,0._WP))/PZDDX)
                  ENDIF

!*** diagnostic
!      write(0,*)'jpy,jpzm=',jpy,jpzm
!***
                  DO JPZ=-JPZM,JPZM         !----- loop over JPZ
!*** diagnostic
!      write(0,*)'jpz=',jpz
!***

                     RJPZ=REAL(JPZ,KIND=WP)*PZDDX
                     X(3)=Z0-RJPZ
                     R2=X2Y2+X(3)*X(3)

! skip the self-interaction (R=0) case (I=J=K=1 and JPY=JPZ=0)

                     IF(R2>1.E-6_WP)THEN

                        R=SQRT(R2)
                        R3=R*R2

! PHASYZ = phase at (1,JPY*NPY+1,JPZ*NPZ+1) - phase at (1,1,1)

                        PHASYZ=PHASY+AK(3)*RJPZ

! include artificial factor exp[-(gamma*kr)^4] to assist convergence

                        CXTERM=CXI*AKD*R
                        CXPHAS=EXP(CXTERM+CXI*PHASYZ-GAMMAKD4*R2*R2)/R3
                        CXFAC=(1._WP-CXTERM)/R2

! II=1      -> M=1   a_1 (xx)
!      JJ=2      2   a_2 (xy)
!         3      3   a_3 (xz)
!    2           4   a_4 (yy)
!         3      5   a_5 (yz)
!    3           6   a_6 (zz)

                        M=0
                        DO II=1,3              !------ loop over II
                           M=M+1
                           DCXSUM(M)=DCXSUM(M)-CXPHAS*(AKD2*(X(II)**2-R2)+ &
                                     CXFAC*(R2-3._WP*X(II)**2))
                           IF(II<3)THEN
                              DO JJ=II+1,3        !------- loop over JJ
                                 M=M+1
                                 XX=X(II)*X(JJ)
                                 DCXSUM(M)=DCXSUM(M)-                      &
                                           CXPHAS*(AKD2*XX-CXFAC*(3._WP*XX))
                              ENDDO               !------- end loop over JJ
                           ENDIF
                        ENDDO                  !------ end loop over II
                     ENDIF
                  ENDDO                     !----- end loop over JPZ
               ENDDO                     !---- end loop over JPY
               DO M=1,6
                  CXZC(ICXZC,JCXZC,KCXZC,M)=DCXSUM(M)
               ENDDO
               IF(I==IMIN.AND.J==JMIN.AND.K==KMIN.AND.MYID==0)THEN

! NB: this call to CPU_TIME occurs within the first thread
!     (I==IMIN, J==JMIN, K==KMIN)

                  CALL CPU_TIME(T2)
                  T2=REAL((NX-IMIN+1)*(NY-JMIN+1)*(NZ-KMIN+1),KIND=WP)*(T2-T1)
                  IF(T2<600._WP)THEN
                     WRITE(CMSGNM,FMT='(A,F8.2,A)')                         &
                        'Estimated total cputime required by DIRECT_CALC=', &
                        T2,' cpu-sec'
                  ELSEIF(T2>=600._WP.AND.T2<3600._WP)THEN
                     WRITE(CMSGNM,FMT='(A,F8.2,A)')                         &
                        'Estimated total cputime required by DIRECT_CALC=', &
                        (T2/60._WP),' cpu-min'
                  ELSE
                     WRITE(CMSGNM,FMT='(A,F8.2,A)')                         &
                        'Estimated total cputime required by DIRECT_CALC=', &
                        (T2/3600._WP),' cpu-hr'
                  ENDIF
                  CALL WRIMSG('DIRECT_CALC',CMSGNM)
                  IF(PYDDX*PZDDX>0)THEN
                     WRITE(CMSGNM,FMT='(A)')          &
                          'cputime scales as 1/gamma^2'
                  ELSE
                     IF(PYDDX+PZDDX==0)THEN
                        WRITE(CMSGNM,FMT='(A)')               &
                              'cputime is independent of gamma'
                     ELSE
                        WRITE(CMSGNM,FMT='(A)')           &
                              '[cputime scales as 1/gamma]'
                     ENDIF
                  ENDIF
                  CALL WRIMSG('DIRECT_CALC',CMSGNM)
              ENDIF
            ENDDO                     !--- end loop over I
         ENDDO                     !-- end loop over J
      ENDDO                     !- end loop over K
#ifdef openmp
!$omp end do
!$omp end parallel
#endif
!*** diagnostic
!      write(0,*)'direct_calc ckpt 2'
!***
      CALL CPU_TIME(T2)
!*** diagnostic
!      write(0,*)'direct_calc ckpt 3'
!***
      T2=T2-T0
      IF(MYID==0)THEN
         IF(T2<600.D0)THEN
            WRITE(CMSGNM,FMT='(A,F8.2,A)')                   &
                  'Actual cputime to complete DIRECT_CALC=', &
                  T2,' cpu-sec'
         ELSEIF(T2>=600._WP.AND.T2<3600._WP)THEN
            WRITE(CMSGNM,FMT='(A,F8.2,A)')                   &
                  'Actual cputime to complete DIRECT_CALC=', &
                  (T2/60._WP),' cpu-min'
         ELSE
            WRITE(CMSGNM,FMT='(A,F8.2,A)')                   &
                  'Actual cputime to complete DIRECT_CALC=', &
                  (T2/3600._WP),' cpu-hr'
         ENDIF
         CALL WRIMSG('DIRECT_CALC',CMSGNM)
      ENDIF

!*** diagnostic
!      write(0,*)'direct_calc ckpt 4'
!***

! If IPBC=1: set the elements with ICXZC=NX+1 or JCXZC=NY+1
!            or KCXZC=NZ+1 to zero

      IF(IPBC==1)THEN
#ifdef openmp
!$omp parallel
#endif 
         DO M=1,6
#ifdef openmp
!$omp do                    &
!$omp&   private(KCXZC,JCXZC)
#endif
            DO KCXZC=1,2*NZ
               DO JCXZC=1,2*NY
                  CXZC(NX+1,JCXZC,KCXZC,M)=CXZERO
               ENDDO
            ENDDO
#ifdef openmp
!$omp end do
!$omp do                    &
!$omp&   private(KCXZC,ICXZC)
#endif
            DO KCXZC=1,2*NZ
               DO ICXZC=1,2*NX
                  CXZC(ICXZC,NY+1,KCXZC,M)=CXZERO
               ENDDO
            ENDDO
#ifdef openmp
!$omp end do
!$omp do                    &
!$omp&   private(JCXZC,ICXZC)
#endif
            DO JCXZC=1,2*NY
               DO ICXZC=1,2*NX
                  CXZC(ICXZC,JCXZC,NZ+1,M)=CXZERO
               ENDDO
            ENDDO
#ifdef openmp
!$omp end do
#endif
         ENDDO
#ifdef openmp
!$omp end parallel
#endif
 
      ENDIF
      RETURN
 6700 FORMAT(F8.2,' cpu-sec')
 6701 FORMAT(F8.2,' cpu-min')
 6702 FORMAT(F8.2,' cpu-hr')
    END SUBROUTINE DIRECT_CALC

    SUBROUTINE REAPAR(CBINFLAG,AEFFA,BETAMI,BETAMX,CALPHA,CFLEPS,CFLPAR,     &
                      CFLSHP,CMDSOL,CMDFFT,CMDFRM,CSHAPE,CMDTRQ,CXE01,CXE02, &
                      DEGRAD,ETASCA,GAMMA,IDVERR,IDVOUT,INIT,IOPAR,IORTH,    &
                      JPBC,IWRKSC,IWRPOL,MXNX,MXNY,MXNZ,MXBETA,MXCOMP,MXPHI, &
                      MXRAD,MXSCA,MXTHET,MXWAV,NBETA,NCOMP,NPHI,NRAD,NSCA,   &
                      NTHETA,NWAV,IWAV0,IRAD0,IORI0,NSMELTS,PHIMIN,PHIMAX,   &
                      PHIN,THETAN,THETMI,THETMX,TOL,WAVEA,SHPAR,SMIND1,      &
                      SMIND2,DX)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Arguments:

      CHARACTER :: CALPHA*(*),CBINFLAG*(*),CFLPAR*(*),CFLSHP*80,CMDSOL*(*), &
                   CMDFFT*(*),CMDFRM*(*),CMDTRQ*(*),CSHAPE*(*)
      INTEGER :: IDVERR,IDVOUT,INIT,IOPAR,IORI0,IORTH,JPBC,IRAD0,IWAV0,      &
                 IWRKSC,IWRPOL,MXBETA,MXCOMP,MXNX,MXNY,MXNZ,MXPHI,MXRAD,     &
                 MXSCA,MXTHET,MXWAV,NBETA,NCOMP,NPHI,NRAD,NSCA,NSMELTS,NWAV, &
                 NTHETA
      INTEGER ::    &
         SMIND1(9), &
         SMIND2(9)
      CHARACTER(60) :: &
         CFLEPS(MXCOMP)
      REAL(WP) :: BETAMI,BETAMX,DEGRAD,ETASCA,GAMMA,PHIMIN,PHIMAX, &
                  THETMI,THETMX,TOL
      REAL(WP) ::       &
         AEFFA(MXRAD),  &
         DX(3),         &
         PHIN(MXSCA),   &
         SHPAR(12),     &
         THETAN(MXSCA), &
         WAVEA(MXWAV)
      COMPLEX(WP) :: &
         CXE01(3),   &
         CXE02(3)

! Local variables:

      CHARACTER :: CDIVID*3,CLINE*70,CMSGNM*70,CWHERE*70
      INTEGER :: J,JPLANE,NPLANES,NSCA0
      REAL(WP) :: AEFEND,AEFINI,DELTA,DTHETA,E1,PHI1,THETA1,THETA2, &
         WAVEND,WAVINI

! External routines:

      EXTERNAL DIVIDE,ERRMSG,WRIMSG

!***********************************************************************
! Subroutine REAPAR handles the reading of input parameters from the
! "ddscat.par" file, as well as elementary processing with those input
! parameters to generate arrays.

! Given:
!       CFLPAR = name of file (normally 'ddscat.par')

! Returns:
!       CMDTRQ   = 'NOTORQ' or 'DOTORQ'
!       CMDSOL   = 'PBCGST' or 'PBCGS2' or 'PETRKP'
!       CMDFFT   = 'GPFAFT' or 'FFTW21' or 'FFTMKL'
!       CALPHA   = 'LATTDR' or 'GKDLDR'
!       CBINFLAG = 'ALLBIN' or 'ORIBIN' or 'NOTBIN'
!       CSHAPE   = 'RCTGLPRSM' or 'ELLIPSOID' or ... other valid shape
!       JPBC     = 0 :isolated finite targets
!                = 1 :target periodic in y direction, finite in z
!                = 2 :target finite in y direction, periodic in z
!                = 3 :target periodic in both y and z directions
!       NCOMP    = number of compositions
!       CFLEPS(1-NCOMP) = filenames for dielectric functions
!       INIT     = 0 or 1 or 2
!       TOL      = error tolerance
!       GAMMA    = parameter controlling integration limit for PBC
!       ETASCA   = parameter controlling accuracy of calculation
!                  of <cos(theta)>
!                  1 is OK, 0.5 gives high accuracy
!       NWAV     = number of wavelengths
!       WAVEA(1-NWAV) = wavelengths (physical units)
!       NRAD     = number of radii
!       AEFFA(1-NRAD) = target effective radii (physical units)
!       CXE01(1-3)= (complex) polarization state 1
!       CXE02(1-3)= complex polarization state 2 (orthogonal to 1)
!       IORTH    = 1 or 2 (number of incident polarization states to use
!       IWRKSC   = 0 or 1 (not write/write ".sca" files)
!       IWRPOL   = 0 or 1 (not write/write ".pol" files)
!       NBETA    = number of beta values for target rotation
!       BETAMI   = minimum beta value (rad) [input from file in deg]
!       BETAMX   = maximum beta value (rad) [input from file in deg]
!       NTHETA   = number of theta values for target rotation
!       THETAMI  = minimum theta value (rad) [input from file in deg]
!       THETAMX  = maximum theta value (rad) [input from file in deg]
!       NPHI     = number of PHI values for target rotation
!       PHIMIN   = minimum PHI value (rad) [input from file in deg]
!       PHIMAX   = maximum PHI value (rad) [input from file in deg]
!       NSMELTS  = number of elements of S matrix to calculate
!                  (less than or equal to 9)
!       SMINDI(J) = indices of S matrix elements to be calculated
!                   (e.g., 11 , 21 , 31 , 41 , 12 , 13)
!       CMDFRM   = 'LFRAME' or 'TFRAME' (Lab frame or Target frame)
!       NSCA     = number of scattering directions

! If JPBC=0:
!       THETAN(1-NSCA) = theta for scattering directions (rad)
!       PHIN(1-NSCA) = phi for scattering directions (rad)

! If JPBC=1 or 2:
!       THETAN(1-NSCA) = order_y or order_z for scattering directions
!       PHIN(1-NSCA)   = psi (radians) for scattering directions,
!                        where psi = rotation around axis of
!                        target periodicity (y_TF if JPBC=1, z_TF if JPB

! If JPBC=3: periodic in both y and z directions
!       THETAN(1-NSCA) = order_y for diffraction
!       PHIN(1-NSCA)   = order_z for diffraction

! Original version created by P.J.Flatau, Colorado State Univ.
! Modified by B.T.Draine, Princeton Univ. Obs.
! History:
! 90.11.09 (BTD): Modified so as to remove sensitivity to errors
!                 in sign of entered value of DTHETA.
! 90.11.30 (BTD): Added test to compare CMDFFT and MXMEM
! 90.12.14 (BTD): Changed option MKRECT to RCTGLPRSM
! 91.01.03 (BTD): Added MXBETA,MXPHI,MXTHET to argument list
!                 and added checking of NBETA,NPHI,NTHETA
! 91.05.08 (BTD): Added CALPHA to allow choice of prescription
!                 for polarizabilities
! 91.05.08 (BTD): Some rewriting done.
! 91.05.14 (BTD): Added separate options LDRXYZ and LDRAVG
! 91.05.15 (BTD): Added new option LDR000
! 91.05.23 (BTD): Added variable IWRKSC to argument list and
!                 added code to read IWRKSC
! 91.05.30 (BTD): Changed LDRXYZ->LDR100
!                 Added option LDR111
! 91.11.13 (BTD): Now three options: DRAI88, GOBR88, LATTDR
!                 (subroutine ALPHA now allows for directional
!                 dependence for LATTDR option)
! 92.05.14 (BTD): Allow for experimental option LDRISO
! 92.09.21 (BTD): Allow for option ANIELLIPS (ellipsoid of anisotropic
!                 material); change option GRPHIT -> UNIAXICYL (cylinder
!                 of uniaxial material)
! 93.01.07 (BTD): Allow for options ELLIPSO_2 and ANI_ELL_2 (two touching
!                 ellipsoids, each either isotropic or anisotropic)
! 93.03.11 (BTD): Deleted all code associated with variable CMACHN
!                 which previously was used to identify machine/OS
!                 This information was not used or needed.
! 93.12.15 (BTD): Added code to check for compatibility of NCOMP
!                 when CSHAPE=ELLIPSO_2,ELLIPSO_3,ANI_ELL_2,or ANI_ELL_3
! 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6)
!                 Added CONELLIPS (two concentric ellipsoids) as target
!                 option.
! 94.06.20 (PJF): Added code to handle NEWTMP
! 94.12.02 (BTD): Added options
!                    LB1991 (Dungey-Bohren 1991 polarizability)
!                    LR1994 (Lumme-Rahola 1994 polarizability)
! 95.05.26 (BTD): Corrected construction of orthogonal polarization
!                 state for case where E01 is complex (e.g.,
!                 circular polarization)
! 95.06.14 (BTD): Added code to check that user is not requesting
!                 f_ml when illuminating target with other then
!                 linearly polarized light
! 95.06.19 (BTD): Added argument CMDSOL to allow selection of
!                 different CCG methods
!                 Added argument CMDTRQ to allow torque calculations
!                 to be skipped.
! 96.01.05 (BTD): Added shape options MLTBLOCKS and DW1996TAR
! 96.01.25 (BTD): Added shape option SPHROID_2
! 96.01.25 (BTD): Disable code added 95.06.14 so that user can
!                 calculate f_ml even when illuminating target with
!                 elliptically polarized light.
! 96.10.18 (BTD): Changed option NEWTMP to GPFAFT (Generalized Prime
!                 Factor Algorithm for Fourier Transform).
! 96.11.06 (BTD): Added provision to
!                 (1) produce fatal error if CXE01(1).NE.(0.,0.)
!                 (2) normalize CXE01 if necessary
! 96.11.14 (PJF): cbinflag for binary file
! 96.11.15 (PJF): netCDF netflag
! 96.11.21 (BTD): modified handling of CBINFLAG and CNETFLAG to
!                 be consistent with other option flags
! 97.11.01 (BTD): add DX to argument list
!                 read DX from ddscat.par
!                 renormalize DX (input DX not required to be
!                 normalized with DX(1)*DX(2)*DX(3)=1.)
! 98.12.06 (BTD): modified to read NSMELTS,SMELTS from ddscat.par
!                 and pass NSMELTS,SMIND1,SMIND2 as arguments to calling
!                 program DDSCAT
! 98.12.21 (BTD): changed dimension of CFLPAR from CHARACTER*40 to
!                 CHARACTER*60 to allow longer file names
!                 (also changed in DDSCAT.f and dielec.f)
! 98.12.29 (BTD): modified to support new option LYRD_SLAB
! 99.01.26 (BTD): modified to allow first IWAV,IRAD,IORI to be
!                 specified in ddscat.par (useful for restarting
!                 jobs which did not complete)
! 99.06.29 (BTD): corrected input of SHPAR for option SPHROID_2
!                 previously had input only SHPAR(1-5),
!                 now input SHPAR(1-6)
! 00.06.12 (BTD): modified to support SPHERES_N option
! 00.06.23 (BTD): modified to support FFTWFJ option
!                 remove MXMEM from argument list
!                 since no longer supporting TMPRTN FFT option which
!                 required additional memory
! 00.07.05 (BTD): modified to print more information about CMDFFT
!                 option
! 02.02.12 (BTD): modified to support TRNGLPRSM option
! 03.01.29 (BTD): modified to force DX(1-3)=1.
! 03.05.21 (BTD): modified to support SPHARM option
! 03.05.22 (BTD): bug fix re SPHARM option
! 03.07.13 (BTD): changed FFTWFJ to FFTW21 in anticipation of future
!                 option FFTW3x (FFTW 2.1.x and FFTW 3.0.1 have
!                 different interfaces, so they must be distinguished).
! 03.10.23 (BTD): removed ICTHM and IPHIM from argument list,
!                 removed code to read these values from ddscat.par
! 03.10.24 (BTD): Add parameter ETASCA to allow user to control
!                 angular resolution used for scattering calculations.
!                 Add checks against invalid input
! 04.02.26 (BTD): Modify to accept polarizability option 'GKDLDR'
!                 for Gutkowicz-Krusin & Draine (2004) lattice
!                 dispersion relation.
! 04.04.01 (BTD): Modify to support option NPSPBC (multi-sphere cluster
!                 with periodic boundary conditions)
! 04.04.05 (BTD): Remove SPHARM option: GAUSS_SPH is sufficient
! 04.04.29 (BTD): Added ANIRCTNGL option for homogeneous anisotropic
!                 rectangular target
! 04.05.23 (BTD): Added CWHERE string to provide error information
!                 in case of malformed ddscat.par file.
! 04.09.14 (BTD): Permit new target option ANIFRMFIL, to read target data
!                 from file, with target allowed to be anistropic
!                 with arbitrary orientations of local "Dielectric Frame
!                 (in which local dielectric tensor is diagonalized)
!                 relative to Target Frame.
! 04.10.12 (BTD): Modified to support new target option SPH_ANI_N, for
!                 a target composed of N possibly anisotropic spheres.
! 04.10.14 (BTD): Modified to support option of reading wavelengths
!                 from file 'wave.tab' if CDIVID='TAB' in ddscat.par
! 05.03.19 (BTD): Added 2 lines to set CLFEPS(1) in case using options
!                 H2OLIQ or H2OICE (previously were left undefined,
!                 which cause problems with output statement)
! 05.08.04 (BTD): Added requirement to read string CMDFRM where
!                 CMDFRM = 'LFRAME' to specify scattering directions in
!                          Lab Frame (rel. to xlab,ylab,zlab,
!                          where xlab = direction of incident beam
!                 CMDFRM = 'TFRAME' to specify scattering directions in
!                          Target Frame (rel. to a1,a2,a3)
! 05.10.18 (BTD): Added check to ensure that NBETA*NTHETA*NPHI < 1001
!                 if IWRKSC=1 (since current version of NAMER is limited
!                 to maximum of 1000 directions)
! 06.04.10 (BTD): Added IWRPOL to argument list, and modified REAPAR
!                 to read IWRPOL from ddscat.par in order to allow
!                 user to elect to write or to not write out polarizatio
!                 array for subsequent processing.
! 06.09.13 (BTD): Added handling of option CYLNDRCAP
! 06.09.15 (BTD): Modified to support new version of target routine
!                 TARHEX, that now requires SHPAR(3) to select prism
!                 orientation.
! 06.09.15 (BTD): Modified to support new target option HEXGONPBC
! 06.10.04 (BTD): Extension to support new scattering directions
!                 required for far-field scattering when PBC is used.
! 06.10.11 (BTD): Corrected errors in handling of JPBC=2,3,
! 06.11.29 (BTD): Added code to catch error in input CMDFRM
! 06.12.08 (BTD): Added support for target option DSKRCTPBC
! 07.01.20 (BTD): Added support for target option DSKRCTNGL
! 07.02.23 (BTD): Added support for target option LYRSLBPBC
! 07.02.25 (BTD): Corrected bug (typo)
! 07.08.05 (BTD): Version 7.0.3
!                 Add code to read MXNX,MXNY,MXNZ from ddscat.par
! 07.08.12 (BTD): Allow CMDSOL='PBCGS2'
! 07.10.26 (BTD): Add support for target option DSKBLYPBC
!                 reorder input shape paramers SHPAR for DSKRCTPBC
!                 changed SHPAR(6) -> SHPAR(10)
! 07.10.27 (BTD): Further improve of reapar
!                 Eliminate CDIEL -- option 'TABLES' is now the only
!                 one used, so no need to input and carry around CDIEL
! 08.02.01 (BTD): Changed SHPAR(10) -> SHPAR(12) to allow up to 12
!                 shape parameters to be input
!                 Added support for target option BLSLINPBC
!                 Added support for target option RCTGLBLK3
!                 Added support for target option TRILYRPBC
! 08.03.11 (BTD): corrected typo: BLSLINPBC -> BISLINPBC
! 08.03.11 (BTD): ver7.0.5
!                 Added ALPHA to argument list.
!                 Modified to read parameter ALPHAA from ddscat.par
! 08.03.12 (BTD): Modified to read NPLANES from ddscat.par
!                 so that we no longer rely on END condition when reading
!                 scattering directions or scattering planes from ddscat.par
! 08.03.12 (BTD): Modified to use new form of ddscat.par
!                 eliminate reading of INIT (since we always set INIT=0)
!                 add new descriptive lines separating ddscat.par into sections
! 08.04.19 (BTD): Changed notation: ALPHA -> GAMMA
!                 reordered argument list
! 08.06.07 (BTD): Added support for FFT option FFTMKL
! 08.07.22 (BTD): Added sanity check to catch users who call for SPHERES_N but
!                 specify multiple dielectric functions
! 08.08.29 (BTD): Removed CNETFLAG from argument list
!                 Removed code to read CNETFLAG from ddscat.par
! 08.09.12 (BTD): Corrected typo DSKRCTGNL -> DSKRCTNGL
! 08.09.16 (BTD): Corrected bug reported by Wang Lin, Nankai Univ.:
!                 typo SPHERN_PBC -> SPHRN_PBC caused SPHERN_PBC to be 
!                 assigned JPBC=0 regardless of values of SHPAR(2) or SHPAR(3).
! 08.09.23 (BTD): Corrected typo DSKBLYPRC -> DSKLBYLRPBC line 613
!                 [typo reported by Georges Levi, Univ-Paris-Diderot]
! 09.12.11 (BTD): Corrected coding error which prevented use of
!                 target options DW1996TAR and MLTBLOCKS
! end history
! Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2002,2003,2004
!               2005,2006,2007,2008,2009 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.

!***********************************************************************

      OPEN(UNIT=IOPAR,FILE=CFLPAR,STATUS='OLD')
      CWHERE='error reading line 1 of ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG('REAPAR',CLINE)
      CWHERE='error reading line 2 of ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)

!=======================================================================
!    Specify whether torques are to be calculated:

!    CMDTRQ*6 = 'DOTORQ' -  calculate torque on grain
!             = 'NOTORQ' -  do not calculate torque on grain

      CWHERE='error reading CMDTRQ from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CMDTRQ
      IF(CMDTRQ=='dotorq')CMDTRQ='DOTORQ'
      IF(CMDTRQ=='notorq')CMDTRQ='NOTORQ'
      IF(CMDTRQ=='DOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDTRQ=='NOTORQ')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDTRQ,' - do not compute torques '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
! diagnostic
         write(0,*)'reapar ckpt 0.1 : CMDTRQ=',CMDTRQ
!
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDTRQ')
      ENDIF

!=======================================================================
!    Define method used for iterative solution of complex linear equations

!    CMDSOL*6 = 'PETRKP' -  Petravic & Kuo-Petravic method
!             = 'PBCGST' -  PIM BiConjugate Gradient with Stabilization
!             = 'PBCGS2' -  M.A Botcheve implementation of BiCGstab 
!                           enhanced to improve convergence properties
!                           with finite precision arithmetic

      CWHERE='error reading CMDSOL from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99) CMDSOL
      IF(CMDSOL=='petrkp')CMDSOL='PETRKP'
      IF(CMDSOL=='pbcgst')CMDSOL='PBCGST'
      IF(CMDSOL=='pbcgs2')CMDSOL='PBCGS2'
      IF(CMDSOL=='PETRKP'.OR. &
         CMDSOL=='PBCGST'.OR. &
         CMDSOL=='PBCGS2')THEN
         WRITE(CMSGNM,FMT='(A,A)')CMDSOL,' - CCG Method  '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDSOL')
      ENDIF

!=======================================================================
!    Define FFT method:

!    CMDFFT*6 = 'GPFAFT' -  GPFA code of Temperton
!             = 'FFTW21' -  FFTW 2.1.x code of Frigo & Johnson
!             = 'FFTMKL' -  Use DFTI from Intel MKL

      CWHERE='error reading CMDFFT from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99) CMDFFT
      IF(CMDFFT=='FFTW21')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using FFTW 2.1.x ', &
                                    'package from Frigo & Johnson'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT=='GPFAFT')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using GPFA package ', &
                                    'from Clive Temperton'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSEIF(CMDFFT=='FFTMKL')THEN
         WRITE(CMSGNM,FMT='(A,A,A)')CMDFFT,' - using DFTI from Intel ', &
                                    'Math Kernel Library (MKL)'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(A,A)')'DDSCAT 7.0 only supports FFT options', &
                                  ' FFTW21, GPFAFT, and FFTMKL'
         CALL WRIMSG('REAPAR',CMSGNM)
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CMDFFT')
      ENDIF

!=======================================================================

!    Define prescription for computing polarizabilities:

!    CALPHA*6 = 'LATTDR' - Lattice Dispersion Relation of
!                          Draine & Goodman (1993)
!               'GKDLDR' - Lattice Dispersion Relation of
!                          Gutkowicz-Krusin & Draine (2004)

      CWHERE='error reading CALPHA from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CALPHA
      IF(CALPHA=='LATTDR')THEN
         CALL WRIMSG('REAPAR','LATTDR - Draine & Goodman (1993) LDR for alpha')
      ELSEIF(CALPHA=='GKDLDR')THEN
         CALL WRIMSG('REAPAR', &
                    'GKDLDR - Gutkowicz-Krusin & Draine (2004) LDR for alpha')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' wrong definition of CALPHA')
      ENDIF

!=======================================================================
! binary file flag

      CWHERE='error reading CBINFLAG from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CBINFLAG
      IF(CBINFLAG=='allbin')CBINFLAG='ALLBIN'
      IF(CBINFLAG=='oribin')CBINFLAG='ORIBIN'
      IF(CBINFLAG=='notbin')CBINFLAG='NOTBIN'
      IF(CBINFLAG=='ALLBIN'.OR.CBINFLAG=='ORIBIN'.OR.CBINFLAG=='NOTBIN')THEN
         WRITE(CMSGNM,FMT='(A,A)')CBINFLAG,' - Unformatted binary dump option'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' Wrong definition of CBINFLAG')
      ENDIF

!=======================================================================
! Read upper bound on target extent
! skip line:
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG('REAPAR',CLINE)
      CWHERE='error reading target size bounds MXNX,MXNY,MXNZ from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)MXNX,MXNY,MXNZ
      WRITE(CMSGNM,FMT='(A,3I6,A)')'allow MXNX,MXNY,MXNZ=',MXNX,MXNY,MXNZ, &
                                   ' for target generation'
      CALL WRIMSG('REAPAR',CMSGNM)

!=======================================================================
!    Define shape:

! skip line:

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG('REAPAR',CLINE)

!    CSHAPE*9 = 'FROM_FILE'     read shape and composition data from file,
!                            for dielectric tensors that are diagonal
!                            in Target Frame
!             = 'ANIFRMFIL'     read shape and composition data from file,
!                            for general anisotropic dielectric tensors
!                            with orientation angles THETADF,PHIDF,BETAD
!                            relative to Target Frame.
!             = 'ANIELLIPS'  ellipsoid of anisotropic material
!             = 'ANIRCTNGL'  homogeneous anisotropic rectangular target
!             = 'ANI_ELL_2'  two touching anisotropic ellipsoids of
!                            materials 1-6
!             = 'ANI_ELL_3'  three touching anisotropic ellipsoids of
!                            materials 1-9
!             = 'BISLINPBC'  bilayer slab with periodic grid of lines
!                            parallel to z on top, with y-period/d=PYD
!                            [or, if PYD=0, a single line]
!             = 'CONELLIPS'  two concentric ellipsoids of materials 1,2
!             = 'CYLINDER1'  homogeneous finite cylinder
!             = 'CYLNDRCAP'  homogeneous cylinder with hemispherical endcaps
!             = 'CYLNDRPBC'  1-d or 2-d array of finite cylinders
!             = 'DSKBLYPBC'  1-d or 2-d array of disk on bilayer rect. slab
!             = 'DSKRCTNGL'  single disk on rectangular slab
!             = 'DSKRCTPBC'  1-d or 2-d array of disk on rectangular slab
!             = 'DW1996TAR'  13-cube target used by Draine & Weingartner 1996
!             = 'ELLIPSOID'  ellipsoid (homogeneous and isotropic)
!             = 'ELLIPSPBC'  1-d or 2-d array of ellipsoids
!             = 'ELLIPSO_2'  two touching isotropic ellipsoids of 
!                            materials 1 and 2
!             = 'ELLIPSO_3'  three touching isotropic ellipsoids of
!                            materials 1,2,3
!             = 'GAUSS_SPH'  gaussian sphere target
!             = 'HEXGONPBC'  1-d or 2-d array of hexagonal prisms
!             = 'HEX_PRISM'  homogeneous hexagonal prism
!             = 'LYRD_SLAB'  layered slab target, with up to 4 separate
!                            material layers
!             = 'LYRSLBPBC'  1-d or 2-d array of layered rect. slab targets,
!                            with up to 4 material layers
!             = 'MLTBLOCKS'  collection of cubic blocks defined by
!                            data in file 'blocks.par'
!             = 'RCTGLBLK3'  isolated target: 3 rectangular blocks with
!                            centers on x-axis
!             = 'RCTGLPRSM'  homogeneous rectangular prism
!             = 'RCTGL_PBC'  1-d or 2-d array of rectangular targets
!             = 'SPHERES_N'  multisphere target = union of N spheres
!             = 'SPHRN_PBC'  1-d or 2-d array of multisphere target
!             = 'SPHROID_2'  two touching spheroids with symmetry axes at
!                            specified angle!
!             = 'SPH_ANI_N'  multisphere target, with spheres that
!                            can have different, anisotropic, composition
!             = 'TETRAHDRN'  regular tetrahedron
!             = 'TRILYRPBC'  periodic target: 3 layer rectangular structure)
!             = 'TRNGLPRSM'  triangular prism (homogeneous and isotropic)
!             = 'UNIAXICYL'  cylinder of unixaxial material

      CWHERE='error reading CSHAPE from ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CSHAPE
      IF(CSHAPE=='ANIELLIPS'.OR.CSHAPE=='ANI_ELL_2'.OR. &
         CSHAPE=='ANI_ELL_3'.OR.CSHAPE=='ANIFRMFIL'.OR. &
         CSHAPE=='ANIRCTNGL'.OR.CSHAPE=='BISLINPBC'.OR. &
         CSHAPE=='CONELLIPS'.OR.CSHAPE=='CYLINDER1'.OR. &
         CSHAPE=='CYLNDRCAP'.OR.CSHAPE=='CYLNDRPBC'.OR. &
         CSHAPE=='DSKBLYPBC'.OR.CSHAPE=='DSKRCTNGL'.OR. &
         CSHAPE=='DSKRCTPBC'.OR.CSHAPE=='DW1996TAR'.OR. &
         CSHAPE=='ELLIPSOID'.OR.CSHAPE=='ELLIPSO_2'.OR. &
         CSHAPE=='ELLIPSO_3'.OR.CSHAPE=='ELLIPSPBC'.OR. &
         CSHAPE=='FROM_FILE'.OR.CSHAPE=='GAUSS_SPH'.OR. &
         CSHAPE=='HEXGONPBC'.OR.CSHAPE=='HEX_PRISM'.OR. &
         CSHAPE=='LAYRDSLAB'.OR.CSHAPE=='LYRSLBPBC'.OR. &
         CSHAPE=='MLTBLOCKS'.OR.CSHAPE=='RCTGLBLK3'.OR. &
         CSHAPE=='RCTGLPRSM'.OR.CSHAPE=='RCTGL_PBC'.OR. &
         CSHAPE=='RCTG_RCTG'.OR.CSHAPE=='RECRECPBC'.OR. &
         CSHAPE=='SPHERES_N'.OR.CSHAPE=='SPHRN_PBC'.OR. &
         CSHAPE=='SPHROID_2'.OR.CSHAPE=='SPH_ANI_N'.OR. &
         CSHAPE=='TETRAHDRN'.OR.CSHAPE=='TRILYRPBC'.OR. &
         CSHAPE=='TRNGLPRSM'.OR.CSHAPE=='UNIAXICYL')THEN
         WRITE(CMSGNM,FMT='(A,A)')CSHAPE,' - Shape definition '
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(A,A)')'CSHAPE=',CSHAPE
         CALL WRIMSG('REAPAR',CMSGNM)
         CALL ERRMSG('FATAL','REAPAR',                            &
                     ' Wrong shape directive [N.B. UPPERCASE only]')
      ENDIF

! Read shape parameters
! Number of required shape parameters:
!      FROM_FILE (0 shape parameters:
!                here skip a line, later read target from file)
!      ANIFRMFIL (0 shape parameters:
!                here skip a line, later read target from file)
!      TETRAHDRN, DW1996TAR (1 shape parameter)
!      CYLNDRCAP, UNIAXICYL (2 shape parameters)
!      SPHERES_N, SPH_ANI_N (2 shape parameters + 1 filename)
!      ANIELLIPS (3 shape parameters)
!      ANI_ELL_2
!      TRNGLPRSM (4 shape parameters)
!      CYLNDRPBC (4 shape parameters)
!      HEXGONPBC (5 shape parameters)
!      RCTGL_PBC (5 shape parameters)
!      ELLIPSPBC (5 shape parameters)
!      LYRSLBPBC (9 shape parameters)
!      SPHROID_2 (6 shape parameters)
!      CONELLIPS (6 shape parameters)
!      LYRD_SLAB (6 shape parameters)
!      GAUSS_SPH (6 shape parameters)
!      RCTG_RCTG (6 shape parameters)
!      RECRECPBC (8 shape parameters)
!      DSKBLYPBC (8 shape parameters)

! targets needing 0 shape parameters;

      IF(CSHAPE=='FROM_FILE'.OR.CSHAPE=='ANIFRMFIL'.OR. &
         CSHAPE=='DW1996TAR'.OR.CSHAPE=='MLTBLOCKS')THEN
         READ(IOPAR,FMT=*,ERR=99)

! targets needing 1 shape parameter:

      ELSEIF(CSHAPE=='TETRAHDRN'.OR.CSHAPE=='DW1996TAR')THEN
         CWHERE='error reading 1 shape parameter in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1)

! targets needing 2 shape parameters:

      ELSEIF(CSHAPE=='CYLNDRCAP'.OR.CSHAPE=='SPHROID_2'.OR. &
             CSHAPE=='UNIAXICYL')THEN
         CWHERE='error reading 2 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1),SHPAR(2)

! targets needing 2 shape parameters and file name:

      ELSEIF(CSHAPE=='SPHERES_N'.OR.CSHAPE=='SPH_ANI_N')THEN
         CWHERE='error reading 2 shape parameters and filename in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1),SHPAR(2),CFLSHP

! targets needing 3 shape parameters:

      ELSEIF(CSHAPE=='ANIELLIPS'.OR.CSHAPE=='ANI_ELL_2'.OR. &
             CSHAPE=='ANI_ELL_3'.OR.CSHAPE=='ANIRCTNGL'.OR. &
             CSHAPE=='CYLINDER1'.OR.CSHAPE=='ELLIPSOID'.OR. &
             CSHAPE=='ELLIPSO_2'.OR.CSHAPE=='ELLIPSO_3'.OR. &
             CSHAPE=='HEX_PRISM'.OR.CSHAPE=='RCTGLPRSM')THEN
         CWHERE='error reading 2 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1),SHPAR(2),SHPAR(3)

! targets needing 3 shape parameters and file name:

      ELSEIF(CSHAPE=='SPHRN_PBC')THEN
         CWHERE='error reading 3 shape parameters and filename in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1),SHPAR(2),SHPAR(3),CFLSHP
         
! targets needing 4 shape parameters

      ELSEIF(CSHAPE=='TRNGLPRSM')THEN
         CWHERE='error reading 4 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4)

! targets needing 5 shape parameters

      ELSEIF(CSHAPE=='CYLNDRPBC'.OR.CSHAPE=='DSKRCTNGL'.OR. &
             CSHAPE=='HEXGONPBC'.OR.CSHAPE=='RCTGL_PBC')THEN
         CWHERE='error reading 5 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,5)

! targets needing 6 shape parameters:

      ELSEIF(CSHAPE=='BISLINPBC'.OR.CSHAPE=='CONELLIPS'.OR. &
             CSHAPE=='GAUSS_SPH'.OR.CSHAPE=='RCTG_RCTG'.OR. &
             CSHAPE=='SPHROID_2')THEN
         CWHERE='error reading 6 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,6)

! targets needing 7 shape parameters:

      ELSEIF(CSHAPE=='DSKRCTPBC'.OR.CSHAPE=='LAYRDSLAB')THEN
         CWHERE='error reading 7 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,7)

! targets needing 8 shape parameters:

      ELSEIF(CSHAPE=='DSKBLYPBC'.OR.CSHAPE=='RECRECPBC')THEN
         CWHERE='error reading 8 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,8)

! targets needing 9 shape parameters:

      ELSEIF(CSHAPE=='LYRSLBPBC'.OR.CSHAPE=='RCTGLBLK3')THEN
         CWHERE='error reading 9 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,9)

! targets needing 10 shape parameters: none

! targets needing 11 shape parameters:

      ELSEIF(CSHAPE=='TRILYRPBC')THEN
         CWHERE='error reading 11 shape parameters in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SHPAR(J),J=1,11)

      ELSE
         CALL ERRMSG('FATAL','REAPAR',                                   &
            ' No instructions for reading shape parameters for this shape')
      ENDIF

!  JPBC=0 if PBC are not used
!       1 if PBC in y direction only
!       2 if PBC in z direction only
!       3 if PBC in y and z directions

      JPBC=0

! need to set JPBC for PBC targets

      IF(CSHAPE=='BISLINPBC')THEN
         IF(SHPAR(6)>0._WP)JPBC=1
         JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='CYLNDRPBC')THEN
         IF(SHPAR(4)>0._WP)JPBC=1
         IF(SHPAR(5)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='DSKBLYPBC')THEN
         IF(SHPAR(7)>0._WP)JPBC=1
         IF(SHPAR(8)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='DSKRCTPBC')THEN
         IF(SHPAR(6)>0._WP)JPBC=1
         IF(SHPAR(7)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='HEXGONPBC')THEN
         IF(SHPAR(4)>0._WP)JPBC=1
         IF(SHPAR(5)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='LYRSLBPBC')THEN
         IF(SHPAR(8)>0._WP)JPBC=1
         IF(SHPAR(9)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='RCTGL_PBC')THEN
         IF(SHPAR(4)>0._WP)JPBC=1
         IF(SHPAR(5)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='RECRECPBC')THEN
         IF(SHPAR(7)>0._WP)JPBC=1
         IF(SHPAR(8)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='SPHRN_PBC')THEN
         IF(SHPAR(2)>0._WP)JPBC=1
         IF(SHPAR(3)>0._WP)JPBC=JPBC+2
      ENDIF
      IF(CSHAPE=='TRILYRPBC')THEN
         IF(SHPAR(10)>0._WP)JPBC=1
         IF(SHPAR(11)>0._WP)JPBC=JPBC+2
      ENDIF

!=======================================================================
! following code disabled 03.01.29
! (retain for use in future noncubic version)

!   Obtain lattice anisotropy parameters DX(1-3)
!   For cubic lattice, DX(1)=DX(2)=DX(3)
!   Note that we do not require here that DX(1)*DX(2)*DX(3)=1 upon
!   input; DX is renormalized here before being returned to DDSCAT


!      READ(IOPAR,FMT=*,ERR=99)DX(1),DX(2),DX(3)
!      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
!     &   ' = relative lattice spacings dx,dy,dz'
!      CALL WRIMSG('REAPAR',CMSGNM)

!      DELTA=(DX(1)*DX(2)*DX(3))**(1./3.)
!      DX(1)=DX(1)/DELTA
!      DX(2)=DX(2)/DELTA
!      DX(3)=DX(3)/DELTA
!      WRITE(CMSGNM,FMT='(F8.3,F8.3,F8.3,A)')DX,
!     &   ' = normalized lattice spacings dx,dy,dz'
!      CALL WRIMSG('REAPAR',CMSGNM)

! and replaced by following:

      DX(1)=1._WP
      DX(2)=1._WP
      DX(3)=1._WP

!=======================================================================

!   Obtain names of file(s) containing dielectric function(s)
!   NCOMP = number of different dielectric functions
!   CFLEPS(1-NCOMP) = names of files containing dielectric functions

      CWHERE='error reading NCOMP in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)NCOMP
      WRITE(CMSGNM,FMT='(A,I4)')' NCOMP=',NCOMP
      CALL WRIMSG('REAPAR',CMSGNM)

! Check that MXCOMP is large enough

      IF(NCOMP>MXCOMP)CALL ERRMSG('FATAL','REAPAR', &
                      'NCOMP > MXCOMP: must increase MXCOMP in DDSCAT')

!*** Check that NCOMP=2 if CSHAPE=UNIAXICYL *******************************
!                     3           ANIELLIPS
!                     2           ELLIPSO_2
!                     3           ELLIPSO_3
!                     6           ANI_ELL_2
!                     9           ANI_ELL_3
!                     2           CONELLIPS
!                     2           SPHROID_2
!                     2-4         LYRD_SLAB
!                     1-4         LYRSLBPBC

      IF(CSHAPE=='UNIAXICYL'.AND.NCOMP/=2)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 2 for option UNIAXICYL')
      IF(CSHAPE=='ANIELLIPS'.AND.NCOMP/=3)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 3 for option ANIELLIPS')
      IF(CSHAPE=='ELLIPSO_2'.AND.NCOMP/=2)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 2 for option ELLIPSO_2')
      IF(CSHAPE=='ELLIPSO_3'.AND.NCOMP/=3)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 3 for option ELLIPSO_3')
      IF(CSHAPE=='ANI_ELL_2'.AND.NCOMP/=6)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 6 for option ANI_ELL_2')
      IF(CSHAPE=='ANI_ELL_3'.AND.NCOMP/=9)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 9 for option ANI_ELL_3')
      IF(CSHAPE=='CONELLIPS'.AND.NCOMP/=2)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 2 for option CONELLIPS')
      IF(CSHAPE=='SPHROID_2'.AND.NCOMP/=2)CALL ERRMSG('FATAL','REAPAR', &
         'NCOMP must be 2 for option SPHROID_2')
      IF(CSHAPE=='LYRSLBPBC')THEN
         J=4
         IF(SHPAR(7)<=0._WP)J=3
         IF(SHPAR(7)<=0._WP.AND.SHPAR(6)<=0._WP)J=2
         IF(SHPAR(7)<=0._WP.AND.SHPAR(6)<=0._WP.AND.SHPAR(5)<=0._WP)J=1
         WRITE(CMSGNM,FMT='(A,I2)')'LYRSLBPBC: need NCOMP=',J
         IF(NCOMP<J)CALL ERRMSG('FATAL','REAPAR',CMSGNM)
      ENDIF
      IF(CSHAPE=='LYRD_SLAB')THEN
         J=4
         IF(SHPAR(7)<=0._WP)J=3
         IF(SHPAR(7)<=0._WP.AND.SHPAR(6)<=0._WP)J=2
         IF(SHPAR(7)<=0._WP.AND.SHPAR(6)<=0._WP.AND.SHPAR(6)<=0._WP)J=1
         WRITE(CMSGNM,FMT='(A,I2)')'LYRD_SLAB: need NCOMP=',J
         IF(NCOMP<J)CALL ERRMSG('FATAL','REAPAR',CMSGNM)
      ENDIF
      IF(CSHAPE=='SPHERES_N'.AND.NCOMP>1)THEN
         WRITE(CMSGNM,FMT='(A,A)')'SPHERES_N is for single isotropic ', &
               ' material -- try option SPH_ANI_N ?'
         CALL ERRMSG('FATAL','REAPAR',CMSGNM)
      ENDIF

!=======================================================================

      CWHERE='error reading filename(s) for diel.fn. in ddscat.par'
      DO J=1,NCOMP
         READ(IOPAR,FMT=*,ERR=99)CFLEPS(J)
         WRITE(CMSGNM,FMT='(I2,A,A)')J,' ',CFLEPS(J)
         CALL WRIMSG('REAPAR',CMSGNM)
      ENDDO

!=======================================================================

!    Define INITIALIZATION:

!    INIT = 0 to start with |X0>=0
!           1 to obtain |X0> from 4th-order expansion in polarizability
!           2 to read |X0> from file solvp.in
! disabled 08.03.12 v7.0.5 since we always use INIT=0
! skip line:
!      READ(IOPAR,FMT=*,ERR=99)CLINE
!      CALL WRIMSG(' ',CLINE)
!      CWHERE='error reading INIT in ddscat.par'
!      READ(IOPAR,FMT=*,ERR=99)INIT
!      IF(INIT==0)THEN
!         CALL WRIMSG('REAPAR','INIT=0 to start with |X0>=0 (CCG method)')
!      ELSEIF(INIT==1)THEN
!         CALL WRIMSG('REAPAR', &
!                     'INIT=1 to obtain |X0> from 4th-order expansion (CCG)')
!      ELSEIF(INIT==2)THEN
!         CALL WRIMSG('REAPAR','INIT=2 to read |X0> from file solvp.in')
!      ELSE
!         CALL ERRMSG('FATAL','REAPAR',' Wrong value of INIT')
!      ENDIF

!***********************************************************************

!    Define error tolerance:
!    TOL= maximum acceptable value of |Ax-E|/|E|

! skip line:

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG('REAPAR',CLINE)
 
      CWHERE='error reading TOL in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)TOL
      WRITE(CMSGNM,FMT='(1PE10.3,A)')TOL,                          &
            ' = TOL = max. acceptable normalized residue |Ax-E|/|E|'
      CALL WRIMSG('REAPAR',CMSGNM)
      IF(TOL<1.E-5_WP.OR.TOL>1.E-1_WP)THEN
         CALL ERRMSG('WARNING','REAPAR',' Strange value of TOL ')
      ENDIF

!***********************************************************************

!    Define summation limit parameter GAMMA for PBC calculations
!    summations will be carried out to distance r=2/(k*alpha)
!    with suppression factor exp[-(alpha*kr)^4]=exp[-16]
!    GAMMA is used only when JPBC=1,2, or 3

! skip line:
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading GAMMA in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)GAMMA
      IF(JPBC>0)THEN
         WRITE(CMSGNM,FMT='(1PE10.3,A)')GAMMA,                     &
               ' = GAMMA = replica dipole summation limiter for PBC'
         CALL WRIMSG('REAPAR',CMSGNM)
         IF(GAMMA>1.E-1_WP.OR.GAMMA<1.E-4_WP)THEN
            CALL ERRMSG('WARNING','REAPAR',' Strange value of GAMMA ')
         ENDIF
      ELSE
         WRITE(CMSGNM,FMT='(A)')'[GAMMA is not used in present calculation]'
         CALL WRIMSG('REAPAR',CMSGNM)
      ENDIF

!=======================================================================

!    Define angular resolution used for calculating radiation force,
!    <cos>, <cos^2>, and radiation torque (if CMTORQ='DOTORQ')

!     ETASCA = parameter controlling number of scattering angles
!            = 1 is a good choice, but can reduce this if higher
!                accuracy is required for angular averages

!     number of scattering angles will be approximately
!            6*[(3+x)/ETASCA]^2

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading ETASCA in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)ETASCA
      IF(ETASCA>1.E-3_WP)THEN
         WRITE(CMSGNM,FMT='(F7.4,A)')ETASCA, &
               ' = ETASCA (parameter controlling number of scattering angles'
         CALL WRIMSG('REAPAR',CMSGNM)
      ELSE
         WRITE(CMSGNM,FMT='(1PE10.3,A)')ETASCA, &
              ' is not an appropriate value for ETASCA: check ddscat.par'
         CALL ERRMSG('FATAL','REAPAR',CMSGNM)
      ENDIF

!=======================================================================

!    Define WAVELENGTH :

!    WAVINI = first wavelength (physical units)
!    WAVEND = last wavelength (physical units)
!    NWAV   = number of wavelengths
!    CDIVID = 'LIN', 'LOG', or 'INV' for equal increments in
!              wavelength, log(wavelength), or frequency
!           = 'TAB' to read wavelengths from file 'wave.tab'

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading firstwave, lastwave, number, how in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)WAVINI,WAVEND,NWAV,CDIVID
      IF(CDIVID/='LIN'.AND.CDIVID/='LOG'.AND.CDIVID/='INV'.AND. &
         CDIVID/='TAB')THEN
         CALL ERRMSG('FATAL','REAPAR', &
                     ' CDIVID for wavelengths must be LIN,LOG,INV, or TAB')
      ENDIF
      IF(CDIVID/='TAB')THEN
         WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')NWAV,' wavelengths from ', &
                                               WAVINI,' to ',WAVEND
         CALL WRIMSG('REAPAR',CMSGNM)
         CALL DIVIDE(CDIVID,WAVINI,WAVEND,NWAV,MXWAV,WAVEA)
      ELSE
         OPEN(UNIT=28,FILE='wave.tab',STATUS='OLD')

! skip one header line

         READ(28,*)
         NWAV=0
900      READ(28,*,END=1000,ERR=1000)WAVINI
         NWAV=NWAV+1
         IF(NWAV>MXWAV)THEN
            WRITE(CMSGNM,FMT='(A,I4,A,I4,A)')'NWAV=',NWAV,' > MXWAV=', &
                  MXWAV,' need to recompile with larger MXWAV'
            CALL WRIMSG('REAPAR',CMSGNM)
            CALL ERRMSG('FATAL','REAPAR',' NWAV > MXWAV')
         ENDIF
         WAVEA(NWAV)=WAVINI
!*** diagnostic
!         write(0,*)'reapar ckpt 1: NWAV=',NWAV,' WAVEA(NWAV)=',WAVEA(NWAV)
!****
         GOTO 900
1000     CLOSE(28)
         WRITE(CMSGNM,FMT='(I3,A,1PE11.5,A,1PE11.5)')NWAV,    &
               ' wavelengths from ',WAVEA(1),' to ',WAVEA(NWAV)
         CALL WRIMSG('REAPAR',CMSGNM)
      ENDIF

!=======================================================================

!    Define AEFF = radius of equal-volume sphere (physical units)

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading firstaeff, lastaeff, number, how in ddscat.par'
      READ(IOPAR,FMT=*)AEFINI,AEFEND,NRAD,CDIVID
      IF(CDIVID/='LIN'.AND.CDIVID/='LOG'.AND.CDIVID/='INV')THEN
         CALL ERRMSG('FATAL','REAPAR', &
                     ' CDIVID for radii must be LIN,LOG, or INV')
      ENDIF
      WRITE(CMSGNM,FMT='(I3,A,F7.4,A,F7.4)')NRAD,' eff. radii from ', &
                                            AEFINI,' to ',AEFEND
      CALL WRIMSG('REAPAR',CMSGNM)
      CALL DIVIDE(CDIVID,AEFINI,AEFEND,NRAD,MXRAD,AEFFA)

!=======================================================================

!    Define incident polarizations (in Lab Frame)
!    It is assumed that incident radiation is along x axis in Lab Frame

! skip one line:

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)

! Read complex polarization vector CXE01=e01 (normalize if necessary).

      CWHERE='error reading CXE01 in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)CXE01
      E1=REAL(SQRT(CXE01(1)*CONJG(CXE01(1))))
      IF(E1/=0._WP)THEN
         CALL ERRMSG('FATAL','REAPAR',' CXE01(1) must be zero!')
      ENDIF

! Normalize:

      E1=SQRT(REAL(CXE01(2)*CONJG(CXE01(2))+CXE01(3)*CONJG(CXE01(3))))
      CXE01(2)=CXE01(2)/E1
      CXE01(3)=CXE01(3)/E1

! Construct orthogonal normalized polarization vector CXE02=e02
! using xhat cross e01* = e02

      CXE02(1)=(0._WP,0._WP)
      CXE02(2)=-CONJG(CXE01(3))
      CXE02(3)=CONJG(CXE01(2))

! IORTH=1 to calculate only for single polarization
!      =2 to also calculate for orthogonal polarization

      READ(IOPAR,FMT=*,ERR=99)IORTH
      WRITE(CMSGNM,FMT='(A,I2)')'IORTH=',IORTH
      CALL WRIMSG('REAPAR',CMSGNM)

!***********************************************************************

!    Specify whether or not to write ".sca" files
! skip line:
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG('REAPAR',CLINE)

! IWRKSC=0 to NOT write ".sca" file for each target orientation
!       =1 to write ".sca" file for each target orientation

      CWHERE='error reading IWRKSC in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)IWRKSC
      WRITE(CMSGNM,FMT='(A,I2)')'IWRKSC=',IWRKSC
      CALL WRIMSG('REAPAR',CMSGNM)

!***********************************************************************

!    Specify whether or not to write ".pol" files

! IWRPOL=0 to NOT write ".pol1" and ".pol2" file for each
!          target orientation (beta,theta)
!       =1 to write ".pol1" and ".pol2" file for each
!          target orientation (beta,theta)

      CWHERE='error reading IWRPOL in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)IWRPOL
      WRITE(CMSGNM,FMT='(A,I2)')'IWRPOL=',IWRPOL
      CALL WRIMSG('REAPAR',CMSGNM)

!***********************************************************************

!    Read information determining target rotations

! skip line
      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading BETAMI,BETAMX,NBETA in ddscat.par'
      READ(IOPAR,FMT=*)BETAMI,BETAMX,NBETA
      CWHERE='error reading THETMI,THETMX,NTHETA in ddscat.par'
      READ(IOPAR,FMT=*)THETMI,THETMX,NTHETA
      CWHERE='error reading PHIMIN,PHIMAX,NPHI in ddscat.par'
      READ(IOPAR,FMT=*)PHIMIN,PHIMAX,NPHI

! check that user has not requested more than 1000 orientations and
! IWRKSC=1

      IF(IWRKSC>0.AND.(NBETA*NTHETA*NPHI)>1000)THEN
         CALL ERRMSG('FATAL','REAPAR',                                        &
                     'error: if IWRKSC=1, NBETA*NTHETA*NPHI must be .le. 1000')
      ENDIF

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading IWAV0,IRAD0,IORI0 in ddscat.par'
      READ(IOPAR,FMT=*)IWAV0,IRAD0,IORI0

!*** Check that values of NBETA,NTHETA,NPHI are OK:

      IF(NBETA>MXBETA)CALL ERRMSG('FATAL','REAPAR',              &
                                  ' NBETA>MXBETA: must recompile')
      IF(NPHI>MXPHI)CALL ERRMSG('FATAL','REAPAR',            &
                                ' NPHI>MXPHI: must recompile')
      IF(NTHETA>MXTHET)CALL ERRMSG('FATAL','REAPAR',               &
                                   ' NTHETA>MXTHET: must recompile')

!***  Check that IWAV0,IRAD0,IORI0 are OK:

      IF(IWAV0+1>NWAV)CALL ERRMSG('FATAL','REAPAR','IWAV0+1 > NWAV')
      IF(IRAD0+1>NRAD)CALL ERRMSG('FATAL','REAPAR','IRAD0+1 > NRAD')
      IF(IORI0+1>NBETA*NTHETA*NPHI)CALL ERRMSG('FATAL','REAPAR',            &
                                               'IORI0+1 > NBETA*NTHETA*NPHI')

! If NPHI>1, then set IORTH=2 regardless of value input.

      IF(IORTH==1.AND.NPHI>1)THEN
         IORTH=2
         CALL WRIMSG('REAPAR','Set IORTH=2 since NPHI>1 ')
      ENDIF

      IF(IORTH==1)THEN
         CALL WRIMSG('REAPAR','Calculate only for single polarization ')
      ELSEIF(IORTH==2)THEN
         CALL WRIMSG('REAPAR','Do orthogonal polarization for each case ')
      ELSE
         CALL ERRMSG('FATAL','REAPAR',' WRONG VALUE OF IORTH ')
      ENDIF
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')BETAMI,BETAMX, &
         ' Range of BETA values ; NBETA =',NBETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')THETMI,THETMX, &
         ' Range of THETA values; NTHETA=',NTHETA
      CALL WRIMSG('REAPAR',CMSGNM)
      WRITE(CMSGNM,FMT='(2F7.2,A,I4)')PHIMIN,PHIMAX, &
         ' Range of PHI values ;   NPHI =',NPHI
      CALL WRIMSG('REAPAR',CMSGNM)

! Convert from degrees to radians

      BETAMI=BETAMI/DEGRAD
      BETAMX=BETAMX/DEGRAD
      THETMI=THETMI/DEGRAD
      THETMX=THETMX/DEGRAD
      PHIMIN=PHIMIN/DEGRAD
      PHIMAX=PHIMAX/DEGRAD

!=======================================================================

!    Specify elements of scattering matrix to be printed out

      READ(IOPAR,FMT=*,ERR=99)CLINE
      CALL WRIMSG(' ',CLINE)
      CWHERE='error reading NSMELTS in ddscat.par'
      READ(IOPAR,FMT=*,ERR=99)NSMELTS

! NSMELTS = number of elements of scattering matrix element to be
!           printed out.  Must be no greater than 9
!           if NSMELTS is zero, then 6 "default" elements are output

      IF(NSMELTS>9)THEN
         WRITE(IDVOUT,FMT='(A,I2,A)')'Error:',NSMELTS,             &
                          ' > 9 is not permitted by output routines'
        CALL ERRMSG('FATAL','REAPAR',                         &
                    'NSMELTS > 9 is not allowed in ddscat.par')
      ENDIF
      IF(NSMELTS<=0)THEN
         SMIND1(1)=11
         SMIND1(2)=21
         SMIND1(3)=31
         SMIND1(4)=41
         SMIND1(5)=12
         SMIND1(6)=13
         NSMELTS=6
         READ(IOPAR,FMT=*)
      ELSE
         CWHERE='error reading indices ij of S_ij elements in ddscat.par'
         READ(IOPAR,FMT=*,ERR=99)(SMIND1(J),J=1,NSMELTS)
      ENDIF
      DO J=1,NSMELTS
         SMIND2(J)=SMIND1(J) - 10*(SMIND1(J)/10)
         SMIND1(J)=SMIND1(J)/10
      ENDDO

!=======================================================================

!    Specify scattering directions to be calculated
!    Two options:
!    CMDFRM = 'LFRAME': specify scattering directions n in Lab Frame
!                       (where incident beam is in x-direction)
!         THETAN,PHIN = Direction of n from n0 in calculation of the
!                       scattering matrix; cos(THETAN) is n0 \dot n
!                       and PHIN is azimuthal angle of n from Lab xy pla
!                       Note: THETA1, THETA2, and PHI for each scatterin
!                       plane are entered in degrees, and immediately
!                       converted to radians.  Arbitrary number
!                       of scattering planes may be considered.
!    CMDFRM = 'TFRAME': specify scattering directions in Target Frame,
!                       defined by target axes a1,a2,a3
! If JPBC=0:
!         THETAN,PHIN = Direction of n relative to a1,a2,a3:
!                       THETAN = angle between n and a1
!                       PHIN = angle between a1-n plane and a1-a2 plane
!    JPBC=1:
!         THETAN      = Diffraction order along y_TF axis
!         PHIN        = azimuthal angle around y_TF
!    JPBC=2:
!         THETAN      = Diffraction order along z_TF axis
!         PHIN        = azimuthal angle around z_TF
!    JPBC=3
!         THETAN      = Diffraction order along y_TF
!         PHIN        = Diffraction order along z_TF
!      where we first run through transmitted waves 1 -> NSCAT/2
!            and then run through reflected waves NSCAT/2+1 -> NSCAT

! Three cases:
! JPBC=0: single isolated target.
!         specify
!            phi for scattering plane
!            thetamin, thetamax, dtheta for scattering plane

! JPBC=1,2: periodic in one dimension.
!         specify
!            diffraction order in direction of target periodicity
!            phimin, phimax, dphi for scattering cone

! JPBC=3: periodic in two dimensions
!         specify
!            difraction order in y direction and order in z direction

      NSCA=0
      IF(JPBC==0)THEN
         READ(IOPAR,FMT=*,ERR=99)CLINE
         CWHERE='error reading CMDFRM (only LFRAME or TFRAME allowed)'
         READ(IOPAR,FMT=*,ERR=99)CMDFRM
         IF(CMDFRM/='LFRAME'.AND.CMDFRM/='lframe'.AND. &
            CMDFRM/='TFRAME'.AND.CMDFRM/='tframe')GOTO 99
         CALL WRIMSG('REAPAR',CLINE)
         CWHERE='JPBC=0, error reading NPLANES = number of scat. planes'
         READ(IOPAR,FMT=*,ERR=99)NPLANES
         WRITE(CMSGNM,FMT='(I4,A)')NPLANES,                       &
                                   ' = number of scattering planes'
         CWHERE='JPBC=0, error reading scattering directions in ddscat.par'
         IF(NPLANES>0)THEN
            DO JPLANE=1,NPLANES
               READ(IOPAR,FMT=*,ERR=99,END=99)PHI1,THETA1,THETA2,DTHETA
               WRITE(CMSGNM,FMT='(3F7.1,A,I4)')PHI1,THETA1,THETA2,        &
                     ' = phi, theta_min, theta_max for scatt. plane', &
                     JPLANE
               CALL WRIMSG('REAPAR',CMSGNM)
               IF(ABS(THETA1-THETA2)>0._WP.AND.DTHETA==0._WP)THEN
                  CALL ERRMSG('FATAL','REAPAR','DTHETA=0 in ddscat.par!')
               ENDIF

! Convert to radians:

               PHI1=PHI1/DEGRAD
               THETA1=THETA1/DEGRAD
               THETA2=THETA2/DEGRAD
               DTHETA=DTHETA/DEGRAD

! Allow for possibility that user did not enter correct sign for
! DTHETA (if I did it, others will too...)

               IF(THETA2<THETA1)DTHETA=-ABS(DTHETA)

! compute theta values for this scattering plane

               NSCA0=1
               DELTA=THETA2-THETA1
               IF(DELTA/=0)NSCA0=1+NINT(DELTA/DTHETA)

! Check that there is enough storage space:

               IF((NSCA+NSCA0)>MXSCA)THEN
                  WRITE(IDVOUT,FMT='(I6,I6,A)')MXSCA,NSCA0,       &
                        ' =MXSCA,NSCA0 (dirs in this scatt. plane)'
                  CALL ERRMSG('FATAL','REAPAR','MXSCA too small in DDSCAT')
               ENDIF

               THETAN(NSCA+1)=THETA1
               IF(NSCA0>2)THEN
                  DO J=2,NSCA0-1
                     THETAN(NSCA+J)=THETA1+(J-1)*DTHETA
                  ENDDO
               ENDIF

               THETAN(NSCA+NSCA0)=THETA2
               DO J=1,NSCA0
                  PHIN(NSCA+J)=PHI1
               ENDDO

               NSCA=NSCA+NSCA0
               WRITE(CMSGNM,FMT='(I4,A)')NSCA0,                           &
                  ' = number of scattering angles in this scattering plane'
               CALL WRIMSG('REAPAR',CMSGNM)
            ENDDO
         ENDIF

!=======================================================================

      ELSEIF(JPBC==1.OR.JPBC==2)THEN

! enter diffraction order, phimin, phimax, dphi for cone
! we will store order in PHIN
!               phi   in THETAN

         READ(IOPAR,FMT=*,ERR=99)CLINE
         CWHERE='error reading CMDFRM (only LFRAME or TFRAME allowed)'
         READ(IOPAR,FMT=*,ERR=99)CMDFRM
         IF(CMDFRM/='LFRAME'.AND.CMDFRM/='lframe'.AND.  &
            CMDFRM/='TFRAME'.AND.CMDFRM/='tframe')GOTO 99
         IF(CMDFRM=='LFRAME'.OR.CMDFRM=='lframe')CALL ERRMSG('FATAL', &
            'REAPAR',' cannot use LFRAME when JPBC=1 or 2')
         CALL WRIMSG(' ',CLINE)
         CWHERE='JPBC=1 or 2, error reading number of scattering cones'
         READ(IOPAR,FMT=*,ERR=99)NPLANES
         WRITE(CMSGNM,FMT='(I4,A)')NPLANES,                      &
                                   ' = number of scattering cones'
         CALL WRIMSG('REAPAR',CMSGNM)
         CWHERE='JPBC=1 or 2, error reading scattering dirs in ddscat.par'
         IF(NPLANES>0)THEN
            DO JPLANE=1,NPLANES
32             READ(IOPAR,FMT=*,ERR=99,END=99)PHI1,THETA1,THETA2,DTHETA
               WRITE(CMSGNM,FMT='(3F7.1,A)')PHI1,THETA1,THETA2,       &
                     ' = order, zeta_min, zeta_max for scattering cone'
               CALL WRIMSG('REAPAR',CMSGNM)
! Convert to radians
               THETA1=THETA1/DEGRAD
               THETA2=THETA2/DEGRAD
               DTHETA=DTHETA/DEGRAD
               IF(THETA2<THETA1)DTHETA=-ABS(DTHETA)

! compute zeta values for this scattering cone

               NSCA0=1
               DELTA=THETA2 - THETA1
               IF(DELTA/=0)NSCA0=1+NINT(DELTA/DTHETA)

! Check that there is sufficient storage

               IF((NSCA+NSCA0)>MXSCA)THEN
                  WRITE(IDVOUT,FMT='(I6,I6,A)')MXSCA,NSCA0,       &
                        ' =MXSCA,NSCA0 (dirs in this scatt. plane)'
                  CALL ERRMSG('FATAL','REAPAR','MXSCA too small in DDSCAT')
               ENDIF
               THETAN(NSCA+1)=THETA1
               IF(NSCA0>2)THEN
                  DO J=2,NSCA0 - 1
                     THETAN(NSCA+J)=THETA1+(J-1)*DTHETA
                  ENDDO
               ENDIF
               THETAN(NSCA+NSCA0)=THETA2
               DO J=1,NSCA0
                  PHIN(NSCA+J)=PHI1
               ENDDO
               NSCA=NSCA+NSCA0
               WRITE(CMSGNM,FMT='(I4,A)')NSCA0,                             &
                     ' = number of scattering angles in this scattering cone'
               CALL WRIMSG('REAPAR',CMSGNM)
            ENDDO
         ENDIF

!=======================================================================

      ELSEIF(JPBC==3)THEN

! Target is doubly periodic: scattering only in discrete directions
! enter diffraction order_y, order_z
! we will store order_y in PHIN
!               order_z in THETAN
! every order_y,order_z case will first be used for transmission, then
! again for reflection

         READ(IOPAR,FMT=*,ERR=99)CLINE
         CWHERE='error reading CMDFRM (only LFRAME or TFRAME allowed)'
         READ(IOPAR,FMT=*,ERR=99)CMDFRM
         IF(CMDFRM=='LFRAME'.OR.CMDFRM=='lframe')CALL ERRMSG('FATAL', &
            'REAPAR',' cannot use LFRAME when JPBC=3')
         CALL WRIMSG(' ',CLINE)
         NSCA=0
         CWHERE='error reading number of transmission diffr. orders for JPBC=3'
         READ(IOPAR,FMT=*,ERR=99)NPLANES
         WRITE(CMSGNM,FMT='(I4,A)')NPLANES,                     &
               ' = number of diffraction orders for transmission'
         CALL WRIMSG('REAPAR',CMSGNM)
         CWHERE='error reading diffraction orders in ddscat.par for JPBC=3'
         IF(NPLANES>0)THEN
            DO JPLANE=1,NPLANES  
               READ(IOPAR,FMT=*,ERR=99,END=99)PHIN(NSCA+1),THETAN(NSCA+1)
               NSCA=NSCA+1
            ENDDO
            DO J=1,NSCA
               PHIN(J+NSCA)=PHIN(J)
               THETAN(J+NSCA)=THETAN(J)
            ENDDO
            NSCA=2*NSCA
         ENDIF

!=======================================================================

      ENDIF
      CLOSE(IOPAR)
!*** diagnostic
!      write(0,*)'reapar ckpt 9: MXNX,MXNY,MXNZ=',MXNX,MXNY,MXNZ
!***
      RETURN
99    CONTINUE
      CALL WRIMSG('REAPAR',CWHERE)
      CALL ERRMSG('FATAL','REAPAR',' Error reading ddscat.par file')
      RETURN
    END SUBROUTINE REAPAR

    SUBROUTINE INTERP(X,Y,Z,XA,YA,ZA,IDVOUT,MXTAB,NTAB)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
! Arguments:
      INTEGER :: IDVOUT, MXTAB, NTAB
      REAL (WP) :: X, Y, Z
      REAL (WP) :: XA(MXTAB), YA(MXTAB), ZA(MXTAB)
! Local variables:
      INTEGER :: I1, I2, I3, I4, INC
      REAL (WP) :: SGN, X1, X2, X3, X4, Y1, Y2, Y3, Y4
!***********************************************************************
! Given array of tabulated values XA(1-NTAB), YA(1-NTAB), ZA(1-NTAB),
! and given independent variable X, this routine interpolates for two
! dependent variables: Y and Z.
! Uses only parabolic interpolation for safety.
! When called with X outside range of tabulated values XA, returns
! extrapolated values Y and Z but issues warning statement.
! Note: XA values must be either monotonically increasing OR
!       monotonically decreasing.
! B.T.Draine, Princeton Univ. Observatory
! 89/12/19 (BTD): Revised.
! 91/05/02 (BTD): Added IDVOUT to argument list.
!                 Changed WRITE(0 -> WRITE(IDVOUT
! 92/03/24 (BTD): Added test IF(I2.GE.NTAB) in case INTERP is used for
!                 data sets with different lengths.

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DATA I2/1/

      IF (I2>=NTAB) I2 = NTAB - 1
      INC = 0
      SGN = 1.E0_WP
!*** Check whether X is increasing or decreasing:
      IF (XA(1)>=XA(NTAB)) SGN = -1.E0_WP
!*** Check whether outside table limits
      IF ((SGN*(X-XA(1)))<0.E0_WP) THEN
        I2 = 2
        WRITE (IDVOUT,FMT=6990) X
        GO TO 4600
      END IF
      IF (SGN*(X-XA(NTAB))>0.E0_WP) THEN
        I2 = NTAB - 1
        WRITE (IDVOUT,FMT=6990) X
        GO TO 4600
      END IF
!*** X is within table limits.  Find I2
1000  IF (SGN*(XA(I2)-X)) 2000, 3000, 4000
2000  IF (INC) 2100, 2200, 2200
2100  IF (I2+2-NTAB) 4700, 4700, 2500
2200  INC = 1
      I2 = I2 + 1
      IF (I2+1<=NTAB) GO TO 1000
2500  I2 = NTAB - 1
      GO TO 4600
3000  Y = YA(I2)
      Z = ZA(I2)
      RETURN
4000  IF (INC) 4200, 4200, 4100
4100  I2 = I2 - 1
      IF (I2-2) 4500, 4700, 4700
4200  INC = -1
      I2 = I2 - 1
      IF (I2>=2) GO TO 1000
4500  I2 = 2
4600  I1 = I2 - 1
      I3 = I2 + 1
      X1 = XA(I1)
      X2 = XA(I2)
      X3 = XA(I3)
      Y1 = YA(I1)
      Y2 = YA(I2)
      Y3 = YA(I3)
      CALL PARAB3(X,Y,X1,X2,X3,Y1,Y2,Y3)
      Y1 = ZA(I1)
      Y2 = ZA(I2)
      Y3 = ZA(I3)
      CALL PARAB3(X,Z,X1,X2,X3,Y1,Y2,Y3)
      RETURN
4700  I1 = I2 - 1
      I3 = I2 + 1
      I4 = I2 + 2
      X1 = XA(I1)
      X2 = XA(I2)
      X3 = XA(I3)
      X4 = XA(I4)
      Y1 = YA(I1)
      Y2 = YA(I2)
      Y3 = YA(I3)
      Y4 = YA(I4)
      CALL PARAB4(X,Y,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      Y1 = ZA(I1)
      Y2 = ZA(I2)
      Y3 = ZA(I3)
      Y4 = ZA(I4)
      CALL PARAB4(X,Z,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      RETURN
6990  FORMAT ('Warning from INTERP: outside table limits for X=',1P,D12.5)
    END SUBROUTINE INTERP

    SUBROUTINE PARAB3(X,Y,X1,X2,X3,Y1,Y2,Y3)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: A, B, X, X1, X2, X3, Y, Y1, Y2, Y3
!***********************************************************************
! Subroutine PARAB3 does parabolic interpolation, with parabola
! constrained to fit (x1,y1),(x2,y2),(x3,y3) exactly.
! B.T.Draine, Institute for Advanced Study, March 1980.

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      A = (Y3-Y2-(X3-X2)*(Y1-Y2)/(X1-X2))/((X3-X2)*(X3-X1))
      B = (Y1-Y2)/(X1-X2) - A*(X1-X2)
      Y = (A*(X-X2)+B)*(X-X2) + Y2
      RETURN
    END SUBROUTINE PARAB3

    SUBROUTINE PARAB4(X,Y,X1,X2,X3,X4,Y1,Y2,Y3,Y4)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: A, B, X, X1, X2, X3, X4, Y, Y1, Y2, Y3, Y4
!***********************************************************************
! Subroutine PARAB4 is designed to do parabolic interpolation, with
! parabola constrained to match (x2,y2) and (x3,y3) exactly, and to
! minimize sum of squared deviations from (x1,y1) and (x4,y4).
! It is assumed that x1.lt.x2.le.x.lt.x3.lt.x4
! Fit parabola Y=A*(X-X2)**2+B*(X-X2)+Y2
! B.T.Draine, Institute for Advanced Study, March 1980.

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!**********************************************************************
      A = ((X1-X2)*(Y3-Y2)/(X3-X2)+Y2-Y1)*(X1-X2)*(X1-X3) + &
        ((X4-X2)*(Y3-Y2)/(X3-X2)+Y2-Y4)*(X4-X2)*(X4-X3)
      A = -A/(((X1-X2)*(X1-X3))**2+((X4-X2)*(X4-X3))**2)
      B = (Y3-Y2)/(X3-X2) - A*(X3-X2)
      Y = (A*(X-X2)+B)*(X-X2) + Y2
      RETURN
    END SUBROUTINE PARAB4

    SUBROUTINE DIAGL(U,V,IPAR)
      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_2,ONLY : CXADIA
      USE DDCOMMON_6,ONLY : GAMMA,PYD,PZD,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, &
                            NAT0,NX,NY,NZ,MXN3F,IDVOUT,IPBC
      IMPLICIT NONE

! Arguments:
      COMPLEX (WP) :: U(*),V(*)
      INTEGER :: IPAR(*)

! cg package
! Left preconditioning subroutine - division by diagonal
! History:
! Originally written by P.J. Flatau, 1993
! 00.06.26 (BTD) Removed MXMEMF from COMMON/M6/
! 04.03.04 (BTD) Added NPY,NPZ to COMMON/M6/ to support periodic
!                boundary conditions
! 05.06.16 (BTD) Replaced integer NPY,NPZ by real PYD,PZD in /M6/
! 06.09.28 (BTD) Added IPBC to COMMON/M6/
! 07.06.30 (BTD) moved CMDFFT from COMMON/M6/... CMDFFT
!                to COMMON/M8/CMDFFT
!                moved PYD,PZD to beginning of COMMON/M6/
! 07.08.04 (BTD) Version 7.0.3
!                * replaced COMMON/M2/ with MODULE DDCOMMON_2
!                * replaced COMMON/M6/ with MODULE DDCOMMON_6
!                * removed COMMON/M8/CMDFFT (CMDFFT not used)
! 08.03.11 (BTD) ver7.0.5
!                * added ALPHA to DDCOMMON_6
! 08.04.20 (BTD) * change notation: ALPHA -> GAMMA
! end history
! Copyright (C) 1993,2000,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'entered DIAGL with IPBC=',IPBC
!      write(0,*)'about to call CDIV'
!***
      CALL CDIV(U,V,CXADIA,NAT3)
      RETURN
    END SUBROUTINE DIAGL

!=======================================================================

    SUBROUTINE CDIV(U,V,CXA,N)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: N
      COMPLEX (WP) :: U(*),V(*),CXA(*)

! Local variables:
      INTEGER :: I

!-----------------------------------------------------------------------
! Part of conjugate gradient package
! needed by left preconditioning subroutine
! Copyright (C) 2003 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License
!-----------------------------------------------------------------------

!*** diagnostic
!      write(0,*)'entered CDIV with N=',N,' **inefficient computation**'
!***
      DO I=1,N
!*** diagnostic --- BE SURE TO ELIMINATE THIS TEST!!!
!         if(.not.(abs(cxa(i))>=0.d0))then
!            write(0,*)'division by zero for i=',i,' cxa(i)=',cxa(i)
!         endif
!         if(.not.(abs(u(i))>=0.d0))then
!            write(0,*)'problem for i=',i,' u(i)=',u(i)
!         endif
!***
         V(I)=U(I)/CXA(I)
      ENDDO
      RETURN
    END SUBROUTINE CDIV

!=======================================================================

    SUBROUTINE MATVEC(CXX,CXY,IPAR)
      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_1,ONLY : AKR,DX
      USE DDCOMMON_2,ONLY : CXADIA
      USE DDCOMMON_3,ONLY : CXZC
      USE DDCOMMON_4,ONLY : CXZW
      USE DDCOMMON_5,ONLY : IOCC
      USE DDCOMMON_6,ONLY : GAMMA,PYD,PZD,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, &
                            NAT0,NX,NY,NZ,MXN3F,IDVOUT,IPBC
      USE DDCOMMON_7,ONLY : CXAOFF
      USE DDCOMMON_8,ONLY : CMDFFT
      IMPLICIT NONE

! Arguments:

      COMPLEX(WP) :: CXX(*),CXY(*)
      INTEGER :: IPAR(*)

! Subroutine MATVEC

! matvec  --> cxy = A cxx          'N'
! tmatvec --> cxy = A' cxx         'T'
! cmatvec --> cxy = conjg(A') cxx  'C'


! Notice that DDSCAT has cases 'N' and 'C' implemented in CPROD
! Notice, however, that in DDSCAT 'T'='N'.
! Some CG methods use cases N, C (like Petravic).
! Some CG methods use cases N, T (like PIM)
! Some CG use all three products N, C, T  (parts of CCGPAK)

! Information about matrix A is transfered via commons /M1/-/M7/ with
! the main program. Arrays cxadia, cxzc, cxzwm,  iocc are properly
! dimensioned inside "cprod". You may get warning during the compilation
! about "misaligned common". Ignore these. Also notice mxnatf,
! mxn3f,mxnxf, mxnyf, mxnzf. These are defined by "parameter
! statement" in main code and this is the reason why they have "f" suffi

! ipar - information array, not used, defined for compatibility

! History:
! 97.11.01 (BTD): modified to allow for noncubic lattice, introduced
!                 new vector DX(1-3) via COMMON/M1/
!                 added DX to argument list of CPROD
! 97.12.25 (BTD): added COMMON/M7/CXAOFF to communicate off-diagonal
!                 elements of inverse polarizability tensors.
!                 Added CXAOFF to argument list of CPROD
! 00.06.13 (BTD): Explicit declaration of all variables.
! 00.06.25 (BTD): Removed MXMEMF from COMMON/M6/
! 04.03.04 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
!                 boundary conditions
!                 Added NPY,NPZ to argument list of CPROD
! 05.06.16 (BTD): Replaced integer NPY,NPZ by real PYD,PZD
! 06.09.28 (BTD): Version 6.2.3
!                 * Added IPBC to COMMON/M6/
!                 * Added IPBC to argument list of CPROD
! 07.06.30 (BTD): moved CMDFFT from COMMON/M6/... CMDFFT
!                 to COMMON/M8/CMDFFT
!                 moved PYD,PZD to beginning of COMMON/M6/
! 07.08.04 (BTD): Version 7.0.3
!                 * renamed AK(3)->AKR(3) for consistency with COMMON/M1/
!                   in DDSCAT
!                 * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                 * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                 * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                 * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                 * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                 * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                 * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                 * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
! 08.03.11 (BTD): v7.0.5
!                 * added ALPHA to DDCOMMON_6
! 08.03.14 (BTD): * changed declaration of argument IPAR
!                   from COMPLEX(WP) :: IPAR(*)
!                   to INTEGER :: IPAR(*)
!                   NB: dummy argument IPAR is not used
! 08.04.20 (BTD): * change notation: ALPHA -> GAMMA
! end history
! Copyright (C) 1993,1997,2000,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!*** diagnostic
!      write(0,*)'matvec ckpt 1, IPBC=',IPBC
!      write(0,*)'               about to call CPROD with CWHAT=N'
!***
      CALL CPROD(AKR,GAMMA,DX,CMDFFT,'N',CXADIA,CXAOFF,CXX,CXY,CXZC,CXZW,     &
                 IDVOUT,IOCC,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT0,NAT3,NX, &
                 NY,NZ,IPBC,PYD,PZD)
!*** diagnostic
!      write(0,*)'matvec ckpt 2'
!***
      RETURN
    END SUBROUTINE MATVEC

!=======================================================================

    SUBROUTINE CMATVEC(CXX,CXY,IPAR)
      USE DDPRECISION,ONLY: WP
      USE DDCOMMON_1,ONLY: AKR,DX
      USE DDCOMMON_2,ONLY: CXADIA
      USE DDCOMMON_3,ONLY: CXZC
      USE DDCOMMON_4,ONLY: CXZW
      USE DDCOMMON_5,ONLY: IOCC
      USE DDCOMMON_6,ONLY: GAMMA,PYD,PZD,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, &
                           NAT0,NX,NY,NZ,MXN3F,IDVOUT,IPBC
      USE DDCOMMON_7,ONLY: CXAOFF
      USE DDCOMMON_8,ONLY: CMDFFT
      IMPLICIT NONE

! Arguments:

      COMPLEX(WP) :: CXX(*),CXY(*),IPAR(*)

!-----------------------------------------------------------------------
! Subroutine CMATVEC

! matvec  --> cxy = A cxx
! tmatvec --> cxy = A' cxx
! cmatvec --> cxy = conjg(A') cxx
! History:
! 97.11.01 (BTD): modified to allow for noncubic lattice, introduced
!                 new vector DX(1-3) via COMMON/M1/
!                 added DX to argument list of CPROD
! 97.12.25 (BTD): added COMMON/M7/CXAOFF to communicate off-diagonal
!                 elements of inverse polarizability tensors.
!                 Added CXAOFF to argument list of CPROD
! 00.06.13 (BTD): Explicit declaration of all variables.
! 00.06.26 (BTD): Removed MXMEMF from COMMON/M6/
! 04.03.04 (BTD): Added NPY,NPZ to COMMON/M6/ to support periodic
!                 boundary conditions
!                 Added NPY,NPZ to argument list of CPROD
! 05.06.16 (BTD): Replaced integer NPY,NPZ by real PYD,PZD in
!                 COMMON/M6/ and argument list of CPROD
! 06.09.29 (BTD): Version 6.2.3:
!                 * Added IPBC to COMMON/M6/
!                 * Added IPBC to argument list of CPROD
! 07.06.30 (BTD): moved CMDFFT from COMMON/M6/... CMDFFT
!                 to COMMON/M8/CMDFFT
!                 moved PYD,PZD to beginning of COMMON/M6/
! 07.08.04 (BTD): Version 7.0.3:
!                 * renamed AK(3)->AKR(3) for consistency with
!                   COMMON/M1/ in DDSCAT
!                 * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                 * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                 * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                 * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                 * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                 * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                 * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                 * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
! 08.03.11 (BTD): v7.0.5:
!                 * added ALPHA to DDCOMMON_6
! 08.04.20 (BTD): * changed notation: ALPHA -> GAMMA
! end history
! Copyright (C) 1993,1997,2000,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!*** diagnostic
!      write(0,*)'entered cmatvec with IPBC=',IPBC
!***
      CALL CPROD(AKR,GAMMA,DX,CMDFFT,'C',CXADIA,CXAOFF,CXX,CXY,CXZC,CXZW,     &
                 IDVOUT,IOCC,MXN3F,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT0,NAT3,NX, &
                 NY,NZ,IPBC,PYD,PZD)
      RETURN
    END SUBROUTINE CMATVEC

!=======================================================================

      SUBROUTINE CPROD(AKR,GAMMA,DX,CMETHD,CWHAT,CXADIA,CXAOFF,CXX,CXY,CXZC, &
                       CXZW,IDVOUT,IOCC,MXN3,MXNAT,MXNX,MXNY,MXNZ,NAT,NAT0,  &
                       NAT3,NX,NY,NZ,IPBC,PYD,PZD)
      USE DDPRECISION,ONLY : WP
       
      IMPLICIT NONE

! Arguments:

      INTEGER :: IDVOUT,IPBC,MXN3,MXNAT,MXNX,MXNY,MXNZ,NAT,NAT0,NAT3, &
         NX,NY,NZ
      CHARACTER :: CMETHD*6,CWHAT*1
      INTEGER*2 :: &
         IOCC(MXNAT)
      REAL(WP) :: GAMMA,PYD,PZD
      REAL(WP) :: &
         AKR(3),  &
         DX(3)
      COMPLEX(WP) ::                                                 &
         CXADIA(MXN3),                                               &
         CXAOFF(MXN3),                                               &
         CXX(MXN3),                                                  &
         CXY(MXN3),                                                  &
         CXZC(NX+1+IPBC*(NX-1),NY+1+IPBC*(NY-1),NZ+1+IPBC*(NZ-1),6), &
         CXZW(MXNX*MXNY*MXNZ,*)

! Local variables:

      INTEGER :: J1,J2,J3
      REAL(WP) :: AKD,DTIME

! Intrinsic functions:

      INTRINSIC CONJG

!***********************************************************************
! Subroutine CPROD

! Given:
!   AKR(1-3)= k(1-3)*d , where k=k vector in vacuo
!                       d=effective lattice spacing=(dx*dy*dz)**(1/3)
!   GAMMA  = parameter controlling PBC summations over replica dipoles
!            interaction is suppressed by factor exp(-(gamma*k*r)^4)
!            and summations are carried out to r=2/(gamma*k)
!   DX(1-3)=(dx/d, dy/d, dz/d)
!                 where dx,dy,dz=lattice spacing in x,y,z directions.
!                 By definition of effective lattice spacing d, must
!                 have DX(1)*DX(2)*DX(3)=1
!   CMETHD         = character variable specifying method used for FFT
!                    evaluation (see ESELF)
!   CWHAT          = 'N' or 'C' determines what is to be done (see below
!   CXADIA(1-NAT3) = diagonal elements of A(j,k)
!                    (diagonal elements of inverse of polarizability
!                     tensor for dipoles 1-NAT)
!   CXAOFF(1-NAT3) = off-diagonal elements of 3x3 diagonal blocks of
!                    A(j,k): CXAOFF(J,1-3)=a_{23},a_{31},a_{12} from 3x3
!                    matrix a_{ij} for dipole J.
!                    Recall that a_{ij} is inverse of 3x3 polarizability
!                    tensor alpha_{ij} for dipole J.
!   CXX(1-NAT3)    = complex vector
!   CXZC           = array of Fourier transformed Green function
!                    coefficients used internally by ESELF, and generate
!                    by ESELF each time called with new k vector
!                    If IPBC=0: size = (NX+1)*(NY+1)*(NZ+1)*6
!                    If IPBC=1: size = (2*NX)*(2*NY)*(2*NZ)*6
!                    *****Not to be overwritten between calls to ESELF**
!   CXZW           = complex workspace required by ESELF
!   IDVOUT      = device number for output
!   IOCC(1-NAT) = 0 or 1 if site is unoccupied or occupied
!   MXN3,MXNX,MXNY,MXNZ = dimensioning information (see DDSCAT)
!   NAT         = number of sites in extended target
!   NAT0        = number of occupied sites in extended target
!   NAT3        = 3*NAT
!   NX,NY,NZ    = extended target size is (NX*DX(1)) by (NY*DX(2)) by
!                 (NZ*DX(3))
!   PYD         = 0. to do isolated target
!               = (periodicity in y direction)/d(2) for periodic b.c.
!   PZD         = 0. to do isolated target
!               = (periodicity in z direction)/d(3) for periodic b.c.

! Returns:
!   CXY(1-NAT3)
!       If CWHAT = 'N' : CXY(j)=A(j,k)*CXX(k) (sum over k)
!                = 'C' : CXY(j)=conjg(A(k,j))*CXX(k) (sum over k)

! It is assumed that matrix A(j,k) is symmetric
! Diagonal elements of A(j,k) are in vector CXADIA(j)
! Off-diagonal terms coupling dipole component x with direction y, etc
! are stored in vector CXAOFF(j), CXAOFF(j+NAT), CXAOFF(j+2*NAT)
! Other off-diagonal elements of A(j,k) are produced internally by
!   subroutine ESELF, which uses 3d-FFT to accomplish convolution
!   of CXX with A-matrix terms coupling dipole j with other dipoles
!   (i.e., E field at j due to other dipoles)

! Original version of CPROD created by P.J.Flatau, Colorado State Univ.
! Subsequently modified by B.T.Draine, Princeton Univ. Obs.
! History:
! 90.11.04 (BTD): Major modification to incorporate FFT method (FFT
!                 computations are handled by ESELF).
! 90.11.08 (BTD): Remove DO...ENDDO structures; renumber DO...CONTINUEs
! 90.11.21 (BTD): Remove "CCGMVM" option: only FFT stuff retained.
! 90.12.03 (BTD): No longer necessary to change ordering of CXX and CXY
! 90.12.05 (BTD): Changed call to ESELF to eliminate MXNX,MXNY,MXNZ
! 97.11.01 (BTD): Added comments and modified to accomodate noncubic
!                 lattice. Added DX to argument list for CPROD and to
!                 argument list in call to ESELF
! 97.12.25 (BTD): Added CXAOFF to argument list.
! 97.12.28 (BTD): Modified to use CXAOFF in calculation of CXY
! 98.01.01 (BTD): Modified coding to use indices J1,J2,J3 in loops
!                 computing with CXAOFF
! 00.06.13 (BTD): Explicit declaration of all variables.
! 04.03.05 (BTD): Added NPY,NPZ to argument list to support periodic
!                 boundary conditions
! 05.06.16 (BTD): Replaced integer NPY,NPZ by real PYD,PZD
!                 in argument list and in argument list of CPROD
! 05.08.04 (BTD): Added AKR(1-3) to argument list of ESELF
! 06.09.23 (BTD): Added comments
! 06.09.29 (BTD): Version 6.2.3:
!                 * Added IPBC to argument list of CPROD
!                 * Modified dimensioning of array CXZC to use larger
!                   dimension when IPBC=1
!                 * Added IPBC to argument list of ESELF (two places)
! 07.08.04 (BTD): Version 7.0.3:
!                 * renamed AK(3)->AKR(3) for consistency with
!                   COMMON/M1/ in DDSCAT
! 08.01.13 (BTD): cosmetic changes
! 08.03.11 (BTD): v7.0.5
!                 * added ALPHA to argument list
!                 * added ALPHA to argument list of ESELF
! 08.04.20 (BTD): * changed notation: ALPHA -> GAMMA
! 08.05.12 (BTD): v7.0.6
!                 * added calls to TIMEIT to time ESELF
! end history
! Copyright (C) 1993,1997,1998,2000,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!-----------------------------------------------------------------------
!*** diagnostic
!      write(0,*)'cprod ckpt 1 with nx,ny,nz,ipbc=',nx,ny,nz,ipbc
!      write(0,*)'              cwhat=',cwhat
!***

      AKD=SQRT(AKR(1)*AKR(1)+AKR(2)*AKR(2)+AKR(3)*AKR(3))

!*** diagnostic
!      write(0,*)' in cprod, akd=',akd
!***
! We assume that input vector CXX has zeroes for elements corresponding
! to vacuum sites.

      IF(CWHAT=='N')THEN
!***********************************************************************

!        CXX(1-NAT3) = polarizations

!*** diagnostic
!         write(0,*)'cprod ckpt 2: about to call eself from cprod'
!***
! 08.10.02 suppress this...
!         CALL TIMEIT('ESELFCP',DTIME)
         CALL ESELF(CMETHD,CXX,NX,NY,NZ,IPBC,GAMMA,PYD,PZD,AKR,AKD,DX, &
                    CXZC,CXZW,CXY)
! 08.10.02 suppress this...
!         CALL TIMEIT('ESELFCP',DTIME)

!*** diagnostic
!         write(0,*)'cprod ckpt 3'
!***
!        CXY(1-NAT3) is now Efield produced by other dipoles (including
!                    replica dipoles if PYZ or PZD are nonzero)

!*** diagnostic
!        write(0,*)'returned to cprod from eself'
!        write(0,*)'check cxy for NaN...'
!        j2=0
!        do j1=1,nat3
!           if(.not.(abs(cxy(j1))>=0.d0))then
!              write(0,*)'j1=',j1,' cxy(j1)=',cxy(j1)
!              j2=j2+1
!           endif
!        enddo
!        write(0,*)'cxy checked for NaN'
!        write(0,*)'j2=',j2,' instances'
!***
!***********************************************************************
! ESELF omitted contribution from diagonal terms: add these.
! Also remember that ESELF computes -A_jk*x_k

         DO J1=1,NAT3
            CXY(J1)=CXADIA(J1)*CXX(J1)-CXY(J1)
         ENDDO

!*** diagnostic
!        write(0,*)'in cprod ckpt 700, check cxy for NaN...'
!        do j1=1,nat3
!           if(.not.(abs(cxy(j1))>=0.d0))then
!              write(0,*)'j1=',j1,' cxy(j1)=',cxy(j1)
!           endif
!        enddo
!        write(0,*)'cxy checked for NaN'
!***        
! Add contribution from off-diagonal elements of 3x3 diagonal blocks
! Version below assumes that off-diagonal elements a_ij are stored as
! CXAOFF(J,1-3)=(a_23,a_31,a_12) for dipole J.
! 97.12.28 (BTD):

         DO J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            CXY(J1)=CXY(J1)+CXAOFF(J2)*CXX(J3)+CXAOFF(J3)*CXX(J2)
            CXY(J2)=CXY(J2)+CXAOFF(J3)*CXX(J1)+CXAOFF(J1)*CXX(J3)
            CXY(J3)=CXY(J3)+CXAOFF(J1)*CXX(J2)+CXAOFF(J2)*CXX(J1)
         ENDDO
!*** diagnostic
!        write(0,*)'in cprod ckpt 701, check cxy for NaN...'
!        do j1=1,nat3
!           if(.not.(abs(cxy(j1))>=0.d0))then
!              write(0,*)'j1=',j1,' cxy(j1)=',cxy(j1)
!           endif
!        enddo
!        write(0,*)'cxy checked for NaN'
!***        

      ELSEIF(CWHAT=='C')THEN

! Need to temporarily replace CXX by conjg(CXX)

         DO J1=1,NAT3
            CXX(J1)=CONJG(CXX(J1))
         ENDDO

!***********************************************************************

         CALL ESELF(CMETHD,CXX,NX,NY,NZ,IPBC,GAMMA,PYD,PZD,AKR,AKD,DX, &
                    CXZC,CXZW,CXY)

!***********************************************************************

! ESELF omitted contribution from diagonal terms: add these.
! Also remember that ESELF computed -A_jk*conjg(x_k), while
! we seek to compute conjg(A_kj)* x_k.  Since A_kj=A_jk, we have
! conjg(A_kj)*x_k=conjg(A_jk*conjg(x_k))

         DO J1=1,NAT3
            CXY(J1)=CXADIA(J1)*CXX(J1)-CXY(J1)
         ENDDO

! Add contribution from off-diagonal elements of 3x3 diagonal blocks
! It is assumed that we have stored off-diagonal elements a_ij as
! CXAOFF(J,1-3)=(a_23,a_31,a_12) for element J
! Note that we could *probably* speed up the code by
! (1) "reducing" product vector CXY immediately after calling ESELF
! (2) restricting CXADIA to occupied sites
! (3) restricting CXAOFF to occupied sites
! but this would require modifications outside this routine, and
! therefore requires further study...
! 97.12.28 (BTD)

         DO J1=1,NAT
            J2=J1+NAT
            J3=J2+NAT
            CXY(J1)=CXY(J1)+CXAOFF(J2)*CXX(J3)+CXAOFF(J3)*CXX(J2)
            CXY(J2)=CXY(J2)+CXAOFF(J3)*CXX(J1)+CXAOFF(J1)*CXX(J3)
            CXY(J3)=CXY(J3)+CXAOFF(J1)*CXX(J2)+CXAOFF(J2)*CXX(J1)
         ENDDO

! Now compute conjugate of CXY, and restore CXX:

         DO J1=1,NAT3
            CXY(J1)=CONJG(CXY(J1))
            CXX(J1)=CONJG(CXX(J1))
         ENDDO
      ELSE
         WRITE (IDVOUT,FMT=*) ' Error in CPROD: CWHAT= ',CWHAT
      ENDIF

!*** Now must "clean" product vector CXY:
!    (zero out elements corresponding to vacuum sites)

!*** diagnostic
!      write(0,*)'about to call nuller to clean cxy...'
!      write(0,*)'mxnat=',mxnat,' mxn3=',mxn3
!      write(0,*)' nat=',nat,' nat0=',nat0
!***

      IF(NAT0<NAT)CALL NULLER(CXY,IOCC,MXNAT,MXN3,NAT)

!*** diagnostic
!      write(0,*)'in cprod, ckpt 707, check xy for NaN'
!      j2=0
!      do j1=1,nat3
!         if(.not.(abs(cxy(j1))>=0.d0))then
!            j2=j2+1
!            write(0,*)'j1=',j1,' cxy(j1)=',cxy(j1)
!         endif
!      enddo
!      write(0,*)'cxy checked for NaN: j2=',j2,' instances'
!***
       RETURN
    END SUBROUTINE CPROD

    SUBROUTINE CXFFT3_MKL(CX,MX,MY,MZ,ISIGN)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments

      INTEGER :: ISIGN,MX,MY,MZ
      COMPLEX(WP) :: CX(MX*MY*MZ)

! Local variables

      CHARACTER :: CMSGNM*70

!=======================================================================

! Purpose: This is a dummy routine to substitute for CXFFT3_MKL to
!          allow DDSCAT to be used on systems where the Intel MKL
!          library is not available.  If called, it will generate
!          a fatal error with an explanatory error message.
! History
! 08.06.05 (BTD): created
! end history
! Copyright (C) 2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!=======================================================================

      WRITE(CMSGNM,FMT='(A,A)') &
        'FATAL ERROR: DDSCAT compiled with cxfft3_mkl_fake'
      CALL WRIMSG('CXFFT3_MKL',CMSGNM)
      WRITE(CMSGNM,FMT='(A)') &
        ' *** option FFTMKL cannot be used with dummy routine'
      CALL WRIMSG('CXFFT3_MKL',CMSGNM)
      WRITE(CMSGNM,FMT='(A)') &
        ' *** to enable option FFTMKL it is necessary to:'
      CALL WRIMSG('CXFFT3_MKL',CMSGNM)
      WRITE(CMSGNM,FMT='(A)') &
        '     have Intel Math Kernel Library (MKL) installed on system'
      CALL WRIMSG('CXFFT3_MKL',CMSGNM)
      WRITE(CMSGNM,FMT='(A)') &
        '     and edit Makefile to use cxfft3_mkl.f90 and mkl_dfti.f90'
      CALL WRIMSG('CXFFT3_MKL',CMSGNM)

      STOP
    END SUBROUTINE CXFFT3_MKL

    SUBROUTINE TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,SHPAR,DX, &
                      NAT,IXYZ,ICOMP,IDVOUT,MXN3,NAT3,PYD,PZD,BETADF,PHIDF,   &
                      THETADF,X0,IANISO)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: MXNAT,MXN3

      CHARACTER :: CDESCR*67,CFLSHP*80,CSHAPE*9
      INTEGER*2 ::   &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      INTEGER :: IANISO,IDVOUT,IDVSHP,IOSHP,NAT,NAT3
      REAL(WP) :: PYD,PZD
      REAL(WP) ::        &
         A1(3),          &
         A2(3),          &
         BETADF(MXNAT),  &
         DX(3),          &
         PHIDF(MXNAT),   &
         SHPAR(12),      &
         THETADF(MXNAT), &
         X0(3)
      EXTERNAL ERRMSG,REASHP,TARCYL,TARELL,TARHEX,TARREC,TARTET

! Local variables:

      INTEGER :: BLKSIZ,IPRINAX,J,J1,NBLOCKS
      INTEGER ::  &
         XYZB(3,100)
      REAL(WP) :: PI

!***********************************************************************
! Given:
!    CSHAPE = string describing target geometry; will determine which
!             "shape" routine is invoked.  Current options are:
!             
! ANIELLIPS, 3 args
! ANIFRMFIL, 0
! ANI_ELL_2, 3
! ANI_ELL_3, 3
! ANIRCTNGL, 3
! BISLINPBC, 6
! CONELLIPS, 6
! CYLINDER1, 3
! CYLNDRCAP, 2
! CYLNDRPBC, 5
! DSKBLYPBC, 8
! DSKRCTNGL, 5
! DSKRCTPBC, 7
! DW1996TAR, 1
! ELLIPSOID, 3
! ELLIPSO_2, 3
! ELLIPSO_3, 3
! FROM_FILE, 0
! GAUSS_SPH, 6
! HEXGONPBC, 5
! HEX_PRISM, 3
! LAYRDSLAB, 7
! LYRSLBPBC, 9
! MLTBLOCKS, 0 [read data from blocks.par]
! RCTGLPRSM, 3
! RCTGLBLK3, 9
! RCTGL_PBC, 5
! RCTG_RCTG, 6
! RECRECPBC, 8
! SPHERES_N, 2 [also need file name]
! SPHRN_PBC, 3 [also need file name]
! SPHROID_2, 6
! SPH_ANI_N, 2 [also need file name]
! TARHOLSLB, 4
! TARSLBLIN  6 
! TETRAHDRN, 1
! TRNGLPRSM, 4
! UNIAXICYL, 2


!    IOSHP = device number for "target.out" file
!          = -1 to suppress printing of "target.out"

!    SHPAR(1-10) = up to 10 parameters defining target geometry

!    DX(1-3)= d_x/d, d_y/d, d_z/d for lattice, where d=(d_x*d_y*d_z)**(1
!             is the effective lattice spacing, and d_x,d_y,d_z are latt
!             spacings in x,y,z directions

!    MXNAT = limit on largest allowed value of NAT
!    MXN3  = 3*MXNAT
!    IDVOUT = 1 to print out information on target shape
!            -1 to suppress printing information on target shape
!    CFLSHP = name of target shape file if CSHAPE='FROM_FILE' or
!                                          CSHAPE='ANIFRMFIL'
!    IDVSHP = device number to use to read target shape if
!             CSHAPE='FROM_FILE' or CSHAPE='ANIFRMFIL'

! Returns:

!    IANISO  = 0 for targets composed of isotropic materials
!            = 1 for targets composed of aniosotropic materials,
!                but with optical axes || x_TF,y_TF,z_TF
!            = 2 for general anisotropic targets
!    A1,A2   = two 3-vectors defining initial target orientation
!    CDESCR  = string describing target
!    NAT     = number of dipoles in target
!    NAT3    = 3*NAT
!    IXYZ(1-NAT,1-3)=integers fixing x,y,z coordinates of
!              occupied sites in target
!    ICOMP(1-NAT,1-3)=composition for E in x,y,z direction at each site
!    BETADF(1-NAT)=angle specifying orientation of "Dielectric Frame"
!                  for locations 1-NAT
!    PHIDF(1-NAT)=angle specifying orientation of "Dielectric Frame"
!                 for locations 1-NAT
!    THETADF(1-NAT)=angle specifying orientation of "Dielectric Frame"
!                   for locations 1-NAT
!    X0(1-3) = offset for IXYZ array.
!              Defined so that dipole with IXYZ(J,1-3)=(IX,IY,IZ)
!              is located at x_TF/(d*DX(1)) = IX+X0(1)
!                            y_TF/(d*DX(2)) = IY+X0(2)
!                            z_TF/(d*DX(3)) = IZ+X0(3)
!              where (x,y,z)_TF = (0,0,0) corresponds to some
!              well-defined location in the target, as specified in
!              the UserGuide for each target geometry.
!              i.e., lattice site IXYZ=(0,0,0) is located at
!                    (x,y,z)_TF = (X0(1)*DX(1), X0(2)*DX(2), X0(3)*DX(3))
!
!    PYD = 0 if isolated target
!        = (periodicity in target frame y direction)/DX(2) if periodic
!           boundary conditions are to be used
!    PZD = 0 if isolated target
!        = (periodicity in target frame z direction)/DX(3) if periodic
!           boundary conditions are to be used

! P.J.Flatau, Colorado State University
! B.T.Draine, Princeton Univ. Observatory
! History:
! 90.11.08 (BTD): Changed DO...ENDDO to DO #...# CONTINUE
! 90.12.02 (BTD): Changed ordering of data in ICOMP
! 90.12.14 (BTD): Changed option MKRECT -> RCTGLPRSM
! 91.05.02 (BTD): Added IDVOUT to argument list
!                 Added IDVOUT to argument list for subr. REASHP
! 91.05.23 (BTD): Added A1,A2 to arg. list for subr. REASHP
! 91.11.12 (BTD): Added IDVSHP to arg. list for TARGET and REASHP
! 92.09.21 (BTD): Added option UNIELL (uniaxial ellipsoid)
! 93.01.07 (BTD): Added option ELLIPSO_2 (two touching ellipsoids,
!                 consisting of materials 1 and 2)
! 92.01.07 (BTD): Added option ANI_ELL_2 (two touching anisotropic
!                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
!                 2nd with diel.fnc.4,5,6 along x,y,z
! 92.01.19 (BTD): Added option ELLIPSO_3 (three touching anisotropic
!                 ellipsoids, 1st with diel.fnc.1,2,3 along x,y,z
!                 2nd with diel.fnc.4,5,6 along x,y,z
!                 3rd with diel.fnc.7,8,9 along x,y,z
! 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
!                 Moved WRITE(IDVOUT,9010) from DDSCAT to TARGET
! 93.12.14 (BTD): Corrected handling of ELLIPSO_3 (had assigned
!                 ICOMP=1 to 50% of sites, ICOMP=2 to other 50%)
! 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
!                 allow up to 6 shape parameters
!                 Added call to TARCEL to generate two concentric
!                 ellipsoids
! 94.03.21 (BTD): Changed "CONCEL" to "CONELLIPS" for consistency with
!                 REAPAR
! 95.12.11 (BTD): Modified to handle "MLTBLOCKS" as target option, using
!                 subroutine TARBLOCKS
! 96.01.04 (BTD): Modified to handle "DW1996TAR" as target option
! 96.01.25 (BTD): Modified to handle "SPHROID_2" as target option
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 96.01.29 (BTD): Added variable IPRINAX to control choice of axes A1,A2
!                 in option MLTBLOCKS
! 97.06.04 (BTD): Corrected bug in handling of option "UNIAXICYL" -- was
!                 not setting composition correctly after changing REAPA
!                 so that no longer had choice of cylinder axis.
!                 Cylinder axis is always in x direction in target frame
!                 Thanks for Mike Wolff for calling attention to the
!                 bug.
! 97.11.01 (BTD): add DX to argument list to allow use of noncubic latti
!                 add DX to argument list of TARELL
! 97.12.26 (BTD): add DX to argument list of TARREC, TARCYL, TARHEX,
!                 TARTET, TAR2EL, TAR3EL, TARCEL, TAR2SP
! 98.04.27 (BTD): restored missing comma in argument list of TAR2EL
! 98.12.29 (BTD): added new option 'LAYRDSLAB' for layered slab
! 00.06.12 (BTD): modified to support option TARNSP for multisphere
!                 target, including variable lattice spacing DX
!                 all data type conversions now explicit
! 00.07.18 (BTD): corrected bug in calls to tarblocks
! 00.11.02 (BTD): added ICOMP to arg. list for TAR2EL,TAR3EL,TARCYL,
!                 TARELL,TARHEX,TARREC,RCTGLPRSM,TARTET
! 02.02.12 (BTD): added option TRNGLPRSM and call to routine TARPRSM
! 03.05.21 (BTD): added option SPHARM = irregular target
!                 generated using spherical harmonics
!                 target generated by TARSPHARM
! 03.05.22 (BTD): bug fix: define CFLSHP='spharm.par' when calling
!                 TARSPHARM
! 03.11.06 (BTD): modify to use new version of TARSPHARM
! 04.03.19 (BTD): change CFLSHP*13 to CFLSHP*80 to accomodate long file
!                 names
! 04.04.01 (BTD): added arguments NPY,NPZ to support periodic b.c.
!                 option (at present time, used only for target option
!                 SPHRN_PBC)
! 04.04.01 (BTD): Add DX to argument list of TARGSPHER
!                 Remove call to TARSPHARM -- this is superseded by
!                 TARGSPHER
! 04.04.29 (BTD): Add option ANIRCTNGL for anisotropic rectangular target
! Begin DDSCAT 6.2:
! 04.09.14 (BTD): Add material orientation angles BETADF,PHIDF,THETADF
!                 to argument list.
!                 Add target option ANIFRMFIL to read properties of general
!                 anisotropic target from file.
!                 Add target option SPH_ANI_N to read properties of target
!                 consisting of N anisotropic spheres
! 05.06.16 (BTD): Change from integers NYD,NZD to real PYD,PZD, because
!                 there is no reason for periods to be integer multiples
!                 of lattice spacing d.
! 05.08.03 (BTD): Add new target option RCTGL_PBC
! 06.09.13 (BTD): Add new target option CYLNDRCAP
! 06.09.15 (BTD): Modify to pass additional variable to TARHEX to allow
!                 orientation in TF to be selected.
! 06.09.15 (BTD): Add new target option HEXGONPBC
! 06.09.15 (BTD): Modify to pass additional variable to TARCYL to allow
!                 orientation in TF to be selected.
! 06.09.15 (BTD): Add new target option CYLNDRPBC
! 06.10.23 (BTD): Set a1=(1,0,0),a2=(0,1,0) for options CYLNDRPBC,HEXGONPBC
! 06.12.08 (BTD): Added support for target option TARPBX
!                 (pillbox on slab)
! 07.01.18 (BTD): Fixed bug in assignment of value of PYD,PZD
! 07.01.20 (BTD): Added support for option DSKRCTGNL
! 07.02.23 (BTD): Added support for option SLBPBC
! 07.02.25 (BTD): Fixed bugs.
! 07.06.19 (BTD): Add X0 (target offset info) to argument list
!                 Modified to use new TARPBX with X0
! 07.06.20 (BTD): Add X0 to argument list for TARCYL
! 07.09.09 (BTD): Cosmetic changes.
!                 Make sure that all PBC targets have
!                 a1=x_TF, a_2=y_TF
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 07.10.26 (BTD): Replace call to TARPBX by call to TARPBXN
!                 Add support for target option DSKBLYPBC
! 07.10.27 (BTD): * Changed SHPAR(6) -> SHPAR(10)
!                 * Changed all target names to new set of 9 character
!                   names.
!                 * Rorganized calls to target generating routines.
! 08.01.13 (BTD): Modified to add X0 to argument list of almost all
!                 target generation routines, as well as REASHP
! 08.01.17 (BTD): Added IANISO to argument list
!                 add code to set IANISO for each target option
! 08.02.01 (BTD): Changed SHPAR(10) -> SHPAR(12)
!                 Added target options 
!                 * RCTGLBLK3  (isolated target: 3 rectangular blocks)
!                 * BISLINPBC  (periodic target: bilayer slab with 
!                               parallel lines on top)
!                 * TRILYRPBC  (periodic target: 3 layer rectangular structure)
! 08.03.13 (BTD): v7.0.5
!                 corrected bug in handling of BISLINPBC
! 08.04.24 (BTD): Add new target option
!                 * TARHOLSLB  (slab with circular hole)
!                   using routine TARHOLESLAB
! 08.08.08 (BTD): Added X0 to argument list of TARBLOCKS
!                 Added X0 to argument list of TAR2SP
!                 Added X0 to argument list of TARHEX
!                 Added X0 to argument list of TARNAS
! 08.08.30 (BTD): Added X0 to argument list of TARPRSM
!                 Added X0 to argument list of TARTET
! 08.09.12 (BTD): Corrected typos DSKRCTGNL -> DSKRCTNGL
! 08.10.28 (BTD): Added X0 to argument list of TARBLOCKS for target
!                 option MLTBLOCKS
! 09.02.02 (BTD): For CSHAPE=='FROM_FILE', added code to set IANISO=2
!                 if any of the angles BETADF,PHIDF,THETADF are nonzero
! end history

! Copyright (C) 1993,1994,1995,1996,1997,1998,2000,2002,2003,2004,2005
!               2006,2007,2008,2009 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!*** diagnostic
!      write(0,*)'entered target, CSHAPE=',CSHAPE
!***
! initialize X0 to zero, because some target routines have not yet
! been upgraded to initialize X0

      DO J=1,3
         X0(J)=0._WP
      ENDDO

! Most targets are isolated, so set PYD=PZD=0 as the default, to be
! changed only in case of targets with periodic b.c.

      PYD=0._WP
      PZD=0._WP

! Most targets have BETADF=0,PHIDF=0,THETADF=0 so initialize these
! before proceeding.

      DO J=1,MXNAT
         BETADF(J)=0._WP
      ENDDO
      DO J=1,MXNAT
         PHIDF(J)=0._WP
      ENDDO
      DO J=1,MXNAT
         THETADF(J)=0._WP
      ENDDO

! Most targets use isotropic materials, so initialize IANISO=0
! before proceeding

      IANISO=0

!*** diagnostic
!      write(0,*)'target ckpt 1'
!***
!-----------------------------------------------------------------------
! ANIELLIPS -> anisotropic ellipsoid

      IF(CSHAPE=='ANIELLIPS')THEN
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)

! Dielectric constants 1,2,3 for E along directions x,y,z in Target Fram

         IANISO=1
         DO J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO

!-----------------------------------------------------------------------
! ANIFRMFIL -> read list of occupied sites and composition and material
!           orientation from file

      ELSEIF(CSHAPE=='ANIFRMFIL')THEN

         CALL REASHP(CSHAPE,CFLSHP,IDVOUT,IDVSHP,A1,A2,DX,X0,BETADF,PHIDF, &
                     THETADF,CDESCR,MXNAT,NAT,IXYZ,ICOMP,MXN3,NAT3)
         IANISO=1
         DO J=1,NAT
            IF(BETADF(J)/=0.)IANISO=2
            IF(PHIDF(J)/=0.)IANISO=2
            IF(THETADF(J)/=0.)IANISO=2
         ENDDO

!-----------------------------------------------------------------------
! ANI_ELL_2 -> two touching identical ellipsoids with anisotropic
!           functions.
!           second ellipsoid is displaced from first in x-direction
!           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
!           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.

      ELSEIF(CSHAPE=='ANI_ELL_2')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=1
         J1=NAT/2
         DO J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO
         DO J=J1+1,NAT
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
         ENDDO

!-----------------------------------------------------------------------
! ANI_ELL_3 -> three touching identical ellipsoids with anisotropic
!           functions.  Need to override TAR3EL.
!           second ellipsoid is displaced from first in x-direction
!           1st ellipsoid has dielectric fcns 1,2,3 in x,y,z dirs.
!           2nd ellipsoid has dielectric fcns 4,5,6 in x,y,z dirs.
!           3rd ellipsoid has dielectric fcns 7,8.9 in x,y,z dirs.

      ELSEIF(CSHAPE=='ANI_ELL_3')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=1
         J1=NAT/3
         DO J=1,J1
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=3
         ENDDO
         DO J=J1+1,2*J1
            ICOMP(J,1)=4
            ICOMP(J,2)=5
            ICOMP(J,3)=6
         ENDDO
         DO J=2*J1+1,NAT
            ICOMP(J,1)=7
            ICOMP(J,2)=8
            ICOMP(J,3)=9
         ENDDO

!-----------------------------------------------------------------------
! ANIRCTNGL -> homogeneous, anisotropic, rectangular target
!              optical axes of material are parallel to x_TF,y_TF,z_TF

      ELSEIF(CSHAPE=='ANIRCTNGL')THEN
         CALL TARANIREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                        MXNAT,NAT,IXYZ,ICOMP)
         IANISO=1

!-----------------------------------------------------------------------
! BISLINPBC -> bilayer slab with a rectangular-cross-section line on top,
!              extending infinitely in z-direction
!              if SHPAR(5)=0, then finite in y direction
!              SHPAR(1) = x-thickness/d of line  [material 1]
!              SHPAR(2) = y-width/d of line
!              SHPAR(3) = x-thickness/d of upper slab layer [material 2]
!              SHPAR(4) = x-thickness/d of lower slab layer [material 3]
!              SHPAR(5) = y-width/d of both lower slab layers
!              SHPAR(6) = periodicity/d of structure in y direction

      ELSEIF(CSHAPE=='BISLINPBC')THEN
         CALL TARRCTBLK3(A1,A2,SHPAR(1),SHPAR(3),SHPAR(4),SHPAR(2),SHPAR(5), &
                         SHPAR(5),1._WP,1._WP,1._WP,DX,X0,CDESCR,IOSHP,      &
                         MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         PYD=SHPAR(6)/DX(2)
         PZD=1._WP

!-----------------------------------------------------------------------
! CONELLIPS -> two concentric ellipsoids with isotropic dielectric function
!           1 (inner) and 2 (outer)

      ELSEIF(CSHAPE=='CONELLIPS')THEN
         CALL TARCEL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                     SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! CYLINDER1 -> homogeneous, isotropic cylinder

      ELSEIF(CSHAPE=='CYLINDER1')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! CYLNDRCAP -> homogeneous, isotropic cylinder with hemispherical caps

      ELSEIF(CSHAPE=='CYLNDRCAP')THEN
         CALL TARCYLCAP(A1,A2,SHPAR(1),SHPAR(2),DX,X0,CDESCR,IOSHP,MXNAT,NAT, &
                        IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! CYLNDRPBC -> homogeneous, isotropic cylinder, repeated with
!           periodicity SHPAR(4) in y direction,
!                       SHPAR(5) in z direction

      ELSEIF(CSHAPE=='CYLNDRPBC')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)

! set target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

         DO J=1,3
            A1(J)=0._WP
            A2(J)=0._WP
         ENDDO
         A1(1)=1._WP
         A2(2)=1._WP
         PYD=SHPAR(4)
         PZD=SHPAR(5)
         IANISO=0

!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKBLYPBC')THEN

! SLPBX2 -> disk on bilayer slab (isolated target)
!           SHPAR(1) = (disk thickness)/d  [material 1]
!           SHPAR(2) = (disk diameter)/d               
!           SHPAR(3) = (x thickness of slab material 2)/d
!           SHPAR(4) = (x thickness of slab material 3)/d
!           SHPAR(5) = (y length of slab)/d
!           SHPAR(6) = (z length of slab)/d
!           SHPAR(7) = (y-periodicity)/d   [SHPAR(8).GE.SHPAR(5)]
!           SHPAR(8) = (z-periodicity)/d   [SHPAR(8).GE.SPHAR(6)]

! set target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

         CALL TARPBXN(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                     SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         PYD=SHPAR(7)
         PZD=SHPAR(8)

!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKRCTNGL')THEN

! DSKRCTNGL -> disk on homogeneous slab (isolated target)
!           SHPAR(1) = (disk thickness)/d  [material 1]
!           SHPAR(2) = (disk diameter)/d               
!           SHPAR(3) = (x thickness of slab)/d [material 2]
!           SHPAR(4) = (y length of slab)/d
!           SHPAR(5) = (z length of slab)/d

! set target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

         CALL TARPBXN(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),0._WP,SHPAR(4), &
                     SHPAR(5),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKRCTPBC')THEN

! DSKRCTPBC -> pillbox on slab with periodic boundary conditions
!           SHPAR(1) = (disk thickness)/d    [material 1
!           SHPAR(2) = (disk diameter)/d
!           SHPAR(3) = (x thickness of slab)/d
!           SHPAR(4) = (y length of slab)/d
!           SHPAR(5) = (z length of slab)/d
!           SHPAR(6) = (repeat length in y direction)/d
!           SHPAR(7) = (repeat length in z direction)/d

! set target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

         CALL TARPBXN(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),0._WP,SHPAR(4), &
                      SHPAR(5),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         PYD=SHPAR(6)
         PZD=SHPAR(7)

!-----------------------------------------------------------------------
! DW1996TAR -> the 13-cube target studied by Draine & Weingartner 1996
!           SHPAR(1)=width per block in lattice units

      ELSEIF(CSHAPE=='DW1996TAR')THEN
         IPRINAX=1
         NBLOCKS=13
         BLKSIZ=NINT(SHPAR(1))
         XYZB(1,1)=0
         XYZB(2,1)=1
         XYZB(3,1)=0
         XYZB(1,2)=1
         XYZB(2,2)=1
         XYZB(3,2)=0
         XYZB(1,3)=0
         XYZB(2,3)=2
         XYZB(3,3)=0
         XYZB(1,4)=1
         XYZB(2,4)=2
         XYZB(3,4)=0
         XYZB(1,5)=0
         XYZB(2,5)=1
         XYZB(3,5)=1
         XYZB(1,6)=1
         XYZB(2,6)=1
         XYZB(3,6)=1
         XYZB(1,7)=0
         XYZB(2,7)=2
         XYZB(3,7)=1
         XYZB(1,8)=1
         XYZB(2,8)=2
         XYZB(3,8)=1
         XYZB(1,9)=2
         XYZB(2,9)=1
         XYZB(3,9)=0
         XYZB(1,10)=2
         XYZB(2,10)=2
         XYZB(3,10)=0
         XYZB(1,11)=0
         XYZB(2,11)=0
         XYZB(3,11)=1
         XYZB(1,12)=0
         XYZB(2,12)=0
         XYZB(3,12)=2
         XYZB(1,13)=0
         XYZB(2,13)=1
         XYZB(3,13)=2
         CALL TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,X0,IPRINAX,IOSHP, &
                        CDESCR,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         CDESCR='13-cube target used by Draine & Weingartner 1996'

!-----------------------------------------------------------------------
! ELLIPSOID -> homogeneous, isotropic, ellipsoidal target

      ELSEIF(CSHAPE=='ELLIPSOID')THEN
!*** diagnostic
!         write(0,*)'target ckpt 2'
!***
         CALL TARELL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
!*** diagnostic
!         write(0,*)'target ckpt 3'
!***
         IANISO=0

!-----------------------------------------------------------------------
! ELLIPSO_2 -> two touching identical ellipsoids, of materials 1 and 2
!           second ellipsoid is displaced from first in x-direction

      ELSEIF(CSHAPE=='ELLIPSO_2')THEN
         CALL TAR2EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! ELLIPSO_3 -> three touching identical ellipsoids, of materials 1,2,3
!           second ellipsoid is displaced from first in +x-direction
!           third ellipsoid is displaced from second in +x-direction
!           1st,2nd,3rd ellipsoid has ICOMP=1,2,3 (set in TAR3EL)

      ELSEIF(CSHAPE=='ELLIPSO_3')THEN
         CALL TAR3EL(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP,MXNAT, &
                     NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! FROM_FILE -> read list of locations IXYZ(J,1-3) and compositions 
!              ICOMP(J,1-3) for occupied sites J=1-NAT
!              from file CFLSHP
!              REASHP should leave BETADF,PHIDF,THETADF untouched
!              If target is anisotropic, principal axes of dielectric tensor
!              must be aligned with x,y,z axes in target frame.

      ELSEIF(CSHAPE=='FROM_FILE')THEN
         CALL REASHP(CSHAPE,CFLSHP,IDVOUT,IDVSHP,A1,A2,DX,X0,BETADF,PHIDF, &
                     THETADF,CDESCR,MXNAT,NAT,IXYZ,ICOMP,MXN3,NAT3)
         IANISO=1
         DO J=1,NAT
            IF(BETADF(J)/=0.)IANISO=2
            IF(PHIDF(J)/=0.)IANISO=2
            IF(THETADF(J)/=0.)IANISO=2
         ENDDO
!-----------------------------------------------------------------------
! GAUSS_SPH -> gaussian sphere target
! SHPAR(1)= a_eff/d
! SHPAR(2)= 0. to use A1=(1,0,0),A2=(0,1,0) in TF
!           1. to use A1,A2 = principal axes with largest,2nd largest
!              moment of inertia
! SHPAR(3)= BETA : for L>1, contribution of different L values to
!                  <s^2> varies as L^{-BETA}
! SHPAR(4)= LMAX : maximum value of L to use
! SHPAR(5)= <s^2>
! SHPAR(6)= RSEED

      ELSEIF(CSHAPE=='GAUSS_SPH')THEN
!*** diagnostic
!         WRITE(0,*)'about to call targspher with shpar(1)=',SHPAR(1)
!***
         CALL TARGSPHER(SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5)   ,    &
                        SHPAR(6),A1,A2,DX,X0,CFLSHP,CDESCR,IOSHP,MXNAT,NAT, &
                        IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! HEXGONPBC -> homogeneous, isotropic hexagonal prism, repeated with
!           periodicity SHPAR(4) in y direction,
!                       SHPAR(5) in z direction

      ELSEIF(CSHAPE=='HEXGONPBC')THEN
         CALL TARHEX(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)

! set target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

         DO J=1,3
            A1(J)=0._WP
            A2(J)=0._WP
         ENDDO
         A1(1)=1._WP
         A2(2)=1._WP

         IANISO=0
         PYD=SHPAR(4)
         PZD=SHPAR(5)

!-----------------------------------------------------------------------
! HEX_PRISM -> homogeneous, isotropic hexagonal prism

      ELSEIF(CSHAPE=='HEX_PRISM')THEN
         CALL TARHEX(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! LAYRDSLAB -> Layered slab:

! SHPAR(1) = (x-thickness of multilayer slab)/[d*DX(1)]
! SHPAR(2) = (y-extent of slab)/[d*DX(2)]
! SHPAR(3) = (z-extent of slab)/[d*DX(3)]
! SHPAR(4) = fraction f1 of slab occupied by material 1
! SHPAR(5) = fraction f2 of slab occupied by material 2
! SHPAR(6) = fraction f3 of slab occupied by material 3
! SHPAR(7) = fraction f4 of slab occupied by material 4

      ELSEIF(CSHAPE=='LAYRDSLAB')THEN
         CALL TARLYRSLAB(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),  &
                         SHPAR(6),SHPAR(7),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ, &
                         ICOMP)
         IANISO=0

! slab has dimensions a,b,c in x,y,z dimensions
! current version allows for up to 4 layers
! slab is layered in x direction
! top surface is composition 1, with interface at x_TF=0
! lower surface has boundary at x_TF=-SHPAR(1)*d

! for one layer only, set f2=f3=f4=0
! for two layers only, set f3=f4=0
! for three layers only, set f4=0

! SHPAR(1-3)= a/d , b/d , c/d  where d=(dx*dy*dz)**{1/3}
! SHPAR(4)  = x1/a
! SHPAR(5)  = x2/a
! SHPAR(6)  = x3/a
!
!-----------------------------------------------------------------------
! LYRSLBPBC -> Multilayer brick repeated in y and z directions

! SHPAR(1) = (x-thickness of multilayer slab)/[d*DX(1)]
! SHPAR(2) = (y-extent of slab)/[d*DX(2)]
! SHPAR(3) = (z-extent of slab)/[d*DX(3)]
! SHPAR(4) = fraction of slab occupied by material 1 (top layer)
! SHPAR(5) = fraction of slab occupied by material 2
! SHPAR(6) = fraction of slab occupied by material 3
! SHPAR(7) = fraction of slab occupied by material 4
! SHPAR(8) = (repeat length in y direction)/[d*DX(2)]
! SHPAR(9) = (repeat length in z direction)/[d*DX(3)]

      ELSEIF(CSHAPE=='LYRSLBPBC')THEN
         CALL TARLYRSLAB(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5),  &
                         SHPAR(6),SHPAR(7),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ, &
                         ICOMP)

! sets target axis a1 = (1,0,0) in TF
!                  a2 = (0,1,0) in TF
! top surface of brick has x_TF = 0 
! X0(1-3) is at center of top surface.
! lower surface is at x_TF=-SHPAR1*d*DX(1)

         IANISO=0
         PYD=SHPAR(8)
         PZD=SHPAR(9)

!-----------------------------------------------------------------------
! MLTBLOCKS -> target is constructed from identical cubic blocks
!           locations of blocks, and size of blocks (lattice units)
!           is specified in file 'blocks.par'
!           file structure:
!              target description
!              IPRINAX = 0 (a1=100,a2=010) or 1 (a1,a2=principal axes)
!              N = number of blocks
!              SIZE = width of one block, in lattice units
!              X Y Z = location of block 1 (in units of block width)
!              ...
!              X Y Z =    "     "    "   N  "   "    "    "     "

      ELSEIF(CSHAPE=='MLTBLOCKS')THEN
         OPEN(UNIT=IDVSHP,FILE='blocks.par',STATUS='OLD',FORM='FORMATTED')
         READ(IDVSHP,FMT='(A67)')CDESCR
         READ(IDVSHP,*)IPRINAX
         READ(IDVSHP,*)NBLOCKS
         READ(IDVSHP,*)BLKSIZ
         DO J=1,NBLOCKS
            READ(IDVSHP,*)XYZB(1,J),XYZB(2,J),XYZB(3,J)
         ENDDO
         CLOSE(IDVSHP)
         CALL TARBLOCKS(A1,A2,DX,NBLOCKS,BLKSIZ,XYZB,X0,IPRINAX,IOSHP,CDESCR, &
                        MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! RCTGLPRSM -> homogeneous, isotropic, rectangular target

      ELSEIF(CSHAPE=='RCTGLPRSM')THEN
         CALL TARREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                     MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! RCTGL_PBC -> rectangular brick with periodic boundary conditions
!           with A1=(1,0,0), A2=(0,1,0) in target frame
! SHPAR(1) = extent of brick in target frame x direction/d
! SHPAR(2) = extent of brick in target frame y direction)/d
! SHPAR(3) = extent of brick in target frame z direction)/d
! SHPAR(4) = periodicity in target frame y direction/d
!            [SHPAR(4) .GE. SHPAR(2)]
! SHPAR(5) = periodicity in target frame z direction/d
!            [SHPAR(5) .GE. SHPAR(3)]

      ELSEIF(CSHAPE=='RCTGL_PBC')THEN
         CALL TARREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),DX,X0,CDESCR,IOSHP, &
                    MXNAT,NAT,IXYZ,ICOMP)

! note: TARREC sets target axis a1 = (1,0,0) in TF
!                               a2 = (0,1,0) in TF
         IANISO=0
         PYD=SHPAR(4)/DX(2)
         PZD=SHPAR(5)/DX(3)

!-----------------------------------------------------------------------
! RCTGLBLK3 -> stack of 3 rectangular solids (isolated target)
!              x axis passes through centers
!              each slab consists of isotropic material
!           SHPAR(1) = (upper solid thickness in x direction)/d [material 1]
!           SHPAR(2) = (upper solid width in y direction)/d
!           SHPAR(3) = (upper solid width in z direction)/d
!           SHPAR(4) = (middle solid thickness in x direction)/d [material 2]
!           SHPAR(5) = (middle solid width in y direction)/d
!           SHPAR(6) = (middle solid width in z direction)/d
!           SHPAR(7) = (lower solid thickness in x direction)/d [material 3]
!           SHPAR(8) = (lower solid width in y direction)/d
!           SHPAR(9) = (lower solid width in z direction)/d

         ELSEIF(CSHAPE=='RCTGLBLK3')THEN
            CALL TARRCTBLK3(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),       &
                            SHPAR(5),SHPAR(6),SHPAR(7),SHPAR(8),SHPAR(9),DX, &
                            X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
            IANISO=0
         
!-----------------------------------------------------------------------
! RCTG_RCTG -> rectangular solid on top resting on another rectangular solid
!              (isolated target)
!           SHPAR(1) = (upper solid thickness in x direction)/d  [material 1]
!           SHPAR(2) = (upper solid width in y direction)/d
!           SHPAR(3) = (upper solid width in z direction)/d
!           SHPAR(4) = (x thickness of lower solid)/d [material 2]
!           SHPAR(5) = (y length of lower solid)/d
!           SHPAR(6) = (z length of lower solid)/d

!     target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF

      ELSEIF(CSHAPE=='RCTG_RCTG')THEN

         CALL TARRECREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                        SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='RECRECPBC')THEN

! RECRECPBC -> rectangular solid on top resting on another rectangular solid
!              repeated periodically in y and z directions
!           SHPAR(1) = (upper solid thickness in x direction)/d  [material 1]
!           SHPAR(2) = (upper solid width in y direction)/d
!           SHPAR(3) = (upper solid width in z direction)/d
!           SHPAR(4) = (x thickness of lower solid)/d [material 2]
!           SHPAR(5) = (y length of lower solid)/d
!           SHPAR(6) = (z length of lower solid)/d
!           SHPAR(7) = (repeat period in y direction)/d 
!           SHPAR(8) = (repeat period in z direction)/d
!                      NB: must have SHPAR(7).GE.MAX(SHPAR(2),SHPAR(5))
!                                    SHPAR(8).GE.MAX(SHPAR(3),SHPAR(6))
!     target axis a1 = (1,0,0) in TF
!                 a2 = (0,1,0) in TF
!*** diagnostic
!         write(0,*)'in target, about to call tarrecrec...'
!***
         CALL TARRECREC(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                        SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         PYD=SHPAR(7)
         PZD=SHPAR(8)

!-----------------------------------------------------------------------
! SPHERES_N -> Multisphere target (uniform composition):

      ELSEIF(CSHAPE=='SPHERES_N')THEN
! diagnostic
         write(0,*)'target ckpt 4 spheres_n'
!
         CALL TARNSP(A1,A2,SHPAR(1),SHPAR(2),DX,X0,CFLSHP,CDESCR,IDVSHP, &
                     IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! SPHRN_PBC -> cluster of N spheres with periodic boundary conditions
!           with A1=(1,0,0), A2=(0,1,0) in target frame
!           spheres may be of differing, possibly anisotropic,
!           compositions.
! SHPAR(1) = DIAMX = max extent in target frame x direction/d
! SHPAR(2) = PYAEFF = (periodicity in target y direction)/AEFF
! SHPAR(3) = PZAEFF = (periodicity in target z direction)/AEFF

      ELSEIF(CSHAPE=='SPHRN_PBC')THEN
         CALL TARNAS(A1,A2,SHPAR(1),0._WP,DX,X0,BETADF,PHIDF,THETADF,CFLSHP, &
                    CDESCR,IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
! diagnostic
         write(0,*)'target ckpt 5 - sphrn_pbc'
         write(0,*)'                x0(1-3)=',x0
!
         IANISO=0.
         PI=4._WP*ATAN(1._WP)
         PYD=SHPAR(2)*(3._WP*REAL(NAT,KIND=WP)/(4._WP*PI))**(1._WP/3._WP)/DX(2)
         PZD=SHPAR(3)*(3._WP*REAL(NAT,KIND=WP)/(4._WP*PI))**(1._WP/3._WP)/DX(3)

!-----------------------------------------------------------------------
! SPHROID_2 -> two touching spheroids

      ELSEIF(CSHAPE=='SPHROID_2')THEN
         CALL TAR2SP(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                     SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

!-----------------------------------------------------------------------
! SPH_ANI_N -> Multisphere target of general anisotropic composition.
!           Different spheres can have different composition, and
!           constituent material can have arbitrary orientation

      ELSEIF(CSHAPE=='SPH_ANI_N')THEN

         CALL TARNAS(A1,A2,SHPAR(1),SHPAR(2),DX,X0,BETADF,PHIDF,THETADF, &
                     CFLSHP,CDESCR,IDVSHP,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=1
         DO J=1,NAT
            IF(BETADF(J)/=0.)IANISO=2
            IF(PHIDF(J)/=0.)IANISO=2
            IF(THETADF(J)/=0.)IANISO=2
         ENDDO

!-----------------------------------------------------------------------
! TARSLBLIN -> rectangular slab with rectangular "line" on top

      ELSEIF(CSHAPE=='TARSLBLIN')THEN
         CALL TARSLBLIN(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                        SHPAR(6),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)

!-----------------------------------------------------------------------
! TETRAHDRN -> homogeneous, isotropic tetrahedron

      ELSEIF(CSHAPE=='TETRAHDRN')THEN
         CALL TARTET(A1,A2,SHPAR(1),DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! TRILYRPBC -> trilayer rectangular structure, periodic in y and z directions
!              SHPAR(1) = x-thickness of upper layer [material 1]
!              SHPAR(2) = y-width/d of upper layer
!              SHPAR(3) = z-width/d of upper layer
!              SHPAR(4) = x-thickness/d of middle layer [material 2]
!              SHPAR(5) = y-width/d of middle layer
!              SHPAR(6) = z-width/d of middle layer
!              SHPAR(7) = x-width/d of lower layer
!              SHPAR(8) = y-width/d of lower layer
!              SHPAR(9) = z-width/d of lower layer
!              SHPAR(10)= period/d in y direction
!              SHPAR(11)= period/d in z direction

      ELSEIF(CSHAPE=='TRILYRPBC')THEN
         CALL TARRCTBLK3(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),SHPAR(5), &
                         SHPAR(6),SHPAR(7),SHPAR(8),SHPAR(9),DX,X0,CDESCR,   &
                         IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0
         PYD=SHPAR(10)
         PZD=SHPAR(11)

!-----------------------------------------------------------------------
! TRNGLPRSM -> triangular prism:

      ELSEIF(CSHAPE=='TRNGLPRSM')THEN
         CALL TARPRSM(A1,A2,SHPAR(1),SHPAR(2),SHPAR(3),SHPAR(4),DX,X0,CDESCR, &
                      IOSHP,MXNAT,NAT,IXYZ,ICOMP)
         IANISO=0

!-----------------------------------------------------------------------
! UNIAXICYL -> uniaxial cylinder
! Cylinder axis is in x direction in Target Frame.
! Assume c axis to be parallel to cylinder axis
! Assume component 1 to be dielectric const. for E par. c axis
! Assume component 2 to be dielectric const. for E perp. c axis

      ELSEIF(CSHAPE=='UNIAXICYL')THEN
         CALL TARCYL(A1,A2,SHPAR(1),SHPAR(2),1._WP,DX,X0,CDESCR,IOSHP,MXNAT, &
                     NAT,IXYZ,ICOMP)

! Set composition

         DO J=1,NAT
            ICOMP(J,1)=1
            ICOMP(J,2)=2
            ICOMP(J,3)=2
         ENDDO
         IANISO=1

!-----------------------------------------------------------------------

! add any other specific shape routines here:

!-----------------------------------------------------------------------
! Reach here only in event of error:

      ELSE
         CALL ERRMSG('FATAL','TARGET',                           &
                     ' Unknown shape requested: check ddscat.par')
      ENDIF

! Check to see that arrays are large enough

      IF(NAT>MXNAT)CALL ERRMSG('FATAL','TARGET',     &
        ' MXNAT < NAT; must increase MXNAT in DDSCAT')

! Write out target description

      WRITE(IDVOUT,FMT=9010)CDESCR,NAT

! Before returning, compute:

      NAT3=3*NAT
      RETURN
9010  FORMAT(' >TARGET:',A,/,6X,I9,' = NAT0 = number of dipoles in target')
    END SUBROUTINE TARGET

    SUBROUTINE WRITESCA(MXNX,MXNY,MXNZ,NX,NY,NZ,DX,ICOMP,IXYZ0,JPBC,MXNAT,    &
                        MXN3,MYID,NAT,NAT3,WAVEA,MXWAV,NWAV,AEFFA,MXRAD,NRAD, &
                        ITHETA,IBETA,IPHI,THETA,MXTHET,NTHETA,BETA,MXBETA,    &
                        NBETA,PHI,MXPHI,NPHI,NSMELTS,TIMERS,MXTIMERS,NTIMERS, &
                        CBINFILE,IOBIN,CBINFLAG,IDNC,       &
                        ILIN10,ILIN12,IORI,IWRKSC,IORTH,IRAD,IWAV,MXCOMP,     &
                        MXSCA,NAT0,NAVG,ITNUM,MXITER,NCOMP,NORI,NSCAT,CALPHA, &
                        CDESCR,CFLAVG,CFLSCA,CMDFFT,CMDFRM,CMDTRQ,CSHAPE,     &
                        CSTAMP,AEFF,AK1,AKR,BETAD,BETMID,BETMXD,ETASCA,PHID,  &
                        PHIMID,PHIMXD,THETAD,THTMID,THTMXD,TOL,WAVE,XX,A1,A2, &
                        PHIN,QABS,QABSUM,QBKSCA,QBKSUM,QEXSUM,QEXT,QPHA,      &
                        QPHSUM,QSCAG,QSCAG2,QSCAT,QSCGSUM,QSCG2SUM,QSCSUM,    &
                        QTRQAB,QTRQABSUM,QTRQSC,QTRQSCSUM,S1111,S2121,SM,     &
                        SMIND1,SMIND2,SMORI,THETAN,CX1121,CXE01,CXE01R,CXE02, &
                        CXE02R,CXEPS,CXRFR,CXF11,CXF21,CXF12,CXF22,PYDDX,     &
                        PZDDX,XMIN,XMAX,YMIN,YMAX,ZMIN,ZMAX)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
!--------------------- writesca_v3 ------------------------------------------
! Scalar Arguments ..

      INTEGER :: IBETA,IDNC,ILIN10,ILIN12,IOBIN,IORI,IORTH,IPHI,IRAD,ITHETA, &
         IWAV,IWRKSC,JPBC,MXBETA,MXCOMP,MXITER,MXN3,MXNAT,MXNX,MXNY,MXNZ,    &
         MXPHI,MXRAD,MXSCA,MXTHET,MXTIMERS,MXWAV,MYID,NAT,NAT0,NAT3,NAVG,    &
         NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,NSMELTS,NTHETA,NTIMERS,NWAV,NX,NY,NZ
      REAL(WP) :: AEFF,AK1,BETAD,BETMID,BETMXD,ETASCA,PHID,PHIMID,PHIMXD,  &
         PYDDX,PZDDX,THETAD,THTMID,THTMXD,TOL,WAVE,XMAX,XMIN,XX,YMAX,YMIN, &
         ZMAX,ZMIN
      INTEGER :: ITNUM(2)
      CHARACTER :: CALPHA*6,CBINFLAG*6,CMDFFT*6,CMDFRM*6,CMDTRQ*6,     &
         CSHAPE*9,CFLAVG*15,CBINFILE*14,CFLSCA*16,          &
         CSTAMP*26,CDESCR*67

! Array Arguments ..

      COMPLEX(WP) ::    &
         CX1121(MXSCA), &
         CXE01(3),      &
         CXE01R(3),     &
         CXE02(3),      &
         CXE02R(3),     &
         CXEPS(MXCOMP), &
         CXF11(MXSCA),  &
         CXF12(MXSCA),  &
         CXF21(MXSCA),  &
         CXF22(MXSCA),  &
         CXRFR(MXCOMP)
      REAL(WP) ::          &
         A1(3),            &
         A2(3),            &
         AEFFA(MXRAD),     &
         AKR(3),           &
         BETA(MXBETA),     &
         DX(3),            &
         PHI(MXPHI),       &
         PHIN(MXSCA),      &
         QABS(2),          &
         QABSUM(2),        &
         QBKSCA(2),        &
         QBKSUM(2),        &
         QEXSUM(2),        &
         QEXT(2),          &
         QPHA(2),          &
         QPHSUM(2),        &
         QSCAG(3,2),       &
         QSCAG2(2),        &
         QSCAT(2),         &
         QSCG2SUM(2),      &
         QSCGSUM(3,2),     &
         QSCSUM(2),        &
         QTRQAB(3,2),      &
         QTRQABSUM(3,2),   &
         QTRQSC(3,2),      &
         QTRQSCSUM(3,2),   &
         S1111(MXSCA),     &
         S2121(MXSCA),     &
         SM(4,4,MXSCA),    &
         SMORI(4,4,MXSCA), &
         THETA(MXTHET),    &
         THETAN(MXSCA),    &
         TIMERS(MXTIMERS), &
         WAVEA(MXWAV)
      INTEGER*2 :: &
         ICOMP(MXN3)
      INTEGER ::        &
         IXYZ0(NAT0,3), &
         SMIND1(9),     &
         SMIND2(9)

! Local variables:

      CHARACTER :: CFLPOL1*17,CFLPOL2*17,CFRAME*12
      COMPLEX(WP) :: CXVAR1
      REAL(WP) :: DAEFF,DEGRAD,DPHYS,MKD,PHIND,PI,PPOL,RVAR1,RVAR2,RVAR3,THETND
      INTEGER :: I,J,ND
      REAL(WP) ::  &
         A1L(3),   &
         A2L(3),   &
         ABSCO(2), &
         G(2),     &
         G2(2),    &
         QAV(18)

! External Subroutines:

      EXTERNAL NAMER,WRITEBIN

! Intrinsic Functions:

      INTRINSIC CONJG,SQRT

! Save statement:

      SAVE DEGRAD

! Data statements:

      DATA DEGRAD/57.29578_WP/
!***********************************************************************
! Subroutine WRITESCA
! Purpose of WRITESCA is to collect a lot of the output code into
! a single module.
! Given:
!    JPBC   = 0 for isolated finite target
!           = 1 for target periodic in y direction in Target Frame
!           = 2 for target periodic in z direction in Target Frame
!           = 3 for target periodic in y and z directions in TF

! If IORI = 0, then print orientational average
! If IORI > 0, print output for specific orientation

! History:
! 96.11.14 (PJF) added binary write options (see also info in
!                "versions.f" about IDL postprocessing)
!                possible "checkpointing" could be done here "close(iobi
!                open(iobin,file=cbinfile,form='unformatted',access='app
!                (which is non-standard Fortran 77 (but standard in F90)
!                open(iobin,file=cbinfile,form='unformatted',status='old
! 96.11.21 (BTD) added call to WRITENET if called with CNETFLAG='NCCLOS'
!                in order to get call to NCCLOS out of DDSCAT.f
! 98.01.11 (BTD) added DX(3) to argument list to pass information on
!                nonuniform lattice spacing [development of DDSCAT.6.0]
! 98.11.16 (BTD) corrected CX01R -> CXE01R in argument list of WRITEBIN
! 98.12.12 (BTD) Introduce NSMELTS,SMIND1,SMIND2 to argument list to
!                allow selection of Muller matrix elements to be
!                printed out.  Add code to allow from 1 to 9 matrix
!                elements to be printed.
! 98.12.13 (BTD) Modify to print out validity criterion |m|kd
!                for each composition
! 03.01.30 (BTD) disabled output line to print out dx,dy,dz
! 03.02.13 (BTD) added one more digit of precision to output Q values
!                with appropriate modifications to format statements
! 03.04.14 (BTD) added ITNUM(2) and MXITER to argument list
!                added ITNUM(2) = number of iterations
!                and MXITER = max number of iterations allowed
!                to output statements 9150 and 9155
! 03.09.01 (BTD) cosmetic change to output statement: g -> g(1)
! 03.10.23 (BTD) removed ICTHM and IPHIM from argument list
!                removed ICTHM and IPHIM from argument list of
!                WRITENET and WRITEBIN
!                removed ICTHM and IPHIM from WRITE(..,9033)
!                added NAVG to argument list
!                added NAVG to WRITE(..,9033)
!                added NAVG to argument list of WRITENET and WRITEBIN
!                write NAVG to qtable,wxxrxxkxxx.sca, wxxrxxori.avg
! 04.02.22 (BTD) added IWRKSC to argument list of WRITESCA and use to
!                control writing to ascii output files
! 04.05.21 (BTD) reordered QSCGSUM and QSCG2SUM in argument list
! 04.12.29 (BTD) corrected error in writing Mueller matrix for the
!                "sca" files when IWRKSC=1
! 05.10.11 (BTD) changed CFLAVG*13 to CFLAVG*14
!                changed CFLSCA*14 to CFLSCA*15
! 05.10.11 (BTD) added CMDFRM to argument list
!                added variable CFRAME
!                modified 9080 FORMAT to print out string CFRAME
!                specifying whether (theta,phi) are in Lab Frame or
!                Target Frame
! 06.10.07 (BTD) added JPBC to argument list
! 06.10.08 (BTD) modified output statements when JPBC=1,2,or 3
! 06.11.28 (BTD) corrected error in calculation of degree of linear
!                polarization of scattered light (two places below)
! 07.06.22 (BTD) original calculation of PPOL was correct -- return
!                to original formula
! 07.08.13 (BTD) modified output format statements to report scattering
!                angles to 0.01 degree
! 07.09.11 (BTD) changed IXYZ0 from INTEGER*2 to INTEGER
! 08.01.12 (BTD) v2
!                * added PYDDX,PZDDX to argument list
!                * for JPBC=3, compute ABSCO(J) = absorption coefficient
!                * for JPBC=3, write out ABSCO(J) and average over two
!                  incident polarizations
! 08.03.15 (BTD) v7.0.5
!                changed IXYZ0(MXNAT,3) -> IXYZ0(NAT0,3)
! 08.04.13 (BTD) v7.0.5
!                * modified format so the first two S_ij elements are
!                  written out with 5 sig figs instead of 4 
! 08.05.09 (BTD) * added MYID to argument list
! 08.05.12 (BTD) * following suggestion from Art Lazanoff, initialize
!                  DAEFF=0._WP and DPHYS=0._WP [WHY?]
! 08.05.29 (BTD) v7.0.6
!                * changed declarations
!                  SM(MXSCA,4,4) -> SM(4,4,MXSCA)
!                  SMORI(MXSCA,4,4) -> SMORI(4,4,MXSCA)
!                * made corresponding changes to write statements
! 08.07.16 (BTD) * change format of w000r000k000.sca and w000r000.avg
!                  files when JPBC > 0, since in these cases we do not
!                  carry out sums over scattering directions.
! 08.07.17 (BTD) * added A1L,A2L,AK to w000r000k000.sca
! 08.08.29 (BTD) * Remove calls to WRITENET -- no longer supported
!                * Removed CNETFLAG and CNETFILE from argument list.
! end history

! Copyright (C) 1996,1998,2003,2004,2005,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

!*** diagnostic
!      write(0,*)'writesca ckpt 1, myid=',myid
!***
      PI=4._WP*ATAN(1._WP)

! compute DAEFF=d/aeff and DPHYS=d (physical units)

      DAEFF=(4._WP*PI/(3._WP*REAL(NAT0,KIND=WP)))**(1._WP/3._WP)
      DPHYS=WAVE*AK1/(2._WP*PI)

! If IORI > 0, then write out scattering properties for this specific
! target orientation.

      IF(CMDFRM=='LFRAME'.OR.CMDFRM=='lframe')THEN
         CFRAME='Lab Frame'
      ELSEIF(CMDFRM=='TFRAME'.OR.CMDFRM=='tframe')THEN
         CFRAME='Target Frame'
      ELSE
         CFRAME='????????'
      ENDIF

      IF(IORI>0)THEN

!*** Compute G=<cos(theta)> and G2=<cos^2(theta)>

         DO J=1,IORTH
            IF(JPBC==0)THEN
               G(J)=QSCAG(1,J)/QSCAT(J)
               G2(J)=QSCAG2(J)/QSCAT(J)
            ELSE

! QSCAT and QSCAG are not available when JPBC > 0

               G(J)=0._WP
               G2(J)=0._WP
            ENDIF
         ENDDO

!*** diagnostic
!         write(0,*)'writesca ckpt 2, myid=',myid
!***
         IF(IWRKSC==1)THEN

            CALL NAMER(IWAV,IRAD,IORI,CFLPOL1,CFLPOL2,CFLSCA,CFLAVG)
!*** diagnostic
!            write(0,*)'writesca ckpt 2.1, myid=',myid,' cflsca=',cflsca
!            write(0,*)'                   itheta=',itheta
!            write(0,*)'                   iphi=',iphi
!***
            OPEN(UNIT=8,FILE=CFLSCA,STATUS='UNKNOWN')

            WRITE(8,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,DAEFF, &
                             DPHYS
            WRITE(8,FMT=9030)(XMIN*DPHYS),(XMAX*DPHYS),(YMIN*DPHYS), &
                             (YMAX*DPHYS),(ZMIN*DPHYS),(ZMAX*DPHYS)

! following code to be enabled for noncubic treatment:
!     &         ,DX

            WRITE(8,FMT=9032)AEFF,WAVE,XX
            DO J=1,NCOMP
               MKD=DAEFF*SQRT(REAL(CXRFR(J)*CONJG(CXRFR(J))))*XX
               WRITE(8,FMT=9031)CXRFR(J),CXEPS(J),MKD,J
            ENDDO
            WRITE(8,FMT=9033)TOL,A1,A2
            IF(JPBC==0)WRITE(8,FMT=9034)NAVG
            WRITE(8,FMT=9035)AKR,CXE01R,CXE02R

! calculate A1L = target axis A1 in Lab Frame
!           A2L = target axis A2 in Lab Frame

            A1L(1)=COS(THETA(ITHETA))
            A1L(2)=SIN(THETA(ITHETA))*COS(PHI(IPHI))
            A1L(3)=SIN(THETA(ITHETA))*SIN(PHI(IPHI))
            A2L(1)=-SIN(THETA(ITHETA))*COS(BETA(IBETA))
            A2L(2)=COS(THETA(ITHETA))*COS(BETA(IBETA))*COS(PHI(IPHI))- &
                   SIN(BETA(IBETA))*SIN(PHI(IPHI))
            A2L(3)=COS(THETA(ITHETA))*COS(BETA(IBETA))*SIN(PHI(IPHI))+ &
                   SIN(BETA(IBETA))*COS(PHI(IPHI))
            WRITE(8,FMT=9036)A1L,A2L
            RVAR1=AK1
            RVAR2=0._WP
            RVAR3=0._WP
            WRITE(8,FMT=9037)RVAR1,RVAR2,RVAR3,CXE01,CXE02
            WRITE(8,FMT=9040)BETAD,THETAD,PHID
            IF(JPBC==0)THEN
               WRITE(8,FMT=9041)ETASCA
               WRITE(8,FMT=9050)QEXT(1),QABS(1),QSCAT(1),G(1),G2(1), &
                                QBKSCA(1),QPHA(1)
            ELSEIF(JPBC==1.OR.JPBC==2)THEN
               WRITE(8,9350)
            ELSEIF(JPBC==3)THEN

! abs.coeff = 1-R-T
!           = [Qabs*pi/cos(theta_i)]*(d/L_y)*(d/L_z)*(3*N/4*pi)^{2/3}

               ABSCO(1)=PI*(AK1/ABS(AKR(1)))*QABS(1)*                      &
                        (0.75_WP*REAL(NAT0)/PI)**(2._WP/3._WP)/(PYDDX*PZDDX)
               WRITE(8,9550)ABSCO(1),ITNUM(1),MXITER
            ENDIF
         ENDIF

         IF(IORTH==1)THEN

! Assign "missing value" value if there is only one polarization

            DO I=1,18
               QAV(I)=-999._WP
            ENDDO
            QEXT(2)=-999._WP
            QABS(2)=-999._WP
            QSCAT(2)=-999._WP
            QBKSCA(2)=-999._WP
            QPHA(2)=-999._WP
            G(2)=-999._WP
            G2(2)=-999._WP
            DO J=1,3
               QSCAG(J,2)=-999._WP
            ENDDO
            QSCAG2(2)=-999._WP
         ENDIF

         IF(IORTH==2)THEN
            IF(JPBC==0)THEN
               QAV(1)=.5_WP*(QEXT(1)+QEXT(2))
               QAV(2)=.5_WP*(QABS(1)+QABS(2))
               QAV(3)=.5_WP*(QSCAT(1)+QSCAT(2))
               QAV(4)=.5_WP*(QSCAG(1,1)+QSCAG(1,2))/QAV(3)
               QAV(5)=.5_WP*(QSCAG2(1)+QSCAG2(2))/QAV(3)
               QAV(6)=.5_WP*(QBKSCA(1)+QBKSCA(2))
               QAV(7)=.5_WP*(QPHA(1)+QPHA(2))
               QAV(8)=QEXT(1)-QEXT(2)
               QAV(9)=QPHA(1)-QPHA(2)
               DO J=1,3
                  QAV(9+J)=.5_WP*(QSCAG(J,1)+QSCAG(J,2))
               ENDDO
               IF(CMDTRQ=='DOTORQ')THEN
                  DO J=1,3
                     QAV(12+J)=.5_WP*(QTRQAB(J,1)+QTRQAB(J,2))
                     QAV(15+J)=.5_WP*(QTRQSC(J,1)+QTRQSC(J,2))
                  ENDDO
               ENDIF
            ELSE
               QAV(1)=.5_WP*(QEXT(1)+QEXT(2))
               QAV(2)=.5_WP*(QABS(1)+QABS(2))
               DO J=3,6
                  QAV(J)=0._WP
               ENDDO
               QAV(7)=.5_WP*(QPHA(1)+QPHA(2))
               QAV(8)=QEXT(1)-QEXT(2)
               QAV(9)=QPHA(1)-QPHA(2)
               DO J=10,18
                  QAV(J)=0._WP
               ENDDO
            ENDIF
            IF(IWRKSC==1)THEN
               IF(JPBC==0)THEN
                  WRITE(8,FMT=9055)QEXT(2),QABS(2),QSCAT(2),G(2),G2(2), &
                                   QBKSCA(2),QPHA(2),(QAV(J),J=1,9)
               ELSEIF(JPBC==1.OR.JPBC==2)THEN
                  WRITE(8,FMT=9355)
               ELSEIF(JPBC==3)THEN
                  ABSCO(2)=PI*(AK1/ABS(AKR(1)))*QABS(2)*                      &
                           (0.75_WP*REAL(NAT0)/PI)**(2._WP/3._WP)/(PYDDX*PZDDX)
                  QAV(2)=0.5_WP*(ABSCO(1)+ABSCO(2))
                  WRITE(8,9551)ABSCO(2),ITNUM(2),MXITER,QAV(2)
               ENDIF
            ENDIF
         ENDIF

         IF(IWRKSC==1)THEN
            IF(JPBC==0)THEN
               WRITE(8,FMT=9150)(QSCAG(J,1),J=1,3),ITNUM(1),MXITER,NAVG
               IF(IORTH==2)THEN
                  WRITE(8,FMT=9155)(QSCAG(J,2),J=1,3),ITNUM(2),MXITER,NAVG, &
                                   (QAV(J),J=10,12)
               ENDIF
            ENDIF
         ENDIF

         IF(CMDTRQ=='DOTORQ')THEN
            IF(IWRKSC==1)THEN
               WRITE(8,FMT=9250)(QTRQAB(J,1),J=1,3),(QTRQSC(J,1),J=1,3)
               IF(IORTH==2)WRITE(8,FMT=9255)(QTRQAB(J,2),J=1,3), &
                           (QTRQSC(J,2),J=1,3),(QAV(J),J=13,18)
            ENDIF
         ELSE

! add missing value code (set to -999.)

            DO I=1,3
               DO J=1,2
                  QTRQAB(I,J)=-999._WP
                  QTRQSC(I,J)=-999._WP
               ENDDO
            ENDDO

         ENDIF

         IF(IORTH==1)THEN

            IF(IWRKSC==1)WRITE(8,FMT=9060)

            DO ND=1,NSCAT

! convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)
               RVAR1=REAL(CONJG(CXF11(ND))*CXF11(ND))
               RVAR2=REAL(CONJG(CXF21(ND))*CXF21(ND))
               CXVAR1=CONJG(CXF11(ND))*CXF21(ND)
               IF(IWRKSC==1)WRITE(8,FMT=9070)ND,THETND,PHIND,RVAR1,RVAR2, &
                                             CXVAR1
            ENDDO

         ELSEIF(IORTH==2)THEN

            IF(IWRKSC==1)THEN

! write file header information

               WRITE(8,FMT=9080)CFRAME
               IF(JPBC==0.OR.JPBC==3)THEN
                  IF(NSMELTS==1)THEN
                     WRITE(8,FMT=9081)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==2)THEN
                     WRITE(8,FMT=9082)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==3)THEN
                     WRITE(8,FMT=9083)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==4)THEN
                     WRITE(8,FMT=9084)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==5)THEN
                     WRITE(8,FMT=9085)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==6)THEN
                     WRITE(8,FMT=9086)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==7)THEN
                     WRITE(8,FMT=9087)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==8)THEN
                     WRITE(8,FMT=9088)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==9)THEN
                     WRITE(8,FMT=9089)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ENDIF
               ELSEIF(JPBC==1.OR.JPBC==2)THEN
                  IF(NSMELTS==1)THEN
                     WRITE(8,FMT=9181)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==2)THEN
                     WRITE(8,FMT=9182)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==3)THEN
                     WRITE(8,FMT=9183)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==4)THEN
                     WRITE(8,FMT=9184)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==5)THEN
                     WRITE(8,FMT=9185)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==6)THEN
                     WRITE(8,FMT=9186)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==7)THEN
                     WRITE(8,FMT=9187)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==8)THEN
                     WRITE(8,FMT=9188)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ELSEIF(NSMELTS==9)THEN
                     WRITE(8,FMT=9189)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
                  ENDIF
               ENDIF

               DO ND=1,NSCAT
  
! convert scattering angles to degrees

                  PHIND=DEGRAD*PHIN(ND)
                  THETND=DEGRAD*THETAN(ND)

!*** diagnostic
!                  write(0,*)'writesca ckpt 3, nd=',nd
!                  write(0,*)'            phin(nd),thetan(nd)=',
!     &                      phin(nd),thetan(nd)
!***

! Compute PPOL = degree of linear polarization of scattered light
! for incident unpolarized light
!*** diagnostic
!                  write(0,*)'writesca ckpt 4, sm(nd,1,1)=',sm(nd,1,1)
!***
                  PPOL=SQRT(SM(2,1,ND)**2+SM(3,1,ND)**2)/SM(1,1,ND)

                  WRITE(8,FMT=9090)THETND,PHIND,PPOL,                     &
                                   (SM(SMIND1(J),SMIND2(J),ND),J=1,NSMELTS)
!***
               ENDDO
            ENDIF
         ENDIF

         IF(IWRKSC==1)CLOSE(8)

      ELSE

! This module writes out results from orientational averaging.
! (arrive here when called with IORI=0)

         OPEN(UNIT=8,FILE=CFLAVG,STATUS='UNKNOWN')
         WRITE(8,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,DAEFF, &
                          DPHYS

! following code to be enabled for noncubic treatment:
!         WRITE(8,FMT=9020)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0,DX

         WRITE(8,FMT=9032)AEFF,WAVE,XX
         DO J=1,NCOMP
            MKD =(4._WP*PI/(3._WP*NAT0))**(1._WP/3._WP)* &
                 SQRT(REAL(CXRFR(J)*CONJG(CXRFR(J))))*XX
            WRITE(8,FMT=9031)CXRFR(J),CXEPS(J),MKD,J
         ENDDO
         WRITE(8,FMT=9033)TOL,A1,A2
         IF(JPBC==0)WRITE(8,FMT=9034)NAVG
         RVAR1=AK1
         RVAR2=0._WP
         RVAR3=0._WP
         WRITE(8,FMT=9037)RVAR1,RVAR2,RVAR3,CXE01,CXE02
         WRITE(8,FMT=9042)BETMID,BETMXD,NBETA,THTMID,THTMXD,NTHETA, &
                          PHIMID,PHIMXD,NPHI
         IF(JPBC==0)WRITE(8,FMT=9041)ETASCA
         WRITE(8,FMT=9043)NORI,IORTH
         IF(JPBC==0)THEN
            RVAR1=QSCGSUM(1,1)/QSCSUM(1)
            RVAR2=QSCG2SUM(1)/QSCSUM(1)
            WRITE(8,FMT=9050)QEXSUM(1),QABSUM(1),QSCSUM(1),RVAR1,RVAR2, &
                             QBKSUM(1),QPHSUM(1)
         ELSE
            QSCSUM(1)=QEXSUM(1)-QABSUM(1)
            WRITE(8,FMT=9051)QEXSUM(1),QABSUM(1),QSCSUM(1)
         ENDIF
         IF(IORTH==1)THEN
            IF(JPBC==0)THEN
               WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3),ITNUM(1),MXITER,NAVG
               IF(CMDTRQ=='DOTORQ')WRITE(8,FMT=9250)(QTRQABSUM(J,1),J=1,3), &
                                   (QTRQSCSUM(J,1),J=1,3)
            ELSE
               WRITE(8,FMT=9151)
            ENDIF
            WRITE(8,FMT=9060)
            DO ND=1,NSCAT

! Convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)
               WRITE(8,FMT=9070)ND,THETND,PHIND,S1111(ND),S2121(ND), &
                                CX1121(ND)
            ENDDO

! Write orientationally-averaged Q values (except Qpha) to 'qtable':

!*** diagnostic
!            write(0,*)'writesca ckpt 5, about to open qtable...'
!***
            OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
            DO ND=1,ILIN10
               READ(10,FMT=*)
            ENDDO
            IF(JPBC==0)THEN
               RVAR1=QSCGSUM(1,1)/QSCSUM(1)
               RVAR2=QSCG2SUM(1)/QSCSUM(1)
            ENDIF
!*** diagnostic
!            write(0,*)'writesca ckpt 6, about to write to qtable...'
!***
            IF(JPBC==0)THEN
               WRITE(10,FMT=9056)AEFF,WAVE,QEXSUM(1),QABSUM(1),QSCSUM(1), &
                                 RVAR1,RVAR2,QBKSUM(1),NAVG
            ELSE
               WRITE(10,FMT=9057)AEFF,WAVE,QEXSUM(1),QABSUM(1),QSCSUM(1)
            ENDIF
            ILIN10=ILIN10+1
            CLOSE(10)
            OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
            DO ND=1,ILIN12
               READ(12,FMT=*)
            ENDDO
            WRITE(12,FMT=9057)AEFF,WAVE,QPHSUM(1)
            ILIN12=ILIN12+1
            CLOSE(12)

         ELSEIF(IORTH==2)THEN
            IF(JPBC==0)THEN
               RVAR1=QSCGSUM(1,2)/QSCSUM(2)
               QAV(1)=.5_WP*(QEXSUM(1)+QEXSUM(2))
               QAV(2)=.5_WP*(QABSUM(1)+QABSUM(2))
               QAV(3)=.5_WP*(QSCSUM(1)+QSCSUM(2))
               QAV(4)=.5_WP*(QSCGSUM(1,1)+QSCGSUM(1,2))/QAV(3)
               QAV(5)=.5_WP*(QSCG2SUM(1)+QSCG2SUM(2))/QAV(3)
               QAV(6)=.5_WP*(QBKSUM(1)+QBKSUM(2))
               QAV(7)=.5_WP*(QPHSUM(1)+QPHSUM(2))
               QAV(8)=QEXSUM(1)-QEXSUM(2)
               QAV(9)=QPHSUM(1)-QPHSUM(2)
               DO J=1,3
                  QAV(9+J)=.5_WP*(QSCGSUM(J,1)+QSCGSUM(J,2))
               ENDDO
               IF(CMDTRQ=='DOTORQ')THEN
                  DO J=1,3
                     QAV(12+J)=.5_WP*(QTRQABSUM(J,1)+QTRQABSUM(J,2))
                     QAV(15+J)=.5_WP*(QTRQSCSUM(J,1)+QTRQSCSUM(J,2))
                  ENDDO
               ENDIF
               RVAR2=.5_WP*(QSCG2SUM(1)+QSCG2SUM(2))/QAV(3)
            ELSE
               QSCSUM(2)=QEXSUM(2)-QABSUM(2)
               RVAR1=0._WP
               RVAR2=0._WP
               QAV(1)=.5_WP*(QEXSUM(1)+QEXSUM(2))
               QAV(2)=.5_WP*(QABSUM(1)+QABSUM(2))
               QAV(3)=.5_WP*(QSCSUM(1)+QSCSUM(2))
               DO J=4,6
                  QAV(J)=0._WP
               ENDDO
               QAV(7)=.5_WP*(QPHSUM(1)+QPHSUM(2))
               QAV(8)=QEXSUM(1)-QEXSUM(2)
               QAV(9)=QPHSUM(1)-QPHSUM(2)
               DO J=10,12
                  QAV(J)=0._WP
               ENDDO
            ENDIF
            IF(JPBC==0)THEN
               WRITE(8,FMT=9055)QEXSUM(2),QABSUM(2),QSCSUM(2),RVAR1,RVAR2, &
                                QBKSUM(2),QPHSUM(2),(QAV(J),J=1,9)
               WRITE(8,FMT=9150)(QSCGSUM(J,1),J=1,3),ITNUM(1),MXITER,NAVG
               WRITE(8,FMT=9155)(QSCGSUM(J,2),J=1,3),ITNUM(2),MXITER,NAVG, &
                                (QAV(J),J=10,12)
               IF(CMDTRQ=='DOTORQ')THEN
                  WRITE(8,FMT=9250)(QTRQABSUM(J,1),J=1,3), &
                                   (QTRQSCSUM(J,1),J=1,3)
                  WRITE(8,FMT=9255)(QTRQABSUM(J,2),J=1,3),               &
                                   (QTRQSCSUM(J,2),J=1,3),(QAV(J),J=13,18)
               ENDIF
            ELSE
               WRITE(8,FMT=9054)QEXSUM(2),QABSUM(2),QSCSUM(2), &
                                (QAV(J),J=1,3),QAV(8)
            ENDIF

! Write orientationally-averaged Q values (except Qpha) to 'qtable':

            OPEN(UNIT=10,FILE='qtable',STATUS='OLD')
            DO ND=1,ILIN10
               READ(10,FMT=*)
            ENDDO
            WRITE(10,FMT=9056)AEFF,WAVE,QAV(1),QAV(2),QAV(3),QAV(4), &
                              QAV(5),QAV(6),NAVG
            ILIN10=ILIN10+1
            CLOSE(10)
            OPEN(UNIT=12,FILE='qtable2',STATUS='OLD')
            DO ND=1,ILIN12
               READ(12,FMT=*)
            ENDDO
            WRITE(12,FMT=9057)AEFF,WAVE,QAV(7),QAV(8),QAV(9)
            ILIN12=ILIN12+1
            CLOSE(12)

            WRITE(8,FMT=9080)CFRAME
            IF(NSMELTS==1)THEN
               WRITE(8,FMT=9081)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==2)THEN
               WRITE(8,FMT=9082)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==3)THEN
               WRITE(8,FMT=9083)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==4)THEN
               WRITE(8,FMT=9084)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==5)THEN
               WRITE(8,FMT=9085)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==6)THEN
               WRITE(8,FMT=9086)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==7)THEN
               WRITE(8,FMT=9087)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==8)THEN
               WRITE(8,FMT=9088)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ELSEIF(NSMELTS==9)THEN
               WRITE(8,FMT=9089)(SMIND1(J),SMIND2(J),J=1,NSMELTS)
            ENDIF

            DO ND=1,NSCAT

! Convert scattering angles to degrees

               PHIND=DEGRAD*PHIN(ND)
               THETND=DEGRAD*THETAN(ND)

! Compute PPOL = degree of linear polarization of scattered light
! for incident unpolarized light (Bohren & Huffman p. 382)

               PPOL=SQRT(SMORI(2,1,ND)**2+SMORI(3,1,ND)**2)/SMORI(1,1,ND)

               WRITE(8,FMT=9090)THETND,PHIND,PPOL,                        &
                                (SMORI(SMIND1(J),SMIND2(J),ND),J=1,NSMELTS)
            ENDDO

         ENDIF

         CLOSE(8)
      ENDIF

! write FORTRAN unformatted file

      IF(CBINFLAG/='NOTBIN')THEN

         CALL WRITEBIN(CBINFLAG,CBINFILE,IOBIN,CSTAMP,CDESCR,CMDFFT,CALPHA,   &
                       CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,MXBETA,MXPHI,MXN3,    &
                       MXNAT,MXSCA,MXTIMERS,IORTH,NX,NY,NZ,NAT0,NAT,NAT3,     &
                       NAVG,NSCAT,NCOMP,NORI,NWAV,NRAD,NTHETA,NPHI,NBETA,     &
                       NTIMERS,MXNX,MXNY,MXNZ,MXCOMP,BETMID,BETMXD,THTMID,    &
                       THTMXD,PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,THETA,BETA,    &
                       PHI,A1,A2,ICOMP,IXYZ0,IWAV,IRAD,IORI,AEFF,WAVE,XX,AK1, &
                       BETAD,THETAD,PHID,AKR,CXE01R,CXE02R,CXRFR,CXEPS,QEXT,  &
                       QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,QTRQSC,SM,PHIN,    &
                       THETAN,TIMERS)

      ENDIF

      RETURN

9020  FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,             &
         ' --- method of solution ',/,' ',A,                         &
         ' --- prescription for polarizabilies',/,                   &
         ' ',A,' --- shape ',/,I8,5X,'= NAT0 = number of dipoles',/, &
         F12.8,' = d/aeff for this target [d=dipole spacing]',/,     &
         F12.6,' = d (physical units)')
9030  FORMAT(                                                               &
         '----- physical extent of target volume in Target Frame ------',/, &
         2F14.6,' = xmin,xmax (physical units)',/,                          &
         2F14.6,' = ymin,ymax (physical units)',/,                          &
         2F14.6,' = zmin,zmax (physical units)')
! following code to be enabled for noncubic treatment
! 9030 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,
!     &       ' --- method of solution ',/,' ',A,
!     &       ' --- prescription for polarizabilies',/,' ',A,
!     &       ' --- shape ',/,I7,' = NAT0 = number of dipoles',
!     &       3F8.5,' = normalized lattice spacings dx,dy,dz')
9031  FORMAT(                                                  &
         'n= (',F7.4,' , ',F7.4,'),  eps.= (',F8.4,' , ',F7.4, &
         ')  |m|kd=',0P,F8.4,' for subs.',I2)
9032  FORMAT(                                                          &
         '  AEFF=',F14.6,' =',' effective radius (physical units)',/,  &
         '  WAVE=',F14.6,' = wavelength (physical units)',/,'K*AEFF=', &
         F14.6,' = 2*pi*aeff/lambda')
9033  FORMAT(                                                       &
         '   TOL=',1P,E10.3,' = error tolerance for CCG method',/,  &
         0P,'(',F8.5,2F9.5,') = target axis A1 in Target Frame',/,  &
         '(',F8.5,2F9.5,') = target axis A2 in Target Frame')
9034  FORMAT('  NAVG=',I6,' = (theta,phi) values used in comp. of Qsca,g')
9035  FORMAT(                                                 &
         '(',F8.5,2F9.5,') = k vector (latt. units) in TF',/, &
         3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in TF',/,  &
         3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in TF')
9036  FORMAT(                                                &
         '(',F8.5,2F9.5,') = target axis A1 in Lab Frame',/, &
         '(',F8.5,2F9.5,') = target axis A2 in Lab Frame')
9037  FORMAT(                                                        &
         '(',F8.5,2F9.5,') = k vector (latt. units) in Lab Frame',/, &
         3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in LF',/,         &
         3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in LF')
9040  FORMAT(                                                &
         ' BETA =',F7.3,' = rotation of target around A1',/, &
         ' THETA=',F7.3,' = angle between A1 and k',/,       &
         '  PHI =',F7.3,' = rotation of A1 around k')
9041  FORMAT(                                                            &
         F7.4,' = ETASCA = param. controlling # of scatt. dirs used to', &
         ' calculate <cos> etc.')
9042  FORMAT(                                                 &
         2F8.3,' = beta_min, beta_max ;  NBETA =',I2,/,2F8.3, &
         ' = theta_min, theta_max; NTHETA=',I2,/,2F8.3,       &
         ' = phi_min, phi_max   ;   NPHI =',I2,/,F7.4)
9043  FORMAT(                                                    &
         ' Results averaged over ',I4,' target orientations',/,  &
         '                   and ',I4,' incident polarizations')
9050  FORMAT(                                                         &
         10X,'Qext',7X,'Qabs',7X,'Qsca',6X,'g(1)=<cos>',2X,'<cos^2>', &
         5X,'Qbk',7X,'Qpha',/,1X,'JO=1: ',1P,3E11.4,E12.4,2E11.4,E12.4)
9051  FORMAT(10X,'Qext',7X,'Qabs',7X,'Qsca',/,1X,'JO=1: ',1P,3E11.4)
9054  FORMAT(1X,'JO=2: ',1P,3E11.4,/,1X,'mean: ',3E11.4,/,1X,'Qpol= ',E11.4)
9055  FORMAT(                                                            &
         1X,'JO=2: ',1P,3E11.4,E12.4,2E11.4,E12.4,/,1X,'mean: ',         &
         3E11.4,E12.4,2E11.4,E12.4,/,1X,'Qpol= ',E11.4,50X,'dQpha=',E12.4)
9056  FORMAT(1P,E10.4,4E11.4,E12.4,E11.4,E11.4,I6)
9057  FORMAT(1P,E10.4,E11.4,3E12.4)
9060  FORMAT(                                                            &
         '**** Selected scattering directions ',                         &
         ' [note: incident pol state 1 is FIXED!]',/,                    &
         ' ND THETA   PHI <|f11|^2> <|f21|^2> Re<f11*f21>',' Im<f11*f21>')
9061  FORMAT(                                                            &
         '**** Selected scattering directions ',                         &
         ' [note: incident pol state 1 is FIXED!]',/,                    &
         ' ND orderM zeta <|f11|^2> <|f21|^2> Re<f11*f21>',' Im<f11*f21>')
9063  FORMAT(                                                              &
         '**** Selected scattering directions ',                           &
         ' [note: incident pol state 1 is FIXED!]',/,                      &
         ' ND orderM orderN <|f11|^2> <|f21|^2> Re<f11*f21>',' Im<f11*f21>')
9070  FORMAT(I3,2F6.1,1P,2E10.3,2E11.3)
9080  FORMAT(                                                    &
         12X,'Mueller matrix elements for selected scattering ', &
         'directions in ',A12)
9081  FORMAT(' theta    phi    Pol.    S_',I1,I1)
9082  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1)
9083  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1)
9084  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1)
9085  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1)
9086  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9087  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9088  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9089  FORMAT(' theta    phi    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,   &
        I1,7X,'S_',I1,I1)
!-----------------------------------------------------------------------
9181  FORMAT(' alpha   zeta    Pol.    S_',I1,I1)
9182  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1)
9183  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1)
9184  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1)
9185  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9186  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9187  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9188  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1)
9189  FORMAT(' alpha   zeta    Pol.    S_',I1,I1,8X,'S_',I1,I1,8X,'S_',I1,I1, &
        7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,I1,7X,'S_',I1,   &
        I1,7X,'S_',I1,I1)
!-----------------------------------------------------------------------
9090  FORMAT(F6.2,F7.2,F9.5,1P,2E12.4,7E11.3)
9150  FORMAT(9X,'Qsca*g(1)   Qsca*g(2)   Qsca*g(3)   iter  mxiter',2X, &
        'Nsca',/,1X,'JO=1:',1P,3E12.4,3I7)
9151  FORMAT(43X,' iter  mxiter')
9155  FORMAT(1X,'JO=2:',1P,3E12.4,3I7,/,1X,'mean:',1P,3E12.4)
9250  FORMAT(8X,'Qtrqab(1)  Qtrqab(2)  Qtrqab(3)  ', &
        'Qtrqsc(1)  Qtrqsc(2)  Qtrqsc(3)',/,1X,'JO=1:',1P,6E11.3)
9255  FORMAT(1X,'JO=2:',1P,6E11.3,/,1X,'mean:',1P,6E11.3)
9350  FORMAT('*** need to figure out what we want to print for JPBC=1,2 ***')
9355  FORMAT('*** need to figure out what we want to print for JPBC=1,2 ***')
9550  FORMAT(' absorption coeff.  iter  mxiter',/,1X,'JO=1: ',1PE11.4,2I6)
9551  FORMAT(1X,'JO=2: ',1PE11.4,2I6,/,1X,'mean: ',1PE11.4)
    END SUBROUTINE WRITESCA

    SUBROUTINE TARHEX(A1,A2,A,B,ORI,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Scalar arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP,MXNAT,NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: A,B,ORI

! Array arguments:

      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local scalars:

      CHARACTER :: CMSGNM*70
      INTEGER :: IORI,JA,JX,JY,JZ,NA,NB,NC,NFAC,NLAY,NMX,NMY,NMZ
      LOGICAL :: IN
      REAL(WP) :: ACM,ASPR,BCM,BEFF,CCM,X,Y,Z

!***********************************************************************
! Routine to construct hexagonal prism from "atoms"
! Input:
!        A = prism length/d
!        B = (vertex-vertex diameter of hexagon face)/d
!          = 2*(one hexagon side)/d
!        ORI = 1. for a1 in x direction, a2 in y direction
!            = 2. for a1 in x direction, a2 in z direction
!            = 3. for a1 in y direction, a2 in x direction
!            = 4. for a1 in y direction, a2 in z direction
!            = 5. for a1 in z direction, a2 in x direction
!            = 6. for a1 in z direction, a2 in y direction
!              (a1 is parallel to prism axis [normal to hexagonal face]
!               a2 is normal to rectangular face
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 (prism axis)
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 (normal to
!                one of the rectangular faces.
!        X0(1-3)=location/d in TF of dipole with IXYZ=0 0 0
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        CDESCR=string describing target (up to 67 chars.)

! B.T.Draine, Princeton Univ. Obs., 87.04.03

! History:
! 90.12.02 (BTD): IOSHP is now output device for target.out
!                 (and is now closed before returning)
! 90.12.14 (BTD): Rewritten so that atoms are always on integral sites
!                 but CM coords may be either integral or half-integral
! 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 92.09.09 (BTD+PJF): in output, NLAY was too large by factor 2 and NFAC
!                 too small by factor of 2: now fixed.
! 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
! 95.07.13 (BTD): Simplify: restrict to case where prism axis is in
!                 x direction and y axis is normal to a rectangular
!                 face.
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 96.02.23 (BTD): Delete PI (unused)
! 97.04.28 (BTD): Initialize NAT=0 (failure to do so reported by
!                 Michael Wolff).
! 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
!                 lattice spacing.
!                 *** Note: additional code modifications required
!                     to support noncubic lattice!
! 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
!                 call ERRMSG and halt with fatal error.
! 98.03.07 (BTD): Modify to write DX to file "target.out" for
!                 compatibility with REASHP
! 00.11.02 (BTD): Added ICOMP to argument list
!                 set ICOMP=1 for occupied sites
!                 write ICOMP to target.out
! 06.09.15 (BTD): Generalized to support 6 different orientations in TF.
!                 Now uses ORI=SHPAR(3) to select orientation.
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.08.08 (BTD): Added X0(3) to argument list
!                 Added code to set X0(1-3)
! 08.08.29 (BTD): Modified format 9020
! end history

! Copyright (C) 1993,1995,1996,1997,1998,2000,2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      IORI=NINT(ORI)

! Current version of TARHEX is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TARHEX',                          &
                     ' tarhex does not support noncubic lattice')
      ENDIF
      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      ENDDO

! A = prism length
! B = prism "diameter"
!       B/2 = length of one side of hexagon
!       B= distance between opposite vertices=max.diameter of hexagon
!       for hexagon, area=(3/8)*SQRT(3)*B**2
!       for hex prism, volume=A*area=(3/8)*SQRT(3)*A*B**2
! Now determine limits for testing x,y,z values
! Along axis, run from 1 to NA=INT(A+0.5)
! Perp. to axis, run from 1 to NB=INT(B+0.5)
      NA=INT(A+0.5_WP)
      NB=INT(B+0.5_WP)
      NC=INT(.5_WP*SQRT(3._WP)*B+0.5_WP)
! ACM="center" of figure in axial direction
! BCM="center" of figure in B direction
! CCM="center" of figure in C direction
      ACM=REAL(NA,KIND=WP)/2._WP+0.5_WP
      BCM=REAL(NB,KIND=WP)/2._WP+0.5_WP
      CCM=REAL(NC,KIND=WP)/2._WP+0.5_WP
      IF(IORI==1)THEN
         NMX=NA
         NMY=NC
         NMZ=NB
         A1(1)=1._WP
         A2(2)=1._WP
      ELSEIF(IORI==2)THEN
         NMX=NA
         NMZ=NC
         NMY=NB
         A1(1)=1._WP
         A2(3)=1._WP
      ELSEIF(IORI==3)THEN
         NMY=NA
         NMX=NC
         NMZ=NB
         A1(2)=1._WP
         A2(1)=1._WP
      ELSEIF(IORI==4)THEN
         NMY=NA
         NMZ=NC
         NMX=NB
         A1(2)=1._WP
         A2(3)=1._WP
      ELSEIF(IORI==5)THEN
         NMZ=NA
         NMX=NC
         NMY=NB
         A1(3)=1._WP
         A2(1)=1._WP
      ELSEIF(IORI==6)THEN
         NMZ=NA
         NMY=NC
         NMX=NB
         A1(3)=1._WP
         A2(2)=1._WP
      ELSE
         CALL ERRMSG('FATAL','TARHEX',' invalid value for SHPAR(3)')
      ENDIF
      NAT=0
      DO JZ=1,NMZ
         Z=REAL(JZ,KIND=WP)
         DO JY=1,NMY
            Y=REAL(JY,KIND=WP)
            DO JX=1,NMX
               X=REAL(JX,KIND=WP)
               IF(IORI==1)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,X,Y,Z,IN)
               ELSEIF(IORI==2)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,X,Z,Y,IN)
               ELSEIF(IORI==3)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,Y,X,Z,IN)
               ELSEIF(IORI==4)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,Y,Z,X,IN)
               ELSEIF(IORI==5)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,Z,X,Y,IN)
               ELSEIF(IORI==6)THEN
                  CALL TESTHEX(ACM,BCM,CCM,A,B,Z,Y,X,IN)
               ENDIF
               IF(IN)THEN
                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
         ENDDO
      ENDDO

! Set X0 = location in TF of IXYZ=0 0 0
! We assume that origin of TF is located at centroid of hex prism
! Set composition

      DO JZ=1,3
         X0(JZ)=0._WP
         DO JX=1,NAT
            ICOMP(JX,JZ)=1
            X0(JZ)=X0(JZ)+REAL(IXYZ(JX,JZ),KIND=WP)
         ENDDO
         X0(JZ)=-X0(JZ)/REAL(NAT,KIND=WP)
      ENDDO

! Now compute some geometric properties of pseudo-hexagonal prism
!   NLAY = number of layers = effective length of prism/d
!   NFAC = number of atoms in one hexagonal face

      NLAY=INT(A)
      NFAC=NAT/NLAY

! BEFF = effective length of hexagonal size/d
!        computed for hexagon of area NFAC*d**2
!                                     =(3/2)*SQRT(3)*BEFF**2
! Note: for hexagon, vertex-vertex diameter = 2*BEFF

      BEFF=.6204032_WP*SQRT(REAL(NFAC,KIND=WP))

! ASPR = effective aspect ratio of target = length/(2*BEFF)

      ASPR=.5_WP*REAL(NLAY,KIND=WP)/BEFF

! Note: string CDESCR will be printed by subr. TARGET

      WRITE(CDESCR,FMT='(A,I7,A)')' Hexagonal prism of NAT=',NAT,' dipoles'

! Here print any additional target info which is desired by using
! subroutine WRIMSG

      WRITE(CMSGNM,FMT='(A,3F7.4,A)')' A1 = (',A1,') = hexagon symmetry axis'
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CMSGNM,FMT='(A,3F7.4,A)')' A2 = (',A2, ') = center-vertex axis'
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CMSGNM,FMT='(A,I7,A,I4,A,I4,A,F7.4)')' NAT=',NAT,' NFAC=', &
                                NFAC,' NLAY=',NLAY,' aspect ratio=',ASPR
      CALL WRIMSG('TARHEX',CMSGNM)
      WRITE(CDESCR,FMT='(A,I7,A,I4,A,I4,A,F7.4)')' Hex prism,NAT=',NAT, &
                           ' NFAC=',NFAC,' NLAY=',NLAY,' asp.ratio=',ASPR

! Now store atom coordinates in file

      IF(IOSHP>0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,9020)A,B,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' Hexagonal Prism:  A=',F7.4,' B=',F7.4,/,            &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARHEX

    SUBROUTINE TESTHEX(ACM,BCM,CCM,A,B,X,Y,Z,IN)
      USE DDPRECISION,ONLY : WP
! Arguments:
      REAL(WP) :: ACM,BCM,CCM,A,B,X,Y,Z
      LOGICAL :: IN
! Local variables:
      REAL(WP) :: AX,Q,U,V

!*** ACM,BCM,CCM=location of center in A,B,C directions
!    A direction is along axis
!    B direction is vertex to vertex of hexagon
!    C direction is face to face of hexagon

      AX=X
      U=Y-CCM
      V=Z-BCM
      IN=.FALSE.
!*** Test along axis:
      IF(2._WP*ABS(AX-ACM)>A) RETURN
!*** Test along C direction
! .4330127=SQRT(3)/4
      IF(ABS(U)>0.4330127_WP*B) RETURN
!*** Now test whether closer to CM than line bounding edge
! .5773503=1/SQRT(3)
      Q=0.5_WP*ABS(U)+0.8660254_WP*ABS(V)
      IF(Q>0.4330127_WP*B) RETURN
      IN=.TRUE.
      RETURN
    END SUBROUTINE TESTHEX

    SUBROUTINE WRIMSG(CSUBRT,CMSGNM)
      IMPLICIT NONE
! Standard procedure for writing messages
! History:
! 96.11.14 (PJF) Remove "getset" and hardwire" ioout"
! 96.11.20 (BTD) change IOOUT to IDVOUT

! Copyright (C) 1993,1996 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! arguments
      CHARACTER :: CMSGNM*(*), CSUBRT*(*)

! local variables:

      INTEGER :: IDVOUT
      SAVE IDVOUT

! Note: on some systems (e.g., Solaris) IDVOUT=0 generates unbuffered
! output to "standard output".  On other systems IDVOUT=0 may not be
! valid; then set IDVOUT=6 to get "standard output", probably buffered.

      DATA IDVOUT/0/

      WRITE(IDVOUT,FMT=9000)CSUBRT,CMSGNM
9000  FORMAT(' >',A,' ',A)
      RETURN
    END SUBROUTINE WRIMSG

    FUNCTION RAN3(IDUM)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: IDUM
      REAL(WP) :: RAN3

! Local variables:

      INTEGER :: MBIG,MSEED,MZ
      REAL(WP) :: FAC
      PARAMETER(MBIG=1000000000,MSEED=161803398,MZ=0,FAC=1./MBIG)
      INTEGER :: I,IFF,II,INEXT,INEXTP,K
      INTEGER :: MJ,MK,MA(55)
      SAVE IFF,INEXT,INEXTP,MA

!***********************************************************************
! Function RAN3
! Given:
!     IDUM = integer seed (always used on first call, but
!            disregarded on subsequent calls unless IDUM < 0)
! Returns:
!     RAN3 = uniform random deviate between 0.0 and 1.0.
!
! Usage:
!     On first call, will be initialized with whatever seed
!     IDUM is provided.
!     On subsequent calls, result does not depend on IDUM 
!     unless IDUM<0, in which case IDUM is used to reinitialize
!     the sequence.
!
! This routine is based on Knuth's recommendation for a portable
! random number generator.  Present Fortran 90 implementation follows
! closely the f77 FUNCTION RAN3 described in section 7.1 of the book 
! "Numerical Recipes" by W.H. Press, B.P. Flannery, S.A. Teukolsky, and 
! W.T. Vetterling (1986; Cambridge University Press).
!
! B.T. Draine, Princeton University Observatory
!
!***********************************************************************

      DATA IFF/0/

! Initialization:

      IF(IDUM<0.OR.IFF==0)THEN
         IFF=1
         MJ=MSEED-IABS(IDUM)
         MJ=MOD(MJ,MBIG)
         MA(55)=MJ
         MK=1
         DO I=1,54
            II=MOD(21*I,55)
            MA(II)=MK
            MK=MJ-MK
            IF(MK.LT.MZ)MK=MK+MBIG
            MJ=MA(II)
         ENDDO
         DO K=1,4
            DO I=1,55
               MA(I)=MA(I)-MA(1+MOD(I+30,55))
               IF(MA(I).LT.MZ)MA(I)=MA(I)+MBIG
            ENDDO
         ENDDO
         INEXT=0
         INEXTP=31
         IDUM=1
      ENDIF

! Under normal use (second and subsequent calls), this is the
! first executed statement:

      INEXT=INEXT+1
      IF(INEXT==56)INEXT=1
      INEXTP=INEXTP+1
      IF(INEXTP==56)INEXTP=1
      MJ=MA(INEXT)-MA(INEXTP)
      IF(MJ<MZ)MJ=MJ+MBIG
      MA(INEXT)=MJ
      RAN3=MJ*FAC

      RETURN
    END FUNCTION RAN3

    SUBROUTINE PRECOND
      RETURN
    END SUBROUTINE PRECOND

    SUBROUTINE ZBCG2(PRINT_RESID,L,N,X,NONZERO_X,RHS,MATVEC,PRECOND,TOLER, &
                     MXMATVEC,WORK,INFO)
      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_9,ONLY: ITERMX,ITERN

! subroutine zbcg2 (print_resid,l,n,x,nonzero_x,rhs,matvec,precond,toler, &
!                   mxmatvec,work,info)

! Improved "vanilla" BiCGStab(2) iterative method

! Copyright (c) 2001 by M.A.Botchev (http://www.math.utwente.nl/~botchev/),
!                       University of Twente
! Permission to copy all or part of this work is granted,
! provided that the copies are not made or distributed
! for resale, and that the copyright notice and this
! notice are retained.

! This is the "vanilla" version of BiCGstab(\ell) as described
! in PhD thesis of D.R.Fokkema, Chapter 3 (also available as
! Preprint 976, Dept. of Mathematics, Utrecht University, URL
! http://www.math.uu.nl/publications/).  It includes two enhancements 
! to BiCGstab(\ell) proposed by G.Sleijpen and H.van der Vorst in
! 1) G.Sleijpen and H.van der Vorst "Maintaining convergence 
!    properties of BiCGstab methods in finite precision arithmetic",
!    Numerical Algorithms, 10, 1995, pp.203-223
! 2) G.Sleijpen and H.van der Vorst "Reliable updated residuals in
!    hybrid BiCG methods", Computing, 56, 1996, pp.141-163

! {{ This code based on original work of D.R.Fokkema:

! subroutine zbistbl v1.1 1998    
! Copyright (c) 1995-1998 by D.R. Fokkema.
! Permission to copy all or part of this work is granted, 
! provided that the copies are not made or distributed 
! for resale, and that the copyright notice and this 
! notice are retained.

! }}

! Your bug reports, comments, etc. are welcome: 
! m.a.botchev@math.utwente.nl

! ------------------------------
! Description of the parameters:
! ------------------------------

! print_resid (input) LOGICAL. If print_resid=.true. the number of 
!            matrix-vector multiplications done so far and residual norm will
!            be printed to the standard output each iteration

! l          (input) INTEGER the dimension \ell of BiCGstab(\ell)
!            in this simple version it is required that l <= 2
!            l=2 is often useful for systems with nonsymmetric matrices

! n          (input) INTEGER size of the linear system to solve 

! x          (input/output) COMPLEX*16 array dimension n
!            initial guess on input, solution on output

! rhs        (input) COMPLEX*16 array dimension n
!            the right-hand side (r.h.s.) vector

! matvec     (input) EXTERNAL name of matrix vector subroutine
!            to deliver y:=A*x by CALL matvec(n,x,y)

! nonzero_x  (input) LOGICAL tells
!            BiCGstab(\ell) if the initial guess x is zero or not. 
!            If nonzero_x is .FALSE., initial residual equals r.h.s. vector
!            and one MATVEC call is avoided

! toler      (input/output) DOUBLE PRECISION tolerance: the iterations are 
!            stopped as soon as || residual ||/|| initial residual|| <= toler,
!            the norm is Euclidean.  On output, if info>=0, the value of 
!            toler is set to the actually achieved residual reduction

! mxmatvec   (input/output) INTEGER.  On input: maximum number of matrix 
!            vector multiplications allowed to be done.  On output: 
!            if info>=0, mxmatvec is set to the actual number of matrix 
!            vector multiplications done

! work       (workspace) COMPLEX*16 array of dimension (n,2*l+5)

! info       (output) INTEGER.  info = 0 in case of succesful computations
!            and 
!            info = -m (<0) - means paramater number m has an illegal value
!            info = 1 - means no convergence achieved (stopping criterion
!            is not fulfilled)
!            info = 2 - means breakdown of the algorithm (taking a larger
!            value of parameter l usually helps)

! WARNING: If the iterations are ended normally (info=0 or info=1),
! the true residual norm is computed and returned as an output value 
! of the parameter toler.  The true residual norm can be slightly larger
! than the projected residual norm used by the algorithm to stop the
! iterations.  It may thus happen that on output info=0 but the value
! of toler is (slightly) larger than tolerance prescribed on input.
! ----------------------------------------------------------
! history:
! 08.03.14 (BTD) added declaration of dummy array IPAR(*)
!                changed
!                CALL MATVEC(X,WORK(1:N,R),N) -> 
!                CALL MATVEC(X,WORK(1:N,R),IPAR)
! 08.05.12 (BTD) Following suggestion by Art Lazanoff, NASA Ames:
!                CALL MATVEC(X,WORK(1:N,R),IPAR)
!                -> CALL MATVEC(X,WORK(1,R),IPAR) ->
!                RNRM0=DNORM2_BCG(N,WORK(1:N,R))
!                -> RNRM0=DNORM2_BCG(N,WORK(1,R))
!                RHO1=ZDOT_BCG(N,WORK(1:N,RR),WORK(1:N,R+K-1))
!                -> RHO1=ZDOT_BCG(N,WORK(1,RR),WORK(1,R+K-1))
!                CALL MATVEC(WORK(1:N,U+K-1),WORK(1:N,U+K),IPAR)
!                -> CALL MATVEC(WORK(1,U+K-1),WORK(1,U+K),IPAR)
!                SIGMA=ZDOT_BCG(N,WORK(1:N,RR),WORK(1:N,U+K))
!                -> SIGMA=ZDOT_BCG(N,WORK(1,RR),WORK(1,U+K))
!                CALL MATVEC(WORK(1:N,R+K-1),WORK(1:N,R+K),IPAR)
!                -> CALL MATVEC(WORK(1,R+K-1),WORK(1,R+K),IPAR)
!                MATRIX_Z(I,J)=
!                            CONJG(ZDOT_BCG(N,WORK(1:N,R+J-1),WORK(1:N,R+I-1)))
!                -> MATRIX_Z(I,J)=
!                            CONJG(ZDOT_BCG(N,WORK(1,R+J-1),WORK(1,R+I-1)))
!                CALL MATVEC(X,WORK(1:N,R),IPAR)
!                -> CALL MATVEC(X,WORK(1,R),IPAR)
!                CALL MATVEC(X,WORK(1:N,R),IPAR)
!                -> CALL MATVEC(X,WORK(1,R),IPAR)
!                RNRM=DNORM2_BCG(N,WORK(1:N,R))
!                -> RNRM=DNORM2_BCG(N,WORK(1,R))
! 08.07.16 (BTD) Added DDCOMMON_9 to communicate ITERMX and ITERN
! end history
      IMPLICIT NONE

! Parameters:

      LOGICAL,INTENT(IN) :: PRINT_RESID,NONZERO_X
      INTEGER,INTENT(IN) :: L,N
      INTEGER,INTENT(INOUT) :: MXMATVEC
      INTEGER,INTENT(OUT) :: INFO
      COMPLEX(WP),INTENT(INOUT) :: X(N)
      COMPLEX(WP),INTENT(IN) :: RHS(N)
      REAL(WP),INTENT(INOUT) :: TOLER
      COMPLEX(WP),INTENT(OUT) :: WORK(N,3+2*(L+1))
      EXTERNAL MATVEC, PRECOND

! Local variables:

      CHARACTER :: CMSGNM*70
      COMPLEX(WP) :: MATRIX_Z(L+1,L+1),Y0(L+1),YL(L+1),ZY0(L+1),ZYL(L+1)
      LOGICAL :: RCMP,XPDT
      INTEGER :: I,J,K,NMATVEC
      COMPLEX(WP) :: ALPHA,BETA,OMEGA,RHO0,RHO1,SIGMA
      COMPLEX(WP) :: VARRHO,HATGAMMA
      REAL(WP) :: RNRM0,RNRM
      REAL(WP) :: MXNRMX,MXNRMR
      COMPLEX(WP) :: KAPPA0,KAPPAL

! Define dummy array IPAR

      INTEGER IPAR(13)

! Aliases for the parts of the work array:

      INTEGER :: RR,R,U,XP,BP

! Constants:

      REAL(WP),PARAMETER :: DELTA=1D-2
      COMPLEX(WP),PARAMETER :: ZZERO=(0D0,0D0),ZONE=(1D0,0D0)

! Functions:

      REAL(WP) :: DNORM2_BCG
      COMPLEX(WP) :: ZDOT_BCG

!---------------------------------------------------------------------------
!*** diagnostic
!      write(0,*)'zbcg2wp ckpt 1'
!***
      INFO=0

      IF(L<1 .OR. L>2)INFO=-2
      IF(N<1)INFO=-3
      IF(TOLER<=0E0_WP)INFO=-9
      IF(MXMATVEC<0)INFO=-10

      RR=1
      R=RR+1
      U=R+(L+1)
      XP=U+(L+1)
      BP=XP+1

      IF(INFO/=0)RETURN

! Initialize first residual

      IF(NONZERO_X)THEN
!*** diagnostic
!         write(0,*)'zbcg2wp ckpt 2'
!****
!        CALL MATVEC(X,WORK(1:N,R),N)
!         CALL MATVEC(X,WORK(1:N,R),IPAR)
         CALL MATVEC(X,WORK(1,R),IPAR)
!*** diagnostic
!         write(0,*)'zbcg2wp ckpt 3'
!****

         WORK(1:N,R)=RHS-WORK(1:N,R)
         NMATVEC=1
      ELSE
         WORK(1:N,R)=RHS
         NMATVEC=0
      ENDIF

!call precond (n,work(1:n,r))

! Initialize iteration loop

      WORK(1:N,RR)=WORK(1:N,R)
      WORK(1:N,BP)=WORK(1:N,R)
      WORK(1:N,XP)=X
      X=ZZERO

!      RNRM0=DNORM2_BCG(N,WORK(1:N,R))
      RNRM0=DNORM2_BCG(N,WORK(1,R))
      RNRM=RNRM0

      MXNRMX=RNRM0
      MXNRMR=RNRM0
      RCMP=.FALSE.
      XPDT=.FALSE.

      ALPHA=ZZERO
      OMEGA=ZONE
      SIGMA=ZONE
      RHO0=ZONE

!BTD 080716:
      ITERN=0
!-----------

! diagnostic
!      write(0,*)'zbcg2wp ckpt 4: itermx=',itermx
!----------

! Iterate

      DO WHILE (RNRM>TOLER*RNRM0 .AND. NMATVEC<MXMATVEC)

!BTD 080716:
         ITERN=ITERN+1
         IF(ITERN>ITERMX)CALL ERRMSG('FATAL','ZBCG2WP',' ITERN>ITERMX')
!-----------
         
! =====================
! The BiCG part ---
! =====================

         RHO0=-OMEGA*RHO0
         DO K=1,L
!            RHO1=ZDOT_BCG(N,WORK(1:N,RR),WORK(1:N,R+K-1))
            RHO1=ZDOT_BCG(N,WORK(1,RR),WORK(1,R+K-1))
            IF(RHO0==ZZERO)THEN
               INFO=2
               TOLER=RNRM/RNRM0
               MXMATVEC=NMATVEC
               RETURN
            ENDIF
            BETA=ALPHA*(RHO1/RHO0)
            RHO0=RHO1
            DO J=0,K-1
               WORK(1:N,U+J)=WORK(1:N,R+J)-BETA*WORK(1:N,U+J)
            ENDDO
!*** diagnostic
!            write(0,*)'zbcq2wp ckpt 5'
!***
!          CALL MATVEC(WORK(1:N,U+K-1),WORK(1:N,U+K),N)
!           CALL MATVEC(WORK(1:N,U+K-1),WORK(1:N,U+K),IPAR)
           CALL MATVEC(WORK(1,U+K-1),WORK(1,U+K),IPAR)
!*** diagnostic
!           write(0,*)'zbcq2wp ckpt 6'
!***
!          call precond (n, work(1:n,u+k))
           NMATVEC=NMATVEC+1

!           SIGMA=ZDOT_BCG(N,WORK(1:N,RR),WORK(1:N,U+K))
           SIGMA=ZDOT_BCG(N,WORK(1,RR),WORK(1,U+K))
           IF(SIGMA==ZZERO)THEN
              INFO=2
              TOLER=RNRM/RNRM0
              MXMATVEC=NMATVEC
              RETURN
           ENDIF
           ALPHA=RHO1/SIGMA
           X(1:N)=ALPHA*WORK(1:N,U)+X(1:N)
           DO J=0,K-1
              WORK(1:N,R+J)=-ALPHA*WORK(1:N,U+J+1)+WORK(1:N,R+J)
           ENDDO
!           CALL MATVEC(WORK(1:N,R+K-1),WORK(1:N,R+K),IPAR)
           CALL MATVEC(WORK(1,R+K-1),WORK(1,R+K),IPAR)
!      call precond (n, work(1:n,r+k))
           NMATVEC=NMATVEC+1
           RNRM=DNORM2_BCG(N,WORK(1,R))
           MXNRMX=MAX(MXNRMX,RNRM)
           MXNRMR=MAX(MXNRMR,RNRM)
        ENDDO

! ==================================
! The convex polynomial part ---
! ==================================

!  --- Z = R'R

        DO I=1,L+1
           DO J=1,I
!              MATRIX_Z(I,J)=CONJG(ZDOT_BCG(N,WORK(1:N,R+J-1),WORK(1:N,R+I-1)))
              MATRIX_Z(I,J)=CONJG(ZDOT_BCG(N,WORK(1,R+J-1),WORK(1,R+I-1)))
           ENDDO
        ENDDO

!  lower triangular part of Z is computed; compute the rest knowing that Z^H=Z
        DO J=2,L+1
           MATRIX_Z(1:J-1,J)=CONJG(MATRIX_Z(J,1:J-1))
        ENDDO

!  small vectors y0 and yl

        Y0(1)=-ZONE
        Y0(2)=(MATRIX_Z(2,1)/MATRIX_Z(2,2)) ! works only for l=2
        Y0(L+1)=ZZERO

        YL(1)=ZZERO
        YL(2)=(MATRIX_Z(2,3)/MATRIX_Z(2,2)) ! works only for l=2
        YL(L+1)=-ZONE

!  --- Convex combination

! compute Z*y0 and Z*yl
        ZY0=ZZERO
        ZYL=ZZERO
        DO J=1,L+1
           ZY0=ZY0+MATRIX_Z(:,J)*Y0(J)
           ZYL=ZYL+MATRIX_Z(:,J)*YL(J)
        ENDDO

        KAPPA0=SQRT(ABS(ZDOT_BCG(L+1,Y0,ZY0)))
        KAPPAL=SQRT(ABS(ZDOT_BCG(L+1,YL,ZYL)))

        VARRHO=ZDOT_BCG(L+1,YL,ZY0)/(KAPPA0*KAPPAL)

        HATGAMMA=VARRHO/ABS(VARRHO)*MAX(ABS(VARRHO),7E-1_WP)

        Y0=Y0-(HATGAMMA*KAPPA0/KAPPAL)*YL


!  --- Update

        OMEGA=Y0(L+1)

        DO J=1,L
           WORK(1:N,U)=WORK(1:N,U)- Y0(J+1)*WORK(1:N,U+J)
           X(1:N)=X(1:N)+Y0(J+1)*WORK(1:N,R+J-1)
           WORK(1:N,R)=WORK(1:N,R)- Y0(J+1)*WORK(1:N,R+J)
        ENDDO

! y0 has changed; compute Z*y0 once more

        ZY0=ZZERO
        DO J=1,L+1
           ZY0=ZY0+MATRIX_Z(:,J)*Y0(J)
        ENDDO

        RNRM=SQRT(ABS(ZDOT_BCG(L+1,Y0,ZY0)))

! ================================
! The reliable update part ---
! ================================

        MXNRMX=MAX(MXNRMX,RNRM)
        MXNRMR=MAX(MXNRMR,RNRM)
        XPDT=(RNRM<DELTA*RNRM0 .AND. RNRM0<MXNRMX)
        RCMP=((RNRM<DELTA*MXNRMR .AND. RNRM0<MXNRMR).OR. XPDT)
        IF(RCMP)THEN
!           CALL MATVEC(X,WORK(1:N,R),N)
!           CALL MATVEC(X,WORK(1:N,R),IPAR)
           CALL MATVEC(X,WORK(1,R),IPAR)
!   call precond (n, work(1:n,r))
           NMATVEC=NMATVEC+1
           WORK(1:N,R)=WORK(1:N,BP)- WORK(1:N,R)
           MXNRMR=RNRM
           IF(XPDT)THEN

              WORK(1:N,XP)=X(1:N)+WORK(1:N,XP)
              X=ZZERO
              WORK(1:N,BP)=WORK(1:N,R)

              MXNRMX=RNRM
           ENDIF
        ENDIF

!        IF(print_resid)PRINT *,nmatvec,' ',rnrm
        
        IF(PRINT_RESID)THEN
           WRITE(CMSGNM,FMT='(A,I8,A,1P,E10.3)') &
                 'IT=',NMATVEC/4,' f.err=',RNRM/RNRM0
           CALL WRIMSG('ZBCG2 ',CMSGNM)
         ENDIF

      ENDDO

! =========================
! End of iterations ---
! =========================

      X(1:N)=X(1:N)+WORK(1:N,XP)

      IF(RNRM>TOLER*RNRM0)INFO=1

! compute the true residual:

! --------------------- One matvec can be saved by commenting out this:
!      CALL MATVEC(X,WORK(1:N,R),N)
!      CALL MATVEC(X,WORK(1:N,R),IPAR)
      CALL MATVEC(X,WORK(1,R),IPAR)

      WORK(1:N,R)=RHS(1:N)- WORK(1:N,R)
!call precond (n,work(1:n,r))
!      RNRM=DNORM2_BCG(N,WORK(1:N,R))
      RNRM=DNORM2_BCG(N,WORK(1,R))
      NMATVEC=NMATVEC+1
! --------------------- One matvec can be saved by commenting out this^

      TOLER=RNRM/RNRM0
      MXMATVEC=NMATVEC

    END SUBROUTINE ZBCG2


    FUNCTION ZDOT_BCG(N,ZX,ZY)
      USE DDPRECISION,ONLY : WP

! complex inner product function

      IMPLICIT NONE
      INTEGER,INTENT (IN) :: N
      COMPLEX(WP),INTENT (IN) :: ZX(N),ZY(N)
      COMPLEX(WP) ZDOT_BCG
      ZDOT_BCG=SUM(CONJG(ZX)*ZY)
    END FUNCTION ZDOT_BCG


    FUNCTION DNORM2_BCG(N,ZX)
      USE DDPRECISION,ONLY : WP

! L2 norm function

      IMPLICIT NONE
      INTEGER,INTENT (IN) :: N
      COMPLEX(WP),INTENT (IN) :: ZX(N)
      COMPLEX(WP),EXTERNAL :: ZDOT_BCG
      REAL(WP) :: DNORM2_BCG
      DNORM2_BCG=SQRT(ABS(ZDOT_BCG(N,ZX,ZX)))

    END FUNCTION DNORM2_BCG

    SUBROUTINE TARNSP(A1,A2,DIAMX,PRINAX,DX,X0,CFLSHP,CDESCR,IDVSHP,IOSHP, &
                      MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!** Arguments:

      CHARACTER :: CDESCR*67,CFLSHP*80
      INTEGER :: IDVSHP,IOSHP,MXNAT,NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: DIAMX, PRINAX
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

!** Local variables:

      INTEGER :: NSPHMX
      PARAMETER (NSPHMX=10000)
      CHARACTER :: CMSGNM*70
      LOGICAL :: OCC
      INTEGER :: JA,JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,NSPH
      REAL(WP) :: R2,SCALE,X,XMAX,XMIN,Y,YMAX,YMIN,Z,ZMAX,ZMIN
      REAL(WP) ::     &
         ALPHA(3),    &
         AS(NSPHMX),  &
         AS2(NSPHMX), &
         XS(NSPHMX),  &
         YS(NSPHMX),  &
         ZS(NSPHMX)

!***********************************************************************
! Routine to construct multisphere target

! Input:
!        DIAMX =max extent in X direction/d
!        PRINAX=0 to set A1=(1,0,0), A2=(0,1,0)
!              =1 to use principal axes for vectors A1 and A2
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        CFLSHP= name of file containing locations and radii of spheres
!        IOSHP =device number for "target.out" file
!              =-1 to suppress printing of "target.out"
!        MXNAT =dimensioning information (max number of atoms)

! and, from input file CFLSHP:

!        NSPH              = number of spheres
!        one descriptive line which will be ignored (may be blank)
!        XS(1) YS(1) ZS(1) AS(1)
!        XS(2) YS(2) ZS(2) AS(2)
!        ...
!        XS(NSPH) YS(NSPH) ZS(NSPH) AS(NSPH)

! where XS(J),YS(J),ZS(J) = x,y,z coordinates in target frame, in
!                                 arbitrary units, of center of sphere J
!        AS(J)            = radius of sphere J (same arbitrary units)

! units used for XS,YS,ZS, and AS are really arbitrary: actual size of
! overall target, in units of lattice spacing d, is controlled by
! parameter SHPAR(1) in ddscat.par

! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Frame
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Frame
!        X0(1-3)=location/d in TF of lattice site IXYZ=0 0 0
!                TF origin is taken to be volume-weighted centroid of
!                N spheres
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=composition identifier (currently 1 1 1)
!        CDESCR=description of target (up to 67 characters)

! B.T.Draine, Princeton Univ. Obs., 2000.06.12

! History:
! 00.06.12 (BTD) adapted to version 6.0 (introduce DX)
! 00.11.02 (BTD) write ICOMP to target.out
! 01.01.13 (BTD) corrected comments
! 01.04.21 (BTD) corrected comments
! 01.04.21 (BTD) corrected typo: changed
!                      YMAX=YS(1)+YS(1)
!                to    YMAX=YS(1)+AS(1)
!                Thanks to Ivan O. Sosa Perez (UNAM) for discovering
!                this error.
! 03.06.06 (BTD) corrected error in setting LMX1,...,LMZ2
! 03.11.06 (BTD) modified to use new version of PRINAXIS with eigenvalue
!                in argument list
! 04.03.19 (BTD) revert to previous version of PRINAXIS
!                change CFLSHP*13 to CFLSHP*80 to accomodate long file
!                names
! 04.05.23 (BTD) modified to obtain eigenvalues ALPHA from PRINAXIS
!                modified arg list of PRINAXIS to conform to change
! 04.09.15 (BTD) added call to ERRMSG and abort if NSPH > NSPHMX
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER
! 08.08.08 (BTD) added X0 to argument list
!                added code to set X0 so that TF origin is located at
!                volume-weighted centroid of the N spheres
! 08.08.30 (BTD) modified format 9020
! 08.09.17 (BTD) corrected bugs that caused target centroid X0 to be
!                computed incorrectly (identical bugs were present in
!                routine TARNAS
! 09.09.09 (BTD) added some more running output to help diagnose
!                fatal errors resulting from problems with input parameters 
! end history

! Copyright (C) 2000,2001,2003,2004,2007,2008,2009 
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Read parameters of spheres:

! 09.09.09 (BTD) added code ----------
      write(0,*)'>TARNSP open CFLSHP=',cflshp
!-------------------------------------
      OPEN(UNIT=IDVSHP,FILE=CFLSHP)
      READ(IDVSHP,*)NSPH
      IF(NSPH>NSPHMX)THEN
!-------------------------------------
! 09.09.09 (BTD) added code ----------
         WRITE(CMSGNM,FMT='(A,I6,A,I6,A)')'fatal error: NSPH=',NSPH, &
                                        ' > NSPHMX',NSPHMX
         CALL WRIMSG('TARNSP',CMSGNM)
!-------------------------------------
         CALL ERRMSG('FATAL','TARNSP',' NSPH > NSPHMX')
         STOP
      ENDIF
      READ(IDVSHP,*)
      DO JA=1,NSPH
         READ(IDVSHP,*)XS(JA),YS(JA),ZS(JA),AS(JA)
      ENDDO

      CLOSE(IDVSHP)

! Dipoles are located at sites
! (x,y,z)=(I,J,K), I,J,K=integers

! Determine max extent in X direction:

      XMIN=XS(1)-AS(1)
      XMAX=XS(1)+AS(1)
      YMIN=YS(1)-AS(1)
      YMAX=YS(1)+AS(1)
      ZMIN=ZS(1)-AS(1)
      ZMAX=ZS(1)+AS(1)
      IF(NSPH>1) THEN
         DO JA=2,NSPH
            IF(XS(JA)-AS(JA)<XMIN)XMIN=XS(JA)-AS(JA)
            IF(XS(JA)+AS(JA)>XMAX)XMAX=XS(JA)+AS(JA)
            IF(YS(JA)-AS(JA)<YMIN)YMIN=YS(JA)-AS(JA)
            IF(YS(JA)+AS(JA)>YMAX)YMAX=YS(JA)+AS(JA)
            IF(ZS(JA)-AS(JA)<ZMIN)ZMIN=ZS(JA)-AS(JA)
            IF(ZS(JA)+AS(JA)>ZMAX)ZMAX=ZS(JA)+AS(JA)
         ENDDO
      ENDIF
      SCALE=DIAMX/(XMAX-XMIN)

! Now determine min,max values of I,J,K:

      LMX1=NINT(SCALE*XMIN/DX(1)-0.01_WP)
      LMX2=NINT(SCALE*XMAX/DX(1)+0.01_WP)
      LMY1=NINT(SCALE*YMIN/DX(2)-0.01_WP)
      LMY2=NINT(SCALE*YMAX/DX(2)+0.01_WP)
      LMZ1=NINT(SCALE*ZMIN/DX(3)-0.01_WP)
      LMZ2=NINT(SCALE*ZMAX/DX(3)+0.01_WP)

      DO JA=1,NSPH
         AS2(JA)=(SCALE*AS(JA))**2
         XS(JA)=SCALE*XS(JA)
         YS(JA)=SCALE*YS(JA)
         ZS(JA)=SCALE*ZS(JA)
      ENDDO

! Determine list of occupied sites

      NAT=0
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ,KIND=WP)*DX(3)
         DO JY=LMY1,LMY2
            Y=REAL(JY,KIND=WP)*DX(2)
            DO JX=LMX1,LMX2
               X=REAL(JX,KIND=WP)*DX(1)
               OCC=.FALSE.
               DO JA=1,NSPH
                  R2=(X-XS(JA))**2+(Y-YS(JA))**2+(Z-ZS(JA))**2
                  IF(R2<AS2(JA))OCC=.TRUE.
               ENDDO
               IF(OCC)THEN

! Site is occupied:

                  NAT=NAT+1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
         ENDDO
      ENDDO

      IF(NAT>MXNAT)THEN
!----------------------------
! 09.09.09 (BTD) added code
         WRITE(CMSGNM,'(A,I8,A,I8)')'NAT=',NAT,' > MXNAT=',MXNAT
         CALL WRIMSG('TARNSP',CMSGNM)
!----------------------------
         CALL ERRMSG('FATAL','TARNSP',' NAT.GT.MXNAT ')
      ENDIF

! Homogeneous target:

      DO JA=1,NAT
         DO JX=1,3
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

!*** diagnostic
!      write(0,*)'in tarsnp: made target with NAT=',NAT,' dipoles'
!***

! Specify target axes A1 and A2
! If PRINAX=0, then
!     A1=(1,0,0) in target frame
!     A2=(0,1,0) in target frame
!     set ALPHA(1)=ALPHA(2)=ALPHA(3)=0
! If PRINAX=1., then
!     A1,A2 are principal axes of largest, second largest moment of
!     inertia

      IF(PRINAX<=0._WP)THEN
         DO JX=1,3
            A1(JX)=0._WP
            A2(JX)=0._WP
            ALPHA(JX)=0._WP
         ENDDO
         A1(1)=1._WP
         A2(2)=1._WP
      ELSE
         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,ALPHA)
      ENDIF

! Find volume-weighted centroid of the N spheres in IJK space
! Take this to be TF origin.
! Set X0 = -(IJK centroid)

      DO JX=1,3
         X0(JX)=0._WP
      ENDDO
      Z=0._WP
      DO JA=1,NSPH
         Z=Z+AS(JA)**3
      ENDDO
      DO JA=1,NSPH
         Y=AS(JA)**3/Z
         X0(1)=X0(1)-XS(JA)*Y
         X0(2)=X0(2)-YS(JA)*Y
         X0(3)=X0(3)-ZS(JA)*Y
      ENDDO

!***********************************************************************
! Write target description into string CDESCR

      WRITE(CDESCR,FMT='(A,I7,A)')' Multisphere cluster containing',NAT, &
                                  ' dipoles'

!***********************************************************************

      CMSGNM=CDESCR
      CALL WRIMSG('TARNSP',CMSGNM)
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NSPH,DIAMX,NAT,ALPHA,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
9020  FORMAT(' >TARNSP multisphere target composed of ',I4,        &
         ' spheres, DIAMX=',F8.4,/,                                &
         I10,3F8.4,' = NAT, alpha_1-3',/,                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARNSP

    SUBROUTINE EVALE(CXE00,AKD,DX,X0,IXYZ0,MXNAT,MXN3,NAT,NAT0,NX,NY,NZ,CXE)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!*** Arguments:

      INTEGER :: MXN3,MXNAT,NAT,NAT0,NX,NY,NZ
      INTEGER ::     &
         IXYZ0(NAT0,3)
      REAL(WP) :: &
         AKD(3),  &
         DX(3),   &
         X0(3)

! Note: CXE should be dimensioned to CXE(NAT,3) in this routine
!       so that first 3*NAT elements of CXE are employed.
!       XYZ0 should be dimensioned to

      COMPLEX(WP) :: & 
         CXE(NAT,3), &
         CXE00(3)

!***  Local variables:

      COMPLEX(WP) :: CXFAC,CXI
      REAL(WP) :: X,X1,X2
      INTEGER :: IA,IX,IY,IZ,M

!*** Intrinsic functions:

      INTRINSIC EXP,REAL

!***********************************************************************
! subroutine EVALE

! Given:   CXE00(1-3)=Incident E field at origin (complex) at t=0
!          AKD(1-3)=(kx,ky,kz)*d for incident wave (d=effective
!                    lattice spacing)
!          DX(1-3)=(dx/d,dy/d,dz/d) for lattice (dx,dy,dz=lattice
!                   spacings in x,y,z directions, d=(dx*dy*dz)**(1/3)
!          X0(1-3)=(x,y,z)location/(d*DX(1-3)) in TF of lattice site
!                  with IX=0,IY=0,IZ=0
!          IXYZ0(1-NAT0,3)=[x-x0(1)]/dx, [y-x0(2)]/dy, [z-x0(3)]/dz
!                  for each of NAT0 physical dipoles
!          MXNAT,MXN3=dimensioning information
!          NAT0=number of dipoles in physical target
!          NAT=number of locations at which to calculate CXE

! Returns: CXE(1-NAT,3)=incident E field at NAT locations at t=0

! B.T.Draine, Princeton Univ. Obs., 88.05.09
! History:
! 90.11.06 (BTD): Modified to pass array dimension.
! 90.11.29 (BTD): Modified to allow option for either
!                   physical locations only (NAT=NAT0), or
!                   extended dipole array (NAT>NAT0)
! 90.11.30 (BTD): Corrected error for case NAT>NAT0
! 90.11.30 (BTD): Corrected another error for case NAT>NAT0
! 90.12.03 (BTD): Change ordering of XYZ0 and CXE
! 90.12.05 (BTD): Corrected error in dimensioning of CXE
! 90.12.10 (BTD): Remove XYZ0, replace with IXYZ0
! 97.11.02 (BTD): Add DX to argument list to allow use with
!                 noncubic lattices.
! 07.06.20 (BTD): Add X0 to the argument list to specify location
!                 in TF corresponding to IX=0,IY=0,IZ=0
! 07.09.11 (BTD): Changed IXYZ0 from INTEGER*2 to INTEGER
! 08.03.14 (BTD): v7.05
!                 corrected dimensioning
!                 IXYZ0(MXNAT,3) -> IXYZO(NAT0,3)
! Copyright (C) 1993,1997,2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      CXI=(0._WP,1._WP)

! Evaluate electric field vector at each dipole location.

! If NAT=NAT0, then evaluate E only at occupied sites.
! If NAT>NAT0, then evaluate E at all sites.

      IF(NAT==NAT0)THEN
         DO IA=1,NAT0
            X=0._WP
            DO M=1,3
               X=X+AKD(M)*DX(M)*(REAL(IXYZ0(IA,M),KIND=WP)+X0(M))
            ENDDO
            CXFAC=EXP(CXI*X)
            DO M=1,3
               CXE(IA,M)=CXE00(M)*CXFAC
            ENDDO
         ENDDO
      ELSE
         IA=0
         DO IZ=1,NZ
            X1=AKD(3)*DX(3)*(REAL(IZ,KIND=WP)+X0(3))
            DO IY=1,NY
               X2=X1+AKD(2)*DX(2)*(REAL(IY,KIND=WP)+X0(2))
               DO IX=1,NX
                  IA=IA+1
                  X=X2+AKD(1)*DX(1)*(REAL(IX,KIND=WP)+X0(1))
                  CXFAC=EXP(CXI*X)
                  DO M=1,3
                     CXE(IA,M)=CXE00(M)*CXFAC
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      RETURN
    END SUBROUTINE EVALE

    SUBROUTINE PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,EIGVAL)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: MXNAT,NAT
      INTEGER*2 ::   &
        ICOMP(MXNAT,3)
      INTEGER ::    &
        IXYZ(MXNAT,3)
      REAL (WP) :: A1(3),A2(3),DX(3),EIGVAL(3)

! Local variables:

      INTEGER :: LWORK
      PARAMETER (LWORK=12)
      INTEGER :: J,J1,J2,J3,JA,JD,K
      REAL (WP) :: DENOM,DSUM,PI,ZNORM,ZNORM2
      REAL (WP) :: &
        A(3,3),    &
        A3(3),     &
        CM(3),     &
        Q(3,3),    &
        W(3)
      CHARACTER :: CMSGNM*70
!***********************************************************************
! Subroutine to determine principal axes of moment of inertia tensor
! of target.
! Target is assumed to be homogeneous.
! Given:

! MXNAT       =limit on largest allowed value of NAT=number of dipoles
! NAT         =number of dipoles in target
! IXYZ(J,1-3) =x,y,z location of dipole Jon lattice
! DX(1-3)     =(dx/d,dy/d,dz/d) where (dx,dy,dz)=lattice spacing in
!              x,y,z directions,
!              and d = (dx*dy*dz)**(1/3) = effective lattice spacing
! ICOMP(J,1-3)=composition for dipole J; x,y,z directions

! Returns:

! A1(1-3)     =principal axis A1 in target frame (normalized)
! A2(1-3)     =principal axis A2 in target frame (normalized)
! EIGV(1-3)   =(eigenvalues of moment of inertia tensor)/(0.4*M*aeff^2)
!              definition of aeff = (3*V/4*pi)^{1/3} , V = solid volume
!              EIGV are in decreasing order:
!              EIGV(1) is largest, EIGV(3) is smallest

!              A1 = principal axis with largest moment of inertia
!              A2 = principal axis with second-largest moment of inertia

! B.T. Draine, Princeton Univ. Observatory, 96.01.26
! History:
! 96.01.26 (BTD) extracted from routine TARBLOCKS
!                IX,IY,IZ replaced by IXYZ
! 96.02.23 (BTD) corrected typo in 2 format statements
!                add code computing axis a3 and printing out
!                eigenvalue.
! 96.11.01 (PJF) modified to use LAPACK code rather than EIGV
!                and associated routines from NSWC package.
! 96.11.21 (BTD) modified to remove WRITE(0 and replace with
!                calls to WRIMSG
! 97.12.26 (BTD) added DX(3) to argument list, and modified to
!                compute principal axes with unequal lattice
!                spacing.
! 98.04.27 (BTD) deleted unused variables I,ZI
! 98.12.15 (BTD) Appears to be a problem with LAPACK routine SGEEV
!                when compiled using g77 under Linux.
!                Add trap to catch this problem if it occurs,
!                print out warning, and terminate execution.
! 00.06.13 (BTD) corrected error in computation of diagonal elements
!                of moment of inertia tensor (NAT/6 -> NAT/18)
! 04.05.23 (BTD) added normalized eigenvalues EIGV to argument list
! 07.08.03 (BTD) modified to replace LAPACK routine SGEEV with
!                routine DSYEVJ3 from Joachim Kopp
!                arXiv.org:physics/0610206
!                use f90 version of DSYEVJ3
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER
! End history.

! Copyright (C) 1993,1994,1995,1996,1997,1998,2000,2004,2007
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      PI=4._WP*ATAN(1._WP)

! Compute moment of inertia tensor.

      DO JD=1,3
        CM(JD)=0._WP
      ENDDO
      DO JA=1,NAT
        DO JD=1,3
          CM(JD)=CM(JD)+IXYZ(JA,JD)*DX(JD)
        ENDDO
      ENDDO
      DO JD=1,3
        CM(JD)=CM(JD)/NAT
      ENDDO

! Compute moment of inertia tensor

      DO J=1,3
        DO K=1,3
          A(J,K)=0._WP
        ENDDO
      ENDDO
      DSUM=0._WP
      DO K=1,3
        DO JA=1,NAT
          DSUM=DSUM+((IXYZ(JA,K)-CM(K))*DX(K))**2
        ENDDO
      ENDDO
      DO J=1,3
        A(J,J)=REAL(DSUM+(NAT/18._WP)*(DX(1)**2+DX(2)**2+DX(3)**2),KIND=WP)
      ENDDO
      DO J=1,3
        DO K=1,3
          DSUM=0._WP
          DO JA=1,NAT
            DSUM=DSUM+(IXYZ(JA,J)-CM(J))*(IXYZ(JA,K)-CM(K))*DX(J)*DX(K)
          ENDDO
          A(J,K)=A(J,K)-REAL(DSUM,KIND=WP)
        ENDDO
      ENDDO

! Normalize moment of inertia tensor to units of 0.4*mass*a_eff**2

      DENOM=0.4_WP*NAT*(.75_WP*NAT/PI)**(2._WP/3._WP)
      DO K=1,3
        DO J=1,3
          A(J,K)=A(J,K)/DENOM
        ENDDO
      ENDDO

! Compute eigenvalues and eigenvectors of A(J,K)

      CALL DSYEVJ3(A,Q,W)

! on return from DSYEVJ3:
!    W(i) = eigenvalues i=1,2,3
!    Q(i,j=1,3) = eigenvector corresponding to eigenvalue W(i) 

! Normalize the eigenvectors:

      DO J=1,3
        ZNORM2=0._WP
        DO K=1,3
          ZNORM2=ZNORM2+Q(K,J)**2
        ENDDO

! Make first component of each eigenvector positive

        ZNORM=SQRT(ZNORM2)
        IF(Q(1,J)<0._WP)THEN
          ZNORM=-ZNORM
        ELSEIF(Q(1,J)==0._WP)THEN
          IF(Q(2,J)<0._WP)ZNORM=-ZNORM
        ENDIF
        DO K=1,3
          Q(K,J)=Q(K,J)/ZNORM
        ENDDO
      ENDDO

! Order the eigenvectors by eigenvalue, largest first:

      J1=1
      IF(W(2)>W(1))J1=2
      IF(W(3)>W(J1))J1=3
      IF(J1==1)THEN
        J2=2
        IF(W(3)>W(2))J2=3
      ELSEIF(J1==2)THEN
        J2=1
        IF(W(3)>W(1))J2=3
      ELSEIF(J1==3)THEN
        J2=1
        IF(W(2)>W(1))J2=2
      ENDIF
      DO K=1,3
        A1(K)=Q(K,J1)
        A2(K)=Q(K,J2)
      ENDDO

! Set J3=3 if J1+J2=1+2=3
!        2         =1+3=4
!        1         =2+3=5

      J3=6-J1-J2

! Having fixed eigenvectors a_1 and a_2, compute a_3 = a_1 x a_2

      A3(1)=A1(2)*A2(3)-A1(3)*A2(2)
      A3(2)=A1(3)*A2(1)-A1(1)*A2(3)
      A3(3)=A1(1)*A2(2)-A1(2)*A2(1)

      EIGVAL(1)=W(J1)
      EIGVAL(2)=W(J2)
      EIGVAL(3)=W(J3)

!*** enable following lines to print out eigenvalues

      WRITE (CMSGNM,FMT='(A,0P,F8.5)')'I_1/.4Ma_eff^2 =',W(J1)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE (CMSGNM,FMT='(A,0P,F8.5)')'I_2/.4Ma_eff^2 =',W(J2)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE (CMSGNM,FMT='(A,0P,F8.5)')'I_3/.4Ma_eff^2 =',W(J3)
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE (CMSGNM,FMT='(A,0P,3F9.5,A)')'axis a_1 = (',A1,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE (CMSGNM,FMT='(A,0P,3F9.5,A)')'     a_2 = (',A2,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
      WRITE (CMSGNM,FMT='(A,0P,3F9.5,A)')'     a_3 = (',A3,')'
      CALL WRIMSG('PRINAXIS',CMSGNM)
!***
      RETURN
    END SUBROUTINE PRINAXIS

    SUBROUTINE WRITEBIN(CBINFLAG,CBINFILE,IOBIN,CSTAMP,CDESCR,CMDFFT,CALPHA, &
        CSHAPE,CMDTRQ,MXWAV,MXRAD,MXTHET,MXBETA,MXPHI,MXN3,MXNAT,MXSCA,      &
        MXTIMERS,IORTH,NX,NY,NZ,NAT0,NAT,NAT3,NAVG,NSCAT,NCOMP,NORI,NWAV,    &
        NRAD,NTHETA,NPHI,NBETA,NTIMERS,MXNX,MXNY,MXNZ,MXCOMP,BETMID,BETMXD,  &
        THTMID,THTMXD,PHIMID,PHIMXD,TOL,DX,WAVEA,AEFFA,THETA,BETA,PHI,A1,A2, &
        ICOMP,IXYZ0,IWAV,IRAD,IORI,AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,   &
        CXE01R,CXE02R,CXRFR,CXEPS,QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,  &
        QTRQSC,SM,PHIN,THETAN,TIMERS)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!     .. Scalar Arguments ..
      REAL (WP) :: AEFF,AK1,BETAD,BETMID,BETMXD,PHID,PHIMID,PHIMXD, &
        THETAD,THTMID,THTMXD,TOL,WAVE,XX
      INTEGER :: IOBIN,IORI,IORTH,IRAD,IWAV,MXBETA,MXCOMP,MXN3,MXNAT, &
        MXNX,MXNY,MXNZ,MXPHI,MXRAD,MXSCA,MXTHET,MXTIMERS,MXWAV,NAT,   &
        NAT0,NAT3,NAVG,NBETA,NCOMP,NORI,NPHI,NRAD,NSCAT,NTHETA,       &
        NTIMERS,NWAV,NX,NY,NZ
      CHARACTER :: CALPHA*6,CBINFLAG*6,CMDFFT*6,CMDTRQ*6,CSHAPE*9, &
        CBINFILE*14,CSTAMP*26,CDESCR*67
!     .. Array Arguments ..
      COMPLEX (WP) :: CXE01R(3),CXE02R(3),CXEPS(MXCOMP),CXRFR(MXCOMP)
      REAL (WP) :: A1(3),A2(3),AEFFA(MXRAD),AKR(3),BETA(MXBETA),DX(3), &
        G(2),PHI(MXPHI),PHIN(MXSCA),QABS(2),QAV(17),QBKSCA(2),QEXT(2), &
        QPHA(2),QSCAT(2),QTRQAB(3,2),QTRQSC(3,2),SM(MXSCA,4,4),        &
        THETA(MXTHET),THETAN(MXSCA),TIMERS(MXTIMERS),WAVEA(MXWAV)
      INTEGER*2 :: ICOMP(MXN3)
      INTEGER :: IXYZ0(MXNAT,3)
!     .. Local Scalars ..
      INTEGER :: I,IENTRY,IS,J
!     .. External Subroutines ..
      EXTERNAL WRIMSG
!     .. Data statements ..
      DATA IENTRY/0/
      SAVE IENTRY

!***********************************************************************
! Subroutine  "writebin" writes FORTRAN unformatted binary file
! to file cbinfile ('dd.bin')

! Original version created by P.J.Flatau, University of California, SD
! History:
! 96.11.15 (PJF): First version.
! 98.01.11 (BTD): Added DX(3) to argument list, and write DX to
!                 binary output upon entry (DX doesn't change).
! 99.06.30 (BTD): Added SAVE IENTRY statement.
! 03.10.23 (BTD): Removed ICTHM and IPHIM from argument list
!                 Removed ICTHM and IPHIM from WRITE statement
!                 Added NAVG to argument list.
!                 Note: manner in which data is written could be
!                 improved along lines followed in WRITENET.
!                 However, does not appear to be demand, so such
!                 changes are postponed indefinitely.
! 07.09.11 (BTD): changed IXYZ0 from INTEGER*2 to INTEGER
! end history
! Copyright (C) 1996,1998,1999,2003,2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      IF(IENTRY==0)THEN
        CALL WRIMSG('WRITEBIN','First call to binary write')
        IENTRY = 1
! General run information:
        WRITE(IOBIN) CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,CMDTRQ
! mostly dimensions:
        WRITE(IOBIN) IORTH,NX,NY,NZ,NAT0,NAT,NAT3,NSCAT,NCOMP,NORI, &
          NWAV,NRAD,NTHETA,NPHI,NBETA,NTIMERS
! maximum dimension (not really needed)
        WRITE(IOBIN) MXNX,MXNY,MXNZ,MXCOMP,MXSCA
        WRITE(IOBIN) BETMID,BETMXD,THTMID,THTMXD,PHIMID,PHIMXD
! dump scattering angles
        WRITE(IOBIN) (PHIN(I),I=1,NSCAT),(THETAN(I),I=1,NSCAT)
! misc run information
        WRITE(IOBIN) TOL,NAVG
        WRITE(IOBIN) (WAVEA(I),I=1,NWAV),(AEFFA(I),I=1,NRAD), &
          (THETA(I),I=1,NTHETA),(BETA(I),I=1,NBETA),(PHI(I),I=1,NPHI), &
          (A1(I),I=1,3),(A2(I),I=1,3),(ICOMP(I),I=1,NAT3), &
          (IXYZ0(I,1),I=1,NAT),(IXYZ0(I,2),I=1,NAT),(IXYZ0(I,3),I=1,NAT), &
          (DX(I),I=1,3)

! endif  "if(cbinflag.eq.'USEBIN') then"
      ENDIF

! binary write of  for particular "iwav, irad, itheta, ibeta iphi"
! Let us try to keep only  one version of the binary file. Thus, in
! case of IORTH=1 or 'DOTORQ' some values are "missing"
! flatau -->draine  do we need smori for "ppol" do we need cxf_ij ?

      IF(IORI/=0 .AND. CBINFLAG=='ALLBIN')THEN
        WRITE(IOBIN) IWAV,IRAD,IORI,(TIMERS(I),I=1,NTIMERS)
        WRITE(IOBIN) AEFF,WAVE,XX,AK1,BETAD,THETAD,PHID,AKR,CXE01R, &
          CXE02R,(CXRFR(I),I=1,NCOMP),(CXEPS(I),I=1,NCOMP)
        WRITE(IOBIN) QEXT,QABS,QSCAT,G,QBKSCA,QPHA,QAV,QTRQAB,QTRQSC
! write sm as 16 independent matrices (IDL handles 7 subscripts only)
        DO I = 1,4
          DO J = 1,4
            WRITE(IOBIN) (SM(IS,I,J),IS=1,NSCAT)
          END DO
        END DO
! endif "if(iori. ne. 0 .and. cbinflag.eq.'ALLCDF') then"
      ENDIF

      IF(IORI==0)THEN

! BTD 98.05.01 add CONTINUE statement in lieu of actual code

        CONTINUE

! iori=0 case
!flatau ---> note. I need to add code for orientational averages
! but may be I can recalculate it from sm for iwav, irad, itheta,
! ---> dump weights

      ENDIF

      RETURN

    END SUBROUTINE WRITEBIN

    SUBROUTINE EVALA(CXADIA,CXAOFF,CXALPH,CXALOF,MXN3,NAT)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!*** Arguments:
      INTEGER :: MXN3, NAT
      COMPLEX (WP) :: CXADIA(MXN3), CXALOF(MXN3), CXALPH(MXN3), CXAOFF(MXN3)

!*** Local variables:
      INTEGER :: J1, J2, J3
      COMPLEX (WP) :: CX1, CX2, CX3, DENOM

!*********************************************************************
! Subroutine EVALA
! Purpose: to evaluate 3x3 ***diagonal*** blocks of matrix A for use in
! discrete-dipole scattering calculation.

! Given:   CXALPH(J,1-3)=(alpha_11,alpha_22,alpha_33) where alpha=
!                         complex polarizability tensor
!                         of dipole J (J=1-NAT, first 3*NAT elements
!                         of CXALPH used)
!          CXALOF(J,1-3)=(alpha_23,alpha_31,alpha_12) for dipole J
!                        (J=1-NAT, first 3*NAT elements of CXALOF used)
!          NAT=number of dipoles
!          MXN3,MXNAT=dimensioning information

! Returns: CXADIAG(1-3*NAT)=diagonal elements of matrix A
!          CXAOFF(J,1-3)=(a_23,a_31,a_12) where a_ij=3x3 matrix
!                        equal to inverse of 3x3 matrix alpha_ij
!                        for dipole J (first 3*NAT elements of CXAOFF
!                        are used)

! Note that it is assumed that vectors E and P will have data
! in order E_1x,E_2x,...,E_Nx,E_1y,E_2y,...,E_Ny,E_1z,E_2z,...,E_Nz

! B. T. Draine, Princeton Univ. Obs., 87.01.07
! History:
! 88.05.05 (BTD): Modifications...
! 90.11.06 (BTD): Modified to pass array dimensions
! 97.12.25 (BTD): Added CXAOFF,CXALOF to argument list
!                 Modified to allow nondiagonal polarizabilities
!                 alpha_ij
! 98.01.01 (BTD): Correct inconsistency in assumed data ordering.

! End history
! Copyright (C) 1993,1997,1998 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!***********************************************************************
! Given symmetric matrix m with six independent elements a1, a2, a3, b1,
! b2, b3 (see below), we seek inverse matrix M with six independent
! elements A1, A2, A3, B1, B2, B3 such that

!      (a1 b3 b2)   (A1 B3 B2)   (1 0 0)
!      (b3 a2 b1) x (B3 A2 B1) = (0 1 0)
!      (b2 b1 a3)   (B2 B1 A3)   (0 0 1)

! solution:
!                     a2*a3 - b1*b1
! A1 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!                     a3*a1 - b2*b2
! A2 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!                     a1*a2 - b3*b3
! A3 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!                     b2*b3 - a1*b1
! B1 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!                     b3*b1 - a2*b2
! B2 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!                     b1*b2 - a3*b3
! B3 = ----------------------------------------------
!      a1*a2*a3+2*b1*b2*b3-a1*b1**2-a2*b2**2-a3*b3**2

!***********************************************************************

!*** diagnostic
!      write(0,*)'entered evala...'
!***

      DO J1=1,NAT
         J2=J1+NAT
         J3=J2+NAT
         CX1=CXALOF(J1)**2
         CX2=CXALOF(J2)**2
         CX3=CXALOF(J3)**2
         DENOM=CXALPH(J1)*CXALPH(J2)*CXALPH(J3)+          &
               2._WP*CXALOF(J1)*CXALOF(J2)*CXALOF(J3)-    &
               CXALPH(J1)*CX1-CXALPH(J2)*CX2-CXALPH(J3)*CX3
         CXADIA(J1)=(CXALPH(J2)*CXALPH(J3)-CX1)/DENOM
         CXADIA(J2)=(CXALPH(J3)*CXALPH(J1)-CX2)/DENOM
         CXADIA(J3)=(CXALPH(J1)*CXALPH(J2)-CX3)/DENOM
         CXAOFF(J1)=(CXALOF(J2)*CXALOF(J3)-CXALPH(J1)*CXALOF(J1))/DENOM
         CXAOFF(J2)=(CXALOF(J3)*CXALOF(J1)-CXALPH(J2)*CXALOF(J2))/DENOM
         CXAOFF(J3)=(CXALOF(J1)*CXALOF(J2)-CXALPH(J3)*CXALOF(J3))/DENOM
      ENDDO
!*** diagnostic
!      write(0,*)'in evala, about to return'
!***
      RETURN

    END SUBROUTINE EVALA

    SUBROUTINE ORIENT(BETAMI,BETAMX,THETMI,THETMX,PHIMIN,PHIMAX,MXBETA,MXTHET, &
        MXPHI,NBETA,NTHETA,NPHI,BETA,THETA,PHI,WGTA,WGTB)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
! Arguments:
      INTEGER :: MXBETA, MXTHET, MXPHI, NBETA, NTHETA, NPHI
      REAL (WP) :: BETAMI, BETAMX, THETMI, THETMX, PHIMIN, PHIMAX
      REAL (WP) :: BETA(MXBETA), THETA(MXTHET), PHI(MXPHI), &
        WGTA(MXTHET,MXPHI), WGTB(MXBETA)
! Local variables:
      INTEGER :: I, J
      REAL (WP) :: DELTA, WG
!***********************************************************************
! Given:
!        BETAMI=minimum value of beta (radians)
!        BETAMX=maximum value of beta (radians)
!        THETMI=minimum value of theta (radians)
!        THETMX=maximum value of theta (radians)
!        PHIMIN=minimum value of phi (radians)
!        PHIMAX=maximum value of phi (radians)
!        MXBETA,MXTHET,MXPHI=parameters for dimensioning of arrays
!                             BETA,THETA,PHI
!        NBETA=desired number of values of beta
!        NTHETA=desired number of values of theta
!        NPHI=desired number of values of PHI
! Returns:
!        BETA(1-NBETA)=beta values (radians)
!        THETA(1-NTHETA)=theta values (radians)
!        PHI(1-NPHI)=phi values (radians)
!        WGTA(1-NTHETA,1-NPHI)=weighting of each orientation of target
!                              axis a1 in Lab Frame
!                              (sum of weights = 1)
!        WGTB(1-NBETA)=weighting of each rotation of target around a1
!                              (sum of weights = 1)
!            Note: it is assumed that target orientation weight function
!                  can be factored into WGTA*WGTB -- i.e., that rotation
!                  around a1 are decoupled from orientation of a1.

! Purpose: to generate list of desired target orientations

! Definitions: beta=angle of rotation of target around target axis a1
!                   (beta=0 is defined to be such that a2 lies in a1-x
!                    plane, with a2 in direction of increasing theta)
!              theta=angle between target axis a1 and x axis
!                   (0.le.theta.le.pi)
!              phi=angle of rotation of axis a1 around axis
!              (phi=0 is defined to be such that a1 lies in xy plane)
! Present version assumes:
!        beta to be uniformly distributed between BETAMI and BETAMX
!        cos(theta) to be uniformly distributed between cos(THETMI) and
!                   cos(THETMX)
!        phi to be uniformly distributed between PHIMIN and PHIMAX

! Values assigned to BETA and PHI are midpoints of uniform intervals in
! beta and phi
! Note that if NBETA=1, BETA is set to midpoint of range in phi
! Likewise, if NPHI=1, PHI is set to midpoint of range in phi

! If NTHETA=1: specify a single value of THETA
!        cos(theta)=0.5*(cos(thetami)+cos(thetamx))

! If NTHETA>1:
!    If NTHETA is even:
!       divide range of cos(theta) into NTHETA equal intervals
!       set THETA to midpoints of these intervals
!       give intervals equal weights
!    If NTHETA is odd:
!       divide range of cos(theta) into NTHETA-1 equal intervals
!       set THETA to endpoints of these intervals; first value of
!       THETA is THETAMI and last value of THETA is THETAMX

! Note: values chosen for beta, phi are at midpoints of
!        uniform intervals

! B.T.Draine, Princeton Univ. Obs., 89.11.20
! History:
! 92.04.01 (BTD) Modify to allow Simpson's rule or trapezoidal rule
!                for integration over cos(theta).
! 99.03.01 (BTD) Modified to properly assign THETA values when NPHI>1
!                Code up to this time was not consistent with
!                description in UserGuide.  This problem was brought
!                to my attention by Miroslav Kocifaj
!                (Miroslav.Kocifaj@swh.sk).
! 99.03.05 (BTD) Corrected errors in assignment of THETA values.
!                Thanks to Miroslav Kocifaj for detecting these.
! 99.04.30 (BTD) Corrected errors in assignment of BETA and
!                PHI values when BETAMI.ne.0 or PHIMIN.ne.0
!                These errors (inadvertent omission of BETAMI and
!                PHIMIN from expressions assigning BETA(J) and PHI(J))
!                were introduced in 99.03.05 revision.
!                Thanks to Henriette Lemke for calling attention to
!                these errors.
! Copyright (C) 1993,1999 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Assign values to BETA:

      DELTA = (BETAMX-BETAMI)/REAL(NBETA,KIND=WP)
      DO J = 1, NBETA
        BETA(J) = BETAMI + DELTA*(REAL(J,KIND=WP)-0.5_WP)
      END DO

! Assign values to THETA:

      IF (NTHETA==2*(NTHETA/2)) THEN

! THETA is even:

        DELTA = (COS(THETMX)-COS(THETMI))/REAL(NTHETA,KIND=WP)
        DO J = 1, NTHETA
          THETA(J) = ACOS(COS(THETMI)+DELTA*(REAL(J,KIND=WP)-0.5_WP))
        END DO
      ELSE

! THETA is odd:

        IF (NTHETA==1) THEN
          THETA(1) = ACOS(0.5_WP*(COS(THETMI)+COS(THETMX)))
        ELSE
          DELTA = (COS(THETMX)-COS(THETMI))/REAL(NTHETA-1,KIND=WP)
          THETA(1) = THETMI
          THETA(NTHETA) = THETMX
          DO J = 2, NTHETA - 1
            THETA(J) = ACOS(COS(THETMI)+DELTA*REAL(J-1,KIND=WP))
          END DO
        END IF
      END IF

! Assign values to PHI:

      DELTA = (PHIMAX-PHIMIN)/REAL(NPHI,KIND=WP)
      DO J = 1, NPHI
        PHI(J) = PHIMIN + DELTA*(REAL(J,KIND=WP)-0.5_WP)
      END DO

!** Specify weight factors WGTA, WGTB
!   (Note: weight function WGTA = 4*pi*P/(NTHETA*NPHI), where
!    P=(probability/solid angle) of orientation in direction THETA,PHI .
!    The orientational averaging program automatically samples uniformly
!    in cos(theta) to allow for d(solid angle)=sin(theta)d(theta)d(phi).

!   Present version assumes random orientations.

!   When NTHETA is >1 and even, we use trapezoidal integration
!   When NTHETA is >1 and odd, we use Simpson's rule integration.

      IF (NTHETA==1 .OR. NTHETA==2*(NTHETA/2)) THEN

! either 1 or even number of theta values: midpoints of intervals

        WG = 1._WP/REAL(NTHETA*NPHI,KIND=WP)
        DO J = 1, NPHI
          DO I = 1, NTHETA
            WGTA(I,J) = WG
          END DO
        END DO
      ELSE

! odd number >1 of theta values: use Simpson's rule weighting

        WG = 1._WP/REAL(3*(NTHETA-1)*NPHI,KIND=WP)
        DO J = 1, NPHI
          WGTA(1,J) = WG
          WGTA(NTHETA,J) = WG
        END DO
        WG = 4._WP/REAL(3*(NTHETA-1)*NPHI,KIND=WP)
        DO I = 2, NTHETA, 2
          DO J = 1, NPHI
            WGTA(I,J) = WG
          END DO
        END DO
        IF (NTHETA>=5) THEN
          WG = 2._WP/REAL(3*(NTHETA-1)*NPHI,KIND=WP)
          DO I = 3, NTHETA - 1, 2
            DO J = 1, NPHI
              WGTA(I,J) = WG
            END DO
          END DO
        END IF
      END IF

! Assign weights for rotation angle beta:

      WG = 1._WP/REAL(NBETA,KIND=WP)
      DO I = 1, NBETA
        WGTB(I) = WG
      END DO

      RETURN
    END SUBROUTINE ORIENT

    SUBROUTINE WRITEPOL(NRWORD,MXNAT,NX,NY,NZ,NAT0,IANISO,  &
                        ICOMP,IXYZ0,PYD,PZD,AKD,DX,X0,WAVE, &
                        BETADF,THETADF,PHIDF,CXE0,CXADIA,   &
                        CXAOFF,CXPOL,CFLPOL)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! arguments:

      INTEGER :: IANISO,MXNAT,NAT0,NRWORD
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::      &
         IXYZ0(NAT0,3)
      INTEGER :: NX,NY,NZ
      REAL(WP) :: PYD,PZD,WAVE
      REAL(WP) ::       &
         AKD(3),        &
         BETADF(NAT0),  &
         DX(3),         &
         PHIDF(NAT0),   &
         THETADF(NAT0), &
         X0(3)
      COMPLEX(WP) ::      &
         CXADIA(MXNAT,3), &
         CXAOFF(MXNAT,3), &
         CXE0(3),         &
         CXPOL(NAT0,3)
      CHARACTER :: CFLPOL*17

! local variables:

      INTEGER :: J,NA

!***********************************************************************
! subroutine WRITEPOL
! given:
!    NRWORD   = length (bytes) of real word [integer]
!    MXNAT    = dimensioning parameter
!    NX       = (1/d)*(maximum extent of target in x-direction) (TF)
!    NY       = (1/d)*(maximum extent of target in y-direction) (TF)
!    NZ       = (1/d)*(maximum extent of target in z-direction) (TF)
!    NAT0     = number of occupied dipole sites
!    IANISO   = 0 for isotropic materials
!               1 for anisotropic materials with optical axes aligned
!                 with Target Frame (i.e., DF=TF)
!               2 for general anisotropic material, with arbitrary
!                 orientation of DF at each site relative to TF
!    ICOMP(IA,JD)=composition of dipole # IA
!                 for principal axis JD=1,2,3 in "dielectric frame"
!                 where dielectric tensor is diagonalized
!    IXYZ0(IA,JD)=x/d,y/d,z/d for dipole # IA, JD=1-3
!                 where (x,y,z) are in Target Frame
!    PYD      = periodicity/d of target replication in y_TF direction
!             = 0 if no replication (single target)
!    PZD      = periodicity/d of target replication in z_TF direction
!             = 0 if no replication (single target)
!    AKD(1-3)=k_x*d,k_y*d,k_z*d where (k_x,k_y,k_z)=k in ambient medium
!             in Target Frame
!    DX(1-3)  = lattice spacing/d in x,y,z directions, with
!               DX(1)*DX(2)*DX(3)=1
!               normally have DX(1)=DX(2)=DX(3)=1
!    X0(1-3)  = location/(DX*d) in TF of lattice site IX=0,IY=0,IZ=0
!    WAVE     = wavelength in ambient medium (physical units)
!    CXE0(1-3)=E_x,E_y,E_z for incident wave in ambient medium
!              in Target Frame
!    CXADIA(3i-2) =alphainv_xx at location i in TF
!          (3i-1) =alphainv_yy at location i in TF
!          (3i)   =alphainv_zz at location i in TF
!          where alphainv = inverse of (complex polarizability tensor)/d
!    CXAOFF(3i-2) =alpha_yz=alphainv_zy at location i in TF
!          (3i-1) =alpha_zx=alphainv_xz at location i in TF
!          (3i)   =alpha_xy=alphainv_yx at location i in TF
!          where alphainv = inverse of (complex polarizability matrix/d^
!    CXPOL(i)        =P_x at location i in TF
!         (NAT0+i)   =P_y at location i
!         (2*NAT0+i) =P_z at location i
!    CFLPOL = filename

! writes NAT0,IXYZ,CXPOL to unformatted file CFLPOL

! Note: IXYZ0, CXPOL, CXADIA, CXAOFF are "reduced" arrays
!       IXYZ0 is produced by subroutine EXTEND
!       CXPOL is reduced by subroutine REDUCE called from GETFML

!       CXADIA is reduced by REDUCE called from GETFLM
!       CXAOFF is reduced by REDUCE called from GETFLM

!       where "reduced" arrays are limited to values for occupied sites

! Note: if IANISO=0 or 1: do not store BETADF,THETADF,PHIDF
!       if IANISO=2       do store BETADF,THETADF,PHIDF

! B.T. Draine, Princeton Univ. Observatory, 2006.04.08
! history
! 06.04.08 (BTD) first written
! 06.04.10 (BTD) revised
! 06.09.21 (BTD) add PYD,PZD, and DX to argument list and to output file
! 07.06.21 (BTD) modify for use with DDSCAT 7.0.2:
!                * add X0 to argument list
!                * add X0 to WRITE statement
! 07.09.11 (BTD) changed IXYZ from INTEGER*2 to INTEGER
! 08.01.12 (BTD) add WAVE to argument list
!                add WAVE to WRITE statement
! 08.01.13 (BTD) add NRWORD to argument list and to WRITE statement
! 08.01.17 (BTD) * add IANISO to argument list, 
!                * write IANISO to file
!                * use IANISO to determine whether BETADF,THETADF,PHIDF
!                  need to be written out
!                * addition cleanup
! 08.03.15 (BTD) v7.0.5
!                * corrected error in dimensioning
!                  IXYZ0(MXNAT,3) -> IXYZ0(NAT0,3)
!                  BETADF(MXNAT) -> BETADF(NAT0)
!                  PHIDF(MXNAT) -> PHIDF(NAT0)
!                  THETADF(MXNAT) -> THETADF(NAT0)
! 08.05.21 (BTD) * CXPOL is reduced in DDSCAT before calling WRITEPOL:
!                  change dimensioning 
!                  CXPOL(MXNAT,3) -> CXPOL(NAT0,3)
!
! end history

! Copyright (C) 2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

      NA=NAT0
      OPEN(UNIT=22,FILE=CFLPOL,FORM='UNFORMATTED')
      WRITE(22)NRWORD,NAT0,IANISO
      WRITE(22)NX,NY,NZ,(IXYZ0(J,1),J=1,NA),(IXYZ0(J,2),J=1,NA),            &
               (IXYZ0(J,3),J=1,NA),PYD,PZD,AKD,DX,X0,WAVE,CXE0,             &
               (CXADIA(J,1),J=1,NA),(CXADIA(J,2),J=1,NA),                   &
               (CXADIA(J,3),J=1,NA),(CXAOFF(J,1),J=1,NA),                   &
               (CXAOFF(J,2),J=1,NA),(CXAOFF(J,3),J=1,NA),                   &
               (CXPOL(J,1),J=1,NA),(CXPOL(J,2),J=1,NA),(CXPOL(J,3),J=1,NA), &
               (ICOMP(J,1),J=1,NA),(ICOMP(J,2),J=1,NA),(ICOMP(J,3),J=1,NA)
      IF(IANISO==2)THEN
         WRITE(22)(BETADF(J),J=1,NA),(THETADF(J),J=1,NA),(PHIDF(J),J=1,NA)
      ENDIF
      CLOSE(22)
      RETURN
    END SUBROUTINE WRITEPOL

    SUBROUTINE TARRECREC(A1,A2,XV1,YV1,ZV1,XV2,YV2,ZV2,DX,X0, &
                         CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL(WP) :: XV1,YV1,ZV1,XV2,YV2,ZV2
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local variables:

      INTEGER :: JA,JX,JX1MAX,JX1MIN,JX2MAX,JX2MIN,JY,JY1MAX,JY1MIN,JY2MAX, &
         JY2MIN,JZ,JZ1MAX,JZ1MIN,JZ2MAX,JZ2MIN,NX1,NX2,NY1,NY2,NZ1,NZ2
      CHARACTER :: CMSGNM*70

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:

!***********************************************************************
! Routine to generate target consisting of rectangular block of
!        composition 1 resting on top of rectangular block of composition 2
! Input:
!        XV1=(x-length)/d  of block 1    (d=lattice spacing)
!        YV1=(y-length)/d           1
!        ZV1=(z-length)/d           1
!        XV2=(x-length)/d  of block 2
!        YV2=(y-length)/d  of block 2
!        ZV2=(z-length)/d  of block 2
!
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Fr
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Fr
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        X0(3)=(x,y,z)_TF corresponding to lattice site IXYZ=(0,0,0)
!
! B.T.Draine, Princeton Univ. Obs.
! History:
! 91.01.05 (BTD): Change I4 -> I7 when printing NAT.
! 91.04.22 (BTD): Added XV,YV,ZV and A1,A2 to WRITE(IOSHP,FMT=9020)
! 93.03.12 (BTD): Specified CDESCR*67, and now use it.
! 95.07.12 (BTD): Changed definition of axes A1,A2.  They used to be
!                 longest,next longest dimention.  They are now
!                 fixed to always be (1,0,0) and (0,1,0).
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(1-3) to argument list to support nonuniform
!                 lattice spacing.
! 98.02.11 (BTD): Modify to generate target on noncubic lattice.
! 00.11.02 (BTD): Add ICOMP to argument list, set ICOMP=1,
!                 write ICOMP to target.out
! 07.09.11 (BTD): changed IXYZ from INTEGER*2 to INTEGER
! 07.10.27 (BTD): created starting from TARREC as template
! 08.08.30 (BTD): modified format 9020
! end history

! Copyright (C) 1993,1995,1996,1997,1998,2000,2007
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      NX1=NINT(XV1/DX(1))
      NY1=NINT(YV1/DX(2))
      NZ1=NINT(ZV1/DX(3))
      NX2=NINT((XV1+XV2)/DX(1))
      NX2=NX2-NX1
      NY2=NINT(YV2/DX(2))
      NZ2=NINT(ZV2/DX(3))

      WRITE(CMSGNM,FMT='(A,3I4,A,3I4)')             &
            'Two rect.slabs NX1,NY1,NZ1=', &
            NX1,NY1,NZ1,' NX2,NYZ,NZ2=',NX2,NY2,NZ2
      WRITE(CDESCR,FMT='(A,3I4,A,3I4)')             &
            'Two rect.slabs NX1,NY1,NZ1=', &
            NX1,NY1,NZ1,' NX2,NYZ,NZ2=',NX2,NY2,NZ2

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in target frame
!             A2 will be (0,1,0) in target frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      END DO
      A1(1)=1._WP
      A2(2)=1._WP

! Bottom of upper box and top of lower box will be in x_TF=0 plane
!                 JX=0 corresponds to x_TF=dx/2
!     upper box:  JX runs from 0 to NX1-1 for material 1
!                 example: NX1=1, JX runs from 0 to 1
!     lower box:  JX runs from -NX2 to -1 for material 2
!                 example: NX2=2, JX runs from -2 to -1

! If NY1 is even, JY=0 corresponds to y_TF = -dy/2
!     upper box:  JY runs from 1-(NY1/2) to (NY1/2)
!                 example: NY1=2, JY runs from 0 to +1
!     lower box:  JY runs from 1-int(NY2/2) to NY2-int(NY2/2)
!                 example1: NY2=2, JY runs from 0 to 1
!                 example2: NY2=3, JY runs from 0 to 2

!    NY1 is  odd, JY=0 corresponds to y_TF=0
!     upper box:  JY runs from -(NY1-1)/2 to (NY1-1)/2
!                 example: NY1=3, JY runs from -1 to +1
!     lower box:  JY runs from -int[(NY2-1)/2] to NY2-1-int[(NY2-1)/2]

! If NZ1 is even, JZ=0 corresponds to z_TF = -dz/2
!     upper box:  JZ runs from 1-(NZ1/2) to (NZ1/2)
!     lower box:  JZ runs from 1-int(NZ2/2) to NZ2-int(NZ2/2)

!    NZ1 is odd,  JZ=0 corresponds to z_TF=0
!     upper box:  JZ runs from -(NZ1-1)/2 to (NZ1-1)/2
!     lower box:  JZ runs from -int[(NZ2-1)/2] to NZ2-1-int[(NZ2-1)/2]

      X0(1)=0.5_WP
      JX1MIN=0
      JX1MAX=NX1-1
      JX2MIN=-NX2
      JX2MAX=-1
      IF(MOD(NY1,2)==0)THEN ! NY1 is even
         X0(2)=-0.5_WP
         JY1MIN=1-NY1/2
         JY1MAX=NY1/2
         JY2MIN=1-INT(NY2/2)
         JY2MAX=NY2-INT(NY2/2)
      ELSE                  ! NY1 is odd
         X0(2)=0.0_WP
         JY1MIN=-(NY1-1)/2
         JY1MIN=(NY1-1)/2
         JY2MIN=-INT((NY2-1)/2)
         JY2MIN=NY2-1-INT((NY2-1)/2)
      ENDIF

      IF(MOD(NZ1,2)==0)THEN ! NZ1 is even
         X0(3)=0.5_WP
         JZ1MIN=1-NZ1/2
         JZ1MAX=NZ1/2
         JZ2MIN=1-INT(NZ2/2)
         JZ2MAX=NZ2-INT(NZ2/2)
      ELSE                  ! NZ2 is odd
         X0(3)=0.0_WP
         JZ1MIN=-(NZ1-1)/2
         JZ1MAX=(NZ1-1)/2
         JZ2MIN=-INT(NZ2-1)/2
         JZ2MAX=NZ2-1-INT((NZ2-1)/2)
      ENDIF

! Now populate upper rectangular slab:

      NAT=0
      DO JZ=JZ1MIN,JZ1MAX
         DO JY=JY1MIN,JY1MAX
            DO JX=JX1MIN,JX1MAX
               NAT=NAT+1
               IF(NAT>MXNAT)THEN
                  CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ

! homogeneous, isotropic composition:

               ICOMP(NAT,1)=1
               ICOMP(NAT,2)=1
               ICOMP(NAT,3)=1
            ENDDO
         ENDDO
      ENDDO

! Lower rectangular slab

      DO JZ=JZ2MIN,JZ2MAX
         DO JY=JY2MIN,JY2MAX
            DO JX=JX2MIN,JX2MAX
               NAT=NAT+1
               IF(NAT>MXNAT)THEN
                  CALL ERRMSG('FATAL','TARREC',' NAT.GT.MXNAT')
               ENDIF
               IXYZ(NAT,1)=JX
               IXYZ(NAT,2)=JY
               IXYZ(NAT,3)=JZ

! homogeneous, isotropic composition:

               ICOMP(NAT,1)=2
               ICOMP(NAT,2)=2
               ICOMP(NAT,3)=2
            ENDDO
         ENDDO
      ENDDO
      WRITE(CMSGNM,FMT='(A,I7,A)')'Two rectangular solids with NAT=',NAT, &
                                  ' dipoles'
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)NX1,NY1,NZ1,NX2,NY2,NZ2,NAT,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARRECREC: two rectangular solids:',                 &
         ' NX1,NY1,NZ1=',3I4,' NX2,NY2,NZ2=',3I4,                    &
         I10,' = NAT=',/,                                            &
         3F10.6,' = A_1 vector',/,                                   &
         3F10.6,' = A_2 vector',/,                                   &
         3F10.5,' = lattice spacings (d_x,d_y,d_z)/d',/,             &
         3F10.5,' = x0(1-3)= (x_TF,y_TF,z_TF)/d for dipole 0 0 0',/, &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARRECREC

    SUBROUTINE READPOL(MODE,MXNAT,NX,NY,NZ,NAT0,IANISO,ICOMP,IXYZ0,PYD,PZD, &
                       AKD,DX,X0,WAVE,BETADF,THETADF,PHIDF,CXE0,CXADIA,     &
                       CXAOFF,CXPOL,CFLPOL)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! arguments:

      INTEGER :: IANISO,MODE,MXNAT,NAT0,NX,NY,NZ

      INTEGER*2 :: &
         ICOMP(MXNAT,3)
      INTEGER ::      &
         IXYZ0(MXNAT,3)

      REAL(WP) :: PYD,PZD,WAVE
      REAL(WP) ::        &
         AKD(3),         &
         BETADF(MXNAT),  &
         DX(3),          &
         PHIDF(MXNAT),   &
         THETADF(MXNAT), &
         X0(3)
      COMPLEX(WP) ::      &
         CXADIA(MXNAT,3), &
         CXAOFF(MXNAT,3), &
         CXE0(3),         &
         CXPOL(MXNAT,3)
      CHARACTER :: CFLPOL*80

! local variables:

      INTEGER :: J,NA,NRWORD

!***********************************************************************
! subroutine READPOL
! given:
!    CFLPOL= file name
!    MXNAT = dimensioning parameter

! when called with MODE=0:
! returns:
!    NAT0   = number of dipoles in target
!    NRWORD = real word length (byte)
!           = 4 if data was stored in single precision
!           = 8 if data was stored in double precision
!
! when called with MODE=1
! returns:
!    NAT0   = number of occupied dipole sites
!    NX     = (1/d)*(maximum extent of target in x-direction) (TF)
!    NY     = (1/d)*(maximum extent of target in y-direction) (TF)
!    NZ     = (1/d)*(maximum extent of target in z-direction) (TF)
!    IXYZ0(IA,JD)=x/(d*DX(1)),y/(d*DX(2)),z/(d*DX(3))
!                 for dipole # IA, JD=1-3
!                 where (x,y,z) are in Target Frame
!    DX(1-3) =lattice spacing/d in x,y,z directions
!            =(1,1,1) for cubic lattice
!    X0(1-3) = vector specifying location (x,y,z) in TF of
!              lattice site (0,0,0):
!              X0(1)=x/(d*DX(1))
!              X0(2)=y/(d*DX(2))
!              X0(3)=z/(d*DX(3))
!    PYD     = periodicity/d of target replication in y_TF direction
!            = 0 if no replication in y direction
!    PZD     = periodicity/d of target replication in z_TF direction
!            = 0 if no replication in z direction
!    AKD(1-3)=k_x*d,k_y*d,k_z*d where (k_x,k_y,k_z)=k in ambient medium
!             in Target Frame
!    WAVE  = wavelength in ambient medium (physical units)
!    CXE0(1-3)=E_x,E_y,E_z for incident wave in ambient medium
!              in Target Frame
!    CXADIA(3i-2) =alphainv_xx at location i in TF
!          (3i-1) =alphainv_yy at location i in TF
!          (3i)   =alphainv_zz at location i in TF
!          where alphainv = inverse of (complex polarizability tensor)/d
!    CXAOFF(3i-2) =alphainv_zy at location i in TF
!          (3i-1) =alphainv_xz at location i in TF
!          (3i)   =alphainv_yx at location i in TF
!          where alphainv = inverse of (complex polarizability matrix/d^
!    CXPOL(i)        =P_x at location i in TF
!         (NAT0+i)   =P_y at location i
!         (2*NAT0+i) =P_z at location i

! Note: IXYZ0, CXPOL, CXADIA, CXAOFF are "reduced" arrays
!       IXYZ0 is produced by subroutine EXTEND
!       CXPOL is reduced by subroutine REDUCE called from GETFML

!       CXADIA is reduced by REDUCE called from GETFLM
!       CXAOFF is reduced by REDUCE called from GETFLM

!       where "reduced" arrays are limited to values for occupied sites

!       If one wishes to reconstitute "full" arrays

!       CXP(JX,JY,JZ,1-3)   polarization at (JX,JY,JZ)
!       CXAD(1-3,JX,JY,JZ)  diagonal elements of alphainv =
!                           inverse of polarizability
!                           tensor alpha/d^3 at (JX,JY,JZ)
!       CXAO(1-3,JX,JY,JZ)  off-diag elements yz,xz,xy of alphainv
!                           at (JX,JY,JZ)


!       one will need to add code like the following

!      COMPLEX
!     &   CXAD(3,NX,NY,NZ),
!     &   CXAO(3,NX,NY,NZ),
!     &   CXP(NX,NY,NZ,3)
!      DO JC=1,3
!         DO JZ=1,NZ
!            DO JY=1,NY
!               DO JX=1,NX
!                  CXP(JX,JY,JZ,JC)=0.
!                  CXAD(JC,JX,JY,JZ)=0.
!                  CXAO(JC,JX,JY,JZ)=0.
!               ENDDO
!            ENDDO
!         ENDDO
!      ENDDO
!      DO JA=1,NAT0
!         JX=IXYZ0(JA,1)
!         JY=IXYZ0(JA,2)
!         JZ=IXYZ0(JA,3)
!         DO JC=1,3
!            CXP(JX,JY,JZ,JC)=CXPOL(JA+(JC-1)*NAT0)
!            CXAD(JC,JX,JY,JZ)=CXADIA(3*(JA-1)+JC)
!            CXAO(JC,JX,JY,JZ)=CXAOFF(3*(JA-1)+JC)
!         ENDDO
!      ENDDO

! B.T. Draine, Princeton Univ. Observatory, 2006.04.08
! history
! 06.04.08 (BTD) first written
! 06.04.10 (BTD) revised
! 06.07.07 (BTD) revised comments
! 06.09.21 (BTD) add PYD,PZD,DX to argument list
!                add PYD,PZD,DX to list of variable read from input file
! 07.06.21 (BTD) modify to use X0(1-3) written out by DDSCAT v7.0.2
!                * add X0 to argument
!                * add X0 to READ statement
! 07.09.11 (BTD) changed IXYZ0 from INTEGER*2 to INTEGER
! 08.01.17 (BTD) * add IANISO to argument list
!                * read IANISO from file
!                * use IANISO to determine whether BETADF,THETADF,
!                  PHIDF need to be read from file; if IANISO<2 then
!                  set BETADF=0,THETADF=0,PHIDF=0
! end history

! Copyright (C) 2006,2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!*** diagnostic
      write(0,*)'entered readpol...'
      write(0,*)'cflpol=',cflpol
!***
      OPEN(UNIT=22,FILE=CFLPOL,FORM='UNFORMATTED')
!*** diagnostic
      write(0,*)'readpol ckpt alpha'
!***
      READ(22)NRWORD,NAT0,IANISO
!*** diagnostic
      write(0,*)'readpol ckpt beta'
!***
      IF(WP==KIND(0.E0).AND.NRWORD==8)THEN
         WRITE(0,*)'Fatal error in READPOL:'
         WRITE(0,*)'   DDfield was compiled in single precision,'
         WRITE(0,*)'   but ',CFLPOL,' contains double precision data'
         STOP
      ELSEIF(WP==KIND(0.D0).AND.NRWORD==4)THEN
         WRITE(0,*)'Fatal error in READPOL:'
         WRITE(0,*)'   DDfield was compiled in double precision,'
         WRITE(0,*)'   but ',CFLPOL,' contains single precision data'
         STOP
      ENDIF
      IF(MODE==0)THEN
         CLOSE(22)
         RETURN
      ENDIF

!*** sanity check

      IF(NAT0>MXNAT)THEN
         WRITE(0,*)'Fatal error in READPOL:'
         WRITE(0,*)'   attempting to read file, but NAT0 > MXNAT'
         CLOSE(22)
         STOP
      ENDIF

!*** diagnostic
      write(0,*)'readpol ckpt gamma'
!***
      NA=NAT0
      READ(22)NX,NY,NZ,(IXYZ0(J,1),J=1,NA),(IXYZ0(J,2),J=1,NA),            &
              (IXYZ0(J,3),J=1,NA),PYD,PZD,AKD,DX,X0,WAVE,CXE0,             &
              (CXADIA(J,1),J=1,NA),(CXADIA(J,2),J=1,NA),                   &
              (CXADIA(J,3),J=1,NA),(CXAOFF(J,1),J=1,NA),                   &
              (CXAOFF(J,2),J=1,NA),(CXAOFF(J,3),J=1,NA),                   &
              (CXPOL(J,1),J=1,NA),(CXPOL(J,2),J=1,NA),(CXPOL(J,3),J=1,NA), &
              (ICOMP(J,1),J=1,NA),(ICOMP(J,2),J=1,NA),(ICOMP(J,3),J=1,NA)
      IF(IANISO==2)THEN
         READ(22)(BETADF(J),J=1,NA),(THETADF(J),J=1,NA),(PHIDF(J),J=1,NA)
      ELSE
         DO J=1,NA
            BETADF(J)=0._WP
            THETADF(J)=0._WP
            PHIDF(J)=0._WP
         ENDDO
      ENDIF
      CLOSE(22)

      RETURN
    END SUBROUTINE READPOL

    SUBROUTINE PETR(X,B,WRK,LDA,IPAR,SPAR,MATVEC,CMATVEC)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
! solves Ax=b

! Input:
! B(LOCLEN) - RHS (doesn't change on output)
! WRK(LDA, LOCLEN) - scratch array
! IPAR - defines integer paramteres (see documentation of PIM)
! SPAR - define real parameters
! LDA - leading dimension of arrays
! MATVEC -- name of procedure for computing y=Ax
! CMATVEC -- name of procedure for computing y= conj(A') x

! Output:
! X(LOCLEN)

! Reference:
!    Petravic,M and Kuo-Petravic,G. 1979, JCP, 32,263
! History:
!    Late 80's  (Coded by Draine)
!    Changes to include "cprod" (PJF+BTD)
!    95.06.01 (PJF) re-written to conform to PIM
!    95.08.11 (BTD) minor editing (comments, etc.)
!    08.05.12 (BTD) change CDUMMY -> CDUMMY(1) following suggestion
!                   by Art Lazanoff, NASA Ames
! end history
!=======================================================================
! Parameters:
      INTEGER :: IACE,IAXI,IGI,IPI,IQI,IR
      PARAMETER (IACE=1,IGI=2,IPI=3,IQI=4,IAXI=5,IR=6)
! Arguments:
      INTEGER :: LDA
      INTEGER :: IPAR(*)
      REAL(WP) :: SPAR(*)
      COMPLEX(WP) :: B(*),WRK(LDA,*),X(*)
      EXTERNAL CMATVEC,MATVEC

! Local variables
      COMPLEX(WP) :: CDUMMY(1)
      INTEGER :: IDUMMY,ITNO,L,LOCLEN,MAXIT,STATUS
      REAL(WP) :: ALPHAI,BETAI1,BNORM,EPSILON,EXITNORM,GIGI, &
                  GI1GI1,QIQI,RHSSTOP
      REAL(WP) :: SCSETRHSSTOP
      EXTERNAL DUMMY,CDUMMY_1,PSCNRM2

!***********************************************************************
      LOCLEN=IPAR(4)
      MAXIT=IPAR(10)
      EPSILON=SPAR(1)

! Compute RHSSTOP=EPSILON*|B|

      RHSSTOP=SCSETRHSSTOP(B,CDUMMY,EPSILON,IPAR,CDUMMY_1,PSCNRM2)

! Compute conjg(A')*B

      CALL CMATVEC(B,WRK(1,IACE),IDUMMY)
      BNORM=0._WP
      DO L=1,LOCLEN
         BNORM=BNORM+REAL(B(L)*CONJG(B(L)))
         WRK(L,IGI)=WRK(L,IACE)
         WRK(L,IPI)=WRK(L,IGI)
      ENDDO

! Compute |QI>=A|PI>

      CALL MATVEC(WRK(1,IPI),WRK(1,IQI),IDUMMY)
      QIQI=0._WP
      GIGI=0._WP
      DO L=1,LOCLEN
         GIGI=GIGI+REAL(CONJG(WRK(L,IGI))*WRK(L,IGI))
         QIQI=QIQI+REAL(CONJG(WRK(L,IQI))*WRK(L,IQI))
      ENDDO
      ALPHAI=GIGI/QIQI
      DO L=1,LOCLEN
         X(L)=X(L)+ALPHAI*WRK(L,IPI)
      ENDDO

! compute |AX1>:

      CALL MATVEC(X,WRK(1,IAXI),IDUMMY)

      DO ITNO=2,MAXIT
         IPAR(11)=ITNO

! Transfer <GI|GI> -> <GI-1|GI-1>:

         GI1GI1=GIGI

! compute |GI>=AC|E>-AC|AXI>:

         CALL CMATVEC(WRK(1,IAXI),WRK(1,IGI),IDUMMY)

! Compute GIGI=<GI|GI>:
         GIGI=0._WP
         DO L=1,LOCLEN
            WRK(L,IGI)=WRK(L,IACE)-WRK(L,IGI)
         ENDDO
         DO L=1,LOCLEN
            GIGI=GIGI+REAL(CONJG(WRK(L,IGI))*WRK(L,IGI))
         ENDDO

! Compute BETAI-1=<GI|GI>/<GI-1|GI-1>:

         BETAI1=GIGI/GI1GI1

! Compute |PI>=|GI>+BETAI-1|PI-1>:

         DO L=1,LOCLEN
            WRK(L,IPI)=WRK(L,IGI)+BETAI1*WRK(L,IPI)
         ENDDO

! Compute |QI>=A|PI>:

         CALL MATVEC(WRK(1,IPI),WRK(1,IQI),IDUMMY)

! Compute <QI|QI>:

         QIQI=0._WP
         DO L=1,LOCLEN
            QIQI=QIQI+REAL(CONJG(WRK(L,IQI))*WRK(L,IQI))
         ENDDO

! Compute ALPHAI=<GI|GI>/<QI|QI>:

         ALPHAI=GIGI/QIQI

! Compute |XI+1>=|XI>+ALPHAI*|PI>:

         DO L=1,LOCLEN
            X(L)=X(L)+ALPHAI*WRK(L,IPI)
         ENDDO

! Except every 10TH iteration, compute |AXI+1>=|AXI>+ALPHAI*|QI>
! Draine: warning this part perhaps not checked

         IF(ITNO/=10*(ITNO/10))THEN
            DO L=1,LOCLEN
               WRK(L,IAXI)=WRK(L,IAXI)+ALPHAI*WRK(L,IQI)
            ENDDO
         ELSE
            CALL MATVEC(X,WRK(1,IAXI),IDUMMY)
         ENDIF

! Compute residual vector |RI>=A|XI>-|B>

         DO L=1,LOCLEN
            WRK(L,IR)=WRK(L,IAXI)-B(L)
         ENDDO

! Call STOPCRIT to check whether to terminate iteration.
! Criterion: terminate if <RI|RI> < TOL**2 * <B|B>
! Return with STATUS=0 if this condition is satisfied.

         CALL STOPCRIT(B,WRK(1,IR),CDUMMY,CDUMMY,CDUMMY,WRK,RHSSTOP,IDUMMY, &
                       EXITNORM,STATUS,IPAR,DUMMY,DUMMY,DUMMY,DUMMY,PSCNRM2)

! Call PROGRESS to report "error" = sqrt(<RI|RI>)/sqrt(<B|B>)

         CALL PROGRESS(LOCLEN,ITNO,EXITNORM,CDUMMY,CDUMMY,CDUMMY)

         IF(STATUS==0)GOTO 500
      ENDDO
500   CONTINUE
      IPAR(12)=0
      RETURN
    END SUBROUTINE PETR

    SUBROUTINE TARLYRSLAB(A1,A2,XV,YV,ZV,F1,F2,F3,F4,DX,X0,CDESCR,IOSHP, &
                          MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
! Arguments:
      REAL(WP) :: F1,F2,F3,F4,XV,YV,ZV
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local variables:

      INTEGER :: IC,JA,JD,JX,JY,JZ,NCOMP,NX,NX1,NX2,NX3,NY,NZ
      CHARACTER :: CMSGNM*70

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:

      INTEGER :: NINT
      INTRINSIC NINT

!***********************************************************************
! Routine to construct rectangular prism from "atoms"
! with layered structure
! slab has dimension XV*d in x direction
!                    YV*d   in y direction
!                    ZV*d   in z direction
!
! current version allows for up to 4 layers
! slab is layered in x direction
! top surface has x=0
! x0(1-3) = point at center of top surface

!      0       > x > -f1*a is composition 1
!   -f1*a      > x > -(f2+f1)*a is composition 2
! -(f2+f1)*a   > x > -(1-f4)*a is composition 3
!   -f4*a      > x >  -a   is composition 4

! for 1 layers, let f2=f3=f4=0
!     2             f3=f4=0
!     3             f4=0

! It is required that f1+f2+f3+f4=1.

! Input:
!        XV=(x-length)/d    (d=lattice spacing)
!        YV=(y-length)/d    (d=lattice spacing)
!        ZV=(z-length)/d    (d=lattice spacing)
!        F1,F2,F3,F4 = fraction of thickness contributed by compositions
!                      1,2,3,4
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Fr
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Fr
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=composition
!        X0(3)=location/d in TF of lattice site with IXYZ=(0,0,0)

! B.T.Draine, Princeton Univ. Obs.
! History:
! 07.02.23 (BTD): Created using TARSLB as starting point
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.03.16 (BTD): Correct handling of NY>1, NZ>1
! 08.08.29 (BTD): Modified format 9020
! end history

! Copyright (C) 2007 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Sanity check:
      IF(ABS(F1+F2+F3+F4-1._WP)>1.E-6_WP)THEN
         WRITE(0,*)'F1,F2,F3,F4=',F1,F2,F3,F4
         CALL ERRMSG('FATAL','TARLYRPBC',' F1+F2+F3+F4.ne.1')
      ENDIF
      IF(F1<0.OR.F2<0.OR.F3<0.OR.F4<0._WP)THEN
         CALL ERRMSG('FATAL','TARLYRPBC',' one or more F are negative')
      ENDIF
      IF(F4==0._WP)NCOMP=3
      IF(F3==0._WP)NCOMP=2
      IF(F2==0._WP)NCOMP=1

      NX=NINT(XV/DX(1))
      NY=NINT(YV/DX(2))
      NZ=NINT(ZV/DX(3))

      WRITE(CMSGNM,FMT='(A,3I4)')' Layered slab; NX,NY,NZ=',NX,NY,NZ
      WRITE(CDESCR,FMT='(A,3I4)')' Layered slab; NX,NY,NZ=',NX,NY,NZ

      NX1=NINT(F1*NX)
      IF(NCOMP>=2)NX2=NINT((F1+F2)*NX)
      IF(NCOMP>=3)NX3=NINT((F1+F2+F3)*NX)

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in target frame
!             A2 will be (0,1,0) in target frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      ENDDO

      A1(1)=1._WP
      A2(2)=1._WP

      NAT=NX*NY*NZ
      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARSLB',' NAT.GT.MXNAT')
      ENDIF

! Now populate lattice:
! Top of lattice (in TF) consists of composition 1
! as we descend in x (in TF) we pass through compositions 2,3,4
! Top layer will have JX=-1
! Lowest layer will have JX=-NX

! Specify X0(3) = (x,y,z)/d in TF corresponding to IXYZ=(0,0,0)
! Top surface of slab (0.5d above topmost dipole layer) is assumed to have x=0
! Dipoles with JX=-1 are assumed to be at x=-dx/2
! Therefore X0(1)=0.5*DX(1)
! Set y=0 and z=0 to be at middle of slab
! JY runs from 1 to NY -> X0(2) = -(1+NY)/2
! JZ runs from 1 to NZ -> X0(3) = -(1+NZ)/2

      X0(1)=0.5*DX(1)
      X0(2)=-0.5*REAL(1+NY)
      X0(3)=-0.5*REAL(1+NZ)

      JA=0
      DO JX=-1,-NX,-1
         IF(JX.LE.NX1)IC=1
         IF(NCOMP>=2.AND.JX.GT.NX1.AND.JX.LE.NX2)IC=2
         IF(NCOMP>=3.AND.JX.GT.NX2.AND.JX.LE.NX3)IC=3
         IF(NCOMP>=4.AND.JX.GT.NX3)IC=4
         DO JY=1,NY
            DO JZ=1,NZ
               JA=JA+1
               IXYZ(JA,1)=JX
               IXYZ(JA,2)=JY
               IXYZ(JA,3)=JZ
               DO JD=1,3
                  ICOMP(JA,JD)=IC
               ENDDO
            ENDDO
         ENDDO
      ENDDO

      WRITE(CMSGNM,FMT='(A,I7,A)') '  Total slab thickness =',NAT,' dipoles'
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XV,YV,ZV,NAT,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

      RETURN
9020  FORMAT (' >TARREC   rectangular prism; AX,AY,AZ=',3F8.4,/,   &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT (I7,3I4,3I2)
    END SUBROUTINE TARLYRSLAB

!----------- cgcommon package ------------------------------------------
! these routines are required for use by the conjugate gradient machiner
! history
! 03.01.28 (BTD) moved routines CAXPY and CSWAP to blas.f package of
!                basic linear algebra subroutines
! end history
!-----------------------------------------------------------------------

    FUNCTION SCSETRHSSTOP(B,WRK,EPSILON,IPAR,PRECONL,PSCNRM)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE
      REAL (WP) :: SCSETRHSSTOP

!     .. Scalar Arguments ..
      REAL (WP) :: EPSILON
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), WRK(*)
      INTEGER :: IPAR(*)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL PRECONL
!     ..
!     .. Local Scalars ..
      INTEGER :: LOCLEN, STOPTYPE
!     ..
      LOCLEN = IPAR(4)
      STOPTYPE = IPAR(9)
      IF ((STOPTYPE==1) .OR. (STOPTYPE==4) .OR. (STOPTYPE==7)) THEN
!  ||r||<epsilon or ||Q1r||<epsilon ||x(k)-x(k-1)||<epsilon
        SCSETRHSSTOP = EPSILON

      ELSE IF ((STOPTYPE==2) .OR. (STOPTYPE==3) .OR. (STOPTYPE==5)) THEN
!  ||r||<epsilon||b|| or sqrt(r(Q1r))<epsilon||b|| or
!  ||Q1r||<epsilon||b||
        SCSETRHSSTOP = EPSILON*PSCNRM(LOCLEN,B)

      ELSE IF (STOPTYPE==6) THEN
!  ||Q1r||<epsilon||Q1b||
        CALL PRECONL(B,WRK,IPAR)
        SCSETRHSSTOP = EPSILON*PSCNRM(LOCLEN,WRK)
      END IF

      RETURN

    END FUNCTION SCSETRHSSTOP
    SUBROUTINE STOPCRIT(B,R,RTRUE,X,XOLD,WRK,RHSSTOP,CNVRTX,EXITNORM,STATUS, &
        IPAR,MATVEC,TMATVEC,PRECONR,PCSUM,PSCNRM)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

!     .. Scalar Arguments ..
      REAL (WP) :: EXITNORM, RHSSTOP
      INTEGER :: CNVRTX, STATUS
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: B(*), R(*), RTRUE(*), WRK(*), X(*), XOLD(*)
      INTEGER :: IPAR(*)
!     ..
!     .. Function Arguments ..
      REAL (WP) :: PSCNRM
      EXTERNAL PSCNRM
!     ..
!     .. Subroutine Arguments ..
      EXTERNAL MATVEC, PCSUM, PRECONR, TMATVEC
!     ..
!     .. Local Scalars ..
      INTEGER :: LOCLEN, PRECONTYPE, STOPTYPE
!     ..
!     .. Local Arrays ..
      COMPLEX (WP) :: DOTS(1)
!     ..
!     .. External Functions ..
! 98.04.27 BTD: CDOTC is defined as a complex function!
! 98.12.03 (BTD) this error also pointed out by Rodolphe Vaillon
!      REAL CDOTC
      COMPLEX (WP) :: CDOTC
!------------------------------------------------
      EXTERNAL CDOTC
!     ..
!     .. External Subroutines ..
      EXTERNAL CAXPY, CCOPY
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
!     ..
!     .. Parameters ..
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0E0_WP,0.0E0_WP))
!     ..
      LOCLEN = IPAR(4)
      PRECONTYPE = IPAR(8)
      STOPTYPE = IPAR(9)

      IF ((STOPTYPE==1) .OR. (STOPTYPE==2) .OR. (STOPTYPE==3)) THEN

!  Compute true residual if needed
        CALL CCOPY(LOCLEN,B,1,RTRUE,1)

        IF ((PRECONTYPE==2) .OR. (PRECONTYPE==3)) THEN
          CALL PRECONR(X,WRK,IPAR)
          IF (CNVRTX==1) THEN
            CALL TMATVEC(WRK,XOLD,IPAR)
            CALL MATVEC(XOLD,WRK,IPAR)
            CALL CAXPY(LOCLEN,-CONE,WRK,1,RTRUE,1)
          ELSE
            CALL MATVEC(WRK,XOLD,IPAR)
            CALL CAXPY(LOCLEN,-CONE,XOLD,1,RTRUE,1)
          END IF
        ELSE IF (CNVRTX==1) THEN
          CALL TMATVEC(X,XOLD,IPAR)
          CALL MATVEC(XOLD,WRK,IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK,1,RTRUE,1)
        ELSE
          CALL MATVEC(X,WRK,IPAR)
          CALL CAXPY(LOCLEN,-CONE,WRK,1,RTRUE,1)
        END IF
      END IF

      IF ((STOPTYPE==1) .OR. (STOPTYPE==2)) THEN

!  ||r|| < epsilon or ||r|| < epsilon ||b||

        EXITNORM = PSCNRM(LOCLEN,RTRUE)
        IF (EXITNORM<RHSSTOP) THEN
          STATUS = 0
        ELSE
          STATUS = -99
        END IF

      ELSE IF (STOPTYPE==3) THEN

!  sqrt(r(Q1r))<epsilon||b||

! BTD 98.04.27 CDOTC is defined as a complex function!
!          DOTS(1) = CDOTC(LOCLEN,RTRUE,1,R,1)

        DOTS(1) = REAL(CDOTC(LOCLEN,RTRUE,1,R,1))
        CALL PCSUM(1,DOTS(1))

        EXITNORM = ABS(SQRT(DOTS(1)))
        IF (EXITNORM<RHSSTOP) THEN
          STATUS = 0
        ELSE
          STATUS = -99
        END IF

      ELSE IF ((STOPTYPE==4) .OR. (STOPTYPE==5) .OR. (STOPTYPE==6)) THEN

!  ||Q1r|| < epsilon or ||Q1r|| < epsilon||b|| or ||Q1r|| < epsilon||Q1b

        EXITNORM = PSCNRM(LOCLEN,R)
        IF (EXITNORM<RHSSTOP) THEN
          STATUS = 0
        ELSE
          STATUS = -99
        END IF

      ELSE IF (STOPTYPE==7) THEN

!  ||x-x0||<epsilon
        CALL CCOPY(LOCLEN,X,1,WRK,1)
        CALL CAXPY(LOCLEN,-CONE,XOLD,1,WRK,1)
        EXITNORM = PSCNRM(LOCLEN,WRK)
        IF (EXITNORM<RHSSTOP) THEN
          STATUS = 0
        ELSE
          STATUS = -99
        END IF
      END IF

      RETURN

    END SUBROUTINE STOPCRIT

    SUBROUTINE PROGRESS(LOCLEN,ITNO,NORMRES,X,RES,TRUERES)
      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_9,ONLY : ERRSCAL,IDVOUT2,ITERMX,ITERN
      IMPLICIT NONE

! Arguments:
      REAL (WP) :: NORMRES
      INTEGER :: ITNO, LOCLEN
      COMPLEX (WP) :: RES(*), TRUERES(*), X(*)

! Common:
!      INTEGER :: IDVOUT2, ITERMX, ITERN
!      REAL (WP) :: ERRSCAL
!-----------------------------------------------------------------------
!      COMMON /NORMERR/ERRSCAL, IDVOUT2, ITERMX, ITERN
!-----------------------------------------------------------------------

! Local:
      INTEGER :: ITNOL
      REAL (WP) :: ERRMIN, NORMERR, RATE
      SAVE ERRMIN, ITNOL

! part of PIM
! history
! 95.08.14 (BTD): modified to include COMMON/NORMERR/ERRSCAL to allow
!                 desired normalization of error.
! 96.11.21 (BTD): added IDVOUT2 to COMMON/NORMERR/ to allow passing
!                 of device number for standard output (so that it
!                 doesn't need to be hardwired here).
! 98.10.08 (BTD): modified to keep track of minimum error, and to
!                 note when new error minimum is attained.  This is
!                 to observe convergence behavior of PBCGST.
! 98.10.26 (BTD): modified to PROGRESS to also print information on
!                 rate of convergence (variable RATE).
! 03.04.13 (BTD): added ITERMX and ITERN to COMMON/NORMERR/
!                 to communicate number of iterations and max number
!                 of iterations allowed.
! 07.08.04 (BTD): DDSCAT Version 7.0.3
!                 Replaced COMMON/NORMERR/ with USE MODULE DDCOMMON_9
! end history

! Note: when used with STOPTYPE=5, NORMRES=|Ax-b|.
! If quantity ERRSCAL is set to |b| elsewhere, then NORMRES/ERRSCAL
! is a measure of the fractional error in the solution vector x.

      ITERN = ITNO
      NORMERR = NORMRES/ERRSCAL
      IF (ITNO<=2) THEN
        ERRMIN = NORMERR
        ITNOL = ITNO
        WRITE (IDVOUT2,FMT=9000) ITNO, NORMERR
      ELSE
        IF (NORMERR<ERRMIN) THEN
          RATE = LOG(ERRMIN/NORMERR)/(ITNO-ITNOL)
          ERRMIN = NORMERR
          ITNOL = ITNO
          WRITE (IDVOUT2,FMT=9001) ITNO, NORMERR, ERRMIN, RATE
        ELSE
          WRITE (IDVOUT2,FMT=9000) ITNO, NORMERR
        END IF
      END IF
!*** btd 98.12.07 experiment
      RETURN
9000  FORMAT (1X,'iter= ',I4,' frac.err= ',0P,F11.7)
9001  FORMAT (1X,'iter= ',I4,' frac.err= ',0P,F11.7,' min.err=',0P,F11.7, &
        ' rate=',0P,F8.6)
    END SUBROUTINE PROGRESS

    SUBROUTINE CVPROD(N,CX,INCX,CY,INCY)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE

!     Modified from saxpy level 1 BLAS
!     element-wise vector multiplication, y<-x*y
!     Rudnei Dias da Cunha, 16/6/93

!     constant times a vector plus a vector.
!     uses unrolled loops for increments equal to one.
!     jack dongarra, linpack, 3/11/78.


!     .. Scalar Arguments ..
      INTEGER :: INCX, INCY, N
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: CX(*), CY(*)
!     ..
!     .. Local Scalars ..
      INTEGER :: I, IX, IY, M, MP1
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC MOD
!     ..
      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      IF (INCY<0) IY = (-N+1)*INCY + 1
      DO I = 1, N
        CY(IY) = CY(IY)*CX(IX)
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

!        code for both increments equal to 1


!        clean-up loop

20    M = MOD(N,4)
      IF (M==0) GO TO 40
      DO I = 1, M
        CY(I) = CY(I)*CX(I)
      END DO
      IF (N<4) RETURN
40    MP1 = M + 1
      DO I = MP1, N, 4
        CY(I) = CY(I)*CX(I)
        CY(I+1) = CY(I+1)*CX(I+1)
        CY(I+2) = CY(I+2)*CX(I+2)
        CY(I+3) = CY(I+3)*CX(I+3)
      END DO
      RETURN

    END SUBROUTINE CVPROD
    SUBROUTINE PRINTV(N,U)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE
!     .. Scalar Arguments ..
      INTEGER :: N
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: U(*)
!     ..
!     .. Local Scalars ..
      INTEGER :: I
!     ..
      WRITE (6,FMT=9000) (U(I),I=1,N)
      RETURN
9000  FORMAT (8(E14.8,1X))
    END SUBROUTINE PRINTV

    SUBROUTINE CINIT(N,ALPHA,CX,INCX)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE

!     Initialises a vector x with a scalar alpha.
!     Modified from scopy, BLAS Level 1.
!     Rudnei Dias da Cunha, 14/6/93.


!     copies a vector, x, to a vector, y.
!     uses unrolled loops for increments equal to one.
!     jack dongarra, linpack, 3/11/78.


!     .. Scalar Arguments ..
      COMPLEX (WP) :: ALPHA
      INTEGER :: INCX, N
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: CX(*)
!     ..
!     .. Local Scalars ..
      INTEGER :: I, IX, M, MP1
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC MOD
!     ..
      IF (N<=0) RETURN
      IF (INCX==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      DO I = 1, N
        CX(IX) = ALPHA
        IX = IX + INCX
      END DO
      RETURN

!        code for both increments equal to 1


!        clean-up loop

20    M = MOD(N,7)
      IF (M==0) GO TO 40
      DO I = 1, M
        CX(I) = ALPHA
      END DO
      IF (N<7) RETURN
40    MP1 = M + 1
      DO I = MP1, N, 7
        CX(I) = ALPHA
        CX(I+1) = ALPHA
        CX(I+2) = ALPHA
        CX(I+3) = ALPHA
        CX(I+4) = ALPHA
        CX(I+5) = ALPHA
        CX(I+6) = ALPHA
      END DO
      RETURN

    END SUBROUTINE CINIT

    FUNCTION CSIGN(X)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE
      COMPLEX (WP) :: CSIGN
!     .. Scalar Arguments ..
      COMPLEX (WP) :: X
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS
!     ..
      CSIGN = X/ABS(X)
      RETURN

    END FUNCTION CSIGN

    SUBROUTINE DECODE(RHO,C,S)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE
!     .. Scalar Arguments ..
      COMPLEX (WP) :: C, RHO, S
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
!     ..
!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0_WP)
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0_WP,0.0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0_WP,0.0_WP))
!     ..
      IF (RHO==CONE) THEN
        C = CZERO
        S = CONE

      ELSE IF (ABS(RHO)<ONE) THEN
        S = 2.0_WP*RHO
        C = SQRT(CONE-S**2)

      ELSE
        C = 2.0_WP/RHO
        S = SQRT(CONE-C**2)
      END IF

      RETURN

    END SUBROUTINE DECODE

    SUBROUTINE ENCODE(RHO,C,S)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE
!     .. Scalar Arguments ..
      COMPLEX (WP) :: C, RHO, S
!     ..
!     .. External Functions ..
      COMPLEX (WP) :: CSIGN
      EXTERNAL CSIGN
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS
!     ..
!     .. Parameters ..
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0_WP,0.0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0_WP,0.0_WP))
!     ..
      IF (C==CZERO) THEN
        RHO = CONE

      ELSE IF (ABS(S)<ABS(C)) THEN
        RHO = CSIGN(C)*S/2.0_WP

      ELSE
        RHO = 2.0_WP*CSIGN(S)/C
      END IF

      RETURN

    END SUBROUTINE ENCODE

    SUBROUTINE GIVENS(A,B,C,S)
      USE DDPRECISION, ONLY : WP
! part of PIM
      IMPLICIT NONE
!     .. Scalar Arguments ..
      COMPLEX (WP) :: A, B, C, S
!     ..
!     .. Local Scalars ..
      COMPLEX (WP) :: TAU
!     ..
!     .. Intrinsic Functions ..
      INTRINSIC ABS, SQRT
!     ..
!     .. Parameters ..
      COMPLEX (WP) :: CZERO
      PARAMETER (CZERO=(0.0_WP,0.0_WP))
      COMPLEX (WP) :: CONE
      PARAMETER (CONE=(1.0_WP,0.0_WP))
!     ..
      IF (B==CZERO) THEN
        C = CONE
        S = CZERO

      ELSE IF (ABS(B)>ABS(A)) THEN
        TAU = -A/B
        S = CONE/SQRT(CONE+TAU**2)
        C = S*TAU

      ELSE
        TAU = -B/A
        C = CONE/SQRT(CONE+TAU**2)
        S = C*TAU
      END IF

      RETURN

    END SUBROUTINE GIVENS
    FUNCTION PSCNRM2(LOCLEN,U)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: PSCNRM2
! part of PIM package
!     .. Scalar Arguments ..
      INTEGER :: LOCLEN
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: U(*)
!     ..
!     .. External Functions ..
      REAL (WP) :: SCNRM2
      EXTERNAL SCNRM2
!     ..
      PSCNRM2 = SCNRM2(LOCLEN,U,1)
      RETURN

    END FUNCTION PSCNRM2

    SUBROUTINE PCSUM(ISIZE,X)
      USE DDPRECISION, ONLY : WP
!     .. Scalar Arguments ..
      INTEGER :: ISIZE
!     ..
!     .. Array Arguments ..
      COMPLEX (WP) :: X(*)
!     ..
      RETURN

    END SUBROUTINE PCSUM

    SUBROUTINE CCOPY(N,CX,INCX,CY,INCY)
      USE DDPRECISION, ONLY : WP

!     copies a vector, x, to a vector, y.
!     jack dongarra, linpack, 4/11/78.

      COMPLEX (WP) :: CX(1), CY(1)
      INTEGER :: I, INCX, INCY, IX, IY, N

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      IF (INCY<0) IY = (-N+1)*INCY + 1
      DO I = 1, N
        CY(IY) = CX(IX)
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

!        code for both increments equal to 1

20    DO I = 1, N
        CY(I) = CX(I)
      END DO
      RETURN
    END SUBROUTINE CCOPY
    FUNCTION CDOTC(N,CX,INCX,CY,INCY)
      USE DDPRECISION, ONLY : WP
      COMPLEX (WP) :: CDOTC

!     forms the dot product of a vector.
!     jack dongarra, 3/11/78.

      COMPLEX (WP) :: CX(1), CY(1), CTEMP
      INTEGER :: I, IX, IY, N, INCX, INCY

      CTEMP = (0.0E0_WP,0.0E0_WP)
      CDOTC = (0.0E0_WP,0.0E0_WP)
      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      IF (INCY<0) IY = (-N+1)*INCY + 1
      DO I = 1, N
        CTEMP = CTEMP + CONJG(CX(IX))*CY(IY)
        IX = IX + INCX
        IY = IY + INCY
      END DO
      CDOTC = CTEMP
      RETURN

!        code for both increments equal to 1

20    DO I = 1, N
        CTEMP = CTEMP + CONJG(CX(I))*CY(I)
      END DO
      CDOTC = CTEMP
      RETURN
    END FUNCTION CDOTC
    FUNCTION CDOTU(N,CX,INCX,CY,INCY)
      USE DDPRECISION, ONLY : WP
      COMPLEX (WP) :: CDOTU

!     forms the dot product of a vector.
!     jack dongarra, 3/11/78.

      COMPLEX (WP) :: CX(1), CY(1), CTEMP
      INTEGER :: I, IX, IY, N, INCX, INCY

      CTEMP = (0.0E0_WP,0.0E0_WP)
      CDOTU = (0.0E0_WP,0.0E0_WP)
      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!        code for unequal increments or equal increments
!          not equal to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      IF (INCY<0) IY = (-N+1)*INCY + 1
      DO I = 1, N
        CTEMP = CTEMP + CX(IX)*CY(IY)
        IX = IX + INCX
        IY = IY + INCY
      END DO
      CDOTU = CTEMP
      RETURN

!        code for both increments equal to 1

20    DO I = 1, N
        CTEMP = CTEMP + CX(I)*CY(I)
      END DO
      CDOTU = CTEMP
      RETURN
    END FUNCTION CDOTU
    SUBROUTINE CROTG(CA,CB,C,S)
      USE DDPRECISION, ONLY : WP
      COMPLEX (WP) :: CA, CB, S
      REAL (WP) :: C
      REAL (WP) :: NORM, SCALE
      COMPLEX (WP) :: ALPHA

      IF (ABS(CA)/=0.0E0_WP) GO TO 10
      C = 0.0E0_WP
      S = (1.0E0_WP,0.0E0_WP)
      CA = CB
      GO TO 20
10    CONTINUE
      SCALE = ABS(CA) + ABS(CB)
      NORM = SCALE*SQRT((ABS(CA/CMPLX(SCALE,0.0E0_WP,KIND=WP)))**2+(ABS(CB/ &
        CMPLX(SCALE,0.0E0_WP,KIND=WP)))**2)
      ALPHA = CA/ABS(CA)
      C = ABS(CA)/NORM
      S = ALPHA*CONJG(CB)/NORM
      CA = ALPHA*NORM
20    CONTINUE
      RETURN
    END SUBROUTINE CROTG
    SUBROUTINE CSROT(N,CX,INCX,CY,INCY,C,S)
      USE DDPRECISION, ONLY : WP

!     applies a plane rotation, where the cos and sin (c and s) are
!     real and the vectors cx and cy are complex.
!     jack dongarra, linpack, 3/11/78.

      COMPLEX (WP) :: CX(1), CY(1), CTEMP
      REAL (WP) :: C, S
      INTEGER :: I, INCX, INCY, IX, IY, N

      IF (N<=0) RETURN
      IF (INCX==1 .AND. INCY==1) GO TO 20

!       code for unequal increments or equal increments not equal
!         to 1

      IX = 1
      IY = 1
      IF (INCX<0) IX = (-N+1)*INCX + 1
      IF (INCY<0) IY = (-N+1)*INCY + 1
      DO I = 1, N
        CTEMP = C*CX(IX) + S*CY(IY)
        CY(IY) = C*CY(IY) - S*CX(IX)
        CX(IX) = CTEMP
        IX = IX + INCX
        IY = IY + INCY
      END DO
      RETURN

!       code for both increments equal to 1

20    DO I = 1, N
        CTEMP = C*CX(I) + S*CY(I)
        CY(I) = C*CY(I) - S*CX(I)
        CX(I) = CTEMP
      END DO
      RETURN
    END SUBROUTINE CSROT
    FUNCTION SCNRM2(N,CX,INCX)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: SCNRM2
! Arguments:
      INTEGER :: INCX, N
      COMPLEX (WP) :: CX(1)
! Local variables:
      INTEGER :: I, J
      REAL (WP) :: SUM
!***********************************************************************
! Returns SCNRM2=unitary norm of complex n-vector stored in CX with
! storage increment INCX.
! Written to replace SCNRM2 written by C.L.Lawson, as g77 compiler
! produces bad code when optimizing Lawson's routine.
! In any event, Lawson's routine appears to be unnecessarily complicated
! for needs of DDSCAT.

! History:
! 98.10.07 (BTD) Created by B.T. Draine, Princeton Univ. Observatory,
!                for use by DDSCAT
! 00.06.13 (BTD) Make data conversion explicit.
! end history
!***********************************************************************
      SUM = 0._WP
      DO I = 1, N
        J = 1 + (I-1)*INCX
        SUM = SUM + REAL(CX(J)*CONJG(CX(J)))
      END DO
      SCNRM2 = REAL(SQRT(SUM),KIND=WP)
      RETURN
    END FUNCTION SCNRM2
!-----------------------------------------------------------------------
! Following code due to C.L. Lawson has been replaced by above module
! because it generated bad code when compiled with g77.
! For use by DDSCAT the overflow/underflow avoidance strategies
! used by this routine do not appear to be necessary, so they can
! be omitted in interests of speed and clean code.
! 98.10.07 BTD

!      real function scnrm2( n, cx, incx)
!      logical imag, scale
!      integer i, incx, ix, n, next
!      real cutlo, cuthi, hitest, sum, xmax, absx, zero, one
!      complex      cx(1)
!      real real,aimag
!      complex zdumr,zdumi
!      real(zdumr) = zdumr
!      aimag(zdumi) = (0.0e0,-1.0e0)*zdumi
!      data         zero, one /0.0e0, 1.0e0/
!c
!c     unitary norm of the complex n-vector stored in cx() with storage
!c     increment incx .
!c     if    n .le. 0 return with result = 0.
!c     if n .ge. 1 then incx must be .ge. 1
!c
!c           c.l.lawson , 1978 jan 08
!c     modified to correct problem with negative increment, 8/21/90.
!c
!c     four phase method     using two built-in constants that are
!c     hopefully applicable to all machines.
!c         cutlo = maximum of  sqrt(u/eps)  over all known machines.
!c         cuthi = minimum of  sqrt(v)      over all known machines.
!c     where
!c         eps = smallest no. such that eps + 1. .gt. 1.
!c         u   = smallest positive no.   (underflow limit)
!c         v   = largest  no.            (overflow  limit)
!c
!c     brief outline of algorithm..
!c
!c     phase 1    scans zero components.
!c     move to phase 2 when a component is nonzero and .le. cutlo
!c     move to phase 3 when a component is .gt. cutlo
!c     move to phase 4 when a component is .ge. cuthi/m
!c     where m = n for x() real and m = 2*n for complex.
!c
!c     values for cutlo and cuthi..
!c     from the environmental parameters listed in the imsl converter
!c     document the limiting values are as follows..
!c     cutlo, s.p.   u/eps = 2**(-102) for  honeywell.  close seconds ar
!c                   univac and dec at 2**(-103)
!c                   thus cutlo = 2**(-51) = 4.44089e-16
!c     cuthi, s.p.   v = 2**127 for univac, honeywell, and dec.
!c                   thus cuthi = 2**(63.5) = 1.30438e19
!c     cutlo, d.p.   u/eps = 2**(-67) for honeywell and dec.
!c                   thus cutlo = 2**(-33.5) = 8.23181d-11
!c     cuthi, d.p.   same as s.p.  cuthi = 1.30438d19
!c     data cutlo, cuthi / 8.232d-11,  1.304d19 /
!c     data cutlo, cuthi / 4.441e-16,  1.304e19 /
!      data cutlo, cuthi / 8.232d-11,  1.304d19 /
!c
!      if(n .gt. 0) go to 10
!         scnrm2  = zero
!         go to 300
!c
!   10 assign 30 to next
!      sum = zero
!      i = 1
!      if( incx .lt. 0 )i = (-n+1)*incx + 1
!c                                                 begin main loop
!      do 220 ix = 1,n
!         absx = abs(real(cx(i)))
!         imag = .false.
!         go to next,(30, 50, 70, 90, 110)
!   30 if( absx .gt. cutlo) go to 85
!      assign 50 to next
!      scale = .false.
!c
!c                        phase 1.  sum is zero
!c
!   50 if( absx .eq. zero) go to 200
!      if( absx .gt. cutlo) go to 85
!c
!c                                prepare for phase 2.
!      assign 70 to next
!      go to 105
!c
!c                                prepare for phase 4.
!c
!  100 assign 110 to next
!      sum = (sum / absx) / absx
!  105 scale = .true.
!      xmax = absx
!      go to 115
!c
!c                   phase 2.  sum is small.
!c                             scale to avoid destructive underflow.
!c
!   70 if( absx .gt. cutlo ) go to 75
!c
!c                     common code for phases 2 and 4.
!c                     in phase 4 sum is large.  scale to avoid overflow
!c
!  110 if( absx .le. xmax ) go to 115
!         sum = one + sum * (xmax / absx)**2
!         xmax = absx
!         go to 200
!c
!  115 sum = sum + (absx/xmax)**2
!      go to 200
!c
!c
!c                  prepare for phase 3.
!c
!   75 sum = (sum * xmax) * xmax
!c
!   85 assign 90 to next
!      scale = .false.
!c
!c     for real or d.p. set hitest = cuthi/n
!c     for complex      set hitest = cuthi/(2*n)
!c
!      hitest = cuthi/float( 2*n )
!c
!c                   phase 3.  sum is mid-range.  no scaling.
!c
!   90 if(absx .ge. hitest) go to 100
!         sum = sum + absx**2
!  200 continue
!c                  control selection of real and imaginary parts.
!c
!      if(imag) go to 210
!         absx = abs(aimag(cx(i)))
!         imag = .true.
!      go to next,(  50, 70, 90, 110 )
!c
!  210 continue
!      i = i + incx
!  220 continue
!c
!c              end of main loop.
!c              compute square root and adjust for scaling.
!c
!      scnrm2 = sqrt(sum)
!      if(scale) scnrm2 = scnrm2 * xmax
!  300 continue
!      return
!      end
!-----------------------------------------------------------------------
    SUBROUTINE SROTG(DA,DB,C,S)
      USE DDPRECISION, ONLY : WP

!     construct givens plane rotation.
!     jack dongarra, linpack, 3/11/78.
!                    modified 9/27/86.

      REAL (WP) :: DA, DB, C, S, ROE, SCALE, R, Z

      ROE = DB
      IF (ABS(DA)>ABS(DB)) ROE = DA
      SCALE = ABS(DA) + ABS(DB)
      IF (SCALE/=0.0E0_WP) GO TO 10
      C = 1.0E0_WP
      S = 0.0E0_WP
      R = 0.0E0_WP
      GO TO 20
10    R = SCALE*SQRT((DA/SCALE)**2+(DB/SCALE)**2)
      R = SIGN(1.0E0_WP,ROE)*R
      C = DA/R
      S = DB/R
20    Z = S
      IF (ABS(C)>0.0E0_WP .AND. ABS(C)<=S) Z = 1.0E0_WP/C
      DA = R
      DB = Z
      RETURN
    END SUBROUTINE SROTG

    SUBROUTINE DMACHCONS(WHAT,RESULT)
      USE DDPRECISION, ONLY : WP

! These values are for IEEE-754 arithmetic
! 07.08.05 (BTD) Modified for compatibility with both single or
!                double precision -- eliminate PARAMETER statements,
!                add executable statements.
!                Will these slow execution?? 
!                How often is DMACHCONS called?
! 08.08.05 (BTD) Modified to use preprocessing to modify file
!                to use appropriate precision MACHEPS,OVERFlOW,
!                end UNDERFLOW
! end history --------------------------------------------------------

!     .. Parameters ..
      REAL (WP) :: MACHEPS,OVERFLOW,UNDERFLOW
#ifdef sp
      PARAMETER(MACHEPS=1.192093E-7_WP)
      PARAMETER(OVERFLOW=3.402823E+38_WP)
      PARAMETER(UNDERFLOW=1.17549435E-38_WP)
#endif
#ifdef dp
      PARAMETER(MACHEPS=2.2204460492503E-16_WP)
      PARAMETER(OVERFLOW=1.7976313E+308_WP)
      PARAMETER(UNDERFLOW=2.2250739E-308_WP)
#endif

!     .. Scalar Arguments ..
      REAL (WP) :: RESULT
      CHARACTER :: WHAT

      IF((WHAT=='M').OR.(WHAT=='m'))THEN
         RESULT=MACHEPS
      ELSEIF((WHAT=='U').OR.(WHAT=='u'))THEN
         RESULT=UNDERFLOW
      ELSEIF((WHAT=='O').OR.(WHAT=='o'))THEN
         RESULT=OVERFLOW
      ENDIF

      RETURN

    END SUBROUTINE DMACHCONS
    SUBROUTINE PIMDGETPAR(IPAR,DPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/double precision
!     dpar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/double precision
!     dpar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: DPARSIZ
      PARAMETER (DPARSIZ=6)
!     ..
!     .. Scalar Arguments ..
      REAL (WP) :: EPSILON, EXITNORM
      INTEGER :: BASISDIM, BLKSZ, ITNO, LDA, LOCLEN, MAXIT, N, NPROCS, &
        PRECONTYPE, PROCID, STATUS, STEPERR, STOPTYPE
!     ..
!     .. Array Arguments ..
      REAL (WP) :: DPAR(DPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
      LDA = IPAR(1)
      N = IPAR(2)
      BLKSZ = IPAR(3)
      LOCLEN = IPAR(4)
      BASISDIM = IPAR(5)
      NPROCS = IPAR(6)
      PROCID = IPAR(7)
      PRECONTYPE = IPAR(8)
      STOPTYPE = IPAR(9)
      MAXIT = IPAR(10)
      ITNO = IPAR(11)
      STATUS = IPAR(12)
      STEPERR = IPAR(13)

      EPSILON = DPAR(1)
      EXITNORM = DPAR(2)

      RETURN

    END SUBROUTINE PIMDGETPAR
    SUBROUTINE PIMDPRTPAR(IPAR,DPAR)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/double precision
!     dpar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/double precision
!     dpar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: DPARSIZ
      PARAMETER (DPARSIZ=6)
!     ..
!     .. Array Arguments ..
      REAL (WP) :: DPAR(DPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Local Scalars ..
      INTEGER :: I
!     ..
      WRITE (6,FMT=10) (IPAR(I),I=1,IPARSIZ)

10    FORMAT ('lda=',I6/'n=',I6/'blksz=',I6/'loclen=',I4/'basisdim=', &
        I4/'nprocs=',I4/'procid=',I4/'precontype=',I4/'stoptype=',I4/'maxit=', &
        I4/'itno=',I4/'status=',I4/'steperr=',I4)

      WRITE (6,FMT=20) (DPAR(I),I=1,DPARSIZ)

20    FORMAT ('epsilon=',D20.12/'exitnorm=',D20.12/'eigenvalues region:'/4( &
        D20.12,1X))

      RETURN

    END SUBROUTINE PIMDPRTPAR
    SUBROUTINE PIMDSETPAR(IPAR,DPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,EPSILON)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/double precision
!     dpar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/double precision
!     dpar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0E0_WP)
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: DPARSIZ
      PARAMETER (DPARSIZ=6)
!     ..
!     .. Scalar Arguments ..
      REAL (WP) :: EPSILON
      INTEGER :: BASISDIM, BLKSZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, &
        PROCID, STOPTYPE
!     ..
!     .. Array Arguments ..
      REAL (WP) :: DPAR(DPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Local Scalars ..
      REAL (WP) :: EXITNORM
      INTEGER :: ITNO, STATUS, STEPERR
!     ..
      IPAR(1) = LDA
      IPAR(2) = N
      IPAR(3) = BLKSZ
      IPAR(4) = LOCLEN
      IPAR(5) = BASISDIM
      IPAR(6) = NPROCS
      IPAR(7) = PROCID
      IPAR(8) = PRECONTYPE
      IPAR(9) = STOPTYPE
      IPAR(10) = MAXIT
      IPAR(11) = -1
      IPAR(12) = -1
      IPAR(13) = -1

      DPAR(1) = EPSILON
      DPAR(2) = -ONE

      RETURN

    END SUBROUTINE PIMDSETPAR
    SUBROUTINE PIMSGETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,ITNO,STATUS,STEPERR,EPSILON,EXITNORM)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/real
!     spar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/real
!     spar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Scalar Arguments ..
      REAL (WP) :: EPSILON, EXITNORM
      INTEGER :: BASISDIM, BLKSZ, ITNO, LDA, LOCLEN, MAXIT, N, NPROCS, &
        PRECONTYPE, PROCID, STATUS, STEPERR, STOPTYPE
!     ..
!     .. Array Arguments ..
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
      LDA = IPAR(1)
      N = IPAR(2)
      BLKSZ = IPAR(3)
      LOCLEN = IPAR(4)
      BASISDIM = IPAR(5)
      NPROCS = IPAR(6)
      PROCID = IPAR(7)
      PRECONTYPE = IPAR(8)
      STOPTYPE = IPAR(9)
      MAXIT = IPAR(10)
      ITNO = IPAR(11)
      STATUS = IPAR(12)
      STEPERR = IPAR(13)

      EPSILON = SPAR(1)
      EXITNORM = SPAR(2)

      RETURN

    END SUBROUTINE PIMSGETPAR
    SUBROUTINE PIMSPRTPAR(IPAR,SPAR)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/real
!     spar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/real
!     spar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Array Arguments ..
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Local Scalars ..
      INTEGER :: I
!     ..
      WRITE (6,FMT=10) (IPAR(I),I=1,IPARSIZ)

10    FORMAT ('lda=',I6/'n=',I6/'blksz=',I6/'loclen=',I4/'basisdim=', &
        I4/'nprocs=',I4/'procid=',I4/'precontype=',I4/'stoptype=',I4/'maxit=', &
        I4/'itno=',I4/'status=',I4/'steperr=',I4)

      WRITE (6,FMT=20) (SPAR(I),I=1,SPARSIZ)

20    FORMAT ('epsilon=',E20.12/'exitnorm=',E20.12,'eigenvalues region:'/4( &
        E20.12,1X))


      RETURN

    END SUBROUTINE PIMSPRTPAR
    SUBROUTINE PIMSSETPAR(IPAR,SPAR,LDA,N,BLKSZ,LOCLEN,BASISDIM,NPROCS,PROCID, &
        PRECONTYPE,STOPTYPE,MAXIT,EPSILON)
      USE DDPRECISION, ONLY : WP

!           PIM -- The Parallel Iterative Methods package
!           ---------------------------------------------

!                      Rudnei Dias da Cunha
!               Centro de Processamento de Dados,
!         Universidade Federal do Rio Grande do Sul, Brasil
!                              and
!     Computing Laboratory, University of Kent at Canterbury, U.K.

!                          Tim Hopkins
!     Computing Laboratory, University of Kent at Canterbury, U.K.

! ----------------------------------------------------------------------

!  Description of parameter arrays
!   IPAR (INPUT)  : integer
!     ipar( 1): lda    (Leading dimension of a)
!           2 : n      (Number of rows/columns of a)
!           3 : blksz  (Size of block of data; used when data is
!                       partitioned using cyclic mode)
!           4 : loclen (Number of elements stored locally;
!                       *PARALLEL: Equal to at least m/nprocs or
!                                  n/procs depending if row or
!                                  column partitioning is used or,
!                                  in the case of cyclic partitioning,
!                                  it is a multiple of either
!                                  m/(blksz*nprocs) or n/(blksz*nprocs).
!                       *SEQUENTIAL: equal to n)
!           5 : basisdim (Dimension of orthogonal basis, used in
!                       GMRES)
!           6 : nprocs (Number of processors)
!           7 : procid (Processor identification)
!           8 : precontype (Type of preconditioning; one of
!                           0 : No preconditioning,
!                           1 : Left preconditioning,
!                           2 : Right preconditioning,
!                           3 : Symmetric preconditioning)
!           9 : stoptype (Type of stopping criteria used)
!          10 : maxit  (Maximum number of iterations allowed)

!   IPAR (OUTPUT) : integer
!     ipar(11): itno   (Number of iterations executed)
!          12 : status (On exit of iterative method, one of
!                        0: converged to solution
!                       -1: no convergence has been achieved
!                       -2: "soft"-breakdown, solution may have
!                           been found
!                       -3: "hard"-breakdown, no solution)
!                       -4: conflict in preconditioner and stopping
!                           criterion selected
!                       -5: error in stopping criterion 3, r^{T}z<0)
!          13 : steperr (If status is either -2 or -3, it gives
!                         the step number of the respective algorithm
!                         where a breakdown has occurred. Refer to the
!                         User's Guide for further information)

!   RPAR/DPAR (INPUT)  : real/real
!     spar( 1): epsilon (The value of epsilon for use in the
!                        stopping criterion)

!   RPAR/DPAR (OUTPUT) : real/real
!     spar( 2): exitnorm (The value of a norm of either the residual
!                         vector or the difference between two
!                         successive solution estimates according to
!                         the value of stoptype)
!           3,
!           4 : smallest and largest eigenvalues of Q1AQ2 (in the
!               symmetric case) OR smallest and largest real parts
!               (in the nonsymmetric case)
!           5,
!           6 : smallest and largest imaginary parts (only in the
!               nonsymmetric case)


!     .. Parameters ..
      REAL (WP) :: ONE
      PARAMETER (ONE=1.0_WP)
      INTEGER :: IPARSIZ
      PARAMETER (IPARSIZ=13)
      INTEGER :: SPARSIZ
      PARAMETER (SPARSIZ=6)
!     ..
!     .. Scalar Arguments ..
      REAL (WP) :: EPSILON
      INTEGER :: BASISDIM, BLKSZ, LDA, LOCLEN, MAXIT, N, NPROCS, PRECONTYPE, &
        PROCID, STOPTYPE
!     ..
!     .. Array Arguments ..
      REAL (WP) :: SPAR(SPARSIZ)
      INTEGER :: IPAR(IPARSIZ)
!     ..
!     .. Local Scalars ..
      REAL (WP) :: EXITNORM
      INTEGER :: ITNO, STATUS, STEPERR
!     ..
      IPAR(1) = LDA
      IPAR(2) = N
      IPAR(3) = BLKSZ
      IPAR(4) = LOCLEN
      IPAR(5) = BASISDIM
      IPAR(6) = NPROCS
      IPAR(7) = PROCID
      IPAR(8) = PRECONTYPE
      IPAR(9) = STOPTYPE
      IPAR(10) = MAXIT
      IPAR(11) = -1
      IPAR(12) = -1
      IPAR(13) = -1

      SPAR(1) = EPSILON
      SPAR(2) = -ONE

      RETURN

    END SUBROUTINE PIMSSETPAR
    SUBROUTINE SMACHCONS(WHAT,RESULT)
      USE DDPRECISION, ONLY : WP

! These values are for IEEE-754 arithmetic

!     .. Parameters ..
      REAL (WP) :: MACHEPS
      PARAMETER (MACHEPS=1.19209E-07_WP)
      REAL (WP) :: UNDERFLOW
      PARAMETER (UNDERFLOW=0.11754945E-37_WP)
      REAL (WP) :: OVERFLOW
!*****************
! 98.10.27 BTD
! following line generated complaint from Solaris compiler, with
! OVERFLOW being instead set equal to "IEEE's +Inf" instead
! Therefore try reducing OVERFLOW to 2**127
!      PARAMETER (OVERFLOW=3.40282347E38)
      PARAMETER (OVERFLOW=1.7014118E38_WP)
!****************
!     ..
!     .. Scalar Arguments ..
      REAL (WP) :: RESULT
      CHARACTER :: WHAT
!     ..
      IF ((WHAT=='M') .OR. (WHAT=='m')) THEN
        RESULT = MACHEPS
      ELSE IF ((WHAT=='U') .OR. (WHAT=='u')) THEN
        RESULT = UNDERFLOW
      ELSE IF ((WHAT=='O') .OR. (WHAT=='o')) THEN
        RESULT = OVERFLOW
      END IF

      RETURN

    END SUBROUTINE SMACHCONS

    SUBROUTINE NULLER(CXVEC,IOCC,MXNAT,MXN3,NAT)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE
! Arguments:
      INTEGER :: MXNAT,MXN3,NAT
      INTEGER*2 :: &
         IOCC(MXNAT)
      COMPLEX(WP) :: &
         CXVEC(NAT,3)
! Local variables:
      INTEGER :: J, L
!***********************************************************************
! This routine takes as input a complex vector with NAT3 elements
! and sets to zero those elements corresponding to "vacuum" sites.
! This is accomplished by multiplying by vector IOCC(J), whose
! elements are either 1 or 0 depending on whether site is occupied
! or "vacuum".
! Note: CXVEC should be given dimension CXVEC(NAT,3) here
!       so that first 3*NAT elements of CXVEC are employed.

! B.T.Draine, Princeton Univ. Obs., 90/11/1
! History:
! 90/12/15 (BTD): Corrected error in dimensioning of CXVEC.

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      DO L=1, 3
         DO J=1,NAT
            IF(IOCC(J)==0)THEN
               CXVEC(J,L)=IOCC(J)*CXVEC(J,L)
            ENDIF
         ENDDO
      ENDDO
      RETURN
    END SUBROUTINE NULLER

    SUBROUTINE ERRMSG(CSTATS,CSUBRT,CMSGNM)
      IMPLICIT NONE
! Arguments:
      CHARACTER :: CMSGNM*(*), CSTATS*(*), CSUBRT*(*)

! Local variables:
      INTEGER :: IOERR

!***********************************************************************
! Given:
!       CSTATS = 'WARNING' or 'FATAL'
!       CSUBRT = name of subroutine
!       CMESGN = message
! Prints a warning message in a standardized way,
! and STOPs if CSTATS='FATAL'

! Copyright (C) 1993, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.

! History:
! 96.11.14 (PJF) Remove "getset" and hardwire "ioerr"
! 04.05.23 (BTD) cleanup
! end history
!***********************************************************************
      DATA IOERR/6/

      IF (CSTATS=='FATAL') THEN
        WRITE (IOERR,FMT=9000) CSUBRT
        WRITE (IOERR,FMT=9010) CMSGNM
        WRITE (IOERR,FMT=9020)
        STOP
      ELSE IF (CSTATS=='WARNING') THEN
        WRITE (IOERR,FMT=9030) CSUBRT
        WRITE (IOERR,FMT=9010) CMSGNM
      END IF
      RETURN
9000  FORMAT (/' >>>>> FATAL ERROR IN PROCEDURE: ',A)
9010  FORMAT (1X,A)
9020  FORMAT (' >>>>> EXECUTION ABORTED ')
9030  FORMAT (/' >>>>> WARNING IN PROCEDURE: ',A)
    END SUBROUTINE ERRMSG

    SUBROUTINE TARGSPHER(AEFF,PRINAX,BETA,RLMAX,S2,RSEED,   &
                         A1,A2,DX,X0,CFLSHP,CDESCR,         &
                         IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Parameters:
! note: this must agree with corresponding parameter in FUNCTION RSPHARM
!       below

      INTEGER NMAX
      PARAMETER(NMAX=100)

! Arguments:

      CHARACTER(67) :: CDESCR
      CHARACTER(*) :: CFLSHP
      INTEGER :: IOSHP,MXNAT,NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: AEFF,BETA,PRINAX,RLMAX,RSEED,S2,S2LMAX
      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local variables

      INTEGER NRES
      PARAMETER(NRES=20)
      CHARACTER CMSGNM*70
      INTEGER ::                              &
         ISEED,JA,JPHI,JTH,JX,JY,JZ,          &
         L,LMAX,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2,M
      REAL(WP) ::                                       &
         AR,AI,COSPH,COSTH,F1,FOURPI,ONE,PHI,PHIARG,PI, &
         R,RAD,ROOTTWO,RYZ,RYZ2,                        &
         SIGLM,SINPH,SINTH,SUM,                         &
         TERM,THETA,TWOPI,X,XMAX,XMIN,XX,               &
         Y,YMAX,YMIN,YY,Z,ZERO,ZMAX,ZMIN,ZZ
      REAL(WP) ::             &
         ALPHA(1:3),          &
         PHIS(0:NRES*NMAX,3), &
         RADS(0:NRES*NMAX,3), &
         THETS(0:NRES*NMAX,3)
      COMPLEX(WP) :: CXI
      COMPLEX(WP) :: ALM(1:NMAX,0:NMAX)

! External functions

      REAL(WP) :: GASDEV,RGSPHER
      EXTERNAL GASDEV,RGSPHER

!***********************************************************************
! Routine to construct irregular grain using spherical harmonics
! to define surface.
!
! Input:
!        AEFF  =effective radius/d (d=lattice spacing)
!        PRINAX=0 to use (1,0,0) and (0,1,0) in TF as a1,a2
!              =1 to use principal axes of moment of inertia tensor
!                        for a1 and a2
!        BETA  = power law index
!                if BETA = 0 : read ALM values from file CFLSHP
!                if BETA > 1 : generate ALM values here using
!                              random number generator, with
!
!                <|a_LM|^2> propto [1/(L+1)]*L**(-BETA) for L>1

!        RLMAX = maximum L value to use in Y_LM expansion
!                LMAX=NINT(RLMAX)
!        RSEED = to choose seed for random number generator
!              = 1, 2, 3, 4, ...
!                ISEED=-NINT(RSEED) is passed to gaussian deviate program
!        S2 = expectation value of <s^2>, where < > denotes average
!             over grain surface

!        CFLSHP=name of file containing spherical harmonic amplitudes
!               (used only if BETA = 0)
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1
!        A2(1-3)=unit vector (0,1,0) defining target axis 2
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=(x-x0(1))/d,(y-x0(2))/d,(z-x0(3))/d
!                        for atoms of target
!        X0(1-3)=(location/d) in Target Frame corresponding to dipole with
!                IXYZ=(0,0,0).  This will be treated at the origin of physical
!                coordinates in the TF.
!                Here origin is set to be centroid of the target.
!        CDESCR=string describing target (up to 67 chars.)
!

!=======================================================================
!                   Gaussian Sphere Geometry

! The target is defined in polar coordinates by a radius function

!                                Lmax  l
!    R(theta,phi).= const * exp[ sum  sum  a_lm Y_lm(theta,phi) ]
!                                l=1  m=-l
!
!    We assume that the a_lm are gaussian random variables,
!    with
!                   4*pi   
!    <|a_{1M}|^2> = ---- * f1* <s^2>
!                    3     
!
!                    4*pi     (1-f1)*<s^2>     1
!    <|a_{LM}|^2> = ------- * ------------ * ------
!                   (2*L+1)   zeta(beta)-1   L^beta

! After generating the a_lm values according to above prescription for
! L=1,...,NMAX, we calculate the actual <s^2> averaged over angles.
! Because the a_lm have been chosen stochastically, this will not be
! exactly equal to the input S2.
! We then rescale all coefficients a_lm by a fixed factor so that
! the resulting a_lm have angle-averaged <s^2> = S2 (summing over
! L values up to NMAX).
! For reference, we also calculate <s^2> with the sum restricted to
! L values up to LMAX (as is used in the target generation).

! For s to be real it is also required that

!    a_{L,-M} = (-1)^m conjg(a_{L,M})    ---> Im[a_{L0}] = 0

! Because of the above requirement, we do not calculate or store
! the a_lm for m < 0, since all that we require to calculate the
! target shape are the combination

!    a_{L,m}Y_{L,m} + a_{L,-m}Y_{L,-m}

!                  (2L+1)*(L-m)!
!          = sqrt[ ------------- ] * P_Lm * 
!                    4*pi*(L+m)!

!              [ a_Lm e^{i*m*phi} + (-1)^m a_{L,-m}*e^{-i*m*phi) ]
!
! where P_Lm(theta,phi) is the associated Legendre function.
! With above requirement on a_{L,-M} it follows that
!
!                  (2L+1)*(L-m)!
!          = sqrt[ ------------- ] * P_Lm * 2 Re(a_Lm e^{i*m*phi})
!                    4*pi*(L+m)!


! B.T.Draine, Princeton Univ. Obs.  Original version: 02.11.12
!
! History:
! 02.11.12 (BTD): Start to write this routine
! 02.11.13 (BTD): further modification
! 03.05.21 (BTD): bug fix (set NAT=0)
!                 bug fix to suppress cross section info when IOSHP < 1
! 03.11.06 (BTD): modify to use random number generator to choose
!                 coefficients a_lm
! 03.11.08 (BTD): Using TARPHARM as template, write routine to
!                 generate gaussian random spheres using
!                 r prop exp(s), with s = sum a_lm Y_lm
! 04.03.19 (BTD): revert to previous version of PRINAXIS
! 04.04.01 (BTD): add DX to argument list
! 04.04.05 (BTD): Replace WRITE(0, with CALL WRIMSG
! 04.05.23 (BTD): Obtain eigenvalues ALPHA from PRINAXIS
!                 modified argument list in call to PRINAXIS to
!                 conform to modification in PRINAXIS
! 07.08.06 (BTD): Converted to f90
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.05.12 (BTD): Added X0 to argument list, and add code to calculate X0
! 08.08.29 (BTD): Modified format 9020
! end history
!
! Copyright (C) 2002,2003,2004,2007,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!-----------------------------------------------------------------------

      ZERO=0._WP
      ONE=1._WP
      CXI=(0._WP,1._WP)
      PI=4._WP*ATAN(ONE)
      TWOPI=2._WP*PI
      FOURPI=4._WP*PI
      ROOTTWO=SQRT(2._WP)

! set Lmax

      LMAX=NINT(RLMAX)

      IF(BETA==ZERO)THEN
         WRITE(CMSGNM,'(A,A)')'going to read alm from file = ',CFLSHP
         CALL WRIMSG('TARGSPHER',CMSGNM)
         OPEN(UNIT=IOSHP,FILE=CFLSHP)
         READ(IOSHP,*)S2LMAX,S2
         READ(IOSHP,*)
         READ(IOSHP,*)
         READ(IOSHP,*)
         READ(IOSHP,*)LMAX
         WRITE(CMSGNM,'(A,I3)')'Lmax=',LMAX
         CALL WRIMSG('TARGSPHER',CMSGNM)
         READ(IOSHP,*)

! read ALM values for nonnegative m
! LMAX = 1 : 2    (m=0 and 1)
! LMAX = 2 : 2+3 = 5
! LMAX = 3 : 2+3+4 = 9
! general: (LMAX^2+3*LMAX)/2

         JTH=(LMAX**2+3*LMAX)/2
         DO JA=1,JTH
            READ(IOSHP,*)L,M,AR,AI
            ALM(L,M)=AR+CXI*AI
         ENDDO
         WRITE(CMSGNM,'(A,I4,A,I3,I3)')                  &
               'Read ',JTH,' a_lm values through L,M=',L,M
         CALL WRIMSG('TARGSPHER',CMSGNM)
         CLOSE(IOSHP)

! calculate S2

         SUM=ZERO
         DO L=1,LMAX
            SUM=SUM+ABS(ALM(L,0))**2
            DO M=1,L
                SUM=SUM+2._WP*ABS(ALM(L,M))**2
            ENDDO
         ENDDO
         WRITE(CMSGNM,FMT='(A,1PE10.3)')'input S2LMAX=',s2lmax
         CALL WRIMSG('TARGSPHER',CMSGNM)
         S2LMAX=SUM/FOURPI
         WRITE(CMSGNM,FMT='(A,1PE10.3)')'S2LMAX=',S2LMAX
         CALL WRIMSG('TARGSPHER',CMSGNM)

      ELSEIF(BETA>ONE)THEN

! set value of F1 = fraction of <s^2> contributed by L=1
! note that to leading order the L=1 terms produce merely a
! translation with no deformation, so we normally suppress the
! L=1 terms by setting F1=0.0

         F1=0.0_WP

! Assign a_lm values using gaussian random deviates
! set seed

         ISEED=-NINT(RSEED)

! sanity check:

         IF(LMAX>NMAX)THEN
            WRITE(CMSGNM,FMT='(A,I4,A,I3)')                      &
               'Fatal problem: called tarspharm with LMAX=',LMAX, &
               ' > NMAX=',NMAX
            CALL WRIMSG('TARGSPHER',CMSGNM)
            STOP
         ENDIF

! Calculate random numbers and store in appropriate elements of ALM
! Calculate them in appropriate order so that changes in NMAX will 
! leave lower L values unaffected.  
! Specifying RSEED, F1, and BETA therefore serves to define a shape, 
! with adjustment to LMAX allowing one to see important to the shape
! of high L components.

! initialize GASDEV

         AR=GASDEV(ISEED)

         DO L=1,NMAX
            ALM(L,0)=GASDEV(ISEED)
            DO M=1,L
               AR=GASDEV(ISEED)/ROOTTWO
               AI=GASDEV(ISEED)/ROOTTWO
               ALM(L,M)=AR+CXI*AI
            ENDDO
         ENDDO

! ALM(L,M) now contains random complex numbers a_lm , with
!    <a_lm> = 0 
!    <|a_lm|^2> = <[Re(a_lm)]^2> + <[Im(a_lm)]^2> = 1
!    Im[a_lm(L,0)] = 0
!    <[Re(a_lm)]^2> = <[Im(a_lm)]^2> = 1/2 for M > 0

! Now multiply the A(L,M) random deviates by
! appropriate factors to obtain intended <|a_lm|^2> values

! First treal L=1
! SIGLM = <|a_lm|^2>^{1/2} 

         SIGLM=SQRT(F1*S2*FOURPI/3.)

         ALM(1,0)=SIGLM*ALM(1,0)
         ALM(1,1)=SIGLM*ALM(1,1)

! set coefficients for L > 1:
! estimate SUM = [Riemann zeta function - 1]

         SUM=ZERO
         DO L=NMAX,2,-1
            SUM=SUM+ONE/REAL(L)**BETA
         ENDDO
         TERM=(ONE-F1)*S2*FOURPI/SUM

! Note: we calculate coefficients up to NMAX
! We then use values only up to LMAX to generate shape, but we
! want to have correct amount of power in high order coefficients,
! even if they are later suppressed.

         DO L=2,NMAX
            SIGLM=SQRT(TERM/(REAL(2*L+1)*REAL(L)**BETA))
            DO M=0,L
               ALM(L,M)=SIGLM*ALM(L,M)
            ENDDO
         ENDDO

! compute actual <s^2> for this realization

         SUM=ZERO
         DO L=1,NMAX
            SUM=SUM+ABS(ALM(L,0))**2
            DO M=1,L
               SUM=SUM+2._WP*ABS(ALM(L,M))**2
            ENDDO
         ENDDO
         SUM=SUM/FOURPI

! At this point, we rescale the a_lm values so that we will have
! <s^2> = S2 exactly including all terms up to NMAX

         TERM=SQRT(S2/SUM)
         DO L=1,NMAX
            DO M=0,L
               ALM(L,M)=TERM*ALM(L,M)
            ENDDO
         ENDDO

! Now calculate S2LMAX = <s^2> contributed by terms up to LMAX

         SUM=ZERO
         DO L=1,LMAX
            SUM=SUM+ABS(ALM(L,0))**2
            DO M=1,L
               SUM=SUM+2._WP*ABS(ALM(L,M))**2
            ENDDO
         ENDDO
         S2LMAX=SUM/FOURPI
      ELSE
         CALL ERRMSG('FATAL','TARGSPHER',' Invalid BETA')
      ENDIF

!=======================================================================
! ALM values are now defined.  
! Proceed to generate target array, using a_lm values up to Lmax

      DO JA=1,3
         A1(JA)=0.
         A2(JA)=0.
      ENDDO
      A1(1)=ONE
      A2(2)=ONE

! if IOSHP > 0 , calculate three cross-sectional slices

! polar slice with phi=0

      IF(IOSHP>0)THEN
         PHI=ZERO
         DO JTH=0,NRES*LMAX
            THETA=TWOPI*REAL(JTH)/(REAL(NRES*LMAX))
            COSTH=COS(THETA)
            THETS(JTH,1)=THETA
            PHIS(JTH,1)=PHI
            PHIARG=PHI
            IF(THETA>PI)PHIARG=PHI+PI
            RADS(JTH,1)=RGSPHER(COSTH,PHIARG,LMAX,NMAX,S2,ALM)
         ENDDO

! polar slice with phi=pi/2

         PHI=PI/2._WP
         DO JTH=0,NRES*LMAX
            THETA=TWOPI*REAL(JTH)/(REAL(NRES*LMAX))
            COSTH=COS(THETA)
            THETS(JTH,2)=THETA
            PHIS(JTH,2)=PHI
            PHIARG=PHI
            IF(THETA>PI)PHIARG=PHI+PI
            RADS(JTH,2)=RGSPHER(COSTH,PHIARG,LMAX,NMAX,S2,ALM)
         ENDDO

! equatorial slice

         THETA=PI/2._WP
         COSTH=ZERO
         DO JPHI=0,NRES*LMAX
            PHI=TWOPI*REAL(JPHI)/(REAL(NRES*LMAX))
            THETS(JPHI,3)=THETA
            COSTH=COS(THETA)
            PHIS(JPHI,3)=PHI
            RADS(JPHI,3)=RGSPHER(COSTH,PHI,LMAX,NMAX,S2,ALM)
         ENDDO
         OPEN(UNIT=IOSHP,FILE='spharm.out')
         WRITE(IOSHP,7600)LMAX
         DO JTH=0,NRES*LMAX
            WRITE(IOSHP,7700)(THETS(JTH,L),PHIS(JTH,L),RADS(JTH,L),L=1,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF

! sample surface to determine total extent of target in x,y,z directions

      XMIN=ZERO
      XMAX=ZERO
      YMIN=ZERO
      YMAX=ZERO
      ZMIN=ZERO
      ZMAX=ZERO

      DO JTH=1,NRES*LMAX
         THETA=PI*(REAL(JTH)-0.5_WP)/REAL(NRES*LMAX)
         COSTH=COS(THETA)
         SINTH=SIN(THETA)

         DO JPHI=1,NRES*LMAX
            PHI=TWOPI*REAL(JPHI)/REAL(NRES*LMAX)
            RAD=AEFF*RGSPHER(COSTH,PHI,LMAX,NMAX,S2,ALM)
            XX=COSTH*RAD
            YY=SINTH*COS(PHI)*RAD
            ZZ=SINTH*SIN(PHI)*RAD
            IF(XX<XMIN)XMIN=XX
            IF(XX>XMAX)XMAX=XX
            IF(YY<YMIN)YMIN=YY
            IF(YY>YMAX)YMAX=YY
            IF(ZZ<ZMIN)ZMIN=ZZ
            IF(ZZ>ZMAX)ZMAX=ZZ
         ENDDO
      ENDDO

      LMX1=-INT(-XMIN)-1
      LMY1=-INT(-YMIN)-1
      LMZ1=-INT(-ZMIN)-1
      LMX2=INT(XMAX)  +1
      LMY2=INT(YMAX)  +1
      LMZ2=INT(ZMAX)  +1

! construct list of occupied sites

      NAT=0
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ)
         DO JY=LMY1,LMY2
            Y=REAL(JY)
            RYZ2=Y**2+Z**2
            RYZ=SQRT(RYZ2)
            IF(RYZ2>ZERO)THEN
               COSPH=Y/RYZ
               SINPH=Z/RYZ
            ELSE
               COSPH=ONE
               SINPH=ZERO
            ENDIF
            DO JX=LMX1,LMX2
               X=REAL(JX)
               R=SQRT(RYZ2+X**2)
               IF(R>0.)THEN
                  COSTH=X/R
               ELSE
                  COSTH=ONE
               ENDIF
               IF(COSPH>=0.)THEN
                  PHI=ASIN(SINPH)
               ELSEIF(COSPH<0)THEN
                  PHI=PI-ASIN(SINPH)
               ENDIF

               RAD=AEFF*RGSPHER(COSTH,PHI,LMAX,NMAX,S2,ALM)
               IF(RAD>=R)THEN

! Site is occupied:

                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
!***
!                     write(0,*)'nat=',nat
!                     write(0,*)'mxnat=',mxnat
!***
                     CALL ERRMSG('FATAL','TARGSPHER',' NAT > MXNAT ')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDIF
            ENDDO
         ENDDO
      ENDDO

! Homogeneous target:

      DO JA=1,NAT
         DO JX=1,3
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

! Specify target axes A1 and A2
! If PRINAX=0, then
!     A1=(1,0,0) in target frame
!     A2=(0,1,0) in target frame
! If PRINAX=1., then
!     A1,A2 are principal axes of largest, second largest moment
!     of inertia

      IF(PRINAX<=ZERO)THEN
         DO JX=1,3
            A1(JX)=ZERO
            A2(JX)=ZERO
         ENDDO
         A1(1)=ONE
         A2(2)=ONE
      ELSE

         CALL PRINAXIS(MXNAT,NAT,ICOMP,IXYZ,DX,A1,A2,ALPHA)

      ENDIF

! Set X0 so that origin is at the centroid

      DO JY=1,3
         X0(JY)=0._WP
         DO JX=1,NAT
            X0(JY)=X0(JY)+REAL(IXYZ(JX,JY))
         ENDDO
         X0(JY)=-X0(JY)/REAL(NAT)
      ENDDO

!-----------------------------------------------------------------------
! Write target description into string CDESCR
! Note: string CDESCR will be printed by subr. TARGET

      WRITE(CDESCR,FMT='(A,I7,A)')                         &
            ' gaussian sphere target of NAT=',NAT,' dipoles'

!-----------------------------------------------------------------------

! Here print any additional information which is desired by using
! subroutine WRIMSG


      WRITE(CMSGNM,FMT='(A,I7,A)')' Gaussian sphere: NAT=',NAT,' dipoles'

      CALL WRIMSG('TARGSPHER',CMSGNM)

      IF(IOSHP>0)THEN

! if this is a new shape, write the ALM value out to a file

         IF(BETA>0)THEN

            OPEN(UNIT=IOSHP,FILE='targspher.alm')
            WRITE(IOSHP,9100)S2LMAX,S2,F1,BETA,LMAX,NINT(RSEED),    &
                             NAT,AEFF,(0.75*NAT/PI)**(1./3.),ALPHA, &
                             A1,A2,LMAX
            DO L=1,LMAX
               DO M=0,L
                  WRITE(IOSHP,9110)L,M,ALM(L,M)
               ENDDO
            ENDDO
            CLOSE(IOSHP)

         ENDIF

         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')

!*** 3 lines of general description allowed:

         WRITE(IOSHP,9020)S2LMAX,S2,F1,BETA,LMAX,NINT(RSEED),           &
               NAT,AEFF,(0.75_WP*NAT/PI)**(1._WP/3._WP),ALPHA,A1,A2,DX,X0

!***

         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
 7600 FORMAT(                                                          &
        'three cross sectional slices for spherical harmonic grain',/, &
        I3,' = LMAX (highest order for Y_lm)',/,                       &
        '------ slice 1 ------ ------ slice 2 ------ ',                &
        '------ slice 3 ------',/,                                     &
        ' theta  phi   r/a_eff  theta  phi   r/a_eff  ',               &
        'theta  phi   r/a_eff')
 7700 FORMAT(F6.4,F7.4,F8.4,2(2F7.4,F8.4))
 9020 FORMAT('> TARGSPHER:',F7.5,F7.4,F6.3,F5.2,I3,I4,            &
         ' = <s^2>_Lmax, <s^2>, f_1, beta, Lmax, ISEED',          &
         ' for gaussian sphere',/,                                &
         I10,5F8.4,' = NAT, AEFF(in) a_eff/d, alpha_1-3',/,        &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                              &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
 9030 FORMAT(I7,3I4,' 1 1 1')
 9100 FORMAT(                                                          &
        F7.5,F7.4,F6.3,F5.2,I3,I4,' = <s^2>_lmax, <s^2>, f_1, beta, ', &
        'Lmax, ISEED for gaussian sphere',/,                           &
        I7,2F8.4,3F8.4,' = NAT, a_eff/d, alpha_1-3',/,                 &
        3F9.4,' = A_1 vector',/,                                       &
        3F9.4,' = A_2 vector',/,                                       &
        I4,' = Lmax',/,                                                &
        ' L   M   Re(a_LM)  Im(a_LM)')
 9110 FORMAT(I3,I4,2F10.6)
    END SUBROUTINE TARGSPHER

    FUNCTION RGSPHER(COSTH,PHI,LMAX,NMAX,S2,ALM)
      USE DDPRECISION,ONLY: WP
      IMPLICIT NONE

! Arguments:

      INTEGER :: LMAX,NMAX
      REAL(WP) :: COSTH,PHI,RGSPHER,S2
      COMPLEX(WP) :: ALM(1:NMAX,0:NMAX)

! Local variables:

      INTEGER :: L,M
      REAL(WP) :: FAC,FOURPI,SIGN,SUM,Y_L0
      COMPLEX(WP) :: CXI,CXTERM

! External functions

      REAL(WP) :: P_LM
      EXTERNAL P_LM

!-----------------------------------------------------------------------
! FUNCTION RGSPHER
! Given:
!    COSTH = cos(theta)
!    PHI   = phi (radians)
!    LMAX = maximum order of spherical harmonics
!    S2   = <s^2>
!    ALM  = complex array of spherical harmonic amplitudes a_lm
!           L=1,...,LMAX , M=-0,..,L
!           Note that we do not require the ALM for m<0, since these
!           are obtained from the values for m>0 using
!           a_{l,-m} = (-1)^m conjg(a_{l,m})

! Returns
!    RGSPHER = distance from "center" to surface for target with
!              a_eff=1.
!                    1             Lmax  l
!            = ------------ * exp[ sum  sum a_lm Y_lm ]
!              sqrt(1+<s^2>)       l=1  m=-l
!
! Requires:
! External function P_LM(L,M,X) to return associated Legendre
!                               polynomial
!                               at the moment this function resides
!                               in file tarspharm.f
!
! Note: we assume that a_{l,-m} = (-1)^m conjg(a_{l,m})
!       so that sum over spherical harmonics gives real function
!
! History
! 02.11.12 (BTD) first written
! 03.11.08 (BTD) gaussian sphere version first created
! end history
!
! Copyright (C) 2002,2003 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!-----------------------------------------------------------------------
      FOURPI=16._WP*ATAN(1._WP)
      CXI=(0._WP,1._WP)

      SUM=0._WP
     
      DO L=1,LMAX
         FAC=SQRT(REAL(2*L+1)/FOURPI)
         Y_L0=FAC*P_LM(L,0,COSTH)

         SUM=SUM+REAL(ALM(1,0))*Y_L0
         SIGN=1._WP
         DO M=1,L
            FAC=FAC/SQRT(REAL((L+M)*(L+1-M)))
            SIGN=-SIGN
            CXTERM=ALM(L,M)*EXP(CXI*REAL(M)*PHI)
            SUM=SUM+FAC*P_LM(L,M,COSTH)*2._WP*REAL(CXTERM)
         ENDDO
      ENDDO

      RGSPHER=EXP(SUM)/SQRT(1._WP+S2)

!*** diagnostic
!      write(17,*)'cos(theta),phi=',costh,phi,' rgspher=',rgspher
!***
      RETURN
      END

    SUBROUTINE TAR3EL(A1,A2,AX,AY,AZ,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE
!** Arguments:
      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP,MXNAT,NAT
      INTEGER*2 ::    &
         ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: AX,AY,AZ
      REAL(WP) :: & 
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

!** Local variables:
      CHARACTER :: CMSGNM*70
      INTEGER :: JA,JX,JXMAX,JXMIN,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1, &
        LMZ2,NAT2
      REAL(WP) :: AX2,AY2,AZ2,R,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF
!***********************************************************************

! Routine to construct three collinear touching ellipsoids from "atoms"
! Input:
!        AX=(x-length of one ellipsoid)/d    (d=lattice spacing)
!        AY=(y-length of one ellipsoid)/d
!        AZ=(z-length of one ellipsoid)/d
!        DX(1-3)=lattice spacing(dx,dy,dz)/d [d=(dx*dy*dz)**(1/3)]
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Fr
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Fr
!        NAT=number of dipoles in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for target dipole locations
!        ICOMP(1-NAT,1-3)=x,y,z composition for dipole locations
!                        = 1 for locations in first ellipsoid
!                          2                  second
!                          3                  third
!        CDESCR=description of target (up to 67 characters)
! Note: atoms 1       - NAT/3   are in first ellipsoid
!             NAT/3+1 - 2*NAT/3 are in second ellipsoid
!             2*NAT/3+1 - NAT   are in third ellipsoid
! Ellipsoids are displaced from one another in x-direction
! First ellipsoid is at smallest x values, third at largest
! B.T.Draine, Princeton Univ. Obs.

! History:
! 93.01.20 (BTD): adapted from tar2el.f
! 93.03.12 (BTD): changed CDESCR*(*) -> CDESCR*67
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.12.26 (BTD): Added DX(3) to argument list to support nonuniform
!                 lattice spacing.
!                 *** Note: additional code modifications required
!                     to support noncubic lattice!
! 98.03.06 (BTD): If called with noncubic lattice (not yet supported)
!                 call ERRMSG and halt with fatal error.
! 98.03.07 (BTD): Modify to write DX to file "target.out" for
!                 compatibility with REASHP
! 00.11.02 (BTD): Add ICOMP to argument list
!                 Set ICOMP=1,2,3 for first,second,third ellipsoid
!                 Write ICOMP to target.out
! 07.09.11 (BTD): Changed IXYZ from INTEGER*2 to INTEGER
! 08.01.13 (BTD): Cosmetic changes
!                 Added X0 to argument list
!                 Added code to evaluate X0, assuing TF origin to be
!                 located at centroid of 3 ellipses.
! 08.08.30 (BTD): Modified format 9020
! end history

! Copyright (C) 1993,1996,1997,1998,2000,2007,2008 
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Current version of TAR3EL is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TAR3EL', &
                     ' tar3el does not support noncubic lattice')
      ENDIF

! Routine to construct pseudo-ellipsoidal target aray.
! With occupied array sites contained within ellipsoidal surface
! defined by (X/AX)**2+(Y/AY)**2+(Z/AZ)**2=0.25
! Ideal volume V=(pi/6)*AX*AY*AZ

! Dipoles are located at sites
! (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
!                                 XOFF,YOFF,ZOFF=constants

! For sphere: call with AX=AY=AZ
! For spheroid: call with AX=AY (or AY=AZ or AX=AZ)
! B.T.Draine, Princeton Univ. Obs., 88/8/12

! Criterion for choosing XOFF:
! If AX is close to an even integer, take XOFF=1/2
! If AX is close to an odd integer, take XOFF=0

      JX=INT(AX+.5_WP)
      IF(2*(JX/2)==JX)THEN
         XOFF=0.5_WP
      ELSE
         XOFF=0._WP
      ENDIF

! Similar criterion for YOFF:

      JY=INT(AY+.5_WP)
      IF(2*(JY/2)==JY)THEN
         YOFF=0.5_WP
      ELSE
         YOFF=0._WP
      ENDIF

! Similar criterion for ZOFF:

      JZ=INT(AZ+.5_WP)
      IF(2*(JZ/2)==JZ)THEN
         ZOFF=0.5_WP
      ELSE
         ZOFF=0._WP
      ENDIF

      LMX1=-INT(.5_WP*AX+.5_WP)
      LMX2=INT(.5_WP*AX-.25_WP)
      LMY1=-INT(.5_WP*AY+.5_WP)
      LMY2=INT(.5_WP*AY-.25_WP)
      LMZ1=-INT(.5_WP*AZ+.5_WP)
      LMZ2=INT(.5_WP*AZ-.25_WP)
      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      NAT=0

! Specify target axes A1 and A2
! Previous convention: A1 along longest dimension
!                      A2 along intermediate dimension
! New convention: A1=(1,0,0) in target frame
!                 A2=(0,1,0) in target frame

      DO JX=1,3
         A1(JX)=0._WP
         A2(JX)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! Determine list of occupied sites in first ellipsoid

      JXMAX=LMX1
      JXMIN=LMX2
      DO JZ=LMZ1,LMZ2
         Z=REAL(JZ,KIND=WP)+ZOFF
         RZ2=Z*Z/AZ2
         IF(RZ2<0.25_WP)THEN
            DO JY=LMY1,LMY2
               Y=REAL(JY,KIND=WP)+YOFF
               RYZ2=RZ2+Y*Y/AY2
               IF(RYZ2<0.25_WP)THEN
                  DO JX=LMX1,LMX2
                     X=REAL(JX,KIND=WP)+XOFF
                     R=RYZ2+X*X/AX2
                     IF(R<0.25_WP)THEN
! Site is occupied:
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                        IF(NAT>1)THEN
                           IF(JX>JXMAX) JXMAX=JX
                           IF(JX<JXMIN) JXMIN=JX
                        ELSE
                           JXMAX=JX
                           JXMIN=JX
                        ENDIF
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO
      DO JX=1,3
         DO JA=1,NAT
            ICOMP(JA,JX)=1
         ENDDO
      ENDDO

      IF(3*NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF

! Now create duplicate second and third ellipsoids

      JXMAX=JXMAX-JXMIN+1
      DO JA=1,NAT
         IXYZ(NAT+JA,1)=IXYZ(JA,1)+JXMAX
         IXYZ(NAT+JA,2)=IXYZ(JA,2)
         IXYZ(NAT+JA,3)=IXYZ(JA,3)
         IXYZ(2*NAT+JA,1)=IXYZ(JA,1)+2*JXMAX
         IXYZ(2*NAT+JA,2)=IXYZ(JA,2)
         IXYZ(2*NAT+JA,3)=IXYZ(JA,3)
      ENDDO
      NAT=3*NAT
      DO JX=1,3
         DO JA=NAT/3+1,2*NAT/3
            ICOMP(JA,JX)=2
         ENDDO
         DO JA=2*NAT/3+1,NAT
            ICOMP(JA,JX)=3
         ENDDO
      ENDDO

! Now find X0, assuming TF origin to be at centroid

      DO JY=1,3
         X0(JY)=0._WP
         DO JA=1,NAT
            X0(JY)=X0(JY)+REAL(IXYZ(JA,JY))
         ENDDO
         X0(JY)=-X0(JY)/REAL(NAT)
      ENDDO

!***********************************************************************
! Write target description into string CDESCR

      NAT2=NAT/3
      IF(AX==AY.AND.AX==AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A)')' Three spheres, each containing', &
                                     NAT2,' dipoles'
      ELSE
         WRITE(CDESCR,FMT='(A,I7,A)')' Three ellipsoids, each containing', &
                                     NAT2,' dipoles'
      ENDIF
!***********************************************************************
      CMSGNM=CDESCR
      CALL WRIMSG('TARELL',CMSGNM)
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020) AX,AY,AZ,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARELL  ellipsoidal grain; AX,AY,AZ=',3F8.4,/,    &
         I10,' = NAT',/,                                           &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                              &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TAR3EL

    PROGRAM CALLTARGET

      USE DDPRECISION,ONLY : WP
      USE DDCOMMON_1,ONLY : DX
      USE DDCOMMON_6,ONLY : GAMMA,PYD,PZD,MXNATF,MXNXF,MXNYF,MXNZF,NAT,NAT3, &
                            NAT0,NX,NY,NZ,MXN3F,IDVOUT,IPBC
      IMPLICIT NONE

! Program CALLTARGET is used to generate target arrays using target
! generation routines employed by DDSCAT.

! B.T.Draine, Princeton Univ. Obs., 91/1/1
! History:
! 91.05.24 (BTD): Modified to allow entry target names in lower case
! 91.07.16 (BTD): Replaced DO...ENDDO with DO #...# CONTINUE
! 92.12.16 (BTD): Added IDVSHP to argument list of TARGET
! 93.01.07 (BTD): Added options TWOELL and TWOAEL
! 94.05.15 (BTD): Added option CONELL
! 95.12.11 (BTD): Added option BLOCKS
! 96.01.04 (BTD): Added option DW1996
! 96.01.25 (BTD): Added option TWOSPH
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ here and in TARGET
!                 Added calls to SIZER
! 96.01.29 (BTD): Support selection of principal axis calculation
!                 in TAR2SP via SHPAR(6)
! 97.04.25 (BTD): Added option BLK_AN
! 97.04.30 (BTD): Removed code offering choice on target axis for
!                 HEXGON option (target axis now hardwired within
!                 TARHEX)
! 00.06.12 (BTD): Added option NSPHER
! 02.02.13 (BTD): Added option PRISM3
! 02.11.12 (BTD): Added option SPHARM
! 03.11.06 (BTD): Modified to input parameters to generate random
!                 SPHARM target
!                 Added DX(3) to argument list of TARGET
! 03.11.08 (BTD): Added option GSPHER
! 04.03.31 (BTD): Replaced all WRITE(0, with WRITE(IDVOUT,
! 04.04.01 (BTD): Added NPY,NPZ to argument list of TARGET,
!                 so we can use new version of TARGET that supports
!                 periodic boundary conditions
! 04.10.02 (BTD): Declared BETADF,PHIDF,THETADF
!                 Added BETADF,PHIDF,THETADF to argument list of
!                 subroutine TARGET
! 04.10.19 (BTD): Modified to allow repeated trials of different
!                 SHPAR(1) for NSPHER and NANSPH options
! 05.06.16 (BTD): Replaced integer NPY,NPZ by real PYD,PZD in
!                 argument list of TARGET
! 06.09.13 (BTD): Added option CYLCAP
! 06.09.15 (BTD): Modified option HEXGON to allow orientation to
!                 be changed.
! 06.12.08 (BTD): Modified to support PBXPBC option
! 08.08.30 (BTD): Added IANISO to argument list of TARGET
! 08.08.31 (BTD): Added options including BISLINPBC
! 08.09.12 (BTD): Correcte typos DSKRCTGNL -> DSKRCTNGL
! end history
!
! Copyright (C) 1993,1994,1995,1996,1997,2000,2002,2003,2004,2005
!               2006,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
!
! Adjustable parameters:
!    MXNAT=max.number of dipoles in target
!
      INTEGER :: MXN3,MXNAT

! Arguments of TARGET:

      CHARACTER :: CDESCR*67,CFLSHP*80,CSHAPE*9

      INTEGER*2,ALLOCATABLE :: &
     &   ICOMP(:,:)

      INTEGER,ALLOCATABLE :: &
     &   IXYZ(:,:)

      INTEGER :: IANISO,IDVSHP,IOSHP
      REAL(WP) ::   &
         A1(3),     &
         A2(3),     &
         SHPAR(12), &
         X0(3)
      REAL(WP),ALLOCATABLE :: &
         BETADF(:),           &
         PHIDF(:),            &
         THETADF(:)

! Local variables:

      INTEGER :: J,JJ
      INTEGER :: LXYZ(3)
      REAL(WP) :: ERR,F,PI,RGYR2,RXY,RXZ,RYX,RYZ,RZX,RZY, &
              X,XCM,Y,YCM,Z,ZCM
      REAL(WP) :: DDX,DDY,DDZ,X2,Y2,Z2
!***********************************************************************
      DATA IOSHP/15/

      MXNAT=2000000
      MXN3=3*MXNAT

      ALLOCATE(IXYZ(MXNAT,3))
      ALLOCATE(ICOMP(MXNAT,3))
      ALLOCATE(BETADF(MXNAT))
      ALLOCATE(PHIDF(MXNAT))
      ALLOCATE(THETADF(MXNAT))

      PI=4.*ATAN(1.)

! Define variables CFLSHP and IDVSHP:

      CFLSHP='none'
      IDVSHP=10
 1000 WRITE(IDVOUT,*)'What shape? (Enter choice in quotes) Choices:'
      WRITE(IDVOUT,*)'  ANIELLIPS = anisotropic ellipsoid'
      WRITE(IDVOUT,*)'  ANI_ELL_2 = 2 touching identical anisotropic ', &
                     'ellipsoids'
      WRITE(IDVOUT,*)'  ANI_ELL_3 = 3 touching identical anisotropic ', &
                     'ellipsoids'
      WRITE(IDVOUT,*)'  ANIRCTNGL = anisotropic rectangular solid'
      WRITE(IDVOUT,*)'  CONELLIPS = 2 concentric ellipsoids'
      WRITE(IDVOUT,*)'  CYLINDER1 = homogenous, isotropic cylinder'
      WRITE(IDVOUT,*)'  CYLNDRCAP = homogenous, isotropic cylinder with ', &
                     'hemispherical endcaps'
      WRITE(IDVOUT,*)'  DSKRCTNGL = disk on homogeneous rectangular block'
      WRITE(IDVOUT,*)'  DW1996TAR = 13 cube target used by Draine & ', &
                     'Weingartner (1996)'
      WRITE(IDVOUT,*)'  ELLIPSOID = homogenous, isotropic ellipsoid'
      WRITE(IDVOUT,*)'  ELLIPSO_2 = 2 touching ellipsoids; 2nd ellipsoid ', &
                     'is displaced from 1st in x-direction'
      WRITE(IDVOUT,*)'  ELLIPSO_3 = 3 touching ellipsoids; 2nd ellipsoid ', &
                     'displaced from 1st in +x-direction,'
      WRITE(IDVOUT,*)'              3rd displaced from 2nd in +x-direction'
!      WRITE(IDVOUT,*)'  GAUSS_SPH = gaussian sphere target'
      WRITE(IDVOUT,*)'  HEX_PRISM = hexagonal prism'
      WRITE(IDVOUT,*)'  MLTBLOCKS = construct from cubic blocks, input ', &
                     'from file "blocks.par"'
      WRITE(IDVOUT,*)'  RCTGLPRSM = rectangular prism'
      WRITE(IDVOUT,*)'  RCTGLBLK3 = stack of 3 rectangular blocks'
      WRITE(IDVOUT,*)'  SPHERES_N = union of N spheres'
      WRITE(IDVOUT,*)'  SPHROID_2 = 2 touching spheroids (with angle ', &
                     'phi between symm. axes'
      WRITE(IDVOUT,*)'  SPH_ANI_N = N-spheres of anisotropic materials'
      WRITE(IDVOUT,*)'  TETRAHDRN = regular tetrahedron'
      WRITE(IDVOUT,*)'  TRNGLPRSM = triangular prism'
!---------------------- PBC target options start here ---------------------
      WRITE(IDVOUT,*)'  BISLINPBC = bilayer slab with parallel lines'
      WRITE(IDVOUT,*)'  DSKBLYPBC = disk on bilayer slab (one unit cell)'
      WRITE(IDVOUT,*)'  DSKRCTPBC = disk on slab (one unit cell)'

! at this time, restrict to cubic lattice:

      DX(1)=1.
      DX(2)=1.
      DX(3)=1.

      READ(*,*)CSHAPE
!-----------------------------------------------------------------------
      IF(CSHAPE=='ANIELLIPS'.OR.CSHAPE=='aniellips')THEN
         CSHAPE='ANIELLIPS'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x-length/d, y-length/d, z-length/d ', &
                           '(0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)SHPAR(1),SHPAR(2),SHPAR(3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ANI_ELL_2'.OR.CSHAPE=='ani_ell_2')THEN
         CSHAPE='ANI_ELL_2'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z', &
                           ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ANI_ELL_3'.OR.CSHAPE=='ani_ell_3')THEN
         CSHAPE='ANI_ELL_3'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of one ellipsoid in x, y, z', &
                           ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ANIRCTNGL'.OR.CSHAPE=='anirctngl')THEN
         CSHAPE='ANIRCTNGL'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length/d in x, y, z', &
                           ' directions (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='BISLINPBC'.OR.CSHAPE=='bislinpbc')THEN
         CSHAPE='BISLINPBC'
         WRITE(IDVOUT,*)'TUC for bilayer slab with parallel line on top'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x-thickness/d of line (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0)STOP
            WRITE(IDVOUT,*)'Enter z-width/d of line'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter x-thickness/d of upper layer'
            READ(*,*)SHPAR(3)
            WRITE(IDVOUT,*)'Enter x-thickness/d of lower layer'
            READ(*,*)SHPAR(4)
            WRITE(IDVOUT,*)'Enter L_y/d, L_z/d dimensions of slab'
            READ(*,*)SHPAR(5),SHPAR(6)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='CONELLIPS'.OR.CSHAPE=='conellips')THEN
         CSHAPE='CONELLIPS'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length of outer ellipsoid (icomp=2) ', &
                           'in x,y,z directions (lattice units) (0 0 0', &
                           ' to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0)STOP
            WRITE(IDVOUT,*)'Enter length of inner ellipsoid (icomp=1) ', &
                           'in x,y,z directions (lattice units)'
            READ(*,*)SHPAR(4),SHPAR(5),SHPAR(6)
            IF(SHPAR(4).LE.SHPAR(1).AND. &
               SHPAR(5).LE.SHPAR(2).AND. &
               SHPAR(6).LE.SHPAR(3))THEN
               CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,        &
                           MXNAT,SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,           &
                           MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
               CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
               WRITE(IDVOUT,7006)(SHPAR(JJ),JJ=1,6),NAT
            ELSE
               WRITE(IDVOUT,*)'Input error: inner ellipsoid is not ', &
                              'contained within outer ellipsoid'
            ENDIF
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='CYLINDER1'.OR.CSHAPE=='cylinder1')THEN
         CSHAPE='CYLINDER1'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter cylinder length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter cylinder diameter'
            READ(*,*)SHPAR(2)
            SHPAR(3)=1     ! 1 for cylinder axis in x direction
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7002)SHPAR(1),SHPAR(2),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='CYLNDRCAP'.OR.CSHAPE=='cylndrcap')THEN
         CSHAPE='CYLNDRCAP'
         WRITE(IDVOUT,*)' CYLNDRCAP: cylinder with hemispherical endcaps'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter cylinder length (not including ', &
                           'end-caps) (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter cylinder diameter'
            READ(*,*)SHPAR(2)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7002)SHPAR(1),SHPAR(2),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKRCTPBC'.OR.CSHAPE=='dskrctpbc')THEN
         CSHAPE='DSKRCTPBC'
         WRITE(IDVOUT,*)'TUC for array of (disk on slab)'
         WRITE(IDVOUT,*)'With disk located on x=0 surface'
         WRITE(IDVOUT,*)'Enter disk thickness/d and diameter/d (0 0 to stop)'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(IDVOUT,*)'Enter slab dimensions Lx/d  Ly/d  Lz/d'
         READ(*,*)SHPAR(3),SHPAR(4),SHPAR(5)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKBLYPBC'.OR.CSHAPE=='dskblypbc')THEN
         CSHAPE='DSKBLYPBC'
         WRITE(IDVOUT,*)'TUC for array of (disk on top of bilayer slab)'
         WRITE(IDVOUT,*)'With disk (comp. 1) located on x=0 surface'
         WRITE(IDVOUT,*)'Enter disk thickness/d and diameter/d (0 0 to stop)'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(IDVOUT,*)'Enter thickness/d of upper layer of slab (comp. 2)'
         READ(*,*)SHPAR(3)
         WRITE(IDVOUT,*)'Enter thickness/d of lower layer of slab (comp. 3)'
         READ(*,*)SHPAR(4)
         WRITE(IDVOUT,*)'Enter slab extent Ly/d  Lz/d'
         READ(*,*)SHPAR(5),SHPAR(6)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DSKRCTNGL'.OR.CSHAPE=='dskrctngl')THEN
         CSHAPE='DSKRCTNGL'
         WRITE(IDVOUT,*)'Rectangular slab with dimension Lx x Ly x Lz'
         WRITE(IDVOUT,*)'With disk located on x=0 surface'
         WRITE(IDVOUT,*)'Enter disk thickness/d and diameter/d'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(IDVOUT,*)'Enter Lx/d  Ly/d  Lz/d'
         READ(*,*)SHPAR(3),SHPAR(4),SHPAR(5)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='DW1996TAR'.OR.CSHAPE=='dw1996tar')THEN
         CSHAPE='DW1996TAR'
         WRITE(IDVOUT,*)'Enter block size (lattice units)'
         READ(*,*)SHPAR(1)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         WRITE(IDVOUT,7001)SHPAR(1),NAT
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ELLIPSOID'.OR.CSHAPE=='ellipsoid')THEN
         CSHAPE='ELLIPSOID'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter ellipsoid diameters xv,yv,zv', &
                           ' (0,0,0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)stop
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            XCM=0.
            YCM=0.
            ZCM=0.
            DO JJ=1,NAT
               X=IXYZ(JJ,1)
               Y=IXYZ(JJ,2)
               Z=IXYZ(JJ,3)
               XCM=XCM+X
               YCM=YCM+Y
               ZCM=ZCM+Z
            ENDDO
            XCM=XCM/REAL(NAT)
            YCM=YCM/REAL(NAT)
            ZCM=ZCM/REAL(NAT)
            X2=0.
            Y2=0.
            Z2=0.
            DO JJ=1,NAT
               DDX=IXYZ(JJ,1)-XCM
               DDY=IXYZ(JJ,2)-YCM
               DDZ=IXYZ(JJ,3)-ZCM
               X2=X2+DDX*DDX
               Y2=Y2+DDY*DDY
               Z2=Z2+DDZ*DDZ
            ENDDO
            X2=X2/NAT+1./12.
            Y2=Y2/NAT+1./12.
            Z2=Z2/NAT+1./12.
            ERR=20.*PI*SQRT(5.*REAL(X2*Y2*Z2))/(3.*REAL(NAT))-1.
            RXY=REAL(SQRT(X2/Y2))
            RYZ=REAL(SQRT(Y2/Z2))
            RZX=REAL(SQRT(Z2/X2))
            RYX=1./RXY
            RZY=1./RYZ
            RXZ=1./RZX
            X2=2.*SQRT(5.*X2)
            Y2=2.*SQRT(5.*Y2)
            Z2=2.*SQRT(5.*Z2)
            WRITE(*,6200)SHPAR(1),SHPAR(2),SHPAR(3),NAT,X2,Y2,Z2,ERR, &
                         RYX,RZX,RYZ,RXY,RXZ,RZY
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ELLIPSO_2'.OR.CSHAPE=='ellipso_2')THEN
         CSHAPE='ELLIPSO_2'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x,y,z length/d for one ', &
                           'ellipsoid (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)SHPAR(1),SHPAR(2),SHPAR(3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='ELLIPSO_3'.OR.CSHAPE=='ellipso_3')THEN
         CSHAPE='ELLIPSO_3'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x,y,z length/d for one ', &
                           'ellipsoid (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)SHPAR(1),SHPAR(2),SHPAR(3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='HEX_PRISM'.OR.CSHAPE=='hex_prism')THEN
         CSHAPE='HEX_PRISM'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter length (along symmetry axis)', &
                           ' (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter length of 1 hexagon side'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Specify orientation of axes a1 (hex axis) ', &
                           'and a2'
            WRITE(IDVOUT,*)' 1 for a1=x,a2=y'
            WRITE(IDVOUT,*)' 2 for a1=x,a2=z'
            WRITE(IDVOUT,*)' 3 for a1=y,a2=x'
            WRITE(IDVOUT,*)' 4 for a1=y,a2=z'
            WRITE(IDVOUT,*)' 5 for a1=z,a2=x'
            WRITE(IDVOUT,*)' 6 for a1=z,a2=y'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='LAYRDSLAB'.OR.CSHAPE=='layrdslab')THEN
         CSHAPE='LAYRDSLAB'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x,y,z length/d ', &
                           ' (0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter fractions f1,f2,f3 (f1+f2+f3.le.1)'
            READ(*,*)SHPAR(4),SHPAR(5),SHPAR(6)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7001)SHPAR(1),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='MLTBLOCKS'.OR.CSHAPE=='mltblocks')THEN
         CSHAPE='MLTBLOCKS'
         WRITE(IDVOUT,*)'MLTBLOCKS : target defined by file blocks.par'
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         WRITE(IDVOUT,7000)NAT
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='RCTGLPRSM'.OR.CSHAPE=='rctglprsm')THEN
         CSHAPE='RCTGLPRSM'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x-length (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter y-length'
            READ(*,*)SHPAR(2)
            WRITE(IDVOUT,*)'Enter z-length'
            READ(*,*)SHPAR(3)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7003)(SHPAR(JJ),JJ=1,3),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='RCTGLBLK3'.OR.CSHAPE=='rctglblk3')THEN
         CSHAPE='RCTGLBLK3'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter x,y,z length/d for first block ', &
                           ' (0 0 0 to stop)'
            READ(*,*)SHPAR(1),SHPAR(2),SHPAR(3)
            IF(SHPAR(1).LE.0.)STOP
            WRITE(IDVOUT,*)'Enter x,y,z length/d for second block '
            READ(*,*)SHPAR(4),SHPAR(5),SHPAR(6)
            WRITE(IDVOUT,*)'Enter x,y,z length/d for third block '
            READ(*,*)SHPAR(7),SHPAR(8),SHPAR(9)
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7001)SHPAR(1),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='SPHERES_N'.OR.CSHAPE=='spheres_n')THEN
         CSHAPE='SPHERES_N'
         WRITE(IDVOUT,*)'Enter DIAMX = target extent in x-direction'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ', &
                        'in TF'
         WRITE(IDVOUT,*)'            =1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
         WRITE(IDVOUT,*)'Enter name of sphere parameter file (e.g., ', &
                   'tarnsp.par [in quotes])'
         READ(*,*)CFLSHP
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='SPHROID_2'.OR.CSHAPE=='sphroid_2')THEN
         CSHAPE='SPHROID_2'
         WRITE(IDVOUT,*)'Enter length a_1 and diameter b_1 of 1st ', &
                        'spheroid'
         READ(*,*)SHPAR(1),SHPAR(2)
         WRITE(IDVOUT,*)'Enter length a_2 and diameter b_2 of 2nd ', &
                        'spheroid'
         READ(*,*)SHPAR(3),SHPAR(4)
         WRITE(IDVOUT,*)'Enter angle phi (deg) between axes a_1 and ', &
                        'a_2'
         READ(*,*)SHPAR(5)
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ', &
                        'in TF'
         WRITE(IDVOUT,*)'            =1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(6)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         WRITE(IDVOUT,7006)
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='SPH_ANI_N'.OR.CSHAPE=='sph_ani_n')THEN
         CSHAPE='SPH_ANI_N'
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ', &
                        'in TF'
         WRITE(IDVOUT,*)'            =1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
         WRITE(IDVOUT,*)'Enter name of sphere parameter file (e.g., ', &
                   'tarnsp.par [in quotes])'
         READ(*,*)CFLSHP
         DO J=1,100
            WRITE(IDVOUT,*)'Enter DIAMX = target extent in x-direction', &
                           ' (0 to stop)'
            READ(*,*)SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP

            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='TETRAHDRN'.OR.CSHAPE=='tetrahdrn')THEN
         CSHAPE='TETRAHDRN'
         DO J=1,100
            WRITE(IDVOUT,*)'Enter tetrahedron side length ', &
                           ' (0 to stop)'
            READ(*,*)SHPAR(1)
            SHPAR(2)=SHPAR(1)
            SHPAR(3)=SHPAR(1)
            IF(SHPAR(1).LE.0.)STOP
            CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                        SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                        MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
            CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
            WRITE(IDVOUT,7001)SHPAR(1),NAT
         ENDDO
         STOP
!-----------------------------------------------------------------------
      ELSEIF(CSHAPE=='TRNGLPRSM'.OR.CSHAPE=='trnglprsm')THEN
         CSHAPE='TRNGLPRSM'
         WRITE(IDVOUT,*)'Enter a/d = first triangle side/d (0 to stop)'
         READ(*,*)SHPAR(1)
         IF(SHPAR(1).LE.0.)STOP
         WRITE(IDVOUT,*)'Enter b/a , c/a, L/a'
         READ(*,*)SHPAR(2),SHPAR(3),SHPAR(4)
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
! Note: this target option is not described in the DDSCAT UserGuide.
!       if you are interested in using it, please contact 
!       draine@astro.princeton.edu

      ELSEIF(CSHAPE=='GAUSS_SPH'.OR.CSHAPE=='gauss_sph')THEN
         CSHAPE='GAUSS_SPH'
         WRITE(IDVOUT,*)'Enter a_eff/d'
         READ(*,*)SHPAR(1)
         WRITE(IDVOUT,*)'Enter power law index beta > 1 (0 to input', &
                   ' a_lm from file targspher.alm)'
         READ(*,*)SHPAR(3)
         IF(SHPAR(3)==0)THEN
            WRITE(IDVOUT,*)'OK -- will read input params from targspher.alm'
            CFLSHP='targspher.alm'
         ELSEIF(SHPAR(3).GT.1.)THEN
            WRITE(IDVOUT,*)'Enter Lmax > 0 (e.g., 5)'
            READ(*,*)SHPAR(4)
            WRITE(IDVOUT,*)'Enter <s^2> (e.g., 0.05) [this includes ', &
                      'all a_lm up to NMAX (=100)'
            READ(*,*)SHPAR(5)
            WRITE(IDVOUT,*)'Enter integer seed > 0'
            READ(*,*)SHPAR(6)
         ELSE
            WRITE(IDVOUT,*)'Invalid value for BETA'
         ENDIF
         WRITE(IDVOUT,*)'Enter PRINAX=0 for a_1=(1,0,0),a_2=(0,1,0) ', &
                        'in TF'
         WRITE(IDVOUT,*)'             1 for a_1,a_2 = principal axes'
         READ(*,*)SHPAR(2)
!*** diagnostic
         WRITE(IDVOUT,*)'about to call target with ioshp=',ioshp
!***
         CALL TARGET(A1,A2,CSHAPE,CFLSHP,IDVSHP,IOSHP,CDESCR,MXNAT,  &
                     SHPAR,DX,NAT,IXYZ,ICOMP,IDVOUT,                 &
                     MXN3,NAT3,PYD,PZD,BETADF,PHIDF,THETADF,X0,IANISO)
         CALL SIZER(MXNAT,NAT,IXYZ,LXYZ)
         STOP
!-----------------------------------------------------------------------
      ELSE
         WRITE(IDVOUT,*)'CALLTARGET does not know how to make shape = ',CSHAPE
         GOTO 1000
      ENDIF
 6000 FORMAT(' AX=',F7.4,' NAT=',I7)
 6100 FORMAT(' AX=',F7.4,' AY=',F7.4,' AZ=',F7.4,' NAT=',I7,' F=',F10.6)
 6200 FORMAT('    XV =',F7.4,'    YV =',F7.4,'    ZV =',F7.4,   &
             ' NAT=',I8,/,                                      &
             ' 2a_eff=',F7.4,' 2b_eff=',F7.4,' 2c_eff=',F7.4,   &
             ' err=',F8.7,/,                                    &
             '   y:x =',F7.4,'   z:x =',F7.4,'   y:z =',F7.4,/, &
             '   x:y =',F7.4,'   x:z =',F7.4,'   z:y =',F7.4)
 7000 FORMAT('NAT=',I8)
 7001 FORMAT('SHPAR(1)=',F10.5,' NAT=',I8)
 7002 FORMAT('SHPAR(1-2)=',2F10.5,' NAT=',I8)
 7003 FORMAT('SHPAR(1-3)=',3F10.5,' NAT=',I8)
 7004 FORMAT('SHPAR(1-4)=',4F10.5,' NAT=',I8)
 7006 FORMAT('SHPAR(1-6_=',6F10.5,' NAT=',I8)
    END PROGRAM CALLTARGET

    SUBROUTINE TARELL(A1,A2,AX,AY,AZ,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

!** Arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP, MXNAT, NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER ::     &
         IXYZ(MXNAT,3)
      REAL(WP) :: AX, AY, AZ
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

!** Local variables:

      INTEGER :: JX,JY,JZ,LMX1,LMX2,LMY1,LMY2,LMZ1,LMZ2
      REAL(WP) :: AX2,AY2,AZ2,R,RYZ2,RZ2,X,XOFF,Y,YOFF,Z,ZOFF

!***********************************************************************
! Routine to construct ellipsoid from "atoms"
! Input:
!        AX=(x-length)/d    (d=lattice spacing)
!        AY=(y-length)/d
!        AZ=(z-length)/d
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=(1,0,0)=unit vector defining target axis 1 in Target Fr
!        A2(1-3)=(0,1,0)=unit vector defining target axis 2 in Target Fr
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=(x-x0(1))/d,(y-x0(2))/d,(z-x0(3))/d
!                        for atoms of target
!        CDESCR=description of target (up to 67 characters)
!        ICOMP(1-NAT,1-3)=1 (composition identifier)
!        X0(1-3)=(location/d) in Target Frame corresponding to dipole with
!                IXYZ=(0,0,0).  This will be treated at the origin of physical
!                coordinates in the TF.
!                Here origin is set to be centroid of ellipsoid.

! B.T.Draine, Princeton Univ. Obs.
! History:
! 91.01.05 (BTD): Changed I4 -> I7 when printing NAT
! 91.04.22 (BTD): Added AX,AY,AZ and A1,A2 to WRITE(IOSHP,FMT=9020)
! 91.05.01 (BTD): TEMPORARY hack to be able to reproduce all arrays
!                 used by Draine 88 (in which XOFF=YOFF=ZOFF=0.5 always)
! 92.10.26 (BTD): Added code to set string CDESCR
!                 Added one call to WRIMSG
! 93.01.01 (BTD): Changed method for determining target axes A1, A2
!                 [previous criteria -- A1 = longest dimension,
!                 A2 = intermediate dimension -- created confusion]
!                 new rule: A1=(1,0,0), A2=(0,1,0)
! 93.03.12 (BTD): Changed CDESCR*(*) -> CDESCR*67
! 96.01.26 (BTD): Replaced IX,IY,IZ by IXYZ
! 97.11.02 (BTD): Added DX to argument list, and modified to allow use
!                 of noncubic lattice
! 98.02.11 (BTD): Modified to write DX to file "target.out"
! 00.10.19 (BTD): Corrected to reduce length of string written to
!                 CDESCR for ellipsoidal grain
! 00.11.02 (BTD): Add ICOMP to argument list, return ICOMP=1
!                 Write ICOMP to target.out
! 07.09.11 (BTD): Change IXYZ from INTEGER*2 to INTEGER
! 08.01.13 (BTD): Cosmetic changes
!                 Added X0 to argument list
!                 Add code specifying (x,y,z)_TF = 0 to be at centroid
!                 of ellipsoid
! 08.02.07 (BTD): Corrected typo in evaluation of X0
! 08.08.29 (BTD): Modified format 9020
! end history

! Copyright (C) 1993,1996,1997,1998,2000,2007,2008 
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! Routine to construct pseudo-ellipsoidal target aray.
! With occupied array sites contained within ellipsoidal surface
! defined by (X/AX*d)**2+(Y/AY*d)**2+(Z/AZ*d)**2=0.25
! Ideal volume V=(pi/6)*AX*AY*AZ*d**3
! where d = effective lattice spacing

! Dipoles are located on lattice at sites
! (x,y,z)=(I+XOFF,J+YOFF,Z+KOFF), I,J,K=integers
!                                 XOFF,YOFF,ZOFF=constants

! For sphere: call with AX=AY=AZ
! For spheroid: call with AX=AY (or AY=AZ or AX=AZ)
! B.T.Draine, Princeton Univ. Obs., 88.08.12

! Criterion for choosing XOFF:
! If AX is close to an even integer, take XOFF=1/2
! If AX is close to an odd integer, take XOFF=0
!-----------------------------------------------------------------------
!*** diagnostic
!      write(0,*)'entered tarell,ax,ay,az=',ax,ay,az
!***
      JX=INT(AX/DX(1)+.5_WP)
      IF(2*(JX/2)==JX)THEN
         XOFF=0.5_WP
      ELSE
         XOFF=0._WP
      ENDIF

! Similar criterion for YOFF:

      JY=INT(AY/DX(2)+.5_WP)
      IF(2*(JY/2)==JY)THEN
         YOFF=0.5_WP
      ELSE
         YOFF=0._WP
      ENDIF

! Similar criterion for ZOFF:

      JZ=INT(AZ/DX(3)+.5_WP)
      IF(2*(JZ/2)==JZ)THEN
         ZOFF=0.5_WP
      ELSE
         ZOFF=0._WP
      ENDIF

      LMX1=-INT(.5_WP*AX/DX(1)+.5_WP)
      LMX2=INT(.5_WP*AX/DX(1)-.25_WP)
      LMY1=-INT(.5_WP*AY/DX(2)+.5_WP)
      LMY2=INT(.5_WP*AY/DX(2)-.25_WP)
      LMZ1=-INT(.5_WP*AZ/DX(3)+.5_WP)
      LMZ2=INT(.5_WP*AZ/DX(3)-.25_WP)
      AX2=AX*AX
      AY2=AY*AY
      AZ2=AZ*AZ
      NAT=0

! Specify target axes A1 and A2
! Convention: A1=(1,0,0) in target frame
!             A2=(0,1,0) in target frame

      DO JX=1,3
         A1(JX)=0._WP
         A2(JX)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

!*** diagnostic
!      write(0,*)'tarell, ckpt 2'
!***

! Determine list of occupied sites.

      DO JZ=LMZ1, LMZ2
         Z=(REAL(JZ,KIND=WP)+ZOFF)*DX(3)
         RZ2=Z*Z/AZ2
         IF(RZ2<0.25_WP)THEN
            DO JY=LMY1, LMY2
               Y=(REAL(JY,KIND=WP)+YOFF)*DX(2)
               RYZ2=RZ2 + Y*Y/AY2
               IF(RYZ2<0.25_WP)THEN
                  DO JX=LMX1, LMX2
                     X=(REAL(JX,KIND=WP)+XOFF)*DX(1)
                     R=RYZ2+X*X/AX2
                     IF(R<0.25_WP)THEN
! Site is occupied:
                        NAT=NAT+1
                        IXYZ(NAT,1)=JX
                        IXYZ(NAT,2)=JY
                        IXYZ(NAT,3)=JZ
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDIF
      ENDDO

!*** diagnostic
!      write(0,*)'tarell, ckpt 3'
!***
      IF(NAT>MXNAT)THEN
         CALL ERRMSG('FATAL','TARELL',' NAT.GT.MXNAT ')
      ENDIF

! Set composition

      DO JX=1,3
         DO JZ=1,NAT
            ICOMP(JZ,JX)=1
         ENDDO
      ENDDO

!*** diagnostic
!      write(0,*)'tarell, ckpt 4'
!***
! Set X0 so that origin is at centroid

      DO JY=1,3
         X0(JY)=0._WP
         DO JX=1,NAT
            X0(JY)=X0(JY)+REAL(IXYZ(JX,JY))
         ENDDO
         X0(JY)=-X0(JY)/REAL(NAT)
      ENDDO
!*** diagnostic
!      write(0,*)'tarell, ckpt 5'
!***
!***********************************************************************
! Write target description into string CDESCR
      IF(AX==AY.AND.AX==AZ)THEN
         WRITE(CDESCR,FMT='(A,I7,A,F6.3,F6.3,F6.3,A)')' Sphere,',NAT, &
            ' dipoles,',DX(1),DX(2),DX(3),'=x,y,z lattice spacing'
      ELSE
         WRITE(CDESCR,FMT='(A,I7,A,F6.3,F6.3,F6.3,A)')' Ellipsoid,',NAT, &
            ' dipoles,',DX(1),DX(2),DX(3),'=x,y,z lattice spacing'
      ENDIF
!***********************************************************************
!*** diagnostic
!      write(0,*)'tarell,ckpt 6, ioshp=',ioshp
!***
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)AX,AY,AZ,NAT,A1,A2,DX,X0
         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARELL  ellipsoidal grain; AX,AY,AZ=',3F8.4,/,     &
         I10,' = NAT',/,                                           &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')

9030  FORMAT (I7,3I4,3I2)
    END SUBROUTINE TARELL

    SUBROUTINE MPI_BCAST_INT2(INT2VAR,ICOUNT,IROOT,IERR)
      IMPLICIT NONE
!-----------------------------------------------------------------------

      INCLUDE 'mpif.h'

!-----------------------------------------------------------------------
! arguments
      INTEGER*2 :: INT2VAR(*)
      INTEGER :: ICOUNT,IERR,IROOT
!-----------------------------------------------------------------------
! Subroutine MPI_BCAST_INT2
! Purpose: to serve as a "jacket" for passing integer*2 variables
!          to MPI_BCAST so that MPI_BCAST will be called with only a 
!          single variable type in a given fortran routine.
! B.T. Draine, Princeton University Observatory, 2004.04.09
! history
! 04.04.09 (BTD) first written
! 08.01.17 (BTD) f90 version
! end history
!-----------------------------------------------------------------------
!*** diagnostic
!      write(0,*)'mpi_bcast_int2 ckpt 1: ICOUNT=',icount
!***
      CALL MPI_BCAST(INT2VAR,ICOUNT,MPI_INTEGER2, &
                     IROOT,MPI_COMM_WORLD,IERR)
!*** diagnostic
!      write(0,*)'mpi_bcast_int2 ckpt 2'
!***
      RETURN
    END SUBROUTINE MPI_BCAST_INT2

    SUBROUTINE TARPRSM(A1,A2,A,BA,CA,LA,DX,X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ, &
                       ICOMP)
      USE DDPRECISION, ONLY : WP
      IMPLICIT NONE

! Arguments:

      CHARACTER :: CDESCR*67
      INTEGER :: IOSHP, MXNAT, NAT
      INTEGER*2 :: ICOMP(MXNAT,3)
      INTEGER :: IXYZ(MXNAT,3)
      REAL(WP) :: A,BA,CA,LA

! Array arguments:

      REAL(WP) :: A1(3),A2(3),DX(3),X0(3)

! Local scalars:

      CHARACTER :: CMSGNM*70
      INTEGER :: JA,JX,JY,JZ,NFAC,NLAY,NX,NY,NZ

      REAL(WP) :: B,BETA,C,COTBETA,COTGAMMA,GAMMA,L,XMAX,XMIN,Y, &
                  YMAX,Z,ZMAX,ZMIN

!***********************************************************************
! Routine to construct triangular prism from "atoms".
! triangle side lengths = a,b,c ; prism length = L
! prism axis is assumed to be in x direction
! normal to prism face of width a : (0,1,0)
! normal to prism face of width b : (0,-cos(gamma),sin(gamma))
! normal to prism face of width c : (0,-cos(beta),-sin(beta))
! angles alpha,beta,gamma are opposite sides a,b,c

! first layer of target array is at x=0 (target boundary at x=-0.5)
! layer along side a is at int(b*sin(gamma))
!      boundary is at ymax=int(b*sin(gamma))+0.5
! Input:
!        A      = a/d
!        BA     = b/a
!        CA     = c/a
!        LA     = L/a
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP  =device number for "target.out" file
!               =-1 to suppress printing of "target.out"
!        MXNAT  =dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 (prism axis)
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 (normal to
!                rectangular faces with sides a,L
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=dielectric function identifier for dipole
!                         locations and 3 directions in space
!        CDESCR=string describing target (up to 67 chars.)
!        X0(3)=location/d in TF of dipole with IXYZ=0 0 0
!              we set the TF origin to be the centroid of the prism
! B.T.Draine, Princeton Univ. Obs., 2002.02.12

! History:
! 02.02.12 (BTD): adapted from tarprsm.f for ver5a10
! 04.02.25 (BTD): corrected typographical error found by In-Ho Lee
! 06.09.30 (BTD): remove unused variable YMIN
! 07.09.11 (BTD): changed IXYZ from INTEGER*2 to INTEGER
! 08.08.30 (BTD): added X0 to argument list
!                 add code to evaluate X0(1-3)
!                 modified format 9020
! end history

! Copyright (C) 2002,2004,2006,2007,2008 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!-----------------------------------------------------------------------

! Current version of TARPRSM is restricted to cubic lattices

      IF(DX(1)/=1._WP.OR.DX(2)/=1._WP)THEN
         CALL ERRMSG('FATAL','TARPRSM',                          &
                     ' tarprsm does not support noncubic lattice')
      ENDIF

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      END DO
      A1(1)=1._WP
      A2(2)=1._WP

! A = a/d
! B = b/d
! C = c/d
! L = L/d

      B=BA*A
      C=CA*A
      L=LA*A

! sanity check:

      IF((A>=B+C).OR.(B>=A+C).OR.(C>=A+B))CALL ERRMSG('FATAL','TARPRSM',   &
         'prism sides a,b,c do not satisfy triangle inequality:check input')

      BETA=ACOS((A*A+C*C-B*B)/(2._WP*A*C))
      GAMMA=ACOS((A*A+B*B-C*C)/(2._WP*A*B))
      COTBETA=COS(BETA)/SIN(BETA)
      COTGAMMA=COS(GAMMA)/SIN(GAMMA)

! ideal prism extent:
!    x = xmin to x=xmax
!    triangle vertices at (0,ymax,zmin),(0,ymax,zmax),(0,ymin,za)
!    where xmin=-0.5
!          xmax=xmin+L
!          ymax=int[b*sin(gamma)]+0.5
!          ymin=ymax-b*sin(gamma)
!          zmax=a/2
!          zmin=-a/2
!          za=-a/2+c*cos(beta)

      XMIN=-0.5_WP
      XMAX=XMIN+L
      YMAX=INT(B*SIN(GAMMA))+0.5_WP
      ZMAX=0.5_WP*A
      ZMIN=-ZMAX

! Now determine limits for testing x,y,z values
! Along axis (x), run from 0 to NX=INT(XMAX)
! Along y direction, run from 0 to NY=INT(YMAX)
! Along z direction, run from -NZ to NZ=INT(ZMAX)

      NX=INT(XMAX)
      NY=INT(YMAX)
      NZ=INT(ZMAX)

      NAT=0
      DO JZ=-NZ,NZ
         Z=REAL(JZ,KIND=WP)
         DO JY=0,NY
            Y=REAL(JY,KIND=WP)
            IF((Z<=ZMAX+(Y-YMAX)*COTGAMMA).AND.(Z>=ZMIN-(Y-YMAX)*COTBETA))THEN
               DO JX=0,NX
                  NAT=NAT + 1
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
               ENDDO
            ENDIF
         ENDDO
      ENDDO

      NLAY=NX+1
      NFAC=NAT/NLAY

      DO JX=1,3
         X0(JX)=0._WP
         DO JA=1,NAT
            X0(JX)=X0(JX)+REAL(IXYZ(JA,JX))
            ICOMP(JA,JX)=1
         ENDDO
         X0(JX)=-X0(JX)/REAL(NAT)
      ENDDO

! Note: string CDESCR will be printed by subr. TARGET

      WRITE(CDESCR,FMT='(A,I7,A)')' Hexagonal prism of NAT=',NAT,' dipoles'

! Here print any additional target info which is desired by using
! subroutine WRIMSG

      WRITE(CMSGNM,FMT='(A,3F7.4,A)')' A1 = (',A1,') = prism axis direction'
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CMSGNM,FMT='(A,3F7.4,A)')' A2 = (',A2,') = normal to face of width a'
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CMSGNM,FMT='(A,I7,A,I4,A,I4)')' NAT=',NAT, ' NFAC=',NFAC, &
                                          ' NLAY=',NLAY
      CALL WRIMSG('TARPRSM',CMSGNM)
      WRITE(CDESCR,FMT='(A,F7.4,A,F8.4,A,F7.4,A,F8.4)')' tri.prism: a/d=', &
                                          A,' b/a=',BA,' c/a=',CA,' L/a=',LA

! Now store atom coordinates in file

      IF(IOSHP>0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')

!*** 3 lines of general description allowed:

         WRITE(IOSHP,9020)A,BA,CA,LA,NAT,A1,A2,DX,X0

!***

         DO JX=1,NAT
            WRITE(IOSHP,FMT=9030)JX,IXYZ(JX,1),IXYZ(JX,2),IXYZ(JX,3), &
                                 ICOMP(JX,1),ICOMP(JX,2),ICOMP(JX,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' Triangular Prism: a/d=',F7.4,' b/a=',F7.4,          &
             ' c/a=',F7.4,' L/a=',F7.4,/,                          &
         I10,' = NAT ',/,                                          &
         3F10.6,' = A_1 vector',/,                                 &
         3F10.6,' = A_2 vector',/,                                 &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,           &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ', &
               'for dipole 0 0 0',/,                               &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARPRSM

!*********************************************************************
!                                                                    *
!     GPFAPACK - FORTRAN IMPLEMENTATION OF THE SELF-SORTING          *
!     IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT [GPFA]         *
!                                                                    *
!     WRITTEN BY CLIVE TEMPERTON                                     *
!     RECHERCHE EN PREVISION NUMERIQUE / ECMWF                       *
!                                                                    *
!     THE PACKAGE CONSISTS OF THE SETUP ROUTINE SETGPFA, TOGETHER    *
!     WITH THE ROUTINES GPFA, GPFA2F, GPFA3F, GPFA5F                 *
!                                                                    *
!*********************************************************************

!        SUBROUTINE 'SETGPFA'
!        SETUP ROUTINE FOR SELF-SORTING IN-PLACE
!            GENERALIZED PRIME FACTOR (COMPLEX) FFT [GPFA]

!        CALL SETGPFA(TRIGS,N)

!        INPUT :
!        -----
!        N IS THE LENGTH OF THE TRANSFORMS. N MUST BE OF THE FORM:
!          -----------------------------------
!            N = (2**IP) * (3**IQ) * (5**IR)
!          -----------------------------------

!        OUTPUT:
!        ------
!        TRIGS IS A TABLE OF TWIDDLE FACTORS,
!          OF LENGTH 2*IPQR (REAL) WORDS, WHERE:
!          --------------------------------------
!            IPQR = (2**IP) + (3**IQ) + (5**IR)
!          --------------------------------------

!        WRITTEN BY CLIVE TEMPERTON 1990

!----------------------------------------------------------------------

    SUBROUTINE SETGPFA(TRIGS,N)
      USE DDPRECISION,ONLY : WP
      REAL(WP) :: ANGLE, DEL, TRIGS, TWOPI

      DIMENSION TRIGS(*)
      DIMENSION NJ(3)

!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
      NN = N
      IFAC = 2

      DO LL = 1, 3
        KK = 0
10      CONTINUE
        IF (MOD(NN,IFAC)/=0) GO TO 20
        KK = KK + 1
        NN = NN/IFAC
        GO TO 10
20      CONTINUE
        NJ(LL) = KK
        IFAC = IFAC + LL
      END DO

      IF (NN/=1) THEN
        WRITE (6,40) N
40      FORMAT (' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
        RETURN
      END IF

      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)

!     COMPUTE LIST OF ROTATED TWIDDLE FACTORS
!     ---------------------------------------
      NJ(1) = 2**IP
      NJ(2) = 3**IQ
      NJ(3) = 5**IR

      TWOPI = 4.0_WP*ASIN(1.0_WP)
      I = 1

      DO LL = 1, 3
        NI = NJ(LL)
        IF (NI==1) GO TO 60

        DEL = TWOPI/REAL(NI,KIND=WP)
        IROT = N/NI
        KINK = MOD(IROT,NI)
        KK = 0

        DO K = 1, NI
          ANGLE = REAL(KK,KIND=WP)*DEL
          TRIGS(I) = COS(ANGLE)
          TRIGS(I+1) = SIN(ANGLE)
          I = I + 2
          KK = KK + KINK
          IF (KK>NI) KK = KK - NI
        END DO
60    END DO

      RETURN
    END SUBROUTINE SETGPFA

!        SUBROUTINE 'GPFA'
!        SELF-SORTING IN-PLACE GENERALIZED PRIME FACTOR (COMPLEX) FFT

!        *** THIS IS THE ALL-FORTRAN VERSION ***
!            -------------------------------

!        CALL GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)

!        A IS FIRST REAL INPUT/OUTPUT VECTOR
!        B IS FIRST IMAGINARY INPUT/OUTPUT VECTOR
!        TRIGS IS A TABLE OF TWIDDLE FACTORS, PRECALCULATED
!              BY CALLING SUBROUTINE 'SETGPFA'
!        INC IS THE INCREMENT WITHIN EACH DATA VECTOR
!        JUMP IS THE INCREMENT BETWEEN DATA VECTORS
!        N IS THE LENGTH OF THE TRANSFORMS:
!          -----------------------------------
!            N = (2**IP) * (3**IQ) * (5**IR)
!          -----------------------------------
!        LOT IS THE NUMBER OF TRANSFORMS
!        ISIGN = +1 FOR FORWARD TRANSFORM
!              = -1 FOR INVERSE TRANSFORM

!        WRITTEN BY CLIVE TEMPERTON
!        RECHERCHE EN PREVISION NUMERIQUE
!        ATMOSPHERIC ENVIRONMENT SERVICE, CANADA

!----------------------------------------------------------------------

!        DEFINITION OF TRANSFORM
!        -----------------------

!        X(J) = SUM(K=0,...,N-1)(C(K)*EXP(ISIGN*2*I*J*K*PI/N))

!---------------------------------------------------------------------

!        FOR A MATHEMATICAL DEVELOPMENT OF THE ALGORITHM USED,
!        SEE:

!        C TEMPERTON : "A GENERALIZED PRIME FACTOR FFT ALGORITHM
!          FOR ANY N = (2**P)(3**Q)(5**R)",
!          SIAM J. SCI. STAT. COMP., MAY 1992.

!----------------------------------------------------------------------

    SUBROUTINE GPFA(A,B,TRIGS,INC,JUMP,N,LOT,ISIGN)
      USE DDPRECISION,ONLY : WP
      REAL(WP) :: TRIGS, B, A

      DIMENSION A(*), B(*), TRIGS(*)
      DIMENSION NJ(3)

!*** diagnostic
!      write(0,*)'gpfa ckpt 1'
!***

!     DECOMPOSE N INTO FACTORS 2,3,5
!     ------------------------------
      NN = N
      IFAC = 2

      DO LL = 1, 3
        KK = 0
10      CONTINUE
        IF (MOD(NN,IFAC)/=0) GO TO 20
        KK = KK + 1
        NN = NN/IFAC
        GO TO 10
20      CONTINUE
        NJ(LL) = KK
        IFAC = IFAC + LL
      END DO

      IF (NN/=1) THEN
        WRITE (6,40) N
40      FORMAT (' *** WARNING!!!',I10,' IS NOT A LEGAL VALUE OF N ***')
        RETURN
      END IF

      IP = NJ(1)
      IQ = NJ(2)
      IR = NJ(3)

!     COMPUTE THE TRANSFORM
!     ---------------------
      I = 1
      IF (IP>0) THEN
!*** diagnostic
!         write(0,*)'in gpfa, about to call gpfa2f'
!***
        CALL GPFA2F(A,B,TRIGS,INC,JUMP,N,IP,LOT,ISIGN)
!*** diagnostic
!        write(0,*)'returned from gpfa2f'
!***
        I = I + 2*(2**IP)
      END IF
      IF (IQ>0) THEN
!*** diagnostic
!         write(0,*)'in gpfa,about to call gpfa3f'
!***
        CALL GPFA3F(A,B,TRIGS(I),INC,JUMP,N,IQ,LOT,ISIGN)
!*** diagnostic
!        write(0,*)'returned from gpfa3f'
!***
        I = I + 2*(3**IQ)
      END IF
      IF (IR>0) THEN
!*** diagnostic
!         write(0,*)'in gpfa, about to call gpfa5f'
!***
        CALL GPFA5F(A,B,TRIGS(I),INC,JUMP,N,IR,LOT,ISIGN)
!*** diagnostic
!        write(0,*)'returned from gpfa5f'
!***
      END IF

      RETURN
    END SUBROUTINE GPFA
!     fortran version of *gpfa2* -
!     radix-2 section of self-sorting, in-place, generalized pfa
!     central radix-2 and radix-8 passes included
!      so that transform length can be any power of 2

!-------------------------------------------------------------------

    SUBROUTINE GPFA2F(A,B,TRIGS,INC,JUMP,N,MM,LOT,ISIGN)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: SI7, CO7, SI6, CO6, SI5, CO5, SI4, CO4, C3, C2, C1, SI3, &
        CO3, SI2, CO2, SI1, CO1, U3, U1, U2, U0, T3, T1, T2, T0, SS, S, B, A, &
        TRIGS
      DIMENSION A(*), B(*), TRIGS(*)
      DATA LVR/64/

!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************

      N2 = 2**MM
      INQ = N/N2
      JSTEPX = (N2-N)*INC
      NINC = N*INC
      INK = INC*INQ

      M2 = 0
      M8 = 0
      IF (MOD(MM,2)==0) THEN
        M = MM/2
      ELSE IF (MOD(MM,4)==1) THEN
        M = (MM-1)/2
        M2 = 1
      ELSE IF (MOD(MM,4)==3) THEN
        M = (MM-3)/2
        M8 = 1
      END IF
      MH = (M+1)/2

      NBLOX = 1 + (LOT-1)/LVR
      LEFT = LOT
      S = REAL(ISIGN,KIND=WP)
      ISTART = 1

!  loop on blocks of lvr transforms
!  --------------------------------
      DO NB = 1, NBLOX

        IF (LEFT<=LVR) THEN
          NVEX = LEFT
        ELSE IF (LEFT<(2*LVR)) THEN
          NVEX = LEFT/2
          NVEX = NVEX + MOD(NVEX,2)
        ELSE
          NVEX = LVR
        END IF
        LEFT = LEFT - NVEX

        LA = 1

!  loop on type I radix-4 passes
!  -----------------------------
        MU = MOD(INQ,4)
        IF (ISIGN==-1) MU = 4 - MU
        SS = 1.0_WP
        IF (MU==3) SS = -1.0_WP

        IF (MH==0) GO TO 200

        DO IPASS = 1, MH
          JSTEP = (N*INC)/(4*LA)
          JSTEPL = JSTEP - NINC

!  k = 0 loop (no twiddle factors)
!  -------------------------------
          DO JJJ = 0, (N-1)*INC, 4*JSTEP
            JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
            DO NU = 1, INQ
              JB = JA + JSTEPL
              IF (JB<ISTART) JB = JB + NINC
              JC = JB + JSTEPL
              IF (JC<ISTART) JC = JC + NINC
              JD = JC + JSTEPL
              IF (JD<ISTART) JD = JD + NINC
              J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
              DO L = 1, NVEX
                T0 = A(JA+J) + A(JC+J)
                T2 = A(JA+J) - A(JC+J)
                T1 = A(JB+J) + A(JD+J)
                T3 = SS*(A(JB+J)-A(JD+J))
                U0 = B(JA+J) + B(JC+J)
                U2 = B(JA+J) - B(JC+J)
                U1 = B(JB+J) + B(JD+J)
                U3 = SS*(B(JB+J)-B(JD+J))
                A(JA+J) = T0 + T1
                A(JC+J) = T0 - T1
                B(JA+J) = U0 + U1
                B(JC+J) = U0 - U1
                A(JB+J) = T2 - U3
                A(JD+J) = T2 + U3
                B(JB+J) = U2 + T3
                B(JD+J) = U2 - T3
                J = J + JUMP
              END DO
              JA = JA + JSTEPX
              IF (JA<ISTART) JA = JA + NINC
            END DO
          END DO

!  finished if n2 = 4
!  ------------------
          IF (N2==4) GO TO 490
          KK = 2*LA

!  loop on nonzero k
!  -----------------
          DO K = INK, JSTEP - INK, INK
            CO1 = TRIGS(KK+1)
            SI1 = S*TRIGS(KK+2)
            CO2 = TRIGS(2*KK+1)
            SI2 = S*TRIGS(2*KK+2)
            CO3 = TRIGS(3*KK+1)
            SI3 = S*TRIGS(3*KK+2)

!  loop along transform
!  --------------------
            DO JJJ = K, (N-1)*INC, 4*JSTEP
              JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
              DO NU = 1, INQ
                JB = JA + JSTEPL
                IF (JB<ISTART) JB = JB + NINC
                JC = JB + JSTEPL
                IF (JC<ISTART) JC = JC + NINC
                JD = JC + JSTEPL
                IF (JD<ISTART) JD = JD + NINC
                J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep,shortloop
                DO L = 1, NVEX
                  T0 = A(JA+J) + A(JC+J)
                  T2 = A(JA+J) - A(JC+J)
                  T1 = A(JB+J) + A(JD+J)
                  T3 = SS*(A(JB+J)-A(JD+J))
                  U0 = B(JA+J) + B(JC+J)
                  U2 = B(JA+J) - B(JC+J)
                  U1 = B(JB+J) + B(JD+J)
                  U3 = SS*(B(JB+J)-B(JD+J))
                  A(JA+J) = T0 + T1
                  B(JA+J) = U0 + U1
                  A(JB+J) = CO1*(T2-U3) - SI1*(U2+T3)
                  B(JB+J) = SI1*(T2-U3) + CO1*(U2+T3)
                  A(JC+J) = CO2*(T0-T1) - SI2*(U0-U1)
                  B(JC+J) = SI2*(T0-T1) + CO2*(U0-U1)
                  A(JD+J) = CO3*(T2+U3) - SI3*(U2-T3)
                  B(JD+J) = SI3*(T2+U3) + CO3*(U2-T3)
                  J = J + JUMP
                END DO
!-----( end of loop across transforms )
                JA = JA + JSTEPX
                IF (JA<ISTART) JA = JA + NINC
              END DO
            END DO
!-----( end of loop along transforms )
            KK = KK + 2*LA
          END DO
!-----( end of loop on nonzero k )
          LA = 4*LA
        END DO
!-----( end of loop on type I radix-4 passes)

!  central radix-2 pass
!  --------------------
200     CONTINUE
        IF (M2==0) GO TO 300

        JSTEP = (N*INC)/(2*LA)
        JSTEPL = JSTEP - NINC

!  k=0 loop (no twiddle factors)
!  -----------------------------
        DO JJJ = 0, (N-1)*INC, 2*JSTEP
          JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
          DO NU = 1, INQ
            JB = JA + JSTEPL
            IF (JB<ISTART) JB = JB + NINC
            J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
            DO L = 1, NVEX
              T0 = A(JA+J) - A(JB+J)
              A(JA+J) = A(JA+J) + A(JB+J)
              A(JB+J) = T0
              U0 = B(JA+J) - B(JB+J)
              B(JA+J) = B(JA+J) + B(JB+J)
              B(JB+J) = U0
              J = J + JUMP
            END DO
!-----(end of loop across transforms)
            JA = JA + JSTEPX
            IF (JA<ISTART) JA = JA + NINC
          END DO
        END DO

!  finished if n2=2
!  ----------------
        IF (N2==2) GO TO 490

        KK = 2*LA

!  loop on nonzero k
!  -----------------
        DO K = INK, JSTEP - INK, INK
          CO1 = TRIGS(KK+1)
          SI1 = S*TRIGS(KK+2)

!  loop along transforms
!  ---------------------
          DO JJJ = K, (N-1)*INC, 2*JSTEP
            JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
            DO NU = 1, INQ
              JB = JA + JSTEPL
              IF (JB<ISTART) JB = JB + NINC
              J = 0

!  loop across transforms
!  ----------------------
              IF (KK==N2/2) THEN
!dir$ ivdep, shortloop
                DO L = 1, NVEX
                  T0 = SS*(A(JA+J)-A(JB+J))
                  A(JA+J) = A(JA+J) + A(JB+J)
                  A(JB+J) = SS*(B(JB+J)-B(JA+J))
                  B(JA+J) = B(JA+J) + B(JB+J)
                  B(JB+J) = T0
                  J = J + JUMP
                END DO

              ELSE

!dir$ ivdep, shortloop
                DO L = 1, NVEX
                  T0 = A(JA+J) - A(JB+J)
                  A(JA+J) = A(JA+J) + A(JB+J)
                  U0 = B(JA+J) - B(JB+J)
                  B(JA+J) = B(JA+J) + B(JB+J)
                  A(JB+J) = CO1*T0 - SI1*U0
                  B(JB+J) = SI1*T0 + CO1*U0
                  J = J + JUMP
                END DO

              END IF

!-----(end of loop across transforms)
              JA = JA + JSTEPX
              IF (JA<ISTART) JA = JA + NINC
            END DO
          END DO
!-----(end of loop along transforms)
          KK = KK + 2*LA
        END DO
!-----(end of loop on nonzero k)
!-----(end of radix-2 pass)

        LA = 2*LA
        GO TO 400

!  central radix-8 pass
!  --------------------
300     CONTINUE
        IF (M8==0) GO TO 400
        JSTEP = (N*INC)/(8*LA)
        JSTEPL = JSTEP - NINC
        MU = MOD(INQ,8)
        IF (ISIGN==-1) MU = 8 - MU
        C1 = 1.0_WP
        IF (MU==3 .OR. MU==7) C1 = -1.0_WP
        C2 = SQRT(0.5_WP)
        IF (MU==3 .OR. MU==5) C2 = -C2
        C3 = C1*C2

!  stage 1
!  -------
        DO K = 0, JSTEP - INK, INK
          DO JJJ = K, (N-1)*INC, 8*JSTEP
            JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
            DO NU = 1, INQ
              JB = JA + JSTEPL
              IF (JB<ISTART) JB = JB + NINC
              JC = JB + JSTEPL
              IF (JC<ISTART) JC = JC + NINC
              JD = JC + JSTEPL
              IF (JD<ISTART) JD = JD + NINC
              JE = JD + JSTEPL
              IF (JE<ISTART) JE = JE + NINC
              JF = JE + JSTEPL
              IF (JF<ISTART) JF = JF + NINC
              JG = JF + JSTEPL
              IF (JG<ISTART) JG = JG + NINC
              JH = JG + JSTEPL
              IF (JH<ISTART) JH = JH + NINC
              J = 0
!dir$ ivdep, shortloop
              DO L = 1, NVEX
                T0 = A(JA+J) - A(JE+J)
                A(JA+J) = A(JA+J) + A(JE+J)
                T1 = C1*(A(JC+J)-A(JG+J))
                A(JE+J) = A(JC+J) + A(JG+J)
                T2 = A(JB+J) - A(JF+J)
                A(JC+J) = A(JB+J) + A(JF+J)
                T3 = A(JD+J) - A(JH+J)
                A(JG+J) = A(JD+J) + A(JH+J)
                A(JB+J) = T0
                A(JF+J) = T1
                A(JD+J) = C2*(T2-T3)
                A(JH+J) = C3*(T2+T3)
                U0 = B(JA+J) - B(JE+J)
                B(JA+J) = B(JA+J) + B(JE+J)
                U1 = C1*(B(JC+J)-B(JG+J))
                B(JE+J) = B(JC+J) + B(JG+J)
                U2 = B(JB+J) - B(JF+J)
                B(JC+J) = B(JB+J) + B(JF+J)
                U3 = B(JD+J) - B(JH+J)
                B(JG+J) = B(JD+J) + B(JH+J)
                B(JB+J) = U0
                B(JF+J) = U1
                B(JD+J) = C2*(U2-U3)
                B(JH+J) = C3*(U2+U3)
                J = J + JUMP
              END DO
              JA = JA + JSTEPX
              IF (JA<ISTART) JA = JA + NINC
            END DO
          END DO
        END DO

!  stage 2
!  -------

!  k=0 (no twiddle factors)
!  ------------------------
        DO JJJ = 0, (N-1)*INC, 8*JSTEP
          JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
          DO NU = 1, INQ
            JB = JA + JSTEPL
            IF (JB<ISTART) JB = JB + NINC
            JC = JB + JSTEPL
            IF (JC<ISTART) JC = JC + NINC
            JD = JC + JSTEPL
            IF (JD<ISTART) JD = JD + NINC
            JE = JD + JSTEPL
            IF (JE<ISTART) JE = JE + NINC
            JF = JE + JSTEPL
            IF (JF<ISTART) JF = JF + NINC
            JG = JF + JSTEPL
            IF (JG<ISTART) JG = JG + NINC
            JH = JG + JSTEPL
            IF (JH<ISTART) JH = JH + NINC
            J = 0
!dir$ ivdep, shortloop
            DO L = 1, NVEX
              T0 = A(JA+J) + A(JE+J)
              T2 = A(JA+J) - A(JE+J)
              T1 = A(JC+J) + A(JG+J)
              T3 = C1*(A(JC+J)-A(JG+J))
              U0 = B(JA+J) + B(JE+J)
              U2 = B(JA+J) - B(JE+J)
              U1 = B(JC+J) + B(JG+J)
              U3 = C1*(B(JC+J)-B(JG+J))
              A(JA+J) = T0 + T1
              A(JE+J) = T0 - T1
              B(JA+J) = U0 + U1
              B(JE+J) = U0 - U1
              A(JC+J) = T2 - U3
              A(JG+J) = T2 + U3
              B(JC+J) = U2 + T3
              B(JG+J) = U2 - T3
              T0 = A(JB+J) + A(JD+J)
              T2 = A(JB+J) - A(JD+J)
              T1 = A(JF+J) - A(JH+J)
              T3 = A(JF+J) + A(JH+J)
              U0 = B(JB+J) + B(JD+J)
              U2 = B(JB+J) - B(JD+J)
              U1 = B(JF+J) - B(JH+J)
              U3 = B(JF+J) + B(JH+J)
              A(JB+J) = T0 - U3
              A(JH+J) = T0 + U3
              B(JB+J) = U0 + T3
              B(JH+J) = U0 - T3
              A(JD+J) = T2 + U1
              A(JF+J) = T2 - U1
              B(JD+J) = U2 - T1
              B(JF+J) = U2 + T1
              J = J + JUMP
            END DO
            JA = JA + JSTEPX
            IF (JA<ISTART) JA = JA + NINC
          END DO
        END DO

        IF (N2==8) GO TO 490

!  loop on nonzero k
!  -----------------
        KK = 2*LA

        DO K = INK, JSTEP - INK, INK

          CO1 = TRIGS(KK+1)
          SI1 = S*TRIGS(KK+2)
          CO2 = TRIGS(2*KK+1)
          SI2 = S*TRIGS(2*KK+2)
          CO3 = TRIGS(3*KK+1)
          SI3 = S*TRIGS(3*KK+2)
          CO4 = TRIGS(4*KK+1)
          SI4 = S*TRIGS(4*KK+2)
          CO5 = TRIGS(5*KK+1)
          SI5 = S*TRIGS(5*KK+2)
          CO6 = TRIGS(6*KK+1)
          SI6 = S*TRIGS(6*KK+2)
          CO7 = TRIGS(7*KK+1)
          SI7 = S*TRIGS(7*KK+2)

          DO JJJ = K, (N-1)*INC, 8*JSTEP
            JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
            DO NU = 1, INQ
              JB = JA + JSTEPL
              IF (JB<ISTART) JB = JB + NINC
              JC = JB + JSTEPL
              IF (JC<ISTART) JC = JC + NINC
              JD = JC + JSTEPL
              IF (JD<ISTART) JD = JD + NINC
              JE = JD + JSTEPL
              IF (JE<ISTART) JE = JE + NINC
              JF = JE + JSTEPL
              IF (JF<ISTART) JF = JF + NINC
              JG = JF + JSTEPL
              IF (JG<ISTART) JG = JG + NINC
              JH = JG + JSTEPL
              IF (JH<ISTART) JH = JH + NINC
              J = 0
!dir$ ivdep, shortloop
              DO L = 1, NVEX
                T0 = A(JA+J) + A(JE+J)
                T2 = A(JA+J) - A(JE+J)
                T1 = A(JC+J) + A(JG+J)
                T3 = C1*(A(JC+J)-A(JG+J))
                U0 = B(JA+J) + B(JE+J)
                U2 = B(JA+J) - B(JE+J)
                U1 = B(JC+J) + B(JG+J)
                U3 = C1*(B(JC+J)-B(JG+J))
                A(JA+J) = T0 + T1
                B(JA+J) = U0 + U1
                A(JE+J) = CO4*(T0-T1) - SI4*(U0-U1)
                B(JE+J) = SI4*(T0-T1) + CO4*(U0-U1)
                A(JC+J) = CO2*(T2-U3) - SI2*(U2+T3)
                B(JC+J) = SI2*(T2-U3) + CO2*(U2+T3)
                A(JG+J) = CO6*(T2+U3) - SI6*(U2-T3)
                B(JG+J) = SI6*(T2+U3) + CO6*(U2-T3)
                T0 = A(JB+J) + A(JD+J)
                T2 = A(JB+J) - A(JD+J)
                T1 = A(JF+J) - A(JH+J)
                T3 = A(JF+J) + A(JH+J)
                U0 = B(JB+J) + B(JD+J)
                U2 = B(JB+J) - B(JD+J)
                U1 = B(JF+J) - B(JH+J)
                U3 = B(JF+J) + B(JH+J)
                A(JB+J) = CO1*(T0-U3) - SI1*(U0+T3)
                B(JB+J) = SI1*(T0-U3) + CO1*(U0+T3)
                A(JH+J) = CO7*(T0+U3) - SI7*(U0-T3)
                B(JH+J) = SI7*(T0+U3) + CO7*(U0-T3)
                A(JD+J) = CO3*(T2+U1) - SI3*(U2-T1)
                B(JD+J) = SI3*(T2+U1) + CO3*(U2-T1)
                A(JF+J) = CO5*(T2-U1) - SI5*(U2+T1)
                B(JF+J) = SI5*(T2-U1) + CO5*(U2+T1)
                J = J + JUMP
              END DO
              JA = JA + JSTEPX
              IF (JA<ISTART) JA = JA + NINC
            END DO
          END DO
          KK = KK + 2*LA
        END DO

        LA = 8*LA

!  loop on type II radix-4 passes
!  ------------------------------
400     CONTINUE
        MU = MOD(INQ,4)
        IF (ISIGN==-1) MU = 4 - MU
        SS = 1.0_WP
        IF (MU==3) SS = -1.0_WP

        DO IPASS = MH + 1, M
          JSTEP = (N*INC)/(4*LA)
          JSTEPL = JSTEP - NINC
          LAINCL = LA*INK - NINC

!  k=0 loop (no twiddle factors)
!  -----------------------------
          DO LL = 0, (LA-1)*INK, 4*JSTEP

            DO JJJ = LL, (N-1)*INC, 4*LA*INK
              JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
              DO NU = 1, INQ
                JB = JA + JSTEPL
                IF (JB<ISTART) JB = JB + NINC
                JC = JB + JSTEPL
                IF (JC<ISTART) JC = JC + NINC
                JD = JC + JSTEPL
                IF (JD<ISTART) JD = JD + NINC
                JE = JA + LAINCL
                IF (JE<ISTART) JE = JE + NINC
                JF = JE + JSTEPL
                IF (JF<ISTART) JF = JF + NINC
                JG = JF + JSTEPL
                IF (JG<ISTART) JG = JG + NINC
                JH = JG + JSTEPL
                IF (JH<ISTART) JH = JH + NINC
                JI = JE + LAINCL
                IF (JI<ISTART) JI = JI + NINC
                JJ = JI + JSTEPL
                IF (JJ<ISTART) JJ = JJ + NINC
                JK = JJ + JSTEPL
                IF (JK<ISTART) JK = JK + NINC
                JL = JK + JSTEPL
                IF (JL<ISTART) JL = JL + NINC
                JM = JI + LAINCL
                IF (JM<ISTART) JM = JM + NINC
                JN = JM + JSTEPL
                IF (JN<ISTART) JN = JN + NINC
                JO = JN + JSTEPL
                IF (JO<ISTART) JO = JO + NINC
                JP = JO + JSTEPL
                IF (JP<ISTART) JP = JP + NINC
                J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
                DO L = 1, NVEX
                  T0 = A(JA+J) + A(JC+J)
                  T2 = A(JA+J) - A(JC+J)
                  T1 = A(JB+J) + A(JD+J)
                  T3 = SS*(A(JB+J)-A(JD+J))
                  A(JC+J) = A(JI+J)
                  U0 = B(JA+J) + B(JC+J)
                  U2 = B(JA+J) - B(JC+J)
                  U1 = B(JB+J) + B(JD+J)
                  U3 = SS*(B(JB+J)-B(JD+J))
                  A(JB+J) = A(JE+J)
                  A(JA+J) = T0 + T1
                  A(JI+J) = T0 - T1
                  B(JA+J) = U0 + U1
                  B(JC+J) = U0 - U1
                  B(JD+J) = B(JM+J)
                  A(JE+J) = T2 - U3
                  A(JD+J) = T2 + U3
                  B(JB+J) = U2 + T3
                  B(JM+J) = U2 - T3
!----------------------
                  T0 = A(JB+J) + A(JG+J)
                  T2 = A(JB+J) - A(JG+J)
                  T1 = A(JF+J) + A(JH+J)
                  T3 = SS*(A(JF+J)-A(JH+J))
                  A(JG+J) = A(JJ+J)
                  U0 = B(JE+J) + B(JG+J)
                  U2 = B(JE+J) - B(JG+J)
                  U1 = B(JF+J) + B(JH+J)
                  U3 = SS*(B(JF+J)-B(JH+J))
                  B(JE+J) = B(JB+J)
                  A(JB+J) = T0 + T1
                  A(JJ+J) = T0 - T1
                  B(JG+J) = B(JJ+J)
                  B(JB+J) = U0 + U1
                  B(JJ+J) = U0 - U1
                  A(JF+J) = T2 - U3
                  A(JH+J) = T2 + U3
                  B(JF+J) = U2 + T3
                  B(JH+J) = U2 - T3
!----------------------
                  T0 = A(JC+J) + A(JK+J)
                  T2 = A(JC+J) - A(JK+J)
                  T1 = A(JG+J) + A(JL+J)
                  T3 = SS*(A(JG+J)-A(JL+J))
                  U0 = B(JI+J) + B(JK+J)
                  U2 = B(JI+J) - B(JK+J)
                  A(JL+J) = A(JO+J)
                  U1 = B(JG+J) + B(JL+J)
                  U3 = SS*(B(JG+J)-B(JL+J))
                  B(JI+J) = B(JC+J)
                  A(JC+J) = T0 + T1
                  A(JK+J) = T0 - T1
                  B(JL+J) = B(JO+J)
                  B(JC+J) = U0 + U1
                  B(JK+J) = U0 - U1
                  A(JG+J) = T2 - U3
                  A(JO+J) = T2 + U3
                  B(JG+J) = U2 + T3
                  B(JO+J) = U2 - T3
!----------------------
                  T0 = A(JM+J) + A(JL+J)
                  T2 = A(JM+J) - A(JL+J)
                  T1 = A(JN+J) + A(JP+J)
                  T3 = SS*(A(JN+J)-A(JP+J))
                  A(JM+J) = A(JD+J)
                  U0 = B(JD+J) + B(JL+J)
                  U2 = B(JD+J) - B(JL+J)
                  U1 = B(JN+J) + B(JP+J)
                  U3 = SS*(B(JN+J)-B(JP+J))
                  A(JN+J) = A(JH+J)
                  A(JD+J) = T0 + T1
                  A(JL+J) = T0 - T1
                  B(JD+J) = U0 + U1
                  B(JL+J) = U0 - U1
                  B(JN+J) = B(JH+J)
                  A(JH+J) = T2 - U3
                  A(JP+J) = T2 + U3
                  B(JH+J) = U2 + T3
                  B(JP+J) = U2 - T3
                  J = J + JUMP
                END DO
!-----( end of loop across transforms )
                JA = JA + JSTEPX
                IF (JA<ISTART) JA = JA + NINC
              END DO
            END DO
          END DO
!-----( end of double loop for k=0 )

!  finished if last pass
!  ---------------------
          IF (IPASS==M) GO TO 490

          KK = 2*LA

!     loop on nonzero k
!     -----------------
          DO K = INK, JSTEP - INK, INK
            CO1 = TRIGS(KK+1)
            SI1 = S*TRIGS(KK+2)
            CO2 = TRIGS(2*KK+1)
            SI2 = S*TRIGS(2*KK+2)
            CO3 = TRIGS(3*KK+1)
            SI3 = S*TRIGS(3*KK+2)

!  double loop along first transform in block
!  ------------------------------------------
            DO LL = K, (LA-1)*INK, 4*JSTEP

              DO JJJ = LL, (N-1)*INC, 4*LA*INK
                JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
                DO NU = 1, INQ
                  JB = JA + JSTEPL
                  IF (JB<ISTART) JB = JB + NINC
                  JC = JB + JSTEPL
                  IF (JC<ISTART) JC = JC + NINC
                  JD = JC + JSTEPL
                  IF (JD<ISTART) JD = JD + NINC
                  JE = JA + LAINCL
                  IF (JE<ISTART) JE = JE + NINC
                  JF = JE + JSTEPL
                  IF (JF<ISTART) JF = JF + NINC
                  JG = JF + JSTEPL
                  IF (JG<ISTART) JG = JG + NINC
                  JH = JG + JSTEPL
                  IF (JH<ISTART) JH = JH + NINC
                  JI = JE + LAINCL
                  IF (JI<ISTART) JI = JI + NINC
                  JJ = JI + JSTEPL
                  IF (JJ<ISTART) JJ = JJ + NINC
                  JK = JJ + JSTEPL
                  IF (JK<ISTART) JK = JK + NINC
                  JL = JK + JSTEPL
                  IF (JL<ISTART) JL = JL + NINC
                  JM = JI + LAINCL
                  IF (JM<ISTART) JM = JM + NINC
                  JN = JM + JSTEPL
                  IF (JN<ISTART) JN = JN + NINC
                  JO = JN + JSTEPL
                  IF (JO<ISTART) JO = JO + NINC
                  JP = JO + JSTEPL
                  IF (JP<ISTART) JP = JP + NINC
                  J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
                  DO L = 1, NVEX
                    T0 = A(JA+J) + A(JC+J)
                    T2 = A(JA+J) - A(JC+J)
                    T1 = A(JB+J) + A(JD+J)
                    T3 = SS*(A(JB+J)-A(JD+J))
                    A(JC+J) = A(JI+J)
                    U0 = B(JA+J) + B(JC+J)
                    U2 = B(JA+J) - B(JC+J)
                    U1 = B(JB+J) + B(JD+J)
                    U3 = SS*(B(JB+J)-B(JD+J))
                    A(JB+J) = A(JE+J)
                    A(JA+J) = T0 + T1
                    B(JA+J) = U0 + U1
                    A(JE+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JB+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    B(JD+J) = B(JM+J)
                    A(JI+J) = CO2*(T0-T1) - SI2*(U0-U1)
                    B(JC+J) = SI2*(T0-T1) + CO2*(U0-U1)
                    A(JD+J) = CO3*(T2+U3) - SI3*(U2-T3)
                    B(JM+J) = SI3*(T2+U3) + CO3*(U2-T3)
!----------------------------------------
                    T0 = A(JB+J) + A(JG+J)
                    T2 = A(JB+J) - A(JG+J)
                    T1 = A(JF+J) + A(JH+J)
                    T3 = SS*(A(JF+J)-A(JH+J))
                    A(JG+J) = A(JJ+J)
                    U0 = B(JE+J) + B(JG+J)
                    U2 = B(JE+J) - B(JG+J)
                    U1 = B(JF+J) + B(JH+J)
                    U3 = SS*(B(JF+J)-B(JH+J))
                    B(JE+J) = B(JB+J)
                    A(JB+J) = T0 + T1
                    B(JB+J) = U0 + U1
                    B(JG+J) = B(JJ+J)
                    A(JF+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JF+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JJ+J) = CO2*(T0-T1) - SI2*(U0-U1)
                    B(JJ+J) = SI2*(T0-T1) + CO2*(U0-U1)
                    A(JH+J) = CO3*(T2+U3) - SI3*(U2-T3)
                    B(JH+J) = SI3*(T2+U3) + CO3*(U2-T3)
!----------------------------------------
                    T0 = A(JC+J) + A(JK+J)
                    T2 = A(JC+J) - A(JK+J)
                    T1 = A(JG+J) + A(JL+J)
                    T3 = SS*(A(JG+J)-A(JL+J))
                    U0 = B(JI+J) + B(JK+J)
                    U2 = B(JI+J) - B(JK+J)
                    A(JL+J) = A(JO+J)
                    U1 = B(JG+J) + B(JL+J)
                    U3 = SS*(B(JG+J)-B(JL+J))
                    B(JI+J) = B(JC+J)
                    A(JC+J) = T0 + T1
                    B(JC+J) = U0 + U1
                    B(JL+J) = B(JO+J)
                    A(JG+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JG+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JK+J) = CO2*(T0-T1) - SI2*(U0-U1)
                    B(JK+J) = SI2*(T0-T1) + CO2*(U0-U1)
                    A(JO+J) = CO3*(T2+U3) - SI3*(U2-T3)
                    B(JO+J) = SI3*(T2+U3) + CO3*(U2-T3)
!----------------------------------------
                    T0 = A(JM+J) + A(JL+J)
                    T2 = A(JM+J) - A(JL+J)
                    T1 = A(JN+J) + A(JP+J)
                    T3 = SS*(A(JN+J)-A(JP+J))
                    A(JM+J) = A(JD+J)
                    U0 = B(JD+J) + B(JL+J)
                    U2 = B(JD+J) - B(JL+J)
                    A(JN+J) = A(JH+J)
                    U1 = B(JN+J) + B(JP+J)
                    U3 = SS*(B(JN+J)-B(JP+J))
                    B(JN+J) = B(JH+J)
                    A(JD+J) = T0 + T1
                    B(JD+J) = U0 + U1
                    A(JH+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JH+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JL+J) = CO2*(T0-T1) - SI2*(U0-U1)
                    B(JL+J) = SI2*(T0-T1) + CO2*(U0-U1)
                    A(JP+J) = CO3*(T2+U3) - SI3*(U2-T3)
                    B(JP+J) = SI3*(T2+U3) + CO3*(U2-T3)
                    J = J + JUMP
                  END DO
!-----(end of loop across transforms)
                  JA = JA + JSTEPX
                  IF (JA<ISTART) JA = JA + NINC
                END DO
              END DO
            END DO
!-----( end of double loop for this k )
            KK = KK + 2*LA
          END DO
!-----( end of loop over values of k )
          LA = 4*LA
        END DO
!-----( end of loop on type II radix-4 passes )
!-----( nvex transforms completed)
490     CONTINUE
        ISTART = ISTART + NVEX*JUMP
      END DO
!-----( end of loop on blocks of transforms )

      RETURN
    END SUBROUTINE GPFA2F
!     fortran version of *gpfa3* -
!     radix-3 section of self-sorting, in-place
!        generalized PFA

!-------------------------------------------------------------------

    SUBROUTINE GPFA3F(A,B,TRIGS,INC,JUMP,N,MM,LOT,ISIGN)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: C1, B, A, SI2, CO2, SI1, SIN60, CO1, U3, U1, U2, T3, T1, &
        T2, S, TRIGS
      DIMENSION A(*), B(*), TRIGS(*)
      DATA SIN60/0.866025403784437_WP/
      DATA LVR/64/

!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************

      N3 = 3**MM
      INQ = N/N3
      JSTEPX = (N3-N)*INC
      NINC = N*INC
      INK = INC*INQ
      MU = MOD(INQ,3)
      IF (ISIGN==-1) MU = 3 - MU
      M = MM
      MH = (M+1)/2
      S = REAL(ISIGN,KIND=WP)
      C1 = SIN60
      IF (MU==2) C1 = -C1

      NBLOX = 1 + (LOT-1)/LVR
      LEFT = LOT
      S = REAL(ISIGN,KIND=WP)
      ISTART = 1

!  loop on blocks of lvr transforms
!  --------------------------------
      DO NB = 1, NBLOX

        IF (LEFT<=LVR) THEN
          NVEX = LEFT
        ELSE IF (LEFT<(2*LVR)) THEN
          NVEX = LEFT/2
          NVEX = NVEX + MOD(NVEX,2)
        ELSE
          NVEX = LVR
        END IF
        LEFT = LEFT - NVEX

        LA = 1

!  loop on type I radix-3 passes
!  -----------------------------
        DO IPASS = 1, MH
          JSTEP = (N*INC)/(3*LA)
          JSTEPL = JSTEP - NINC

!  k = 0 loop (no twiddle factors)
!  -------------------------------
          DO JJJ = 0, (N-1)*INC, 3*JSTEP
            JA = ISTART + JJJ

!  "transverse" loop
!  -----------------
            DO NU = 1, INQ
              JB = JA + JSTEPL
              IF (JB<ISTART) JB = JB + NINC
              JC = JB + JSTEPL
              IF (JC<ISTART) JC = JC + NINC
              J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
              DO L = 1, NVEX
                T1 = A(JB+J) + A(JC+J)
                T2 = A(JA+J) - 0.5_WP*T1
                T3 = C1*(A(JB+J)-A(JC+J))
                U1 = B(JB+J) + B(JC+J)
                U2 = B(JA+J) - 0.5_WP*U1
                U3 = C1*(B(JB+J)-B(JC+J))
                A(JA+J) = A(JA+J) + T1
                B(JA+J) = B(JA+J) + U1
                A(JB+J) = T2 - U3
                B(JB+J) = U2 + T3
                A(JC+J) = T2 + U3
                B(JC+J) = U2 - T3
                J = J + JUMP
              END DO
              JA = JA + JSTEPX
              IF (JA<ISTART) JA = JA + NINC
            END DO
          END DO

!  finished if n3 = 3
!  ------------------
          IF (N3==3) GO TO 490
          KK = 2*LA

!  loop on nonzero k
!  -----------------
          DO K = INK, JSTEP - INK, INK
            CO1 = TRIGS(KK+1)
            SI1 = S*TRIGS(KK+2)
            CO2 = TRIGS(2*KK+1)
            SI2 = S*TRIGS(2*KK+2)

!  loop along transform
!  --------------------
            DO JJJ = K, (N-1)*INC, 3*JSTEP
              JA = ISTART + JJJ

!  "transverse" loop
!  -----------------
              DO NU = 1, INQ
                JB = JA + JSTEPL
                IF (JB<ISTART) JB = JB + NINC
                JC = JB + JSTEPL
                IF (JC<ISTART) JC = JC + NINC
                J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep,shortloop
                DO L = 1, NVEX
                  T1 = A(JB+J) + A(JC+J)
                  T2 = A(JA+J) - 0.5_WP*T1
                  T3 = C1*(A(JB+J)-A(JC+J))
                  U1 = B(JB+J) + B(JC+J)
                  U2 = B(JA+J) - 0.5_WP*U1
                  U3 = C1*(B(JB+J)-B(JC+J))
                  A(JA+J) = A(JA+J) + T1
                  B(JA+J) = B(JA+J) + U1
                  A(JB+J) = CO1*(T2-U3) - SI1*(U2+T3)
                  B(JB+J) = SI1*(T2-U3) + CO1*(U2+T3)
                  A(JC+J) = CO2*(T2+U3) - SI2*(U2-T3)
                  B(JC+J) = SI2*(T2+U3) + CO2*(U2-T3)
                  J = J + JUMP
                END DO
!-----( end of loop across transforms )
                JA = JA + JSTEPX
                IF (JA<ISTART) JA = JA + NINC
              END DO
            END DO
!-----( end of loop along transforms )
            KK = KK + 2*LA
          END DO
!-----( end of loop on nonzero k )
          LA = 3*LA
        END DO
!-----( end of loop on type I radix-3 passes)

!  loop on type II radix-3 passes
!  ------------------------------
400     CONTINUE

        DO IPASS = MH + 1, M
          JSTEP = (N*INC)/(3*LA)
          JSTEPL = JSTEP - NINC
          LAINCL = LA*INK - NINC

!  k=0 loop (no twiddle factors)
!  -----------------------------
          DO LL = 0, (LA-1)*INK, 3*JSTEP

            DO JJJ = LL, (N-1)*INC, 3*LA*INK
              JA = ISTART + JJJ

!  "transverse" loop
!  -----------------
              DO NU = 1, INQ
                JB = JA + JSTEPL
                IF (JB<ISTART) JB = JB + NINC
                JC = JB + JSTEPL
                IF (JC<ISTART) JC = JC + NINC
                JD = JA + LAINCL
                IF (JD<ISTART) JD = JD + NINC
                JE = JD + JSTEPL
                IF (JE<ISTART) JE = JE + NINC
                JF = JE + JSTEPL
                IF (JF<ISTART) JF = JF + NINC
                JG = JD + LAINCL
                IF (JG<ISTART) JG = JG + NINC
                JH = JG + JSTEPL
                IF (JH<ISTART) JH = JH + NINC
                JI = JH + JSTEPL
                IF (JI<ISTART) JI = JI + NINC
                J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
                DO L = 1, NVEX
                  T1 = A(JB+J) + A(JC+J)
                  T2 = A(JA+J) - 0.5_WP*T1
                  T3 = C1*(A(JB+J)-A(JC+J))
                  A(JB+J) = A(JD+J)
                  U1 = B(JB+J) + B(JC+J)
                  U2 = B(JA+J) - 0.5_WP*U1
                  U3 = C1*(B(JB+J)-B(JC+J))
                  B(JB+J) = B(JD+J)
                  A(JA+J) = A(JA+J) + T1
                  B(JA+J) = B(JA+J) + U1
                  A(JD+J) = T2 - U3
                  B(JD+J) = U2 + T3
                  A(JC+J) = T2 + U3
                  B(JC+J) = U2 - T3
!----------------------
                  T1 = A(JE+J) + A(JF+J)
                  T2 = A(JB+J) - 0.5_WP*T1
                  T3 = C1*(A(JE+J)-A(JF+J))
                  A(JF+J) = A(JH+J)
                  U1 = B(JE+J) + B(JF+J)
                  U2 = B(JB+J) - 0.5_WP*U1
                  U3 = C1*(B(JE+J)-B(JF+J))
                  B(JF+J) = B(JH+J)
                  A(JB+J) = A(JB+J) + T1
                  B(JB+J) = B(JB+J) + U1
                  A(JE+J) = T2 - U3
                  B(JE+J) = U2 + T3
                  A(JH+J) = T2 + U3
                  B(JH+J) = U2 - T3
!----------------------
                  T1 = A(JF+J) + A(JI+J)
                  T2 = A(JG+J) - 0.5_WP*T1
                  T3 = C1*(A(JF+J)-A(JI+J))
                  T1 = A(JG+J) + T1
                  A(JG+J) = A(JC+J)
                  U1 = B(JF+J) + B(JI+J)
                  U2 = B(JG+J) - 0.5_WP*U1
                  U3 = C1*(B(JF+J)-B(JI+J))
                  U1 = B(JG+J) + U1
                  B(JG+J) = B(JC+J)
                  A(JC+J) = T1
                  B(JC+J) = U1
                  A(JF+J) = T2 - U3
                  B(JF+J) = U2 + T3
                  A(JI+J) = T2 + U3
                  B(JI+J) = U2 - T3
                  J = J + JUMP
                END DO
!-----( end of loop across transforms )
                JA = JA + JSTEPX
                IF (JA<ISTART) JA = JA + NINC
              END DO
            END DO
          END DO
!-----( end of double loop for k=0 )

!  finished if last pass
!  ---------------------
          IF (IPASS==M) GO TO 490

          KK = 2*LA

!     loop on nonzero k
!     -----------------
          DO K = INK, JSTEP - INK, INK
            CO1 = TRIGS(KK+1)
            SI1 = S*TRIGS(KK+2)
            CO2 = TRIGS(2*KK+1)
            SI2 = S*TRIGS(2*KK+2)

!  double loop along first transform in block
!  ------------------------------------------
            DO LL = K, (LA-1)*INK, 3*JSTEP

              DO JJJ = LL, (N-1)*INC, 3*LA*INK
                JA = ISTART + JJJ

!  "transverse" loop
!  -----------------
                DO NU = 1, INQ
                  JB = JA + JSTEPL
                  IF (JB<ISTART) JB = JB + NINC
                  JC = JB + JSTEPL
                  IF (JC<ISTART) JC = JC + NINC
                  JD = JA + LAINCL
                  IF (JD<ISTART) JD = JD + NINC
                  JE = JD + JSTEPL
                  IF (JE<ISTART) JE = JE + NINC
                  JF = JE + JSTEPL
                  IF (JF<ISTART) JF = JF + NINC
                  JG = JD + LAINCL
                  IF (JG<ISTART) JG = JG + NINC
                  JH = JG + JSTEPL
                  IF (JH<ISTART) JH = JH + NINC
                  JI = JH + JSTEPL
                  IF (JI<ISTART) JI = JI + NINC
                  J = 0

!  loop across transforms
!  ----------------------
!dir$ ivdep, shortloop
                  DO L = 1, NVEX
                    T1 = A(JB+J) + A(JC+J)
                    T2 = A(JA+J) - 0.5_WP*T1
                    T3 = C1*(A(JB+J)-A(JC+J))
                    A(JB+J) = A(JD+J)
                    U1 = B(JB+J) + B(JC+J)
                    U2 = B(JA+J) - 0.5_WP*U1
                    U3 = C1*(B(JB+J)-B(JC+J))
                    B(JB+J) = B(JD+J)
                    A(JA+J) = A(JA+J) + T1
                    B(JA+J) = B(JA+J) + U1
                    A(JD+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JD+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JC+J) = CO2*(T2+U3) - SI2*(U2-T3)
                    B(JC+J) = SI2*(T2+U3) + CO2*(U2-T3)
!----------------------
                    T1 = A(JE+J) + A(JF+J)
                    T2 = A(JB+J) - 0.5_WP*T1
                    T3 = C1*(A(JE+J)-A(JF+J))
                    A(JF+J) = A(JH+J)
                    U1 = B(JE+J) + B(JF+J)
                    U2 = B(JB+J) - 0.5_WP*U1
                    U3 = C1*(B(JE+J)-B(JF+J))
                    B(JF+J) = B(JH+J)
                    A(JB+J) = A(JB+J) + T1
                    B(JB+J) = B(JB+J) + U1
                    A(JE+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JE+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JH+J) = CO2*(T2+U3) - SI2*(U2-T3)
                    B(JH+J) = SI2*(T2+U3) + CO2*(U2-T3)
!----------------------
                    T1 = A(JF+J) + A(JI+J)
                    T2 = A(JG+J) - 0.5_WP*T1
                    T3 = C1*(A(JF+J)-A(JI+J))
                    T1 = A(JG+J) + T1
                    A(JG+J) = A(JC+J)
                    U1 = B(JF+J) + B(JI+J)
                    U2 = B(JG+J) - 0.5_WP*U1
                    U3 = C1*(B(JF+J)-B(JI+J))
                    U1 = B(JG+J) + U1
                    B(JG+J) = B(JC+J)
                    A(JC+J) = T1
                    B(JC+J) = U1
                    A(JF+J) = CO1*(T2-U3) - SI1*(U2+T3)
                    B(JF+J) = SI1*(T2-U3) + CO1*(U2+T3)
                    A(JI+J) = CO2*(T2+U3) - SI2*(U2-T3)
                    B(JI+J) = SI2*(T2+U3) + CO2*(U2-T3)
                    J = J + JUMP
                  END DO
!-----(end of loop across transforms)
                  JA = JA + JSTEPX
                  IF (JA<ISTART) JA = JA + NINC
                END DO
              END DO
            END DO
!-----( end of double loop for this k )
            KK = KK + 2*LA
          END DO
!-----( end of loop over values of k )
          LA = 3*LA
        END DO
!-----( end of loop on type II radix-3 passes )
!-----( nvex transforms completed)
490     CONTINUE
        ISTART = ISTART + NVEX*JUMP
      END DO
!-----( end of loop on blocks of transforms )

      RETURN
    END SUBROUTINE GPFA3F
!     fortran version of *gpfa5* -
!     radix-5 section of self-sorting, in-place,
!        generalized pfa

!-------------------------------------------------------------------

    SUBROUTINE GPFA5F(A,B,TRIGS,INC,JUMP,N,MM,LOT,ISIGN)
      USE DDPRECISION, ONLY : WP
      REAL (WP) :: BX, AX, U11, U10, U9, U8, U7, U6, U5, U4, T11, T10, T9, T8, &
        T7, T6, T5, T4, QRT5, SIN72, SIN36, SI4, CO4, C3, C2, C1, SI3, CO3, &
        SI2, CO2, SI1, CO1, U3, U1, U2, T3, T1, T2, S, B, A, TRIGS
      DIMENSION A(*), B(*), TRIGS(*)
      DATA SIN36/0.587785252292473_WP/, SIN72/0.951056516295154_WP/, &
        QRT5/0.559016994374947_WP/
      DATA LVR/64/

!     ***************************************************************
!     *                                                             *
!     *  N.B. LVR = LENGTH OF VECTOR REGISTERS, SET TO 128 FOR C90. *
!     *  RESET TO 64 FOR OTHER CRAY MACHINES, OR TO ANY LARGE VALUE *
!     *  (GREATER THAN OR EQUAL TO LOT) FOR A SCALAR COMPUTER.      *
!     *                                                             *
!     ***************************************************************

      N5 = 5**MM
      INQ = N/N5
      JSTEPX = (N5-N)*INC
      NINC = N*INC
      INK = INC*INQ
      MU = MOD(INQ,5)
      IF (ISIGN==-1) MU = 5 - MU

      M = MM
      MH = (M+1)/2
      S = REAL(ISIGN,KIND=WP)
      C1 = QRT5
      C2 = SIN72
      C3 = SIN36
      IF (MU==2 .OR. MU==3) THEN
        C1 = -C1
        C2 = SIN36
        C3 = SIN72
      END IF
      IF (MU==3 .OR. MU==4) C2 = -C2
      IF (MU==2 .OR. MU==4) C3 = -C3

      NBLOX = 1 + (LOT-1)/LVR
      LEFT = LOT
      S = REAL(ISIGN,KIND=WP)
      ISTART = 1

!  loop on blocks of lvr transforms
!  --------------------------------
      DO NB = 1, NBLOX

        IF (LEFT<=LVR) THEN
          NVEX = LEFT
        ELSE IF (LEFT<(2*LVR)) THEN
          NVEX = LEFT/2
          NVEX = NVEX + MOD(NVEX,2)
        ELSE
          NVEX = LVR
        END IF
        LEFT = LEFT - NVEX

        LA = 1

!  loop on type I radix-5 passes
!  -----------------------------
        DO IPASS = 1, MH
          JSTEP = (N*INC)/(5*LA)
          JSTEPL = JSTEP - NINC
          KK = 0

!  loop on k
!  ---------
          DO K = 0, JSTEP - INK, INK

            IF (K>0) THEN
              CO1 = TRIGS(KK+1)
              SI1 = S*TRIGS(KK+2)
              CO2 = TRIGS(2*KK+1)
              SI2 = S*TRIGS(2*KK+2)
              CO3 = TRIGS(3*KK+1)
              SI3 = S*TRIGS(3*KK+2)
              CO4 = TRIGS(4*KK+1)
              SI4 = S*TRIGS(4*KK+2)
            END IF

!  loop along transform
!  --------------------
            DO JJJ = K, (N-1)*INC, 5*JSTEP
              JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
              DO NU = 1, INQ
                JB = JA + JSTEPL
                IF (JB<ISTART) JB = JB + NINC
                JC = JB + JSTEPL
                IF (JC<ISTART) JC = JC + NINC
                JD = JC + JSTEPL
                IF (JD<ISTART) JD = JD + NINC
                JE = JD + JSTEPL
                IF (JE<ISTART) JE = JE + NINC
                J = 0

!  loop across transforms
!  ----------------------
                IF (K==0) THEN

!dir$ ivdep, shortloop
                  DO L = 1, NVEX
                    T1 = A(JB+J) + A(JE+J)
                    T2 = A(JC+J) + A(JD+J)
                    T3 = A(JB+J) - A(JE+J)
                    T4 = A(JC+J) - A(JD+J)
                    T5 = T1 + T2
                    T6 = C1*(T1-T2)
                    T7 = A(JA+J) - 0.25_WP*T5
                    A(JA+J) = A(JA+J) + T5
                    T8 = T7 + T6
                    T9 = T7 - T6
                    T10 = C3*T3 - C2*T4
                    T11 = C2*T3 + C3*T4
                    U1 = B(JB+J) + B(JE+J)
                    U2 = B(JC+J) + B(JD+J)
                    U3 = B(JB+J) - B(JE+J)
                    U4 = B(JC+J) - B(JD+J)
                    U5 = U1 + U2
                    U6 = C1*(U1-U2)
                    U7 = B(JA+J) - 0.25_WP*U5
                    B(JA+J) = B(JA+J) + U5
                    U8 = U7 + U6
                    U9 = U7 - U6
                    U10 = C3*U3 - C2*U4
                    U11 = C2*U3 + C3*U4
                    A(JB+J) = T8 - U11
                    B(JB+J) = U8 + T11
                    A(JE+J) = T8 + U11
                    B(JE+J) = U8 - T11
                    A(JC+J) = T9 - U10
                    B(JC+J) = U9 + T10
                    A(JD+J) = T9 + U10
                    B(JD+J) = U9 - T10
                    J = J + JUMP
                  END DO

                ELSE

!dir$ ivdep,shortloop
                  DO L = 1, NVEX
                    T1 = A(JB+J) + A(JE+J)
                    T2 = A(JC+J) + A(JD+J)
                    T3 = A(JB+J) - A(JE+J)
                    T4 = A(JC+J) - A(JD+J)
                    T5 = T1 + T2
                    T6 = C1*(T1-T2)
                    T7 = A(JA+J) - 0.25_WP*T5
                    A(JA+J) = A(JA+J) + T5
                    T8 = T7 + T6
                    T9 = T7 - T6
                    T10 = C3*T3 - C2*T4
                    T11 = C2*T3 + C3*T4
                    U1 = B(JB+J) + B(JE+J)
                    U2 = B(JC+J) + B(JD+J)
                    U3 = B(JB+J) - B(JE+J)
                    U4 = B(JC+J) - B(JD+J)
                    U5 = U1 + U2
                    U6 = C1*(U1-U2)
                    U7 = B(JA+J) - 0.25_WP*U5
                    B(JA+J) = B(JA+J) + U5
                    U8 = U7 + U6
                    U9 = U7 - U6
                    U10 = C3*U3 - C2*U4
                    U11 = C2*U3 + C3*U4
                    A(JB+J) = CO1*(T8-U11) - SI1*(U8+T11)
                    B(JB+J) = SI1*(T8-U11) + CO1*(U8+T11)
                    A(JE+J) = CO4*(T8+U11) - SI4*(U8-T11)
                    B(JE+J) = SI4*(T8+U11) + CO4*(U8-T11)
                    A(JC+J) = CO2*(T9-U10) - SI2*(U9+T10)
                    B(JC+J) = SI2*(T9-U10) + CO2*(U9+T10)
                    A(JD+J) = CO3*(T9+U10) - SI3*(U9-T10)
                    B(JD+J) = SI3*(T9+U10) + CO3*(U9-T10)
                    J = J + JUMP
                  END DO

                END IF

!-----( end of loop across transforms )

                JA = JA + JSTEPX
                IF (JA<ISTART) JA = JA + NINC
              END DO
            END DO
!-----( end of loop along transforms )
            KK = KK + 2*LA
          END DO
!-----( end of loop on nonzero k )
          LA = 5*LA
        END DO
!-----( end of loop on type I radix-5 passes)

        IF (N==5) GO TO 490

!  loop on type II radix-5 passes
!  ------------------------------
400     CONTINUE

        DO IPASS = MH + 1, M
          JSTEP = (N*INC)/(5*LA)
          JSTEPL = JSTEP - NINC
          LAINCL = LA*INK - NINC
          KK = 0

!     loop on k
!     ---------
          DO K = 0, JSTEP - INK, INK

            IF (K>0) THEN
              CO1 = TRIGS(KK+1)
              SI1 = S*TRIGS(KK+2)
              CO2 = TRIGS(2*KK+1)
              SI2 = S*TRIGS(2*KK+2)
              CO3 = TRIGS(3*KK+1)
              SI3 = S*TRIGS(3*KK+2)
              CO4 = TRIGS(4*KK+1)
              SI4 = S*TRIGS(4*KK+2)
            END IF

!  double loop along first transform in block
!  ------------------------------------------
            DO LL = K, (LA-1)*INK, 5*JSTEP

              DO JJJ = LL, (N-1)*INC, 5*LA*INK
                JA = ISTART + JJJ

!     "transverse" loop
!     -----------------
                DO NU = 1, INQ
                  JB = JA + JSTEPL
                  IF (JB<ISTART) JB = JB + NINC
                  JC = JB + JSTEPL
                  IF (JC<ISTART) JC = JC + NINC
                  JD = JC + JSTEPL
                  IF (JD<ISTART) JD = JD + NINC
                  JE = JD + JSTEPL
                  IF (JE<ISTART) JE = JE + NINC
                  JF = JA + LAINCL
                  IF (JF<ISTART) JF = JF + NINC
                  JG = JF + JSTEPL
                  IF (JG<ISTART) JG = JG + NINC
                  JH = JG + JSTEPL
                  IF (JH<ISTART) JH = JH + NINC
                  JI = JH + JSTEPL
                  IF (JI<ISTART) JI = JI + NINC
                  JJ = JI + JSTEPL
                  IF (JJ<ISTART) JJ = JJ + NINC
                  JK = JF + LAINCL
                  IF (JK<ISTART) JK = JK + NINC
                  JL = JK + JSTEPL
                  IF (JL<ISTART) JL = JL + NINC
                  JM = JL + JSTEPL
                  IF (JM<ISTART) JM = JM + NINC
                  JN = JM + JSTEPL
                  IF (JN<ISTART) JN = JN + NINC
                  JO = JN + JSTEPL
                  IF (JO<ISTART) JO = JO + NINC
                  JP = JK + LAINCL
                  IF (JP<ISTART) JP = JP + NINC
                  JQ = JP + JSTEPL
                  IF (JQ<ISTART) JQ = JQ + NINC
                  JR = JQ + JSTEPL
                  IF (JR<ISTART) JR = JR + NINC
                  JS = JR + JSTEPL
                  IF (JS<ISTART) JS = JS + NINC
                  JT = JS + JSTEPL
                  IF (JT<ISTART) JT = JT + NINC
                  JU = JP + LAINCL
                  IF (JU<ISTART) JU = JU + NINC
                  JV = JU + JSTEPL
                  IF (JV<ISTART) JV = JV + NINC
                  JW = JV + JSTEPL
                  IF (JW<ISTART) JW = JW + NINC
                  JX = JW + JSTEPL
                  IF (JX<ISTART) JX = JX + NINC
                  JY = JX + JSTEPL
                  IF (JY<ISTART) JY = JY + NINC
                  J = 0

!  loop across transforms
!  ----------------------
                  IF (K==0) THEN

!dir$ ivdep, shortloop
                    DO L = 1, NVEX
                      T1 = A(JB+J) + A(JE+J)
                      T2 = A(JC+J) + A(JD+J)
                      T3 = A(JB+J) - A(JE+J)
                      T4 = A(JC+J) - A(JD+J)
                      A(JB+J) = A(JF+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JA+J) - 0.25_WP*T5
                      A(JA+J) = A(JA+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JC+J) = A(JK+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JB+J) + B(JE+J)
                      U2 = B(JC+J) + B(JD+J)
                      U3 = B(JB+J) - B(JE+J)
                      U4 = B(JC+J) - B(JD+J)
                      B(JB+J) = B(JF+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JA+J) - 0.25_WP*U5
                      B(JA+J) = B(JA+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JC+J) = B(JK+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JF+J) = T8 - U11
                      B(JF+J) = U8 + T11
                      A(JE+J) = T8 + U11
                      B(JE+J) = U8 - T11
                      A(JK+J) = T9 - U10
                      B(JK+J) = U9 + T10
                      A(JD+J) = T9 + U10
                      B(JD+J) = U9 - T10
!----------------------
                      T1 = A(JG+J) + A(JJ+J)
                      T2 = A(JH+J) + A(JI+J)
                      T3 = A(JG+J) - A(JJ+J)
                      T4 = A(JH+J) - A(JI+J)
                      A(JH+J) = A(JL+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JB+J) - 0.25_WP*T5
                      A(JB+J) = A(JB+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JI+J) = A(JQ+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JG+J) + B(JJ+J)
                      U2 = B(JH+J) + B(JI+J)
                      U3 = B(JG+J) - B(JJ+J)
                      U4 = B(JH+J) - B(JI+J)
                      B(JH+J) = B(JL+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JB+J) - 0.25_WP*U5
                      B(JB+J) = B(JB+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JI+J) = B(JQ+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JG+J) = T8 - U11
                      B(JG+J) = U8 + T11
                      A(JJ+J) = T8 + U11
                      B(JJ+J) = U8 - T11
                      A(JL+J) = T9 - U10
                      B(JL+J) = U9 + T10
                      A(JQ+J) = T9 + U10
                      B(JQ+J) = U9 - T10
!----------------------
                      T1 = A(JH+J) + A(JO+J)
                      T2 = A(JM+J) + A(JN+J)
                      T3 = A(JH+J) - A(JO+J)
                      T4 = A(JM+J) - A(JN+J)
                      A(JN+J) = A(JR+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JC+J) - 0.25_WP*T5
                      A(JC+J) = A(JC+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JO+J) = A(JW+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JH+J) + B(JO+J)
                      U2 = B(JM+J) + B(JN+J)
                      U3 = B(JH+J) - B(JO+J)
                      U4 = B(JM+J) - B(JN+J)
                      B(JN+J) = B(JR+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JC+J) - 0.25_WP*U5
                      B(JC+J) = B(JC+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JO+J) = B(JW+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JH+J) = T8 - U11
                      B(JH+J) = U8 + T11
                      A(JW+J) = T8 + U11
                      B(JW+J) = U8 - T11
                      A(JM+J) = T9 - U10
                      B(JM+J) = U9 + T10
                      A(JR+J) = T9 + U10
                      B(JR+J) = U9 - T10
!----------------------
                      T1 = A(JI+J) + A(JT+J)
                      T2 = A(JN+J) + A(JS+J)
                      T3 = A(JI+J) - A(JT+J)
                      T4 = A(JN+J) - A(JS+J)
                      A(JT+J) = A(JX+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JP+J) - 0.25_WP*T5
                      AX = A(JP+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JP+J) = A(JD+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      A(JD+J) = AX
                      U1 = B(JI+J) + B(JT+J)
                      U2 = B(JN+J) + B(JS+J)
                      U3 = B(JI+J) - B(JT+J)
                      U4 = B(JN+J) - B(JS+J)
                      B(JT+J) = B(JX+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JP+J) - 0.25_WP*U5
                      BX = B(JP+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JP+J) = B(JD+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      B(JD+J) = BX
                      A(JI+J) = T8 - U11
                      B(JI+J) = U8 + T11
                      A(JX+J) = T8 + U11
                      B(JX+J) = U8 - T11
                      A(JN+J) = T9 - U10
                      B(JN+J) = U9 + T10
                      A(JS+J) = T9 + U10
                      B(JS+J) = U9 - T10
!----------------------
                      T1 = A(JV+J) + A(JY+J)
                      T2 = A(JO+J) + A(JT+J)
                      T3 = A(JV+J) - A(JY+J)
                      T4 = A(JO+J) - A(JT+J)
                      A(JV+J) = A(JJ+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JU+J) - 0.25_WP*T5
                      AX = A(JU+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JU+J) = A(JE+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      A(JE+J) = AX
                      U1 = B(JV+J) + B(JY+J)
                      U2 = B(JO+J) + B(JT+J)
                      U3 = B(JV+J) - B(JY+J)
                      U4 = B(JO+J) - B(JT+J)
                      B(JV+J) = B(JJ+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JU+J) - 0.25_WP*U5
                      BX = B(JU+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JU+J) = B(JE+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      B(JE+J) = BX
                      A(JJ+J) = T8 - U11
                      B(JJ+J) = U8 + T11
                      A(JY+J) = T8 + U11
                      B(JY+J) = U8 - T11
                      A(JO+J) = T9 - U10
                      B(JO+J) = U9 + T10
                      A(JT+J) = T9 + U10
                      B(JT+J) = U9 - T10
                      J = J + JUMP
                    END DO

                  ELSE

!dir$ ivdep, shortloop
                    DO L = 1, NVEX
                      T1 = A(JB+J) + A(JE+J)
                      T2 = A(JC+J) + A(JD+J)
                      T3 = A(JB+J) - A(JE+J)
                      T4 = A(JC+J) - A(JD+J)
                      A(JB+J) = A(JF+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JA+J) - 0.25_WP*T5
                      A(JA+J) = A(JA+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JC+J) = A(JK+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JB+J) + B(JE+J)
                      U2 = B(JC+J) + B(JD+J)
                      U3 = B(JB+J) - B(JE+J)
                      U4 = B(JC+J) - B(JD+J)
                      B(JB+J) = B(JF+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JA+J) - 0.25_WP*U5
                      B(JA+J) = B(JA+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JC+J) = B(JK+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JF+J) = CO1*(T8-U11) - SI1*(U8+T11)
                      B(JF+J) = SI1*(T8-U11) + CO1*(U8+T11)
                      A(JE+J) = CO4*(T8+U11) - SI4*(U8-T11)
                      B(JE+J) = SI4*(T8+U11) + CO4*(U8-T11)
                      A(JK+J) = CO2*(T9-U10) - SI2*(U9+T10)
                      B(JK+J) = SI2*(T9-U10) + CO2*(U9+T10)
                      A(JD+J) = CO3*(T9+U10) - SI3*(U9-T10)
                      B(JD+J) = SI3*(T9+U10) + CO3*(U9-T10)
!----------------------
                      T1 = A(JG+J) + A(JJ+J)
                      T2 = A(JH+J) + A(JI+J)
                      T3 = A(JG+J) - A(JJ+J)
                      T4 = A(JH+J) - A(JI+J)
                      A(JH+J) = A(JL+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JB+J) - 0.25_WP*T5
                      A(JB+J) = A(JB+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JI+J) = A(JQ+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JG+J) + B(JJ+J)
                      U2 = B(JH+J) + B(JI+J)
                      U3 = B(JG+J) - B(JJ+J)
                      U4 = B(JH+J) - B(JI+J)
                      B(JH+J) = B(JL+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JB+J) - 0.25_WP*U5
                      B(JB+J) = B(JB+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JI+J) = B(JQ+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JG+J) = CO1*(T8-U11) - SI1*(U8+T11)
                      B(JG+J) = SI1*(T8-U11) + CO1*(U8+T11)
                      A(JJ+J) = CO4*(T8+U11) - SI4*(U8-T11)
                      B(JJ+J) = SI4*(T8+U11) + CO4*(U8-T11)
                      A(JL+J) = CO2*(T9-U10) - SI2*(U9+T10)
                      B(JL+J) = SI2*(T9-U10) + CO2*(U9+T10)
                      A(JQ+J) = CO3*(T9+U10) - SI3*(U9-T10)
                      B(JQ+J) = SI3*(T9+U10) + CO3*(U9-T10)
!----------------------
                      T1 = A(JH+J) + A(JO+J)
                      T2 = A(JM+J) + A(JN+J)
                      T3 = A(JH+J) - A(JO+J)
                      T4 = A(JM+J) - A(JN+J)
                      A(JN+J) = A(JR+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JC+J) - 0.25_WP*T5
                      A(JC+J) = A(JC+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JO+J) = A(JW+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      U1 = B(JH+J) + B(JO+J)
                      U2 = B(JM+J) + B(JN+J)
                      U3 = B(JH+J) - B(JO+J)
                      U4 = B(JM+J) - B(JN+J)
                      B(JN+J) = B(JR+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JC+J) - 0.25_WP*U5
                      B(JC+J) = B(JC+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JO+J) = B(JW+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      A(JH+J) = CO1*(T8-U11) - SI1*(U8+T11)
                      B(JH+J) = SI1*(T8-U11) + CO1*(U8+T11)
                      A(JW+J) = CO4*(T8+U11) - SI4*(U8-T11)
                      B(JW+J) = SI4*(T8+U11) + CO4*(U8-T11)
                      A(JM+J) = CO2*(T9-U10) - SI2*(U9+T10)
                      B(JM+J) = SI2*(T9-U10) + CO2*(U9+T10)
                      A(JR+J) = CO3*(T9+U10) - SI3*(U9-T10)
                      B(JR+J) = SI3*(T9+U10) + CO3*(U9-T10)
!----------------------
                      T1 = A(JI+J) + A(JT+J)
                      T2 = A(JN+J) + A(JS+J)
                      T3 = A(JI+J) - A(JT+J)
                      T4 = A(JN+J) - A(JS+J)
                      A(JT+J) = A(JX+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JP+J) - 0.25_WP*T5
                      AX = A(JP+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JP+J) = A(JD+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      A(JD+J) = AX
                      U1 = B(JI+J) + B(JT+J)
                      U2 = B(JN+J) + B(JS+J)
                      U3 = B(JI+J) - B(JT+J)
                      U4 = B(JN+J) - B(JS+J)
                      B(JT+J) = B(JX+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JP+J) - 0.25_WP*U5
                      BX = B(JP+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JP+J) = B(JD+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      B(JD+J) = BX
                      A(JI+J) = CO1*(T8-U11) - SI1*(U8+T11)
                      B(JI+J) = SI1*(T8-U11) + CO1*(U8+T11)
                      A(JX+J) = CO4*(T8+U11) - SI4*(U8-T11)
                      B(JX+J) = SI4*(T8+U11) + CO4*(U8-T11)
                      A(JN+J) = CO2*(T9-U10) - SI2*(U9+T10)
                      B(JN+J) = SI2*(T9-U10) + CO2*(U9+T10)
                      A(JS+J) = CO3*(T9+U10) - SI3*(U9-T10)
                      B(JS+J) = SI3*(T9+U10) + CO3*(U9-T10)
!----------------------
                      T1 = A(JV+J) + A(JY+J)
                      T2 = A(JO+J) + A(JT+J)
                      T3 = A(JV+J) - A(JY+J)
                      T4 = A(JO+J) - A(JT+J)
                      A(JV+J) = A(JJ+J)
                      T5 = T1 + T2
                      T6 = C1*(T1-T2)
                      T7 = A(JU+J) - 0.25_WP*T5
                      AX = A(JU+J) + T5
                      T8 = T7 + T6
                      T9 = T7 - T6
                      A(JU+J) = A(JE+J)
                      T10 = C3*T3 - C2*T4
                      T11 = C2*T3 + C3*T4
                      A(JE+J) = AX
                      U1 = B(JV+J) + B(JY+J)
                      U2 = B(JO+J) + B(JT+J)
                      U3 = B(JV+J) - B(JY+J)
                      U4 = B(JO+J) - B(JT+J)
                      B(JV+J) = B(JJ+J)
                      U5 = U1 + U2
                      U6 = C1*(U1-U2)
                      U7 = B(JU+J) - 0.25_WP*U5
                      BX = B(JU+J) + U5
                      U8 = U7 + U6
                      U9 = U7 - U6
                      B(JU+J) = B(JE+J)
                      U10 = C3*U3 - C2*U4
                      U11 = C2*U3 + C3*U4
                      B(JE+J) = BX
                      A(JJ+J) = CO1*(T8-U11) - SI1*(U8+T11)
                      B(JJ+J) = SI1*(T8-U11) + CO1*(U8+T11)
                      A(JY+J) = CO4*(T8+U11) - SI4*(U8-T11)
                      B(JY+J) = SI4*(T8+U11) + CO4*(U8-T11)
                      A(JO+J) = CO2*(T9-U10) - SI2*(U9+T10)
                      B(JO+J) = SI2*(T9-U10) + CO2*(U9+T10)
                      A(JT+J) = CO3*(T9+U10) - SI3*(U9-T10)
                      B(JT+J) = SI3*(T9+U10) + CO3*(U9-T10)
                      J = J + JUMP
                    END DO

                  END IF

!-----(end of loop across transforms)

                  JA = JA + JSTEPX
                  IF (JA<ISTART) JA = JA + NINC
                END DO
              END DO
            END DO
!-----( end of double loop for this k )
            KK = KK + 2*LA
          END DO
!-----( end of loop over values of k )
          LA = 5*LA
        END DO
!-----( end of loop on type II radix-5 passes )
!-----( nvex transforms completed)
490     CONTINUE
        ISTART = ISTART + NVEX*JUMP
      END DO
!-----( end of loop on blocks of transforms )

      RETURN
    END SUBROUTINE GPFA5F

    SUBROUTINE TARRCTBLK3(A1,A2,XS1,YS1,ZS1,XS2,YS2,ZS2,XS3,YS3,ZS3,DX, &
                          X0,CDESCR,IOSHP,MXNAT,NAT,IXYZ,ICOMP)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Arguments:

      REAL(WP) :: XS1,XS2,XS3,YS1,YS2,YS3,ZS1,ZS2,ZS3
      INTEGER :: IOSHP,MXNAT,NAT
      CHARACTER :: CDESCR*67
      INTEGER*2 :: &
         ICOMP(MXNAT,3)
      INTEGER :: &
         IXYZ(MXNAT,3)
      REAL(WP) :: &
         A1(3),   &
         A2(3),   &
         DX(3),   &
         X0(3)

! Local variables:

      INTEGER :: JA,JD,JX,JXMAX1,JXMAX2,JXMAX3,JXMIN1,JXMIN2,JXMIN3,  &
                 JY,JYMAX1,JYMAX2,JYMAX3,JYMIN1,JYMIN2,JYMIN3,        &
                 JZ,JZMAX1,JZMAX2,JZMAX3,JZMIN1,JZMIN2,JZMIN3,        &
                 NATS1,NATS2,NATS3,NX1,NX2,NX3,NY1,NY2,NY3,NZ1,NZ2,NZ3
      CHARACTER :: CMSGNM*70
      REAL(WP) :: DELTA,TERM

! External subroutines:

      EXTERNAL ERRMSG

! Intrinsic functions:

!***********************************************************************
! subroutine TARRCTBLK3
! Purpose: to construct target consisting of 3 stacked rectangular blocks:
! boundary between blocks 1 and 2 lies in x=0 plane

!      block 1, of composition 1, extends from x/d= 0 to XS1
!                                              y/d=-YS1/2 to +YS1/2
!                                              z/d=-ZS1/2 to +ZS1/2
!      block 2, of composition 2, extends from x/d=-XS2 to     0
!                                              y/d=-YS2/2 to +YS2/2
!                                              z/d=-ZS2/2 to +ZS2/2
!      block 3, of composition 3, extends from x/d=-(XS2+XS3) to -XS2
!                                              y/d=-YS3/2 to +YS3/2
!                                              z/d=-ZS3/2 to +ZS3/2

! Input:
!        XS1=(x thickness of composition 1 of slab)/d   (d=lattice spacing)
!        YS1=(y extent of composition 1 of slab)/d   (d=lattice spacing)
!        ZS1=(z extent of composition 1 of slab)/d   (d=lattice spacing)
!        XS2=(x thickness of composition 2 of slab)/d
!        YS2=(y extent of composition 2 of slab)/d
!        ZS2=(z extent of composition 2 of slab)/d
!        XS3=(x thickness of composition 3 of slab)/d
!        YS3=(y extent of composition 3 of slab)/d
!        ZS3=(z extent of composition 3 of slab)/d
!        DX(1-3)=(dx,dy,dz)/d where dx,dy,dz=lattice spacings in x,y,z
!                directions, and d=(dx*dy*dz)**(1/3)=effective lattice
!                spacing
!        IOSHP=device number for "target.out" file
!             =-1 to suppress printing of "target.out"
!        MXNAT=dimensioning information (max number of atoms)
! Output:
!        A1(1-3)=unit vector (1,0,0) defining target axis 1 in Target Frame
!        A2(1-3)=unit vector (0,1,0) defining target axis 2 in Target Frame
!        NAT=number of atoms in target
!        IXYZ(1-NAT,1-3)=x/d,y/d,z/d for atoms of target
!        ICOMP(1-NAT,1-3)=composition number for locations 1-NAT 
!                         and directions 1-3
!        X0(1-3)=offset vector, such that
!                x/d=(IXYZ(J,1)+X0(1))*DX(1)
!                y/d=(IXYZ(J,2)+X0(2))*DX(2)
!                z/d=(IXYZ(J,3)+X0(3))*DX(3)
!                where (x,y,z)=location of dipole in Target Frame
!                with (0,0,0)=point where axis of disk
!                             intersects upper surface of slab

! Target consists of three stacked rectangular slabs with x-axis running
!        through center of each slab
!        slab 1 is of extent XS1 x YS1 x ZS1 (in units of d)
!        slab 2 is of extent XS2 x YS2 x ZS2 (in units of d)
!        slab 3 is of extent XS3 x YS3 x ZS3 (in units of d)

!        center of upper surface of slab 1 is at (XS1*d*DX(1), 0 , 0)
!        center of upper surface of slab 2 is at (0,0,0)
!        center of lower surface of slab 2 = upper surface of slab 3
!                                          is at (-XS2*d*DX(2) , 0 , 0 )
!        boundary between compositions 1 and 2 is in the x=0 plane
!        boundary between compositions 2 and 3 is in the x=-XS2*d*DX(1) plane
!        lower surface of slab 3 is in the x=-(XS2+XS3)*d*DX(1) plane

!        if max(YS1,YS2,YS3)/DX(2)
!           is even: lattice will be located at y/(d*DX(2)) = +/-0.5, +/-1.5, .
!               odd:                            y/(d*DX(2)) = 0, +/-1, +/-2, ..
!        if max(ZS1,ZS2,ZS3)/DX(3) 
!           is even: lattice will be located at z/(d*DX(3)) = +/-0.5, +/-1.5, .
!               odd:                            z/(d*DX(3)) = 0, +/-1, +/-2, ..

! B.T.Draine, Princeton Univ. Obs.
! History:
! 08.01.31 (BTD) created
! 08.03.23 (BTD) fixed errors
! 08.03.30 (BTD) replace 1.E-8 -> 1.E-5 so that it will work with
!                single as well as double precision arithmetic
! 08.03.30 (BTD) replace 1.E-5 by DELTA=0.499999 to obtain proper
!                behavior as YS1,YS2,YS3 vary, etc.
! 08.08.30 (BTD) modified format 9020
! 10.01.24 (BTD) reordered argument list
!                XS1,XS2,XS3,YS1,YS2,YS3,ZS1,ZS2,ZS3 ->
!                XS1,YS1,ZS1,XS2,YS2,ZS2,XS3,YS3,ZS3
!                for consistency with UserGuide
!                problem reported by
!                Bala Krishna Juluri, Penn State Univ.
! end history

! Copyright (C) 2008,2010
!               B.T. Draine and P.J. Flatau

! This code is covered by the GNU General Public License.
!***********************************************************************
!***********************************************************************
      IF(XS1*XS2*XS3.GT.0._WP)THEN
         WRITE(CMSGNM,FMT='(A)')' Three stacked rectangular slabs'
         WRITE(CDESCR,FMT='(A)')' Three stacked rectangular slabs'
      ELSEIF(XS1==0..OR.XS2==0..OR.XS3==0.)THEN
         WRITE(CMSGNM,FMT='(A)')' Two stacked rectangular slabs'
         WRITE(CDESCR,FMT='(A)')' Two stacked rectangular slabs'
      ENDIF

! Specify target axes A1 and A2
! Convention: A1 will be (1,0,0) in Target Frame
!             A2 will be (0,1,0) in Target Frame

      DO JA=1,3
         A1(JA)=0._WP
         A2(JA)=0._WP
      ENDDO
      A1(1)=1._WP
      A2(2)=1._WP

! Target reference point =intersection of x_TF axis with plane separating
! slabs 1 and 2

! Set lattice offset in x direction:
! Dipole with IX=0 is located at x/(d*DX(1))=0.5

      X0(1)=0.5_WP

! Determine lattice offset in y and z directions
!   if NY is even, dipole with IY=0 is located at y/d=0.5
!            odd                                      0
!   if NZ is even, dipole with IZ=0 is located at z/d=0.5
!            odd                                      0

      TERM=MAX(YS1,YS2)
      TERM=MAX(TERM,YS3)
      NY1=NINT(TERM/DX(2))
      IF(MOD(NY1,2)==0)THEN
         X0(2)=0.5_WP
      ELSE
         X0(2)=0._WP
      ENDIF

      TERM=MAX(ZS1,ZS2)
      TERM=MAX(TERM,ZS3)
      NZ1=NINT(TERM/DX(3))
      IF(MOD(NZ1,2)==0)THEN
         X0(3)=0.5_WP
      ELSE
         X0(3)=0._WP
      ENDIF

! Now populate lattice:

      NAT=0
      DELTA=0.49999_WP

! First do the top block (material 1)

      JXMIN1=0
      JXMAX1=NINT(XS1/DX(1))-1
      NX1=JXMAX1-JXMIN1+1

! number of dipole layers 
!           NX1 = jxmax1-jxmin1+1 = nint(xs1/dx(1))

      JYMIN1=NINT(-0.5_WP*YS1/DX(2)-X0(2)+DELTA)
      JYMAX1=NINT(0.5_WP*YS1/DX(2)-X0(2)-DELTA)
      JZMIN1=NINT(-0.5_WP*ZS1/DX(3)-X0(3)+DELTA)
      JZMAX1=NINT(0.5_WP*ZS1/DX(3)-X0(3)-DELTA)
!*** diagnostic
      write(0,*)'ys1=',ys1,' x0(2)=',x0(2)
      write(0,*)'jymin1=',jymin1,' jymax1=',jymax1
      write(0,*)'zs1=',zs1,' x0(3)=',x0(3)
      write(0,*)'jzmin1=',jzmin1,' jzmax1=',jzmax1
!***
      NY1=JYMAX1-JYMIN1+1
      NZ1=JZMAX1-JZMIN1+1

! number of dipoles in y direction 
!     NY1 = jymax1-jymin1+1 
!         = nint(0.5*ys1/dx(2)-x0(2)+delta)-nint(-0.5*ys1/dx(2)-x0(2)-delta)+1
!         = nint(0.5*ys1/dx(2)-x0(2)+delta)+nint(0.5*ys1/dx(2)+x0(2)+delta)+1
!
! number of dipoles in Z direction 
!     NZ1 = jzmax1-jzmin1+1 
!         = nint(0.5*zs1/dx(3)-x0(3)+delta)-nint(-0.5*zs1/dx(3)-x0(3)-delta)+1
!         = nint(0.5*zs1/dx(3)-x0(3)+delta)+nint(0.5*zs1/dx(3)+x0(3)+delta)+1

      IF(JXMIN1.LE.JXMAX1)THEN
         DO JY=JYMIN1,JYMAX1
            DO JZ=JZMIN1,JZMAX1
               DO JX=JXMIN1,JXMAX1
                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','TARRCTBLK3',' NAT.GT.MXNAT')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  DO JD=1,3
                     ICOMP(NAT,JD)=1
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
         NATS1=NAT
      ENDIF
      NATS1=NAT

!*** diagnostic
      write(0,*)'block 1 runs from JX= ',JXMIN1,' to ',JXMAX1
!***
! sanity check

      IF(NATS1/=NX1*NY1*NZ1)THEN
         CALL ERRMSG('FATAL','TARRCTBLK3',' NAT1.ne.NX1*NY1*NZ1')
      ENDIF

! now do block 2 (material 2)
! layer 1: extends from     0   to  xs1         [composition 2]
!          dipoles from     1   to NAT1
! layer 2: extends from -(xs1+xs2) to -xs1       [composition 3]
!          dipoles from   JXMIN2   to (JXMIN1-1)

      JXMIN2=-NINT(XS2/DX(1))
      JXMAX2=-1
      NX2=JXMAX2-JXMIN2+1
      JYMIN2=NINT(-0.5_WP*YS2/DX(2)-X0(2)+DELTA)
      JYMAX2=NINT(0.5_WP*YS2/DX(2)-X0(2)-DELTA)
      JZMIN2=NINT(-0.5_WP*ZS2/DX(3)-X0(3)+DELTA)
      JZMAX2=NINT(0.5_WP*ZS2/DX(3)-X0(3)-DELTA)
      NY2=JYMAX2-JYMIN2+1
      NZ2=JZMAX2-JZMIN2+1

! middle layer = composition 2:

      IF(JXMIN2.LT.JXMIN1)THEN
         DO JX=JXMIN2,JXMAX2
            DO JY=JYMIN2,JYMAX2
               DO JZ=JZMIN2,JZMAX2
                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','TARSLBLIN',' NAT.GT.MXNAT ')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  DO JD=1,3
                     ICOMP(NAT,JD)=2
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
      ENDIF
      NATS2=NAT-NATS1

!*** diagnostic
      write(0,*)'block 2 runs from JX= ',JXMIN2,' to ',JXMAX2
!***
! sanity check

      IF(NATS2/=NX2*NY2*NZ2)THEN
         CALL ERRMSG('FATAL','TARRCTBLK3',' NATS2.ne.NX2*NY2*NZ2')
      ENDIF

! lower slab layer = composition 3

      JXMIN3=-NINT((XS2+XS3)/DX(1))
      JXMAX3=-NINT(XS2/DX(1))-1
      NX3=JXMAX3-JXMIN3+1

      JYMIN3=NINT(-0.5_WP*YS3/DX(2)-X0(2)+DELTA)
      JYMAX3=NINT(0.5_WP*YS3/DX(2)-X0(2)-DELTA)
      JZMIN3=NINT(-0.5_WP*ZS3/DX(3)-X0(3)+DELTA)
      JZMAX3=NINT(0.5_WP*ZS3/DX(3)-X0(3)-DELTA)
      NY3=JYMAX3-JYMIN3+1
      NZ3=JZMAX3-JZMIN3+1

      IF(JXMIN3.LT.JXMIN2)THEN
         DO JX=JXMIN3,JXMAX3
            DO JY=JYMIN3,JYMAX3
               DO JZ=JZMIN3,JZMAX3
                  NAT=NAT+1
                  IF(NAT>MXNAT)THEN
                     CALL ERRMSG('FATAL','TARSLBLIN',' NAT.GT.MXNAT ')
                  ENDIF
                  IXYZ(NAT,1)=JX
                  IXYZ(NAT,2)=JY
                  IXYZ(NAT,3)=JZ
                  DO JD=1,3
                     ICOMP(NAT,JD)=3
                  ENDDO
               ENDDO
            ENDDO
         ENDDO
!***
         write(0,*)'layer 3 runs from JX= ',JXMIN3,' to ',JXMAX3
         write(0,*)'xs2=',xs2,' xs3=',xs3
!***
      ENDIF
      NATS3=NAT-NATS1-NATS2

! sanity check:

      IF(NATS3/=NX3*NY3*NZ3)THEN
         CALL ERRMSG('FATAL','TARRCTBLK3',' NATS3.ne.NX3*NY3*NZ3')
      ENDIF

      IF(NATS1*NATS2*NATS3>0)THEN
         WRITE(CMSGNM,FMT='(A,I7,A)')                          &
            ' Trilayer block structure with NAT=',NAT,' dipoles'
      ELSE
         WRITE(CMSGNM,FMT='(A,I7,A)')                         &
            ' Bilayer block structure with NAT=',NAT,' dipoles'
      ENDIF
      IF(IOSHP>=0)THEN
         OPEN(UNIT=IOSHP,FILE='target.out',STATUS='UNKNOWN')
         WRITE(IOSHP,FMT=9020)XS1,YS1,ZS1,XS2,YS2,ZS2,XS3,YS3,ZS3, &
            NAT,NATS1,NATS2,NATS3,A1,A2,DX,X0
         DO JA=1,NAT
            WRITE(IOSHP,FMT=9030)JA,IXYZ(JA,1),IXYZ(JA,2),IXYZ(JA,3), &
                                 ICOMP(JA,1),ICOMP(JA,2),ICOMP(JA,3)
         ENDDO
         CLOSE(UNIT=IOSHP)
      ENDIF
      RETURN
9020  FORMAT(' >TARRCTBLK3: XS1,YS1,ZS1,XS2,YS2,ZS2,XS3,YS3,ZS3=',9F8.4,/, &
         I10,3I7,' = NAT,NATS1,NATS2,NATS3',/,                             &
         3F10.6,' = A_1 vector',/,                                         &
         3F10.6,' = A_2 vector',/,                                         &
         3F10.6,' = lattice spacings (d_x,d_y,d_z)/d',/,                   &
         3F10.5,' = lattice offset x0(1-3) = (x_TF,y_TF,z_TF)/d ',         &
               'for dipole 0 0 0',/,                                       &
         '     JA  IX  IY  IZ ICOMP(x,y,z)')
9030  FORMAT(I7,3I4,3I2)
    END SUBROUTINE TARRCTBLK3

    SUBROUTINE VERSION(CSTAMP)
      IMPLICIT NONE
! Arguments:
      CHARACTER :: CSTAMP*26

      CSTAMP = 'DDSCAT 7.0.7 [10.01.28]'
!***********************************************************************
! History of major changes to DDSCAT package:
! 90.12.21 (BTD): Added code to DDSCAT to create output files
!                 'qtable' (summary of Q values)
!                 'mtable' (summary of diel. func. for material 1)
! 91.08.14 (BTD): Add QBKSCA to arg. list for GETFML
!                 Modify code to print out Q_bk
! 91.08.15 (BTD): Provide different headings for qtable depending on
!                 whether IORTH=1 or 2 (add statement 9043 to DDSCAT).
! 91.09.17 (BTD): Remove calls to ALPHA and EVALA in DDSCAT (needed to
!                 move these to subroutine GETFML since alpha from Latti
!                 Dispersion Relation depends on propagation direction
!                 and polarization state)
!                 Add CALPHA,CXEPS,ICOMP,MXCOMP to argument list for
!                 GETFML (information required by ALPHA)
! 91.11.12 (BTD): Added variable IDVSHP to argument list for TARGET
!                 (device number for REASHP to use in reading shape file
! 93.01.15 (BTD): Modified DDSCAT to divided output file qtable into 2 f
!                 qtable (containing Q_ext,Q_abs,Q_sca,g,Q_bk) and
!                 qtable2 (containing Q_pha, Q_pol, Q_cpol)
! 93.01.16 (BTD): Modify DDSCAT so that qtable, qtable2, and mtable are
!                 after writing, and reopened for each new write
! 93.01.20 (BTD): Add MXNX, MXNY, MXNZ to argument list for subroutine
!                 EXTEND to permit checking of target size against
!                 maximum allowed dimensions
! 93.03.11 (BTD): Deleted all code associated with unused variable
!                 CMACHN (originally included to identify machine/OS)
! 93.03.12 (BTD): Changed CDESCR*60 -> CDESCR*67
!                 Moved WRITE(IDVOUT,9010) to subr. TARGET
! 93.06.02 (BTD): Corrected error in FORMAT statement 9045 in DDSCAT
! 93.06.03 (BTD): Corrected error in computation of angle-averaged
!                 backscattering cross section QBKSUM(JO) in DDSCAT (had
!                 neglected to reset sum to zero for each new target).
! 93.09.28 (BTD): Add "fix" in DDSCAT.f to work around Sun compiler/OS
!                 bug (see description below.
! 93.12.15 (BTD): Corrected calculation of PPOL in DDSCAT.f  Added
!                 comments on correspondence between our notation and
!                 elements of 2x2 amplitude scattering matrix and 4x4
!                 Mueller scattering matrix.
! 94.01.27 (BTD): Replaced SHPAR1,SHPAR2,SHPAR3 by SHPAR(1-6) to
!                 allow up to 6 shape parameters in DDSCAT, REAPAR,
!                 TARGET.
! 94.06.20 (PJF): Version 4c.1:
!                 Modifications to various routines to support use of
!                 GPFA FFT code of Temperton by specifying option
!                 NEWTMP in ddscat.par.  Changes made in
!                 cxfft3, eself, extend, reapar
!                 Add FFT timing code TSTFFT to distribution.
!                 Change made to timeit_xxx routines for compatibility
!                 with TSTFFT
! 94.12.20 (BTD): Add subroutine VERSION to consolidate log of
!                 significant changes to DDSCAT package.
! 95.04.07 (BTD): REASHP: Changed CDESCR*60->CDESCR*67 for compatibility
!                         with calling routine TARGET
!                 TARCYL: corrected error in code
! 95.05.15 (BTD): REASHP: Corrected READ statement
!                         added module for inhomogeneous/anisotropic
!                         targets.
! 95.05.26 (BTD): REAPAR: corrected construction of orthogonal
!                         polarization when E01 is complex (e.g.,
!                         circular polarization).
! 95.06.14 (BTD): REAPAR: added code to check that user is not requestin
!                         computation of f_ml when using other than
!                         linearly polarized E01
! 95.06.14 (BTD): Version 5a.1: first development
!                 Differs from version 4d in computing:
!                 full radiation pressure force (transverse components,
!                 in additional to longitudinal component computed
!                 previously);
!                 Torque due to scattering and absorption of radiation
!                 as measured by "vector torque cross section".
!                 Changes made in:
!                 DDSCAT
!                 GETFML (including argument list)
!                 SCAT (including argument list)
!                 VERSION (CSTAMP is now CHARACTER*22, so that a date
!                    can be attached to version number)
! 95.06.15 (BTD): Added CXE to argument list of SCAT
!                 Added new control parameters
!                 CMDSOL (to choose solution method)
!                 CMDTRQ (to choose whether or not to compute torques)
! 95.06.20 (PJF+: Major modification of DDSCAT and GETFML to support
!           BTD): use of modular iterative solvers (e.g., CCGPACK and
!                 PIM routines).
!               : add CMDSOL to argument list to specify method
!                 of solution, with "supported" options
!                 PETRKP = Petravic&Kuo-Petravic CCG routine (from
!                          CCGPACK, coded by P.J. Flatau based on
!                          earlier code by B.T. Draine)
!                 PBCGST = Preconditioned Biconjugate Gradient with
!                          Stabilization (from PIM package, coded by
!                          R. Dias da Cunha and T. Hopkins)
!               : add CMDTRQ to argument list of REAPAR and GETFML
! 95.07.21 (BTD): Major revision to subroutine SCAT
!                 Added additional scratch arrays to DDSCAT,GETFML,SCAT
! 95.07.24 (BTD): Corrected errors in SCAT
! 95.08.14 (BTD): Modified GETFML and PROGRESS to include
!                 COMMON/NORMRES/ERRSCAL to allow renormalization of
!                 error |Ax-b| relative to |b|.
! 96.01.05 (BTD): Version 5a.2:
!                 Differs from version 5a.1 in including
!                 shape options BLOCKS and DW1996, including
!                 automatic calculation of principal axes A1 and A2
!                 with largest and second-largest moment of inertia
!                 eigenvalue and eigenvector problem is solved using
!                 routines BALANC, BALBAK, EIGV, ELMHS0, ELTRN0, HQR2,
!                 IPMPAR, and SPMPAR taken from the Naval Surface
!                 Warfare Center Library of Mathematics Subroutines.
! 96.01.25 (BTD): Added shape option TWOSPH (routine TAR2SP, and
!                 modifications to TARGET,REAPAR).
! 96.02.23 (BTD): Subroutine PRINAXIS now carries out calculation of
!                 principal axes and eigenvalues of moment of inertia
!                 for arbitary grain shape (if invoked by appropriate
!                 "target generation" subroutine), and prints out
!                 3 principal axes and eigenvalues
! 96.10.17 (BTD): Version 5a.3:
!                 Added NAT0 to argument list for routine ALPHA.
!                 This required modification of ALPHA and GETFML.
! 96.10.18 (BTD): Changed NEWTMP to GPFAFT (for Generalized Prime
!                 Factor Algorithm for Fourier Transform).
! 96.11.06 (BTD): Version 5a.4:
!                 Removed code from DDSCAT and moved to subroutines
!                 GETMUELLER and WRITESCA
!                 Changed definition of scattering angle phi.
!                 Previously, phi was measured from plane containing
!                 incident k vector and Re(CXE01)
!                 Henceforth, phi is measured from Lab x,y plane
!                 (incident radiation is along x axis).
!                 This involved changes to SCAVEC
!                 Modified GETMUELLER so that for IORTH=2 it
!                 automatically computes the complete Mueller scattering
!                 matrix for each target orientation, and for the
!                 orientational average.
!                 Modified WRITESCA so that it writes out selected
!                 elements of the Mueller matrix.
! 96.11.14 (PJF): Add timers(mxtimers), ntimers to DDSCAT and getfml
!                 timers contains information about CPU times of
!                 various parts of the code and informations needed
!                 for timming (e.g. number of iterations)
!                 Further changes of "WRITESCA" to include binary
!                 file option. This should be of use, for example,
!                 for users of IDL.
!                 Added "cbinflag" to DDSCA, reapar. Added
!                 "cbinfile", "iobin" and "open" unformatted file in DDS
!                 "close(iobin) in DDSCAT.
!                 Removed "getset" routine. Hardwired "ioerr" in
!                 "errmsg", and "ioout" in "wrimsg".
!                 Combined all "rotation" code in rot.2
!                 Added dd.pro package for DDSCAT output postprocessing.
!                 The package includes IDL reading code of binary
!                 DDSCAT file and Bohren and Huffman Mie routine coded i
!                 Added 10,000 lines of LAPACK code to solve 3x3
!                 eigenvalue problem. Removed NSWC l(eispack)
!                 driver because (a) it contains ald r1mach
!                 tedious to support code (b) because LAPACK is
!                 more modern.
!                 Add several *.ps files to doc and BibTeX
!                 bibliography of recent DDA references.
! 96.11.15 (PJF): Added NetCDF binary option to "writesca.f"
!                 One needs "include" in writesca.f which is non-standar
!                 in FORTRAN77 but will probably work on all architectur
!                 Also -lnetcdf flag is needed during the loading step
!                 if NetCDF is being used. Otherwise  "empty" NetCDF rou
!                 should be substittuted to satisfy loader (c.f. dummyne
!                 "ncclose" is executed from DDSCAT.f instead of writesc
!                 NetCDF is available from http://www.unidata.ucar.edu/
!                 for most popular computers.
!                 Added "writebin.f" and "writecdf.f" for 5a7
! 96.11.21 (BTD): moved NCCLOS to WRITENET so that all dependence on
!                 netCDF is through subroutine WRITENET
!                 This required changes to DDSCAT,WRITESCA, and
!                 WRITENET, and adding additional call to WRITESCA
!                 from DDSCAT, and additional call to WRITENET from
!                 WRITESCA
!                 added variable IDVOUT2 to COMMON/NORMERR to permit
!                 device number for standard output to be passed to
!                 subroutine PROGRESS
! 96.12.02 (BTD): Corrected error in DDSCAT.f : SMORI was not
!                 initialized, and hence was incorrect except (possibly)
!                 for first wavelength and radius.
!                 Also eliminated some superfluous variables from
!                 DDSCAT.f
! 97.04.28 (BTD): Corrected bug in TARHEX: NAT was not initialized to 0
! 97.06.04 (BTD): Corrected bug in TARGET, affecting only target option
!                 "UNICYL" (target composition was not being set
!                 correctly).
! 97.07.24 (BTD): Corrected bug in GETMUELLER: was using PHI rather
!                 than PHIN in computation of amplitude scattering
!                 matrix and Mueller matrix from f_ml computed by
!                 GETFML.  Required change in GETMUELLER argument,
!                 list, with corresponding change required in DDSCAT.f
!                 Also corrected bugs in GETMUELLER pertaining to
!                 computation of Mueller matrix elements S_14 and
!                 S_31.  Note that because S_31 was incorrect, PPOL
!                 (evaluated in WRITESCA) was numerically incorrect.

! --------------- begin creation of version 6.0 -----------------------
!                 continuing to support "public" version 5a7 while
!                 carrying on private development of version 6.0
! ---------------------------------------------------------------------
! 98.01.01 (BTD): Version 6.0, with capability of using noncubic
!                 rectangular lattices.  Extensive changes required,
!                 because polarizability tensor will now be nondiagonal
!                 even when dielectric tensor is isotropic.
!                 Changes include following modules:
!                    DDSCAT
!                    ALPHA
!                    CMATVEC (in cprod.f)
!                    CPROD
!                    ESELF
!                    EVALA
!                    EVALE
!                    EVALQ
!                    GETFML
!                    MATVEC (in cprod.f)
!                    PRINAXIS
!                    REASHP
!                    SCAT
!                    TARELL
!                    TARGET
!                    TARBLOCKS
!                    TARCEL
!                    TARCYL
!                    TARHEX
!                    TARREC
!                    TARTET
!                    TAR2EL
!                    TAR3EL
!                    TAR2SP
!                 and additional module
!                    NONCUBIC (called by subroutine ALPHA)
! 98.01.20 (BTD): Modified subroutine ALPHA to use (and print out)
!                 constant C4 in evaluation of first-order corrections
!                 to alpha.
! 98.03.10 (BTD): Changes to:
!                    ERRMSG
!                    REAPAR
!                    TAR2EL
!                    TAR2SP
!                    TAR3EL
!                    TARBLOCKS
!                    TARCEL
!                    TARELL
!                    TARHEX
!                    TARTET
! 98.04.27 (BTD): Minor changes made in
!                    ALPHA
!                    CGCOMMON
!                    EVALQ
!                    GETFML
!                    NONCUBIC
!                    PRINAXIS
!                    RESTORE
!                    TARCYL
!                    TARGET
! 98.10.07 (BTD) Rewrote cgcommon.f, function SCNRM2,
!                because g77 optimization generates bad code
!                complicated code replaced with simple code
! -------------- [separate creation of version 5a9 at this time] ----
! 98.10.08 (BTD) modified cgcommon.f, subroutine PROGRESS,
!                to keep track of minimum error, and to
!                note when new error minimum is attained.  This is
!                to observe convergence behavior of PBCGST.
! 98.10.26 (BTD) modified subroutine PROGRESS in cgcommon.f
!                to also print information on
!                rate of convergence (variable RATE).
! 98.10.27 (BTD) modified subroutine SMACHCONS in cgcommon.f
!                because Solaris compiler complained about value of
!                OVERFLOW parameter.  Reduced by factor 2
! 98.11.16 (BTD) Corrected error in value of CXE01R passed to WRITEBIN
!                for binary write option.
! 98.12.07 (BTD) Found and corrected bug reported by Timo Nousiainen
!                (tpnousia@lumi.meteo.helsinki.fi) which caused Mueller
!                matrix elements S_12 and S_13 to be computed
!                due to inconsistency in definition of f_ml.  Removed
!                code in GETFML which had been inserted to change
!                f_ml to refer to "usual" incident pol states l=1,2
!                whereas GETFML assumed that incident pol states
!                l=1,2 were those specified by the user in ddscat.par
!                Stick with this latter convention.
!                Modified GETMUELLER so that Mueller matrix elements
!                are computed correctly even when user-specified
!                incident polarization state CXE01 is not linearly
!                polarized.
! 98.12.07 (BTD) Edited UserGuide to give more detailed (and now correct
!                discussion of computation of Mueller matrix elements
!                from the f_ml.
! 98.12.07 (BTD) Inserted (commented out) code into getfml to allow
!                verification of final error in approximate solution
!                to confirm reliability of error reported by iteration
!                machinery.  After confirming that these errors appear
!                to be reasonable, code was commented out, but can be
!                reactivated at future date if repetition of such tests
!                is desired.
! 98.12.16 (BTD) In getfml.f, increase upper limit on iterations from
!                300 to 10000
! 99.01.26 (BTD) Modified DDSCAT.f and reapar.f to allow user to specify
!                first IWAV,IRAD,IORI (normally 0 0 0).  This allows
!                one to restart calculational runs which abort after
!                doing only some of the desired wavelengths, radii,
!                and orientations.  Note: structure of ddscat.par is
!                changed as a result!
! 99.03.01 (BTD) rewrote subroutine orient.f to make it handle odd
!                NTHETA as described in the UserGuide
! 99.03.05 (BTD) corrected errors in new orient.f
! 99.04.30 (BTD) corrected new errors in orient.f (introduced in
!                99.03.05 revision)
! 99.06.30 (BTD) modifications to reapar (was not reading correct
!                number of SHPAR values for case TWOSPH) and tar2sp
!                in order to deal correctly with two spheroid case.
!                (Although have not yet implemented changes necessary
!                to do TWOSPH with noncubic lattice.)
!-----------------------------------------------------------------------
! 00.06.12 (BTD) [Separate release of version 5a10 at this time]
!-----------------------------------------------------------------------
! 00.06.12 (BTD) New target option NSPHER supported by routine TARNSP
!                Replaced old LAPACK source code with latest version
!                of routines from www.netlib.org
!                New LAPACK routines required by PRINAXIS are now
!                collected in two files, lapackblas.f and lapacksubs.f
!                with new LAPACK routines, PRINAXIS now executes properl
!                when compiled with g77
!                To support TARNSP, it was necessary to modify argument
!                lists for REAPAR and TARGET to include character
!                variable CFLSHP to pass name of file containing
!                description of multisphere target
!                Minor "tidying" of a number of files to make
!                all data type conversion explicit.
!                All variables in CXFFT3 now declared explicitly.
! 01.04.21 (BTD) copied over changes made to REASHP in version 5a10
!                modified all target routines so that in all cases
!                the target.out file created when using CALLTARGET
!                will contain composition information, so that there
!                is now a standard format for shape.dat input files
!                Modified as-delivered REASHP to read ICOMP.
! 01.04.21 (BTD) copied over changes made to TARNSP to correct bug
!                in version 5a10
! 02.02.12 (BTD) added support for target option PRISM3, with
!                new routine TARPRSM and concomitant changes to
!                TARGET and REAPAR
! 02.11.15 (BTD) working with Matthew Collinge to add MPI capability to
!                code.
!                DDSCAT.f now calls
!                       MPI_INIT
!                       MPI_COMM_RANK
!                       MPI_COMM_SIZE
!                       MPI_FINALIZE
!                created new module mpi_subs.f with following routines:
!                    SUBROUTINE COLSUM, which calls MPI_REDUCE
!                    SUBROUTINE SHARE1, which calls MPI_BCAST
!                    SUBROUTINE SHARE2, which calls MPI_BCAST
!                for use on systems where MPI is not installed,
!                created new module mpi_fake.f with dummy routines
!                    SUBROUTINE MPI_INIT
!                    SUBROUTINE MPI_COMM_RANK
!                    SUBROUTINE MPI_COMM_SIZE
!                    SUBROUTINE MPI_BCAST
!                    SUBROUTINE MPI_REDUCE
!                    SUBROUTINE MPI_FINALIZE
!                so that calls to these subroutines can remain in
!                the code.
! 03.02.13 (BTD) added 1 more digit of precision to qtable and qtable2
!                outputs
! 03.04.13 (BTD) working with Matthew Collinge to add MPI capability to
!                added character variable CFFLOG to contain name of
!                running output file
!                added routine NAMID to generate a unique name for outpu
!                file printed by each MPI-spawned process.
!                output to logfile is no longer unbuffered (if required
!                for debugging purposes, this can be reactivated -- see
!                comments in DDSCAT.f
!                added variables ITNUM(2) and MXITER to argument lists
!                for GETFLM and WRITESCA
! 03.07.13 (BTD) added new variable ITNUMMX(2) to DDSCAT so that
!                waarbbori.avg file will contain *maximum* number of
!                iterations required by any of the orientations being
!                averaged over
! 03.08.01 (BTD) version 6.0 released
! 03.10.24 (BTD) Modifications for version 6.1:
!                Changed method used for choosing scattering
!                directions for calculation of radiation force and
!                torque.
!                * Eliminate use of ICTHM and IPHIM -- these are
!                  removed from many argument lists, and are no longer
!                  read from file ddscat.par
!                * Add variable ETASCA to control angular resolution
!                  used for angular averaging.  ETASCA is now input
!                  from file ddscat.par, and passed to subroutines
!                  GETFML, SCAT, and WRITESCA
!                * Add variable NAVG to record number of scattering
!                  directions used.  Pass NAVG from SCAT to GETFML to
!                  DDSCAT to WRITESCA to WRITENET and WRITEBIN
!                * Add code to calculate <cos^2> in SCAT, and pass
!                  variable CSCAG2(2) from SCAT to DDSCAT to WRITESCA
!                * Modify output format of qtable, wxxrxxkxxx.sca,
!                  and wxxrxxori.avg to report NAVG
! 03.10.30 (BTD) corrected typo in WRITENET
! 04.02 22 (BTD):Modifications to writenet:
!                 * add QEXSUM,QABSUM,QSCSUM,QBKSUM,QPHSUM,QSCGSUM,
!                       QTRQABSUM,QTRQSCSUM
!                   to argument list
!                 * add various quantities (e.g. Qext) averaged over
!                   polarization to netcdf output when IORI>0
!                 * add various quantities (e.g. Qext) averaged over
!                   orientation (and polarization)
!                   to netcdf output when IORI=0
!                 * reorganize netCDF output following experimental
!                   version ver6.01
! 04.02.22 (BTD) added IWRKSC to argument list of WRITESCA and use to
!                control writing to ascii output files
! 04.02.25 (BTD) corrected typo in TARPRSM
! 04.03.31 (BTD) modified LAPACK routine SLAMC1 so that it behaves
!                as intended even after optimization by pgf77.  Note
!                that fix presumes that arithmetic is base 2.
! 04.04.01 (BTD) * added calls to TARGSPHER in subroutine TARGET
!                * added DX to argument list of TARGSPHER
!                * added arguments NPY,NPZ to support periodic b.c.
!                  option (at present time, used only for target option
!                  NSPPBC)
!                * added code to REAPAR to support option NSPPBC
! 04.04.04 (BTD) * added NPY,NPZ to argument list of TARGET
!                   and in call to TARGET from DDSCAT
!                * added variables to argument list of fake version of
!                  WRITENET in dummywritenet.f
!                * reorganize file mpi_subs.f so that mpi_subs includes
!                   SUBROUTINE COLSUM
!                   SUBROUTINE SHARE1
!                   SUBROUTINE SHARE2
!                  and mpi_fake.f includes dummy versions of
!                   SUBROUTINE COLSUM
!                   SUBROUTINE SHARE1
!                   SUBROUTINE SHARE2
!                   SUBROUTINE MPI_INIT
!                   SUBROUTINE MPI_COMM_RANK
!                   SUBROUTINE MPI_COMM_SIZE
!                   SUBROUTINE MPI_FINALIZE
!                  Subroutine mpi_subs is no longer used in "plain"
!                  version -- all the ersatz MPI calls used by DDSCAT
!                  are supplied in mpi_fake.f
! 04.04.29 (BTD) Added target option ANIREC (homogeneous anisotropic
!                rectangular target
!                To accomplish this, modified subroutines
!                  REAPAR
!                  TARGET
!                and added new routine
!                  TARANIREC
! 04.05.21 (BTD) Fixed bug in DDSCAT.f: one of the calls to WRITESCA
!                had QSCGSUM and QSCG2SUM in incorrect order.
! 04.05.22 (BTD) Fixed bug in computation of true error in getfml.f
! 04.05.23 (BTD) Added CWHERE string in reapar.f to provide helpful
!                information to user in event of malformed ddscat.par
!                file

! Begin DDSCAT 6.2:
! 04.09.14 (BTD) Added THETADF,PHIDF,BETADF to argument list of
!                subroutine TARGET
!                define new local variable R(3,3),RI(3,3),
!                COSBE,COSPH,COSTH,SINBE,SINPH,SINTH,...
!                add code to recalculate CXALPH(1-3) and CXALOF(1-3)
!                if there is nonzero rotation of dielectric frame
!                at local lattice site, AND dielectric tensor is
!                anisotropic.
! 04.09.14 (BTD) Added CSHAPE,BETADF,PHIDF,THETADF to argument list
!                of subroutine REASHP
!                Add support for CSHAPE='ANIFIL' to read dipole
!                locations, composition, and orientation angles
!                BETADF, PHIDF, THETADF for Dielectric Frame relative
!                to Target Frame at each occupied site.
!                Add new shape option CSHAPE=NANSPH to generate
!                target from list of spheres with 3 composition
!                indices plus 3 angles giving orientation of Dielectric
!                Frame relative to Target Frame
! 04.10.13 (BTD) Modified REAPAR to support new shape option NANSPH
!                Modified DIELEC to check that user does not specify
!                refractive index = 1
! 04.10.14 (BTD) Modified REAPAR to support reading wavelengths from
!                file "wave.tab".
! 04.12.29 (BTD) Corrected error in WRITESCA: when IWRKSC=1, had not
!                been writing out correct values of Mueller matrix to
!                wxxrxxkxxx.sca files. (Output error only: wrong
!                variable in WRITE statement. No computational error
!                involved.)
! 05.03.19 (BTD) REAPAR modified:
!                Added 2 lines to set CLFEPS(1) in case using options
!                H2OLIQ or H2OICE (previously were left undefined,
!                which cause problems with output statement)
! 05.03.29 (BTD) ROTATE modified:
!                Added code to guard against roundoff errors leading to
!                argument of ACOS with abs(arg)>1
! 05.07.08 (BTD) Corrected error in routine eself related to option
!                NSPPBC
! 05.08.03 (BTD) Added code to REAPAR and TARGET to support option
!                RCTPBC = rectangular brick with periodic b.c.
! 05.08.04 (BTD) Corrected error in ESELF
! 05.08.04 (BTD) Modified modules
!                   DDSCAT.f
!                   reapar.f
!                   mpisubs.f
!                   mpi_fake.f
!                Added new character variable CMDFRM to be read by
!                subroutine REAPAR from input file ddscat.par.
!                CMDFRM=LFRAME : angles THETAN,PHIN are relative to
!                                Lab Frame (xlab,ylab,zlab)
!                CMDFRM=TFRAME : angles THETAN,PHIN are relative to
!                                Target Frame (a1,a2,a3)
!                Modified DDSCAT.f to define ENSC,EM1,EM2 accordingly
! 05.09.26 (BTD) Corrected bug in DDSCAT regarding calculation of
!                scattering intensities for option CMDFRM = TFRAME
! 05.10.11 (BTD) Modified to support up to 1000 wavelengths:
!                changed MXWAV from 100 to 1000 in DDSCAT
!                changes to DDSCAT,NAMER,WRITESCA:
!                changed CFLAVG*13 to CFLAVG*14
!                changed CFLSCA*14 to CFLSCA*15
!                also other changes to NAMER
! 05.10.11 (BTD) Added CMDFRM to argument list of WRITESCA
! 05.10.18 (BTD) Modified DDSCAT.f to allow use of more than 1000
!                orientations if IWRKSC=0 (previously would exceed array
!                limits in subroutine NAMER with IORI>1000).
!                Modified REAPAR to ensure that user does not request
!                more than 1000 orientations with IWRKSC=1
! 06.04.10 (BTD) * Modified REAPAR to read IWRPOL from ddscat.par
!                  and pass to DDSCAT
!                * Created routine WRITEPOL to write out complex
!                  polarization array as well as additional information
!                  defining target geometry and incident wave
!                * Modified DDSCAT to use IWRPOL and (if IWRPOL=1) to
!                  call subroutine WRITEPOL to write out unformatted
!                  file of reduced polarization array as well as
!                  additional information defining target geometry and
!                  incident wave
!                * Modified NAMER to generate unique names
!                  waaarbbkccc.pol1 and waaarbbkccc.pol2 for
!                  polarization arrays.  Rewrote NAMER to remove
!                  EQUIVALENCE statements and use another method to
!                  construct strings.
! 06.09.13 (BTD) Modified REAPAR and TARGET to handle new target option
!                CYLCAP
!                Added new routine TARCYLCAP to generate homogeneous
!                cylinder with hemispherical caps.
! 06.09.15 (BTD) * Modified TARHEX to allow hex prism orientation in TF
!                  to be selected.
!                  TARHEX now able to produce hexagonal prism in 6
!                  different orientations in TF.
!                * Modified TARGET and REAPAR to support this change.
! 06.09.15 (BTD) Modified TARGET and REAPAR to support new
!                target option HEXPBC (uses routine TARHEX).
! 06.09.15 (BTD) * Modified TARCYL to allow cylinder orientation in TF
!                  to be selected
!                * Modified TARGET and REAPAR to support this change.
! 06.09.21 (BTD) Modified DDSCAT and WRITEPOL to add PYD,PZD,DX to
!                quantities written by WRITEPOL
! 06.09.28 (BTD) *** version 6.2.3 ***
!                Modified
!                * ESELF to do direct calculation of A matrix elements
!                  including contribution form replica dipoles using
!                  new routine DIRECT_CALC
!                  (cannot employ symmetry tricks
!                  because they don't apply when kx or kz .ne.0)
! 06.09.29 (BTD) Modified
!                * ESELF to change way calculation is done when IPBC=1
!                  - calculate and store full Fourier transform of A
!                    matrix in CXZC
!                  - added variable IPBC to argument list to increase
!                    dimensioning of CXZC when PBC is used.
!                  - store full CXZC when IPBC=1
!                * DDSCAT to change dimensioning of IPBC when new
!                  parameter MXPBC=1
!                * GETFML
! 06.10.05 (BTD) Modified
!                * REAPAR to improve handling of input for PBC targets,
!                  specifically selection of scattering directions
!                * PBCSCAVEC = new routine added to calculate
!                  scattering directions for PBC targets
! 06.10.05 (BTD) fixed minor bugs in WRITENET
! 06.10.07 (BTD) Extend to handle computation of S matrix for 1-d
!                and 2-d periodic targets.
!                Modified:
!                * DDSCAT
!                * GETMUELLER
!                * PBCSCAVEC
!                * WRITESCA (added variables to arg list, but no
!                  change in operation)
! 06.10.23 (BTD) Set a1=(1,0,0),a2=(0,1,0) for target options
!                RCTPBC,CYLPBC,HEXPBC
! 06.11.28 (BTD) Modified WRITESCA to correct error in calculation of
!                degree of linear polarization of scattered light
! 06.11.29 (BTD) Modified REAPAR:
!                added code to catch error in input CMDFRM
! 06.12.24 (BTD) Modified DDSCAT
!                Added ORDERM,ORDERN to argument list of GETMUELLER
!                Modified GETMUELLER
!                * Added ORDERM,ORDERN to argument list.
!                * When JPBC=3,(target periodic in two dimensions) use
!                  ORDERM,ORDERN to identify (0,0) forward scattering
!                  direction for special-case calculation of Mueller
!                  matrix
!                Modified EXTEND
!                * Added 1 as first element of NF235, so that we can
!                  treat 1d targets that are 1 layer thick, or
!                  plane-parallel 2d target using single dipole line.
! 06.12.28 (BTD) Modified DDSCAT
!                * Added arrays A3,XLR,YLR,ZLR
!                * Added XLR,YLR,ZLR to argument list of PBCSCAVEC
!                Modified PBCSCAVEC
!                * corrected error in calculation of unit vector for
!                  scattered wave in special case
!                * added XLR,YLR,ZLR to argument list
!                  use XLR,YLR,ZLR in defining unit pol vectors in speci
!                  case of scattering angle theta = 0 or pi (in which
!                  case scattering plane is not uniquely defined).
! 07.01.18 (BTD) Modified DDSCAT,SHARE1
!                * added A3(3),IWRPOL,IPBC,JPBC,MXNX,MXNY,MXNZ,MXPBC,
!                  ORDERM(MXSCA),ORDERN(MXSCA),
!                  PYD,PYDDX,PZD,PZDDX to argument list of SHARE1
!                * added appropriate MPI_BCAST... calls in SHARE1
! 07.01.19 (BTD) * Corrected bug in PBCSCAVEC
! 07.01.20 (BTD) Modified REAPAR,TARGET
!                * added support for target option SLBPBX
! 07.02.23 (BTD) Modified REAPAR,TARGET
!                * added support for target option SLBPBC
!                Create new routine TARSLBPBC for 4-layer slab of
!                infinite extent in target y and z directions
!                (using periodic boundary conditions)
! 07.06.21 (BTD) *** Version 7.0.2.  
!                Modified to handle vector X0(3) definin
!                physical location in TF of lattice site (0,0,0).
!                This facilitates subsequent use of DDfield for
!                near-field calculations (simplifies specification of
!                locations).
!                Also modified to change way azimuthal scattering angle
!                is defined for targets with 1-d periodicity.
!                Modified:
!                * TARPBX
!                * TARCYL
!                * TARGET
!                * EXTEND
!                * GETFML
!                * SCAT
!                * EVALE
!                * WRITEPOL
!                * READPOL
!                * MPI_FAKE
!                * MPI_SUBS
!                * PBCSCAVEC
!                * DDSCAT
!                * DDfield
! 07.06.22 (BTD) * SCAT: corrected error in computation of PPOL (returne
!                  to formula used prior to 06.11.28)
!                * GETMUELLER: corrected multiplicative error
!                  in calculation of Mueller matrix elements for
!                  targets with 1-d periodicity
!                * PBCSCAVEC: changed definition of azimuthal angle
!                  zeta for scattered directions -- changed so that
!                  forward scattering has zeta=0
! 07.06.30 (BTD) DDSCAT, DIAGL (in cprod.f), MATVEC (in cprod.f),
!                CMATVEC (in cprod.f):
!                * moved CMDFFT from COMMON/M6/... CMDFFT
!                  to COMMON/M8/CMDFFT
!                * moved PYD,PZD to beginning of COMMON/M6/
!                ALPHA:
!                * eliminated COMMON/M6/
!                * added COMMON/M8/CMDFFT
! 07.07.03 (BTD) modified
!                * DDSCAT
!                * GETMUELLER
!                * PBCSCAVEC
! 07.07.08 (BTD) modified
!                * DDSCAT: added EM1,EM2 to argument list for PBCSCAVEC
!                  and GETMUELLER
!                * PBCSCAVEC: added EM1,EM2 to argument list
!                  added code to compute EM1,EM2 when JPBC > 0
!                * GETMUELLER: added EM1, EM2 to argument list
!                  use EM1,EM2 to compute S matrix in case of forward
!                  scattering
! 07.08.03 (PJF+BTD) **** Version 7.0.3
!                * PJF converted bulk of code from f77 to f90 using
!                  NAGware
!                * DDPRECISION: module to specify whether DDSCAT uses
!                  single or double precision storage and arithmetic
!                  DDPRECISION module is used by PROGRAM DDSCAT and
!                  all subroutines.
!                * TIMEIT: now uses f95 intrinsic function CPU_TIME
!                * PRINAXIS: modified to use DSYEVJ3 to find 
!                  eigenvalues and eigenvectors of moment of inertia
!                  tensor
!                * LAPACK subroutines have been removed from the code
! 07.08.04 (BTD) * DDSCAT
!                  * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                  * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                    add dynamic allocation of CXADIA
!                  * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                    add dynamic allocation of CXZC
!                  * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                    add dynamic allocation of CXZW
!                  * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                    add dynamic allocation of IOCC
!                  * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                  * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                    add dynamic allocation of CXAOFF
!                  * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
!                * ALPHA (in alpha.f90)
!                  * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
!                * DIAGL (in cprod.f90)
!                  * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                  * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                  * removed COMMON/M8/ (was not used)
!                * CMATVEC (in cprod.f90)
!                  * renamed AK(3)->AKR(3) for consistency with
!                    COMMON/M1/ in DDSCAT
!                  * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                  * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                  * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                  * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                  * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                  * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                  * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                  * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
!                * MATVEC (in cprod.f90)
!                  * renamed AK(3)->AKR(3) for consistency with COMMON/M1/
!                  * in DDSCAT
!                  * replaced COMMON/M1/ with USE MODULE DDCOMMON_1
!                  * replaced COMMON/M2/ with USE MODULE DDCOMMON_2
!                  * replaced COMMON/M3/ with USE MODULE DDCOMMON_3
!                  * replaced COMMON/M4/ with USE MODULE DDCOMMON_4
!                  * replaced COMMON/M5/ with USE MODULE DDCOMMON_5
!                  * replaced COMMON/M6/ with USE MODULE DDCOMMON_6
!                  * replaced COMMON/M7/ with USE MODULE DDCOMMON_7
!                  * replaced COMMON/M8/ with USE MODULE DDCOMMON_8
!                * PROGRESS (in cgcommon.f90)
!                  * replaced COMMON/NORMERR/ with USE MODULE DDCOMMON_9
!                * GETFML (in getfml.f90)
!                  * replaced COMMON/NORMERR/ with USE MODULE DDCOMMON_9
! 07.08.05 (BTD) * DDSCAT
!                  * extensive modification to use dynamic memory allocation
!                  * add MXNX,MXNY,MXNZ to CALL REAPAR argument list in
!                    use this MXNX,MXNY,MXNZ on first call to TARGET
!                    after actual size of extended target is set by EXTEND,
!                    then reallocate minimum memory required for problem
!                * REAPAR (in reapar.f90)
!                  * modified to read MXNX,MXNY,MXNZ from ddscat.par
!                  * add MXNX,MXNY,MXNZ to argument list
!                * DMACHCONS (in cgcommon.f90)
!                  * modified setting of MACHEPS,UNDERFLOW, and OVERFLOW
!                    based on whether single- or double-precision
!                    version is used 
!                    Question: do changes slow execution??
! 07.10.27 (BTD) * REAPAR
!                  * allow new target options PB2PBC, SLBLIN, SLNPBC
!                * TARGET
!                  * support new target options PB2PBC, SLBBOX, SLNPBC
! 08.01.12 (BTD) * DDSCAT
!                  * add PYDDX,PZDDX to argument list of WRITESCA
! 08.01.13 (BTD) * DDSCAT
!                  * introduce variable NRWORD = length (bytes) of real word
!                  * add to argument list of WRITEPOL, so that this can
!                    be stored in file written by WRITEPOL for sanity check
!                * WRITEPOL
!                  * provide option for more efficient storage when
!                    BETADF,THETADF,PHIDF are trivial because target
!                    material is either (1) isotropic or (2) has
!                    optical axes aligned with x_TF,y_TF,z_TF
! 08.01.17 (BTD) * DDSCAT
!                  * add new variable IANISO to record whether target
!                    is isotropic (IANISO=0), anisotropic but with
!                    principal axes everywhere aligned with x_TF,y_TF,z_TF
!                    (IANISO=1) or generally anisotropic (IANISO=2)
!                * TARGET
!                  * modify TARGET to set value of IANISO
!                * WRITEPOL
!                  * modifications to use IANISO to determine whether
!                    anisotropy info in BETADF,THETADF,PHIDF needs to
!                    be written out to file
! 08.01.21 (BTD) * DDSCAT
!                  * add IANISO to argument list of SHARE1
! 08.02.01 (BTD) * DDSCAT
!                  * changed SHPAR(10) to SHPAR(12)
!                * REAPAR
!                  * changed SHPAR(10) to SHPAR(12)
!                  * added support for target options 
!                    BISLINPBC
!                    RCTGLBLK3
!                    TRILYRPBC
!                * TARGET
!                  * changed SHPAR(10) to SHPAR(12)
!                    BISLINPBC
!                    RCTGLBLK3
!                    TRILYRLKPBC
!                * added new routine TARRCTBLK3 to support
!                  target shapes BISLINPBC, RCTGLBLK3, TRILYRLKPBC
! 08.02.09 (BTD) Cosmetic changes (affecting appearance of running output)
!                in following routines:
!                * DDSCAT
!                * REAPAR
!                * DSYEVJ3
! 08.02.13 (BTD) * Added MXNAT0 to argument list of SHARE1
!                * A number of changes in SHARE1 to correct dimensioning
!                  of IOCC,IXYZ0,BETADF,THETADF,PHIDF from MXNAT to MXNAT0
!                * Added CALL_MPI_BCAST_INT calls for 
!                  * MXBETA
!                  * MXNAT
!                  * MXNAT0
!                  * MXPHI
!                  * MXSCA
!                  * MXTHET
!                  * MXWAV
! 08.02.17 (BTD) * DDSCAT: allocation of all arrays needed
!                  by parallel processes now allocated by each process
!                  rather than just master process
!                * DDSCAT: call new routine SHARE0 to distribute information
!                  needed for memory allocation
!                * DDSCAT: added CLOSE(11) to close mtable
!                * Created new routine SHARE0
!                  in mpi_subs.f90 and mpi_fake.f90
!                * Added DAEFF to argument list of SHARE1
!                DDSCAT 7.0.4 now appears to run properly under MPI !
! 08.03.11 (BTD) * reapar.f90: corrected typo BLSLINPBC -> BISLINPBC
! 08.04.19 (BTD) change in notation: ALPHA -> GAMMA
!                This affects routines
!                * DDSCAT
!                * REAPAR (changed order in argument list)
!                * GETFML (changed order in argument list)
!                * SHARE1 in mpi_subs.f (changed order in argument list)
!                * SHARE1 in mpi_fake.f (changed order in argument list)
!                * DIAGL (DDCOMMON_6)
!                * MATVEC (DDCOMMON_6)
!                * CMATVEC (DDCOMMON_6)
!                * CPROD (DDCOMMON_6) and call to ESELF
!                * ESELF
!                * DDCOMMON_6 (changed ALPHA -> GAMMA)
!                and program
!                * DDfield
! 08.05.12 (BTD) ver7.0.6:
!                * DDSCAT : added code mods suggested by Art Lazanoff
!                  - initialize IXYZ0 to 0            [WHY?]
!                    with !$omp parallel do / !$omp end parallel do
!                  - initialize CXZC to (0._WP,0._WP) [WHY?]
!                    with !$omp parallel do / !$omp end parallel do
!                  - initialize CXZW to (0._WP,0._WP) [WHY?]
!                    with !$omp parallel do / !$omp end parallel do
!                  - initialize CXSCR1 to (0._WP,0._WP)
!                    with !$omp parallel do / !$omp end parallel do
!                  - iniitialize SCRRS1 to 0._WP
!                    with !$omp parallel do / !$omp end parallel do
!                * CPROD  : added calls to TIMEIT to time call to ESELF
!                * dummy.f90 : add this module to hold dummy routines
!                  - DUMMY
!                  - CDUMMY
!                  - CDUMMY_1
!                * ESELF  : added code mods suggested by Art Lazanoff
!                           to support OpenMP if compiled with preprocessor
!                           flag -fpp -Deself_omp
!                * GETFML : changed declaration of DUMMY from REAL to EXTERNAL
!                * PETR   : (in ccgpack.f90)
!                  - change CDUMMY -> CDUMMY(1)
!                  - declare DUMMY,CDUMMY_1 as EXTERNAL
!                * pim.f90 package :added code mods suggested by Art Lazanoff
!                  changed PARAMETER(SPARSIZ=2) -> PARAMETER(SPARSIZ=6) in
!                  - PIMCBICG
!                  - PIMCBICGSTAB
!                  - PIMCCG
!                  - PIMCCGNE
!                  - PIMCCGNR
!                  - PIMCCHEBYSHEV
!                  - PIMCQMR
!                  - PIMCRBICGSTAB
!                  - PIMCRGCR
!                * SCAT   : added code mods suggested by Art Lazanoff
!                           to support OpenMP if compiled with preprocessor
!                           flag -fpp -Dscat_omp
!                * TARGSPHER:
!                  - added X0 to argument list
!                  - added code to calculate X0
!                * WRITESCA: following suggestion from Lazanoff, initialize
!                  DAEFF=0._WP and DPHYS=0._WP [WHY?]
!                * ZBCG2
!                  - changed WORK(1:N,J) in arguments to WORK(1,J) [10 places]
! 08.05.21 (BTD) * WRITEPOL : change dimensioning 
!                  CXPOL(MXNAT,3) -> CXPOL(NAT0,3)
! 08.05.30 (BTD) * DDSCAT : changed declarations                 
!                  SM(MXSCA,4,4)      -> SM(4,4,MXSCA)
!                  SMORI(MXSCA,4,4)   -> SMORI(4,4,MXSCA)
!                  SMORI_1(MXSCA,4,4) -> SMORI_1(4,4,MXSCA)
!                * GETMUELLER : changed declarations
!                  SM(MXSCA,4,4)    -> SM(4,4,MXSCA)
!                  SMORI(MXSCA,4,4) -> SMORI(4,4,MXSCA)
!                  and corresponding reordering of indices in lines
!                  where SM and SMORI are evaluated
!                * COLSUM in mpi_fake.f90: changed declarations
!                  SMORI(MXSCA,4,4)   -> SMORI(4,4,MXSCA)
!                  SMORI_1(MXSCA,4,4) -> SMORI_1(4,4,MXSCA)
!                  added code to use 
!                     QSCSUM_1 to update QSCSUM
!                     QABSUM_1 to update QABSUM
!                     QEXSUM_1 to update QEXSUM
!                     QBKSUM_1 to update QBKSUM
!                     QPHSUM_1 to update QPHSUM
!                     QSCG2SUM_1 to update QSCG2SUM
!                     QSCGSUM_1 to update QSCGSUM
!                     QTRQABSUM_1 to update QTRQABSUM
!                     QTRQSCSUM_1 to update QTRQSCSUM
!                     CX1121_1 to update CX1121
!                     S1111_1 to update S1111
!                     S2121_1 to update S2121
!                     SMORI_1 to update SMORI
!                * COLSUM in mpi_subs.f90: changed declarations
!                  SMORI(MXSCA,4,4)   -> SMORI(4,4,MXSCA)
!                  SMORI_1(MXSCA,4,4) -> SMORI_1(4,4,MXSCA)
!                * WRITESCA: changed declarations
!                  SM(MXSCA,4,4)    -> SM(4,4,MXSCA)
!                  SMORI(MXSCA,4,4) -> SMORI(4,4,MXSCA)
!                  and corresponding changes in code
! 08.06.07 (BTD) * CXFFT3MKL routine added (written by Art Lazanoff)
!                * REAPAR : added support for option FFTMKL
!                * ESELF : added calls to CXFFT3_MKL 
! 08.06.23 (BTD) * TARCYLCAP : fixed bug 
! 08.07.22 (BTD) * DDSCAT: added XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN to argument list
!                  of SHARE1
!                * SHARE1: added XMAX,XMIN,YMAX,YMIN,ZMAX,ZMIN to argument list
!                  of SHARE1
!                * REAPAR: added sanity check to catch users who select
!                  target option SPHERES_N but also specify multiple materials
! 08.07.23 (BTD) * DDSCAT: removed some MPI_BARRIER calls,
!                  added others just before SHARE1 and SHARE2
! 08.07.27 (BTD) * DDSCAT: 
!                  * eliminated variable CXALDS
!                    (removed from argument list of GETFML)
!                  * changed final allocation of BETADF,PHIDF,THETADF
!                    from NAT0 -> MXNAT
!                * ALPHADIAG: 
!                  * changed dimensioning of BETADF,PHIDF,THETADF
!                    from (NAT0) to (MXNAT)
!                  * eliminated variable CXALDS from argument list
!                * GETFML: 
!                  * changed dimensioning of BETADF,PHIDF,THETADF
!                    from (NAT0) to (MXNAT)
!                  * eliminated variable CXALDS from argument list
!                  * eliminated CXALDS from arg list of ALPHADIAG
! 08.08.07 (BTD) v7.0.7
!                * DDSCAT
!                  * changed #ifdef debug -> #ifdef openmp
!                  * add #ifdef mpi , #ifndef mpi to switch between 
!                    INCLUDE 'mpif.h' 
!                    and
!                    INTEGER :: MPI_COMM_WORLD
!                * eself
!                  * changed #ifdef debug -> #ifdef openmp
!                * scat
!                  * changed #ifdef debug -> #ifdef openmp                
! 08.08.08 (BTD) * REASHP corrected 
!                  FRMFIL -> FROM_FILE
!                  ANIFIL -> ANIFRMFIL
!                * TARGET: added X0 to argument lists of
!                  * TARBLOCKS
!                  * TAR2SP
!                  * TARHEX
!                  * TARNAS
!                  * TARNSP
!                * TARBLOCKS: added X0 to arg list, and code to set X0
!                * TAR2SP: added X0 to arg list, and code to set X0
!                * TARHEX: added X0 to arg list, and code to set X0
!                * TARNAS: added X0 to arg list, and code to set X0
!                * TARNSP: added X0 to arg list, and code to set X0
! 08.08.31 (BTD) * DDSCAT: eliminate netCDF-related code
!                          removed CNETFLAG, CNETFILE 
!                * REAPAR: removed CNETFLAG
!                * SHARE1: removed CNETFLAG
!                * WRITESCA: removed CNETFLAG, CNETFILE
!                * TARGET: made corrections
!                edited various routines to standardize target.out format:
!                * REASHP
!                * TAR2EL
!                * TAR2SP
!                * TAR3EL
!                * TARANIREC
!                * TARBLOCKS
!                * TARCEL
!                * TARCYL
!                * TARCYLCAP
!                * TARELL
!                * TARGSPHER
!                * TARHEX
!                * TARLYRSLAB
!                * TARNAS
!                * TARNSP
!                * TARPBXN
!                * TARPRSM
!                * TARRCTBLK3
!                * TARREC
!                * TARRECREC
!                * TARSLBLIN
!                * TARTET
! 08.09.12 (BTD) Corrected typo DSKRCTGNL -> DSKRCTNGL in
!                * REAPAR
!                * TARGET
!                * CALLTARGET
!                Removed extra dummy read statement from REASHP
! 08.09.15 (BTD) Corrected typo SPHERN_PBC -> SPHRN_PBC which
!                caused SPHERN_PBC to be assigned JPBC=0 regardless of
!                values of SHPAR(2) or SHPAR(3)
! 08.09.17 (BTD) Corrected typos in routines TARNAS and TARNSP that caused
!                target centroid and therefore X0 to be computed incorrectly
!                [this only affected value of X0(1-3); it did not affect 
!                calculations of absorption and scattering ]
! 08.09.23 (BTD) Corrected typo in routine REAPAR
! 08.10.28 (BTD) Corrected error in TARGET: added X0 to argument list of
!                TARBLOCKS for target option MLTBLOCKS
! 09.07.08 (BTD) Corrected typo in DDfield.f90 affecting evaluation of
!                XMIN and XMINPHYS (output describing spatial extent of
!                target)
! 09.08.12 (BTD) Corrected declaration of CFLPOL in DDpol.f90 to agree
!                with declaration in readpol.f90 and DDfield.f90. 
! 09.12.11 (BTD) Corrected error in reapar that prevented use of
!                target options MLTBLOCKS and DW1996TAR
! 10.01.24 (BTD) Corrected inconsistency between UserGuide and code
!                regarding shape parameters for target options
!                RCTGLBLK3 and TRILYRPBC.
!                * modified tarrctblk3.f90 (reordered arg. list).
! 10.01.28 (BTD) in DDSCAT: when IWRKSC=0, 
!                change IORI from 0 to 1 in call NAMER
! end history

! Copyright (C) 1993,1994,1995,1996,1997,1998,1999,2000,2001,2002,2003,
!               2004,2005,2006,2007,2008,2009,2010 B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
      RETURN
    END SUBROUTINE VERSION

    SUBROUTINE NAMID(MYID,CFLLOG)
      IMPLICIT NONE
!***********************************************************************
! Purpose: to generate unique file names for log file written
!          each MPI process

! Present version allows up to 1000 MPI processes (000-999)

! Given:
!         MYID=integer (0-999) MPI ID number

! Returns:
!          CFLLOG=name for output file containing running output
!                 from DDSCAT
!                 = ddscat.log_nnn
!                   where nnn = MYID

! B.T.Draine, Princeton Univ. Observatory, 2003.04.12
! History:
! 03.04.12 (BTD): Created using NAMER as an example
! end history

! Copyright (C) 2003, B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************
! Arguments:

      INTEGER :: MYID
      CHARACTER :: CFLLOG*14

! Local variables:

      CHARACTER :: A1*11, ZLOG*14
      CHARACTER :: N(0:9)*1, V(1:3)*1, W(1:14)*1

! Equivalences:
      EQUIVALENCE (A1,W(1)), (V,W(12))
      EQUIVALENCE (W,ZLOG)

! DATA statements:

      DATA N/'0', '1', '2', '3', '4', '5', '6', '7', '8', '9'/
!***********************************************************************
!*** Filename CFLLOG will be of the form ddscat.log_NNN
!     where NNN = MYID

      A1 = 'ddscat.log_'

      V(1) = N(MYID/100)
      V(2) = N((MYID-100*(MYID/100))/10)
      V(3) = N(MYID-10*(MYID/10))

      CFLLOG = ZLOG

      RETURN

    END SUBROUTINE NAMID

    SUBROUTINE WRITEFML(JPBC,IORI,IORTH,IRAD,IWAV,MXCOMP,MXSCA,NAT0,  &
                        NAVG,NCOMP,NSCAT,CALPHA,CDESCR,CMDFFT,CMDFRM, &
                        CSHAPE,CSTAMP,AEFF,AK1,AKR,BETAD,PHID,THETAD, &
                        TOL,WAVE,XX,A1,A2,PHIN,THETAN,CXE01,CXE01R,   &
                        CXE02,CXE02R,CXEPS,CXRFR,CXF11,CXF21,CXF12,   &
                        CXF22,PYD,PZD)
      USE DDPRECISION,ONLY : WP
      IMPLICIT NONE

! Scalar Arguments ..

      REAL(WP) :: AEFF,AK1,BETAD,PHID,PYD,PZD,THETAD,TOL,WAVE,XX
      INTEGER :: IORI,IORTH,IRAD,IWAV,JPBC,MXCOMP,MXSCA,NAT0,NAVG,NCOMP,NSCAT

      CHARACTER :: CALPHA*6,CMDFFT*6,CMDFRM*6, &
        CSHAPE*9,CFLFML*16,CSTAMP*26,CDESCR*67

! Array Arguments ..

      COMPLEX(WP) ::   &
        CXE01(3),      &
        CXE01R(3),     &
        CXE02(3),      &
        CXE02R(3),     &
        CXEPS(MXCOMP), &
        CXF11(MXSCA),  &
        CXF12(MXSCA),  &
        CXF21(MXSCA),  &
        CXF22(MXSCA),  &
        CXRFR(MXCOMP)
      REAL(WP) ::    &
        A1(3),       &
        A2(3),       &
        AKR(3),      &
        PHIN(MXSCA), &
        THETAN(MXSCA)

! Local variables:

      CHARACTER :: CFRAME*12
      INTEGER :: J,ND
      REAL(WP) :: DEGRAD,MKD,PHIND,PI,RVAR1,RVAR2,RVAR3,SINALPHA,THETND
      COMPLEX(WP) :: CXFAC,CXI

! External Subroutines:

      EXTERNAL NAMER2

! Intrinsic Functions:

      INTRINSIC CONJG,SQRT

!***********************************************************************
! Subroutine WRITEFML

! Purpose of this module is to write out the complex scattering
! amplitudes f_ml

! History:
! 07.08.31 (BTD) created using WRITESCA as template
! 08.06.30 (BTD) changed normalization factor CXFAC for case JPBC=3
!                [target periodic in y and z directions]
! end history

! Copyright (C) 2007,2008
!               B.T. Draine and P.J. Flatau
! This code is covered by the GNU General Public License.
!***********************************************************************

! diagnostic
!      write(0,*)'writefml ckpt 0, NAT0=',NAT0
!

! If IORI > 0, then write out scattering properties for this specific
! target orientation.

      PI=4._WP*ATAN(1._WP)
      DEGRAD=180._WP/PI
      CXI=(0._WP,1._WP)

      IF(CMDFRM=='LFRAME' .OR. CMDFRM=='lframe')THEN
        CFRAME='Lab Frame'
      ELSEIF(CMDFRM=='TFRAME' .OR. CMDFRM=='tframe')THEN
        CFRAME='Target Frame'
      ELSE
        CFRAME='????????'
      ENDIF

      CALL NAMER2(IWAV,IRAD,IORI,CFLFML)
      OPEN (UNIT=8,FILE=CFLFML,STATUS='UNKNOWN')
      WRITE(8,FMT=9030)CSTAMP,CDESCR,CMDFFT,CALPHA,CSHAPE,NAT0

      WRITE(8,FMT=9032)AEFF,WAVE,XX
      DO J=1,NCOMP
         MKD=(4._WP*PI/(3._WP*NAT0))**(1._WP/3._WP)* &
             SQRT(REAL(CXRFR(J)*CONJG(CXRFR(J))))*XX
         WRITE(8,FMT=9031)CXRFR(J),CXEPS(J),MKD,J
      ENDDO
      WRITE(8,FMT=9033)TOL,NAVG,A1,A2
      WRITE(8,FMT=9035)AKR,CXE01R,CXE02R
      RVAR1=AK1
      RVAR2=0._WP
      RVAR3=0._WP
      WRITE(8,FMT=9037)RVAR1,RVAR2,RVAR3,CXE01,CXE02
      WRITE(8,FMT=9040)BETAD,THETAD,PHID

      IF(JPBC==0)THEN
         CXFAC=1._WP
         WRITE(8,FMT=9050)

! for periodic structures (JPC=1,2, or 3), it is assumed that 
! target axis a_1 = x_TF
!             a_2 = y_TF
!             a_3 = z_TF
! JPBC=1 : target is periodic in y direction
!      2                         z direction
!      3                         y and z directions

      ELSEIF(JPBC==1)THEN

         SINALPHA=SQRT(1._WP-(SIN(THETAD/DEGRAD)*COS(BETAD/DEGRAD))**2)
         CXFAC=SQRT(2._WP*PI*CXI/SINALPHA)/(AK1*PYD)
         RVAR1=AK1*PYD
         WRITE(8,FMT=9051)PYD,RVAR1
      ELSEIF(JPBC==2)THEN
         SINALPHA=SQRT(1._WP-(SIN(THETAD/DEGRAD)*SIN(BETAD/DEGRAD))**2)
         CXFAC=SQRT(2._WP*PI*CXI/SINALPHA)/(AK1*PZD)
         RVAR1=AK1*PZD
         WRITE(8,FMT=9052)PZD,RVAR1
      ELSEIF(JPBC==3)THEN
! 080630 BTD not certain how we want to set normalization factor CXFAC
!            THETAD = angle relative to normal
!            ALPHA  = 90-THETAD
!                   = angle between scattered vector and surface
         SINALPHA=COS(THETAD/DEGRAD)
         CXFAC=2._WP*PI*CXI/(AK1*PYD*AK1*PZD*SINALPHA)
         RVAR1=AK1*PYD
         RVAR2=AK1*PZD
         WRITE(8,FMT=9053)PYD,PZD,RVAR1,RVAR2
      ENDIF

      DO ND=1,NSCAT

! convert scattering angles to degrees

         PHIND=DEGRAD*PHIN(ND)
         THETND=DEGRAD*THETAN(ND)
         IF(IORTH==1)THEN
            WRITE(8,FMT=9070)THETND,PHIND,                        &
                             (CXFAC*CXF11(ND)),(CXFAC*CXF21(ND))
         ELSE
            WRITE(8,FMT=9071)THETND,PHIND,                        &
                             (CXFAC*CXF11(ND)),(CXFAC*CXF21(ND)), &
                             (CXFAC*CXF12(ND)),(CXFAC*CXF22(ND))
         ENDIF
      ENDDO

9030  FORMAT (' DDSCAT --- ',A/' TARGET ---',A/' ',A,                  &
        ' --- method of solution '/' ',A,                              &
        ' --- prescription for polarizabilies'/' ',A,' --- shape '/I7, &
        ' = NAT0 = number of dipoles')
! following code to be enabled for noncubic treatment
! 9030 FORMAT(' DDSCAT --- ',A,/,' TARGET ---',A,/,' ',A,
!     &       ' --- method of solution ',/,' ',A,
!     &       ' --- prescription for polarizabilies',/,' ',A,
!     &       ' --- shape ',/,I7,' = NAT0 = number of dipoles',
!     &       3F8.5,' = normalized lattice spacings dx,dy,dz')
9031  FORMAT ('n= (',F7.4,' , ',F7.4,'),  eps.= (',F8.4,' , ',F7.4, &
        ')  |m|kd=',0P,F8.4,' for subs.',I2)
9032  FORMAT ('  AEFF=',F10.5,' =',' effective radius (physical units)',/,  &
        '  WAVE=',F10.5,' = wavelength (physical units)',/,'K*AEFF=',F10.5, &
        ' = 2*pi*aeff/lambda')
9033  FORMAT ('   TOL=',1P,E10.3,' = error tolerance for CCG method'/ &
        '  NAVG=',I6,' = (theta,phi) values used in comp. of Qsca,g'/ &
        0P,'(',F8.5,2F9.5,') = target axis A1 in Target Frame'/       &
        1X,'(',F8.5,2F9.5,') = target axis A2 in Target Frame')
9035  FORMAT (1X,'(',F8.5,2F9.5,') = k vector (latt. units) in TF',/,1X, &
        3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in TF',/,1X,           &
        3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in TF')
9037  FORMAT (1X,'(',F8.5,2F9.5,') = k vector (latt. units) in Lab Frame',/, &
        1X,3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 1 in LF',/,1X,            &
        3('(',F8.5,',',F8.5,')'),'=inc.pol.vec. 2 in LF')
9040  FORMAT (' BETA =',F7.3,' = rotation of target around A1',/,          &
        ' THETA=',F7.3,' = angle between A1 and k',/,                      &
        '  PHI =',F7.3,' = rotation of A1 around k')
9050  FORMAT(5X,'Finite target:',/,                                        &
        5X,'e_m dot E(r) = i*exp(ikr)*f_ml*E_inc(0)/(kr)',/,               &
        5X,'m=1 in scatt. plane, m=2 perp to scatt. plane',/,/,            &
        ' theta   phi',2X,'Re(f_11)',3X,'Im(f_11)',3X,'Re(f_21)',3X,       &
        'Im(f_21)',3X,'Re(f_12)',3X,'Im(f_12)',3X,'Re(f_22)',3X,'Im(f_22)')
9051  FORMAT(                                                              &
        5X,'Target periodic in y direction with L_y/d=',1P,E10.3,2X,       &
        'kL_y = ',E10.3,/,                                                 &
        5X,'e_m dot E(r) = exp(ikr)*f_ml*[e_l dot E_inc(0)]/sqrt(kR)',     &
        5X,'[R = dist. from target]',/,                                    &
        5X,'m=1 in scatt. plane, m=2 perp to scatt. plane',/,/,            &
        ' alpha  zeta',2X,'Re(f_11)',3X,'Im(f_11)',3X,'Re(f_21)',3X,       &
        'Im(f_21)',3X,'Re(f_12)',3X,'Im(f_12)',3X,'Re(f_22)',3X,'Im(f_22)')
9052  FORMAT(                                                              &
        5X,'Target periodic in z direction with L_z/d=',1P,E10.3,2X,       &
        'kL_z = ',E10.3,/,                                                 &
        5X,'e_m dot E(r) = exp(ikr)*f_ml*[e_l dot E_inc(0)]/sqrt(kR)',     &
        5X,'[R = dist. from target]',/,                                    & 
        5X,'m=1 in scatt. plane, m=2 perp to scatt. plane',/,/,            &
        ' alpha  zeta',2X,'Re(f_11)',3X,'Im(f_11)',3X,'Re(f_21)',3X,       &
        'Im(f_21)',3X,'Re(f_12)',3X,'Im(f_12)',3X,'Re(f_22)',3X,'Im(f_22)')
9053  FORMAT(5X,                                                           &
        'Target periodic in y,z directions with L_y/d,L_z/d=',1P,2E10.3,   &
        2X,'kL_y=',E10.3,' kL_z=',E10.3,/,                                 &
        5X,' e_m dot E(r) = exp(ikr)*f_ml*[e_l dot E_inc(0)]',/,           &
        5X,'m=1 in scatt. plane, m=2 perp to scatt. plane',/,/,            &
        ' alpha   phi',2X,'Re(f_11)',3X,'Im(f_11)',3X,'Re(f_21)',3X,       &
        'Im(f_21)',3X,'Re(f_12)',3X,'Im(f_12)',3X,'Re(f_22)',3X,'Im(f_22)')
9070  FORMAT(2F6.1,1P,4E11.3)
9071  FORMAT(2F6.1,1P,8E11.3)

    END SUBROUTINE WRITEFML
